/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern0 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[3], E_PSImode))
    return -1;
  switch (GET_MODE (x1))
    {
    case E_QImode:
      if (!register_operand (operands[1], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!register_operand (operands[1], E_HImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern11 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x5 = XEXP (x3, 0);
  operands[1] = x5;
  x6 = XEXP (x3, 2);
  operands[2] = x6;
  if (!const0_operand (operands[2], E_QImode))
    return -1;
  x7 = XEXP (x2, 1);
  operands[3] = x7;
  x8 = XEXP (x1, 1);
  operands[4] = x8;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      return pattern10 (x1, 
E_QImode); /* [-1, 3] */

    case E_HImode:
      res = pattern10 (x1, 
E_HImode);
      if (res >= 0)
        return res + 4; /* [4, 7] */
      return -1;

    case E_PSImode:
      res = pattern10 (x1, 
E_PSImode);
      if (res >= 0)
        return res + 8; /* [8, 11] */
      return -1;

    case E_SImode:
      res = pattern10 (x1, 
E_SImode);
      if (res >= 0)
        return res + 12; /* [12, 15] */
      return -1;

    default:
      return -1;
    }
}

int
pattern20 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x3) != E_HImode
          || !combine_pseudo_register_operand (operands[1], E_QImode))
        return -1;
      return 0;

    case E_PSImode:
      res = pattern18 (x3);
      if (res >= 0)
        return res + 1; /* [1, 2] */
      return -1;

    case E_SImode:
      res = pattern19 (x3);
      if (res >= 0)
        return res + 3; /* [3, 5] */
      return -1;

    default:
      return -1;
    }
}

int
pattern29 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != MEM
      || GET_MODE (x3) != E_BLKmode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != LO_SUM
      || GET_MODE (x4) != E_PSImode)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 23
      || GET_MODE (x5) != E_QImode)
    return -1;
  x6 = XEXP (x4, 1);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 30
      || GET_MODE (x6) != E_HImode)
    return -1;
  x7 = XEXP (x2, 0);
  if (GET_CODE (x7) != MEM
      || GET_MODE (x7) != E_BLKmode)
    return -1;
  x8 = XEXP (x7, 0);
  if (GET_CODE (x8) != REG
      || REGNO (x8) != 26
      || GET_MODE (x8) != E_HImode)
    return -1;
  x9 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x9) != UNSPEC
      || XVECLEN (x9, 0) != 1
      || XINT (x9, 1) != 1)
    return -1;
  x10 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x10) != USE)
    return -1;
  x11 = XEXP (x10, 0);
  if (GET_CODE (x11) != REG
      || REGNO (x11) != 24)
    return -1;
  x12 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x12) != CLOBBER)
    return -1;
  x13 = XEXP (x12, 0);
  if (GET_CODE (x13) != REG
      || REGNO (x13) != 26
      || GET_MODE (x13) != E_HImode)
    return -1;
  x14 = XVECEXP (x1, 0, 4);
  if (GET_CODE (x14) != CLOBBER)
    return -1;
  x15 = XEXP (x14, 0);
  if (GET_CODE (x15) != REG
      || REGNO (x15) != 30
      || GET_MODE (x15) != E_HImode)
    return -1;
  x16 = XVECEXP (x1, 0, 5);
  if (GET_CODE (x16) != CLOBBER)
    return -1;
  x17 = XEXP (x16, 0);
  if (GET_CODE (x17) != REG
      || REGNO (x17) != 0
      || GET_MODE (x17) != E_QImode)
    return -1;
  x18 = XVECEXP (x1, 0, 6);
  if (GET_CODE (x18) != CLOBBER)
    return -1;
  x19 = XEXP (x18, 0);
  if (GET_CODE (x19) != REG
      || REGNO (x19) != 24
      || GET_MODE (x19) != E_HImode)
    return -1;
  x20 = XVECEXP (x1, 0, 7);
  if (GET_CODE (x20) != CLOBBER)
    return -1;
  x21 = XEXP (x20, 0);
  if (GET_CODE (x21) != REG
      || REGNO (x21) != 23
      || GET_MODE (x21) != E_QImode)
    return -1;
  x22 = XVECEXP (x1, 0, 8);
  if (GET_CODE (x22) != CLOBBER)
    return -1;
  x23 = XEXP (x22, 0);
  if (GET_CODE (x23) != MEM
      || GET_MODE (x23) != E_QImode)
    return -1;
  x24 = XVECEXP (x9, 0, 0);
  operands[0] = x24;
  if (!const_int_operand (operands[0], E_QImode))
    return -1;
  x25 = XEXP (x23, 0);
  operands[1] = x25;
  if (!io_address_operand (operands[1], E_QImode))
    return -1;
  switch (GET_MODE (x11))
    {
    case E_QImode:
      return 0;

    case E_HImode:
      return 1;

    default:
      return -1;
    }
}

int
pattern54 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      return pattern52 (x3, 
E_QImode); /* [-1, 0] */

    case E_QQmode:
      if (pattern52 (x3, 
E_QQmode) != 0)
        return -1;
      return 1;

    case E_UQQmode:
      if (pattern52 (x3, 
E_UQQmode) != 0)
        return -1;
      return 2;

    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x3) != E_HImode
          || !register_operand (operands[1], E_HImode))
        return -1;
      return 3;

    case E_HQmode:
      if (!register_operand (operands[0], E_HQmode)
          || GET_MODE (x3) != E_HQmode
          || !register_operand (operands[1], E_HQmode))
        return -1;
      return 4;

    case E_UHQmode:
      if (!register_operand (operands[0], E_UHQmode)
          || GET_MODE (x3) != E_UHQmode
          || !register_operand (operands[1], E_UHQmode))
        return -1;
      return 5;

    case E_HAmode:
      if (!register_operand (operands[0], E_HAmode)
          || GET_MODE (x3) != E_HAmode
          || !register_operand (operands[1], E_HAmode))
        return -1;
      return 6;

    case E_UHAmode:
      if (!register_operand (operands[0], E_UHAmode)
          || GET_MODE (x3) != E_UHAmode
          || !register_operand (operands[1], E_UHAmode))
        return -1;
      return 7;

    case E_PSImode:
      if (pattern53 (x3, pnum_clobbers, 
E_QImode) != 0)
        return -1;
      return 8;

    case E_SImode:
      if (pattern52 (x3, 
E_SImode) != 0)
        return -1;
      return 9;

    case E_SQmode:
      if (pattern52 (x3, 
E_SQmode) != 0)
        return -1;
      return 10;

    case E_USQmode:
      if (pattern52 (x3, 
E_USQmode) != 0)
        return -1;
      return 11;

    case E_SAmode:
      if (pattern52 (x3, 
E_SAmode) != 0)
        return -1;
      return 12;

    case E_USAmode:
      if (pattern52 (x3, 
E_USAmode) != 0)
        return -1;
      return 13;

    default:
      return -1;
    }
}

int
pattern72 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (REGNO (x3) != 18)
    return -1;
  x4 = XEXP (x1, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 18)
    return -1;
  x5 = XEXP (x2, 1);
  switch (GET_CODE (x5))
    {
    case REG:
      return pattern70 (x1); /* [-1, 6] */

    case SIGN_EXTEND:
      if (GET_MODE (x5) != E_DImode)
        return -1;
      x6 = XEXP (x5, 0);
      if (GET_CODE (x6) != REG
          || REGNO (x6) != 26
          || GET_MODE (x6) != E_QImode
          || GET_MODE (x4) != E_DImode
          || GET_MODE (x2) != E_DImode
          || GET_MODE (x3) != E_DImode)
        return -1;
      return 7;

    case CONST_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
      res = pattern71 (x1);
      if (res >= 0)
        return res + 8; /* [8, 14] */
      return -1;

    default:
      return -1;
    }
}

int
pattern79 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x2, 1);
  operands[3] = x3;
  if (!const_8_16_24_operand (operands[3], E_QImode))
    return -1;
  x4 = XEXP (x1, 1);
  operands[2] = x4;
  if (!register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern85 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x1) != E_HImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_HImode)
        return -1;
      x3 = XEXP (x2, 0);
      if (GET_MODE (x3) != E_HImode)
        return -1;
      x4 = XEXP (x3, 0);
      if (GET_MODE (x4) != E_QImode
          || !register_operand (operands[1], E_QImode)
          || !nonmemory_operand (operands[2], E_HImode)
          || !register_operand (operands[3], E_HImode))
        return -1;
      return 0;

    case E_PSImode:
      if (!register_operand (operands[0], E_PSImode)
          || GET_MODE (x1) != E_PSImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_PSImode)
        return -1;
      x3 = XEXP (x2, 0);
      if (GET_MODE (x3) != E_PSImode
          || !nonmemory_operand (operands[2], E_PSImode))
        return -1;
      x4 = XEXP (x3, 0);
      res = pattern0 (x4);
      if (res >= 0)
        return res + 1; /* [1, 2] */
      return -1;

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_SImode)
        return -1;
      x3 = XEXP (x2, 0);
      if (GET_MODE (x3) != E_SImode
          || !nonmemory_operand (operands[2], E_SImode))
        return -1;
      x4 = XEXP (x3, 0);
      res = pattern1 (x4);
      if (res >= 0)
        return res + 3; /* [3, 5] */
      return -1;

    default:
      return -1;
    }
}

int
pattern96 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_QImode))
    return -1;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  x3 = XEXP (x1, 1);
  operands[2] = x3;
  switch (GET_MODE (operands[1]))
    {
    case E_QImode:
      if (!reg_or_low_io_operand (operands[1], E_QImode)
          || !const0_operand (operands[2], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!reg_or_low_io_operand (operands[1], E_HImode)
          || !const0_operand (operands[2], E_HImode))
        return -1;
      return 1;

    case E_PSImode:
      if (!reg_or_low_io_operand (operands[1], E_PSImode)
          || !const0_operand (operands[2], E_PSImode))
        return -1;
      return 2;

    case E_SImode:
      if (!reg_or_low_io_operand (operands[1], E_SImode)
          || !const0_operand (operands[2], E_SImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern107 (rtx x1, unsigned int i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x1, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != i1
      || GET_MODE (x3) != i2)
    return -1;
  return 0;
}

int
pattern111 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 36
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  x6 = XEXP (x4, 1);
  x7 = XEXP (x6, 0);
  switch (GET_CODE (x7))
    {
    case REG:
    case SUBREG:
      operands[1] = x7;
      x8 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x8) != CLOBBER)
        return -1;
      return pattern110 (x1); /* [-1, 2] */

    case ZERO_EXTRACT:
      res = pattern97 (x1);
      if (res >= 0)
        return res + 3; /* [3, 4] */
      return -1;

    default:
      return -1;
    }
}

int
pattern122 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  operands[1] = x1;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      if (!register_operand (operands[0], E_QImode)
          || !memory_operand (operands[1], E_QImode))
        return -1;
      return 0;

    case E_QQmode:
      if (!register_operand (operands[0], E_QQmode)
          || !memory_operand (operands[1], E_QQmode))
        return -1;
      return 1;

    case E_UQQmode:
      if (!register_operand (operands[0], E_UQQmode)
          || !memory_operand (operands[1], E_UQQmode))
        return -1;
      return 2;

    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || !memory_operand (operands[1], E_HImode))
        return -1;
      return 3;

    case E_HQmode:
      if (!register_operand (operands[0], E_HQmode)
          || !memory_operand (operands[1], E_HQmode))
        return -1;
      return 4;

    case E_UHQmode:
      if (!register_operand (operands[0], E_UHQmode)
          || !memory_operand (operands[1], E_UHQmode))
        return -1;
      return 5;

    case E_HAmode:
      if (!register_operand (operands[0], E_HAmode)
          || !memory_operand (operands[1], E_HAmode))
        return -1;
      return 6;

    case E_UHAmode:
      if (!register_operand (operands[0], E_UHAmode)
          || !memory_operand (operands[1], E_UHAmode))
        return -1;
      return 7;

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || !memory_operand (operands[1], E_SImode))
        return -1;
      return 8;

    case E_SQmode:
      if (!register_operand (operands[0], E_SQmode)
          || !memory_operand (operands[1], E_SQmode))
        return -1;
      return 9;

    case E_USQmode:
      if (!register_operand (operands[0], E_USQmode)
          || !memory_operand (operands[1], E_USQmode))
        return -1;
      return 10;

    case E_SAmode:
      if (!register_operand (operands[0], E_SAmode)
          || !memory_operand (operands[1], E_SAmode))
        return -1;
      return 11;

    case E_USAmode:
      if (!register_operand (operands[0], E_USAmode)
          || !memory_operand (operands[1], E_USAmode))
        return -1;
      return 12;

    case E_SFmode:
      if (!register_operand (operands[0], E_SFmode)
          || !memory_operand (operands[1], E_SFmode))
        return -1;
      return 13;

    case E_PSImode:
      if (!register_operand (operands[0], E_PSImode)
          || !memory_operand (operands[1], E_PSImode))
        return -1;
      return 14;

    default:
      return -1;
    }
}

int
pattern140 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!pseudo_register_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1
      || !pseudo_register_operand (operands[1], i1)
      || !pseudo_register_operand (operands[2], i1)
      || !pseudo_register_operand (operands[3], i1))
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 1);
  if (GET_MODE (x5) != i1)
    return -1;
  return 0;
}

int
pattern145 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 25
      || GET_MODE (x3) != E_QImode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  return pattern144 (x4); /* [-1, 1] */
}

int
pattern148 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 36
      || GET_MODE (x5) != E_CCmode)
    return -1;
  x6 = XEXP (x2, 1);
  x7 = XEXP (x6, 0);
  switch (REGNO (x7))
    {
    case 24:
      if (REGNO (x3) != 24)
        return -1;
      switch (GET_MODE (x3))
        {
        case E_HQmode:
          if (GET_MODE (x6) != E_HQmode
              || GET_MODE (x7) != E_HQmode)
            return -1;
          return 0;

        case E_HAmode:
          if (GET_MODE (x6) != E_HAmode
              || GET_MODE (x7) != E_HAmode)
            return -1;
          return 1;

        default:
          return -1;
        }

    case 22:
      if (REGNO (x3) != 22)
        return -1;
      switch (GET_MODE (x3))
        {
        case E_SAmode:
          if (GET_MODE (x6) != E_SAmode
              || GET_MODE (x7) != E_SAmode)
            return -1;
          return 2;

        case E_SQmode:
          if (GET_MODE (x6) != E_SQmode
              || GET_MODE (x7) != E_SQmode)
            return -1;
          return 3;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern163 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 26
      || GET_MODE (x6) != E_HImode)
    return -1;
  x7 = XEXP (x2, 1);
  if (GET_CODE (x7) != REG
      || REGNO (x7) != 18
      || GET_MODE (x7) != E_SImode
      || pattern162 (x1, 
E_SImode, 
22) != 0)
    return -1;
  return 0;
}

int
pattern168 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 36
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 1);
  x6 = XEXP (x5, 0);
  x7 = XEXP (x6, 0);
  operands[1] = x7;
  x8 = XEXP (x6, 1);
  operands[2] = x8;
  x9 = XEXP (x5, 1);
  operands[3] = x9;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      if (!register_operand (operands[0], E_QImode)
          || GET_MODE (x5) != E_QImode
          || GET_MODE (x6) != E_QImode
          || !register_operand (operands[1], E_QImode)
          || !const_0_to_7_operand (operands[2], E_QImode)
          || !single_one_operand (operands[3], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x5) != E_HImode
          || GET_MODE (x6) != E_HImode
          || !register_operand (operands[1], E_HImode)
          || !const_0_to_15_operand (operands[2], E_QImode)
          || !single_one_operand (operands[3], E_HImode))
        return -1;
      return 1;

    case E_PSImode:
      if (!register_operand (operands[0], E_PSImode)
          || GET_MODE (x5) != E_PSImode
          || GET_MODE (x6) != E_PSImode
          || !register_operand (operands[1], E_PSImode)
          || !const_0_to_23_operand (operands[2], E_QImode)
          || !single_one_operand (operands[3], E_PSImode))
        return -1;
      return 2;

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x5) != E_SImode
          || GET_MODE (x6) != E_SImode
          || !register_operand (operands[1], E_SImode)
          || !const_0_to_31_operand (operands[2], E_QImode)
          || !single_one_operand (operands[3], E_SImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern185 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != SCRATCH
      || GET_MODE (x3) != E_QImode)
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  x5 = XEXP (x4, 0);
  if (REGNO (x5) != 36
      || GET_MODE (x5) != E_CCmode)
    return -1;
  x6 = XVECEXP (x1, 0, 0);
  x7 = XEXP (x6, 0);
  operands[0] = x7;
  x8 = XEXP (x6, 1);
  x9 = XEXP (x8, 1);
  operands[1] = x9;
  x10 = XEXP (x8, 0);
  if (!rtx_equal_p (x10, operands[0]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x8) != E_HImode
          || !register_operand (operands[1], E_HImode))
        return -1;
      return 0;

    case E_PSImode:
      if (!register_operand (operands[0], E_PSImode)
          || GET_MODE (x8) != E_PSImode
          || !register_operand (operands[1], E_PSImode))
        return -1;
      return 1;

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x8) != E_SImode
          || !register_operand (operands[1], E_SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern200 (rtx x1, machine_mode i1, unsigned int i2, unsigned int i3, machine_mode i4)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i4)
    return -1;
  x5 = XEXP (x2, 1);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != i3
      || GET_MODE (x5) != i1
      || pattern199 (x1, 
i1, 
i2) != 0)
    return -1;
  return 0;
}

int
pattern205 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (REGNO (x4) != 18)
    return -1;
  x5 = XEXP (x2, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 18)
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != REG
      || REGNO (x7) != 36
      || GET_MODE (x7) != E_CCmode)
    return -1;
  return 0;
}

int
pattern207 (rtx x1, machine_mode i1, unsigned int i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 22
      || GET_MODE (x5) != E_SImode)
    return -1;
  x6 = XEXP (x2, 0);
  if (GET_CODE (x6) != REG
      || pattern206 (x1, 
E_HImode, 
i1, 
24, 
i2) != 0)
    return -1;
  return 0;
}

int
pattern216 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_HImode
      || !register_operand (operands[0], E_HImode)
      || GET_MODE (x1) != E_HImode)
    return -1;
  x3 = XEXP (x1, 0);
  if (GET_MODE (x3) != E_HImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != E_HImode)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != E_QImode
      || !register_operand (operands[1], E_QImode))
    return -1;
  x6 = XEXP (x2, 0);
  operands[2] = x6;
  if (!register_operand (operands[2], E_QImode))
    return -1;
  return 0;
}

int
pattern224 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_HImode
      || !register_operand (operands[0], E_HImode)
      || GET_MODE (x1) != E_HImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[3] = x3;
  if (!register_operand (operands[3], E_HImode))
    return -1;
  x4 = XEXP (x2, 0);
  if (GET_MODE (x4) != E_HImode)
    return -1;
  return 0;
}

int
pattern228 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != i1)
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG)
    return -1;
  x6 = XVECEXP (x1, 0, 3);
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != REG)
    return -1;
  x8 = XVECEXP (x1, 0, 4);
  x9 = XEXP (x8, 0);
  if (GET_CODE (x9) != REG)
    return -1;
  return 0;
}

int
pattern234 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  if (!register_operand (operands[1], E_QImode)
      || !register_operand (operands[0], E_QImode)
      || GET_MODE (x1) != E_QImode
      || GET_MODE (x2) != E_QImode)
    return -1;
  return 0;
}

int
pattern237 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case REG:
    case SUBREG:
      operands[1] = x3;
      if (!register_operand (operands[1], E_QImode)
          || !register_operand (operands[0], E_QImode)
          || GET_MODE (x1) != E_QImode
          || !register_operand (operands[3], E_QImode)
          || GET_MODE (x2) != E_QImode)
        return -1;
      return 0;

    case SIGN_EXTEND:
      if (pattern236 (x1) != 0)
        return -1;
      return 1;

    case ZERO_EXTEND:
      if (pattern236 (x1) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern241 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  x3 = XEXP (x1, 1);
  operands[2] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_UQQmode:
      return pattern108 (x1, 
E_UQQmode); /* [-1, 0] */

    case E_UHQmode:
      if (pattern108 (x1, 
E_UHQmode) != 0)
        return -1;
      return 1;

    case E_UHAmode:
      if (pattern108 (x1, 
E_UHAmode) != 0)
        return -1;
      return 2;

    case E_USAmode:
      if (pattern108 (x1, 
E_USAmode) != 0)
        return -1;
      return 3;

    case E_USQmode:
      if (pattern108 (x1, 
E_USQmode) != 0)
        return -1;
      return 4;

    default:
      return -1;
    }
}

int
pattern247 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != ZERO_EXTEND
      || GET_MODE (x5) != E_SImode)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != NOT
      || GET_MODE (x6) != E_HImode)
    return -1;
  x7 = XVECEXP (x1, 0, 1);
  x8 = XEXP (x7, 0);
  if (REGNO (x8) != 26
      || GET_MODE (x8) != E_HImode)
    return -1;
  x9 = XVECEXP (x1, 0, 2);
  x10 = XEXP (x9, 0);
  if (REGNO (x10) != 18
      || GET_MODE (x10) != E_DImode)
    return -1;
  x11 = XEXP (x2, 0);
  operands[0] = x11;
  if (!pseudo_register_operand (operands[0], E_SImode)
      || GET_MODE (x3) != E_SImode)
    return -1;
  x12 = XEXP (x6, 0);
  operands[1] = x12;
  if (!pseudo_register_operand (operands[1], E_HImode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[2] = x13;
  if (!pseudo_register_or_const_int_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern251 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != UNSPEC_VOLATILE
      || XVECLEN (x3, 0) != 1
      || XINT (x3, 1) != 6
      || GET_MODE (x3) != E_BLKmode)
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x4) != CLOBBER
      || pattern250 (x1) != 0)
    return -1;
  return 0;
}

int
pattern258 (rtx x1, machine_mode i1, machine_mode i2, unsigned int i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i2)
    return -1;
  x5 = XEXP (x1, 0);
  if (REGNO (x5) != i3
      || GET_MODE (x5) != i1
      || GET_MODE (x2) != i1)
    return -1;
  x6 = XEXP (x2, 0);
  if (GET_MODE (x6) != i1)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_MODE (x7) != i2
      || GET_MODE (x3) != i1)
    return -1;
  return 0;
}

int
pattern264 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 36
      || GET_MODE (x3) != E_CCmode
      || !register_operand (operands[0], i1))
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 1);
  if (GET_MODE (x5) != i1
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern269 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 2);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_HImode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 1);
  x6 = XEXP (x5, 0);
  x7 = XEXP (x6, 0);
  switch (REGNO (x7))
    {
    case 22:
      if (GET_MODE (x7) != E_QImode)
        return -1;
      x8 = XEXP (x5, 1);
      x9 = XEXP (x8, 0);
      if (REGNO (x9) != 24
          || GET_MODE (x9) != E_QImode
          || pattern268 (x1, 
E_HImode, 
22, 
E_QImode, 
21, 
24) != 0)
        return -1;
      return 0;

    case 18:
      if (GET_MODE (x7) != E_SImode)
        return -1;
      x8 = XEXP (x5, 1);
      x9 = XEXP (x8, 0);
      if (REGNO (x9) != 22
          || GET_MODE (x9) != E_SImode
          || pattern268 (x1, 
E_DImode, 
30, 
E_HImode, 
26, 
18) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern283 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_CODE (x1))
    {
    case SIGN_EXTEND:
      if (GET_MODE (x1) != E_HImode)
        return -1;
      x2 = XEXP (x1, 0);
      operands[2] = x2;
      if (!register_operand (operands[2], E_QImode))
        return -1;
      return 0;

    case ZERO_EXTEND:
      if (GET_MODE (x1) != E_HImode)
        return -1;
      x2 = XEXP (x1, 0);
      operands[2] = x2;
      if (!register_operand (operands[2], E_QImode))
        return -1;
      return 1;

    case REG:
    case SUBREG:
      operands[2] = x1;
      if (!register_operand (operands[2], E_HImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern291 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  operands[0] = x4;
  if (!register_operand (operands[0], E_HImode))
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  x6 = XEXP (x5, 0);
  operands[1] = x6;
  x7 = XVECEXP (x1, 0, 2);
  x8 = XEXP (x7, 0);
  operands[2] = x8;
  if (!const_int_operand (operands[2], E_HImode))
    return -1;
  x9 = XVECEXP (x1, 0, 3);
  x10 = XEXP (x9, 0);
  operands[3] = x10;
  if (!scratch_operand (operands[3], E_HImode))
    return -1;
  x11 = XVECEXP (x1, 0, 4);
  x12 = XEXP (x11, 0);
  operands[4] = x12;
  switch (GET_MODE (operands[1]))
    {
    case E_QImode:
      if (!register_operand (operands[1], E_QImode)
          || !scratch_operand (operands[4], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!register_operand (operands[1], E_HImode)
          || !scratch_operand (operands[4], E_HImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern299 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_DImode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 26
      || GET_MODE (x3) != E_QImode)
    return -1;
  x4 = XEXP (x1, 0);
  if (GET_MODE (x4) != E_DImode)
    return -1;
  return 0;
}

int
pattern303 (rtx x1, machine_mode i1, unsigned int i2, unsigned int i3, machine_mode i4)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i4)
    return -1;
  x5 = XEXP (x2, 1);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != i3
      || GET_MODE (x5) != i1
      || pattern302 (x1, 
i1, 
i2) != 0)
    return -1;
  return 0;
}

int
pattern310 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != MEM
      || GET_MODE (x3) != E_BLKmode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 26
      || GET_MODE (x4) != E_HImode)
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x5) != UNSPEC
      || XVECLEN (x5, 0) != 1
      || XINT (x5, 1) != 1)
    return -1;
  x6 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x6) != USE)
    return -1;
  return 0;
}

int
pattern317 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!d_register_operand (operands[0], i1)
      || !const_int_operand (operands[1], i1)
      || GET_CODE (x1) != PARALLEL
      || XVECLEN (x1, 0) != 3)
    return -1;
  return pattern316 (x1, 
i1); /* [-1, 2] */
}

int
pattern321 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x1) != E_HImode
          || !register_operand (operands[1], E_HImode))
        return -1;
      return 0;

    case E_HQmode:
      if (!register_operand (operands[0], E_HQmode)
          || GET_MODE (x1) != E_HQmode
          || !register_operand (operands[1], E_HQmode))
        return -1;
      return 1;

    case E_UHQmode:
      if (!register_operand (operands[0], E_UHQmode)
          || GET_MODE (x1) != E_UHQmode
          || !register_operand (operands[1], E_UHQmode))
        return -1;
      return 2;

    case E_HAmode:
      if (!register_operand (operands[0], E_HAmode)
          || GET_MODE (x1) != E_HAmode
          || !register_operand (operands[1], E_HAmode))
        return -1;
      return 3;

    case E_UHAmode:
      if (!register_operand (operands[0], E_UHAmode)
          || GET_MODE (x1) != E_UHAmode
          || !register_operand (operands[1], E_UHAmode))
        return -1;
      return 4;

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode
          || !register_operand (operands[1], E_SImode))
        return -1;
      return 5;

    case E_SQmode:
      if (!register_operand (operands[0], E_SQmode)
          || GET_MODE (x1) != E_SQmode
          || !register_operand (operands[1], E_SQmode))
        return -1;
      return 6;

    case E_USQmode:
      if (!register_operand (operands[0], E_USQmode)
          || GET_MODE (x1) != E_USQmode
          || !register_operand (operands[1], E_USQmode))
        return -1;
      return 7;

    case E_SAmode:
      if (!register_operand (operands[0], E_SAmode)
          || GET_MODE (x1) != E_SAmode
          || !register_operand (operands[1], E_SAmode))
        return -1;
      return 8;

    case E_USAmode:
      if (!register_operand (operands[0], E_USAmode)
          || GET_MODE (x1) != E_USAmode
          || !register_operand (operands[1], E_USAmode))
        return -1;
      return 9;

    default:
      return -1;
    }
}

int
pattern343 (rtx x1, int *pnum_clobbers, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !register_operand (operands[3], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 1);
  operands[1] = x5;
  if (!const_int_operand (operands[1], i1)
      || !register_operand (operands[0], i1))
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 1);
  if (GET_MODE (x7) != i1)
    return -1;
  x8 = XEXP (x7, 0);
  operands[4] = x8;
  if (!register_operand (operands[4], i1))
    return -1;
  x9 = XEXP (x7, 1);
  operands[5] = x9;
  if (!const_int_operand (operands[5], i1))
    return -1;
  return 0;
}

int
pattern351 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  x4 = XEXP (x1, 0);
  switch (GET_CODE (x4))
    {
    case GE:
      return pattern350 (x4); /* [-1, 0] */

    case LT:
      if (pattern350 (x4) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern357 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != E_SImode)
    return -1;
  switch (GET_CODE (x1))
    {
    case CTZ:
      x2 = XEXP (x1, 0);
      if (GET_CODE (x2) != REG
          || REGNO (x2) != 22
          || GET_MODE (x2) != E_SImode)
        return -1;
      return 0;

    case FFS:
      x2 = XEXP (x1, 0);
      if (GET_CODE (x2) != REG
          || REGNO (x2) != 22
          || GET_MODE (x2) != E_SImode)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern363 (rtx x1, machine_mode i1, unsigned int i2, machine_mode i3, unsigned int i4)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 2);
  x3 = XEXP (x2, 0);
  if (REGNO (x3) != i4
      || GET_MODE (x3) != i3)
    return -1;
  x4 = XVECEXP (x1, 0, 3);
  x5 = XEXP (x4, 0);
  if (REGNO (x5) != i2)
    return -1;
  x6 = XVECEXP (x1, 0, 0);
  x7 = XEXP (x6, 0);
  if (GET_MODE (x7) != i1)
    return -1;
  x8 = XEXP (x6, 1);
  if (GET_MODE (x8) != i1)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_MODE (x9) != i1)
    return -1;
  x10 = XEXP (x8, 1);
  if (GET_MODE (x10) != i1)
    return -1;
  return 0;
}

int
pattern370 (rtx x1, machine_mode i1, machine_mode i2, unsigned int i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 4);
  x3 = XEXP (x2, 0);
  if (REGNO (x3) != i3
      || GET_MODE (x3) != i2
      || pattern142 (x1, 
i1) != 0)
    return -1;
  return 0;
}

int
pattern377 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 3);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_QImode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 0);
  switch (REGNO (x5))
    {
    case 24:
      return pattern376 (x1, 
E_QImode, 
23, 
22, 
25); /* [-1, 0] */

    case 22:
      if (pattern376 (x1, 
E_HImode, 
21, 
26, 
24) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern381 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  operands[1] = x1;
  if (!const0_operand (operands[1], i1))
    return -1;
  x2 = PATTERN (peep2_next_insn (1));
  x3 = XEXP (x2, 1);
  return pattern351 (x3); /* [-1, 1] */
}

int
pattern385 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != SCRATCH
      || GET_MODE (x3) != E_QImode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 1);
  x6 = XEXP (x5, 1);
  operands[3] = x6;
  x7 = XEXP (x5, 0);
  if (!rtx_equal_p (x7, operands[0]))
    return -1;
  x8 = PATTERN (peep2_next_insn (2));
  if (GET_CODE (x8) != SET)
    return -1;
  x9 = XEXP (x8, 1);
  if (GET_CODE (x9) != IF_THEN_ELSE)
    return -1;
  x10 = XEXP (x9, 1);
  if (GET_CODE (x10) != LABEL_REF)
    return -1;
  x11 = XEXP (x9, 2);
  if (GET_CODE (x11) != PC)
    return -1;
  x12 = XEXP (x8, 0);
  if (GET_CODE (x12) != PC)
    return -1;
  x13 = XEXP (x10, 0);
  operands[2] = x13;
  return 0;
}

int
pattern396 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1))
    return -1;
  x2 = PATTERN (peep2_next_insn (2));
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  return pattern392 (x4, 
i1); /* [-1, 5] */
}

int
pattern399 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!const_int_operand (operands[1], i1))
    return -1;
  switch (GET_CODE (x1))
    {
    case EQ:
      return pattern391 (x1); /* [-1, 0] */

    case NE:
      if (pattern391 (x1) != 0)
        return -1;
      return 1;

    case GE:
      if (pattern391 (x1) != 0)
        return -1;
      return 2;

    case LT:
      if (pattern391 (x1) != 0)
        return -1;
      return 3;

    case GT:
      if (pattern391 (x1) != 0)
        return -1;
      return 4;

    case LE:
      if (pattern391 (x1) != 0)
        return -1;
      return 5;

    default:
      return -1;
    }
}

 int
recog_7 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      res = recog_6 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case ZERO_EXTEND:
      if (pattern69 (x1) == 0)
        return 182; /* *addhi3_zero_extend1_split */
      break;

    default:
      break;
    }
  x4 = XEXP (x2, 0);
  if (GET_CODE (x4) != REG)
    return -1;
  switch (pattern72 (x1))
    {
    case 0:
      if (
#line 101 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
        return 3166; /* adddi3_insn */
      if (pnum_clobbers == NULL
          || !
#line 114 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 3173; /* *adddi3_insn */

    case 1:
      if (
#line 101 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
        return 3167; /* adddq3_insn */
      if (pnum_clobbers == NULL
          || !
#line 114 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 3174; /* *adddq3_insn */

    case 2:
      if (
#line 101 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
        return 3168; /* addudq3_insn */
      if (pnum_clobbers == NULL
          || !
#line 114 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 3175; /* *addudq3_insn */

    case 3:
      if (
#line 101 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
        return 3169; /* addda3_insn */
      if (pnum_clobbers == NULL
          || !
#line 114 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 3176; /* *addda3_insn */

    case 4:
      if (
#line 101 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
        return 3170; /* adduda3_insn */
      if (pnum_clobbers == NULL
          || !
#line 114 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 3177; /* *adduda3_insn */

    case 5:
      if (
#line 101 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
        return 3171; /* addta3_insn */
      if (pnum_clobbers == NULL
          || !
#line 114 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 3178; /* *addta3_insn */

    case 6:
      if (
#line 101 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
        return 3172; /* adduta3_insn */
      if (pnum_clobbers == NULL
          || !
#line 114 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 3179; /* *adduta3_insn */

    case 7:
      if (
#line 122 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
        return 3180; /* adddi3_const8_insn */
      if (pnum_clobbers == NULL
          || !
#line 135 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 3181; /* *adddi3_const8_insn */

    case 8:
      if (
#line 147 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && !s8_operand (operands[0], VOIDmode)))
        return 3182; /* adddi3_const_insn */
      if (pnum_clobbers == NULL
          || !
#line 161 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && !s8_operand (operands[0], VOIDmode)
   && reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 3189; /* *adddi3_const_insn */

    case 9:
      if (
#line 147 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && !s8_operand (operands[0], VOIDmode)))
        return 3183; /* adddq3_const_insn */
      if (pnum_clobbers == NULL
          || !
#line 161 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && !s8_operand (operands[0], VOIDmode)
   && reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 3190; /* *adddq3_const_insn */

    case 10:
      if (
#line 147 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && !s8_operand (operands[0], VOIDmode)))
        return 3184; /* addudq3_const_insn */
      if (pnum_clobbers == NULL
          || !
#line 161 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && !s8_operand (operands[0], VOIDmode)
   && reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 3191; /* *addudq3_const_insn */

    case 11:
      if (
#line 147 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && !s8_operand (operands[0], VOIDmode)))
        return 3185; /* addda3_const_insn */
      if (pnum_clobbers == NULL
          || !
#line 161 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && !s8_operand (operands[0], VOIDmode)
   && reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 3192; /* *addda3_const_insn */

    case 12:
      if (
#line 147 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && !s8_operand (operands[0], VOIDmode)))
        return 3186; /* adduda3_const_insn */
      if (pnum_clobbers == NULL
          || !
#line 161 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && !s8_operand (operands[0], VOIDmode)
   && reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 3193; /* *adduda3_const_insn */

    case 13:
      if (
#line 147 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && !s8_operand (operands[0], VOIDmode)))
        return 3187; /* addta3_const_insn */
      if (pnum_clobbers == NULL
          || !
#line 161 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && !s8_operand (operands[0], VOIDmode)
   && reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 3194; /* *addta3_const_insn */

    case 14:
      if (
#line 147 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && !s8_operand (operands[0], VOIDmode)))
        return 3188; /* adduta3_const_insn */
      if (pnum_clobbers == NULL
          || !
#line 161 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && !s8_operand (operands[0], VOIDmode)
   && reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 3195; /* *adduta3_const_insn */

    default:
      return -1;
    }
}

 int
recog_15 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[1] = x6;
  x7 = XEXP (x2, 1);
  switch (GET_CODE (x7))
    {
    case SIGN_EXTEND:
      if (pattern216 (x2) != 0)
        return -1;
      if (
#line 2542 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
        return 486; /* *osmulqihi3_split */
      if (pnum_clobbers == NULL
          || !
#line 2555 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 487; /* *osmulqihi3 */

    case ZERO_EXTEND:
      if (pattern216 (x2) != 0)
        return -1;
      if (
#line 2566 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
        return 488; /* *oumulqihi3_split */
      if (pnum_clobbers == NULL
          || !
#line 2579 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 489; /* *oumulqihi3 */

    case CONST_INT:
    case REG:
    case SUBREG:
      operands[2] = x7;
      switch (GET_MODE (operands[0]))
        {
        case E_HImode:
          if (!register_operand (operands[0], E_HImode)
              || GET_MODE (x2) != E_HImode
              || GET_MODE (x3) != E_HImode
              || GET_MODE (x4) != E_HImode
              || GET_MODE (x5) != E_QImode
              || !register_operand (operands[1], E_QImode)
              || !register_operand (operands[2], E_HImode))
            return -1;
          if (
#line 3205 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
            return 535; /* muloqihi3 */
          if (pnum_clobbers == NULL
              || !
#line 3218 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
            return -1;
          *pnum_clobbers = 1;
          return 536; /* *muloqihi3 */

        case E_SImode:
          if (pnum_clobbers == NULL
              || !pseudo_register_operand (operands[0], E_SImode)
              || GET_MODE (x2) != E_SImode
              || GET_MODE (x3) != E_SImode
              || GET_MODE (x4) != E_SImode
              || GET_MODE (x5) != E_HImode
              || !pseudo_register_operand (operands[1], E_HImode)
              || !pseudo_register_or_const_int_operand (operands[2], E_SImode)
              || !
#line 3598 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed))
            return -1;
          *pnum_clobbers = 2;
          return 547; /* *mulohisi3 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_18 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != CONST_INT)
    return -1;
  operands[2] = x3;
  if (pattern164 (x1) == 0)
    return 642; /* *rotlqi3_split */
  x4 = XEXP (x1, 0);
  operands[0] = x4;
  switch (XWINT (x3, 0))
    {
    case 1L:
      switch (pattern203 (x2))
        {
        case 0:
          return 644; /* *rotlhi2.1_split */

        case 1:
          return 648; /* *rotlpsi2.1_split */

        case 2:
          return 652; /* *rotlsi2.1_split */

        default:
          break;
        }
      break;

    case 15L:
      if (register_operand (operands[0], E_HImode)
          && GET_MODE (x2) == E_HImode
          && register_operand (operands[1], E_HImode))
        return 646; /* *rotlhi2.15_split */
      break;

    case 23L:
      if (register_operand (operands[0], E_PSImode)
          && GET_MODE (x2) == E_PSImode
          && register_operand (operands[1], E_PSImode))
        return 650; /* *rotlpsi2.23_split */
      break;

    case 31L:
      if (register_operand (operands[0], E_SImode)
          && GET_MODE (x2) == E_SImode
          && register_operand (operands[1], E_SImode))
        return 654; /* *rotlsi2.31_split */
      break;

    default:
      break;
    }
  if (pnum_clobbers == NULL)
    return -1;
  operands[2] = x3;
  if (!const_int_operand (operands[2], E_VOIDmode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x2) != E_HImode
          || !register_operand (operands[1], E_HImode))
        return -1;
      if (
#line 5236 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MOVW
   && CONST_INT_P (operands[2])
   && 2 % 2 == 0
   && 0 == INTVAL (operands[2]) % 16))
        {
          *pnum_clobbers = 1;
          return 656; /* *rotwhi */
        }
      if (!
#line 5259 "../../gcc/config/avr/avr.md"
(CONST_INT_P (operands[2])
   && (8 == INTVAL (operands[2]) % 16
       || ((!AVR_HAVE_MOVW
            || 2 % 2 != 0)
           && 0 == INTVAL (operands[2]) % 16))))
        return -1;
      *pnum_clobbers = 1;
      return 658; /* *rotbhi */

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x2) != E_SImode
          || !register_operand (operands[1], E_SImode))
        return -1;
      if (
#line 5236 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MOVW
   && CONST_INT_P (operands[2])
   && 4 % 2 == 0
   && 0 == INTVAL (operands[2]) % 16))
        {
          *pnum_clobbers = 1;
          return 657; /* *rotwsi */
        }
      if (!
#line 5259 "../../gcc/config/avr/avr.md"
(CONST_INT_P (operands[2])
   && (8 == INTVAL (operands[2]) % 16
       || ((!AVR_HAVE_MOVW
            || 4 % 2 != 0)
           && 0 == INTVAL (operands[2]) % 16))))
        return -1;
      *pnum_clobbers = 1;
      return 660; /* *rotbsi */

    case E_PSImode:
      if (!register_operand (operands[0], E_PSImode)
          || GET_MODE (x2) != E_PSImode
          || !register_operand (operands[1], E_PSImode)
          || !
#line 5259 "../../gcc/config/avr/avr.md"
(CONST_INT_P (operands[2])
   && (8 == INTVAL (operands[2]) % 16
       || ((!AVR_HAVE_MOVW
            || 3 % 2 != 0)
           && 0 == INTVAL (operands[2]) % 16))))
        return -1;
      *pnum_clobbers = 1;
      return 659; /* *rotbpsi */

    default:
      return -1;
    }
}

 int
recog_25 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case REG:
    case SUBREG:
      operands[1] = x3;
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      x5 = XEXP (x2, 1);
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_QImode:
          if (pattern193 (x2, 
E_QImode) == 0)
            return 634; /* xorqi3 */
          break;

        case E_HImode:
          if (pnum_clobbers != NULL
              && pattern61 (x2, 
E_HImode) == 0)
            {
              *pnum_clobbers = 1;
              return 636; /* xorhi3 */
            }
          break;

        case E_PSImode:
          if (pattern53 (x2, pnum_clobbers, 
E_PSImode) == 0)
            {
              *pnum_clobbers = 1;
              return 638; /* xorpsi3 */
            }
          break;

        case E_SImode:
          if (pnum_clobbers != NULL
              && pattern61 (x2, 
E_SImode) == 0)
            {
              *pnum_clobbers = 1;
              return 640; /* xorsi3 */
            }
          break;

        default:
          break;
        }
      operands[2] = x3;
      if (!register_operand (operands[2], E_QImode)
          || x5 != const_int_rtx[MAX_SAVED_CONST_INT + 1]
          || GET_CODE (x4) != ZERO_EXTRACT
          || GET_MODE (x4) != E_QImode)
        return -1;
      x6 = XEXP (x4, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x7 = XEXP (x4, 0);
      operands[0] = x7;
      if (!register_operand (operands[0], E_QImode))
        return -1;
      x8 = XEXP (x4, 2);
      operands[1] = x8;
      if (!const_0_to_7_operand (operands[1], E_QImode)
          || GET_MODE (x2) != E_QImode)
        return -1;
      return 1087; /* *insv.xor1-bit.0_split */

    case LSHIFTRT:
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      switch (pattern81 (x2))
        {
        case 0:
          if (!
#line 10156 "../../gcc/config/avr/avr.md"
(INTVAL (operands[3]) <= 15))
            return -1;
          return 1092; /* *xorhi.lshiftrt */

        case 1:
          if (!
#line 10156 "../../gcc/config/avr/avr.md"
(INTVAL (operands[3]) <= 23))
            return -1;
          return 1096; /* *xorpsi.lshiftrt */

        case 2:
          if (!
#line 10156 "../../gcc/config/avr/avr.md"
(INTVAL (operands[3]) <= 31))
            return -1;
          return 1100; /* *xorsi.lshiftrt */

        case 3:
          if (!
#line 10992 "../../gcc/config/avr/avr.md"
(optimize && avropt_use_nonzero_bits
   && !reload_completed
   && avr_nonzero_bits_lsr_operands_p (XOR, operands)))
            return -1;
          return 1479; /* *nzb=1.xor.lsr_split */

        case 4:
          if (!
#line 10202 "../../gcc/config/avr/avr.md"
(2 > 1
   && INTVAL (operands[3]) <= 15))
            return -1;
          return 1116; /* *xorhiqi.lshiftrt */

        case 5:
          if (!
#line 10202 "../../gcc/config/avr/avr.md"
(3 > 1
   && INTVAL (operands[3]) <= 23))
            return -1;
          return 1120; /* *xorpsiqi.lshiftrt */

        case 6:
          if (!
#line 10202 "../../gcc/config/avr/avr.md"
(3 > 2
   && INTVAL (operands[3]) <= 23))
            return -1;
          return 1128; /* *xorpsihi.lshiftrt */

        case 7:
          if (!
#line 10202 "../../gcc/config/avr/avr.md"
(4 > 1
   && INTVAL (operands[3]) <= 31))
            return -1;
          return 1124; /* *xorsiqi.lshiftrt */

        case 8:
          if (!
#line 10202 "../../gcc/config/avr/avr.md"
(4 > 2
   && INTVAL (operands[3]) <= 31))
            return -1;
          return 1132; /* *xorsihi.lshiftrt */

        case 9:
          if (!
#line 10202 "../../gcc/config/avr/avr.md"
(4 > 3
   && INTVAL (operands[3]) <= 31))
            return -1;
          return 1136; /* *xorsipsi.lshiftrt */

        case 10:
          if (!
#line 11042 "../../gcc/config/avr/avr.md"
(optimize && avropt_use_nonzero_bits
   && !reload_completed
   && INTVAL (operands[2]) == exact_log2 (0xff & INTVAL (operands[4]))
   && avr_nonzero_bits_lsr_operands_p (XOR, operands)))
            return -1;
          return 1485; /* *nzb=1.xor.lsr.not_split */

        default:
          return -1;
        }

    case ASHIFT:
      switch (pattern48 (x1))
        {
        case 0:
          if (!
#line 10156 "../../gcc/config/avr/avr.md"
(INTVAL (operands[3]) <= 15))
            return -1;
          return 1094; /* *xorhi.ashift */

        case 1:
          if (!
#line 10156 "../../gcc/config/avr/avr.md"
(INTVAL (operands[3]) <= 23))
            return -1;
          return 1098; /* *xorpsi.ashift */

        case 2:
          if (!
#line 10156 "../../gcc/config/avr/avr.md"
(INTVAL (operands[3]) <= 31))
            return -1;
          return 1102; /* *xorsi.ashift */

        case 3:
          if (!
#line 10202 "../../gcc/config/avr/avr.md"
(2 > 1
   && INTVAL (operands[3]) <= 15))
            return -1;
          return 1118; /* *xorhiqi.ashift */

        case 4:
          if (!
#line 10202 "../../gcc/config/avr/avr.md"
(3 > 1
   && INTVAL (operands[3]) <= 23))
            return -1;
          return 1122; /* *xorpsiqi.ashift */

        case 5:
          if (!
#line 10202 "../../gcc/config/avr/avr.md"
(3 > 2
   && INTVAL (operands[3]) <= 23))
            return -1;
          return 1130; /* *xorpsihi.ashift */

        case 6:
          if (!
#line 10202 "../../gcc/config/avr/avr.md"
(4 > 1
   && INTVAL (operands[3]) <= 31))
            return -1;
          return 1126; /* *xorsiqi.ashift */

        case 7:
          if (!
#line 10202 "../../gcc/config/avr/avr.md"
(4 > 2
   && INTVAL (operands[3]) <= 31))
            return -1;
          return 1134; /* *xorsihi.ashift */

        case 8:
          if (!
#line 10202 "../../gcc/config/avr/avr.md"
(4 > 3
   && INTVAL (operands[3]) <= 31))
            return -1;
          return 1138; /* *xorsipsi.ashift */

        case 9:
          if (!
#line 10798 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 2 > 1
   && ! reload_completed))
            return -1;
          return 1373; /* *shl.ext.and1-to-skip.hi */

        case 10:
          if (!
#line 10798 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 1
   && ! reload_completed))
            return -1;
          return 1379; /* *shl.ext.and1-to-skip.psi */

        case 11:
          if (!
#line 10798 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 2
   && ! reload_completed))
            return -1;
          return 1391; /* *shl.ext.and1-to-skip.psi */

        case 12:
          if (!
#line 10798 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 1
   && ! reload_completed))
            return -1;
          return 1385; /* *shl.ext.and1-to-skip.si */

        case 13:
          if (!
#line 10798 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 2
   && ! reload_completed))
            return -1;
          return 1397; /* *shl.ext.and1-to-skip.si */

        case 14:
          if (!
#line 10798 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 3
   && ! reload_completed))
            return -1;
          return 1403; /* *shl.ext.and1-to-skip.si */

        case 15:
          if (!
#line 10798 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 2 > 1
   && ! reload_completed))
            return -1;
          return 1372; /* *shl.ext.and1-to-skip.hi */

        case 16:
          if (!
#line 10798 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 1
   && ! reload_completed))
            return -1;
          return 1378; /* *shl.ext.and1-to-skip.psi */

        case 17:
          if (!
#line 10798 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 2
   && ! reload_completed))
            return -1;
          return 1390; /* *shl.ext.and1-to-skip.psi */

        case 18:
          if (!
#line 10798 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 1
   && ! reload_completed))
            return -1;
          return 1384; /* *shl.ext.and1-to-skip.si */

        case 19:
          if (!
#line 10798 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 2
   && ! reload_completed))
            return -1;
          return 1396; /* *shl.ext.and1-to-skip.si */

        case 20:
          if (!
#line 10798 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 3
   && ! reload_completed))
            return -1;
          return 1402; /* *shl.ext.and1-to-skip.si */

        default:
          return -1;
        }

    case ZERO_EXTEND:
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      x9 = XEXP (x3, 0);
      operands[1] = x9;
      switch (pattern3 (x2))
        {
        case 0:
          return 1104; /* *xorhiqi.0 */

        case 1:
          return 1106; /* *xorpsiqi.0 */

        case 2:
          return 1110; /* *xorpsihi.0 */

        case 3:
          return 1108; /* *xorsiqi.0 */

        case 4:
          return 1112; /* *xorsihi.0 */

        case 5:
          return 1114; /* *xorsipsi.0 */

        default:
          return -1;
        }

    case AND:
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      x9 = XEXP (x3, 0);
      switch (GET_CODE (x9))
        {
        case SIGN_EXTRACT:
          switch (pattern11 (x2))
            {
            case 0:
              if (!
#line 10736 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
                return -1;
              return 1274; /* *pixop-to-skip.qi */

            case 1:
              if (!
#line 10736 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
                return -1;
              return 1286; /* *pixop-to-skip.qi */

            case 2:
              if (!
#line 10736 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
                return -1;
              return 1298; /* *pixop-to-skip.qi */

            case 3:
              if (!
#line 10736 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
                return -1;
              return 1310; /* *pixop-to-skip.qi */

            case 4:
              if (!
#line 10736 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
                return -1;
              return 1277; /* *pixop-to-skip.hi */

            case 5:
              if (!
#line 10736 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
                return -1;
              return 1289; /* *pixop-to-skip.hi */

            case 6:
              if (!
#line 10736 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
                return -1;
              return 1301; /* *pixop-to-skip.hi */

            case 7:
              if (!
#line 10736 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
                return -1;
              return 1313; /* *pixop-to-skip.hi */

            case 8:
              if (!
#line 10736 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
                return -1;
              return 1280; /* *pixop-to-skip.psi */

            case 9:
              if (!
#line 10736 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
                return -1;
              return 1292; /* *pixop-to-skip.psi */

            case 10:
              if (!
#line 10736 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
                return -1;
              return 1304; /* *pixop-to-skip.psi */

            case 11:
              if (!
#line 10736 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
                return -1;
              return 1316; /* *pixop-to-skip.psi */

            case 12:
              if (!
#line 10736 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
                return -1;
              return 1283; /* *pixop-to-skip.si */

            case 13:
              if (!
#line 10736 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
                return -1;
              return 1295; /* *pixop-to-skip.si */

            case 14:
              if (!
#line 10736 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
                return -1;
              return 1307; /* *pixop-to-skip.si */

            case 15:
              if (!
#line 10736 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
                return -1;
              return 1319; /* *pixop-to-skip.si */

            default:
              return -1;
            }

        case ASHIFT:
          switch (pattern12 (x2))
            {
            case 0:
              if (!
#line 10817 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && exact_log2 (UINTVAL (operands[2]) & GET_MODE_MASK (HImode))
      == INTVAL (operands[4])
   && ! reload_completed))
                return -1;
              return 1406; /* *shl.and-to-skip.hi */

            case 1:
              if (!
#line 10817 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && exact_log2 (UINTVAL (operands[2]) & GET_MODE_MASK (PSImode))
      == INTVAL (operands[4])
   && ! reload_completed))
                return -1;
              return 1409; /* *shl.and-to-skip.psi */

            case 2:
              if (!
#line 10817 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && exact_log2 (UINTVAL (operands[2]) & GET_MODE_MASK (SImode))
      == INTVAL (operands[4])
   && ! reload_completed))
                return -1;
              return 1412; /* *shl.and-to-skip.si */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case MULT:
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      switch (pattern87 (x2))
        {
        case 0:
          if (!
#line 10761 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
            return -1;
          return 1322; /* *mul.and1-to-skip.qi */

        case 1:
          if (!
#line 10761 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
            return -1;
          return 1325; /* *mul.and1-to-skip.hi */

        case 2:
          if (!
#line 10761 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
            return -1;
          return 1328; /* *mul.and1-to-skip.psi */

        case 3:
          if (!
#line 10761 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
            return -1;
          return 1331; /* *mul.and1-to-skip.si */

        case 4:
          if (!
#line 10778 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 2 > 1
   && ! reload_completed))
            return -1;
          return 1336; /* *mul.ext.and1-to-skip.hi */

        case 5:
          if (!
#line 10778 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 1
   && ! reload_completed))
            return -1;
          return 1342; /* *mul.ext.and1-to-skip.psi */

        case 6:
          if (!
#line 10778 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 2
   && ! reload_completed))
            return -1;
          return 1354; /* *mul.ext.and1-to-skip.psi */

        case 7:
          if (!
#line 10778 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 1
   && ! reload_completed))
            return -1;
          return 1348; /* *mul.ext.and1-to-skip.si */

        case 8:
          if (!
#line 10778 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 2
   && ! reload_completed))
            return -1;
          return 1360; /* *mul.ext.and1-to-skip.si */

        case 9:
          if (!
#line 10778 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 3
   && ! reload_completed))
            return -1;
          return 1366; /* *mul.ext.and1-to-skip.si */

        case 10:
          if (!
#line 10778 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 2 > 1
   && ! reload_completed))
            return -1;
          return 1337; /* *mul.ext.and1-to-skip.hi */

        case 11:
          if (!
#line 10778 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 1
   && ! reload_completed))
            return -1;
          return 1343; /* *mul.ext.and1-to-skip.psi */

        case 12:
          if (!
#line 10778 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 2
   && ! reload_completed))
            return -1;
          return 1355; /* *mul.ext.and1-to-skip.psi */

        case 13:
          if (!
#line 10778 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 1
   && ! reload_completed))
            return -1;
          return 1349; /* *mul.ext.and1-to-skip.si */

        case 14:
          if (!
#line 10778 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 2
   && ! reload_completed))
            return -1;
          return 1361; /* *mul.ext.and1-to-skip.si */

        case 15:
          if (!
#line 10778 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 3
   && ! reload_completed))
            return -1;
          return 1367; /* *mul.ext.and1-to-skip.si */

        default:
          return -1;
        }

    case ZERO_EXTRACT:
      switch (pattern42 (x1))
        {
        case 0:
          if (!
#line 10947 "../../gcc/config/avr/avr.md"
(optimize && avropt_use_nonzero_bits
   && !reload_completed
   && (XOR == IOR || XOR == XOR
       || nonzero_bits (operands[3], QImode) == 1)))
            return -1;
          return 1473; /* *nzb=1.xor.zerox_split */

        case 1:
          if (!
#line 11016 "../../gcc/config/avr/avr.md"
(optimize && avropt_use_nonzero_bits
   && !reload_completed
   && INTVAL (operands[2]) == exact_log2 (0xff & INTVAL (operands[4]))
   && (XOR == IOR
       || nonzero_bits (operands[3], QImode) == 1)))
            return -1;
          return 1482; /* *nzb=1.xor.zerox.not_split */

        default:
          return -1;
        }

    case GE:
      if (pattern44 (x1) != 0
          || !
#line 11066 "../../gcc/config/avr/avr.md"
(optimize && avropt_use_nonzero_bits
   && !reload_completed
   && (XOR == IOR || XOR == XOR
       || nonzero_bits (operands[2], QImode) == 1)))
        return -1;
      return 1488; /* *nzb=1.xor.ge0_split */

    default:
      return -1;
    }
}

 int
recog_38 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (REGNO (x3) == 22)
    {
      x4 = XVECEXP (x1, 0, 1);
      x5 = XEXP (x4, 0);
      if (GET_CODE (x5) == REG
          && REGNO (x5) == 36
          && GET_MODE (x5) == E_CCmode)
        {
          x6 = XEXP (x2, 1);
          operands[0] = x6;
          switch (GET_MODE (x3))
            {
            case E_QImode:
              if (memory_operand (operands[0], E_QImode)
                  && 
#line 585 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))
   && reload_completed))
                return 20; /* *load_qi_libgcc */
              break;

            case E_QQmode:
              if (memory_operand (operands[0], E_QQmode)
                  && 
#line 585 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))
   && reload_completed))
                return 21; /* *load_qq_libgcc */
              break;

            case E_UQQmode:
              if (memory_operand (operands[0], E_UQQmode)
                  && 
#line 585 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))
   && reload_completed))
                return 22; /* *load_uqq_libgcc */
              break;

            case E_HImode:
              if (memory_operand (operands[0], E_HImode)
                  && 
#line 585 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))
   && reload_completed))
                return 23; /* *load_hi_libgcc */
              break;

            case E_HQmode:
              if (memory_operand (operands[0], E_HQmode)
                  && 
#line 585 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))
   && reload_completed))
                return 24; /* *load_hq_libgcc */
              break;

            case E_UHQmode:
              if (memory_operand (operands[0], E_UHQmode)
                  && 
#line 585 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))
   && reload_completed))
                return 25; /* *load_uhq_libgcc */
              break;

            case E_HAmode:
              if (memory_operand (operands[0], E_HAmode)
                  && 
#line 585 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))
   && reload_completed))
                return 26; /* *load_ha_libgcc */
              break;

            case E_UHAmode:
              if (memory_operand (operands[0], E_UHAmode)
                  && 
#line 585 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))
   && reload_completed))
                return 27; /* *load_uha_libgcc */
              break;

            case E_SImode:
              if (memory_operand (operands[0], E_SImode)
                  && 
#line 585 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))
   && reload_completed))
                return 28; /* *load_si_libgcc */
              break;

            case E_SQmode:
              if (memory_operand (operands[0], E_SQmode)
                  && 
#line 585 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))
   && reload_completed))
                return 29; /* *load_sq_libgcc */
              break;

            case E_USQmode:
              if (memory_operand (operands[0], E_USQmode)
                  && 
#line 585 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))
   && reload_completed))
                return 30; /* *load_usq_libgcc */
              break;

            case E_SAmode:
              if (memory_operand (operands[0], E_SAmode)
                  && 
#line 585 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))
   && reload_completed))
                return 31; /* *load_sa_libgcc */
              break;

            case E_USAmode:
              if (memory_operand (operands[0], E_USAmode)
                  && 
#line 585 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))
   && reload_completed))
                return 32; /* *load_usa_libgcc */
              break;

            case E_SFmode:
              if (memory_operand (operands[0], E_SFmode)
                  && 
#line 585 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))
   && reload_completed))
                return 33; /* *load_sf_libgcc */
              break;

            case E_PSImode:
              if (memory_operand (operands[0], E_PSImode)
                  && 
#line 585 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))
   && reload_completed))
                return 34; /* *load_psi_libgcc */
              break;

            default:
              break;
            }
        }
    }
  if (pnum_clobbers == NULL)
    return -1;
  operands[0] = x3;
  x6 = XEXP (x2, 1);
  operands[1] = x6;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 0);
  operands[2] = x5;
  if (!register_operand (operands[2], E_QImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      if (!l_register_operand (operands[0], E_HImode)
          || !immediate_operand (operands[1], E_HImode)
          || !
#line 950 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 123; /* *reload_inhi */

    case E_HQmode:
      if (!l_register_operand (operands[0], E_HQmode)
          || !immediate_operand (operands[1], E_HQmode)
          || !
#line 950 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 124; /* *reload_inhq */

    case E_UHQmode:
      if (!l_register_operand (operands[0], E_UHQmode)
          || !immediate_operand (operands[1], E_UHQmode)
          || !
#line 950 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 125; /* *reload_inuhq */

    case E_HAmode:
      if (!l_register_operand (operands[0], E_HAmode)
          || !immediate_operand (operands[1], E_HAmode)
          || !
#line 950 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 126; /* *reload_inha */

    case E_UHAmode:
      if (!l_register_operand (operands[0], E_UHAmode)
          || !immediate_operand (operands[1], E_UHAmode)
          || !
#line 950 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 127; /* *reload_inuha */

    default:
      return -1;
    }
}

 int
recog_55 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XVECEXP (x1, 0, 0);
  x4 = XEXP (x3, 1);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
      operands[1] = x5;
      res = recog_41 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      if (GET_CODE (x5) != REG
          || pattern205 (x1) != 0)
        return -1;
      x6 = XEXP (x4, 1);
      switch (GET_CODE (x6))
        {
        case REG:
          switch (pattern334 (x3))
            {
            case 0:
              if (!
#line 114 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
                return -1;
              return 3173; /* *adddi3_insn */

            case 1:
              if (!
#line 114 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
                return -1;
              return 3174; /* *adddq3_insn */

            case 2:
              if (!
#line 114 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
                return -1;
              return 3175; /* *addudq3_insn */

            case 3:
              if (!
#line 114 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
                return -1;
              return 3176; /* *addda3_insn */

            case 4:
              if (!
#line 114 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
                return -1;
              return 3177; /* *adduda3_insn */

            case 5:
              if (!
#line 114 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
                return -1;
              return 3178; /* *addta3_insn */

            case 6:
              if (!
#line 114 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
                return -1;
              return 3179; /* *adduta3_insn */

            default:
              return -1;
            }

        case SIGN_EXTEND:
          if (pattern300 (x6, 
E_QImode, 
26, 
E_DImode) != 0)
            return -1;
          x7 = XEXP (x3, 0);
          if (GET_MODE (x7) != E_DImode
              || GET_MODE (x4) != E_DImode
              || GET_MODE (x5) != E_DImode
              || !
#line 135 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          return 3181; /* *adddi3_const8_insn */

        case CONST_INT:
        case CONST_FIXED:
        case CONST_DOUBLE:
          switch (pattern335 (x3))
            {
            case 0:
              if (!
#line 161 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && !s8_operand (operands[0], VOIDmode)
   && reload_completed))
                return -1;
              return 3189; /* *adddi3_const_insn */

            case 1:
              if (!
#line 161 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && !s8_operand (operands[0], VOIDmode)
   && reload_completed))
                return -1;
              return 3190; /* *adddq3_const_insn */

            case 2:
              if (!
#line 161 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && !s8_operand (operands[0], VOIDmode)
   && reload_completed))
                return -1;
              return 3191; /* *addudq3_const_insn */

            case 3:
              if (!
#line 161 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && !s8_operand (operands[0], VOIDmode)
   && reload_completed))
                return -1;
              return 3192; /* *addda3_const_insn */

            case 4:
              if (!
#line 161 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && !s8_operand (operands[0], VOIDmode)
   && reload_completed))
                return -1;
              return 3193; /* *adduda3_const_insn */

            case 5:
              if (!
#line 161 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && !s8_operand (operands[0], VOIDmode)
   && reload_completed))
                return -1;
              return 3194; /* *addta3_const_insn */

            case 6:
              if (!
#line 161 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && !s8_operand (operands[0], VOIDmode)
   && reload_completed))
                return -1;
              return 3195; /* *adduta3_const_insn */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case ZERO_EXTEND:
      x8 = XEXP (x2, 0);
      if (GET_CODE (x8) != REG
          || REGNO (x8) != 36
          || GET_MODE (x8) != E_CCmode)
        return -1;
      x7 = XEXP (x3, 0);
      operands[0] = x7;
      x9 = XEXP (x5, 0);
      operands[1] = x9;
      x6 = XEXP (x4, 1);
      switch (GET_CODE (x6))
        {
        case REG:
        case SUBREG:
          switch (pattern288 (x4))
            {
            case 0:
              if (!
#line 1653 "../../gcc/config/avr/avr.md"
(reload_completed))
                return -1;
              return 181; /* *addhi3_zero_extend */

            case 1:
              if (!
#line 1998 "../../gcc/config/avr/avr.md"
(reload_completed
   && 3 > 1
   && (3 > 2 || ZERO_EXTEND == SIGN_EXTEND)))
                return -1;
              return 237; /* *addpsi3.zero_extend.qi */

            case 2:
              if (!
#line 1998 "../../gcc/config/avr/avr.md"
(reload_completed
   && 3 > 2
   && (3 > 2 || ZERO_EXTEND == SIGN_EXTEND)))
                return -1;
              return 241; /* *addpsi3.zero_extend.hi */

            case 3:
              if (!
#line 1998 "../../gcc/config/avr/avr.md"
(reload_completed
   && 4 > 1
   && (4 > 2 || ZERO_EXTEND == SIGN_EXTEND)))
                return -1;
              return 239; /* *addsi3.zero_extend.qi */

            case 4:
              if (!
#line 1998 "../../gcc/config/avr/avr.md"
(reload_completed
   && 4 > 2
   && (4 > 2 || ZERO_EXTEND == SIGN_EXTEND)))
                return -1;
              return 243; /* *addsi3.zero_extend.hi */

            case 5:
              if (!
#line 1998 "../../gcc/config/avr/avr.md"
(reload_completed
   && 4 > 3
   && (4 > 2 || ZERO_EXTEND == SIGN_EXTEND)))
                return -1;
              return 245; /* *addsi3.zero_extend.psi */

            default:
              return -1;
            }

        case CONST_INT:
          operands[2] = x6;
          if (!const_m255_to_m1_operand (operands[2], E_HImode)
              || !register_operand (operands[0], E_HImode)
              || GET_MODE (x4) != E_HImode
              || GET_MODE (x5) != E_HImode
              || !register_operand (operands[1], E_QImode)
              || !
#line 1697 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 185; /* *addhi3_zero_extend.const */

        case ZERO_EXTEND:
          if (GET_MODE (x6) != E_HImode
              || !register_operand (operands[0], E_HImode)
              || GET_MODE (x4) != E_HImode
              || GET_MODE (x5) != E_HImode
              || !register_operand (operands[1], E_QImode))
            return -1;
          x10 = XEXP (x6, 0);
          operands[2] = x10;
          if (!register_operand (operands[2], E_QImode)
              || !
#line 1766 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 190; /* *usum_widenqihi3 */

        default:
          return -1;
        }

    case ASHIFT:
      if (GET_MODE (x5) != E_HImode)
        return -1;
      x9 = XEXP (x5, 0);
      if (GET_CODE (x9) != ZERO_EXTEND
          || GET_MODE (x9) != E_HImode)
        return -1;
      x11 = XEXP (x5, 1);
      if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 1]
          || pattern169 (x1, 
E_HImode) != 0)
        return -1;
      x12 = XEXP (x9, 0);
      operands[1] = x12;
      if (!register_operand (operands[1], E_QImode))
        return -1;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      if (!register_operand (operands[2], E_HImode)
          || !
#line 1738 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 188; /* *addhi3_zero_extend.ashift1 */

    case SIGN_EXTEND:
      x8 = XEXP (x2, 0);
      if (GET_CODE (x8) != REG
          || REGNO (x8) != 36
          || GET_MODE (x8) != E_CCmode)
        return -1;
      x7 = XEXP (x3, 0);
      operands[0] = x7;
      x9 = XEXP (x5, 0);
      operands[1] = x9;
      switch (pattern288 (x4))
        {
        case 0:
          if (!
#line 1998 "../../gcc/config/avr/avr.md"
(reload_completed
   && 2 > 1
   && (2 > 2 || SIGN_EXTEND == SIGN_EXTEND)))
            return -1;
          return 235; /* *addhi3.sign_extend.qi */

        case 1:
          if (!
#line 1998 "../../gcc/config/avr/avr.md"
(reload_completed
   && 3 > 1
   && (3 > 2 || SIGN_EXTEND == SIGN_EXTEND)))
            return -1;
          return 236; /* *addpsi3.sign_extend.qi */

        case 2:
          if (!
#line 1998 "../../gcc/config/avr/avr.md"
(reload_completed
   && 3 > 2
   && (3 > 2 || SIGN_EXTEND == SIGN_EXTEND)))
            return -1;
          return 240; /* *addpsi3.sign_extend.hi */

        case 3:
          if (!
#line 1998 "../../gcc/config/avr/avr.md"
(reload_completed
   && 4 > 1
   && (4 > 2 || SIGN_EXTEND == SIGN_EXTEND)))
            return -1;
          return 238; /* *addsi3.sign_extend.qi */

        case 4:
          if (!
#line 1998 "../../gcc/config/avr/avr.md"
(reload_completed
   && 4 > 2
   && (4 > 2 || SIGN_EXTEND == SIGN_EXTEND)))
            return -1;
          return 242; /* *addsi3.sign_extend.hi */

        case 5:
          if (!
#line 1998 "../../gcc/config/avr/avr.md"
(reload_completed
   && 4 > 3
   && (4 > 2 || SIGN_EXTEND == SIGN_EXTEND)))
            return -1;
          return 244; /* *addsi3.sign_extend.psi */

        default:
          return -1;
        }

    case GE:
      switch (pattern167 (x1))
        {
        case 0:
          if (!
#line 2390 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 380; /* *addqi3.ge0 */

        case 1:
          if (!
#line 2390 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 388; /* *addqi3.ge0 */

        case 2:
          if (!
#line 2390 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 396; /* *addqi3.ge0 */

        case 3:
          if (!
#line 2390 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 404; /* *addqi3.ge0 */

        case 4:
          if (!
#line 2390 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 382; /* *addhi3.ge0 */

        case 5:
          if (!
#line 2390 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 390; /* *addhi3.ge0 */

        case 6:
          if (!
#line 2390 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 398; /* *addhi3.ge0 */

        case 7:
          if (!
#line 2390 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 406; /* *addhi3.ge0 */

        case 8:
          if (!
#line 2390 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 384; /* *addpsi3.ge0 */

        case 9:
          if (!
#line 2390 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 392; /* *addpsi3.ge0 */

        case 10:
          if (!
#line 2390 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 400; /* *addpsi3.ge0 */

        case 11:
          if (!
#line 2390 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 408; /* *addpsi3.ge0 */

        case 12:
          if (!
#line 2390 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 386; /* *addsi3.ge0 */

        case 13:
          if (!
#line 2390 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 394; /* *addsi3.ge0 */

        case 14:
          if (!
#line 2390 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 402; /* *addsi3.ge0 */

        case 15:
          if (!
#line 2390 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 410; /* *addsi3.ge0 */

        default:
          return -1;
        }

    case LT:
      switch (pattern167 (x1))
        {
        case 0:
          if (!
#line 2390 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 381; /* *addqi3.lt0 */

        case 1:
          if (!
#line 2390 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 389; /* *addqi3.lt0 */

        case 2:
          if (!
#line 2390 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 397; /* *addqi3.lt0 */

        case 3:
          if (!
#line 2390 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 405; /* *addqi3.lt0 */

        case 4:
          if (!
#line 2390 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 383; /* *addhi3.lt0 */

        case 5:
          if (!
#line 2390 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 391; /* *addhi3.lt0 */

        case 6:
          if (!
#line 2390 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 399; /* *addhi3.lt0 */

        case 7:
          if (!
#line 2390 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 407; /* *addhi3.lt0 */

        case 8:
          if (!
#line 2390 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 385; /* *addpsi3.lt0 */

        case 9:
          if (!
#line 2390 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 393; /* *addpsi3.lt0 */

        case 10:
          if (!
#line 2390 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 401; /* *addpsi3.lt0 */

        case 11:
          if (!
#line 2390 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 409; /* *addpsi3.lt0 */

        case 12:
          if (!
#line 2390 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 387; /* *addsi3.lt0 */

        case 13:
          if (!
#line 2390 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 395; /* *addsi3.lt0 */

        case 14:
          if (!
#line 2390 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 403; /* *addsi3.lt0 */

        case 15:
          if (!
#line 2390 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 411; /* *addsi3.lt0 */

        default:
          return -1;
        }

    case MULT:
      x7 = XEXP (x3, 0);
      operands[0] = x7;
      x6 = XEXP (x4, 1);
      operands[3] = x6;
      x9 = XEXP (x5, 0);
      switch (GET_CODE (x9))
        {
        case REG:
        case SUBREG:
          if (pattern234 (x4) != 0)
            return -1;
          x11 = XEXP (x5, 1);
          operands[2] = x11;
          if (!register_operand (operands[3], E_QImode))
            return -1;
          switch (GET_CODE (operands[2]))
            {
            case REG:
            case SUBREG:
              if (!register_operand (operands[2], E_QImode))
                return -1;
              x8 = XEXP (x2, 0);
              if (GET_CODE (x8) != REG
                  || REGNO (x8) != 36
                  || GET_MODE (x8) != E_CCmode
                  || !
#line 2611 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
                return -1;
              return 491; /* *maddqi4 */

            case CONST_INT:
              if (!const_int_operand (operands[2], E_QImode))
                return -1;
              x8 = XEXP (x2, 0);
              operands[4] = x8;
              if (!scratch_operand (operands[4], E_QImode)
                  || !
#line 2649 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
                return -1;
              return 494; /* *maddqi4.const */

            default:
              return -1;
            }

        case SIGN_EXTEND:
          if (pattern235 (x4) != 0)
            return -1;
          x11 = XEXP (x5, 1);
          switch (GET_CODE (x11))
            {
            case SIGN_EXTEND:
              if (pattern358 (x1) != 0
                  || !
#line 2720 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
                return -1;
              return 498; /* *maddqihi4 */

            case ZERO_EXTEND:
              if (pattern358 (x1) != 0
                  || !
#line 2780 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL
   && reload_completed
   && SIGN_EXTEND != ZERO_EXTEND))
                return -1;
              return 507; /* *sumsubqihi4 */

            case CONST_INT:
              operands[2] = x11;
              x8 = XEXP (x2, 0);
              operands[4] = x8;
              if (!scratch_operand (operands[4], E_QImode))
                return -1;
              if (s8_operand (operands[2], E_HImode)
                  && 
#line 2859 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
                return 513; /* *maddqihi4.sconst */
              if (!u8_operand (operands[2], E_HImode)
                  || !
#line 2951 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL
   && !s8_operand (operands[2], VOIDmode)))
                return -1;
              return 519; /* *sumaddqihi4.uconst */

            default:
              return -1;
            }

        case ZERO_EXTEND:
          if (pattern235 (x4) != 0)
            return -1;
          x11 = XEXP (x5, 1);
          switch (GET_CODE (x11))
            {
            case ZERO_EXTEND:
              if (pattern358 (x1) != 0
                  || !
#line 2720 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
                return -1;
              return 499; /* *umaddqihi4 */

            case SIGN_EXTEND:
              if (pattern358 (x1) != 0
                  || !
#line 2780 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL
   && reload_completed
   && ZERO_EXTEND != SIGN_EXTEND))
                return -1;
              return 506; /* *usmsubqihi4 */

            case CONST_INT:
              operands[2] = x11;
              if (!u8_operand (operands[2], E_HImode))
                return -1;
              x8 = XEXP (x2, 0);
              operands[4] = x8;
              if (!scratch_operand (operands[4], E_QImode)
                  || !
#line 2859 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
                return -1;
              return 514; /* *umaddqihi4.uconst */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_84 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  switch (GET_CODE (x2))
    {
    case SET:
      return recog_83 (x1, insn, pnum_clobbers);

    case UNSPEC_VOLATILE:
      x3 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x3) != SET)
        return -1;
      switch (XVECLEN (x2, 0))
        {
        case 1:
          if (pnum_clobbers == NULL
              || pattern175 (x1) != 0)
            return -1;
          x4 = XEXP (x3, 1);
          x5 = XEXP (x4, 1);
          operands[0] = x5;
          if (!immediate_operand (operands[0], E_HImode))
            return -1;
          x6 = XVECEXP (x1, 0, 2);
          x7 = XEXP (x6, 1);
          x8 = XEXP (x7, 1);
          if (!rtx_equal_p (x8, operands[0]))
            return -1;
          *pnum_clobbers = 2;
          return 997; /* epilogue_restores */

        case 2:
          x4 = XEXP (x3, 1);
          if (GET_CODE (x4) != UNSPEC_VOLATILE
              || XVECLEN (x4, 0) != 1)
            return -1;
          x9 = XVECEXP (x2, 0, 0);
          operands[0] = x9;
          switch (XINT (x2, 1))
            {
            case 3:
              if (pnum_clobbers == NULL
                  || pattern282 (x1) != 0
                  || !
#line 8677 "../../gcc/config/avr/avr.md"
(avropt_gasisr_prologues))
                return -1;
              *pnum_clobbers = 1;
              return 998; /* *gasisr */

            case 10:
              switch (pattern249 (x1))
                {
                case 0:
                  return 1003; /* delay_cycles_1 */

                case 1:
                  return 1005; /* delay_cycles_2 */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_88 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 4);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XVECEXP (x1, 0, 5);
  if (GET_CODE (x3) != CLOBBER)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  switch (GET_CODE (x4))
    {
    case SET:
      x5 = XVECEXP (x1, 0, 3);
      if (GET_CODE (x5) != CLOBBER)
        return -1;
      x6 = XEXP (x3, 0);
      if (GET_CODE (x6) != REG)
        return -1;
      x7 = XEXP (x4, 1);
      switch (GET_CODE (x7))
        {
        case CONST_INT:
          if (XWINT (x7, 0) != 0L
              || pattern174 (x1) != 0
              || REGNO (x6) != 36
              || GET_MODE (x6) != E_CCmode)
            return -1;
          switch (pattern291 (x1))
            {
            case 0:
              if (!
#line 1480 "../../gcc/config/avr/avr.md"
(reload_completed))
                return -1;
              return 169; /* *clrmemqi */

            case 1:
              if (!
#line 1514 "../../gcc/config/avr/avr.md"
(reload_completed))
                return -1;
              return 171; /* *clrmemhi */

            default:
              return -1;
            }

        case DIV:
          if (pattern228 (x1, 
MOD) != 0)
            return -1;
          x8 = XEXP (x4, 0);
          operands[0] = x8;
          switch (pattern346 (x1))
            {
            case 0:
              return 584; /* divmodqi4 */

            case 1:
              return 590; /* divmodhi4 */

            case 2:
              return 612; /* divmodsi4 */

            default:
              break;
            }
          x9 = XEXP (x2, 0);
          if (REGNO (x9) != 26
              || pattern347 (x1) != 0
              || !
#line 4328 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 608; /* *divmodpsi4_call */

        case UDIV:
          if (pattern228 (x1, 
UMOD) != 0)
            return -1;
          x8 = XEXP (x4, 0);
          operands[0] = x8;
          switch (pattern346 (x1))
            {
            case 0:
              return 587; /* udivmodqi4 */

            case 1:
              return 593; /* udivmodhi4 */

            case 2:
              return 615; /* udivmodsi4 */

            default:
              break;
            }
          x9 = XEXP (x2, 0);
          if (REGNO (x9) != 26
              || pattern347 (x1) != 0
              || !
#line 4377 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 611; /* *udivmodpsi4_call */

        default:
          return -1;
        }

    case UNSPEC_VOLATILE:
      switch (XVECLEN (x4, 0))
        {
        case 1:
          if (pattern149 (x1) != 0)
            return -1;
          x10 = XVECEXP (x1, 0, 2);
          x11 = XEXP (x10, 0);
          if (GET_MODE (x11) != E_HImode)
            return -1;
          x5 = XVECEXP (x1, 0, 3);
          if (GET_CODE (x5) != USE
              || pattern372 (x1, 
E_CCmode, 
36) != 0)
            return -1;
          x12 = XVECEXP (x1, 0, 1);
          operands[0] = x12;
          if (!immediate_operand (operands[0], E_HImode))
            return -1;
          x13 = XEXP (x10, 1);
          x14 = XEXP (x13, 1);
          operands[1] = x14;
          if (!immediate_operand (operands[1], E_HImode))
            return -1;
          return 996; /* call_prologue_saves */

        case 2:
          if (XINT (x4, 1) != 10)
            return -1;
          x15 = XVECEXP (x4, 0, 1);
          if (GET_CODE (x15) != CONST_INT)
            return -1;
          x12 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x12) != SET)
            return -1;
          x16 = XEXP (x12, 1);
          if (GET_CODE (x16) != UNSPEC_VOLATILE
              || XVECLEN (x16, 0) != 1
              || XINT (x16, 1) != 6
              || GET_MODE (x16) != E_BLKmode)
            return -1;
          x10 = XVECEXP (x1, 0, 2);
          if (GET_CODE (x10) != CLOBBER)
            return -1;
          x5 = XVECEXP (x1, 0, 3);
          if (GET_CODE (x5) != CLOBBER
              || pattern250 (x1) != 0)
            return -1;
          switch (XWINT (x15, 0))
            {
            case 3L:
              x6 = XEXP (x3, 0);
              if (GET_CODE (x6) != REG
                  || REGNO (x6) != 36
                  || GET_MODE (x6) != E_CCmode
                  || !
#line 8841 "../../gcc/config/avr/avr.md"
(reload_completed))
                return -1;
              return 1008; /* *delay_cycles_3 */

            case 4L:
              x6 = XEXP (x3, 0);
              operands[5] = x6;
              if (!scratch_operand (operands[5], E_QImode))
                return -1;
              return 1009; /* delay_cycles_4 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 rtx_insn *
split_2 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case SIGN_EXTEND:
      switch (pattern130 (x2))
        {
        case 0:
          if (!(
#line 2019 "../../gcc/config/avr/avr.md"
(2 > 1) && 
#line 2021 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_135 (insn, operands);

        case 1:
          if (!(
#line 2019 "../../gcc/config/avr/avr.md"
(3 > 1) && 
#line 2021 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_137 (insn, operands);

        case 2:
          if (!(
#line 2019 "../../gcc/config/avr/avr.md"
(3 > 2) && 
#line 2021 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_141 (insn, operands);

        case 3:
          if (!(
#line 2019 "../../gcc/config/avr/avr.md"
(4 > 1) && 
#line 2021 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_139 (insn, operands);

        case 4:
          if (!(
#line 2019 "../../gcc/config/avr/avr.md"
(4 > 2) && 
#line 2021 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_143 (insn, operands);

        case 5:
          if (!(
#line 2019 "../../gcc/config/avr/avr.md"
(4 > 3) && 
#line 2021 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_145 (insn, operands);

        default:
          return NULL;
        }

    case ZERO_EXTEND:
      switch (pattern130 (x2))
        {
        case 0:
          if (!(
#line 2019 "../../gcc/config/avr/avr.md"
(2 > 1) && 
#line 2021 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_136 (insn, operands);

        case 1:
          if (!(
#line 2019 "../../gcc/config/avr/avr.md"
(3 > 1) && 
#line 2021 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_138 (insn, operands);

        case 2:
          if (!(
#line 2019 "../../gcc/config/avr/avr.md"
(3 > 2) && 
#line 2021 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_142 (insn, operands);

        case 3:
          if (!(
#line 2019 "../../gcc/config/avr/avr.md"
(4 > 1) && 
#line 2021 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_140 (insn, operands);

        case 4:
          if (!(
#line 2019 "../../gcc/config/avr/avr.md"
(4 > 2) && 
#line 2021 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_144 (insn, operands);

        case 5:
          if (!(
#line 2019 "../../gcc/config/avr/avr.md"
(4 > 3) && 
#line 2021 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_146 (insn, operands);

        default:
          return NULL;
        }

    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      operands[2] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_PSImode:
          if (pattern193 (x2, 
E_PSImode) != 0
              || !
#line 2081 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_148 (insn, operands);

        case E_QImode:
          if (pattern215 (x2, 
E_QImode) != 0
              || !
#line 2108 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_149 (insn, operands);

        case E_QQmode:
          if (pattern215 (x2, 
E_QQmode) != 0
              || !
#line 2108 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_150 (insn, operands);

        case E_UQQmode:
          if (pattern215 (x2, 
E_UQQmode) != 0
              || !
#line 2108 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_151 (insn, operands);

        default:
          return NULL;
        }

    case LSHIFTRT:
      switch (pattern131 (x2))
        {
        case 0:
          if (!
#line 2303 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_166 (insn, operands);

        case 1:
          if (!
#line 2303 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_168 (insn, operands);

        case 2:
          if (!
#line 2303 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_170 (insn, operands);

        case 3:
          if (!
#line 2303 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_172 (insn, operands);

        case 4:
          if (!(
#line 2354 "../../gcc/config/avr/avr.md"
(2 > 1) && 
#line 2356 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_194 (insn, operands);

        case 5:
          if (!(
#line 2354 "../../gcc/config/avr/avr.md"
(3 > 1) && 
#line 2356 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_196 (insn, operands);

        case 6:
          if (!(
#line 2354 "../../gcc/config/avr/avr.md"
(3 > 2) && 
#line 2356 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_200 (insn, operands);

        case 7:
          if (!(
#line 2354 "../../gcc/config/avr/avr.md"
(4 > 1) && 
#line 2356 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_198 (insn, operands);

        case 8:
          if (!(
#line 2354 "../../gcc/config/avr/avr.md"
(4 > 2) && 
#line 2356 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_202 (insn, operands);

        case 9:
          if (!(
#line 2354 "../../gcc/config/avr/avr.md"
(4 > 3) && 
#line 2356 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_204 (insn, operands);

        default:
          return NULL;
        }

    case ASHIFTRT:
      switch (pattern131 (x2))
        {
        case 0:
          if (!
#line 2303 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_167 (insn, operands);

        case 1:
          if (!
#line 2303 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_169 (insn, operands);

        case 2:
          if (!
#line 2303 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_171 (insn, operands);

        case 3:
          if (!
#line 2303 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_173 (insn, operands);

        case 4:
          if (!(
#line 2354 "../../gcc/config/avr/avr.md"
(2 > 1) && 
#line 2356 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_195 (insn, operands);

        case 5:
          if (!(
#line 2354 "../../gcc/config/avr/avr.md"
(3 > 1) && 
#line 2356 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_197 (insn, operands);

        case 6:
          if (!(
#line 2354 "../../gcc/config/avr/avr.md"
(3 > 2) && 
#line 2356 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_201 (insn, operands);

        case 7:
          if (!(
#line 2354 "../../gcc/config/avr/avr.md"
(4 > 1) && 
#line 2356 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_199 (insn, operands);

        case 8:
          if (!(
#line 2354 "../../gcc/config/avr/avr.md"
(4 > 2) && 
#line 2356 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_203 (insn, operands);

        case 9:
          if (!(
#line 2354 "../../gcc/config/avr/avr.md"
(4 > 3) && 
#line 2356 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_205 (insn, operands);

        default:
          return NULL;
        }

    case GE:
      switch (pattern133 (x2))
        {
        case 0:
          if (!
#line 2426 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_238 (insn, operands);

        case 1:
          if (!
#line 2426 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_246 (insn, operands);

        case 2:
          if (!
#line 2426 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_254 (insn, operands);

        case 3:
          if (!
#line 2426 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_262 (insn, operands);

        case 4:
          if (!
#line 2426 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_240 (insn, operands);

        case 5:
          if (!
#line 2426 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_248 (insn, operands);

        case 6:
          if (!
#line 2426 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_256 (insn, operands);

        case 7:
          if (!
#line 2426 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_264 (insn, operands);

        case 8:
          if (!
#line 2426 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_242 (insn, operands);

        case 9:
          if (!
#line 2426 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_250 (insn, operands);

        case 10:
          if (!
#line 2426 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_258 (insn, operands);

        case 11:
          if (!
#line 2426 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_266 (insn, operands);

        case 12:
          if (!
#line 2426 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_244 (insn, operands);

        case 13:
          if (!
#line 2426 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_252 (insn, operands);

        case 14:
          if (!
#line 2426 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_260 (insn, operands);

        case 15:
          if (!
#line 2426 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_268 (insn, operands);

        default:
          return NULL;
        }

    case LT:
      switch (pattern133 (x2))
        {
        case 0:
          if (!
#line 2426 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_239 (insn, operands);

        case 1:
          if (!
#line 2426 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_247 (insn, operands);

        case 2:
          if (!
#line 2426 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_255 (insn, operands);

        case 3:
          if (!
#line 2426 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_263 (insn, operands);

        case 4:
          if (!
#line 2426 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_241 (insn, operands);

        case 5:
          if (!
#line 2426 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_249 (insn, operands);

        case 6:
          if (!
#line 2426 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_257 (insn, operands);

        case 7:
          if (!
#line 2426 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_265 (insn, operands);

        case 8:
          if (!
#line 2426 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_243 (insn, operands);

        case 9:
          if (!
#line 2426 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_251 (insn, operands);

        case 10:
          if (!
#line 2426 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_259 (insn, operands);

        case 11:
          if (!
#line 2426 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_267 (insn, operands);

        case 12:
          if (!
#line 2426 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_245 (insn, operands);

        case 13:
          if (!
#line 2426 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_253 (insn, operands);

        case 14:
          if (!
#line 2426 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_261 (insn, operands);

        case 15:
          if (!
#line 2426 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_269 (insn, operands);

        default:
          return NULL;
        }

    case MULT:
      x4 = XEXP (x2, 0);
      operands[3] = x4;
      x5 = XEXP (x3, 0);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
          if (pattern191 (x2) != 0
              || !register_operand (operands[2], E_QImode)
              || !(
#line 2622 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 2624 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_278 (insn, operands);

        case SIGN_EXTEND:
          if (pattern213 (x2) != 0)
            return NULL;
          x6 = XEXP (x3, 1);
          switch (GET_CODE (x6))
            {
            case SIGN_EXTEND:
              x7 = XEXP (x6, 0);
              operands[2] = x7;
              if (!register_operand (operands[2], E_QImode)
                  || !(
#line 2734 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 2736 "../../gcc/config/avr/avr.md"
( reload_completed)))
                return NULL;
              return gen_split_283 (insn, operands);

            case ZERO_EXTEND:
              x7 = XEXP (x6, 0);
              operands[2] = x7;
              if (!register_operand (operands[2], E_QImode)
                  || !(
#line 2798 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL
   && reload_completed
   && SIGN_EXTEND != ZERO_EXTEND) && 
#line 2802 "../../gcc/config/avr/avr.md"
( reload_completed)))
                return NULL;
              return gen_split_288 (insn, operands);

            default:
              return NULL;
            }

        case ZERO_EXTEND:
          if (pattern213 (x2) != 0)
            return NULL;
          x6 = XEXP (x3, 1);
          switch (GET_CODE (x6))
            {
            case ZERO_EXTEND:
              x7 = XEXP (x6, 0);
              operands[2] = x7;
              if (!register_operand (operands[2], E_QImode)
                  || !(
#line 2734 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 2736 "../../gcc/config/avr/avr.md"
( reload_completed)))
                return NULL;
              return gen_split_284 (insn, operands);

            case SIGN_EXTEND:
              x7 = XEXP (x6, 0);
              operands[2] = x7;
              if (!register_operand (operands[2], E_QImode)
                  || !(
#line 2798 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL
   && reload_completed
   && ZERO_EXTEND != SIGN_EXTEND) && 
#line 2802 "../../gcc/config/avr/avr.md"
( reload_completed)))
                return NULL;
              return gen_split_287 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_12 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case REG:
    case SUBREG:
      if (!register_operand (x3, E_QImode)
          || GET_MODE (x2) != E_QImode)
        return NULL;
      x4 = XEXP (x2, 1);
      switch (GET_CODE (x4))
        {
        case REG:
        case SUBREG:
          operands[2] = x4;
          if (!register_operand (operands[2], E_QImode))
            return NULL;
          x5 = XEXP (x1, 0);
          operands[0] = x5;
          if (!register_operand (operands[0], E_QImode))
            return NULL;
          operands[1] = x3;
          if (!
#line 4760 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_375 (insn, operands);

        case CONST_INT:
          if (XWINT (x4, 0) != 1L)
            return NULL;
          x5 = XEXP (x1, 0);
          if (GET_CODE (x5) != ZERO_EXTRACT
              || GET_MODE (x5) != E_QImode)
            return NULL;
          x6 = XEXP (x5, 1);
          if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
            return NULL;
          x7 = XEXP (x5, 0);
          operands[0] = x7;
          if (!register_operand (operands[0], E_QImode))
            return NULL;
          x8 = XEXP (x5, 2);
          operands[1] = x8;
          if (!const_0_to_7_operand (operands[1], E_QImode))
            return NULL;
          operands[2] = x3;
          if (!
#line 10090 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_662 (insn, operands);

        default:
          return NULL;
        }

    case LSHIFTRT:
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      switch (pattern81 (x2))
        {
        case 0:
          if (!(
#line 10156 "../../gcc/config/avr/avr.md"
(INTVAL (operands[3]) <= 15) && 
#line 10158 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_667 (insn, operands);

        case 1:
          if (!(
#line 10156 "../../gcc/config/avr/avr.md"
(INTVAL (operands[3]) <= 23) && 
#line 10158 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_671 (insn, operands);

        case 2:
          if (!(
#line 10156 "../../gcc/config/avr/avr.md"
(INTVAL (operands[3]) <= 31) && 
#line 10158 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_675 (insn, operands);

        case 3:
          if (!
#line 10996 "../../gcc/config/avr/avr.md"
(optimize && avropt_use_nonzero_bits
   && !reload_completed))
            return NULL;
          return gen_split_1018 (insn, operands);

        case 4:
          if (!(
#line 10202 "../../gcc/config/avr/avr.md"
(2 > 1
   && INTVAL (operands[3]) <= 15) && 
#line 10205 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_691 (insn, operands);

        case 5:
          if (!(
#line 10202 "../../gcc/config/avr/avr.md"
(3 > 1
   && INTVAL (operands[3]) <= 23) && 
#line 10205 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_695 (insn, operands);

        case 6:
          if (!(
#line 10202 "../../gcc/config/avr/avr.md"
(3 > 2
   && INTVAL (operands[3]) <= 23) && 
#line 10205 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_703 (insn, operands);

        case 7:
          if (!(
#line 10202 "../../gcc/config/avr/avr.md"
(4 > 1
   && INTVAL (operands[3]) <= 31) && 
#line 10205 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_699 (insn, operands);

        case 8:
          if (!(
#line 10202 "../../gcc/config/avr/avr.md"
(4 > 2
   && INTVAL (operands[3]) <= 31) && 
#line 10205 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_707 (insn, operands);

        case 9:
          if (!(
#line 10202 "../../gcc/config/avr/avr.md"
(4 > 3
   && INTVAL (operands[3]) <= 31) && 
#line 10205 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_711 (insn, operands);

        case 10:
          if (!
#line 11047 "../../gcc/config/avr/avr.md"
(optimize && avropt_use_nonzero_bits
   && !reload_completed))
            return NULL;
          return gen_split_1024 (insn, operands);

        default:
          return NULL;
        }

    case ASHIFT:
      switch (pattern48 (x1))
        {
        case 0:
          if (!(
#line 10156 "../../gcc/config/avr/avr.md"
(INTVAL (operands[3]) <= 15) && 
#line 10158 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_669 (insn, operands);

        case 1:
          if (!(
#line 10156 "../../gcc/config/avr/avr.md"
(INTVAL (operands[3]) <= 23) && 
#line 10158 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_673 (insn, operands);

        case 2:
          if (!(
#line 10156 "../../gcc/config/avr/avr.md"
(INTVAL (operands[3]) <= 31) && 
#line 10158 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_677 (insn, operands);

        case 3:
          if (!(
#line 10202 "../../gcc/config/avr/avr.md"
(2 > 1
   && INTVAL (operands[3]) <= 15) && 
#line 10205 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_693 (insn, operands);

        case 4:
          if (!(
#line 10202 "../../gcc/config/avr/avr.md"
(3 > 1
   && INTVAL (operands[3]) <= 23) && 
#line 10205 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_697 (insn, operands);

        case 5:
          if (!(
#line 10202 "../../gcc/config/avr/avr.md"
(3 > 2
   && INTVAL (operands[3]) <= 23) && 
#line 10205 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_705 (insn, operands);

        case 6:
          if (!(
#line 10202 "../../gcc/config/avr/avr.md"
(4 > 1
   && INTVAL (operands[3]) <= 31) && 
#line 10205 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_701 (insn, operands);

        case 7:
          if (!(
#line 10202 "../../gcc/config/avr/avr.md"
(4 > 2
   && INTVAL (operands[3]) <= 31) && 
#line 10205 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_709 (insn, operands);

        case 8:
          if (!(
#line 10202 "../../gcc/config/avr/avr.md"
(4 > 3
   && INTVAL (operands[3]) <= 31) && 
#line 10205 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_713 (insn, operands);

        case 9:
          if (!(
#line 10798 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 2 > 1
   && ! reload_completed) && 
#line 10802 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_915 (insn, operands);

        case 10:
          if (!(
#line 10798 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 1
   && ! reload_completed) && 
#line 10802 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_921 (insn, operands);

        case 11:
          if (!(
#line 10798 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 2
   && ! reload_completed) && 
#line 10802 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_933 (insn, operands);

        case 12:
          if (!(
#line 10798 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 1
   && ! reload_completed) && 
#line 10802 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_927 (insn, operands);

        case 13:
          if (!(
#line 10798 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 2
   && ! reload_completed) && 
#line 10802 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_939 (insn, operands);

        case 14:
          if (!(
#line 10798 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 3
   && ! reload_completed) && 
#line 10802 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_945 (insn, operands);

        case 15:
          if (!(
#line 10798 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 2 > 1
   && ! reload_completed) && 
#line 10802 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_914 (insn, operands);

        case 16:
          if (!(
#line 10798 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 1
   && ! reload_completed) && 
#line 10802 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_920 (insn, operands);

        case 17:
          if (!(
#line 10798 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 2
   && ! reload_completed) && 
#line 10802 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_932 (insn, operands);

        case 18:
          if (!(
#line 10798 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 1
   && ! reload_completed) && 
#line 10802 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_926 (insn, operands);

        case 19:
          if (!(
#line 10798 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 2
   && ! reload_completed) && 
#line 10802 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_938 (insn, operands);

        case 20:
          if (!(
#line 10798 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 3
   && ! reload_completed) && 
#line 10802 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_944 (insn, operands);

        default:
          return NULL;
        }

    case ZERO_EXTEND:
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      x9 = XEXP (x3, 0);
      operands[1] = x9;
      switch (pattern3 (x2))
        {
        case 0:
          if (!(
#line 10179 "../../gcc/config/avr/avr.md"
(2 > 1) && 
#line 10181 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_679 (insn, operands);

        case 1:
          if (!(
#line 10179 "../../gcc/config/avr/avr.md"
(3 > 1) && 
#line 10181 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_681 (insn, operands);

        case 2:
          if (!(
#line 10179 "../../gcc/config/avr/avr.md"
(3 > 2) && 
#line 10181 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_685 (insn, operands);

        case 3:
          if (!(
#line 10179 "../../gcc/config/avr/avr.md"
(4 > 1) && 
#line 10181 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_683 (insn, operands);

        case 4:
          if (!(
#line 10179 "../../gcc/config/avr/avr.md"
(4 > 2) && 
#line 10181 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_687 (insn, operands);

        case 5:
          if (!(
#line 10179 "../../gcc/config/avr/avr.md"
(4 > 3) && 
#line 10181 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_689 (insn, operands);

        default:
          return NULL;
        }

    case AND:
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      x9 = XEXP (x3, 0);
      switch (GET_CODE (x9))
        {
        case SIGN_EXTRACT:
          switch (pattern11 (x2))
            {
            case 0:
              if (!(
#line 10736 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10739 "../../gcc/config/avr/avr.md"
( 1)))
                return NULL;
              return gen_split_816 (insn, operands);

            case 1:
              if (!(
#line 10736 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10739 "../../gcc/config/avr/avr.md"
( 1)))
                return NULL;
              return gen_split_828 (insn, operands);

            case 2:
              if (!(
#line 10736 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10739 "../../gcc/config/avr/avr.md"
( 1)))
                return NULL;
              return gen_split_840 (insn, operands);

            case 3:
              if (!(
#line 10736 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10739 "../../gcc/config/avr/avr.md"
( 1)))
                return NULL;
              return gen_split_852 (insn, operands);

            case 4:
              if (!(
#line 10736 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10739 "../../gcc/config/avr/avr.md"
( 1)))
                return NULL;
              return gen_split_819 (insn, operands);

            case 5:
              if (!(
#line 10736 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10739 "../../gcc/config/avr/avr.md"
( 1)))
                return NULL;
              return gen_split_831 (insn, operands);

            case 6:
              if (!(
#line 10736 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10739 "../../gcc/config/avr/avr.md"
( 1)))
                return NULL;
              return gen_split_843 (insn, operands);

            case 7:
              if (!(
#line 10736 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10739 "../../gcc/config/avr/avr.md"
( 1)))
                return NULL;
              return gen_split_855 (insn, operands);

            case 8:
              if (!(
#line 10736 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10739 "../../gcc/config/avr/avr.md"
( 1)))
                return NULL;
              return gen_split_822 (insn, operands);

            case 9:
              if (!(
#line 10736 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10739 "../../gcc/config/avr/avr.md"
( 1)))
                return NULL;
              return gen_split_834 (insn, operands);

            case 10:
              if (!(
#line 10736 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10739 "../../gcc/config/avr/avr.md"
( 1)))
                return NULL;
              return gen_split_846 (insn, operands);

            case 11:
              if (!(
#line 10736 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10739 "../../gcc/config/avr/avr.md"
( 1)))
                return NULL;
              return gen_split_858 (insn, operands);

            case 12:
              if (!(
#line 10736 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10739 "../../gcc/config/avr/avr.md"
( 1)))
                return NULL;
              return gen_split_825 (insn, operands);

            case 13:
              if (!(
#line 10736 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10739 "../../gcc/config/avr/avr.md"
( 1)))
                return NULL;
              return gen_split_837 (insn, operands);

            case 14:
              if (!(
#line 10736 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10739 "../../gcc/config/avr/avr.md"
( 1)))
                return NULL;
              return gen_split_849 (insn, operands);

            case 15:
              if (!(
#line 10736 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10739 "../../gcc/config/avr/avr.md"
( 1)))
                return NULL;
              return gen_split_861 (insn, operands);

            default:
              return NULL;
            }

        case ASHIFT:
          switch (pattern12 (x2))
            {
            case 0:
              if (!(
#line 10817 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && exact_log2 (UINTVAL (operands[2]) & GET_MODE_MASK (HImode))
      == INTVAL (operands[4])
   && ! reload_completed) && 
#line 10822 "../../gcc/config/avr/avr.md"
( 1)))
                return NULL;
              return gen_split_948 (insn, operands);

            case 1:
              if (!(
#line 10817 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && exact_log2 (UINTVAL (operands[2]) & GET_MODE_MASK (PSImode))
      == INTVAL (operands[4])
   && ! reload_completed) && 
#line 10822 "../../gcc/config/avr/avr.md"
( 1)))
                return NULL;
              return gen_split_951 (insn, operands);

            case 2:
              if (!(
#line 10817 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && exact_log2 (UINTVAL (operands[2]) & GET_MODE_MASK (SImode))
      == INTVAL (operands[4])
   && ! reload_completed) && 
#line 10822 "../../gcc/config/avr/avr.md"
( 1)))
                return NULL;
              return gen_split_954 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case MULT:
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      switch (pattern87 (x2))
        {
        case 0:
          if (!(
#line 10761 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10764 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_864 (insn, operands);

        case 1:
          if (!(
#line 10761 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10764 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_867 (insn, operands);

        case 2:
          if (!(
#line 10761 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10764 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_870 (insn, operands);

        case 3:
          if (!(
#line 10761 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10764 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_873 (insn, operands);

        case 4:
          if (!(
#line 10778 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 2 > 1
   && ! reload_completed) && 
#line 10782 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_878 (insn, operands);

        case 5:
          if (!(
#line 10778 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 1
   && ! reload_completed) && 
#line 10782 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_884 (insn, operands);

        case 6:
          if (!(
#line 10778 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 2
   && ! reload_completed) && 
#line 10782 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_896 (insn, operands);

        case 7:
          if (!(
#line 10778 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 1
   && ! reload_completed) && 
#line 10782 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_890 (insn, operands);

        case 8:
          if (!(
#line 10778 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 2
   && ! reload_completed) && 
#line 10782 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_902 (insn, operands);

        case 9:
          if (!(
#line 10778 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 3
   && ! reload_completed) && 
#line 10782 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_908 (insn, operands);

        case 10:
          if (!(
#line 10778 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 2 > 1
   && ! reload_completed) && 
#line 10782 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_879 (insn, operands);

        case 11:
          if (!(
#line 10778 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 1
   && ! reload_completed) && 
#line 10782 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_885 (insn, operands);

        case 12:
          if (!(
#line 10778 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 2
   && ! reload_completed) && 
#line 10782 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_897 (insn, operands);

        case 13:
          if (!(
#line 10778 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 1
   && ! reload_completed) && 
#line 10782 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_891 (insn, operands);

        case 14:
          if (!(
#line 10778 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 2
   && ! reload_completed) && 
#line 10782 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_903 (insn, operands);

        case 15:
          if (!(
#line 10778 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 3
   && ! reload_completed) && 
#line 10782 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_909 (insn, operands);

        default:
          return NULL;
        }

    case ZERO_EXTRACT:
      switch (pattern42 (x1))
        {
        case 0:
          if (!
#line 10952 "../../gcc/config/avr/avr.md"
(optimize && avropt_use_nonzero_bits
   && !reload_completed))
            return NULL;
          return gen_split_1015 (insn, operands);

        case 1:
          if (!
#line 11022 "../../gcc/config/avr/avr.md"
(optimize && avropt_use_nonzero_bits
   && !reload_completed))
            return NULL;
          return gen_split_1021 (insn, operands);

        default:
          return NULL;
        }

    case GE:
      if (pattern44 (x1) != 0
          || !
#line 11071 "../../gcc/config/avr/avr.md"
(optimize && avropt_use_nonzero_bits
   && !reload_completed))
        return NULL;
      return gen_split_1027 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_20 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return NULL;
  x4 = XEXP (x2, 0);
  switch (GET_CODE (x4))
    {
    case XOR:
      switch (pattern93 (x1))
        {
        case 0:
          if (!(
#line 10137 "../../gcc/config/avr/avr.md"
(INTVAL (operands[4]) & (1 << INTVAL (operands[3]))) && 
#line 10139 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_666 (insn, operands);

        case 1:
          if (!(
#line 10513 "../../gcc/config/avr/avr.md"
(! reload_completed
   && ((1 << INTVAL (operands[3])) & INTVAL (operands[2])) != 0) && 
#line 10516 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_742 (insn, operands);

        default:
          return NULL;
        }

    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x4;
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      switch (pattern181 (x2))
        {
        case 0:
          if (
#line 10391 "../../gcc/config/avr/avr.md"
( reload_completed))
            return gen_split_720 (insn, operands);
          break;

        case 1:
          if (
#line 10391 "../../gcc/config/avr/avr.md"
( reload_completed))
            return gen_split_721 (insn, operands);
          break;

        case 2:
          if (
#line 10391 "../../gcc/config/avr/avr.md"
( reload_completed))
            return gen_split_722 (insn, operands);
          break;

        case 3:
          if (
#line 10391 "../../gcc/config/avr/avr.md"
( reload_completed))
            return gen_split_723 (insn, operands);
          break;

        case 4:
          return gen_split_724 (insn, operands);

        case 5:
          return gen_split_725 (insn, operands);

        default:
          break;
        }
      if (GET_CODE (x4) != SUBREG)
        return NULL;
      switch (pattern139 (x1))
        {
        case 0:
          if (!(
#line 10490 "../../gcc/config/avr/avr.md"
(! reload_completed
   && IN_RANGE (UINTVAL(operands[2]) & GET_MODE_MASK(HImode),
                1U << (8 * 0), 0x80U << (8 * 0))
   && exact_log2 (UINTVAL(operands[2]) & GET_MODE_MASK(HImode))
      == 8 * 0 + INTVAL (operands[3])) && 
#line 10496 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_730 (insn, operands);

        case 1:
          if (!(
#line 10490 "../../gcc/config/avr/avr.md"
(! reload_completed
   && IN_RANGE (UINTVAL(operands[2]) & GET_MODE_MASK(PSImode),
                1U << (8 * 0), 0x80U << (8 * 0))
   && exact_log2 (UINTVAL(operands[2]) & GET_MODE_MASK(PSImode))
      == 8 * 0 + INTVAL (operands[3])) && 
#line 10496 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_734 (insn, operands);

        case 2:
          if (!(
#line 10490 "../../gcc/config/avr/avr.md"
(! reload_completed
   && IN_RANGE (UINTVAL(operands[2]) & GET_MODE_MASK(SImode),
                1U << (8 * 0), 0x80U << (8 * 0))
   && exact_log2 (UINTVAL(operands[2]) & GET_MODE_MASK(SImode))
      == 8 * 0 + INTVAL (operands[3])) && 
#line 10496 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_738 (insn, operands);

        case 3:
          if (!(
#line 10490 "../../gcc/config/avr/avr.md"
(! reload_completed
   && IN_RANGE (UINTVAL(operands[2]) & GET_MODE_MASK(HImode),
                1U << (8 * 1), 0x80U << (8 * 1))
   && exact_log2 (UINTVAL(operands[2]) & GET_MODE_MASK(HImode))
      == 8 * 1 + INTVAL (operands[3])) && 
#line 10496 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_731 (insn, operands);

        case 4:
          if (!(
#line 10490 "../../gcc/config/avr/avr.md"
(! reload_completed
   && IN_RANGE (UINTVAL(operands[2]) & GET_MODE_MASK(PSImode),
                1U << (8 * 1), 0x80U << (8 * 1))
   && exact_log2 (UINTVAL(operands[2]) & GET_MODE_MASK(PSImode))
      == 8 * 1 + INTVAL (operands[3])) && 
#line 10496 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_735 (insn, operands);

        case 5:
          if (!(
#line 10490 "../../gcc/config/avr/avr.md"
(! reload_completed
   && IN_RANGE (UINTVAL(operands[2]) & GET_MODE_MASK(SImode),
                1U << (8 * 1), 0x80U << (8 * 1))
   && exact_log2 (UINTVAL(operands[2]) & GET_MODE_MASK(SImode))
      == 8 * 1 + INTVAL (operands[3])) && 
#line 10496 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_739 (insn, operands);

        case 6:
          if (!(
#line 10490 "../../gcc/config/avr/avr.md"
(! reload_completed
   && IN_RANGE (UINTVAL(operands[2]) & GET_MODE_MASK(HImode),
                1U << (8 * 2), 0x80U << (8 * 2))
   && exact_log2 (UINTVAL(operands[2]) & GET_MODE_MASK(HImode))
      == 8 * 2 + INTVAL (operands[3])) && 
#line 10496 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_732 (insn, operands);

        case 7:
          if (!(
#line 10490 "../../gcc/config/avr/avr.md"
(! reload_completed
   && IN_RANGE (UINTVAL(operands[2]) & GET_MODE_MASK(PSImode),
                1U << (8 * 2), 0x80U << (8 * 2))
   && exact_log2 (UINTVAL(operands[2]) & GET_MODE_MASK(PSImode))
      == 8 * 2 + INTVAL (operands[3])) && 
#line 10496 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_736 (insn, operands);

        case 8:
          if (!(
#line 10490 "../../gcc/config/avr/avr.md"
(! reload_completed
   && IN_RANGE (UINTVAL(operands[2]) & GET_MODE_MASK(SImode),
                1U << (8 * 2), 0x80U << (8 * 2))
   && exact_log2 (UINTVAL(operands[2]) & GET_MODE_MASK(SImode))
      == 8 * 2 + INTVAL (operands[3])) && 
#line 10496 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_740 (insn, operands);

        case 9:
          if (!(
#line 10490 "../../gcc/config/avr/avr.md"
(! reload_completed
   && IN_RANGE (UINTVAL(operands[2]) & GET_MODE_MASK(HImode),
                1U << (8 * 3), 0x80U << (8 * 3))
   && exact_log2 (UINTVAL(operands[2]) & GET_MODE_MASK(HImode))
      == 8 * 3 + INTVAL (operands[3])) && 
#line 10496 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_733 (insn, operands);

        case 10:
          if (!(
#line 10490 "../../gcc/config/avr/avr.md"
(! reload_completed
   && IN_RANGE (UINTVAL(operands[2]) & GET_MODE_MASK(PSImode),
                1U << (8 * 3), 0x80U << (8 * 3))
   && exact_log2 (UINTVAL(operands[2]) & GET_MODE_MASK(PSImode))
      == 8 * 3 + INTVAL (operands[3])) && 
#line 10496 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_737 (insn, operands);

        case 11:
          if (!(
#line 10490 "../../gcc/config/avr/avr.md"
(! reload_completed
   && IN_RANGE (UINTVAL(operands[2]) & GET_MODE_MASK(SImode),
                1U << (8 * 3), 0x80U << (8 * 3))
   && exact_log2 (UINTVAL(operands[2]) & GET_MODE_MASK(SImode))
      == 8 * 3 + INTVAL (operands[3])) && 
#line 10496 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_741 (insn, operands);

        default:
          return NULL;
        }

    case NOT:
      if (pattern94 (x1) != 0
          || !
#line 10445 "../../gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_726 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_31 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != SET)
    return NULL;
  x3 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x3) != CLOBBER)
    return NULL;
  x4 = XEXP (x2, 1);
  switch (GET_CODE (x4))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      return split_24 (x1, insn);

    case PLUS:
      return split_25 (x1, insn);

    case MINUS:
      return split_26 (x1, insn);

    case MULT:
      x5 = XEXP (x4, 0);
      switch (GET_CODE (x5))
        {
        case REG:
          x6 = XEXP (x4, 1);
          if (GET_CODE (x6) != REG)
            return NULL;
          x7 = XEXP (x2, 0);
          if (GET_CODE (x7) != REG)
            return NULL;
          x8 = XEXP (x3, 0);
          if (GET_CODE (x8) != REG)
            return NULL;
          switch (REGNO (x5))
            {
            case 24:
              if (pattern284 (x1) != 0
                  || !(
#line 2243 "../../gcc/config/avr/avr.md"
(!AVR_HAVE_MUL) && 
#line 2245 "../../gcc/config/avr/avr.md"
( reload_completed)))
                return NULL;
              return gen_split_163 (insn, operands);

            case 22:
              if (pattern285 (x1) != 0
                  || !(
#line 3719 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 3721 "../../gcc/config/avr/avr.md"
( reload_completed)))
                return NULL;
              return gen_split_335 (insn, operands);

            case 18:
              switch (pattern286 (x1))
                {
                case 0:
                  if (!(
#line 425 "../../gcc/config/avr/avr-fixed.md"
(AVR_HAVE_MUL) && 
#line 427 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
                    return NULL;
                  return gen_split_1824 (insn, operands);

                case 1:
                  if (!(
#line 425 "../../gcc/config/avr/avr-fixed.md"
(AVR_HAVE_MUL) && 
#line 427 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
                    return NULL;
                  return gen_split_1825 (insn, operands);

                case 2:
                  if (!(
#line 425 "../../gcc/config/avr/avr-fixed.md"
(AVR_HAVE_MUL) && 
#line 427 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
                    return NULL;
                  return gen_split_1826 (insn, operands);

                case 3:
                  if (!(
#line 425 "../../gcc/config/avr/avr-fixed.md"
(AVR_HAVE_MUL) && 
#line 427 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
                    return NULL;
                  return gen_split_1827 (insn, operands);

                default:
                  return NULL;
                }

            default:
              return NULL;
            }

        case SIGN_EXTEND:
          if (pattern182 (x1) != 0)
            return NULL;
          if (s8_operand (operands[2], E_HImode)
              && (
#line 2998 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 3000 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return gen_split_298 (insn, operands);
          if (u8_operand (operands[2], E_HImode)
              && (
#line 3034 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 3036 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return gen_split_301 (insn, operands);
          if (!o8_operand (operands[2], E_HImode)
              || !(
#line 3052 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 3054 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_302 (insn, operands);

        case ZERO_EXTEND:
          if (pattern182 (x1) != 0)
            return NULL;
          if (u8_operand (operands[2], E_HImode)
              && (
#line 2998 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 3000 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return gen_split_299 (insn, operands);
          if (!s8_operand (operands[2], E_HImode)
              || !(
#line 3016 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 3018 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_300 (insn, operands);

        default:
          return NULL;
        }

    case ASHIFT:
      return split_27 (x1, insn);

    case TRUNCATE:
      if (GET_MODE (x4) != E_HImode
          || pattern183 (x1, 
E_HImode, 
24) != 0)
        return NULL;
      x5 = XEXP (x4, 0);
      if (GET_MODE (x5) != E_SImode)
        return NULL;
      switch (GET_CODE (x5))
        {
        case LSHIFTRT:
          x9 = XEXP (x5, 0);
          if (GET_CODE (x9) != MULT
              || GET_MODE (x9) != E_SImode)
            return NULL;
          x10 = XEXP (x5, 1);
          if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 16])
            return NULL;
          x8 = XEXP (x3, 0);
          if (REGNO (x8) != 22
              || GET_MODE (x8) != E_HImode)
            return NULL;
          switch (pattern362 (x9))
            {
            case 0:
              if (!(
#line 3804 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 3806 "../../gcc/config/avr/avr.md"
( reload_completed)))
                return NULL;
              return gen_split_339 (insn, operands);

            case 1:
              if (!(
#line 3804 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 3806 "../../gcc/config/avr/avr.md"
( reload_completed)))
                return NULL;
              return gen_split_340 (insn, operands);

            default:
              return NULL;
            }

        case CLZ:
          x9 = XEXP (x5, 0);
          if (GET_CODE (x9) != REG
              || REGNO (x9) != 22
              || GET_MODE (x9) != E_SImode)
            return NULL;
          x8 = XEXP (x3, 0);
          if (REGNO (x8) != 26
              || GET_MODE (x8) != E_QImode
              || !
#line 9409 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_647 (insn, operands);

        default:
          return NULL;
        }

    case AND:
      switch (pattern154 (x1))
        {
        case 0:
          if (!
#line 4513 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_368 (insn, operands);

        case 1:
          if (!
#line 4547 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_369 (insn, operands);

        case 2:
          if (!
#line 4582 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_370 (insn, operands);

        default:
          return NULL;
        }

    case IOR:
      switch (pattern154 (x1))
        {
        case 0:
          if (!
#line 4661 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_372 (insn, operands);

        case 1:
          if (!
#line 4693 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_373 (insn, operands);

        case 2:
          if (!
#line 4725 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_374 (insn, operands);

        default:
          return NULL;
        }

    case XOR:
      switch (pattern154 (x1))
        {
        case 0:
          if (!
#line 4782 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_376 (insn, operands);

        case 1:
          if (!
#line 4812 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_377 (insn, operands);

        case 2:
          if (!
#line 4844 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_378 (insn, operands);

        default:
          return NULL;
        }

    case ROTATE:
      x7 = XEXP (x2, 0);
      operands[0] = x7;
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      if (!const_int_operand (operands[2], E_VOIDmode))
        return NULL;
      switch (pattern254 (x1))
        {
        case 0:
          if ((
#line 5236 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MOVW
   && CONST_INT_P (operands[2])
   && 2 % 2 == 0
   && 0 == INTVAL (operands[2]) % 16) && 
#line 5241 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return gen_split_403 (insn, operands);
          if (!(
#line 5259 "../../gcc/config/avr/avr.md"
(CONST_INT_P (operands[2])
   && (8 == INTVAL (operands[2]) % 16
       || ((!AVR_HAVE_MOVW
            || 2 % 2 != 0)
           && 0 == INTVAL (operands[2]) % 16))) && 
#line 5265 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_405 (insn, operands);

        case 1:
          if (!(
#line 5236 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MOVW
   && CONST_INT_P (operands[2])
   && 4 % 2 == 0
   && 0 == INTVAL (operands[2]) % 16) && 
#line 5241 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_404 (insn, operands);

        case 2:
          if (!(
#line 5259 "../../gcc/config/avr/avr.md"
(CONST_INT_P (operands[2])
   && (8 == INTVAL (operands[2]) % 16
       || ((!AVR_HAVE_MOVW
            || 4 % 2 != 0)
           && 0 == INTVAL (operands[2]) % 16))) && 
#line 5265 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_407 (insn, operands);

        case 3:
          if (!(
#line 5259 "../../gcc/config/avr/avr.md"
(CONST_INT_P (operands[2])
   && (8 == INTVAL (operands[2]) % 16
       || ((!AVR_HAVE_MOVW
            || 3 % 2 != 0)
           && 0 == INTVAL (operands[2]) % 16))) && 
#line 5265 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_406 (insn, operands);

        default:
          return NULL;
        }

    case LSHIFTRT:
      x7 = XEXP (x2, 0);
      operands[0] = x7;
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      if (const_int_operand (operands[2], E_QImode))
        {
          switch (pattern255 (x1))
            {
            case 0:
              if (
#line 5595 "../../gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C2r (operands[2])))
                return gen_split_435 (insn, operands);
              break;

            case 1:
              if (
#line 5595 "../../gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C4r (operands[2])))
                return gen_split_438 (insn, operands);
              break;

            case 2:
              if (
#line 5595 "../../gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C3r (operands[2])))
                return gen_split_441 (insn, operands);
              break;

            case 3:
              if (
#line 5595 "../../gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C2r (operands[2])))
                return gen_split_444 (insn, operands);
              break;

            case 4:
              if (
#line 5595 "../../gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C2r (operands[2])))
                return gen_split_447 (insn, operands);
              break;

            case 5:
              if (
#line 5595 "../../gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C2r (operands[2])))
                return gen_split_450 (insn, operands);
              break;

            case 6:
              if (
#line 5595 "../../gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C2r (operands[2])))
                return gen_split_453 (insn, operands);
              break;

            case 7:
              if (
#line 5595 "../../gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C4r (operands[2])))
                return gen_split_456 (insn, operands);
              break;

            case 8:
              if (
#line 5595 "../../gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C4r (operands[2])))
                return gen_split_459 (insn, operands);
              break;

            case 9:
              if (
#line 5595 "../../gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C4r (operands[2])))
                return gen_split_462 (insn, operands);
              break;

            case 10:
              if (
#line 5595 "../../gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C4r (operands[2])))
                return gen_split_465 (insn, operands);
              break;

            default:
              break;
            }
        }
      if (!nonmemory_operand (operands[2], E_QImode)
          || pattern256 (x1) != 0
          || !
#line 6033 "../../gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_532 (insn, operands);

    case ASHIFTRT:
      x7 = XEXP (x2, 0);
      operands[0] = x7;
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      if (const_int_operand (operands[2], E_QImode))
        {
          switch (pattern255 (x1))
            {
            case 0:
              if (
#line 5595 "../../gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C2a (operands[2])))
                return gen_split_436 (insn, operands);
              break;

            case 1:
              if (
#line 5595 "../../gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C4a (operands[2])))
                return gen_split_439 (insn, operands);
              break;

            case 2:
              if (
#line 5595 "../../gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C3a (operands[2])))
                return gen_split_442 (insn, operands);
              break;

            case 3:
              if (
#line 5595 "../../gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C2a (operands[2])))
                return gen_split_445 (insn, operands);
              break;

            case 4:
              if (
#line 5595 "../../gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C2a (operands[2])))
                return gen_split_448 (insn, operands);
              break;

            case 5:
              if (
#line 5595 "../../gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C2a (operands[2])))
                return gen_split_451 (insn, operands);
              break;

            case 6:
              if (
#line 5595 "../../gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C2a (operands[2])))
                return gen_split_454 (insn, operands);
              break;

            case 7:
              if (
#line 5595 "../../gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C4a (operands[2])))
                return gen_split_457 (insn, operands);
              break;

            case 8:
              if (
#line 5595 "../../gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C4a (operands[2])))
                return gen_split_460 (insn, operands);
              break;

            case 9:
              if (
#line 5595 "../../gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C4a (operands[2])))
                return gen_split_463 (insn, operands);
              break;

            case 10:
              if (
#line 5595 "../../gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C4a (operands[2])))
                return gen_split_466 (insn, operands);
              break;

            default:
              break;
            }
        }
      if (!nonmemory_operand (operands[2], E_QImode)
          || pattern256 (x1) != 0
          || !
#line 5833 "../../gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_511 (insn, operands);

    case LO_SUM:
      if (GET_MODE (x4) != E_PSImode
          || pattern171 (x1) != 0
          || !
#line 6638 "../../gcc/config/avr/avr.md"
(reload_completed))
        return NULL;
      return gen_split_560 (insn, operands);

    case COMPARE:
      if (GET_MODE (x4) != E_CCmode)
        return NULL;
      x5 = XEXP (x4, 0);
      if (GET_CODE (x5) != LSHIFTRT)
        return NULL;
      x6 = XEXP (x4, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return NULL;
      x7 = XEXP (x2, 0);
      if (GET_CODE (x7) != REG
          || REGNO (x7) != 36
          || GET_MODE (x7) != E_CCmode)
        return NULL;
      x8 = XEXP (x3, 0);
      if (GET_CODE (x8) != SCRATCH
          || GET_MODE (x8) != E_QImode)
        return NULL;
      switch (pattern327 (x5))
        {
        case 0:
          if (!(
#line 6912 "../../gcc/config/avr/avr.md"
(reload_completed) && 
#line 6916 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_566 (insn, operands);

        case 1:
          if (!(
#line 6912 "../../gcc/config/avr/avr.md"
(reload_completed) && 
#line 6916 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_567 (insn, operands);

        case 2:
          if (!(
#line 6912 "../../gcc/config/avr/avr.md"
(reload_completed) && 
#line 6916 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_568 (insn, operands);

        default:
          return NULL;
        }

    case IF_THEN_ELSE:
      x5 = XEXP (x4, 0);
      if (!ordered_comparison_operator (x5, E_VOIDmode))
        return NULL;
      operands[0] = x5;
      x6 = XEXP (x4, 1);
      if (GET_CODE (x6) != LABEL_REF)
        return NULL;
      x11 = XEXP (x4, 2);
      if (GET_CODE (x11) != PC)
        return NULL;
      x7 = XEXP (x2, 0);
      if (GET_CODE (x7) != PC)
        return NULL;
      x9 = XEXP (x5, 0);
      operands[1] = x9;
      switch (pattern292 (x1))
        {
        case 0:
          if (
#line 7020 "../../gcc/config/avr/avr.md"
(reload_completed))
            return gen_split_572 (insn, operands);
          break;

        case 1:
          if (
#line 7020 "../../gcc/config/avr/avr.md"
(reload_completed))
            return gen_split_573 (insn, operands);
          break;

        case 2:
          if (
#line 7020 "../../gcc/config/avr/avr.md"
(reload_completed))
            return gen_split_574 (insn, operands);
          break;

        case 3:
          if (
#line 7020 "../../gcc/config/avr/avr.md"
(reload_completed))
            return gen_split_575 (insn, operands);
          break;

        case 4:
          if (
#line 7020 "../../gcc/config/avr/avr.md"
(reload_completed))
            return gen_split_576 (insn, operands);
          break;

        case 5:
          if (
#line 7047 "../../gcc/config/avr/avr.md"
(reload_completed))
            return gen_split_577 (insn, operands);
          break;

        case 6:
          if (
#line 7075 "../../gcc/config/avr/avr.md"
(reload_completed))
            return gen_split_578 (insn, operands);
          break;

        case 7:
          if (
#line 7075 "../../gcc/config/avr/avr.md"
(reload_completed))
            return gen_split_579 (insn, operands);
          break;

        case 8:
          if (
#line 7075 "../../gcc/config/avr/avr.md"
(reload_completed))
            return gen_split_580 (insn, operands);
          break;

        case 9:
          if (
#line 7075 "../../gcc/config/avr/avr.md"
(reload_completed))
            return gen_split_581 (insn, operands);
          break;

        case 10:
          if (
#line 7075 "../../gcc/config/avr/avr.md"
(reload_completed))
            return gen_split_582 (insn, operands);
          break;

        default:
          break;
        }
      if (GET_CODE (x9) != REG)
        return NULL;
      switch (pattern293 (x1))
        {
        case 0:
          if (!(
#line 555 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && !s8_operand (operands[1], VOIDmode)) && 
#line 558 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
            return NULL;
          return gen_split_1928 (insn, operands);

        case 1:
          if (!(
#line 555 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && !s8_operand (operands[1], VOIDmode)) && 
#line 558 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
            return NULL;
          return gen_split_1929 (insn, operands);

        case 2:
          if (!(
#line 555 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && !s8_operand (operands[1], VOIDmode)) && 
#line 558 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
            return NULL;
          return gen_split_1930 (insn, operands);

        case 3:
          if (!(
#line 555 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && !s8_operand (operands[1], VOIDmode)) && 
#line 558 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
            return NULL;
          return gen_split_1931 (insn, operands);

        case 4:
          if (!(
#line 555 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && !s8_operand (operands[1], VOIDmode)) && 
#line 558 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
            return NULL;
          return gen_split_1932 (insn, operands);

        case 5:
          if (!(
#line 555 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && !s8_operand (operands[1], VOIDmode)) && 
#line 558 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
            return NULL;
          return gen_split_1933 (insn, operands);

        case 6:
          if (!(
#line 555 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && !s8_operand (operands[1], VOIDmode)) && 
#line 558 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
            return NULL;
          return gen_split_1934 (insn, operands);

        default:
          return NULL;
        }

    case PARITY:
      if (GET_MODE (x4) != E_HImode)
        return NULL;
      x8 = XEXP (x3, 0);
      if (GET_CODE (x8) != REG
          || REGNO (x8) != 24)
        return NULL;
      switch (pattern227 (x1))
        {
        case 0:
          if (!(
#line 9144 "../../gcc/config/avr/avr.md"
(!reload_completed) && 
#line 9146 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_635 (insn, operands);

        case 1:
          if (!(
#line 9173 "../../gcc/config/avr/avr.md"
(!reload_completed) && 
#line 9175 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_637 (insn, operands);

        default:
          return NULL;
        }

    case ZERO_EXTEND:
      if (GET_MODE (x4) != E_HImode)
        return NULL;
      x5 = XEXP (x4, 0);
      if (GET_CODE (x5) != PARITY
          || GET_MODE (x5) != E_QImode)
        return NULL;
      x8 = XEXP (x3, 0);
      if (GET_CODE (x8) != REG
          || REGNO (x8) != 24
          || GET_MODE (x8) != E_HImode)
        return NULL;
      x7 = XEXP (x2, 0);
      operands[0] = x7;
      if (!register_operand (operands[0], E_HImode))
        return NULL;
      x9 = XEXP (x5, 0);
      operands[1] = x9;
      if (!register_operand (operands[1], E_QImode)
          || !(
#line 9159 "../../gcc/config/avr/avr.md"
(!reload_completed) && 
#line 9161 "../../gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_636 (insn, operands);

    case CLZ:
      if (pattern156 (x1) != 0
          || !
#line 9388 "../../gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_646 (insn, operands);

    case CTZ:
      if (pattern156 (x1) != 0
          || !
#line 9457 "../../gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_648 (insn, operands);

    case FFS:
      if (pattern156 (x1) != 0
          || !
#line 9529 "../../gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_650 (insn, operands);

    case UNSPEC:
      if (XVECLEN (x4, 0) != 2)
        return NULL;
      x12 = XVECEXP (x4, 0, 0);
      if (GET_CODE (x12) != REG)
        return NULL;
      x13 = XVECEXP (x4, 0, 1);
      if (GET_CODE (x13) != REG
          || GET_MODE (x13) != E_QImode)
        return NULL;
      x7 = XEXP (x2, 0);
      if (GET_CODE (x7) != REG)
        return NULL;
      x8 = XEXP (x3, 0);
      if (GET_CODE (x8) != REG)
        return NULL;
      switch (pattern296 (x1))
        {
        case 0:
          if (!(
#line 9733 "../../gcc/config/avr/avr.md"
(!AVR_HAVE_MUL) && 
#line 9735 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_654 (insn, operands);

        case 1:
          if (!(
#line 9805 "../../gcc/config/avr/avr.md"
(!AVR_HAVE_MUL) && 
#line 9807 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_656 (insn, operands);

        case 2:
          if (!(
#line 9877 "../../gcc/config/avr/avr.md"
(!AVR_HAVE_MUL) && 
#line 9879 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_658 (insn, operands);

        case 3:
          if (!
#line 716 "../../gcc/config/avr/avr-fixed.md"
( reload_completed))
            return NULL;
          return gen_split_1856 (insn, operands);

        case 4:
          if (!
#line 716 "../../gcc/config/avr/avr-fixed.md"
( reload_completed))
            return NULL;
          return gen_split_1857 (insn, operands);

        case 5:
          if (!
#line 742 "../../gcc/config/avr/avr-fixed.md"
( reload_completed))
            return NULL;
          return gen_split_1858 (insn, operands);

        case 6:
          if (!
#line 742 "../../gcc/config/avr/avr-fixed.md"
( reload_completed))
            return NULL;
          return gen_split_1859 (insn, operands);

        case 7:
          if (!
#line 742 "../../gcc/config/avr/avr-fixed.md"
( reload_completed))
            return NULL;
          return gen_split_1860 (insn, operands);

        case 8:
          if (!
#line 742 "../../gcc/config/avr/avr-fixed.md"
( reload_completed))
            return NULL;
          return gen_split_1861 (insn, operands);

        case 9:
          if (!
#line 768 "../../gcc/config/avr/avr-fixed.md"
( reload_completed))
            return NULL;
          return gen_split_1862 (insn, operands);

        case 10:
          if (!
#line 768 "../../gcc/config/avr/avr-fixed.md"
( reload_completed))
            return NULL;
          return gen_split_1863 (insn, operands);

        case 11:
          if (!
#line 768 "../../gcc/config/avr/avr-fixed.md"
( reload_completed))
            return NULL;
          return gen_split_1864 (insn, operands);

        case 12:
          if (!
#line 768 "../../gcc/config/avr/avr-fixed.md"
( reload_completed))
            return NULL;
          return gen_split_1865 (insn, operands);

        default:
          return NULL;
        }

    case UDIV:
      switch (pattern157 (x1))
        {
        case 0:
          if (!
#line 516 "../../gcc/config/avr/avr-fixed.md"
( reload_completed))
            return NULL;
          return gen_split_1830 (insn, operands);

        case 1:
          if (!
#line 516 "../../gcc/config/avr/avr-fixed.md"
( reload_completed))
            return NULL;
          return gen_split_1832 (insn, operands);

        default:
          return NULL;
        }

    case DIV:
      switch (pattern157 (x1))
        {
        case 0:
          if (!
#line 516 "../../gcc/config/avr/avr-fixed.md"
( reload_completed))
            return NULL;
          return gen_split_1831 (insn, operands);

        case 1:
          if (!
#line 516 "../../gcc/config/avr/avr-fixed.md"
( reload_completed))
            return NULL;
          return gen_split_1833 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}
