/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern9 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[1]))
    {
    case E_QImode:
      if (!register_operand (operands[1], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!register_operand (operands[1], E_HImode))
        return -1;
      return 1;

    case E_PSImode:
      if (!register_operand (operands[1], E_PSImode))
        return -1;
      return 2;

    case E_SImode:
      if (!register_operand (operands[1], E_SImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern15 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      if (!register_operand (operands[0], E_QImode)
          || GET_MODE (x3) != E_QImode
          || !register_operand (operands[1], E_QImode))
        return -1;
      return 0;

    case E_SFmode:
      if (!register_operand (operands[0], E_SFmode)
          || GET_MODE (x3) != E_SFmode
          || !register_operand (operands[1], E_SFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern18 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_PSImode)
      || GET_MODE (x1) != E_PSImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_QImode:
      if (!combine_pseudo_register_operand (operands[1], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!combine_pseudo_register_operand (operands[1], E_HImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern23 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_QQmode:
      if (!register_operand (operands[0], E_QQmode)
          || GET_MODE (x3) != E_QQmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_UQQmode:
          if (!register_operand (operands[1], E_UQQmode))
            return -1;
          return 0;

        case E_HQmode:
          if (!register_operand (operands[1], E_HQmode))
            return -1;
          return 1;

        case E_UHQmode:
          if (!register_operand (operands[1], E_UHQmode))
            return -1;
          return 2;

        case E_HAmode:
          if (!register_operand (operands[1], E_HAmode))
            return -1;
          return 3;

        case E_UHAmode:
          if (!register_operand (operands[1], E_UHAmode))
            return -1;
          return 4;

        case E_SQmode:
          if (!register_operand (operands[1], E_SQmode))
            return -1;
          return 5;

        case E_USQmode:
          if (!register_operand (operands[1], E_USQmode))
            return -1;
          return 6;

        case E_SAmode:
          if (!register_operand (operands[1], E_SAmode))
            return -1;
          return 7;

        case E_USAmode:
          if (!register_operand (operands[1], E_USAmode))
            return -1;
          return 8;

        case E_DQmode:
          if (!register_operand (operands[1], E_DQmode))
            return -1;
          return 9;

        case E_UDQmode:
          if (!register_operand (operands[1], E_UDQmode))
            return -1;
          return 10;

        case E_DAmode:
          if (!register_operand (operands[1], E_DAmode))
            return -1;
          return 11;

        case E_UDAmode:
          if (!register_operand (operands[1], E_UDAmode))
            return -1;
          return 12;

        case E_TAmode:
          if (!register_operand (operands[1], E_TAmode))
            return -1;
          return 13;

        case E_UTAmode:
          if (!register_operand (operands[1], E_UTAmode))
            return -1;
          return 14;

        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 15;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 16;

        case E_SImode:
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 17;

        case E_DImode:
          if (!register_operand (operands[1], E_DImode))
            return -1;
          return 18;

        default:
          return -1;
        }

    case E_UQQmode:
      if (!register_operand (operands[0], E_UQQmode)
          || GET_MODE (x3) != E_UQQmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QQmode:
          if (!register_operand (operands[1], E_QQmode))
            return -1;
          return 19;

        case E_HQmode:
          if (!register_operand (operands[1], E_HQmode))
            return -1;
          return 20;

        case E_UHQmode:
          if (!register_operand (operands[1], E_UHQmode))
            return -1;
          return 21;

        case E_HAmode:
          if (!register_operand (operands[1], E_HAmode))
            return -1;
          return 22;

        case E_UHAmode:
          if (!register_operand (operands[1], E_UHAmode))
            return -1;
          return 23;

        case E_SQmode:
          if (!register_operand (operands[1], E_SQmode))
            return -1;
          return 24;

        case E_USQmode:
          if (!register_operand (operands[1], E_USQmode))
            return -1;
          return 25;

        case E_SAmode:
          if (!register_operand (operands[1], E_SAmode))
            return -1;
          return 26;

        case E_USAmode:
          if (!register_operand (operands[1], E_USAmode))
            return -1;
          return 27;

        case E_DQmode:
          if (!register_operand (operands[1], E_DQmode))
            return -1;
          return 28;

        case E_UDQmode:
          if (!register_operand (operands[1], E_UDQmode))
            return -1;
          return 29;

        case E_DAmode:
          if (!register_operand (operands[1], E_DAmode))
            return -1;
          return 30;

        case E_UDAmode:
          if (!register_operand (operands[1], E_UDAmode))
            return -1;
          return 31;

        case E_TAmode:
          if (!register_operand (operands[1], E_TAmode))
            return -1;
          return 32;

        case E_UTAmode:
          if (!register_operand (operands[1], E_UTAmode))
            return -1;
          return 33;

        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 34;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 35;

        case E_SImode:
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 36;

        case E_DImode:
          if (!register_operand (operands[1], E_DImode))
            return -1;
          return 37;

        default:
          return -1;
        }

    case E_HQmode:
      if (!register_operand (operands[0], E_HQmode)
          || GET_MODE (x3) != E_HQmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QQmode:
          if (!register_operand (operands[1], E_QQmode))
            return -1;
          return 38;

        case E_UQQmode:
          if (!register_operand (operands[1], E_UQQmode))
            return -1;
          return 39;

        case E_UHQmode:
          if (!register_operand (operands[1], E_UHQmode))
            return -1;
          return 40;

        case E_HAmode:
          if (!register_operand (operands[1], E_HAmode))
            return -1;
          return 41;

        case E_UHAmode:
          if (!register_operand (operands[1], E_UHAmode))
            return -1;
          return 42;

        case E_SQmode:
          if (!register_operand (operands[1], E_SQmode))
            return -1;
          return 43;

        case E_USQmode:
          if (!register_operand (operands[1], E_USQmode))
            return -1;
          return 44;

        case E_SAmode:
          if (!register_operand (operands[1], E_SAmode))
            return -1;
          return 45;

        case E_USAmode:
          if (!register_operand (operands[1], E_USAmode))
            return -1;
          return 46;

        case E_DQmode:
          if (!register_operand (operands[1], E_DQmode))
            return -1;
          return 47;

        case E_UDQmode:
          if (!register_operand (operands[1], E_UDQmode))
            return -1;
          return 48;

        case E_DAmode:
          if (!register_operand (operands[1], E_DAmode))
            return -1;
          return 49;

        case E_UDAmode:
          if (!register_operand (operands[1], E_UDAmode))
            return -1;
          return 50;

        case E_TAmode:
          if (!register_operand (operands[1], E_TAmode))
            return -1;
          return 51;

        case E_UTAmode:
          if (!register_operand (operands[1], E_UTAmode))
            return -1;
          return 52;

        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 53;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 54;

        case E_SImode:
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 55;

        case E_DImode:
          if (!register_operand (operands[1], E_DImode))
            return -1;
          return 56;

        default:
          return -1;
        }

    case E_UHQmode:
      if (!register_operand (operands[0], E_UHQmode)
          || GET_MODE (x3) != E_UHQmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QQmode:
          if (!register_operand (operands[1], E_QQmode))
            return -1;
          return 57;

        case E_UQQmode:
          if (!register_operand (operands[1], E_UQQmode))
            return -1;
          return 58;

        case E_HQmode:
          if (!register_operand (operands[1], E_HQmode))
            return -1;
          return 59;

        case E_HAmode:
          if (!register_operand (operands[1], E_HAmode))
            return -1;
          return 60;

        case E_UHAmode:
          if (!register_operand (operands[1], E_UHAmode))
            return -1;
          return 61;

        case E_SQmode:
          if (!register_operand (operands[1], E_SQmode))
            return -1;
          return 62;

        case E_USQmode:
          if (!register_operand (operands[1], E_USQmode))
            return -1;
          return 63;

        case E_SAmode:
          if (!register_operand (operands[1], E_SAmode))
            return -1;
          return 64;

        case E_USAmode:
          if (!register_operand (operands[1], E_USAmode))
            return -1;
          return 65;

        case E_DQmode:
          if (!register_operand (operands[1], E_DQmode))
            return -1;
          return 66;

        case E_UDQmode:
          if (!register_operand (operands[1], E_UDQmode))
            return -1;
          return 67;

        case E_DAmode:
          if (!register_operand (operands[1], E_DAmode))
            return -1;
          return 68;

        case E_UDAmode:
          if (!register_operand (operands[1], E_UDAmode))
            return -1;
          return 69;

        case E_TAmode:
          if (!register_operand (operands[1], E_TAmode))
            return -1;
          return 70;

        case E_UTAmode:
          if (!register_operand (operands[1], E_UTAmode))
            return -1;
          return 71;

        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 72;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 73;

        case E_SImode:
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 74;

        case E_DImode:
          if (!register_operand (operands[1], E_DImode))
            return -1;
          return 75;

        default:
          return -1;
        }

    case E_HAmode:
      if (!register_operand (operands[0], E_HAmode)
          || GET_MODE (x3) != E_HAmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QQmode:
          if (!register_operand (operands[1], E_QQmode))
            return -1;
          return 76;

        case E_UQQmode:
          if (!register_operand (operands[1], E_UQQmode))
            return -1;
          return 77;

        case E_HQmode:
          if (!register_operand (operands[1], E_HQmode))
            return -1;
          return 78;

        case E_UHQmode:
          if (!register_operand (operands[1], E_UHQmode))
            return -1;
          return 79;

        case E_UHAmode:
          if (!register_operand (operands[1], E_UHAmode))
            return -1;
          return 80;

        case E_SQmode:
          if (!register_operand (operands[1], E_SQmode))
            return -1;
          return 81;

        case E_USQmode:
          if (!register_operand (operands[1], E_USQmode))
            return -1;
          return 82;

        case E_SAmode:
          if (!register_operand (operands[1], E_SAmode))
            return -1;
          return 83;

        case E_USAmode:
          if (!register_operand (operands[1], E_USAmode))
            return -1;
          return 84;

        case E_DQmode:
          if (!register_operand (operands[1], E_DQmode))
            return -1;
          return 85;

        case E_UDQmode:
          if (!register_operand (operands[1], E_UDQmode))
            return -1;
          return 86;

        case E_DAmode:
          if (!register_operand (operands[1], E_DAmode))
            return -1;
          return 87;

        case E_UDAmode:
          if (!register_operand (operands[1], E_UDAmode))
            return -1;
          return 88;

        case E_TAmode:
          if (!register_operand (operands[1], E_TAmode))
            return -1;
          return 89;

        case E_UTAmode:
          if (!register_operand (operands[1], E_UTAmode))
            return -1;
          return 90;

        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 91;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 92;

        case E_SImode:
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 93;

        case E_DImode:
          if (!register_operand (operands[1], E_DImode))
            return -1;
          return 94;

        default:
          return -1;
        }

    case E_UHAmode:
      if (!register_operand (operands[0], E_UHAmode)
          || GET_MODE (x3) != E_UHAmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QQmode:
          if (!register_operand (operands[1], E_QQmode))
            return -1;
          return 95;

        case E_UQQmode:
          if (!register_operand (operands[1], E_UQQmode))
            return -1;
          return 96;

        case E_HQmode:
          if (!register_operand (operands[1], E_HQmode))
            return -1;
          return 97;

        case E_UHQmode:
          if (!register_operand (operands[1], E_UHQmode))
            return -1;
          return 98;

        case E_HAmode:
          if (!register_operand (operands[1], E_HAmode))
            return -1;
          return 99;

        case E_SQmode:
          if (!register_operand (operands[1], E_SQmode))
            return -1;
          return 100;

        case E_USQmode:
          if (!register_operand (operands[1], E_USQmode))
            return -1;
          return 101;

        case E_SAmode:
          if (!register_operand (operands[1], E_SAmode))
            return -1;
          return 102;

        case E_USAmode:
          if (!register_operand (operands[1], E_USAmode))
            return -1;
          return 103;

        case E_DQmode:
          if (!register_operand (operands[1], E_DQmode))
            return -1;
          return 104;

        case E_UDQmode:
          if (!register_operand (operands[1], E_UDQmode))
            return -1;
          return 105;

        case E_DAmode:
          if (!register_operand (operands[1], E_DAmode))
            return -1;
          return 106;

        case E_UDAmode:
          if (!register_operand (operands[1], E_UDAmode))
            return -1;
          return 107;

        case E_TAmode:
          if (!register_operand (operands[1], E_TAmode))
            return -1;
          return 108;

        case E_UTAmode:
          if (!register_operand (operands[1], E_UTAmode))
            return -1;
          return 109;

        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 110;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 111;

        case E_SImode:
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 112;

        case E_DImode:
          if (!register_operand (operands[1], E_DImode))
            return -1;
          return 113;

        default:
          return -1;
        }

    case E_SQmode:
      if (!register_operand (operands[0], E_SQmode)
          || GET_MODE (x3) != E_SQmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QQmode:
          if (!register_operand (operands[1], E_QQmode))
            return -1;
          return 114;

        case E_UQQmode:
          if (!register_operand (operands[1], E_UQQmode))
            return -1;
          return 115;

        case E_HQmode:
          if (!register_operand (operands[1], E_HQmode))
            return -1;
          return 116;

        case E_UHQmode:
          if (!register_operand (operands[1], E_UHQmode))
            return -1;
          return 117;

        case E_HAmode:
          if (!register_operand (operands[1], E_HAmode))
            return -1;
          return 118;

        case E_UHAmode:
          if (!register_operand (operands[1], E_UHAmode))
            return -1;
          return 119;

        case E_USQmode:
          if (!register_operand (operands[1], E_USQmode))
            return -1;
          return 120;

        case E_SAmode:
          if (!register_operand (operands[1], E_SAmode))
            return -1;
          return 121;

        case E_USAmode:
          if (!register_operand (operands[1], E_USAmode))
            return -1;
          return 122;

        case E_DQmode:
          if (!register_operand (operands[1], E_DQmode))
            return -1;
          return 123;

        case E_UDQmode:
          if (!register_operand (operands[1], E_UDQmode))
            return -1;
          return 124;

        case E_DAmode:
          if (!register_operand (operands[1], E_DAmode))
            return -1;
          return 125;

        case E_UDAmode:
          if (!register_operand (operands[1], E_UDAmode))
            return -1;
          return 126;

        case E_TAmode:
          if (!register_operand (operands[1], E_TAmode))
            return -1;
          return 127;

        case E_UTAmode:
          if (!register_operand (operands[1], E_UTAmode))
            return -1;
          return 128;

        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 129;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 130;

        case E_SImode:
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 131;

        case E_DImode:
          if (!register_operand (operands[1], E_DImode))
            return -1;
          return 132;

        default:
          return -1;
        }

    case E_USQmode:
      if (!register_operand (operands[0], E_USQmode)
          || GET_MODE (x3) != E_USQmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QQmode:
          if (!register_operand (operands[1], E_QQmode))
            return -1;
          return 133;

        case E_UQQmode:
          if (!register_operand (operands[1], E_UQQmode))
            return -1;
          return 134;

        case E_HQmode:
          if (!register_operand (operands[1], E_HQmode))
            return -1;
          return 135;

        case E_UHQmode:
          if (!register_operand (operands[1], E_UHQmode))
            return -1;
          return 136;

        case E_HAmode:
          if (!register_operand (operands[1], E_HAmode))
            return -1;
          return 137;

        case E_UHAmode:
          if (!register_operand (operands[1], E_UHAmode))
            return -1;
          return 138;

        case E_SQmode:
          if (!register_operand (operands[1], E_SQmode))
            return -1;
          return 139;

        case E_SAmode:
          if (!register_operand (operands[1], E_SAmode))
            return -1;
          return 140;

        case E_USAmode:
          if (!register_operand (operands[1], E_USAmode))
            return -1;
          return 141;

        case E_DQmode:
          if (!register_operand (operands[1], E_DQmode))
            return -1;
          return 142;

        case E_UDQmode:
          if (!register_operand (operands[1], E_UDQmode))
            return -1;
          return 143;

        case E_DAmode:
          if (!register_operand (operands[1], E_DAmode))
            return -1;
          return 144;

        case E_UDAmode:
          if (!register_operand (operands[1], E_UDAmode))
            return -1;
          return 145;

        case E_TAmode:
          if (!register_operand (operands[1], E_TAmode))
            return -1;
          return 146;

        case E_UTAmode:
          if (!register_operand (operands[1], E_UTAmode))
            return -1;
          return 147;

        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 148;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 149;

        case E_SImode:
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 150;

        case E_DImode:
          if (!register_operand (operands[1], E_DImode))
            return -1;
          return 151;

        default:
          return -1;
        }

    case E_SAmode:
      if (!register_operand (operands[0], E_SAmode)
          || GET_MODE (x3) != E_SAmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QQmode:
          if (!register_operand (operands[1], E_QQmode))
            return -1;
          return 152;

        case E_UQQmode:
          if (!register_operand (operands[1], E_UQQmode))
            return -1;
          return 153;

        case E_HQmode:
          if (!register_operand (operands[1], E_HQmode))
            return -1;
          return 154;

        case E_UHQmode:
          if (!register_operand (operands[1], E_UHQmode))
            return -1;
          return 155;

        case E_HAmode:
          if (!register_operand (operands[1], E_HAmode))
            return -1;
          return 156;

        case E_UHAmode:
          if (!register_operand (operands[1], E_UHAmode))
            return -1;
          return 157;

        case E_SQmode:
          if (!register_operand (operands[1], E_SQmode))
            return -1;
          return 158;

        case E_USQmode:
          if (!register_operand (operands[1], E_USQmode))
            return -1;
          return 159;

        case E_USAmode:
          if (!register_operand (operands[1], E_USAmode))
            return -1;
          return 160;

        case E_DQmode:
          if (!register_operand (operands[1], E_DQmode))
            return -1;
          return 161;

        case E_UDQmode:
          if (!register_operand (operands[1], E_UDQmode))
            return -1;
          return 162;

        case E_DAmode:
          if (!register_operand (operands[1], E_DAmode))
            return -1;
          return 163;

        case E_UDAmode:
          if (!register_operand (operands[1], E_UDAmode))
            return -1;
          return 164;

        case E_TAmode:
          if (!register_operand (operands[1], E_TAmode))
            return -1;
          return 165;

        case E_UTAmode:
          if (!register_operand (operands[1], E_UTAmode))
            return -1;
          return 166;

        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 167;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 168;

        case E_SImode:
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 169;

        case E_DImode:
          if (!register_operand (operands[1], E_DImode))
            return -1;
          return 170;

        default:
          return -1;
        }

    case E_USAmode:
      if (!register_operand (operands[0], E_USAmode)
          || GET_MODE (x3) != E_USAmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QQmode:
          if (!register_operand (operands[1], E_QQmode))
            return -1;
          return 171;

        case E_UQQmode:
          if (!register_operand (operands[1], E_UQQmode))
            return -1;
          return 172;

        case E_HQmode:
          if (!register_operand (operands[1], E_HQmode))
            return -1;
          return 173;

        case E_UHQmode:
          if (!register_operand (operands[1], E_UHQmode))
            return -1;
          return 174;

        case E_HAmode:
          if (!register_operand (operands[1], E_HAmode))
            return -1;
          return 175;

        case E_UHAmode:
          if (!register_operand (operands[1], E_UHAmode))
            return -1;
          return 176;

        case E_SQmode:
          if (!register_operand (operands[1], E_SQmode))
            return -1;
          return 177;

        case E_USQmode:
          if (!register_operand (operands[1], E_USQmode))
            return -1;
          return 178;

        case E_SAmode:
          if (!register_operand (operands[1], E_SAmode))
            return -1;
          return 179;

        case E_DQmode:
          if (!register_operand (operands[1], E_DQmode))
            return -1;
          return 180;

        case E_UDQmode:
          if (!register_operand (operands[1], E_UDQmode))
            return -1;
          return 181;

        case E_DAmode:
          if (!register_operand (operands[1], E_DAmode))
            return -1;
          return 182;

        case E_UDAmode:
          if (!register_operand (operands[1], E_UDAmode))
            return -1;
          return 183;

        case E_TAmode:
          if (!register_operand (operands[1], E_TAmode))
            return -1;
          return 184;

        case E_UTAmode:
          if (!register_operand (operands[1], E_UTAmode))
            return -1;
          return 185;

        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 186;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 187;

        case E_SImode:
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 188;

        case E_DImode:
          if (!register_operand (operands[1], E_DImode))
            return -1;
          return 189;

        default:
          return -1;
        }

    case E_DQmode:
      if (!register_operand (operands[0], E_DQmode)
          || GET_MODE (x3) != E_DQmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QQmode:
          if (!register_operand (operands[1], E_QQmode))
            return -1;
          return 190;

        case E_UQQmode:
          if (!register_operand (operands[1], E_UQQmode))
            return -1;
          return 191;

        case E_HQmode:
          if (!register_operand (operands[1], E_HQmode))
            return -1;
          return 192;

        case E_UHQmode:
          if (!register_operand (operands[1], E_UHQmode))
            return -1;
          return 193;

        case E_HAmode:
          if (!register_operand (operands[1], E_HAmode))
            return -1;
          return 194;

        case E_UHAmode:
          if (!register_operand (operands[1], E_UHAmode))
            return -1;
          return 195;

        case E_SQmode:
          if (!register_operand (operands[1], E_SQmode))
            return -1;
          return 196;

        case E_USQmode:
          if (!register_operand (operands[1], E_USQmode))
            return -1;
          return 197;

        case E_SAmode:
          if (!register_operand (operands[1], E_SAmode))
            return -1;
          return 198;

        case E_USAmode:
          if (!register_operand (operands[1], E_USAmode))
            return -1;
          return 199;

        case E_UDQmode:
          if (!register_operand (operands[1], E_UDQmode))
            return -1;
          return 200;

        case E_DAmode:
          if (!register_operand (operands[1], E_DAmode))
            return -1;
          return 201;

        case E_UDAmode:
          if (!register_operand (operands[1], E_UDAmode))
            return -1;
          return 202;

        case E_TAmode:
          if (!register_operand (operands[1], E_TAmode))
            return -1;
          return 203;

        case E_UTAmode:
          if (!register_operand (operands[1], E_UTAmode))
            return -1;
          return 204;

        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 205;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 206;

        case E_SImode:
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 207;

        case E_DImode:
          if (!register_operand (operands[1], E_DImode))
            return -1;
          return 208;

        default:
          return -1;
        }

    case E_UDQmode:
      if (!register_operand (operands[0], E_UDQmode)
          || GET_MODE (x3) != E_UDQmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QQmode:
          if (!register_operand (operands[1], E_QQmode))
            return -1;
          return 209;

        case E_UQQmode:
          if (!register_operand (operands[1], E_UQQmode))
            return -1;
          return 210;

        case E_HQmode:
          if (!register_operand (operands[1], E_HQmode))
            return -1;
          return 211;

        case E_UHQmode:
          if (!register_operand (operands[1], E_UHQmode))
            return -1;
          return 212;

        case E_HAmode:
          if (!register_operand (operands[1], E_HAmode))
            return -1;
          return 213;

        case E_UHAmode:
          if (!register_operand (operands[1], E_UHAmode))
            return -1;
          return 214;

        case E_SQmode:
          if (!register_operand (operands[1], E_SQmode))
            return -1;
          return 215;

        case E_USQmode:
          if (!register_operand (operands[1], E_USQmode))
            return -1;
          return 216;

        case E_SAmode:
          if (!register_operand (operands[1], E_SAmode))
            return -1;
          return 217;

        case E_USAmode:
          if (!register_operand (operands[1], E_USAmode))
            return -1;
          return 218;

        case E_DQmode:
          if (!register_operand (operands[1], E_DQmode))
            return -1;
          return 219;

        case E_DAmode:
          if (!register_operand (operands[1], E_DAmode))
            return -1;
          return 220;

        case E_UDAmode:
          if (!register_operand (operands[1], E_UDAmode))
            return -1;
          return 221;

        case E_TAmode:
          if (!register_operand (operands[1], E_TAmode))
            return -1;
          return 222;

        case E_UTAmode:
          if (!register_operand (operands[1], E_UTAmode))
            return -1;
          return 223;

        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 224;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 225;

        case E_SImode:
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 226;

        case E_DImode:
          if (!register_operand (operands[1], E_DImode))
            return -1;
          return 227;

        default:
          return -1;
        }

    case E_DAmode:
      if (!register_operand (operands[0], E_DAmode)
          || GET_MODE (x3) != E_DAmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QQmode:
          if (!register_operand (operands[1], E_QQmode))
            return -1;
          return 228;

        case E_UQQmode:
          if (!register_operand (operands[1], E_UQQmode))
            return -1;
          return 229;

        case E_HQmode:
          if (!register_operand (operands[1], E_HQmode))
            return -1;
          return 230;

        case E_UHQmode:
          if (!register_operand (operands[1], E_UHQmode))
            return -1;
          return 231;

        case E_HAmode:
          if (!register_operand (operands[1], E_HAmode))
            return -1;
          return 232;

        case E_UHAmode:
          if (!register_operand (operands[1], E_UHAmode))
            return -1;
          return 233;

        case E_SQmode:
          if (!register_operand (operands[1], E_SQmode))
            return -1;
          return 234;

        case E_USQmode:
          if (!register_operand (operands[1], E_USQmode))
            return -1;
          return 235;

        case E_SAmode:
          if (!register_operand (operands[1], E_SAmode))
            return -1;
          return 236;

        case E_USAmode:
          if (!register_operand (operands[1], E_USAmode))
            return -1;
          return 237;

        case E_DQmode:
          if (!register_operand (operands[1], E_DQmode))
            return -1;
          return 238;

        case E_UDQmode:
          if (!register_operand (operands[1], E_UDQmode))
            return -1;
          return 239;

        case E_UDAmode:
          if (!register_operand (operands[1], E_UDAmode))
            return -1;
          return 240;

        case E_TAmode:
          if (!register_operand (operands[1], E_TAmode))
            return -1;
          return 241;

        case E_UTAmode:
          if (!register_operand (operands[1], E_UTAmode))
            return -1;
          return 242;

        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 243;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 244;

        case E_SImode:
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 245;

        case E_DImode:
          if (!register_operand (operands[1], E_DImode))
            return -1;
          return 246;

        default:
          return -1;
        }

    case E_UDAmode:
      if (!register_operand (operands[0], E_UDAmode)
          || GET_MODE (x3) != E_UDAmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QQmode:
          if (!register_operand (operands[1], E_QQmode))
            return -1;
          return 247;

        case E_UQQmode:
          if (!register_operand (operands[1], E_UQQmode))
            return -1;
          return 248;

        case E_HQmode:
          if (!register_operand (operands[1], E_HQmode))
            return -1;
          return 249;

        case E_UHQmode:
          if (!register_operand (operands[1], E_UHQmode))
            return -1;
          return 250;

        case E_HAmode:
          if (!register_operand (operands[1], E_HAmode))
            return -1;
          return 251;

        case E_UHAmode:
          if (!register_operand (operands[1], E_UHAmode))
            return -1;
          return 252;

        case E_SQmode:
          if (!register_operand (operands[1], E_SQmode))
            return -1;
          return 253;

        case E_USQmode:
          if (!register_operand (operands[1], E_USQmode))
            return -1;
          return 254;

        case E_SAmode:
          if (!register_operand (operands[1], E_SAmode))
            return -1;
          return 255;

        case E_USAmode:
          if (!register_operand (operands[1], E_USAmode))
            return -1;
          return 256;

        case E_DQmode:
          if (!register_operand (operands[1], E_DQmode))
            return -1;
          return 257;

        case E_UDQmode:
          if (!register_operand (operands[1], E_UDQmode))
            return -1;
          return 258;

        case E_DAmode:
          if (!register_operand (operands[1], E_DAmode))
            return -1;
          return 259;

        case E_TAmode:
          if (!register_operand (operands[1], E_TAmode))
            return -1;
          return 260;

        case E_UTAmode:
          if (!register_operand (operands[1], E_UTAmode))
            return -1;
          return 261;

        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 262;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 263;

        case E_SImode:
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 264;

        case E_DImode:
          if (!register_operand (operands[1], E_DImode))
            return -1;
          return 265;

        default:
          return -1;
        }

    case E_TAmode:
      if (!register_operand (operands[0], E_TAmode)
          || GET_MODE (x3) != E_TAmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QQmode:
          if (!register_operand (operands[1], E_QQmode))
            return -1;
          return 266;

        case E_UQQmode:
          if (!register_operand (operands[1], E_UQQmode))
            return -1;
          return 267;

        case E_HQmode:
          if (!register_operand (operands[1], E_HQmode))
            return -1;
          return 268;

        case E_UHQmode:
          if (!register_operand (operands[1], E_UHQmode))
            return -1;
          return 269;

        case E_HAmode:
          if (!register_operand (operands[1], E_HAmode))
            return -1;
          return 270;

        case E_UHAmode:
          if (!register_operand (operands[1], E_UHAmode))
            return -1;
          return 271;

        case E_SQmode:
          if (!register_operand (operands[1], E_SQmode))
            return -1;
          return 272;

        case E_USQmode:
          if (!register_operand (operands[1], E_USQmode))
            return -1;
          return 273;

        case E_SAmode:
          if (!register_operand (operands[1], E_SAmode))
            return -1;
          return 274;

        case E_USAmode:
          if (!register_operand (operands[1], E_USAmode))
            return -1;
          return 275;

        case E_DQmode:
          if (!register_operand (operands[1], E_DQmode))
            return -1;
          return 276;

        case E_UDQmode:
          if (!register_operand (operands[1], E_UDQmode))
            return -1;
          return 277;

        case E_DAmode:
          if (!register_operand (operands[1], E_DAmode))
            return -1;
          return 278;

        case E_UDAmode:
          if (!register_operand (operands[1], E_UDAmode))
            return -1;
          return 279;

        case E_UTAmode:
          if (!register_operand (operands[1], E_UTAmode))
            return -1;
          return 280;

        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 281;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 282;

        case E_SImode:
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 283;

        case E_DImode:
          if (!register_operand (operands[1], E_DImode))
            return -1;
          return 284;

        default:
          return -1;
        }

    case E_UTAmode:
      if (!register_operand (operands[0], E_UTAmode)
          || GET_MODE (x3) != E_UTAmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QQmode:
          if (!register_operand (operands[1], E_QQmode))
            return -1;
          return 285;

        case E_UQQmode:
          if (!register_operand (operands[1], E_UQQmode))
            return -1;
          return 286;

        case E_HQmode:
          if (!register_operand (operands[1], E_HQmode))
            return -1;
          return 287;

        case E_UHQmode:
          if (!register_operand (operands[1], E_UHQmode))
            return -1;
          return 288;

        case E_HAmode:
          if (!register_operand (operands[1], E_HAmode))
            return -1;
          return 289;

        case E_UHAmode:
          if (!register_operand (operands[1], E_UHAmode))
            return -1;
          return 290;

        case E_SQmode:
          if (!register_operand (operands[1], E_SQmode))
            return -1;
          return 291;

        case E_USQmode:
          if (!register_operand (operands[1], E_USQmode))
            return -1;
          return 292;

        case E_SAmode:
          if (!register_operand (operands[1], E_SAmode))
            return -1;
          return 293;

        case E_USAmode:
          if (!register_operand (operands[1], E_USAmode))
            return -1;
          return 294;

        case E_DQmode:
          if (!register_operand (operands[1], E_DQmode))
            return -1;
          return 295;

        case E_UDQmode:
          if (!register_operand (operands[1], E_UDQmode))
            return -1;
          return 296;

        case E_DAmode:
          if (!register_operand (operands[1], E_DAmode))
            return -1;
          return 297;

        case E_UDAmode:
          if (!register_operand (operands[1], E_UDAmode))
            return -1;
          return 298;

        case E_TAmode:
          if (!register_operand (operands[1], E_TAmode))
            return -1;
          return 299;

        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 300;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 301;

        case E_SImode:
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 302;

        case E_DImode:
          if (!register_operand (operands[1], E_DImode))
            return -1;
          return 303;

        default:
          return -1;
        }

    case E_QImode:
      if (!register_operand (operands[0], E_QImode)
          || GET_MODE (x3) != E_QImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QQmode:
          if (!register_operand (operands[1], E_QQmode))
            return -1;
          return 304;

        case E_UQQmode:
          if (!register_operand (operands[1], E_UQQmode))
            return -1;
          return 305;

        case E_HQmode:
          if (!register_operand (operands[1], E_HQmode))
            return -1;
          return 306;

        case E_UHQmode:
          if (!register_operand (operands[1], E_UHQmode))
            return -1;
          return 307;

        case E_HAmode:
          if (!register_operand (operands[1], E_HAmode))
            return -1;
          return 308;

        case E_UHAmode:
          if (!register_operand (operands[1], E_UHAmode))
            return -1;
          return 309;

        case E_SQmode:
          if (!register_operand (operands[1], E_SQmode))
            return -1;
          return 310;

        case E_USQmode:
          if (!register_operand (operands[1], E_USQmode))
            return -1;
          return 311;

        case E_SAmode:
          if (!register_operand (operands[1], E_SAmode))
            return -1;
          return 312;

        case E_USAmode:
          if (!register_operand (operands[1], E_USAmode))
            return -1;
          return 313;

        case E_DQmode:
          if (!register_operand (operands[1], E_DQmode))
            return -1;
          return 314;

        case E_UDQmode:
          if (!register_operand (operands[1], E_UDQmode))
            return -1;
          return 315;

        case E_DAmode:
          if (!register_operand (operands[1], E_DAmode))
            return -1;
          return 316;

        case E_UDAmode:
          if (!register_operand (operands[1], E_UDAmode))
            return -1;
          return 317;

        case E_TAmode:
          if (!register_operand (operands[1], E_TAmode))
            return -1;
          return 318;

        case E_UTAmode:
          if (!register_operand (operands[1], E_UTAmode))
            return -1;
          return 319;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 320;

        case E_SImode:
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 321;

        case E_DImode:
          if (!register_operand (operands[1], E_DImode))
            return -1;
          return 322;

        default:
          return -1;
        }

    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x3) != E_HImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QQmode:
          if (!register_operand (operands[1], E_QQmode))
            return -1;
          return 323;

        case E_UQQmode:
          if (!register_operand (operands[1], E_UQQmode))
            return -1;
          return 324;

        case E_HQmode:
          if (!register_operand (operands[1], E_HQmode))
            return -1;
          return 325;

        case E_UHQmode:
          if (!register_operand (operands[1], E_UHQmode))
            return -1;
          return 326;

        case E_HAmode:
          if (!register_operand (operands[1], E_HAmode))
            return -1;
          return 327;

        case E_UHAmode:
          if (!register_operand (operands[1], E_UHAmode))
            return -1;
          return 328;

        case E_SQmode:
          if (!register_operand (operands[1], E_SQmode))
            return -1;
          return 329;

        case E_USQmode:
          if (!register_operand (operands[1], E_USQmode))
            return -1;
          return 330;

        case E_SAmode:
          if (!register_operand (operands[1], E_SAmode))
            return -1;
          return 331;

        case E_USAmode:
          if (!register_operand (operands[1], E_USAmode))
            return -1;
          return 332;

        case E_DQmode:
          if (!register_operand (operands[1], E_DQmode))
            return -1;
          return 333;

        case E_UDQmode:
          if (!register_operand (operands[1], E_UDQmode))
            return -1;
          return 334;

        case E_DAmode:
          if (!register_operand (operands[1], E_DAmode))
            return -1;
          return 335;

        case E_UDAmode:
          if (!register_operand (operands[1], E_UDAmode))
            return -1;
          return 336;

        case E_TAmode:
          if (!register_operand (operands[1], E_TAmode))
            return -1;
          return 337;

        case E_UTAmode:
          if (!register_operand (operands[1], E_UTAmode))
            return -1;
          return 338;

        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 339;

        case E_SImode:
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 340;

        case E_DImode:
          if (!register_operand (operands[1], E_DImode))
            return -1;
          return 341;

        default:
          return -1;
        }

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QQmode:
          if (!register_operand (operands[1], E_QQmode))
            return -1;
          return 342;

        case E_UQQmode:
          if (!register_operand (operands[1], E_UQQmode))
            return -1;
          return 343;

        case E_HQmode:
          if (!register_operand (operands[1], E_HQmode))
            return -1;
          return 344;

        case E_UHQmode:
          if (!register_operand (operands[1], E_UHQmode))
            return -1;
          return 345;

        case E_HAmode:
          if (!register_operand (operands[1], E_HAmode))
            return -1;
          return 346;

        case E_UHAmode:
          if (!register_operand (operands[1], E_UHAmode))
            return -1;
          return 347;

        case E_SQmode:
          if (!register_operand (operands[1], E_SQmode))
            return -1;
          return 348;

        case E_USQmode:
          if (!register_operand (operands[1], E_USQmode))
            return -1;
          return 349;

        case E_SAmode:
          if (!register_operand (operands[1], E_SAmode))
            return -1;
          return 350;

        case E_USAmode:
          if (!register_operand (operands[1], E_USAmode))
            return -1;
          return 351;

        case E_DQmode:
          if (!register_operand (operands[1], E_DQmode))
            return -1;
          return 352;

        case E_UDQmode:
          if (!register_operand (operands[1], E_UDQmode))
            return -1;
          return 353;

        case E_DAmode:
          if (!register_operand (operands[1], E_DAmode))
            return -1;
          return 354;

        case E_UDAmode:
          if (!register_operand (operands[1], E_UDAmode))
            return -1;
          return 355;

        case E_TAmode:
          if (!register_operand (operands[1], E_TAmode))
            return -1;
          return 356;

        case E_UTAmode:
          if (!register_operand (operands[1], E_UTAmode))
            return -1;
          return 357;

        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 358;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 359;

        case E_DImode:
          if (!register_operand (operands[1], E_DImode))
            return -1;
          return 360;

        default:
          return -1;
        }

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QQmode:
          if (!register_operand (operands[1], E_QQmode))
            return -1;
          return 361;

        case E_UQQmode:
          if (!register_operand (operands[1], E_UQQmode))
            return -1;
          return 362;

        case E_HQmode:
          if (!register_operand (operands[1], E_HQmode))
            return -1;
          return 363;

        case E_UHQmode:
          if (!register_operand (operands[1], E_UHQmode))
            return -1;
          return 364;

        case E_HAmode:
          if (!register_operand (operands[1], E_HAmode))
            return -1;
          return 365;

        case E_UHAmode:
          if (!register_operand (operands[1], E_UHAmode))
            return -1;
          return 366;

        case E_SQmode:
          if (!register_operand (operands[1], E_SQmode))
            return -1;
          return 367;

        case E_USQmode:
          if (!register_operand (operands[1], E_USQmode))
            return -1;
          return 368;

        case E_SAmode:
          if (!register_operand (operands[1], E_SAmode))
            return -1;
          return 369;

        case E_USAmode:
          if (!register_operand (operands[1], E_USAmode))
            return -1;
          return 370;

        case E_DQmode:
          if (!register_operand (operands[1], E_DQmode))
            return -1;
          return 371;

        case E_UDQmode:
          if (!register_operand (operands[1], E_UDQmode))
            return -1;
          return 372;

        case E_DAmode:
          if (!register_operand (operands[1], E_DAmode))
            return -1;
          return 373;

        case E_UDAmode:
          if (!register_operand (operands[1], E_UDAmode))
            return -1;
          return 374;

        case E_TAmode:
          if (!register_operand (operands[1], E_TAmode))
            return -1;
          return 375;

        case E_UTAmode:
          if (!register_operand (operands[1], E_UTAmode))
            return -1;
          return 376;

        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 377;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 378;

        case E_SImode:
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 379;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_22 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (pattern21 (x1) != 0)
    return -1;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case CONST_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
      operands[0] = x3;
      x4 = XEXP (x2, 1);
      operands[1] = x4;
      if (register_operand (operands[1], E_QImode)
          && const0_operand (operands[0], E_QImode)
          && 
#line 6737 "../../gcc/config/avr/avr.md"
(reload_completed))
        return 828; /* *swapped_tstqi */
      if (register_operand (operands[1], E_QQmode)
          && const0_operand (operands[0], E_QQmode)
          && 
#line 6737 "../../gcc/config/avr/avr.md"
(reload_completed))
        return 829; /* *swapped_tstqq */
      if (register_operand (operands[1], E_HImode)
          && const0_operand (operands[0], E_HImode)
          && 
#line 6747 "../../gcc/config/avr/avr.md"
(reload_completed))
        return 830; /* *swapped_tsthi */
      if (register_operand (operands[1], E_HQmode)
          && const0_operand (operands[0], E_HQmode)
          && 
#line 6747 "../../gcc/config/avr/avr.md"
(reload_completed))
        return 831; /* *swapped_tsthq */
      if (register_operand (operands[1], E_HAmode)
          && const0_operand (operands[0], E_HAmode)
          && 
#line 6747 "../../gcc/config/avr/avr.md"
(reload_completed))
        return 832; /* *swapped_tstha */
      if (register_operand (operands[1], E_SImode)
          && const0_operand (operands[0], E_SImode)
          && 
#line 6767 "../../gcc/config/avr/avr.md"
(reload_completed))
        return 834; /* *swapped_tstsi */
      if (register_operand (operands[1], E_SQmode)
          && const0_operand (operands[0], E_SQmode)
          && 
#line 6767 "../../gcc/config/avr/avr.md"
(reload_completed))
        return 835; /* *swapped_tstsq */
      if (register_operand (operands[1], E_SAmode)
          && const0_operand (operands[0], E_SAmode)
          && 
#line 6767 "../../gcc/config/avr/avr.md"
(reload_completed))
        return 836; /* *swapped_tstsa */
      if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      operands[0] = x4;
      if (!register_operand (operands[0], E_PSImode)
          || !
#line 6757 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 833; /* *swapped_tstpsi */

    case REG:
    case SUBREG:
      operands[0] = x3;
      x4 = XEXP (x2, 1);
      switch (GET_CODE (x4))
        {
        case CONST_INT:
        case CONST_WIDE_INT:
        case CONST_POLY_INT:
        case CONST_FIXED:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case CONST:
        case REG:
        case SUBREG:
        case LABEL_REF:
        case SYMBOL_REF:
        case HIGH:
          operands[1] = x4;
          switch (GET_MODE (operands[0]))
            {
            case E_QImode:
              if (register_operand (operands[0], E_QImode)
                  && nonmemory_operand (operands[1], E_QImode)
                  && 
#line 6781 "../../gcc/config/avr/avr.md"
(reload_completed))
                return 837; /* cmpqi3 */
              break;

            case E_QQmode:
              if (register_operand (operands[0], E_QQmode)
                  && nonmemory_operand (operands[1], E_QQmode)
                  && 
#line 6781 "../../gcc/config/avr/avr.md"
(reload_completed))
                return 838; /* cmpqq3 */
              break;

            case E_UQQmode:
              if (register_operand (operands[0], E_UQQmode)
                  && nonmemory_operand (operands[1], E_UQQmode)
                  && 
#line 6781 "../../gcc/config/avr/avr.md"
(reload_completed))
                return 839; /* cmpuqq3 */
              break;

            case E_HImode:
              if (pnum_clobbers != NULL
                  && register_operand (operands[0], E_HImode)
                  && nonmemory_operand (operands[1], E_HImode)
                  && 
#line 6823 "../../gcc/config/avr/avr.md"
(reload_completed))
                {
                  *pnum_clobbers = 1;
                  return 864; /* cmphi3 */
                }
              break;

            case E_HQmode:
              if (pnum_clobbers != NULL
                  && register_operand (operands[0], E_HQmode)
                  && nonmemory_operand (operands[1], E_HQmode)
                  && 
#line 6823 "../../gcc/config/avr/avr.md"
(reload_completed))
                {
                  *pnum_clobbers = 1;
                  return 865; /* cmphq3 */
                }
              break;

            case E_UHQmode:
              if (pnum_clobbers != NULL
                  && register_operand (operands[0], E_UHQmode)
                  && nonmemory_operand (operands[1], E_UHQmode)
                  && 
#line 6823 "../../gcc/config/avr/avr.md"
(reload_completed))
                {
                  *pnum_clobbers = 1;
                  return 866; /* cmpuhq3 */
                }
              break;

            case E_HAmode:
              if (pnum_clobbers != NULL
                  && register_operand (operands[0], E_HAmode)
                  && nonmemory_operand (operands[1], E_HAmode)
                  && 
#line 6823 "../../gcc/config/avr/avr.md"
(reload_completed))
                {
                  *pnum_clobbers = 1;
                  return 867; /* cmpha3 */
                }
              break;

            case E_UHAmode:
              if (pnum_clobbers != NULL
                  && register_operand (operands[0], E_UHAmode)
                  && nonmemory_operand (operands[1], E_UHAmode)
                  && 
#line 6823 "../../gcc/config/avr/avr.md"
(reload_completed))
                {
                  *pnum_clobbers = 1;
                  return 868; /* cmpuha3 */
                }
              break;

            case E_PSImode:
              if (pnum_clobbers != NULL
                  && register_operand (operands[0], E_PSImode)
                  && nonmemory_operand (operands[1], E_PSImode)
                  && 
#line 6858 "../../gcc/config/avr/avr.md"
(reload_completed))
                {
                  *pnum_clobbers = 1;
                  return 869; /* *cmppsi */
                }
              break;

            case E_SImode:
              if (pnum_clobbers != NULL
                  && register_operand (operands[0], E_SImode)
                  && nonmemory_operand (operands[1], E_SImode)
                  && 
#line 6890 "../../gcc/config/avr/avr.md"
(reload_completed))
                {
                  *pnum_clobbers = 1;
                  return 870; /* *cmpsi */
                }
              break;

            case E_SQmode:
              if (pnum_clobbers != NULL
                  && register_operand (operands[0], E_SQmode)
                  && nonmemory_operand (operands[1], E_SQmode)
                  && 
#line 6890 "../../gcc/config/avr/avr.md"
(reload_completed))
                {
                  *pnum_clobbers = 1;
                  return 871; /* *cmpsq */
                }
              break;

            case E_USQmode:
              if (pnum_clobbers != NULL
                  && register_operand (operands[0], E_USQmode)
                  && nonmemory_operand (operands[1], E_USQmode)
                  && 
#line 6890 "../../gcc/config/avr/avr.md"
(reload_completed))
                {
                  *pnum_clobbers = 1;
                  return 872; /* *cmpusq */
                }
              break;

            case E_SAmode:
              if (pnum_clobbers != NULL
                  && register_operand (operands[0], E_SAmode)
                  && nonmemory_operand (operands[1], E_SAmode)
                  && 
#line 6890 "../../gcc/config/avr/avr.md"
(reload_completed))
                {
                  *pnum_clobbers = 1;
                  return 873; /* *cmpsa */
                }
              break;

            case E_USAmode:
              if (pnum_clobbers != NULL
                  && register_operand (operands[0], E_USAmode)
                  && nonmemory_operand (operands[1], E_USAmode)
                  && 
#line 6890 "../../gcc/config/avr/avr.md"
(reload_completed))
                {
                  *pnum_clobbers = 1;
                  return 874; /* *cmpusa */
                }
              break;

            default:
              break;
            }
          break;

        case SIGN_EXTEND:
          switch (pattern232 (x4))
            {
            case 0:
              if (
#line 6807 "../../gcc/config/avr/avr.md"
(reload_completed
   && 2 > 1))
                return 852; /* *cmphi.sign_extendqi.1 */
              break;

            case 1:
              if (
#line 6807 "../../gcc/config/avr/avr.md"
(reload_completed
   && 3 > 1))
                return 854; /* *cmppsi.sign_extendqi.1 */
              break;

            case 2:
              if (
#line 6807 "../../gcc/config/avr/avr.md"
(reload_completed
   && 3 > 2))
                return 858; /* *cmppsi.sign_extendhi.1 */
              break;

            case 3:
              if (
#line 6807 "../../gcc/config/avr/avr.md"
(reload_completed
   && 4 > 1))
                return 856; /* *cmpsi.sign_extendqi.1 */
              break;

            case 4:
              if (
#line 6807 "../../gcc/config/avr/avr.md"
(reload_completed
   && 4 > 2))
                return 860; /* *cmpsi.sign_extendhi.1 */
              break;

            case 5:
              if (
#line 6807 "../../gcc/config/avr/avr.md"
(reload_completed
   && 4 > 3))
                return 862; /* *cmpsi.sign_extendpsi.1 */
              break;

            default:
              break;
            }
          break;

        case ZERO_EXTEND:
          switch (pattern232 (x4))
            {
            case 0:
              if (
#line 6807 "../../gcc/config/avr/avr.md"
(reload_completed
   && 2 > 1))
                return 853; /* *cmphi.zero_extendqi.1 */
              break;

            case 1:
              if (
#line 6807 "../../gcc/config/avr/avr.md"
(reload_completed
   && 3 > 1))
                return 855; /* *cmppsi.zero_extendqi.1 */
              break;

            case 2:
              if (
#line 6807 "../../gcc/config/avr/avr.md"
(reload_completed
   && 3 > 2))
                return 859; /* *cmppsi.zero_extendhi.1 */
              break;

            case 3:
              if (
#line 6807 "../../gcc/config/avr/avr.md"
(reload_completed
   && 4 > 1))
                return 857; /* *cmpsi.zero_extendqi.1 */
              break;

            case 4:
              if (
#line 6807 "../../gcc/config/avr/avr.md"
(reload_completed
   && 4 > 2))
                return 861; /* *cmpsi.zero_extendhi.1 */
              break;

            case 5:
              if (
#line 6807 "../../gcc/config/avr/avr.md"
(reload_completed
   && 4 > 3))
                return 863; /* *cmpsi.zero_extendpsi.1 */
              break;

            default:
              break;
            }
          break;

        default:
          break;
        }
      if (GET_CODE (x3) != REG
          || REGNO (x3) != 18)
        return -1;
      switch (GET_CODE (x4))
        {
        case REG:
          if (REGNO (x4) != 10)
            return -1;
          switch (GET_MODE (x3))
            {
            case E_DImode:
              if (GET_MODE (x4) != E_DImode
                  || !
#line 518 "../../gcc/config/avr/avr-dimode.md"
(reload_completed && avr_have_dimode))
                return -1;
              return 3281; /* compare_di2 */

            case E_DQmode:
              if (GET_MODE (x4) != E_DQmode
                  || !
#line 518 "../../gcc/config/avr/avr-dimode.md"
(reload_completed && avr_have_dimode))
                return -1;
              return 3282; /* compare_dq2 */

            case E_UDQmode:
              if (GET_MODE (x4) != E_UDQmode
                  || !
#line 518 "../../gcc/config/avr/avr-dimode.md"
(reload_completed && avr_have_dimode))
                return -1;
              return 3283; /* compare_udq2 */

            case E_DAmode:
              if (GET_MODE (x4) != E_DAmode
                  || !
#line 518 "../../gcc/config/avr/avr-dimode.md"
(reload_completed && avr_have_dimode))
                return -1;
              return 3284; /* compare_da2 */

            case E_UDAmode:
              if (GET_MODE (x4) != E_UDAmode
                  || !
#line 518 "../../gcc/config/avr/avr-dimode.md"
(reload_completed && avr_have_dimode))
                return -1;
              return 3285; /* compare_uda2 */

            case E_TAmode:
              if (GET_MODE (x4) != E_TAmode
                  || !
#line 518 "../../gcc/config/avr/avr-dimode.md"
(reload_completed && avr_have_dimode))
                return -1;
              return 3286; /* compare_ta2 */

            case E_UTAmode:
              if (GET_MODE (x4) != E_UTAmode
                  || !
#line 518 "../../gcc/config/avr/avr-dimode.md"
(reload_completed && avr_have_dimode))
                return -1;
              return 3287; /* compare_uta2 */

            default:
              return -1;
            }

        case SIGN_EXTEND:
          if (pattern252 (x4, 
E_QImode, 
E_DImode) != 0
              || GET_MODE (x3) != E_DImode
              || !
#line 543 "../../gcc/config/avr/avr-dimode.md"
(reload_completed && avr_have_dimode))
            return -1;
          return 3289; /* compare_const8_di2 */

        default:
          return -1;
        }

    case SIGN_EXTEND:
      switch (pattern204 (x2))
        {
        case 0:
          if (!
#line 6794 "../../gcc/config/avr/avr.md"
(reload_completed
   && 2 > 1))
            return -1;
          return 840; /* *cmphi.sign_extendqi.0 */

        case 1:
          if (!
#line 6794 "../../gcc/config/avr/avr.md"
(reload_completed
   && 3 > 1))
            return -1;
          return 842; /* *cmppsi.sign_extendqi.0 */

        case 2:
          if (!
#line 6794 "../../gcc/config/avr/avr.md"
(reload_completed
   && 3 > 2))
            return -1;
          return 846; /* *cmppsi.sign_extendhi.0 */

        case 3:
          if (!
#line 6794 "../../gcc/config/avr/avr.md"
(reload_completed
   && 4 > 1))
            return -1;
          return 844; /* *cmpsi.sign_extendqi.0 */

        case 4:
          if (!
#line 6794 "../../gcc/config/avr/avr.md"
(reload_completed
   && 4 > 2))
            return -1;
          return 848; /* *cmpsi.sign_extendhi.0 */

        case 5:
          if (!
#line 6794 "../../gcc/config/avr/avr.md"
(reload_completed
   && 4 > 3))
            return -1;
          return 850; /* *cmpsi.sign_extendpsi.0 */

        default:
          return -1;
        }

    case ZERO_EXTEND:
      switch (pattern204 (x2))
        {
        case 0:
          if (!
#line 6794 "../../gcc/config/avr/avr.md"
(reload_completed
   && 2 > 1))
            return -1;
          return 841; /* *cmphi.zero_extendqi.0 */

        case 1:
          if (!
#line 6794 "../../gcc/config/avr/avr.md"
(reload_completed
   && 3 > 1))
            return -1;
          return 843; /* *cmppsi.zero_extendqi.0 */

        case 2:
          if (!
#line 6794 "../../gcc/config/avr/avr.md"
(reload_completed
   && 3 > 2))
            return -1;
          return 847; /* *cmppsi.zero_extendhi.0 */

        case 3:
          if (!
#line 6794 "../../gcc/config/avr/avr.md"
(reload_completed
   && 4 > 1))
            return -1;
          return 845; /* *cmpsi.zero_extendqi.0 */

        case 4:
          if (!
#line 6794 "../../gcc/config/avr/avr.md"
(reload_completed
   && 4 > 2))
            return -1;
          return 849; /* *cmpsi.zero_extendhi.0 */

        case 5:
          if (!
#line 6794 "../../gcc/config/avr/avr.md"
(reload_completed
   && 4 > 3))
            return -1;
          return 851; /* *cmpsi.zero_extendpsi.0 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_34 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  switch (GET_CODE (x2))
    {
    case MEM:
      x3 = XEXP (x2, 0);
      if (GET_CODE (x3) == POST_DEC
          && GET_MODE (x3) == E_HImode)
        {
          x4 = XEXP (x3, 0);
          if (GET_CODE (x4) == REG
              && REGNO (x4) == 32
              && GET_MODE (x4) == E_HImode)
            {
              x5 = XEXP (x1, 1);
              operands[0] = x5;
              switch (GET_MODE (x2))
                {
                case E_QImode:
                  if (reg_or_0_operand (operands[0], E_QImode))
                    return 1; /* pushqi1 */
                  break;

                case E_QQmode:
                  if (reg_or_0_operand (operands[0], E_QQmode))
                    return 2; /* pushqq1 */
                  break;

                case E_UQQmode:
                  if (reg_or_0_operand (operands[0], E_UQQmode))
                    return 3; /* pushuqq1 */
                  break;

                case E_HImode:
                  if (reg_or_0_operand (operands[0], E_HImode))
                    return 4; /* pushhi1_insn */
                  break;

                default:
                  break;
                }
            }
        }
      break;

    case REG:
    case SUBREG:
      res = recog_1 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case ZERO_EXTRACT:
      res = recog_2 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    default:
      break;
    }
  x5 = XEXP (x1, 1);
  switch (GET_CODE (x5))
    {
    case SUBREG:
    case MEM:
      res = recog_4 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case LABEL_REF:
      if (GET_CODE (x2) == PC)
        {
          x6 = XEXP (x5, 0);
          operands[0] = x6;
          return 969; /* jump */
        }
      break;

    default:
      break;
    }
  switch (GET_CODE (x2))
    {
    case REG:
    case SUBREG:
    case MEM:
      res = recog_5 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case PC:
      operands[0] = x5;
      if (nonmemory_operand (operands[0], E_HImode))
        return 973; /* *indirect_jump */
      break;

    default:
      break;
    }
  operands[0] = x2;
  if (GET_MODE (x5) != E_QImode)
    return -1;
  switch (GET_CODE (x5))
    {
    case SUBREG:
      switch (pattern123 (x5))
        {
        case 0:
          if (register_operand (operands[0], E_QImode))
            return 677; /* *ashlsqihiqi3 */
          if (!memory_operand (operands[0], E_QImode)
              || !
#line 5409 "../../gcc/config/avr/avr.md"
(!reload_completed))
            return -1;
          return 679; /* *ashlsqihiqi3.mem */

        case 1:
          if (register_operand (operands[0], E_QImode))
            return 678; /* *ashluqihiqi3 */
          if (!memory_operand (operands[0], E_QImode)
              || !
#line 5409 "../../gcc/config/avr/avr.md"
(!reload_completed))
            return -1;
          return 680; /* *ashluqihiqi3.mem */

        case 2:
          if (!
#line 5427 "../../gcc/config/avr/avr.md"
(!reload_completed))
            return -1;
          return 681; /* *ashlhiqi3 */

        case 3:
          return 1015; /* mask1_0x80_split */

        case 4:
          if (!
#line 10470 "../../gcc/config/avr/avr.md"
(! reload_completed))
            return -1;
          return 1157; /* *extzv.subreg.hi */

        case 5:
          if (!
#line 10470 "../../gcc/config/avr/avr.md"
(! reload_completed))
            return -1;
          return 1158; /* *extzv.subreg.psi */

        case 6:
          if (!
#line 10470 "../../gcc/config/avr/avr.md"
(! reload_completed))
            return -1;
          return 1159; /* *extzv.subreg.si */

        case 7:
          return 1021; /* *split.flash_segment */

        default:
          return -1;
        }

    case MEM:
      x6 = XEXP (x5, 0);
      if (GET_CODE (x6) != PRE_INC
          || GET_MODE (x6) != E_HImode)
        return -1;
      x7 = XEXP (x6, 0);
      if (GET_CODE (x7) != REG
          || REGNO (x7) != 32
          || GET_MODE (x7) != E_HImode
          || !register_operand (operands[0], E_QImode))
        return -1;
      return 994; /* popqi */

    default:
      return -1;
    }
}

 int
recog_40 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_QImode)
    return -1;
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 36
      || GET_MODE (x6) != E_CCmode)
    return -1;
  x7 = XEXP (x3, 0);
  operands[0] = x7;
  if (!register_operand (operands[0], E_QImode))
    return -1;
  x8 = XEXP (x3, 2);
  operands[1] = x8;
  if (!const_0_to_7_operand (operands[1], E_QImode))
    return -1;
  x9 = XEXP (x2, 1);
  operands[2] = x9;
  if (!nonmemory_operand (operands[2], E_QImode)
      || !
#line 10017 "../../gcc/config/avr/avr.md"
(reload_completed))
    return -1;
  return 1079; /* *insv.reg */
}

 int
recog_44 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  switch (GET_CODE (x4))
    {
    case ZERO_EXTEND:
      x5 = XVECEXP (x1, 0, 1);
      x6 = XEXP (x5, 0);
      if (GET_CODE (x6) != REG
          || REGNO (x6) != 36
          || GET_MODE (x6) != E_CCmode)
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_HImode:
          if (pattern304 (x3) != 0
              || GET_MODE (x4) != E_HImode)
            return -1;
          x7 = XEXP (x4, 0);
          operands[2] = x7;
          if (!register_operand (operands[2], E_QImode)
              || !
#line 2482 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
            return -1;
          return 481; /* umulqihi3 */

        case E_PSImode:
          if (!register_operand (operands[0], E_PSImode)
              || GET_MODE (x3) != E_PSImode)
            return -1;
          x8 = XEXP (x3, 0);
          if (GET_MODE (x8) != E_PSImode
              || GET_MODE (x4) != E_PSImode)
            return -1;
          x9 = XEXP (x8, 0);
          switch (GET_MODE (x9))
            {
            case E_QImode:
              operands[1] = x9;
              if (!register_operand (operands[1], E_QImode))
                return -1;
              x7 = XEXP (x4, 0);
              operands[2] = x7;
              if (!register_operand (operands[2], E_HImode)
                  || !
#line 4125 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
                return -1;
              return 597; /* *umulqihipsi3 */

            case E_HImode:
              operands[2] = x9;
              if (!register_operand (operands[2], E_HImode))
                return -1;
              x7 = XEXP (x4, 0);
              operands[1] = x7;
              if (!register_operand (operands[1], E_QImode)
                  || !
#line 4152 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
                return -1;
              return 599; /* *umulhiqipsi3 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case SIGN_EXTEND:
      if (GET_MODE (x4) != E_HImode)
        return -1;
      x5 = XVECEXP (x1, 0, 1);
      x6 = XEXP (x5, 0);
      if (GET_CODE (x6) != REG
          || REGNO (x6) != 36
          || GET_MODE (x6) != E_CCmode
          || !register_operand (operands[0], E_HImode)
          || GET_MODE (x3) != E_HImode)
        return -1;
      x8 = XEXP (x3, 0);
      if (GET_MODE (x8) != E_HImode)
        return -1;
      x9 = XEXP (x8, 0);
      operands[1] = x9;
      if (!register_operand (operands[1], E_QImode))
        return -1;
      x7 = XEXP (x4, 0);
      operands[2] = x7;
      if (!register_operand (operands[2], E_QImode)
          || !
#line 2505 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
        return -1;
      return 483; /* *usmulqihi3 */

    case CONST_INT:
      operands[2] = x4;
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x3) != E_HImode)
        return -1;
      x8 = XEXP (x3, 0);
      if (GET_MODE (x8) != E_HImode)
        return -1;
      x9 = XEXP (x8, 0);
      operands[1] = x9;
      if (!register_operand (operands[1], E_QImode))
        return -1;
      x5 = XVECEXP (x1, 0, 1);
      x6 = XEXP (x5, 0);
      operands[3] = x6;
      if (!scratch_operand (operands[3], E_QImode))
        return -1;
      if (u8_operand (operands[2], E_HImode)
          && 
#line 2998 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
        return 522; /* *muluqihi3.uconst */
      if (!s8_operand (operands[2], E_HImode)
          || !
#line 3016 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
        return -1;
      return 523; /* *muluqihi3.sconst */

    case REG:
    case SUBREG:
      if (pattern225 (x1) != 0
          || pattern304 (x3) != 0
          || !
#line 3191 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
        return -1;
      return 534; /* *muluqihi3 */

    default:
      return -1;
    }
}

 int
recog_51 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x5 = XVECEXP (x1, 0, 0);
  x6 = XEXP (x5, 0);
  if (GET_MODE (x6) != E_CCNmode)
    return -1;
  x7 = XEXP (x5, 1);
  if (GET_MODE (x7) != E_CCNmode)
    return -1;
  x8 = XEXP (x7, 0);
  x9 = XEXP (x8, 0);
  operands[2] = x9;
  switch (GET_MODE (x8))
    {
    case E_HImode:
      if (pattern369 (x3, 
E_HImode) != 0
          || !
#line 7541 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 937; /* *ashift.for.ccn.hi */

    case E_PSImode:
      if (pattern369 (x3, 
E_PSImode) != 0
          || !
#line 7541 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 938; /* *ashift.for.ccn.psi */

    case E_SImode:
      if (pattern369 (x3, 
E_SImode) != 0
          || !
#line 7541 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 939; /* *ashift.for.ccn.si */

    default:
      return -1;
    }
}

 int
recog_54 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern102 (x1))
    {
    case 0:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UQQmode != QQmode
   && reload_completed))
        return -1;
      return 1876; /* *fractuqqqq2 */

    case 1:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(HQmode != QQmode
   && reload_completed))
        return -1;
      return 1877; /* *fracthqqq2 */

    case 2:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UHQmode != QQmode
   && reload_completed))
        return -1;
      return 1878; /* *fractuhqqq2 */

    case 3:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(HAmode != QQmode
   && reload_completed))
        return -1;
      return 1879; /* *fracthaqq2 */

    case 4:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UHAmode != QQmode
   && reload_completed))
        return -1;
      return 1880; /* *fractuhaqq2 */

    case 5:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(SQmode != QQmode
   && reload_completed))
        return -1;
      return 1881; /* *fractsqqq2 */

    case 6:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(USQmode != QQmode
   && reload_completed))
        return -1;
      return 1882; /* *fractusqqq2 */

    case 7:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(SAmode != QQmode
   && reload_completed))
        return -1;
      return 1883; /* *fractsaqq2 */

    case 8:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(USAmode != QQmode
   && reload_completed))
        return -1;
      return 1884; /* *fractusaqq2 */

    case 9:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(DQmode != QQmode
   && reload_completed))
        return -1;
      return 1885; /* *fractdqqq2 */

    case 10:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UDQmode != QQmode
   && reload_completed))
        return -1;
      return 1886; /* *fractudqqq2 */

    case 11:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(DAmode != QQmode
   && reload_completed))
        return -1;
      return 1887; /* *fractdaqq2 */

    case 12:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UDAmode != QQmode
   && reload_completed))
        return -1;
      return 1888; /* *fractudaqq2 */

    case 13:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(TAmode != QQmode
   && reload_completed))
        return -1;
      return 1889; /* *fracttaqq2 */

    case 14:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UTAmode != QQmode
   && reload_completed))
        return -1;
      return 1890; /* *fractutaqq2 */

    case 15:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(QImode != QQmode
   && reload_completed))
        return -1;
      return 1891; /* *fractqiqq2 */

    case 16:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(HImode != QQmode
   && reload_completed))
        return -1;
      return 1892; /* *fracthiqq2 */

    case 17:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(SImode != QQmode
   && reload_completed))
        return -1;
      return 1893; /* *fractsiqq2 */

    case 18:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(DImode != QQmode
   && reload_completed))
        return -1;
      return 1894; /* *fractdiqq2 */

    case 19:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(QQmode != UQQmode
   && reload_completed))
        return -1;
      return 1895; /* *fractqquqq2 */

    case 20:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(HQmode != UQQmode
   && reload_completed))
        return -1;
      return 1896; /* *fracthquqq2 */

    case 21:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UHQmode != UQQmode
   && reload_completed))
        return -1;
      return 1897; /* *fractuhquqq2 */

    case 22:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(HAmode != UQQmode
   && reload_completed))
        return -1;
      return 1898; /* *fracthauqq2 */

    case 23:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UHAmode != UQQmode
   && reload_completed))
        return -1;
      return 1899; /* *fractuhauqq2 */

    case 24:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(SQmode != UQQmode
   && reload_completed))
        return -1;
      return 1900; /* *fractsquqq2 */

    case 25:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(USQmode != UQQmode
   && reload_completed))
        return -1;
      return 1901; /* *fractusquqq2 */

    case 26:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(SAmode != UQQmode
   && reload_completed))
        return -1;
      return 1902; /* *fractsauqq2 */

    case 27:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(USAmode != UQQmode
   && reload_completed))
        return -1;
      return 1903; /* *fractusauqq2 */

    case 28:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(DQmode != UQQmode
   && reload_completed))
        return -1;
      return 1904; /* *fractdquqq2 */

    case 29:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UDQmode != UQQmode
   && reload_completed))
        return -1;
      return 1905; /* *fractudquqq2 */

    case 30:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(DAmode != UQQmode
   && reload_completed))
        return -1;
      return 1906; /* *fractdauqq2 */

    case 31:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UDAmode != UQQmode
   && reload_completed))
        return -1;
      return 1907; /* *fractudauqq2 */

    case 32:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(TAmode != UQQmode
   && reload_completed))
        return -1;
      return 1908; /* *fracttauqq2 */

    case 33:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UTAmode != UQQmode
   && reload_completed))
        return -1;
      return 1909; /* *fractutauqq2 */

    case 34:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(QImode != UQQmode
   && reload_completed))
        return -1;
      return 1910; /* *fractqiuqq2 */

    case 35:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(HImode != UQQmode
   && reload_completed))
        return -1;
      return 1911; /* *fracthiuqq2 */

    case 36:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(SImode != UQQmode
   && reload_completed))
        return -1;
      return 1912; /* *fractsiuqq2 */

    case 37:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(DImode != UQQmode
   && reload_completed))
        return -1;
      return 1913; /* *fractdiuqq2 */

    case 38:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(QQmode != HQmode
   && reload_completed))
        return -1;
      return 1914; /* *fractqqhq2 */

    case 39:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UQQmode != HQmode
   && reload_completed))
        return -1;
      return 1915; /* *fractuqqhq2 */

    case 40:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UHQmode != HQmode
   && reload_completed))
        return -1;
      return 1916; /* *fractuhqhq2 */

    case 41:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(HAmode != HQmode
   && reload_completed))
        return -1;
      return 1917; /* *fracthahq2 */

    case 42:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UHAmode != HQmode
   && reload_completed))
        return -1;
      return 1918; /* *fractuhahq2 */

    case 43:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(SQmode != HQmode
   && reload_completed))
        return -1;
      return 1919; /* *fractsqhq2 */

    case 44:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(USQmode != HQmode
   && reload_completed))
        return -1;
      return 1920; /* *fractusqhq2 */

    case 45:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(SAmode != HQmode
   && reload_completed))
        return -1;
      return 1921; /* *fractsahq2 */

    case 46:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(USAmode != HQmode
   && reload_completed))
        return -1;
      return 1922; /* *fractusahq2 */

    case 47:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(DQmode != HQmode
   && reload_completed))
        return -1;
      return 1923; /* *fractdqhq2 */

    case 48:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UDQmode != HQmode
   && reload_completed))
        return -1;
      return 1924; /* *fractudqhq2 */

    case 49:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(DAmode != HQmode
   && reload_completed))
        return -1;
      return 1925; /* *fractdahq2 */

    case 50:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UDAmode != HQmode
   && reload_completed))
        return -1;
      return 1926; /* *fractudahq2 */

    case 51:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(TAmode != HQmode
   && reload_completed))
        return -1;
      return 1927; /* *fracttahq2 */

    case 52:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UTAmode != HQmode
   && reload_completed))
        return -1;
      return 1928; /* *fractutahq2 */

    case 53:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(QImode != HQmode
   && reload_completed))
        return -1;
      return 1929; /* *fractqihq2 */

    case 54:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(HImode != HQmode
   && reload_completed))
        return -1;
      return 1930; /* *fracthihq2 */

    case 55:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(SImode != HQmode
   && reload_completed))
        return -1;
      return 1931; /* *fractsihq2 */

    case 56:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(DImode != HQmode
   && reload_completed))
        return -1;
      return 1932; /* *fractdihq2 */

    case 57:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(QQmode != UHQmode
   && reload_completed))
        return -1;
      return 1933; /* *fractqquhq2 */

    case 58:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UQQmode != UHQmode
   && reload_completed))
        return -1;
      return 1934; /* *fractuqquhq2 */

    case 59:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(HQmode != UHQmode
   && reload_completed))
        return -1;
      return 1935; /* *fracthquhq2 */

    case 60:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(HAmode != UHQmode
   && reload_completed))
        return -1;
      return 1936; /* *fracthauhq2 */

    case 61:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UHAmode != UHQmode
   && reload_completed))
        return -1;
      return 1937; /* *fractuhauhq2 */

    case 62:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(SQmode != UHQmode
   && reload_completed))
        return -1;
      return 1938; /* *fractsquhq2 */

    case 63:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(USQmode != UHQmode
   && reload_completed))
        return -1;
      return 1939; /* *fractusquhq2 */

    case 64:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(SAmode != UHQmode
   && reload_completed))
        return -1;
      return 1940; /* *fractsauhq2 */

    case 65:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(USAmode != UHQmode
   && reload_completed))
        return -1;
      return 1941; /* *fractusauhq2 */

    case 66:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(DQmode != UHQmode
   && reload_completed))
        return -1;
      return 1942; /* *fractdquhq2 */

    case 67:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UDQmode != UHQmode
   && reload_completed))
        return -1;
      return 1943; /* *fractudquhq2 */

    case 68:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(DAmode != UHQmode
   && reload_completed))
        return -1;
      return 1944; /* *fractdauhq2 */

    case 69:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UDAmode != UHQmode
   && reload_completed))
        return -1;
      return 1945; /* *fractudauhq2 */

    case 70:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(TAmode != UHQmode
   && reload_completed))
        return -1;
      return 1946; /* *fracttauhq2 */

    case 71:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UTAmode != UHQmode
   && reload_completed))
        return -1;
      return 1947; /* *fractutauhq2 */

    case 72:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(QImode != UHQmode
   && reload_completed))
        return -1;
      return 1948; /* *fractqiuhq2 */

    case 73:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(HImode != UHQmode
   && reload_completed))
        return -1;
      return 1949; /* *fracthiuhq2 */

    case 74:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(SImode != UHQmode
   && reload_completed))
        return -1;
      return 1950; /* *fractsiuhq2 */

    case 75:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(DImode != UHQmode
   && reload_completed))
        return -1;
      return 1951; /* *fractdiuhq2 */

    case 76:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(QQmode != HAmode
   && reload_completed))
        return -1;
      return 1952; /* *fractqqha2 */

    case 77:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UQQmode != HAmode
   && reload_completed))
        return -1;
      return 1953; /* *fractuqqha2 */

    case 78:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(HQmode != HAmode
   && reload_completed))
        return -1;
      return 1954; /* *fracthqha2 */

    case 79:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UHQmode != HAmode
   && reload_completed))
        return -1;
      return 1955; /* *fractuhqha2 */

    case 80:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UHAmode != HAmode
   && reload_completed))
        return -1;
      return 1956; /* *fractuhaha2 */

    case 81:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(SQmode != HAmode
   && reload_completed))
        return -1;
      return 1957; /* *fractsqha2 */

    case 82:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(USQmode != HAmode
   && reload_completed))
        return -1;
      return 1958; /* *fractusqha2 */

    case 83:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(SAmode != HAmode
   && reload_completed))
        return -1;
      return 1959; /* *fractsaha2 */

    case 84:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(USAmode != HAmode
   && reload_completed))
        return -1;
      return 1960; /* *fractusaha2 */

    case 85:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(DQmode != HAmode
   && reload_completed))
        return -1;
      return 1961; /* *fractdqha2 */

    case 86:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UDQmode != HAmode
   && reload_completed))
        return -1;
      return 1962; /* *fractudqha2 */

    case 87:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(DAmode != HAmode
   && reload_completed))
        return -1;
      return 1963; /* *fractdaha2 */

    case 88:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UDAmode != HAmode
   && reload_completed))
        return -1;
      return 1964; /* *fractudaha2 */

    case 89:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(TAmode != HAmode
   && reload_completed))
        return -1;
      return 1965; /* *fracttaha2 */

    case 90:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UTAmode != HAmode
   && reload_completed))
        return -1;
      return 1966; /* *fractutaha2 */

    case 91:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(QImode != HAmode
   && reload_completed))
        return -1;
      return 1967; /* *fractqiha2 */

    case 92:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(HImode != HAmode
   && reload_completed))
        return -1;
      return 1968; /* *fracthiha2 */

    case 93:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(SImode != HAmode
   && reload_completed))
        return -1;
      return 1969; /* *fractsiha2 */

    case 94:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(DImode != HAmode
   && reload_completed))
        return -1;
      return 1970; /* *fractdiha2 */

    case 95:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(QQmode != UHAmode
   && reload_completed))
        return -1;
      return 1971; /* *fractqquha2 */

    case 96:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UQQmode != UHAmode
   && reload_completed))
        return -1;
      return 1972; /* *fractuqquha2 */

    case 97:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(HQmode != UHAmode
   && reload_completed))
        return -1;
      return 1973; /* *fracthquha2 */

    case 98:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UHQmode != UHAmode
   && reload_completed))
        return -1;
      return 1974; /* *fractuhquha2 */

    case 99:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(HAmode != UHAmode
   && reload_completed))
        return -1;
      return 1975; /* *fracthauha2 */

    case 100:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(SQmode != UHAmode
   && reload_completed))
        return -1;
      return 1976; /* *fractsquha2 */

    case 101:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(USQmode != UHAmode
   && reload_completed))
        return -1;
      return 1977; /* *fractusquha2 */

    case 102:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(SAmode != UHAmode
   && reload_completed))
        return -1;
      return 1978; /* *fractsauha2 */

    case 103:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(USAmode != UHAmode
   && reload_completed))
        return -1;
      return 1979; /* *fractusauha2 */

    case 104:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(DQmode != UHAmode
   && reload_completed))
        return -1;
      return 1980; /* *fractdquha2 */

    case 105:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UDQmode != UHAmode
   && reload_completed))
        return -1;
      return 1981; /* *fractudquha2 */

    case 106:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(DAmode != UHAmode
   && reload_completed))
        return -1;
      return 1982; /* *fractdauha2 */

    case 107:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UDAmode != UHAmode
   && reload_completed))
        return -1;
      return 1983; /* *fractudauha2 */

    case 108:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(TAmode != UHAmode
   && reload_completed))
        return -1;
      return 1984; /* *fracttauha2 */

    case 109:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UTAmode != UHAmode
   && reload_completed))
        return -1;
      return 1985; /* *fractutauha2 */

    case 110:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(QImode != UHAmode
   && reload_completed))
        return -1;
      return 1986; /* *fractqiuha2 */

    case 111:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(HImode != UHAmode
   && reload_completed))
        return -1;
      return 1987; /* *fracthiuha2 */

    case 112:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(SImode != UHAmode
   && reload_completed))
        return -1;
      return 1988; /* *fractsiuha2 */

    case 113:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(DImode != UHAmode
   && reload_completed))
        return -1;
      return 1989; /* *fractdiuha2 */

    case 114:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(QQmode != SQmode
   && reload_completed))
        return -1;
      return 1990; /* *fractqqsq2 */

    case 115:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UQQmode != SQmode
   && reload_completed))
        return -1;
      return 1991; /* *fractuqqsq2 */

    case 116:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(HQmode != SQmode
   && reload_completed))
        return -1;
      return 1992; /* *fracthqsq2 */

    case 117:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UHQmode != SQmode
   && reload_completed))
        return -1;
      return 1993; /* *fractuhqsq2 */

    case 118:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(HAmode != SQmode
   && reload_completed))
        return -1;
      return 1994; /* *fracthasq2 */

    case 119:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UHAmode != SQmode
   && reload_completed))
        return -1;
      return 1995; /* *fractuhasq2 */

    case 120:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(USQmode != SQmode
   && reload_completed))
        return -1;
      return 1996; /* *fractusqsq2 */

    case 121:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(SAmode != SQmode
   && reload_completed))
        return -1;
      return 1997; /* *fractsasq2 */

    case 122:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(USAmode != SQmode
   && reload_completed))
        return -1;
      return 1998; /* *fractusasq2 */

    case 123:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(DQmode != SQmode
   && reload_completed))
        return -1;
      return 1999; /* *fractdqsq2 */

    case 124:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UDQmode != SQmode
   && reload_completed))
        return -1;
      return 2000; /* *fractudqsq2 */

    case 125:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(DAmode != SQmode
   && reload_completed))
        return -1;
      return 2001; /* *fractdasq2 */

    case 126:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UDAmode != SQmode
   && reload_completed))
        return -1;
      return 2002; /* *fractudasq2 */

    case 127:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(TAmode != SQmode
   && reload_completed))
        return -1;
      return 2003; /* *fracttasq2 */

    case 128:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UTAmode != SQmode
   && reload_completed))
        return -1;
      return 2004; /* *fractutasq2 */

    case 129:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(QImode != SQmode
   && reload_completed))
        return -1;
      return 2005; /* *fractqisq2 */

    case 130:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(HImode != SQmode
   && reload_completed))
        return -1;
      return 2006; /* *fracthisq2 */

    case 131:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(SImode != SQmode
   && reload_completed))
        return -1;
      return 2007; /* *fractsisq2 */

    case 132:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(DImode != SQmode
   && reload_completed))
        return -1;
      return 2008; /* *fractdisq2 */

    case 133:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(QQmode != USQmode
   && reload_completed))
        return -1;
      return 2009; /* *fractqqusq2 */

    case 134:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UQQmode != USQmode
   && reload_completed))
        return -1;
      return 2010; /* *fractuqqusq2 */

    case 135:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(HQmode != USQmode
   && reload_completed))
        return -1;
      return 2011; /* *fracthqusq2 */

    case 136:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UHQmode != USQmode
   && reload_completed))
        return -1;
      return 2012; /* *fractuhqusq2 */

    case 137:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(HAmode != USQmode
   && reload_completed))
        return -1;
      return 2013; /* *fracthausq2 */

    case 138:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UHAmode != USQmode
   && reload_completed))
        return -1;
      return 2014; /* *fractuhausq2 */

    case 139:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(SQmode != USQmode
   && reload_completed))
        return -1;
      return 2015; /* *fractsqusq2 */

    case 140:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(SAmode != USQmode
   && reload_completed))
        return -1;
      return 2016; /* *fractsausq2 */

    case 141:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(USAmode != USQmode
   && reload_completed))
        return -1;
      return 2017; /* *fractusausq2 */

    case 142:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(DQmode != USQmode
   && reload_completed))
        return -1;
      return 2018; /* *fractdqusq2 */

    case 143:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UDQmode != USQmode
   && reload_completed))
        return -1;
      return 2019; /* *fractudqusq2 */

    case 144:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(DAmode != USQmode
   && reload_completed))
        return -1;
      return 2020; /* *fractdausq2 */

    case 145:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UDAmode != USQmode
   && reload_completed))
        return -1;
      return 2021; /* *fractudausq2 */

    case 146:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(TAmode != USQmode
   && reload_completed))
        return -1;
      return 2022; /* *fracttausq2 */

    case 147:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UTAmode != USQmode
   && reload_completed))
        return -1;
      return 2023; /* *fractutausq2 */

    case 148:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(QImode != USQmode
   && reload_completed))
        return -1;
      return 2024; /* *fractqiusq2 */

    case 149:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(HImode != USQmode
   && reload_completed))
        return -1;
      return 2025; /* *fracthiusq2 */

    case 150:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(SImode != USQmode
   && reload_completed))
        return -1;
      return 2026; /* *fractsiusq2 */

    case 151:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(DImode != USQmode
   && reload_completed))
        return -1;
      return 2027; /* *fractdiusq2 */

    case 152:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(QQmode != SAmode
   && reload_completed))
        return -1;
      return 2028; /* *fractqqsa2 */

    case 153:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UQQmode != SAmode
   && reload_completed))
        return -1;
      return 2029; /* *fractuqqsa2 */

    case 154:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(HQmode != SAmode
   && reload_completed))
        return -1;
      return 2030; /* *fracthqsa2 */

    case 155:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UHQmode != SAmode
   && reload_completed))
        return -1;
      return 2031; /* *fractuhqsa2 */

    case 156:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(HAmode != SAmode
   && reload_completed))
        return -1;
      return 2032; /* *fracthasa2 */

    case 157:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UHAmode != SAmode
   && reload_completed))
        return -1;
      return 2033; /* *fractuhasa2 */

    case 158:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(SQmode != SAmode
   && reload_completed))
        return -1;
      return 2034; /* *fractsqsa2 */

    case 159:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(USQmode != SAmode
   && reload_completed))
        return -1;
      return 2035; /* *fractusqsa2 */

    case 160:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(USAmode != SAmode
   && reload_completed))
        return -1;
      return 2036; /* *fractusasa2 */

    case 161:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(DQmode != SAmode
   && reload_completed))
        return -1;
      return 2037; /* *fractdqsa2 */

    case 162:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UDQmode != SAmode
   && reload_completed))
        return -1;
      return 2038; /* *fractudqsa2 */

    case 163:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(DAmode != SAmode
   && reload_completed))
        return -1;
      return 2039; /* *fractdasa2 */

    case 164:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UDAmode != SAmode
   && reload_completed))
        return -1;
      return 2040; /* *fractudasa2 */

    case 165:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(TAmode != SAmode
   && reload_completed))
        return -1;
      return 2041; /* *fracttasa2 */

    case 166:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UTAmode != SAmode
   && reload_completed))
        return -1;
      return 2042; /* *fractutasa2 */

    case 167:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(QImode != SAmode
   && reload_completed))
        return -1;
      return 2043; /* *fractqisa2 */

    case 168:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(HImode != SAmode
   && reload_completed))
        return -1;
      return 2044; /* *fracthisa2 */

    case 169:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(SImode != SAmode
   && reload_completed))
        return -1;
      return 2045; /* *fractsisa2 */

    case 170:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(DImode != SAmode
   && reload_completed))
        return -1;
      return 2046; /* *fractdisa2 */

    case 171:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(QQmode != USAmode
   && reload_completed))
        return -1;
      return 2047; /* *fractqqusa2 */

    case 172:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UQQmode != USAmode
   && reload_completed))
        return -1;
      return 2048; /* *fractuqqusa2 */

    case 173:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(HQmode != USAmode
   && reload_completed))
        return -1;
      return 2049; /* *fracthqusa2 */

    case 174:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UHQmode != USAmode
   && reload_completed))
        return -1;
      return 2050; /* *fractuhqusa2 */

    case 175:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(HAmode != USAmode
   && reload_completed))
        return -1;
      return 2051; /* *fracthausa2 */

    case 176:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UHAmode != USAmode
   && reload_completed))
        return -1;
      return 2052; /* *fractuhausa2 */

    case 177:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(SQmode != USAmode
   && reload_completed))
        return -1;
      return 2053; /* *fractsqusa2 */

    case 178:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(USQmode != USAmode
   && reload_completed))
        return -1;
      return 2054; /* *fractusqusa2 */

    case 179:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(SAmode != USAmode
   && reload_completed))
        return -1;
      return 2055; /* *fractsausa2 */

    case 180:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(DQmode != USAmode
   && reload_completed))
        return -1;
      return 2056; /* *fractdqusa2 */

    case 181:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UDQmode != USAmode
   && reload_completed))
        return -1;
      return 2057; /* *fractudqusa2 */

    case 182:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(DAmode != USAmode
   && reload_completed))
        return -1;
      return 2058; /* *fractdausa2 */

    case 183:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UDAmode != USAmode
   && reload_completed))
        return -1;
      return 2059; /* *fractudausa2 */

    case 184:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(TAmode != USAmode
   && reload_completed))
        return -1;
      return 2060; /* *fracttausa2 */

    case 185:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UTAmode != USAmode
   && reload_completed))
        return -1;
      return 2061; /* *fractutausa2 */

    case 186:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(QImode != USAmode
   && reload_completed))
        return -1;
      return 2062; /* *fractqiusa2 */

    case 187:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(HImode != USAmode
   && reload_completed))
        return -1;
      return 2063; /* *fracthiusa2 */

    case 188:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(SImode != USAmode
   && reload_completed))
        return -1;
      return 2064; /* *fractsiusa2 */

    case 189:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(DImode != USAmode
   && reload_completed))
        return -1;
      return 2065; /* *fractdiusa2 */

    case 190:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(QQmode != DQmode
   && reload_completed))
        return -1;
      return 2066; /* *fractqqdq2 */

    case 191:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UQQmode != DQmode
   && reload_completed))
        return -1;
      return 2067; /* *fractuqqdq2 */

    case 192:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(HQmode != DQmode
   && reload_completed))
        return -1;
      return 2068; /* *fracthqdq2 */

    case 193:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UHQmode != DQmode
   && reload_completed))
        return -1;
      return 2069; /* *fractuhqdq2 */

    case 194:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(HAmode != DQmode
   && reload_completed))
        return -1;
      return 2070; /* *fracthadq2 */

    case 195:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UHAmode != DQmode
   && reload_completed))
        return -1;
      return 2071; /* *fractuhadq2 */

    case 196:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(SQmode != DQmode
   && reload_completed))
        return -1;
      return 2072; /* *fractsqdq2 */

    case 197:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(USQmode != DQmode
   && reload_completed))
        return -1;
      return 2073; /* *fractusqdq2 */

    case 198:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(SAmode != DQmode
   && reload_completed))
        return -1;
      return 2074; /* *fractsadq2 */

    case 199:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(USAmode != DQmode
   && reload_completed))
        return -1;
      return 2075; /* *fractusadq2 */

    case 200:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UDQmode != DQmode
   && reload_completed))
        return -1;
      return 2076; /* *fractudqdq2 */

    case 201:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(DAmode != DQmode
   && reload_completed))
        return -1;
      return 2077; /* *fractdadq2 */

    case 202:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UDAmode != DQmode
   && reload_completed))
        return -1;
      return 2078; /* *fractudadq2 */

    case 203:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(TAmode != DQmode
   && reload_completed))
        return -1;
      return 2079; /* *fracttadq2 */

    case 204:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UTAmode != DQmode
   && reload_completed))
        return -1;
      return 2080; /* *fractutadq2 */

    case 205:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(QImode != DQmode
   && reload_completed))
        return -1;
      return 2081; /* *fractqidq2 */

    case 206:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(HImode != DQmode
   && reload_completed))
        return -1;
      return 2082; /* *fracthidq2 */

    case 207:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(SImode != DQmode
   && reload_completed))
        return -1;
      return 2083; /* *fractsidq2 */

    case 208:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(DImode != DQmode
   && reload_completed))
        return -1;
      return 2084; /* *fractdidq2 */

    case 209:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(QQmode != UDQmode
   && reload_completed))
        return -1;
      return 2085; /* *fractqqudq2 */

    case 210:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UQQmode != UDQmode
   && reload_completed))
        return -1;
      return 2086; /* *fractuqqudq2 */

    case 211:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(HQmode != UDQmode
   && reload_completed))
        return -1;
      return 2087; /* *fracthqudq2 */

    case 212:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UHQmode != UDQmode
   && reload_completed))
        return -1;
      return 2088; /* *fractuhqudq2 */

    case 213:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(HAmode != UDQmode
   && reload_completed))
        return -1;
      return 2089; /* *fracthaudq2 */

    case 214:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UHAmode != UDQmode
   && reload_completed))
        return -1;
      return 2090; /* *fractuhaudq2 */

    case 215:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(SQmode != UDQmode
   && reload_completed))
        return -1;
      return 2091; /* *fractsqudq2 */

    case 216:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(USQmode != UDQmode
   && reload_completed))
        return -1;
      return 2092; /* *fractusqudq2 */

    case 217:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(SAmode != UDQmode
   && reload_completed))
        return -1;
      return 2093; /* *fractsaudq2 */

    case 218:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(USAmode != UDQmode
   && reload_completed))
        return -1;
      return 2094; /* *fractusaudq2 */

    case 219:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(DQmode != UDQmode
   && reload_completed))
        return -1;
      return 2095; /* *fractdqudq2 */

    case 220:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(DAmode != UDQmode
   && reload_completed))
        return -1;
      return 2096; /* *fractdaudq2 */

    case 221:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UDAmode != UDQmode
   && reload_completed))
        return -1;
      return 2097; /* *fractudaudq2 */

    case 222:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(TAmode != UDQmode
   && reload_completed))
        return -1;
      return 2098; /* *fracttaudq2 */

    case 223:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UTAmode != UDQmode
   && reload_completed))
        return -1;
      return 2099; /* *fractutaudq2 */

    case 224:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(QImode != UDQmode
   && reload_completed))
        return -1;
      return 2100; /* *fractqiudq2 */

    case 225:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(HImode != UDQmode
   && reload_completed))
        return -1;
      return 2101; /* *fracthiudq2 */

    case 226:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(SImode != UDQmode
   && reload_completed))
        return -1;
      return 2102; /* *fractsiudq2 */

    case 227:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(DImode != UDQmode
   && reload_completed))
        return -1;
      return 2103; /* *fractdiudq2 */

    case 228:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(QQmode != DAmode
   && reload_completed))
        return -1;
      return 2104; /* *fractqqda2 */

    case 229:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UQQmode != DAmode
   && reload_completed))
        return -1;
      return 2105; /* *fractuqqda2 */

    case 230:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(HQmode != DAmode
   && reload_completed))
        return -1;
      return 2106; /* *fracthqda2 */

    case 231:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UHQmode != DAmode
   && reload_completed))
        return -1;
      return 2107; /* *fractuhqda2 */

    case 232:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(HAmode != DAmode
   && reload_completed))
        return -1;
      return 2108; /* *fracthada2 */

    case 233:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UHAmode != DAmode
   && reload_completed))
        return -1;
      return 2109; /* *fractuhada2 */

    case 234:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(SQmode != DAmode
   && reload_completed))
        return -1;
      return 2110; /* *fractsqda2 */

    case 235:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(USQmode != DAmode
   && reload_completed))
        return -1;
      return 2111; /* *fractusqda2 */

    case 236:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(SAmode != DAmode
   && reload_completed))
        return -1;
      return 2112; /* *fractsada2 */

    case 237:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(USAmode != DAmode
   && reload_completed))
        return -1;
      return 2113; /* *fractusada2 */

    case 238:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(DQmode != DAmode
   && reload_completed))
        return -1;
      return 2114; /* *fractdqda2 */

    case 239:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UDQmode != DAmode
   && reload_completed))
        return -1;
      return 2115; /* *fractudqda2 */

    case 240:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UDAmode != DAmode
   && reload_completed))
        return -1;
      return 2116; /* *fractudada2 */

    case 241:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(TAmode != DAmode
   && reload_completed))
        return -1;
      return 2117; /* *fracttada2 */

    case 242:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UTAmode != DAmode
   && reload_completed))
        return -1;
      return 2118; /* *fractutada2 */

    case 243:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(QImode != DAmode
   && reload_completed))
        return -1;
      return 2119; /* *fractqida2 */

    case 244:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(HImode != DAmode
   && reload_completed))
        return -1;
      return 2120; /* *fracthida2 */

    case 245:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(SImode != DAmode
   && reload_completed))
        return -1;
      return 2121; /* *fractsida2 */

    case 246:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(DImode != DAmode
   && reload_completed))
        return -1;
      return 2122; /* *fractdida2 */

    case 247:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(QQmode != UDAmode
   && reload_completed))
        return -1;
      return 2123; /* *fractqquda2 */

    case 248:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UQQmode != UDAmode
   && reload_completed))
        return -1;
      return 2124; /* *fractuqquda2 */

    case 249:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(HQmode != UDAmode
   && reload_completed))
        return -1;
      return 2125; /* *fracthquda2 */

    case 250:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UHQmode != UDAmode
   && reload_completed))
        return -1;
      return 2126; /* *fractuhquda2 */

    case 251:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(HAmode != UDAmode
   && reload_completed))
        return -1;
      return 2127; /* *fracthauda2 */

    case 252:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UHAmode != UDAmode
   && reload_completed))
        return -1;
      return 2128; /* *fractuhauda2 */

    case 253:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(SQmode != UDAmode
   && reload_completed))
        return -1;
      return 2129; /* *fractsquda2 */

    case 254:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(USQmode != UDAmode
   && reload_completed))
        return -1;
      return 2130; /* *fractusquda2 */

    case 255:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(SAmode != UDAmode
   && reload_completed))
        return -1;
      return 2131; /* *fractsauda2 */

    case 256:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(USAmode != UDAmode
   && reload_completed))
        return -1;
      return 2132; /* *fractusauda2 */

    case 257:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(DQmode != UDAmode
   && reload_completed))
        return -1;
      return 2133; /* *fractdquda2 */

    case 258:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UDQmode != UDAmode
   && reload_completed))
        return -1;
      return 2134; /* *fractudquda2 */

    case 259:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(DAmode != UDAmode
   && reload_completed))
        return -1;
      return 2135; /* *fractdauda2 */

    case 260:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(TAmode != UDAmode
   && reload_completed))
        return -1;
      return 2136; /* *fracttauda2 */

    case 261:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UTAmode != UDAmode
   && reload_completed))
        return -1;
      return 2137; /* *fractutauda2 */

    case 262:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(QImode != UDAmode
   && reload_completed))
        return -1;
      return 2138; /* *fractqiuda2 */

    case 263:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(HImode != UDAmode
   && reload_completed))
        return -1;
      return 2139; /* *fracthiuda2 */

    case 264:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(SImode != UDAmode
   && reload_completed))
        return -1;
      return 2140; /* *fractsiuda2 */

    case 265:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(DImode != UDAmode
   && reload_completed))
        return -1;
      return 2141; /* *fractdiuda2 */

    case 266:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(QQmode != TAmode
   && reload_completed))
        return -1;
      return 2142; /* *fractqqta2 */

    case 267:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UQQmode != TAmode
   && reload_completed))
        return -1;
      return 2143; /* *fractuqqta2 */

    case 268:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(HQmode != TAmode
   && reload_completed))
        return -1;
      return 2144; /* *fracthqta2 */

    case 269:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UHQmode != TAmode
   && reload_completed))
        return -1;
      return 2145; /* *fractuhqta2 */

    case 270:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(HAmode != TAmode
   && reload_completed))
        return -1;
      return 2146; /* *fracthata2 */

    case 271:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UHAmode != TAmode
   && reload_completed))
        return -1;
      return 2147; /* *fractuhata2 */

    case 272:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(SQmode != TAmode
   && reload_completed))
        return -1;
      return 2148; /* *fractsqta2 */

    case 273:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(USQmode != TAmode
   && reload_completed))
        return -1;
      return 2149; /* *fractusqta2 */

    case 274:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(SAmode != TAmode
   && reload_completed))
        return -1;
      return 2150; /* *fractsata2 */

    case 275:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(USAmode != TAmode
   && reload_completed))
        return -1;
      return 2151; /* *fractusata2 */

    case 276:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(DQmode != TAmode
   && reload_completed))
        return -1;
      return 2152; /* *fractdqta2 */

    case 277:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UDQmode != TAmode
   && reload_completed))
        return -1;
      return 2153; /* *fractudqta2 */

    case 278:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(DAmode != TAmode
   && reload_completed))
        return -1;
      return 2154; /* *fractdata2 */

    case 279:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UDAmode != TAmode
   && reload_completed))
        return -1;
      return 2155; /* *fractudata2 */

    case 280:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UTAmode != TAmode
   && reload_completed))
        return -1;
      return 2156; /* *fractutata2 */

    case 281:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(QImode != TAmode
   && reload_completed))
        return -1;
      return 2157; /* *fractqita2 */

    case 282:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(HImode != TAmode
   && reload_completed))
        return -1;
      return 2158; /* *fracthita2 */

    case 283:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(SImode != TAmode
   && reload_completed))
        return -1;
      return 2159; /* *fractsita2 */

    case 284:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(DImode != TAmode
   && reload_completed))
        return -1;
      return 2160; /* *fractdita2 */

    case 285:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(QQmode != UTAmode
   && reload_completed))
        return -1;
      return 2161; /* *fractqquta2 */

    case 286:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UQQmode != UTAmode
   && reload_completed))
        return -1;
      return 2162; /* *fractuqquta2 */

    case 287:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(HQmode != UTAmode
   && reload_completed))
        return -1;
      return 2163; /* *fracthquta2 */

    case 288:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UHQmode != UTAmode
   && reload_completed))
        return -1;
      return 2164; /* *fractuhquta2 */

    case 289:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(HAmode != UTAmode
   && reload_completed))
        return -1;
      return 2165; /* *fracthauta2 */

    case 290:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UHAmode != UTAmode
   && reload_completed))
        return -1;
      return 2166; /* *fractuhauta2 */

    case 291:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(SQmode != UTAmode
   && reload_completed))
        return -1;
      return 2167; /* *fractsquta2 */

    case 292:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(USQmode != UTAmode
   && reload_completed))
        return -1;
      return 2168; /* *fractusquta2 */

    case 293:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(SAmode != UTAmode
   && reload_completed))
        return -1;
      return 2169; /* *fractsauta2 */

    case 294:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(USAmode != UTAmode
   && reload_completed))
        return -1;
      return 2170; /* *fractusauta2 */

    case 295:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(DQmode != UTAmode
   && reload_completed))
        return -1;
      return 2171; /* *fractdquta2 */

    case 296:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UDQmode != UTAmode
   && reload_completed))
        return -1;
      return 2172; /* *fractudquta2 */

    case 297:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(DAmode != UTAmode
   && reload_completed))
        return -1;
      return 2173; /* *fractdauta2 */

    case 298:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UDAmode != UTAmode
   && reload_completed))
        return -1;
      return 2174; /* *fractudauta2 */

    case 299:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(TAmode != UTAmode
   && reload_completed))
        return -1;
      return 2175; /* *fracttauta2 */

    case 300:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(QImode != UTAmode
   && reload_completed))
        return -1;
      return 2176; /* *fractqiuta2 */

    case 301:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(HImode != UTAmode
   && reload_completed))
        return -1;
      return 2177; /* *fracthiuta2 */

    case 302:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(SImode != UTAmode
   && reload_completed))
        return -1;
      return 2178; /* *fractsiuta2 */

    case 303:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(DImode != UTAmode
   && reload_completed))
        return -1;
      return 2179; /* *fractdiuta2 */

    case 304:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(QQmode != QImode
   && reload_completed))
        return -1;
      return 2180; /* *fractqqqi2 */

    case 305:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UQQmode != QImode
   && reload_completed))
        return -1;
      return 2181; /* *fractuqqqi2 */

    case 306:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(HQmode != QImode
   && reload_completed))
        return -1;
      return 2182; /* *fracthqqi2 */

    case 307:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UHQmode != QImode
   && reload_completed))
        return -1;
      return 2183; /* *fractuhqqi2 */

    case 308:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(HAmode != QImode
   && reload_completed))
        return -1;
      return 2184; /* *fracthaqi2 */

    case 309:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UHAmode != QImode
   && reload_completed))
        return -1;
      return 2185; /* *fractuhaqi2 */

    case 310:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(SQmode != QImode
   && reload_completed))
        return -1;
      return 2186; /* *fractsqqi2 */

    case 311:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(USQmode != QImode
   && reload_completed))
        return -1;
      return 2187; /* *fractusqqi2 */

    case 312:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(SAmode != QImode
   && reload_completed))
        return -1;
      return 2188; /* *fractsaqi2 */

    case 313:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(USAmode != QImode
   && reload_completed))
        return -1;
      return 2189; /* *fractusaqi2 */

    case 314:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(DQmode != QImode
   && reload_completed))
        return -1;
      return 2190; /* *fractdqqi2 */

    case 315:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UDQmode != QImode
   && reload_completed))
        return -1;
      return 2191; /* *fractudqqi2 */

    case 316:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(DAmode != QImode
   && reload_completed))
        return -1;
      return 2192; /* *fractdaqi2 */

    case 317:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UDAmode != QImode
   && reload_completed))
        return -1;
      return 2193; /* *fractudaqi2 */

    case 318:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(TAmode != QImode
   && reload_completed))
        return -1;
      return 2194; /* *fracttaqi2 */

    case 319:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UTAmode != QImode
   && reload_completed))
        return -1;
      return 2195; /* *fractutaqi2 */

    case 320:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(HImode != QImode
   && reload_completed))
        return -1;
      return 2196; /* *fracthiqi2 */

    case 321:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(SImode != QImode
   && reload_completed))
        return -1;
      return 2197; /* *fractsiqi2 */

    case 322:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(DImode != QImode
   && reload_completed))
        return -1;
      return 2198; /* *fractdiqi2 */

    case 323:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(QQmode != HImode
   && reload_completed))
        return -1;
      return 2199; /* *fractqqhi2 */

    case 324:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UQQmode != HImode
   && reload_completed))
        return -1;
      return 2200; /* *fractuqqhi2 */

    case 325:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(HQmode != HImode
   && reload_completed))
        return -1;
      return 2201; /* *fracthqhi2 */

    case 326:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UHQmode != HImode
   && reload_completed))
        return -1;
      return 2202; /* *fractuhqhi2 */

    case 327:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(HAmode != HImode
   && reload_completed))
        return -1;
      return 2203; /* *fracthahi2 */

    case 328:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UHAmode != HImode
   && reload_completed))
        return -1;
      return 2204; /* *fractuhahi2 */

    case 329:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(SQmode != HImode
   && reload_completed))
        return -1;
      return 2205; /* *fractsqhi2 */

    case 330:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(USQmode != HImode
   && reload_completed))
        return -1;
      return 2206; /* *fractusqhi2 */

    case 331:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(SAmode != HImode
   && reload_completed))
        return -1;
      return 2207; /* *fractsahi2 */

    case 332:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(USAmode != HImode
   && reload_completed))
        return -1;
      return 2208; /* *fractusahi2 */

    case 333:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(DQmode != HImode
   && reload_completed))
        return -1;
      return 2209; /* *fractdqhi2 */

    case 334:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UDQmode != HImode
   && reload_completed))
        return -1;
      return 2210; /* *fractudqhi2 */

    case 335:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(DAmode != HImode
   && reload_completed))
        return -1;
      return 2211; /* *fractdahi2 */

    case 336:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UDAmode != HImode
   && reload_completed))
        return -1;
      return 2212; /* *fractudahi2 */

    case 337:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(TAmode != HImode
   && reload_completed))
        return -1;
      return 2213; /* *fracttahi2 */

    case 338:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UTAmode != HImode
   && reload_completed))
        return -1;
      return 2214; /* *fractutahi2 */

    case 339:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(QImode != HImode
   && reload_completed))
        return -1;
      return 2215; /* *fractqihi2 */

    case 340:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(SImode != HImode
   && reload_completed))
        return -1;
      return 2216; /* *fractsihi2 */

    case 341:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(DImode != HImode
   && reload_completed))
        return -1;
      return 2217; /* *fractdihi2 */

    case 342:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(QQmode != SImode
   && reload_completed))
        return -1;
      return 2218; /* *fractqqsi2 */

    case 343:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UQQmode != SImode
   && reload_completed))
        return -1;
      return 2219; /* *fractuqqsi2 */

    case 344:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(HQmode != SImode
   && reload_completed))
        return -1;
      return 2220; /* *fracthqsi2 */

    case 345:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UHQmode != SImode
   && reload_completed))
        return -1;
      return 2221; /* *fractuhqsi2 */

    case 346:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(HAmode != SImode
   && reload_completed))
        return -1;
      return 2222; /* *fracthasi2 */

    case 347:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UHAmode != SImode
   && reload_completed))
        return -1;
      return 2223; /* *fractuhasi2 */

    case 348:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(SQmode != SImode
   && reload_completed))
        return -1;
      return 2224; /* *fractsqsi2 */

    case 349:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(USQmode != SImode
   && reload_completed))
        return -1;
      return 2225; /* *fractusqsi2 */

    case 350:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(SAmode != SImode
   && reload_completed))
        return -1;
      return 2226; /* *fractsasi2 */

    case 351:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(USAmode != SImode
   && reload_completed))
        return -1;
      return 2227; /* *fractusasi2 */

    case 352:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(DQmode != SImode
   && reload_completed))
        return -1;
      return 2228; /* *fractdqsi2 */

    case 353:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UDQmode != SImode
   && reload_completed))
        return -1;
      return 2229; /* *fractudqsi2 */

    case 354:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(DAmode != SImode
   && reload_completed))
        return -1;
      return 2230; /* *fractdasi2 */

    case 355:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UDAmode != SImode
   && reload_completed))
        return -1;
      return 2231; /* *fractudasi2 */

    case 356:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(TAmode != SImode
   && reload_completed))
        return -1;
      return 2232; /* *fracttasi2 */

    case 357:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UTAmode != SImode
   && reload_completed))
        return -1;
      return 2233; /* *fractutasi2 */

    case 358:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(QImode != SImode
   && reload_completed))
        return -1;
      return 2234; /* *fractqisi2 */

    case 359:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(HImode != SImode
   && reload_completed))
        return -1;
      return 2235; /* *fracthisi2 */

    case 360:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(DImode != SImode
   && reload_completed))
        return -1;
      return 2236; /* *fractdisi2 */

    case 361:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(QQmode != DImode
   && reload_completed))
        return -1;
      return 2237; /* *fractqqdi2 */

    case 362:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UQQmode != DImode
   && reload_completed))
        return -1;
      return 2238; /* *fractuqqdi2 */

    case 363:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(HQmode != DImode
   && reload_completed))
        return -1;
      return 2239; /* *fracthqdi2 */

    case 364:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UHQmode != DImode
   && reload_completed))
        return -1;
      return 2240; /* *fractuhqdi2 */

    case 365:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(HAmode != DImode
   && reload_completed))
        return -1;
      return 2241; /* *fracthadi2 */

    case 366:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UHAmode != DImode
   && reload_completed))
        return -1;
      return 2242; /* *fractuhadi2 */

    case 367:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(SQmode != DImode
   && reload_completed))
        return -1;
      return 2243; /* *fractsqdi2 */

    case 368:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(USQmode != DImode
   && reload_completed))
        return -1;
      return 2244; /* *fractusqdi2 */

    case 369:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(SAmode != DImode
   && reload_completed))
        return -1;
      return 2245; /* *fractsadi2 */

    case 370:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(USAmode != DImode
   && reload_completed))
        return -1;
      return 2246; /* *fractusadi2 */

    case 371:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(DQmode != DImode
   && reload_completed))
        return -1;
      return 2247; /* *fractdqdi2 */

    case 372:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UDQmode != DImode
   && reload_completed))
        return -1;
      return 2248; /* *fractudqdi2 */

    case 373:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(DAmode != DImode
   && reload_completed))
        return -1;
      return 2249; /* *fractdadi2 */

    case 374:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UDAmode != DImode
   && reload_completed))
        return -1;
      return 2250; /* *fractudadi2 */

    case 375:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(TAmode != DImode
   && reload_completed))
        return -1;
      return 2251; /* *fracttadi2 */

    case 376:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UTAmode != DImode
   && reload_completed))
        return -1;
      return 2252; /* *fractutadi2 */

    case 377:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(QImode != DImode
   && reload_completed))
        return -1;
      return 2253; /* *fractqidi2 */

    case 378:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(HImode != DImode
   && reload_completed))
        return -1;
      return 2254; /* *fracthidi2 */

    case 379:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(SImode != DImode
   && reload_completed))
        return -1;
      return 2255; /* *fractsidi2 */

    default:
      return -1;
    }
}

 rtx_insn *
split_17 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) == CONST_INT)
    {
      x5 = XEXP (x3, 0);
      if (rtx_equal_p (x5, operands[0]))
        {
          switch (XWINT (x4, 0))
            {
            case 4L:
              switch (pattern178 (x3))
                {
                case 0:
                  return gen_split_517 (insn, operands);

                case 1:
                  return gen_split_518 (insn, operands);

                case 2:
                  return gen_split_519 (insn, operands);

                default:
                  break;
                }
              break;

            case 5L:
              switch (pattern178 (x3))
                {
                case 0:
                  return gen_split_520 (insn, operands);

                case 1:
                  return gen_split_521 (insn, operands);

                case 2:
                  return gen_split_522 (insn, operands);

                default:
                  break;
                }
              break;

            case 6L:
              if (d_register_operand (operands[0], E_QImode)
                  && GET_MODE (x3) == E_QImode)
                return gen_split_523 (insn, operands);
              break;

            default:
              break;
            }
        }
    }
  x5 = XEXP (x3, 0);
  operands[1] = x5;
  operands[2] = x4;
  switch (pattern153 (x3))
    {
    case 0:
      if (
#line 5980 "../../gcc/config/avr/avr.md"
( reload_completed))
        return gen_split_524 (insn, operands);
      break;

    case 1:
      if (
#line 5980 "../../gcc/config/avr/avr.md"
( reload_completed))
        return gen_split_525 (insn, operands);
      break;

    case 2:
      if (
#line 5980 "../../gcc/config/avr/avr.md"
( reload_completed))
        return gen_split_526 (insn, operands);
      break;

    case 3:
      if (
#line 6006 "../../gcc/config/avr/avr.md"
( reload_completed))
        return gen_split_527 (insn, operands);
      break;

    case 4:
      if (
#line 6006 "../../gcc/config/avr/avr.md"
( reload_completed))
        return gen_split_528 (insn, operands);
      break;

    case 5:
      if (
#line 6006 "../../gcc/config/avr/avr.md"
( reload_completed))
        return gen_split_529 (insn, operands);
      break;

    case 6:
      if (
#line 6006 "../../gcc/config/avr/avr.md"
( reload_completed))
        return gen_split_530 (insn, operands);
      break;

    case 7:
      if (
#line 6006 "../../gcc/config/avr/avr.md"
( reload_completed))
        return gen_split_531 (insn, operands);
      break;

    case 8:
      if (
#line 6065 "../../gcc/config/avr/avr.md"
( reload_completed))
        return gen_split_533 (insn, operands);
      break;

    case 9:
      if (
#line 6065 "../../gcc/config/avr/avr.md"
( reload_completed))
        return gen_split_534 (insn, operands);
      break;

    case 10:
      if (
#line 6065 "../../gcc/config/avr/avr.md"
( reload_completed))
        return gen_split_535 (insn, operands);
      break;

    case 11:
      if (
#line 6065 "../../gcc/config/avr/avr.md"
( reload_completed))
        return gen_split_536 (insn, operands);
      break;

    case 12:
      if (
#line 6065 "../../gcc/config/avr/avr.md"
( reload_completed))
        return gen_split_537 (insn, operands);
      break;

    default:
      break;
    }
  if (reg_or_low_io_operand (operands[1], E_QImode)
      && x4 == const_int_rtx[MAX_SAVED_CONST_INT + 7]
      && register_operand (operands[0], E_QImode)
      && GET_MODE (x3) == E_QImode
      && (
#line 10564 "../../gcc/config/avr/avr.md"
(! reload_completed) && 
#line 10566 "../../gcc/config/avr/avr.md"
( 1)))
    return gen_split_751 (insn, operands);
  if (GET_CODE (x5) != REG)
    return NULL;
  switch (pattern56 (x1))
    {
    case 0:
      if (!(
#line 629 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 631 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
        return NULL;
      return gen_split_1937 (insn, operands);

    case 1:
      if (!(
#line 629 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 631 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
        return NULL;
      return gen_split_1941 (insn, operands);

    case 2:
      if (!(
#line 629 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 631 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
        return NULL;
      return gen_split_1945 (insn, operands);

    case 3:
      if (!(
#line 629 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 631 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
        return NULL;
      return gen_split_1949 (insn, operands);

    case 4:
      if (!(
#line 629 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 631 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
        return NULL;
      return gen_split_1953 (insn, operands);

    case 5:
      if (!(
#line 629 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 631 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
        return NULL;
      return gen_split_1957 (insn, operands);

    case 6:
      if (!(
#line 629 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 631 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
        return NULL;
      return gen_split_1961 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_27 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 1);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case SIGN_EXTEND:
      if (GET_MODE (x5) != E_HImode)
        return NULL;
      x6 = XEXP (x4, 1);
      if (GET_CODE (x6) != CONST_INT)
        return NULL;
      operands[2] = x6;
      if (const_2_to_6_operand (operands[2], E_HImode)
          && register_operand (operands[0], E_HImode)
          && GET_MODE (x4) == E_HImode)
        {
          x7 = XEXP (x5, 0);
          operands[1] = x7;
          if (register_operand (operands[1], E_QImode))
            {
              x8 = XVECEXP (x1, 0, 1);
              x9 = XEXP (x8, 0);
              operands[3] = x9;
              if (scratch_operand (operands[3], E_QImode)
                  && (
#line 3096 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 3098 "../../gcc/config/avr/avr.md"
( reload_completed)))
                return gen_split_304 (insn, operands);
            }
        }
      if (XWINT (x6, 0) != 7L
          || !register_operand (operands[0], E_HImode)
          || GET_MODE (x4) != E_HImode)
        return NULL;
      x7 = XEXP (x5, 0);
      operands[1] = x7;
      if (!register_operand (operands[1], E_QImode))
        return NULL;
      x8 = XVECEXP (x1, 0, 1);
      x9 = XEXP (x8, 0);
      operands[2] = x9;
      if (!scratch_operand (operands[2], E_QImode)
          || !(
#line 3114 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 3116 "../../gcc/config/avr/avr.md"
( reload_completed)))
        return NULL;
      return gen_split_305 (insn, operands);

    case ZERO_EXTEND:
      if (GET_MODE (x5) != E_HImode
          || pattern226 (x1) != 0
          || !(
#line 3132 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 3134 "../../gcc/config/avr/avr.md"
( reload_completed)))
        return NULL;
      return gen_split_306 (insn, operands);

    case REG:
    case SUBREG:
      operands[1] = x5;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      if (const_int_operand (operands[2], E_QImode))
        {
          switch (pattern255 (x1))
            {
            case 0:
              if (
#line 5595 "../../gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C2l (operands[2])))
                return gen_split_437 (insn, operands);
              break;

            case 1:
              if (
#line 5595 "../../gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C4l (operands[2])))
                return gen_split_440 (insn, operands);
              break;

            case 2:
              if (
#line 5595 "../../gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C3l (operands[2])))
                return gen_split_443 (insn, operands);
              break;

            case 3:
              if (
#line 5595 "../../gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C2l (operands[2])))
                return gen_split_446 (insn, operands);
              break;

            case 4:
              if (
#line 5595 "../../gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C2l (operands[2])))
                return gen_split_449 (insn, operands);
              break;

            case 5:
              if (
#line 5595 "../../gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C2l (operands[2])))
                return gen_split_452 (insn, operands);
              break;

            case 6:
              if (
#line 5595 "../../gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C2l (operands[2])))
                return gen_split_455 (insn, operands);
              break;

            case 7:
              if (
#line 5595 "../../gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C4l (operands[2])))
                return gen_split_458 (insn, operands);
              break;

            case 8:
              if (
#line 5595 "../../gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C4l (operands[2])))
                return gen_split_461 (insn, operands);
              break;

            case 9:
              if (
#line 5595 "../../gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C4l (operands[2])))
                return gen_split_464 (insn, operands);
              break;

            case 10:
              if (
#line 5595 "../../gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C4l (operands[2])))
                return gen_split_467 (insn, operands);
              break;

            default:
              break;
            }
        }
      if (!nonmemory_operand (operands[2], E_QImode)
          || pattern256 (x1) != 0
          || !
#line 5716 "../../gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_501 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
peephole2_2 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (peep2_current_count < 2)
    return NULL;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_QImode
      || !d_register_operand (operands[0], E_QImode))
    return NULL;
  x4 = XEXP (x3, 1);
  operands[1] = x4;
  if (!const_int_operand (operands[1], E_QImode))
    return NULL;
  x5 = XEXP (x3, 0);
  if (!rtx_equal_p (x5, operands[0]))
    return NULL;
  x6 = PATTERN (peep2_next_insn (1));
  if (pattern320 (x6, 
E_QImode, 
AND) != 0)
    return NULL;
  x7 = XVECEXP (x6, 0, 0);
  x8 = XEXP (x7, 1);
  x9 = XEXP (x8, 1);
  operands[2] = x9;
  if (!const_int_operand (operands[2], E_QImode))
    return NULL;
  x10 = XEXP (x8, 0);
  if (!rtx_equal_p (x10, operands[0]))
    return NULL;
  x11 = XEXP (x7, 0);
  if (!rtx_equal_p (x11, operands[0]))
    return NULL;
  *pmatch_len_ = 1;
  return gen_peephole2_42 (insn, operands);
}

 rtx_insn *
peephole2_3 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (peep2_current_count < 2
      || peep2_current_count < 3)
    return NULL;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  operands[1] = x4;
  x5 = XEXP (x3, 0);
  if (pattern323 (x5) != 0)
    return NULL;
  x6 = PATTERN (peep2_next_insn (1));
  switch (pattern387 (x6))
    {
    case 0:
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x3) != E_HImode)
        return NULL;
      x7 = XVECEXP (x6, 0, 0);
      x8 = XEXP (x7, 1);
      x9 = XEXP (x8, 1);
      if (!const0_operand (x9, E_HImode))
        return NULL;
      operands[3] = x9;
      x10 = PATTERN (peep2_next_insn (2));
      x11 = XEXP (x10, 1);
      x12 = XEXP (x11, 0);
      switch (pattern398 (x12, 
E_HImode))
        {
        case 0:
          if (
#line 7250 "../../gcc/config/avr/avr.md"
(// Multi-byte reg-reg additions only set the N flag.
   (EQ == GE || EQ == LT || ! REG_P (operands[1]))
   // Needs a const or a d-reg.
   && (REG_P (operands[1]) || d_register_operand (operands[0], HImode))
   && peep2_regno_dead_p (3, REG_CC)))
            {
              *pmatch_len_ = 2;
              res = gen_peephole2_134 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case 1:
          if (
#line 7250 "../../gcc/config/avr/avr.md"
(// Multi-byte reg-reg additions only set the N flag.
   (NE == GE || NE == LT || ! REG_P (operands[1]))
   // Needs a const or a d-reg.
   && (REG_P (operands[1]) || d_register_operand (operands[0], HImode))
   && peep2_regno_dead_p (3, REG_CC)))
            {
              *pmatch_len_ = 2;
              res = gen_peephole2_135 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case 2:
          if (
#line 7250 "../../gcc/config/avr/avr.md"
(// Multi-byte reg-reg additions only set the N flag.
   (GE == GE || GE == LT || ! REG_P (operands[1]))
   // Needs a const or a d-reg.
   && (REG_P (operands[1]) || d_register_operand (operands[0], HImode))
   && peep2_regno_dead_p (3, REG_CC)))
            {
              *pmatch_len_ = 2;
              res = gen_peephole2_136 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case 3:
          if (
#line 7250 "../../gcc/config/avr/avr.md"
(// Multi-byte reg-reg additions only set the N flag.
   (LT == GE || LT == LT || ! REG_P (operands[1]))
   // Needs a const or a d-reg.
   && (REG_P (operands[1]) || d_register_operand (operands[0], HImode))
   && peep2_regno_dead_p (3, REG_CC)))
            {
              *pmatch_len_ = 2;
              res = gen_peephole2_137 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case 4:
          if (
#line 7250 "../../gcc/config/avr/avr.md"
(// Multi-byte reg-reg additions only set the N flag.
   (GT == GE || GT == LT || ! REG_P (operands[1]))
   // Needs a const or a d-reg.
   && (REG_P (operands[1]) || d_register_operand (operands[0], HImode))
   && peep2_regno_dead_p (3, REG_CC)))
            {
              *pmatch_len_ = 2;
              res = gen_peephole2_138 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case 5:
          if (
#line 7250 "../../gcc/config/avr/avr.md"
(// Multi-byte reg-reg additions only set the N flag.
   (LE == GE || LE == LT || ! REG_P (operands[1]))
   // Needs a const or a d-reg.
   && (REG_P (operands[1]) || d_register_operand (operands[0], HImode))
   && peep2_regno_dead_p (3, REG_CC)))
            {
              *pmatch_len_ = 2;
              res = gen_peephole2_139 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        default:
          break;
        }
      operands[4] = x9;
      switch (pattern399 (x12, 
E_HImode))
        {
        case 0:
          if (!
#line 7313 "../../gcc/config/avr/avr.md"
(peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_170 (insn, operands);

        case 1:
          if (!
#line 7313 "../../gcc/config/avr/avr.md"
(peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_171 (insn, operands);

        case 2:
          if (!
#line 7313 "../../gcc/config/avr/avr.md"
(peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_172 (insn, operands);

        case 3:
          if (!
#line 7313 "../../gcc/config/avr/avr.md"
(peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_173 (insn, operands);

        case 4:
          if (!
#line 7313 "../../gcc/config/avr/avr.md"
(peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_174 (insn, operands);

        case 5:
          if (!
#line 7313 "../../gcc/config/avr/avr.md"
(peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_175 (insn, operands);

        default:
          return NULL;
        }

    case 1:
      if (!register_operand (operands[0], E_PSImode)
          || GET_MODE (x3) != E_PSImode)
        return NULL;
      x7 = XVECEXP (x6, 0, 0);
      x8 = XEXP (x7, 1);
      x9 = XEXP (x8, 1);
      if (!const0_operand (x9, E_PSImode))
        return NULL;
      operands[3] = x9;
      x10 = PATTERN (peep2_next_insn (2));
      x11 = XEXP (x10, 1);
      x12 = XEXP (x11, 0);
      switch (pattern398 (x12, 
E_PSImode))
        {
        case 0:
          if (
#line 7250 "../../gcc/config/avr/avr.md"
(// Multi-byte reg-reg additions only set the N flag.
   (EQ == GE || EQ == LT || ! REG_P (operands[1]))
   // Needs a const or a d-reg.
   && (REG_P (operands[1]) || d_register_operand (operands[0], PSImode))
   && peep2_regno_dead_p (3, REG_CC)))
            {
              *pmatch_len_ = 2;
              res = gen_peephole2_140 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case 1:
          if (
#line 7250 "../../gcc/config/avr/avr.md"
(// Multi-byte reg-reg additions only set the N flag.
   (NE == GE || NE == LT || ! REG_P (operands[1]))
   // Needs a const or a d-reg.
   && (REG_P (operands[1]) || d_register_operand (operands[0], PSImode))
   && peep2_regno_dead_p (3, REG_CC)))
            {
              *pmatch_len_ = 2;
              res = gen_peephole2_141 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case 2:
          if (
#line 7250 "../../gcc/config/avr/avr.md"
(// Multi-byte reg-reg additions only set the N flag.
   (GE == GE || GE == LT || ! REG_P (operands[1]))
   // Needs a const or a d-reg.
   && (REG_P (operands[1]) || d_register_operand (operands[0], PSImode))
   && peep2_regno_dead_p (3, REG_CC)))
            {
              *pmatch_len_ = 2;
              res = gen_peephole2_142 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case 3:
          if (
#line 7250 "../../gcc/config/avr/avr.md"
(// Multi-byte reg-reg additions only set the N flag.
   (LT == GE || LT == LT || ! REG_P (operands[1]))
   // Needs a const or a d-reg.
   && (REG_P (operands[1]) || d_register_operand (operands[0], PSImode))
   && peep2_regno_dead_p (3, REG_CC)))
            {
              *pmatch_len_ = 2;
              res = gen_peephole2_143 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case 4:
          if (
#line 7250 "../../gcc/config/avr/avr.md"
(// Multi-byte reg-reg additions only set the N flag.
   (GT == GE || GT == LT || ! REG_P (operands[1]))
   // Needs a const or a d-reg.
   && (REG_P (operands[1]) || d_register_operand (operands[0], PSImode))
   && peep2_regno_dead_p (3, REG_CC)))
            {
              *pmatch_len_ = 2;
              res = gen_peephole2_144 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case 5:
          if (
#line 7250 "../../gcc/config/avr/avr.md"
(// Multi-byte reg-reg additions only set the N flag.
   (LE == GE || LE == LT || ! REG_P (operands[1]))
   // Needs a const or a d-reg.
   && (REG_P (operands[1]) || d_register_operand (operands[0], PSImode))
   && peep2_regno_dead_p (3, REG_CC)))
            {
              *pmatch_len_ = 2;
              res = gen_peephole2_145 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        default:
          break;
        }
      operands[4] = x9;
      switch (pattern399 (x12, 
E_PSImode))
        {
        case 0:
          if (!
#line 7313 "../../gcc/config/avr/avr.md"
(peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_176 (insn, operands);

        case 1:
          if (!
#line 7313 "../../gcc/config/avr/avr.md"
(peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_177 (insn, operands);

        case 2:
          if (!
#line 7313 "../../gcc/config/avr/avr.md"
(peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_178 (insn, operands);

        case 3:
          if (!
#line 7313 "../../gcc/config/avr/avr.md"
(peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_179 (insn, operands);

        case 4:
          if (!
#line 7313 "../../gcc/config/avr/avr.md"
(peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_180 (insn, operands);

        case 5:
          if (!
#line 7313 "../../gcc/config/avr/avr.md"
(peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_181 (insn, operands);

        default:
          return NULL;
        }

    case 2:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode)
        return NULL;
      x7 = XVECEXP (x6, 0, 0);
      x8 = XEXP (x7, 1);
      x9 = XEXP (x8, 1);
      if (!const0_operand (x9, E_SImode))
        return NULL;
      operands[3] = x9;
      x10 = PATTERN (peep2_next_insn (2));
      x11 = XEXP (x10, 1);
      x12 = XEXP (x11, 0);
      switch (pattern398 (x12, 
E_SImode))
        {
        case 0:
          if (
#line 7250 "../../gcc/config/avr/avr.md"
(// Multi-byte reg-reg additions only set the N flag.
   (EQ == GE || EQ == LT || ! REG_P (operands[1]))
   // Needs a const or a d-reg.
   && (REG_P (operands[1]) || d_register_operand (operands[0], SImode))
   && peep2_regno_dead_p (3, REG_CC)))
            {
              *pmatch_len_ = 2;
              res = gen_peephole2_146 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case 1:
          if (
#line 7250 "../../gcc/config/avr/avr.md"
(// Multi-byte reg-reg additions only set the N flag.
   (NE == GE || NE == LT || ! REG_P (operands[1]))
   // Needs a const or a d-reg.
   && (REG_P (operands[1]) || d_register_operand (operands[0], SImode))
   && peep2_regno_dead_p (3, REG_CC)))
            {
              *pmatch_len_ = 2;
              res = gen_peephole2_147 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case 2:
          if (
#line 7250 "../../gcc/config/avr/avr.md"
(// Multi-byte reg-reg additions only set the N flag.
   (GE == GE || GE == LT || ! REG_P (operands[1]))
   // Needs a const or a d-reg.
   && (REG_P (operands[1]) || d_register_operand (operands[0], SImode))
   && peep2_regno_dead_p (3, REG_CC)))
            {
              *pmatch_len_ = 2;
              res = gen_peephole2_148 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case 3:
          if (
#line 7250 "../../gcc/config/avr/avr.md"
(// Multi-byte reg-reg additions only set the N flag.
   (LT == GE || LT == LT || ! REG_P (operands[1]))
   // Needs a const or a d-reg.
   && (REG_P (operands[1]) || d_register_operand (operands[0], SImode))
   && peep2_regno_dead_p (3, REG_CC)))
            {
              *pmatch_len_ = 2;
              res = gen_peephole2_149 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case 4:
          if (
#line 7250 "../../gcc/config/avr/avr.md"
(// Multi-byte reg-reg additions only set the N flag.
   (GT == GE || GT == LT || ! REG_P (operands[1]))
   // Needs a const or a d-reg.
   && (REG_P (operands[1]) || d_register_operand (operands[0], SImode))
   && peep2_regno_dead_p (3, REG_CC)))
            {
              *pmatch_len_ = 2;
              res = gen_peephole2_150 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case 5:
          if (
#line 7250 "../../gcc/config/avr/avr.md"
(// Multi-byte reg-reg additions only set the N flag.
   (LE == GE || LE == LT || ! REG_P (operands[1]))
   // Needs a const or a d-reg.
   && (REG_P (operands[1]) || d_register_operand (operands[0], SImode))
   && peep2_regno_dead_p (3, REG_CC)))
            {
              *pmatch_len_ = 2;
              res = gen_peephole2_151 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        default:
          break;
        }
      operands[4] = x9;
      switch (pattern399 (x12, 
E_SImode))
        {
        case 0:
          if (!
#line 7313 "../../gcc/config/avr/avr.md"
(peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_182 (insn, operands);

        case 1:
          if (!
#line 7313 "../../gcc/config/avr/avr.md"
(peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_183 (insn, operands);

        case 2:
          if (!
#line 7313 "../../gcc/config/avr/avr.md"
(peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_184 (insn, operands);

        case 3:
          if (!
#line 7313 "../../gcc/config/avr/avr.md"
(peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_185 (insn, operands);

        case 4:
          if (!
#line 7313 "../../gcc/config/avr/avr.md"
(peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_186 (insn, operands);

        case 5:
          if (!
#line 7313 "../../gcc/config/avr/avr.md"
(peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_187 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
peephole2_6 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != SET)
    return NULL;
  x3 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x3) != CLOBBER)
    return NULL;
  x4 = XEXP (x2, 1);
  switch (GET_CODE (x4))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      operands[1] = x4;
      res = peephole2_1 (x1, insn, pmatch_len_);
      if (res != NULL_RTX)
        return res;
      if (peep2_current_count < 2
          || x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
          || pattern210 (x1, 
E_QImode) != 0)
        return NULL;
      x5 = PATTERN (peep2_next_insn (1));
      if (pattern320 (x5, 
E_QImode, 
IOR) != 0)
        return NULL;
      x6 = XVECEXP (x5, 0, 0);
      x7 = XEXP (x6, 1);
      x8 = XEXP (x7, 1);
      operands[1] = x8;
      if (!register_operand (operands[1], E_QImode))
        return NULL;
      x9 = XEXP (x7, 0);
      if (!rtx_equal_p (x9, operands[0]))
        return NULL;
      x10 = XEXP (x6, 0);
      if (!rtx_equal_p (x10, operands[0]))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_308 (insn, operands);

    case REG:
      return peephole2_5 (x1, insn, pmatch_len_);

    case PLUS:
    case MINUS:
    case AND:
    case IOR:
    case XOR:
    case ASHIFT:
    case ASHIFTRT:
    case LSHIFTRT:
      x11 = XEXP (x3, 0);
      if (GET_CODE (x11) != REG
          || REGNO (x11) != 36
          || GET_MODE (x11) != E_CCmode)
        return NULL;
      x12 = XEXP (x2, 0);
      operands[0] = x12;
      switch (GET_CODE (x4))
        {
        case AND:
          res = peephole2_2 (x1, insn, pmatch_len_);
          if (res != NULL_RTX)
            return res;
          break;

        case ASHIFT:
          x13 = XEXP (x4, 1);
          switch (GET_CODE (x13))
            {
            case REG:
            case SUBREG:
              operands[1] = x13;
              if (register_operand (operands[1], E_QImode)
                  && register_operand (operands[0], E_HImode)
                  && GET_MODE (x4) == E_HImode)
                {
                  x14 = XEXP (x4, 0);
                  if (rtx_equal_p (x14, operands[0]))
                    {
                      *pmatch_len_ = 0;
                      res = gen_peephole2_85 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                }
              break;

            case CONST_INT:
              x14 = XEXP (x4, 0);
              if (rtx_equal_p (x14, operands[0]))
                {
                  switch (XWINT (x13, 0))
                    {
                    case 4L:
                      switch (pattern332 (x4))
                        {
                        case 0:
                          *pmatch_len_ = 0;
                          res = gen_peephole2_86 (insn, operands);
                          if (res != NULL_RTX)
                            return res;
                          break;

                        case 1:
                          *pmatch_len_ = 0;
                          res = gen_peephole2_87 (insn, operands);
                          if (res != NULL_RTX)
                            return res;
                          break;

                        case 2:
                          *pmatch_len_ = 0;
                          res = gen_peephole2_88 (insn, operands);
                          if (res != NULL_RTX)
                            return res;
                          break;

                        default:
                          break;
                        }
                      break;

                    case 5L:
                      switch (pattern332 (x4))
                        {
                        case 0:
                          *pmatch_len_ = 0;
                          res = gen_peephole2_89 (insn, operands);
                          if (res != NULL_RTX)
                            return res;
                          break;

                        case 1:
                          *pmatch_len_ = 0;
                          res = gen_peephole2_90 (insn, operands);
                          if (res != NULL_RTX)
                            return res;
                          break;

                        case 2:
                          *pmatch_len_ = 0;
                          res = gen_peephole2_91 (insn, operands);
                          if (res != NULL_RTX)
                            return res;
                          break;

                        default:
                          break;
                        }
                      break;

                    case 6L:
                      switch (pattern332 (x4))
                        {
                        case 0:
                          *pmatch_len_ = 0;
                          res = gen_peephole2_92 (insn, operands);
                          if (res != NULL_RTX)
                            return res;
                          break;

                        case 1:
                          *pmatch_len_ = 0;
                          res = gen_peephole2_93 (insn, operands);
                          if (res != NULL_RTX)
                            return res;
                          break;

                        case 2:
                          *pmatch_len_ = 0;
                          res = gen_peephole2_94 (insn, operands);
                          if (res != NULL_RTX)
                            return res;
                          break;

                        default:
                          break;
                        }
                      break;

                    default:
                      break;
                    }
                }
              operands[2] = x13;
              switch (pattern322 (x4))
                {
                case 0:
                  *pmatch_len_ = 0;
                  res = gen_peephole2_97 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                  break;

                case 1:
                  *pmatch_len_ = 0;
                  res = gen_peephole2_100 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                  break;

                case 2:
                  *pmatch_len_ = 0;
                  res = gen_peephole2_103 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                  break;

                case 3:
                  *pmatch_len_ = 0;
                  res = gen_peephole2_106 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                  break;

                case 4:
                  *pmatch_len_ = 0;
                  res = gen_peephole2_109 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                  break;

                case 5:
                  *pmatch_len_ = 0;
                  res = gen_peephole2_112 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                  break;

                case 6:
                  *pmatch_len_ = 0;
                  res = gen_peephole2_115 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                  break;

                case 7:
                  *pmatch_len_ = 0;
                  res = gen_peephole2_118 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                  break;

                case 8:
                  *pmatch_len_ = 0;
                  res = gen_peephole2_121 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                  break;

                case 9:
                  *pmatch_len_ = 0;
                  res = gen_peephole2_124 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                  break;

                default:
                  break;
                }
              break;

            default:
              break;
            }
          break;

        case LSHIFTRT:
          x13 = XEXP (x4, 1);
          if (GET_CODE (x13) == CONST_INT)
            {
              operands[2] = x13;
              switch (pattern322 (x4))
                {
                case 0:
                  *pmatch_len_ = 0;
                  res = gen_peephole2_95 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                  break;

                case 1:
                  *pmatch_len_ = 0;
                  res = gen_peephole2_98 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                  break;

                case 2:
                  *pmatch_len_ = 0;
                  res = gen_peephole2_101 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                  break;

                case 3:
                  *pmatch_len_ = 0;
                  res = gen_peephole2_104 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                  break;

                case 4:
                  *pmatch_len_ = 0;
                  res = gen_peephole2_107 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                  break;

                case 5:
                  *pmatch_len_ = 0;
                  res = gen_peephole2_110 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                  break;

                case 6:
                  *pmatch_len_ = 0;
                  res = gen_peephole2_113 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                  break;

                case 7:
                  *pmatch_len_ = 0;
                  res = gen_peephole2_116 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                  break;

                case 8:
                  *pmatch_len_ = 0;
                  res = gen_peephole2_119 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                  break;

                case 9:
                  *pmatch_len_ = 0;
                  res = gen_peephole2_122 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                  break;

                default:
                  break;
                }
              x14 = XEXP (x4, 0);
              if (rtx_equal_p (x14, operands[0]))
                {
                  switch (XWINT (x13, 0))
                    {
                    case 4L:
                      switch (pattern332 (x4))
                        {
                        case 0:
                          *pmatch_len_ = 0;
                          res = gen_peephole2_125 (insn, operands);
                          if (res != NULL_RTX)
                            return res;
                          break;

                        case 1:
                          *pmatch_len_ = 0;
                          res = gen_peephole2_126 (insn, operands);
                          if (res != NULL_RTX)
                            return res;
                          break;

                        case 2:
                          *pmatch_len_ = 0;
                          res = gen_peephole2_127 (insn, operands);
                          if (res != NULL_RTX)
                            return res;
                          break;

                        default:
                          break;
                        }
                      break;

                    case 5L:
                      switch (pattern332 (x4))
                        {
                        case 0:
                          *pmatch_len_ = 0;
                          res = gen_peephole2_128 (insn, operands);
                          if (res != NULL_RTX)
                            return res;
                          break;

                        case 1:
                          *pmatch_len_ = 0;
                          res = gen_peephole2_129 (insn, operands);
                          if (res != NULL_RTX)
                            return res;
                          break;

                        case 2:
                          *pmatch_len_ = 0;
                          res = gen_peephole2_130 (insn, operands);
                          if (res != NULL_RTX)
                            return res;
                          break;

                        default:
                          break;
                        }
                      break;

                    case 6L:
                      switch (pattern332 (x4))
                        {
                        case 0:
                          *pmatch_len_ = 0;
                          res = gen_peephole2_131 (insn, operands);
                          if (res != NULL_RTX)
                            return res;
                          break;

                        case 1:
                          *pmatch_len_ = 0;
                          res = gen_peephole2_132 (insn, operands);
                          if (res != NULL_RTX)
                            return res;
                          break;

                        case 2:
                          *pmatch_len_ = 0;
                          res = gen_peephole2_133 (insn, operands);
                          if (res != NULL_RTX)
                            return res;
                          break;

                        default:
                          break;
                        }
                      break;

                    default:
                      break;
                    }
                }
            }
          break;

        case ASHIFTRT:
          x14 = XEXP (x4, 0);
          operands[1] = x14;
          x13 = XEXP (x4, 1);
          operands[2] = x13;
          if (const_int_operand (operands[2], E_QImode))
            {
              switch (pattern321 (x4))
                {
                case 0:
                  *pmatch_len_ = 0;
                  res = gen_peephole2_96 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                  break;

                case 1:
                  *pmatch_len_ = 0;
                  res = gen_peephole2_99 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                  break;

                case 2:
                  *pmatch_len_ = 0;
                  res = gen_peephole2_102 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                  break;

                case 3:
                  *pmatch_len_ = 0;
                  res = gen_peephole2_105 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                  break;

                case 4:
                  *pmatch_len_ = 0;
                  res = gen_peephole2_108 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                  break;

                case 5:
                  *pmatch_len_ = 0;
                  res = gen_peephole2_111 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                  break;

                case 6:
                  *pmatch_len_ = 0;
                  res = gen_peephole2_114 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                  break;

                case 7:
                  *pmatch_len_ = 0;
                  res = gen_peephole2_117 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                  break;

                case 8:
                  *pmatch_len_ = 0;
                  res = gen_peephole2_120 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                  break;

                case 9:
                  *pmatch_len_ = 0;
                  res = gen_peephole2_123 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                  break;

                default:
                  break;
                }
            }
          break;

        case PLUS:
          res = peephole2_3 (x1, insn, pmatch_len_);
          if (res != NULL_RTX)
            return res;
          break;

        case MINUS:
          res = peephole2_4 (x1, insn, pmatch_len_);
          if (res != NULL_RTX)
            return res;
          break;

        default:
          break;
        }
      if (peep2_current_count < 2
          || peep2_current_count < 3
          || !register_operand (operands[0], E_QImode))
        return NULL;
      operands[2] = x4;
      if (!op8_ZN_operator (operands[2], E_QImode))
        return NULL;
      x13 = XEXP (x4, 1);
      operands[1] = x13;
      x14 = XEXP (x4, 0);
      if (!rtx_equal_p (x14, operands[0]))
        return NULL;
      x5 = PATTERN (peep2_next_insn (1));
      if (GET_CODE (x5) != SET)
        return NULL;
      x15 = XEXP (x5, 1);
      if (GET_CODE (x15) != COMPARE
          || GET_MODE (x15) != E_CCmode)
        return NULL;
      x16 = XEXP (x5, 0);
      if (GET_CODE (x16) != REG
          || REGNO (x16) != 36
          || GET_MODE (x16) != E_CCmode)
        return NULL;
      x17 = XEXP (x15, 1);
      operands[4] = x17;
      if (!const0_operand (operands[4], E_QImode))
        return NULL;
      x18 = XEXP (x15, 0);
      if (!rtx_equal_p (x18, operands[0]))
        return NULL;
      x19 = PATTERN (peep2_next_insn (2));
      if (GET_CODE (x19) != SET)
        return NULL;
      x20 = XEXP (x19, 1);
      if (GET_CODE (x20) != IF_THEN_ELSE)
        return NULL;
      x21 = XEXP (x20, 1);
      if (GET_CODE (x21) != LABEL_REF)
        return NULL;
      x22 = XEXP (x20, 2);
      if (GET_CODE (x22) != PC)
        return NULL;
      x23 = XEXP (x19, 0);
      if (GET_CODE (x23) != PC)
        return NULL;
      x24 = XEXP (x21, 0);
      operands[3] = x24;
      x25 = XEXP (x20, 0);
      switch (GET_CODE (x25))
        {
        case EQ:
          if (pattern391 (x25) != 0
              || !
#line 7566 "../../gcc/config/avr/avr.md"
(peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_284 (insn, operands);

        case NE:
          if (pattern391 (x25) != 0
              || !
#line 7566 "../../gcc/config/avr/avr.md"
(peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_285 (insn, operands);

        case GE:
          if (pattern391 (x25) != 0
              || !
#line 7566 "../../gcc/config/avr/avr.md"
(peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_286 (insn, operands);

        case LT:
          if (pattern391 (x25) != 0
              || !
#line 7566 "../../gcc/config/avr/avr.md"
(peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_287 (insn, operands);

        case GT:
          if (pattern391 (x25) != 0
              || !
#line 7566 "../../gcc/config/avr/avr.md"
(peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_288 (insn, operands);

        case LE:
          if (pattern391 (x25) != 0
              || !
#line 7566 "../../gcc/config/avr/avr.md"
(peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_289 (insn, operands);

        default:
          return NULL;
        }

    case COMPARE:
      if (peep2_current_count < 2
          || pattern107 (x2, 
36, 
E_CCmode) != 0)
        return NULL;
      x11 = XEXP (x3, 0);
      operands[3] = x11;
      if (!scratch_operand (operands[3], E_QImode))
        return NULL;
      x5 = PATTERN (peep2_next_insn (1));
      if (pattern214 (x5) != 0)
        return NULL;
      x14 = XEXP (x4, 0);
      switch (GET_MODE (x14))
        {
        case E_HImode:
          if (!register_operand (x14, E_HImode))
            return NULL;
          operands[0] = x14;
          x13 = XEXP (x4, 1);
          switch (pattern381 (x13, 
E_HImode))
            {
            case 0:
              if (
#line 7759 "../../gcc/config/avr/avr.md"
(peep2_regno_dead_p (2, REG_CC)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_294 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            case 1:
              if (
#line 7759 "../../gcc/config/avr/avr.md"
(peep2_regno_dead_p (2, REG_CC)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_295 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            default:
              break;
            }
          operands[1] = x14;
          if (pattern382 (x13, 
E_HImode) != 0
              || !
#line 10308 "../../gcc/config/avr/avr.md"
(peep2_regno_dead_p (2, REG_CC)))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_309 (insn, operands);

        case E_SImode:
          if (!register_operand (x14, E_SImode))
            return NULL;
          operands[0] = x14;
          x13 = XEXP (x4, 1);
          switch (pattern381 (x13, 
E_SImode))
            {
            case 0:
              if (
#line 7759 "../../gcc/config/avr/avr.md"
(peep2_regno_dead_p (2, REG_CC)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_296 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            case 1:
              if (
#line 7759 "../../gcc/config/avr/avr.md"
(peep2_regno_dead_p (2, REG_CC)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_297 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            default:
              break;
            }
          operands[1] = x14;
          if (pattern382 (x13, 
E_SImode) != 0
              || !
#line 10308 "../../gcc/config/avr/avr.md"
(peep2_regno_dead_p (2, REG_CC)))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_310 (insn, operands);

        case E_PSImode:
          if (!register_operand (x14, E_PSImode))
            return NULL;
          operands[0] = x14;
          x13 = XEXP (x4, 1);
          switch (pattern381 (x13, 
E_PSImode))
            {
            case 0:
              if (
#line 7759 "../../gcc/config/avr/avr.md"
(peep2_regno_dead_p (2, REG_CC)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_298 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            case 1:
              if (
#line 7759 "../../gcc/config/avr/avr.md"
(peep2_regno_dead_p (2, REG_CC)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_299 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            default:
              break;
            }
          operands[1] = x14;
          if (pattern382 (x13, 
E_PSImode) != 0
              || !
#line 10308 "../../gcc/config/avr/avr.md"
(peep2_regno_dead_p (2, REG_CC)))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_311 (insn, operands);

        case E_HQmode:
          if (!register_operand (x14, E_HQmode))
            return NULL;
          operands[0] = x14;
          x13 = XEXP (x4, 1);
          switch (pattern381 (x13, 
E_HQmode))
            {
            case 0:
              if (
#line 7759 "../../gcc/config/avr/avr.md"
(peep2_regno_dead_p (2, REG_CC)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_300 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            case 1:
              if (
#line 7759 "../../gcc/config/avr/avr.md"
(peep2_regno_dead_p (2, REG_CC)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_301 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            default:
              break;
            }
          operands[1] = x14;
          if (pattern382 (x13, 
E_HQmode) != 0
              || !
#line 10308 "../../gcc/config/avr/avr.md"
(peep2_regno_dead_p (2, REG_CC)))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_312 (insn, operands);

        case E_HAmode:
          if (!register_operand (x14, E_HAmode))
            return NULL;
          operands[0] = x14;
          x13 = XEXP (x4, 1);
          switch (pattern381 (x13, 
E_HAmode))
            {
            case 0:
              if (
#line 7759 "../../gcc/config/avr/avr.md"
(peep2_regno_dead_p (2, REG_CC)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_302 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            case 1:
              if (
#line 7759 "../../gcc/config/avr/avr.md"
(peep2_regno_dead_p (2, REG_CC)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_303 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            default:
              break;
            }
          operands[1] = x14;
          if (pattern382 (x13, 
E_HAmode) != 0
              || !
#line 10308 "../../gcc/config/avr/avr.md"
(peep2_regno_dead_p (2, REG_CC)))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_313 (insn, operands);

        case E_SQmode:
          if (!register_operand (x14, E_SQmode))
            return NULL;
          operands[0] = x14;
          x13 = XEXP (x4, 1);
          switch (pattern381 (x13, 
E_SQmode))
            {
            case 0:
              if (
#line 7759 "../../gcc/config/avr/avr.md"
(peep2_regno_dead_p (2, REG_CC)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_304 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            case 1:
              if (
#line 7759 "../../gcc/config/avr/avr.md"
(peep2_regno_dead_p (2, REG_CC)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_305 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            default:
              break;
            }
          operands[1] = x14;
          if (pattern382 (x13, 
E_SQmode) != 0
              || !
#line 10308 "../../gcc/config/avr/avr.md"
(peep2_regno_dead_p (2, REG_CC)))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_314 (insn, operands);

        case E_SAmode:
          if (!register_operand (x14, E_SAmode))
            return NULL;
          operands[0] = x14;
          x13 = XEXP (x4, 1);
          switch (pattern381 (x13, 
E_SAmode))
            {
            case 0:
              if (
#line 7759 "../../gcc/config/avr/avr.md"
(peep2_regno_dead_p (2, REG_CC)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_306 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            case 1:
              if (
#line 7759 "../../gcc/config/avr/avr.md"
(peep2_regno_dead_p (2, REG_CC)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_307 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            default:
              break;
            }
          operands[1] = x14;
          if (pattern382 (x13, 
E_SAmode) != 0
              || !
#line 10308 "../../gcc/config/avr/avr.md"
(peep2_regno_dead_p (2, REG_CC)))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_315 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}
