/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern2 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 1);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x6 = XEXP (x4, 0);
  operands[1] = x6;
  x7 = XEXP (x2, 1);
  operands[2] = x7;
  if (!const_int_operand (operands[2], E_QImode))
    return -1;
  x8 = XEXP (x1, 1);
  operands[3] = x8;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x1) != E_HImode
          || GET_MODE (x2) != E_HImode
          || GET_MODE (x3) != E_HImode
          || GET_MODE (x4) != E_QImode
          || !register_operand (operands[1], E_QImode)
          || !register_operand (operands[3], E_HImode))
        return -1;
      return 0;

    case E_PSImode:
      if (!register_operand (operands[0], E_PSImode)
          || GET_MODE (x1) != E_PSImode
          || GET_MODE (x2) != E_PSImode
          || GET_MODE (x3) != E_PSImode)
        return -1;
      res = pattern0 (x4);
      if (res >= 0)
        return res + 1; /* [1, 2] */
      return -1;

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode
          || GET_MODE (x2) != E_SImode
          || GET_MODE (x3) != E_SImode)
        return -1;
      res = pattern1 (x4);
      if (res >= 0)
        return res + 3; /* [3, 5] */
      return -1;

    default:
      return -1;
    }
}

int
pattern22 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 24)
    return -1;
  x4 = XEXP (x1, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 24)
    return -1;
  switch (GET_MODE (x4))
    {
    case E_HImode:
      if (GET_MODE (x2) != E_HImode
          || GET_MODE (x3) != E_HImode)
        return -1;
      return 0;

    case E_QImode:
      if (GET_MODE (x2) != E_QImode
          || GET_MODE (x3) != E_QImode)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern27 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 26
      || GET_MODE (x3) != E_HImode)
    return -1;
  x4 = XVECEXP (x1, 0, 4);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 30
      || GET_MODE (x5) != E_HImode)
    return -1;
  x6 = XVECEXP (x1, 0, 5);
  if (GET_CODE (x6) != CLOBBER)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != REG
      || REGNO (x7) != 0
      || GET_MODE (x7) != E_QImode)
    return -1;
  x8 = XVECEXP (x1, 0, 6);
  if (GET_CODE (x8) != CLOBBER)
    return -1;
  return 0;
}

int
pattern31 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      return 0;

    case AND:
      x5 = XEXP (x4, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x6 = XEXP (x1, 0);
      operands[0] = x6;
      x7 = XEXP (x4, 0);
      operands[1] = x7;
      x8 = XEXP (x2, 1);
      operands[2] = x8;
      switch (GET_MODE (operands[0]))
        {
        case E_HImode:
          if (!register_operand (operands[0], E_HImode)
              || GET_MODE (x2) != E_HImode
              || GET_MODE (x3) != E_HImode
              || GET_MODE (x4) != E_QImode
              || !register_operand (operands[1], E_QImode)
              || !nonmemory_operand (operands[2], E_HImode))
            return -1;
          return 1;

        case E_PSImode:
          if (!register_operand (operands[0], E_PSImode)
              || GET_MODE (x2) != E_PSImode
              || GET_MODE (x3) != E_PSImode
              || !nonmemory_operand (operands[2], E_PSImode))
            return -1;
          switch (GET_MODE (x4))
            {
            case E_QImode:
              if (!register_operand (operands[1], E_QImode))
                return -1;
              return 2;

            case E_HImode:
              if (!register_operand (operands[1], E_HImode))
                return -1;
              return 3;

            default:
              return -1;
            }

        case E_SImode:
          if (!register_operand (operands[0], E_SImode)
              || GET_MODE (x2) != E_SImode
              || GET_MODE (x3) != E_SImode
              || !nonmemory_operand (operands[2], E_SImode))
            return -1;
          res = pattern30 (x4);
          if (res >= 0)
            return res + 4; /* [4, 6] */
          return -1;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern53 (rtx x1, int *pnum_clobbers, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !register_operand (operands[0], E_PSImode)
      || GET_MODE (x1) != E_PSImode
      || !register_operand (operands[1], E_PSImode)
      || !nonmemory_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern58 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_QImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + -2])
    return -1;
  x5 = XEXP (x3, 1);
  if (GET_CODE (x5) != AND
      || GET_MODE (x5) != E_QImode)
    return -1;
  x6 = XEXP (x5, 1);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 7])
    return -1;
  x7 = XEXP (x1, 0);
  operands[0] = x7;
  if (!register_operand (operands[0], E_QImode)
      || GET_MODE (x2) != E_QImode)
    return -1;
  x8 = XEXP (x5, 0);
  operands[1] = x8;
  if (!register_operand (operands[1], E_QImode))
    return -1;
  return 0;
}

int
pattern64 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  x3 = XEXP (x1, 1);
  operands[2] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_UQQmode:
      return pattern61 (x1, 
E_UQQmode); /* [-1, 0] */

    case E_UHQmode:
      if (pattern61 (x1, 
E_UHQmode) != 0)
        return -1;
      return 1;

    case E_UHAmode:
      if (pattern61 (x1, 
E_UHAmode) != 0)
        return -1;
      return 2;

    case E_USAmode:
      if (pattern61 (x1, 
E_USAmode) != 0)
        return -1;
      return 3;

    case E_USQmode:
      if (pattern61 (x1, 
E_USQmode) != 0)
        return -1;
      return 4;

    default:
      return -1;
    }
}

int
pattern71 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  operands[0] = x3;
  x4 = XEXP (x1, 0);
  switch (GET_MODE (x4))
    {
    case E_DImode:
      if (GET_MODE (x2) != E_DImode)
        return -1;
      x5 = XEXP (x2, 0);
      if (GET_MODE (x5) != E_DImode
          || !const_operand (operands[0], E_DImode))
        return -1;
      return 0;

    case E_DQmode:
      if (GET_MODE (x2) != E_DQmode)
        return -1;
      x5 = XEXP (x2, 0);
      if (GET_MODE (x5) != E_DQmode
          || !const_operand (operands[0], E_DQmode))
        return -1;
      return 1;

    case E_UDQmode:
      if (GET_MODE (x2) != E_UDQmode)
        return -1;
      x5 = XEXP (x2, 0);
      if (GET_MODE (x5) != E_UDQmode
          || !const_operand (operands[0], E_UDQmode))
        return -1;
      return 2;

    case E_DAmode:
      if (GET_MODE (x2) != E_DAmode)
        return -1;
      x5 = XEXP (x2, 0);
      if (GET_MODE (x5) != E_DAmode
          || !const_operand (operands[0], E_DAmode))
        return -1;
      return 3;

    case E_UDAmode:
      if (GET_MODE (x2) != E_UDAmode)
        return -1;
      x5 = XEXP (x2, 0);
      if (GET_MODE (x5) != E_UDAmode
          || !const_operand (operands[0], E_UDAmode))
        return -1;
      return 4;

    case E_TAmode:
      if (GET_MODE (x2) != E_TAmode)
        return -1;
      x5 = XEXP (x2, 0);
      if (GET_MODE (x5) != E_TAmode
          || !const_operand (operands[0], E_TAmode))
        return -1;
      return 5;

    case E_UTAmode:
      if (GET_MODE (x2) != E_UTAmode)
        return -1;
      x5 = XEXP (x2, 0);
      if (GET_MODE (x5) != E_UTAmode
          || !const_operand (operands[0], E_UTAmode))
        return -1;
      return 6;

    default:
      return -1;
    }
}

int
pattern84 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[1], i1)
      || !nonmemory_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern89 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (maybe_ne (SUBREG_BYTE (x3), 0)
      || GET_MODE (x3) != E_QImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != ASHIFTRT)
    return -1;
  x5 = XEXP (x1, 0);
  operands[0] = x5;
  if (!register_operand (operands[0], E_QImode)
      || GET_MODE (x2) != E_QImode)
    return -1;
  x6 = XEXP (x4, 0);
  operands[1] = x6;
  x7 = XEXP (x4, 1);
  operands[2] = x7;
  switch (GET_MODE (x4))
    {
    case E_QImode:
      if (!register_operand (operands[1], E_QImode)
          || !const7_operand (operands[2], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!register_operand (operands[1], E_HImode)
          || !const15_operand (operands[2], E_QImode))
        return -1;
      return 1;

    case E_PSImode:
      if (!register_operand (operands[1], E_PSImode)
          || !const23_operand (operands[2], E_QImode))
        return -1;
      return 2;

    case E_SImode:
      if (!register_operand (operands[1], E_SImode)
          || !const31_operand (operands[2], E_QImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern97 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != E_QImode)
    return -1;
  x5 = XEXP (x4, 1);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x6 = XEXP (x3, 1);
  if (GET_CODE (x6) != UNSPEC
      || XVECLEN (x6, 0) != 1
      || XINT (x6, 1) != 3
      || GET_MODE (x6) != E_QImode)
    return -1;
  x7 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x7) != USE
      || !register_operand (operands[0], E_QImode)
      || GET_MODE (x3) != E_QImode)
    return -1;
  x8 = XEXP (x4, 2);
  operands[2] = x8;
  if (!const_0_to_7_operand (operands[2], E_QImode))
    return -1;
  x9 = XVECEXP (x6, 0, 0);
  operands[3] = x9;
  if (!register_operand (operands[3], E_QImode))
    return -1;
  x10 = XEXP (x7, 0);
  operands[4] = x10;
  if (!nonmemory_operand (operands[4], E_QImode))
    return -1;
  x11 = XEXP (x4, 0);
  switch (GET_CODE (x11))
    {
    case REG:
    case SUBREG:
      operands[1] = x11;
      if (!register_operand (operands[1], E_QImode))
        return -1;
      return 0;

    case NOT:
      if (GET_MODE (x11) != E_QImode)
        return -1;
      x12 = XEXP (x11, 0);
      operands[1] = x12;
      if (!register_operand (operands[1], E_QImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern113 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !const_int_operand (operands[2], E_QImode)
      || !scratch_operand (operands[3], E_QImode))
    return -1;
  return 0;
}

int
pattern119 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (XVECLEN (x3, 0) != 1
      || XINT (x3, 1) != 2
      || GET_MODE (x3) != E_HImode)
    return -1;
  x4 = XEXP (x2, 0);
  if (GET_CODE (x4) != PC)
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x5) != USE)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != LABEL_REF)
    return -1;
  return 0;
}

int
pattern125 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  if (!register_operand (operands[1], E_QImode)
      || !register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || GET_MODE (x2) != i1)
    return -1;
  return 0;
}

int
pattern128 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[1] = x4;
      if (!register_operand (operands[1], E_QImode)
          || !register_operand (operands[0], E_HImode)
          || GET_MODE (x1) != E_HImode
          || GET_MODE (x2) != E_HImode
          || GET_MODE (x3) != E_HImode)
        return -1;
      x5 = XEXP (x1, 1);
      if (!register_operand (x5, E_HImode))
        return -1;
      x6 = XEXP (x2, 1);
      switch (GET_CODE (x6))
        {
        case ZERO_EXTEND:
          if (GET_MODE (x6) != E_HImode)
            return -1;
          x7 = XEXP (x6, 0);
          operands[2] = x7;
          if (!register_operand (operands[2], E_QImode))
            return -1;
          operands[3] = x5;
          return 0;

        case SIGN_EXTEND:
          if (GET_MODE (x6) != E_HImode)
            return -1;
          x7 = XEXP (x6, 0);
          operands[2] = x7;
          if (!register_operand (operands[2], E_QImode))
            return -1;
          operands[3] = x5;
          return 1;

        case CONST_INT:
          return 2;

        default:
          return -1;
        }

    case AND:
      x8 = XEXP (x4, 1);
      if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x9 = XEXP (x4, 0);
      operands[1] = x9;
      x6 = XEXP (x2, 1);
      operands[2] = x6;
      x5 = XEXP (x1, 1);
      operands[3] = x5;
      res = pattern85 (x1);
      if (res >= 0)
        return res + 3; /* [3, 8] */
      return -1;

    default:
      return -1;
    }
}

int
pattern137 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_QImode)
    return -1;
  x3 = XEXP (x2, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x4 = XEXP (x2, 0);
  operands[0] = x4;
  if (!register_operand (operands[0], E_QImode))
    return -1;
  x5 = XEXP (x2, 2);
  operands[1] = x5;
  if (!const_0_to_7_operand (operands[1], E_QImode))
    return -1;
  x6 = XEXP (x1, 1);
  if (GET_MODE (x6) != E_QImode)
    return -1;
  x7 = XEXP (x6, 0);
  operands[2] = x7;
  if (!register_operand (operands[2], E_QImode))
    return -1;
  x8 = XEXP (x6, 2);
  operands[3] = x8;
  if (!const_0_to_7_operand (operands[3], E_QImode))
    return -1;
  return 0;
}

int
pattern144 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  switch (GET_MODE (x2))
    {
    case E_QQmode:
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_QQmode)
        return -1;
      x4 = XEXP (x3, 0);
      if (GET_MODE (x4) != E_QQmode)
        return -1;
      x5 = XEXP (x3, 1);
      if (GET_MODE (x5) != E_QQmode)
        return -1;
      return 0;

    case E_UQQmode:
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_UQQmode)
        return -1;
      x4 = XEXP (x3, 0);
      if (GET_MODE (x4) != E_UQQmode)
        return -1;
      x5 = XEXP (x3, 1);
      if (GET_MODE (x5) != E_UQQmode)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern152 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[1], E_QImode)
      || !register_operand (operands[0], E_QImode)
      || GET_MODE (x1) != E_QImode)
    return -1;
  x2 = XEXP (x1, 1);
  operands[2] = x2;
  if (!nonmemory_operand (operands[2], E_QImode))
    return -1;
  return 0;
}

int
pattern155 (rtx x1, unsigned int i1, machine_mode i2, machine_mode i3, unsigned int i4)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != i4
      || GET_MODE (x3) != i3)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != i1
      || GET_MODE (x5) != i2)
    return -1;
  return 0;
}

int
pattern160 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 24
      || GET_MODE (x3) != E_QImode)
    return -1;
  x4 = XVECEXP (x2, 0, 1);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 25
      || GET_MODE (x4) != E_QImode)
    return -1;
  x5 = XEXP (x1, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 22
      || GET_MODE (x5) != E_HImode)
    return -1;
  return 0;
}

int
pattern165 (rtx x1, machine_mode i1, unsigned int i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x1, 0);
  if (REGNO (x4) != i2
      || GET_MODE (x4) != i1
      || GET_MODE (x2) != i1)
    return -1;
  return 0;
}

int
pattern170 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (REGNO (x4) != 18)
    return -1;
  x5 = XEXP (x3, 1);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 16
      || GET_MODE (x5) != E_QImode)
    return -1;
  x6 = XEXP (x2, 0);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 18)
    return -1;
  x7 = XVECEXP (x1, 0, 1);
  x8 = XEXP (x7, 0);
  if (GET_CODE (x8) != REG
      || REGNO (x8) != 36
      || GET_MODE (x8) != E_CCmode)
    return -1;
  switch (GET_MODE (x6))
    {
    case E_DImode:
      if (GET_MODE (x3) != E_DImode
          || GET_MODE (x4) != E_DImode)
        return -1;
      return 0;

    case E_DQmode:
      if (GET_MODE (x3) != E_DQmode
          || GET_MODE (x4) != E_DQmode)
        return -1;
      return 1;

    case E_UDQmode:
      if (GET_MODE (x3) != E_UDQmode
          || GET_MODE (x4) != E_UDQmode)
        return -1;
      return 2;

    case E_DAmode:
      if (GET_MODE (x3) != E_DAmode
          || GET_MODE (x4) != E_DAmode)
        return -1;
      return 3;

    case E_UDAmode:
      if (GET_MODE (x3) != E_UDAmode
          || GET_MODE (x4) != E_UDAmode)
        return -1;
      return 4;

    case E_TAmode:
      if (GET_MODE (x3) != E_TAmode
          || GET_MODE (x4) != E_TAmode)
        return -1;
      return 5;

    case E_UTAmode:
      if (GET_MODE (x3) != E_UTAmode
          || GET_MODE (x4) != E_UTAmode)
        return -1;
      return 6;

    default:
      return -1;
    }
}

int
pattern183 (rtx x1, machine_mode i1, unsigned int i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != i2
      || GET_MODE (x3) != i1)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG)
    return -1;
  return 0;
}

int
pattern190 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_HImode)
      || GET_MODE (x1) != E_HImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_HImode
      || !register_operand (operands[1], E_QImode))
    return -1;
  return 0;
}

int
pattern192 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_HImode
      || !register_operand (operands[0], E_HImode)
      || GET_MODE (x1) != E_HImode
      || !register_operand (operands[3], E_HImode)
      || GET_MODE (x2) != E_HImode)
    return -1;
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], E_QImode))
    return -1;
  return 0;
}

int
pattern197 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!pseudo_register_operand (operands[1], i1))
    return -1;
  switch (GET_MODE (operands[2]))
    {
    case E_QImode:
      if (!pseudo_register_operand (operands[2], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!pseudo_register_operand (operands[2], E_HImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern202 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != E_SImode)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 18
      || GET_MODE (x6) != E_HImode)
    return -1;
  x7 = XEXP (x4, 1);
  if (GET_CODE (x7) != i1
      || GET_MODE (x7) != E_SImode)
    return -1;
  x8 = XEXP (x7, 0);
  if (GET_CODE (x8) != REG
      || REGNO (x8) != 26
      || GET_MODE (x8) != E_HImode)
    return -1;
  x9 = XEXP (x3, 1);
  if (XWINT (x9, 0) != 16L
      || pattern162 (x1, 
E_HImode, 
24) != 0)
    return -1;
  return 0;
}

int
pattern208 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != E_QImode)
    return -1;
  x5 = XEXP (x3, 1);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x6) != SET)
    return -1;
  x7 = XEXP (x6, 1);
  if (GET_CODE (x7) != i1
      || GET_MODE (x7) != E_QImode)
    return -1;
  x8 = XEXP (x2, 0);
  if (GET_MODE (x8) != E_CCZNmode
      || GET_MODE (x3) != E_CCZNmode)
    return -1;
  x9 = XEXP (x4, 0);
  operands[3] = x9;
  if (!register_operand (operands[3], E_QImode))
    return -1;
  x10 = XEXP (x4, 1);
  operands[4] = x10;
  if (!nonmemory_operand (operands[4], E_QImode))
    return -1;
  x11 = XEXP (x6, 0);
  operands[0] = x11;
  if (!register_operand (operands[0], E_QImode))
    return -1;
  x12 = XEXP (x7, 0);
  operands[1] = x12;
  if (!register_operand (operands[1], E_QImode))
    return -1;
  x13 = XEXP (x7, 1);
  operands[2] = x13;
  if (!nonmemory_operand (operands[2], E_QImode))
    return -1;
  return 0;
}

int
pattern223 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  x5 = XEXP (x4, 1);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != REG
      || REGNO (x7) != 36
      || GET_MODE (x7) != E_CCmode)
    return -1;
  x8 = XEXP (x3, 0);
  operands[1] = x8;
  x9 = XEXP (x4, 0);
  operands[2] = x9;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      return pattern222 (x3, 
E_QImode); /* [-1, 3] */

    case E_HImode:
      res = pattern222 (x3, 
E_HImode);
      if (res >= 0)
        return res + 4; /* [4, 7] */
      return -1;

    case E_PSImode:
      res = pattern222 (x3, 
E_PSImode);
      if (res >= 0)
        return res + 8; /* [8, 11] */
      return -1;

    case E_SImode:
      res = pattern222 (x3, 
E_SImode);
      if (res >= 0)
        return res + 12; /* [12, 15] */
      return -1;

    default:
      return -1;
    }
}

int
pattern233 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x2, 1);
  operands[2] = x5;
  x6 = XEXP (x1, 1);
  x7 = XEXP (x6, 0);
  operands[3] = x7;
  switch (GET_MODE (x3))
    {
    case E_HImode:
      if (!register_operand (operands[1], E_QImode)
          || !register_operand (operands[2], E_HImode))
        return -1;
      return 0;

    case E_PSImode:
      if (!register_operand (operands[2], E_PSImode))
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 1;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 2;

        default:
          return -1;
        }

    case E_SImode:
      if (!register_operand (operands[2], E_SImode))
        return -1;
      res = pattern4 ();
      if (res >= 0)
        return res + 3; /* [3, 5] */
      return -1;

    default:
      return -1;
    }
}

int
pattern242 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (REGNO (x3) != 18)
    return -1;
  x4 = XEXP (x1, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 18)
    return -1;
  x5 = XEXP (x2, 1);
  switch (GET_CODE (x5))
    {
    case REG:
      if (REGNO (x5) != 10)
        return -1;
      switch (GET_MODE (x4))
        {
        case E_UDQmode:
          if (GET_MODE (x2) != E_UDQmode
              || GET_MODE (x3) != E_UDQmode
              || GET_MODE (x5) != E_UDQmode)
            return -1;
          return 0;

        case E_UDAmode:
          if (GET_MODE (x2) != E_UDAmode
              || GET_MODE (x3) != E_UDAmode
              || GET_MODE (x5) != E_UDAmode)
            return -1;
          return 1;

        case E_UTAmode:
          if (GET_MODE (x2) != E_UTAmode
              || GET_MODE (x3) != E_UTAmode
              || GET_MODE (x5) != E_UTAmode)
            return -1;
          return 2;

        default:
          return -1;
        }

    case CONST_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
      operands[0] = x5;
      switch (GET_MODE (x4))
        {
        case E_UDQmode:
          if (GET_MODE (x2) != E_UDQmode
              || GET_MODE (x3) != E_UDQmode
              || !const_operand (operands[0], E_UDQmode))
            return -1;
          return 3;

        case E_UDAmode:
          if (GET_MODE (x2) != E_UDAmode
              || GET_MODE (x3) != E_UDAmode
              || !const_operand (operands[0], E_UDAmode))
            return -1;
          return 4;

        case E_UTAmode:
          if (GET_MODE (x2) != E_UTAmode
              || GET_MODE (x3) != E_UTAmode
              || !const_operand (operands[0], E_UTAmode))
            return -1;
          return 5;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern253 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !scratch_operand (operands[3], E_QImode))
    return -1;
  return 0;
}

int
pattern257 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[1], E_QImode))
    return -1;
  operands[2] = x1;
  switch (GET_CODE (operands[2]))
    {
    case CONST_INT:
      if (pnum_clobbers == NULL)
        return -1;
      return 0;

    case REG:
    case SUBREG:
      if (!register_operand (operands[2], E_HImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern263 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 0);
  if (REGNO (x4) != 24
      || GET_MODE (x4) != E_QImode)
    return -1;
  x5 = XVECEXP (x3, 0, 1);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 25
      || GET_MODE (x5) != E_QImode)
    return -1;
  x6 = XEXP (x2, 0);
  if (GET_CODE (x6) != REG
      || pattern262 (x1, 
24, 
E_HImode, 
22, 
E_HImode) != 0)
    return -1;
  return 0;
}

int
pattern268 (rtx x1, machine_mode i1, unsigned int i2, machine_mode i3, unsigned int i4, unsigned int i5)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (REGNO (x3) != i5
      || GET_MODE (x3) != i1)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 0);
  if (REGNO (x5) != i4
      || GET_MODE (x5) != i3)
    return -1;
  x6 = XVECEXP (x1, 0, 2);
  x7 = XEXP (x6, 0);
  if (REGNO (x7) != i2)
    return -1;
  x8 = XEXP (x2, 1);
  if (GET_MODE (x8) != i1)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_MODE (x9) != i1)
    return -1;
  x10 = XEXP (x8, 1);
  if (GET_MODE (x10) != i1)
    return -1;
  return 0;
}

int
pattern279 (rtx x1, machine_mode i1, unsigned int i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 2);
  x3 = XEXP (x2, 0);
  if (REGNO (x3) != i2
      || GET_MODE (x3) != i1)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  return pattern244 (x4); /* [-1, 3] */
}

int
pattern284 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != E_QImode)
    return -1;
  x5 = XEXP (x3, 1);
  if (REGNO (x5) != 22
      || GET_MODE (x5) != E_QImode)
    return -1;
  x6 = XEXP (x2, 0);
  if (REGNO (x6) != 24
      || GET_MODE (x6) != E_QImode)
    return -1;
  x7 = XVECEXP (x1, 0, 1);
  x8 = XEXP (x7, 0);
  if (REGNO (x8) != 22
      || GET_MODE (x8) != E_QImode
      || GET_MODE (x3) != E_QImode)
    return -1;
  return 0;
}

int
pattern289 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 1);
  if (GET_CODE (x6) != i1
      || GET_MODE (x6) != E_HImode)
    return -1;
  x7 = XEXP (x4, 1);
  if (XWINT (x7, 0) != 8L)
    return -1;
  x8 = XVECEXP (x1, 0, 1);
  x9 = XEXP (x8, 0);
  if (REGNO (x9) != 36
      || GET_MODE (x9) != E_CCmode)
    return -1;
  x10 = XEXP (x2, 0);
  operands[0] = x10;
  if (!register_operand (operands[0], E_QImode)
      || GET_MODE (x3) != E_QImode
      || GET_MODE (x4) != E_HImode
      || GET_MODE (x5) != E_HImode)
    return -1;
  x11 = XEXP (x5, 0);
  x12 = XEXP (x11, 0);
  operands[1] = x12;
  if (!register_operand (operands[1], E_QImode))
    return -1;
  x13 = XEXP (x6, 0);
  operands[2] = x13;
  if (!register_operand (operands[2], E_QImode))
    return -1;
  return 0;
}

int
pattern297 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != REG)
    return -1;
  x5 = XEXP (x2, 0);
  if (GET_CODE (x5) != REG)
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 1);
  x8 = XEXP (x7, 0);
  if (GET_CODE (x8) != REG)
    return -1;
  x9 = XEXP (x7, 1);
  if (GET_CODE (x9) != REG)
    return -1;
  x10 = XEXP (x6, 0);
  if (GET_CODE (x10) != REG)
    return -1;
  return 0;
}

int
pattern302 (rtx x1, machine_mode i1, unsigned int i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (REGNO (x2) != i2
      || GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  return 0;
}

int
pattern308 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  if (REGNO (x5) != 18
      || GET_MODE (x5) != E_SImode)
    return -1;
  x6 = XEXP (x3, 1);
  if (GET_CODE (x6) != SIGN_EXTEND
      || GET_MODE (x6) != E_DImode)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != REG
      || REGNO (x7) != 22
      || GET_MODE (x7) != E_SImode)
    return -1;
  x8 = XEXP (x2, 0);
  if (GET_CODE (x8) != REG
      || REGNO (x8) != 18
      || GET_MODE (x8) != E_DImode)
    return -1;
  x9 = XVECEXP (x1, 0, 2);
  x10 = XEXP (x9, 0);
  if (REGNO (x10) != 30
      || GET_MODE (x10) != E_HImode
      || GET_MODE (x3) != E_DImode
      || GET_MODE (x4) != E_DImode)
    return -1;
  return 0;
}

int
pattern319 (rtx x1, machine_mode i1, rtx_code i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != i2
      || GET_MODE (x3) != i1)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  return pattern318 (x4); /* [-1, 0] */
}

int
pattern324 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !single_zero_operand (operands[2], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[3], i1)
      || !single_one_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern330 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (XVECLEN (x1, 0) != 2)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XVECEXP (x1, 0, 1);
  return pattern318 (x3); /* [-1, 0] */
}

int
pattern335 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  operands[0] = x3;
  x4 = XEXP (x1, 0);
  switch (GET_MODE (x4))
    {
    case E_DImode:
      if (GET_MODE (x2) != E_DImode)
        return -1;
      x5 = XEXP (x2, 0);
      if (GET_MODE (x5) != E_DImode
          || !const_operand (operands[0], E_DImode))
        return -1;
      return 0;

    case E_DQmode:
      if (GET_MODE (x2) != E_DQmode)
        return -1;
      x5 = XEXP (x2, 0);
      if (GET_MODE (x5) != E_DQmode
          || !const_operand (operands[0], E_DQmode))
        return -1;
      return 1;

    case E_UDQmode:
      if (GET_MODE (x2) != E_UDQmode)
        return -1;
      x5 = XEXP (x2, 0);
      if (GET_MODE (x5) != E_UDQmode
          || !const_operand (operands[0], E_UDQmode))
        return -1;
      return 2;

    case E_DAmode:
      if (GET_MODE (x2) != E_DAmode)
        return -1;
      x5 = XEXP (x2, 0);
      if (GET_MODE (x5) != E_DAmode
          || !const_operand (operands[0], E_DAmode))
        return -1;
      return 3;

    case E_UDAmode:
      if (GET_MODE (x2) != E_UDAmode)
        return -1;
      x5 = XEXP (x2, 0);
      if (GET_MODE (x5) != E_UDAmode
          || !const_operand (operands[0], E_UDAmode))
        return -1;
      return 4;

    case E_TAmode:
      if (GET_MODE (x2) != E_TAmode)
        return -1;
      x5 = XEXP (x2, 0);
      if (GET_MODE (x5) != E_TAmode
          || !const_operand (operands[0], E_TAmode))
        return -1;
      return 5;

    case E_UTAmode:
      if (GET_MODE (x2) != E_UTAmode)
        return -1;
      x5 = XEXP (x2, 0);
      if (GET_MODE (x5) != E_UTAmode
          || !const_operand (operands[0], E_UTAmode))
        return -1;
      return 6;

    default:
      return -1;
    }
}

int
pattern348 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != i1)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 1);
  x6 = XEXP (x5, 0);
  operands[1] = x6;
  x7 = XEXP (x5, 1);
  operands[2] = x7;
  return pattern345 (x1); /* [-1, 2] */
}

int
pattern356 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_CODE (x1))
    {
    case ZERO_EXTEND:
      x2 = XEXP (x1, 0);
      operands[1] = x2;
      if (!register_operand (operands[1], E_QImode)
          || !const_2_to_7_operand (operands[2], E_HImode))
        return -1;
      return 0;

    case SIGN_EXTEND:
      x2 = XEXP (x1, 0);
      operands[1] = x2;
      if (!register_operand (operands[1], E_QImode)
          || !const_1_to_6_operand (operands[2], E_HImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern362 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  switch (GET_CODE (x2))
    {
    case SIGN_EXTEND:
      return pattern361 (x1, 
SIGN_EXTEND); /* [-1, 0] */

    case ZERO_EXTEND:
      if (pattern361 (x1, 
ZERO_EXTEND) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern369 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[2], i1)
      || !register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern372 (rtx x1, machine_mode i1, unsigned int i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 3);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 26
      || GET_MODE (x3) != E_HImode)
    return -1;
  x4 = XVECEXP (x1, 0, 4);
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 30
      || GET_MODE (x5) != E_HImode)
    return -1;
  x6 = XVECEXP (x1, 0, 5);
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != REG
      || REGNO (x7) != i2
      || GET_MODE (x7) != i1)
    return -1;
  return 0;
}

int
pattern380 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  if (!d_register_operand (operands[0], i1)
      || !l_register_operand (operands[1], i1))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x1, 0);
  if (!rtx_equal_p (x3, operands[0]))
    return -1;
  x4 = PATTERN (peep2_next_insn (2));
  if (GET_CODE (x4) != PARALLEL
      || XVECLEN (x4, 0) != 2)
    return -1;
  x5 = XVECEXP (x4, 0, 0);
  if (GET_CODE (x5) != SET)
    return -1;
  x6 = XVECEXP (x4, 0, 1);
  if (GET_CODE (x6) != CLOBBER)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != REG
      || REGNO (x7) != 36
      || GET_MODE (x7) != E_CCmode)
    return -1;
  x8 = XEXP (x5, 1);
  if (!rtx_equal_p (x8, operands[0]))
    return -1;
  x9 = XEXP (x5, 0);
  if (!rtx_equal_p (x9, operands[1]))
    return -1;
  switch (GET_CODE (x2))
    {
    case XOR:
      x10 = XEXP (x2, 1);
      operands[2] = x10;
      if (!const_operand (operands[2], i1))
        return -1;
      x11 = XEXP (x2, 0);
      if (!rtx_equal_p (x11, operands[0]))
        return -1;
      return 0;

    case IOR:
      x10 = XEXP (x2, 1);
      operands[2] = x10;
      if (!const_operand (operands[2], i1))
        return -1;
      x11 = XEXP (x2, 0);
      if (!rtx_equal_p (x11, operands[0]))
        return -1;
      return 1;

    case AND:
      x10 = XEXP (x2, 1);
      operands[2] = x10;
      if (!const_operand (operands[2], i1))
        return -1;
      x11 = XEXP (x2, 0);
      if (!rtx_equal_p (x11, operands[0]))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern397 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = PATTERN (peep2_next_insn (2));
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case GE:
      return pattern391 (x4); /* [-1, 0] */

    case LT:
      if (pattern391 (x4) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

 int
recog_4 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  if (GET_CODE (x3) == MEM)
    {
      res = recog_3 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
    }
  if (pnum_clobbers != NULL)
    {
      switch (pattern122 (x3))
        {
        case 0:
          if (
#line 674 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true))))
            {
              *pnum_clobbers = 3;
              return 68; /* fxloadqi_A */
            }
          break;

        case 1:
          if (
#line 674 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true))))
            {
              *pnum_clobbers = 3;
              return 69; /* fxloadqq_A */
            }
          break;

        case 2:
          if (
#line 674 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true))))
            {
              *pnum_clobbers = 3;
              return 70; /* fxloaduqq_A */
            }
          break;

        case 3:
          if (
#line 674 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true))))
            {
              *pnum_clobbers = 3;
              return 71; /* fxloadhi_A */
            }
          break;

        case 4:
          if (
#line 674 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true))))
            {
              *pnum_clobbers = 3;
              return 72; /* fxloadhq_A */
            }
          break;

        case 5:
          if (
#line 674 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true))))
            {
              *pnum_clobbers = 3;
              return 73; /* fxloaduhq_A */
            }
          break;

        case 6:
          if (
#line 674 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true))))
            {
              *pnum_clobbers = 3;
              return 74; /* fxloadha_A */
            }
          break;

        case 7:
          if (
#line 674 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true))))
            {
              *pnum_clobbers = 3;
              return 75; /* fxloaduha_A */
            }
          break;

        case 8:
          if (
#line 674 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true))))
            {
              *pnum_clobbers = 3;
              return 76; /* fxloadsi_A */
            }
          break;

        case 9:
          if (
#line 674 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true))))
            {
              *pnum_clobbers = 3;
              return 77; /* fxloadsq_A */
            }
          break;

        case 10:
          if (
#line 674 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true))))
            {
              *pnum_clobbers = 3;
              return 78; /* fxloadusq_A */
            }
          break;

        case 11:
          if (
#line 674 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true))))
            {
              *pnum_clobbers = 3;
              return 79; /* fxloadsa_A */
            }
          break;

        case 12:
          if (
#line 674 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true))))
            {
              *pnum_clobbers = 3;
              return 80; /* fxloadusa_A */
            }
          break;

        case 13:
          if (
#line 674 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true))))
            {
              *pnum_clobbers = 3;
              return 81; /* fxloadsf_A */
            }
          break;

        case 14:
          if (
#line 674 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true))))
            {
              *pnum_clobbers = 3;
              return 82; /* fxloadpsi_A */
            }
          break;

        default:
          break;
        }
    }
  if (pnum_clobbers == NULL
      || GET_CODE (x3) != MEM)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != LO_SUM
      || GET_MODE (x4) != E_PSImode)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 21
      || GET_MODE (x5) != E_QImode)
    return -1;
  x6 = XEXP (x4, 1);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 30
      || GET_MODE (x6) != E_HImode
      || GET_CODE (x2) != REG
      || REGNO (x2) != 22)
    return -1;
  switch (GET_MODE (x2))
    {
    case E_QImode:
      if (GET_MODE (x3) != E_QImode)
        return -1;
      if (
#line 715 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
    || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true)))
        {
          *pnum_clobbers = 2;
          return 83; /* fxload_qi_libgcc */
        }
      if (!
#line 735 "../../gcc/config/avr/avr.md"
(reload_completed
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true))))
        return -1;
      *pnum_clobbers = 3;
      return 98; /* *fxload_qi_libgcc */

    case E_QQmode:
      if (GET_MODE (x3) != E_QQmode)
        return -1;
      if (
#line 715 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
    || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true)))
        {
          *pnum_clobbers = 2;
          return 84; /* fxload_qq_libgcc */
        }
      if (!
#line 735 "../../gcc/config/avr/avr.md"
(reload_completed
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true))))
        return -1;
      *pnum_clobbers = 3;
      return 99; /* *fxload_qq_libgcc */

    case E_UQQmode:
      if (GET_MODE (x3) != E_UQQmode)
        return -1;
      if (
#line 715 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
    || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true)))
        {
          *pnum_clobbers = 2;
          return 85; /* fxload_uqq_libgcc */
        }
      if (!
#line 735 "../../gcc/config/avr/avr.md"
(reload_completed
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true))))
        return -1;
      *pnum_clobbers = 3;
      return 100; /* *fxload_uqq_libgcc */

    case E_HImode:
      if (GET_MODE (x3) != E_HImode)
        return -1;
      if (
#line 715 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
    || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true)))
        {
          *pnum_clobbers = 2;
          return 86; /* fxload_hi_libgcc */
        }
      if (!
#line 735 "../../gcc/config/avr/avr.md"
(reload_completed
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true))))
        return -1;
      *pnum_clobbers = 3;
      return 101; /* *fxload_hi_libgcc */

    case E_HQmode:
      if (GET_MODE (x3) != E_HQmode)
        return -1;
      if (
#line 715 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
    || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true)))
        {
          *pnum_clobbers = 2;
          return 87; /* fxload_hq_libgcc */
        }
      if (!
#line 735 "../../gcc/config/avr/avr.md"
(reload_completed
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true))))
        return -1;
      *pnum_clobbers = 3;
      return 102; /* *fxload_hq_libgcc */

    case E_UHQmode:
      if (GET_MODE (x3) != E_UHQmode)
        return -1;
      if (
#line 715 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
    || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true)))
        {
          *pnum_clobbers = 2;
          return 88; /* fxload_uhq_libgcc */
        }
      if (!
#line 735 "../../gcc/config/avr/avr.md"
(reload_completed
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true))))
        return -1;
      *pnum_clobbers = 3;
      return 103; /* *fxload_uhq_libgcc */

    case E_HAmode:
      if (GET_MODE (x3) != E_HAmode)
        return -1;
      if (
#line 715 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
    || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true)))
        {
          *pnum_clobbers = 2;
          return 89; /* fxload_ha_libgcc */
        }
      if (!
#line 735 "../../gcc/config/avr/avr.md"
(reload_completed
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true))))
        return -1;
      *pnum_clobbers = 3;
      return 104; /* *fxload_ha_libgcc */

    case E_UHAmode:
      if (GET_MODE (x3) != E_UHAmode)
        return -1;
      if (
#line 715 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
    || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true)))
        {
          *pnum_clobbers = 2;
          return 90; /* fxload_uha_libgcc */
        }
      if (!
#line 735 "../../gcc/config/avr/avr.md"
(reload_completed
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true))))
        return -1;
      *pnum_clobbers = 3;
      return 105; /* *fxload_uha_libgcc */

    case E_SImode:
      if (GET_MODE (x3) != E_SImode)
        return -1;
      if (
#line 715 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
    || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true)))
        {
          *pnum_clobbers = 2;
          return 91; /* fxload_si_libgcc */
        }
      if (!
#line 735 "../../gcc/config/avr/avr.md"
(reload_completed
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true))))
        return -1;
      *pnum_clobbers = 3;
      return 106; /* *fxload_si_libgcc */

    case E_SQmode:
      if (GET_MODE (x3) != E_SQmode)
        return -1;
      if (
#line 715 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
    || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true)))
        {
          *pnum_clobbers = 2;
          return 92; /* fxload_sq_libgcc */
        }
      if (!
#line 735 "../../gcc/config/avr/avr.md"
(reload_completed
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true))))
        return -1;
      *pnum_clobbers = 3;
      return 107; /* *fxload_sq_libgcc */

    case E_USQmode:
      if (GET_MODE (x3) != E_USQmode)
        return -1;
      if (
#line 715 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
    || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true)))
        {
          *pnum_clobbers = 2;
          return 93; /* fxload_usq_libgcc */
        }
      if (!
#line 735 "../../gcc/config/avr/avr.md"
(reload_completed
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true))))
        return -1;
      *pnum_clobbers = 3;
      return 108; /* *fxload_usq_libgcc */

    case E_SAmode:
      if (GET_MODE (x3) != E_SAmode)
        return -1;
      if (
#line 715 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
    || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true)))
        {
          *pnum_clobbers = 2;
          return 94; /* fxload_sa_libgcc */
        }
      if (!
#line 735 "../../gcc/config/avr/avr.md"
(reload_completed
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true))))
        return -1;
      *pnum_clobbers = 3;
      return 109; /* *fxload_sa_libgcc */

    case E_USAmode:
      if (GET_MODE (x3) != E_USAmode)
        return -1;
      if (
#line 715 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
    || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true)))
        {
          *pnum_clobbers = 2;
          return 95; /* fxload_usa_libgcc */
        }
      if (!
#line 735 "../../gcc/config/avr/avr.md"
(reload_completed
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true))))
        return -1;
      *pnum_clobbers = 3;
      return 110; /* *fxload_usa_libgcc */

    case E_SFmode:
      if (GET_MODE (x3) != E_SFmode)
        return -1;
      if (
#line 715 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
    || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true)))
        {
          *pnum_clobbers = 2;
          return 96; /* fxload_sf_libgcc */
        }
      if (!
#line 735 "../../gcc/config/avr/avr.md"
(reload_completed
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true))))
        return -1;
      *pnum_clobbers = 3;
      return 111; /* *fxload_sf_libgcc */

    case E_PSImode:
      if (GET_MODE (x3) != E_PSImode)
        return -1;
      if (
#line 715 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
    || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true)))
        {
          *pnum_clobbers = 2;
          return 97; /* fxload_psi_libgcc */
        }
      if (!
#line 735 "../../gcc/config/avr/avr.md"
(reload_completed
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true))))
        return -1;
      *pnum_clobbers = 3;
      return 112; /* *fxload_psi_libgcc */

    default:
      return -1;
    }
}

 int
recog_27 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case SIGN_EXTEND:
      switch (pattern39 (x1))
        {
        case 0:
          x4 = XEXP (x2, 1);
          if (GET_CODE (x4) != CONST_INT
              || !register_operand (operands[0], E_HImode)
              || GET_MODE (x2) != E_HImode
              || GET_MODE (x3) != E_HImode)
            return -1;
          if (XWINT (x4, 0) == 1L)
            return 526; /* *ashiftqihi2.signx.1_split */
          if (pnum_clobbers == NULL)
            return -1;
          operands[2] = x4;
          if (const_2_to_6_operand (operands[2], E_HImode)
              && 
#line 3096 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
            {
              *pnum_clobbers = 1;
              return 528; /* *ashifthi3.signx.const */
            }
          if (XWINT (x4, 0) != 7L
              || !
#line 3114 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
            return -1;
          *pnum_clobbers = 1;
          return 529; /* *ashifthi3.signx.const7 */

        case 1:
          if (!
#line 10891 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 2 > 1
   && ! reload_completed))
            return -1;
          return 1445; /* *map.shl.ext.and1-to-skip.hi */

        case 2:
          if (!
#line 10891 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 1
   && ! reload_completed))
            return -1;
          return 1447; /* *map.shl.ext.and1-to-skip.psi */

        case 3:
          if (!
#line 10891 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 2
   && ! reload_completed))
            return -1;
          return 1451; /* *map.shl.ext.and1-to-skip.psi */

        case 4:
          if (!
#line 10891 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 1
   && ! reload_completed))
            return -1;
          return 1449; /* *map.shl.ext.and1-to-skip.si */

        case 5:
          if (!
#line 10891 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 2
   && ! reload_completed))
            return -1;
          return 1453; /* *map.shl.ext.and1-to-skip.si */

        case 6:
          if (!
#line 10891 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 3
   && ! reload_completed))
            return -1;
          return 1455; /* *map.shl.ext.and1-to-skip.si */

        default:
          return -1;
        }

    case ZERO_EXTEND:
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      x4 = XEXP (x2, 1);
      operands[2] = x4;
      x6 = XEXP (x3, 0);
      switch (GET_CODE (x6))
        {
        case REG:
        case SUBREG:
          if (pnum_clobbers == NULL
              || pattern125 (x2, 
E_HImode) != 0
              || !const_2_to_7_operand (operands[2], E_HImode)
              || !
#line 3132 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
            return -1;
          *pnum_clobbers = 1;
          return 530; /* *ashifthi3.zerox.const */

        case AND:
          x7 = XEXP (x6, 1);
          if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
            return -1;
          x8 = XEXP (x6, 0);
          operands[1] = x8;
          switch (pattern37 (x2))
            {
            case 0:
              if (!
#line 10891 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 2 > 1
   && ! reload_completed))
                return -1;
              return 1446; /* *map.shl.ext.and1-to-skip.hi */

            case 1:
              if (!
#line 10891 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 1
   && ! reload_completed))
                return -1;
              return 1448; /* *map.shl.ext.and1-to-skip.psi */

            case 2:
              if (!
#line 10891 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 2
   && ! reload_completed))
                return -1;
              return 1452; /* *map.shl.ext.and1-to-skip.psi */

            case 3:
              if (!
#line 10891 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 1
   && ! reload_completed))
                return -1;
              return 1450; /* *map.shl.ext.and1-to-skip.si */

            case 4:
              if (!
#line 10891 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 2
   && ! reload_completed))
                return -1;
              return 1454; /* *map.shl.ext.and1-to-skip.si */

            case 5:
              if (!
#line 10891 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 3
   && ! reload_completed))
                return -1;
              return 1456; /* *map.shl.ext.and1-to-skip.si */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      operands[1] = x3;
      res = recog_16 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      if (GET_CODE (x3) != REG)
        return -1;
      switch (pattern56 (x1))
        {
        case 0:
          if (
#line 629 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
            return 3304; /* ashldi3_insn */
          if (pnum_clobbers == NULL
              || !
#line 642 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          *pnum_clobbers = 1;
          return 3332; /* *ashldi3_insn */

        case 1:
          if (
#line 629 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
            return 3308; /* ashldq3_insn */
          if (pnum_clobbers == NULL
              || !
#line 642 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          *pnum_clobbers = 1;
          return 3336; /* *ashldq3_insn */

        case 2:
          if (
#line 629 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
            return 3312; /* ashludq3_insn */
          if (pnum_clobbers == NULL
              || !
#line 642 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          *pnum_clobbers = 1;
          return 3340; /* *ashludq3_insn */

        case 3:
          if (
#line 629 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
            return 3316; /* ashlda3_insn */
          if (pnum_clobbers == NULL
              || !
#line 642 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          *pnum_clobbers = 1;
          return 3344; /* *ashlda3_insn */

        case 4:
          if (
#line 629 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
            return 3320; /* ashluda3_insn */
          if (pnum_clobbers == NULL
              || !
#line 642 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          *pnum_clobbers = 1;
          return 3348; /* *ashluda3_insn */

        case 5:
          if (
#line 629 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
            return 3324; /* ashlta3_insn */
          if (pnum_clobbers == NULL
              || !
#line 642 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          *pnum_clobbers = 1;
          return 3352; /* *ashlta3_insn */

        case 6:
          if (
#line 629 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
            return 3328; /* ashluta3_insn */
          if (pnum_clobbers == NULL
              || !
#line 642 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          *pnum_clobbers = 1;
          return 3356; /* *ashluta3_insn */

        default:
          return -1;
        }

    case CONST_INT:
      if (XWINT (x3, 0) != 1L
          || pattern74 (x1) != 0)
        return -1;
      return 1013; /* mask1_0x01_split */

    default:
      return -1;
    }
}

 int
recog_30 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  switch (pattern14 (x1))
    {
    case 0:
      return 191; /* *udiff_widenqihi3_split */

    case 1:
      x2 = XEXP (x1, 0);
      operands[0] = x2;
      res = recog_8 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      x3 = XEXP (x1, 1);
      x4 = XEXP (x3, 0);
      if (GET_CODE (x4) != REG)
        return -1;
      switch (pattern73 (x1))
        {
        case 0:
          if (
#line 211 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
            return 3196; /* subdi3_insn */
          if (pnum_clobbers == NULL
              || !
#line 224 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          *pnum_clobbers = 1;
          return 3203; /* *subdi3_insn */

        case 1:
          if (
#line 211 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
            return 3197; /* subdq3_insn */
          if (pnum_clobbers == NULL
              || !
#line 224 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          *pnum_clobbers = 1;
          return 3204; /* *subdq3_insn */

        case 2:
          if (
#line 211 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
            return 3198; /* subudq3_insn */
          if (pnum_clobbers == NULL
              || !
#line 224 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          *pnum_clobbers = 1;
          return 3205; /* *subudq3_insn */

        case 3:
          if (
#line 211 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
            return 3199; /* subda3_insn */
          if (pnum_clobbers == NULL
              || !
#line 224 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          *pnum_clobbers = 1;
          return 3206; /* *subda3_insn */

        case 4:
          if (
#line 211 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
            return 3200; /* subuda3_insn */
          if (pnum_clobbers == NULL
              || !
#line 224 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          *pnum_clobbers = 1;
          return 3207; /* *subuda3_insn */

        case 5:
          if (
#line 211 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
            return 3201; /* subta3_insn */
          if (pnum_clobbers == NULL
              || !
#line 224 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          *pnum_clobbers = 1;
          return 3208; /* *subta3_insn */

        case 6:
          if (
#line 211 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
            return 3202; /* subuta3_insn */
          if (pnum_clobbers == NULL
              || !
#line 224 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          *pnum_clobbers = 1;
          return 3209; /* *subuta3_insn */

        case 7:
          if (
#line 236 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
            return 3210; /* subdi3_const_insn */
          if (pnum_clobbers == NULL
              || !
#line 249 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          *pnum_clobbers = 1;
          return 3217; /* *subdi3_const_insn */

        case 8:
          if (
#line 236 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
            return 3211; /* subdq3_const_insn */
          if (pnum_clobbers == NULL
              || !
#line 249 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          *pnum_clobbers = 1;
          return 3218; /* *subdq3_const_insn */

        case 9:
          if (
#line 236 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
            return 3212; /* subudq3_const_insn */
          if (pnum_clobbers == NULL
              || !
#line 249 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          *pnum_clobbers = 1;
          return 3219; /* *subudq3_const_insn */

        case 10:
          if (
#line 236 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
            return 3213; /* subda3_const_insn */
          if (pnum_clobbers == NULL
              || !
#line 249 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          *pnum_clobbers = 1;
          return 3220; /* *subda3_const_insn */

        case 11:
          if (
#line 236 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
            return 3214; /* subuda3_const_insn */
          if (pnum_clobbers == NULL
              || !
#line 249 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          *pnum_clobbers = 1;
          return 3221; /* *subuda3_const_insn */

        case 12:
          if (
#line 236 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
            return 3215; /* subta3_const_insn */
          if (pnum_clobbers == NULL
              || !
#line 249 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          *pnum_clobbers = 1;
          return 3222; /* *subta3_const_insn */

        case 13:
          if (
#line 236 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
            return 3216; /* subuta3_const_insn */
          if (pnum_clobbers == NULL
              || !
#line 249 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          *pnum_clobbers = 1;
          return 3223; /* *subuta3_const_insn */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_36 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x4 = XEXP (x2, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case MEM:
      x5 = XEXP (x1, 0);
      switch (GET_CODE (x5))
        {
        case ZERO_EXTRACT:
          if (pattern137 (x1) == 0)
            return 1081; /* *insv.extract */
          break;

        case REG:
        case SUBREG:
          operands[0] = x5;
          operands[1] = x4;
          switch (pattern181 (x2))
            {
            case 0:
              return 1145; /* *extzvqi_split */

            case 1:
              return 1146; /* *extzvhi_split */

            case 2:
              return 1147; /* *extzvpsi_split */

            case 3:
              return 1148; /* *extzvsi_split */

            case 4:
              return 1153; /* *extzv.qihi1 */

            case 5:
              return 1154; /* *extzv.qihi1 */

            default:
              break;
            }
          break;

        default:
          break;
        }
      if (GET_CODE (x4) != SUBREG)
        return -1;
      switch (pattern139 (x1))
        {
        case 0:
          if (!
#line 10490 "../../gcc/config/avr/avr.md"
(! reload_completed
   && IN_RANGE (UINTVAL(operands[2]) & GET_MODE_MASK(HImode),
                1U << (8 * 0), 0x80U << (8 * 0))
   && exact_log2 (UINTVAL(operands[2]) & GET_MODE_MASK(HImode))
      == 8 * 0 + INTVAL (operands[3])))
            return -1;
          return 1160; /* *extzv.hi.subreg0 */

        case 1:
          if (!
#line 10490 "../../gcc/config/avr/avr.md"
(! reload_completed
   && IN_RANGE (UINTVAL(operands[2]) & GET_MODE_MASK(PSImode),
                1U << (8 * 0), 0x80U << (8 * 0))
   && exact_log2 (UINTVAL(operands[2]) & GET_MODE_MASK(PSImode))
      == 8 * 0 + INTVAL (operands[3])))
            return -1;
          return 1164; /* *extzv.psi.subreg0 */

        case 2:
          if (!
#line 10490 "../../gcc/config/avr/avr.md"
(! reload_completed
   && IN_RANGE (UINTVAL(operands[2]) & GET_MODE_MASK(SImode),
                1U << (8 * 0), 0x80U << (8 * 0))
   && exact_log2 (UINTVAL(operands[2]) & GET_MODE_MASK(SImode))
      == 8 * 0 + INTVAL (operands[3])))
            return -1;
          return 1168; /* *extzv.si.subreg0 */

        case 3:
          if (!
#line 10490 "../../gcc/config/avr/avr.md"
(! reload_completed
   && IN_RANGE (UINTVAL(operands[2]) & GET_MODE_MASK(HImode),
                1U << (8 * 1), 0x80U << (8 * 1))
   && exact_log2 (UINTVAL(operands[2]) & GET_MODE_MASK(HImode))
      == 8 * 1 + INTVAL (operands[3])))
            return -1;
          return 1161; /* *extzv.hi.subreg1 */

        case 4:
          if (!
#line 10490 "../../gcc/config/avr/avr.md"
(! reload_completed
   && IN_RANGE (UINTVAL(operands[2]) & GET_MODE_MASK(PSImode),
                1U << (8 * 1), 0x80U << (8 * 1))
   && exact_log2 (UINTVAL(operands[2]) & GET_MODE_MASK(PSImode))
      == 8 * 1 + INTVAL (operands[3])))
            return -1;
          return 1165; /* *extzv.psi.subreg1 */

        case 5:
          if (!
#line 10490 "../../gcc/config/avr/avr.md"
(! reload_completed
   && IN_RANGE (UINTVAL(operands[2]) & GET_MODE_MASK(SImode),
                1U << (8 * 1), 0x80U << (8 * 1))
   && exact_log2 (UINTVAL(operands[2]) & GET_MODE_MASK(SImode))
      == 8 * 1 + INTVAL (operands[3])))
            return -1;
          return 1169; /* *extzv.si.subreg1 */

        case 6:
          if (!
#line 10490 "../../gcc/config/avr/avr.md"
(! reload_completed
   && IN_RANGE (UINTVAL(operands[2]) & GET_MODE_MASK(HImode),
                1U << (8 * 2), 0x80U << (8 * 2))
   && exact_log2 (UINTVAL(operands[2]) & GET_MODE_MASK(HImode))
      == 8 * 2 + INTVAL (operands[3])))
            return -1;
          return 1162; /* *extzv.hi.subreg2 */

        case 7:
          if (!
#line 10490 "../../gcc/config/avr/avr.md"
(! reload_completed
   && IN_RANGE (UINTVAL(operands[2]) & GET_MODE_MASK(PSImode),
                1U << (8 * 2), 0x80U << (8 * 2))
   && exact_log2 (UINTVAL(operands[2]) & GET_MODE_MASK(PSImode))
      == 8 * 2 + INTVAL (operands[3])))
            return -1;
          return 1166; /* *extzv.psi.subreg2 */

        case 8:
          if (!
#line 10490 "../../gcc/config/avr/avr.md"
(! reload_completed
   && IN_RANGE (UINTVAL(operands[2]) & GET_MODE_MASK(SImode),
                1U << (8 * 2), 0x80U << (8 * 2))
   && exact_log2 (UINTVAL(operands[2]) & GET_MODE_MASK(SImode))
      == 8 * 2 + INTVAL (operands[3])))
            return -1;
          return 1170; /* *extzv.si.subreg2 */

        case 9:
          if (!
#line 10490 "../../gcc/config/avr/avr.md"
(! reload_completed
   && IN_RANGE (UINTVAL(operands[2]) & GET_MODE_MASK(HImode),
                1U << (8 * 3), 0x80U << (8 * 3))
   && exact_log2 (UINTVAL(operands[2]) & GET_MODE_MASK(HImode))
      == 8 * 3 + INTVAL (operands[3])))
            return -1;
          return 1163; /* *extzv.hi.subreg3 */

        case 10:
          if (!
#line 10490 "../../gcc/config/avr/avr.md"
(! reload_completed
   && IN_RANGE (UINTVAL(operands[2]) & GET_MODE_MASK(PSImode),
                1U << (8 * 3), 0x80U << (8 * 3))
   && exact_log2 (UINTVAL(operands[2]) & GET_MODE_MASK(PSImode))
      == 8 * 3 + INTVAL (operands[3])))
            return -1;
          return 1167; /* *extzv.psi.subreg3 */

        case 11:
          if (!
#line 10490 "../../gcc/config/avr/avr.md"
(! reload_completed
   && IN_RANGE (UINTVAL(operands[2]) & GET_MODE_MASK(SImode),
                1U << (8 * 3), 0x80U << (8 * 3))
   && exact_log2 (UINTVAL(operands[2]) & GET_MODE_MASK(SImode))
      == 8 * 3 + INTVAL (operands[3])))
            return -1;
          return 1171; /* *extzv.si.subreg3 */

        default:
          return -1;
        }

    case XOR:
      switch (pattern93 (x1))
        {
        case 0:
          if (!
#line 10137 "../../gcc/config/avr/avr.md"
(INTVAL (operands[4]) & (1 << INTVAL (operands[3]))))
            return -1;
          return 1091; /* *insv.xor-extract_split */

        case 1:
          if (!
#line 10513 "../../gcc/config/avr/avr.md"
(! reload_completed
   && ((1 << INTVAL (operands[3])) & INTVAL (operands[2])) != 0))
            return -1;
          return 1172; /* *extzv.xor */

        default:
          return -1;
        }

    case NOT:
      if (pattern94 (x1) != 0)
        return -1;
      return 1155; /* *extzv.not_split */

    default:
      return -1;
    }
}

 int
recog_49 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  if (nop_general_operand (operands[2], E_QImode))
    {
      switch (pattern238 (x1))
        {
        case 0:
          if (
#line 5991 "../../gcc/config/avr/avr.md"
(reload_completed))
            return 746; /* *lshrqi3 */
          break;

        case 1:
          if (
#line 5991 "../../gcc/config/avr/avr.md"
(reload_completed))
            return 747; /* *lshrqq3 */
          break;

        case 2:
          if (
#line 5991 "../../gcc/config/avr/avr.md"
(reload_completed))
            return 748; /* *lshruqq3 */
          break;

        case 3:
          if (
#line 6019 "../../gcc/config/avr/avr.md"
(reload_completed))
            return 754; /* *lshrhi3 */
          break;

        case 4:
          if (
#line 6019 "../../gcc/config/avr/avr.md"
(reload_completed))
            return 755; /* *lshrhq3 */
          break;

        case 5:
          if (
#line 6019 "../../gcc/config/avr/avr.md"
(reload_completed))
            return 756; /* *lshruhq3 */
          break;

        case 6:
          if (
#line 6019 "../../gcc/config/avr/avr.md"
(reload_completed))
            return 757; /* *lshrha3 */
          break;

        case 7:
          if (
#line 6019 "../../gcc/config/avr/avr.md"
(reload_completed))
            return 758; /* *lshruha3 */
          break;

        case 8:
          if (
#line 6078 "../../gcc/config/avr/avr.md"
(reload_completed))
            return 766; /* *lshrsi3 */
          break;

        case 9:
          if (
#line 6078 "../../gcc/config/avr/avr.md"
(reload_completed))
            return 767; /* *lshrsq3 */
          break;

        case 10:
          if (
#line 6078 "../../gcc/config/avr/avr.md"
(reload_completed))
            return 768; /* *lshrusq3 */
          break;

        case 11:
          if (
#line 6078 "../../gcc/config/avr/avr.md"
(reload_completed))
            return 769; /* *lshrsa3 */
          break;

        case 12:
          if (
#line 6078 "../../gcc/config/avr/avr.md"
(reload_completed))
            return 770; /* *lshrusa3 */
          break;

        default:
          break;
        }
    }
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 0);
  operands[3] = x7;
  switch (GET_MODE (operands[0]))
    {
    case E_PSImode:
      if (pattern112 (x3) != 0)
        return -1;
      return 759; /* lshrpsi3 */

    case E_SImode:
      if (pnum_clobbers == NULL
          || pattern114 (x3, 
E_SImode) != 0
          || !
#line 6169 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 776; /* *lshrsi3_const */

    case E_SQmode:
      if (pnum_clobbers == NULL
          || pattern114 (x3, 
E_SQmode) != 0
          || !
#line 6169 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 777; /* *lshrsq3_const */

    case E_USQmode:
      if (pnum_clobbers == NULL
          || pattern114 (x3, 
E_USQmode) != 0
          || !
#line 6169 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 778; /* *lshrusq3_const */

    case E_SAmode:
      if (pnum_clobbers == NULL
          || pattern114 (x3, 
E_SAmode) != 0
          || !
#line 6169 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 779; /* *lshrsa3_const */

    case E_USAmode:
      if (pnum_clobbers == NULL
          || pattern114 (x3, 
E_USAmode) != 0
          || !
#line 6169 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 780; /* *lshrusa3_const */

    default:
      return -1;
    }
}

 int
recog_58 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XVECEXP (x1, 0, 0);
  x4 = XEXP (x3, 1);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
      operands[1] = x5;
      x6 = XEXP (x2, 0);
      if (GET_CODE (x6) == REG
          && REGNO (x6) == 36
          && GET_MODE (x6) == E_CCmode)
        {
          x7 = XEXP (x3, 0);
          operands[0] = x7;
          x8 = XEXP (x4, 1);
          operands[2] = x8;
          switch (GET_MODE (operands[0]))
            {
            case E_QImode:
              if (pattern325 (x4, 
E_QImode) == 0
                  && 
#line 2222 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
                return 301; /* *mulqi3_enh */
              break;

            case E_HImode:
              if (pattern325 (x4, 
E_HImode) == 0
                  && 
#line 3290 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
                return 538; /* *mulhi3_enh */
              break;

            case E_QQmode:
              if (pattern325 (x4, 
E_QQmode) == 0
                  && 
#line 309 "../../gcc/config/avr/avr-fixed.md"
(AVR_HAVE_MUL && reload_completed))
                return 3077; /* *mulqq3_enh */
              break;

            case E_UQQmode:
              if (pattern325 (x4, 
E_UQQmode) == 0
                  && 
#line 330 "../../gcc/config/avr/avr-fixed.md"
(AVR_HAVE_MUL && reload_completed))
                return 3079; /* *muluqq3_enh */
              break;

            default:
              break;
            }
        }
      if (GET_CODE (x5) != REG)
        return -1;
      x8 = XEXP (x4, 1);
      if (GET_CODE (x8) != REG)
        return -1;
      x7 = XEXP (x3, 0);
      if (GET_CODE (x7) != REG
          || GET_CODE (x6) != REG)
        return -1;
      switch (REGNO (x5))
        {
        case 24:
          if (pattern284 (x1) != 0
              || !
#line 2243 "../../gcc/config/avr/avr.md"
(!AVR_HAVE_MUL))
            return -1;
          return 302; /* *mulqi3_call_split */

        case 22:
          if (pattern285 (x1) != 0
              || !
#line 3719 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
            return -1;
          return 564; /* *mulsi3_call_split */

        case 18:
          switch (pattern286 (x1))
            {
            case 0:
              if (!
#line 425 "../../gcc/config/avr/avr-fixed.md"
(AVR_HAVE_MUL))
                return -1;
              return 3082; /* *mulhq3.call_split */

            case 1:
              if (!
#line 425 "../../gcc/config/avr/avr-fixed.md"
(AVR_HAVE_MUL))
                return -1;
              return 3083; /* *muluhq3.call_split */

            case 2:
              if (!
#line 425 "../../gcc/config/avr/avr-fixed.md"
(AVR_HAVE_MUL))
                return -1;
              return 3084; /* *mulha3.call_split */

            case 3:
              if (!
#line 425 "../../gcc/config/avr/avr-fixed.md"
(AVR_HAVE_MUL))
                return -1;
              return 3085; /* *muluha3.call_split */

            default:
              return -1;
            }

        case 16:
          if (REGNO (x8) != 20
              || REGNO (x7) != 24
              || REGNO (x6) != 36
              || GET_MODE (x6) != E_CCmode)
            return -1;
          switch (pattern275 (x3))
            {
            case 0:
              if (!
#line 481 "../../gcc/config/avr/avr-fixed.md"
(AVR_HAVE_MUL && reload_completed))
                return -1;
              return 3092; /* *mulsa3.call */

            case 1:
              if (!
#line 481 "../../gcc/config/avr/avr-fixed.md"
(AVR_HAVE_MUL && reload_completed))
                return -1;
              return 3093; /* *mulusa3.call */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case SIGN_EXTEND:
      if (GET_MODE (x5) == E_HImode)
        {
          res = recog_43 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      x9 = XEXP (x5, 0);
      if (GET_CODE (x9) != REG)
        return -1;
      x7 = XEXP (x3, 0);
      if (GET_CODE (x7) != REG)
        return -1;
      x6 = XEXP (x2, 0);
      if (GET_CODE (x6) != REG
          || REGNO (x6) != 36
          || GET_MODE (x6) != E_CCmode)
        return -1;
      switch (REGNO (x9))
        {
        case 18:
          if (pattern301 (x4, 
E_HImode, 
26, 
E_SImode) != 0
              || pattern302 (x3, 
E_SImode, 
22) != 0
              || !
#line 3792 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
            return -1;
          return 570; /* *mulhisi3_call */

        case 26:
          if (pattern303 (x3, 
E_SImode, 
22, 
18, 
E_HImode) != 0
              || !
#line 3863 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
            return -1;
          return 580; /* *mulshisi3_call */

        case 25:
          if (pattern303 (x3, 
E_PSImode, 
18, 
22, 
E_QImode) != 0
              || !
#line 4242 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
            return -1;
          return 603; /* *mulsqipsi3.libgcc */

        default:
          return -1;
        }

    case ZERO_EXTEND:
      x7 = XEXP (x3, 0);
      operands[0] = x7;
      res = recog_44 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      if (GET_MODE (x5) != E_SImode)
        return -1;
      x9 = XEXP (x5, 0);
      if (GET_CODE (x9) != REG
          || pattern183 (x1, 
E_SImode, 
22) != 0)
        return -1;
      x6 = XEXP (x2, 0);
      if (REGNO (x6) != 36
          || GET_MODE (x6) != E_CCmode
          || GET_MODE (x4) != E_SImode
          || GET_MODE (x9) != E_HImode)
        return -1;
      x8 = XEXP (x4, 1);
      if (GET_MODE (x8) != E_SImode)
        return -1;
      switch (REGNO (x9))
        {
        case 18:
          switch (GET_CODE (x8))
            {
            case ZERO_EXTEND:
              x10 = XEXP (x8, 0);
              if (GET_CODE (x10) != REG
                  || REGNO (x10) != 26
                  || GET_MODE (x10) != E_HImode
                  || !
#line 3792 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
                return -1;
              return 571; /* *umulhisi3_call */

            case SIGN_EXTEND:
              x10 = XEXP (x8, 0);
              if (GET_CODE (x10) != REG
                  || REGNO (x10) != 26
                  || GET_MODE (x10) != E_HImode
                  || !
#line 3842 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
                return -1;
              return 577; /* *usmulhisi3_call */

            default:
              return -1;
            }

        case 26:
          if (GET_CODE (x8) != REG
              || REGNO (x8) != 18
              || !
#line 3863 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
            return -1;
          return 581; /* *muluhisi3_call */

        default:
          return -1;
        }

    case NOT:
      x9 = XEXP (x5, 0);
      if (GET_CODE (x9) != ZERO_EXTEND)
        return -1;
      x11 = XEXP (x9, 0);
      if (GET_CODE (x11) != NOT)
        return -1;
      if (GET_MODE (x11) == E_QImode)
        {
          res = recog_45 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      if (GET_MODE (x11) != E_HImode)
        return -1;
      x12 = XEXP (x11, 0);
      if (GET_CODE (x12) != REG
          || REGNO (x12) != 26
          || GET_MODE (x12) != E_HImode)
        return -1;
      x8 = XEXP (x4, 1);
      if (GET_CODE (x8) != REG
          || REGNO (x8) != 18
          || GET_MODE (x8) != E_SImode
          || pattern155 (x1, 
36, 
E_CCmode, 
E_SImode, 
22) != 0
          || GET_MODE (x4) != E_SImode
          || GET_MODE (x5) != E_SImode
          || GET_MODE (x9) != E_SImode
          || !
#line 3884 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
        return -1;
      return 583; /* *mulohisi3_call */

    default:
      return -1;
    }
}

 int
recog_65 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 1);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
      operands[1] = x5;
      x6 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x6) != CLOBBER)
        return -1;
      x7 = XEXP (x4, 1);
      operands[2] = x7;
      if (nonmemory_operand (operands[2], E_QImode)
          && pattern264 (x1, 
E_QImode) == 0
          && 
#line 4497 "../../gcc/config/avr/avr.md"
(reload_completed))
        return 619; /* *andqi3 */
      x8 = XEXP (x6, 0);
      operands[3] = x8;
      switch (pattern109 (x4))
        {
        case 0:
          return 620; /* andhi3 */

        case 1:
          return 622; /* andpsi3 */

        case 2:
          return 624; /* andsi3 */

        default:
          return -1;
        }

    case LSHIFTRT:
      switch (pattern168 (x1))
        {
        case 0:
          if (!
#line 10599 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 1194; /* *insv.any_shift.qi */

        case 1:
          if (!
#line 10599 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 1197; /* *insv.any_shift.hi */

        case 2:
          if (!
#line 10599 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 1200; /* *insv.any_shift.psi */

        case 3:
          if (!
#line 10599 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 1203; /* *insv.any_shift.si */

        default:
          return -1;
        }

    case ASHIFTRT:
      switch (pattern168 (x1))
        {
        case 0:
          if (!
#line 10599 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 1195; /* *insv.any_shift.qi */

        case 1:
          if (!
#line 10599 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 1198; /* *insv.any_shift.hi */

        case 2:
          if (!
#line 10599 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 1201; /* *insv.any_shift.psi */

        case 3:
          if (!
#line 10599 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 1204; /* *insv.any_shift.si */

        default:
          return -1;
        }

    case ASHIFT:
      switch (pattern168 (x1))
        {
        case 0:
          if (!
#line 10599 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 1196; /* *insv.any_shift.qi */

        case 1:
          if (!
#line 10599 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 1199; /* *insv.any_shift.hi */

        case 2:
          if (!
#line 10599 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 1202; /* *insv.any_shift.psi */

        case 3:
          if (!
#line 10599 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 1205; /* *insv.any_shift.si */

        default:
          return -1;
        }

    case ZERO_EXTRACT:
      if (pnum_clobbers == NULL)
        return -1;
      switch (pattern97 (x1))
        {
        case 0:
          if (!
#line 10974 "../../gcc/config/avr/avr.md"
(optimize && avropt_use_nonzero_bits))
            return -1;
          *pnum_clobbers = 1;
          return 1478; /* *nzb=1.and.zerox */

        case 1:
          if (!
#line 11094 "../../gcc/config/avr/avr.md"
(optimize && avropt_use_nonzero_bits))
            return -1;
          *pnum_clobbers = 1;
          return 1493; /* *nzb=1.and.zerox.not */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_72 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  switch (GET_CODE (x2))
    {
    case SET:
      return recog_71 (x1, insn, pnum_clobbers);

    case CALL:
      x3 = XEXP (x2, 0);
      if (GET_CODE (x3) != MEM
          || GET_MODE (x3) != E_HImode)
        return -1;
      x4 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x4) != USE)
        return -1;
      x5 = XEXP (x3, 0);
      operands[0] = x5;
      if (!nonmemory_operand (operands[0], E_HImode))
        return -1;
      x6 = XEXP (x2, 1);
      operands[1] = x6;
      if (!general_operand (operands[1], E_HImode))
        return -1;
      x7 = XEXP (x4, 0);
      operands[2] = x7;
      if (!const_int_operand (operands[2], E_HImode))
        return -1;
      return 970; /* call_insn */

    case UNSPEC_VOLATILE:
      x4 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x4) != SET)
        return -1;
      x8 = XEXP (x4, 1);
      if (pattern103 (x8) != 0)
        return -1;
      switch (XVECLEN (x2, 0))
        {
        case 1:
          switch (XINT (x2, 1))
            {
            case 5:
              x9 = XVECEXP (x2, 0, 0);
              operands[0] = x9;
              if (!const_int_operand (operands[0], E_QImode))
                return -1;
              x7 = XEXP (x4, 0);
              operands[1] = x7;
              x10 = XVECEXP (x8, 0, 0);
              if (!rtx_equal_p (x10, operands[1]))
                return -1;
              return 995; /* cli_sei */

            case 7:
              x9 = XVECEXP (x2, 0, 0);
              operands[0] = x9;
              if (!const_int_operand (operands[0], E_SImode))
                return -1;
              x7 = XEXP (x4, 0);
              operands[1] = x7;
              x10 = XVECEXP (x8, 0, 0);
              if (!rtx_equal_p (x10, operands[1]))
                return -1;
              return 1054; /* *nopv */

            case 8:
              x9 = XVECEXP (x2, 0, 0);
              if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return -1;
              x7 = XEXP (x4, 0);
              operands[0] = x7;
              x10 = XVECEXP (x8, 0, 0);
              if (!rtx_equal_p (x10, operands[0]))
                return -1;
              return 1055; /* *sleep */

            case 9:
              x9 = XVECEXP (x2, 0, 0);
              if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return -1;
              x7 = XEXP (x4, 0);
              operands[0] = x7;
              x10 = XVECEXP (x8, 0, 0);
              if (!rtx_equal_p (x10, operands[0]))
                return -1;
              return 1056; /* *wdr */

            default:
              return -1;
            }

        case 2:
          if (pnum_clobbers == NULL
              || XINT (x2, 1) != 10)
            return -1;
          x11 = XVECEXP (x2, 0, 1);
          if (GET_CODE (x11) != CONST_INT)
            return -1;
          x9 = XVECEXP (x2, 0, 0);
          operands[0] = x9;
          x7 = XEXP (x4, 0);
          operands[1] = x7;
          x10 = XVECEXP (x8, 0, 0);
          if (!rtx_equal_p (x10, operands[1]))
            return -1;
          switch (XWINT (x11, 0))
            {
            case 1L:
              if (!const_int_operand (operands[0], E_QImode))
                return -1;
              *pnum_clobbers = 1;
              return 1003; /* delay_cycles_1 */

            case 2L:
              if (!const_int_operand (operands[0], E_HImode))
                return -1;
              *pnum_clobbers = 1;
              return 1005; /* delay_cycles_2 */

            case 3L:
              if (!const_int_operand (operands[0], E_SImode))
                return -1;
              *pnum_clobbers = 3;
              return 1007; /* delay_cycles_3 */

            case 4L:
              if (!const_int_operand (operands[0], E_SImode))
                return -1;
              *pnum_clobbers = 4;
              return 1009; /* delay_cycles_4 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_82 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (pattern105 (x1) != 0
      || !scratch_operand (operands[3], E_QImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      x2 = XVECEXP (x1, 0, 0);
      x3 = XEXP (x2, 1);
      if (pattern311 (x3, 
E_HImode) != 0
          || !
#line 1927 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 209; /* *addhi3_clobber */

    case E_HQmode:
      x2 = XVECEXP (x1, 0, 0);
      x3 = XEXP (x2, 1);
      if (pattern311 (x3, 
E_HQmode) != 0
          || !
#line 1927 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 210; /* *addhq3_clobber */

    case E_UHQmode:
      x2 = XVECEXP (x1, 0, 0);
      x3 = XEXP (x2, 1);
      if (pattern311 (x3, 
E_UHQmode) != 0
          || !
#line 1927 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 211; /* *adduhq3_clobber */

    case E_HAmode:
      x2 = XVECEXP (x1, 0, 0);
      x3 = XEXP (x2, 1);
      if (pattern311 (x3, 
E_HAmode) != 0
          || !
#line 1927 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 212; /* *addha3_clobber */

    case E_UHAmode:
      x2 = XVECEXP (x1, 0, 0);
      x3 = XEXP (x2, 1);
      if (pattern311 (x3, 
E_UHAmode) != 0
          || !
#line 1927 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 213; /* *adduha3_clobber */

    case E_SImode:
      x2 = XVECEXP (x1, 0, 0);
      x3 = XEXP (x2, 1);
      if (pattern108 (x3, 
E_SImode) != 0
          || !
#line 1958 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 219; /* *addsi3 */

    case E_SQmode:
      x2 = XVECEXP (x1, 0, 0);
      x3 = XEXP (x2, 1);
      if (pattern108 (x3, 
E_SQmode) != 0
          || !
#line 1958 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 220; /* *addsq3 */

    case E_USQmode:
      x2 = XVECEXP (x1, 0, 0);
      x3 = XEXP (x2, 1);
      if (pattern108 (x3, 
E_USQmode) != 0
          || !
#line 1958 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 221; /* *addusq3 */

    case E_SAmode:
      x2 = XVECEXP (x1, 0, 0);
      x3 = XEXP (x2, 1);
      if (pattern108 (x3, 
E_SAmode) != 0
          || !
#line 1958 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 222; /* *addsa3 */

    case E_USAmode:
      x2 = XVECEXP (x1, 0, 0);
      x3 = XEXP (x2, 1);
      if (pattern108 (x3, 
E_USAmode) != 0
          || !
#line 1958 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 223; /* *addusa3 */

    case E_PSImode:
      x2 = XVECEXP (x1, 0, 0);
      x3 = XEXP (x2, 1);
      if (pattern108 (x3, 
E_PSImode) != 0
          || !
#line 2068 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 271; /* *addpsi3 */

    default:
      return -1;
    }
}

 int
recog_87 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32, x33;
  rtx x34, x35, x36, x37, x38, x39, x40, x41;
  rtx x42, x43, x44, x45, x46, x47, x48, x49;
  rtx x50, x51, x52;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  switch (GET_CODE (x2))
    {
    case SET:
      x3 = XEXP (x2, 1);
      switch (GET_CODE (x3))
        {
        case CONST_INT:
          if (XWINT (x3, 0) != 0L)
            return -1;
          x4 = XEXP (x2, 0);
          if (GET_CODE (x4) != MEM
              || GET_MODE (x4) != E_BLKmode)
            return -1;
          x5 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x5) != USE)
            return -1;
          x6 = XVECEXP (x1, 0, 2);
          if (GET_CODE (x6) != USE)
            return -1;
          x7 = XVECEXP (x1, 0, 3);
          if (GET_CODE (x7) != CLOBBER)
            return -1;
          x8 = XVECEXP (x1, 0, 4);
          if (GET_CODE (x8) != CLOBBER)
            return -1;
          switch (pattern291 (x1))
            {
            case 0:
              return 168; /* *clrmemqi_split */

            case 1:
              return 170; /* *clrmemhi_split */

            default:
              return -1;
            }

        case MULT:
          x9 = XEXP (x3, 0);
          if (GET_CODE (x9) != REG
              || pattern150 (x2) != 0
              || pattern106 (x1) != 0)
            return -1;
          x7 = XVECEXP (x1, 0, 3);
          if (GET_CODE (x7) != CLOBBER)
            return -1;
          x10 = XEXP (x7, 0);
          if (GET_CODE (x10) != REG
              || GET_MODE (x10) != E_HImode)
            return -1;
          x8 = XVECEXP (x1, 0, 4);
          if (pattern176 (x8) != 0)
            return -1;
          switch (pattern364 (x1))
            {
            case 0:
              if (!
#line 3766 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! AVR_HAVE_MUL
   && ! AVR_TINY
   && reload_completed))
                return -1;
              return 567; /* *mulsi3_call_pr118012 */

            case 1:
              if (!
#line 4272 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
                return -1;
              return 605; /* *mulpsi3.libgcc */

            default:
              return -1;
            }

        case DIV:
          switch (pattern118 (x1, 
MOD))
            {
            case 0:
              x11 = XEXP (x3, 1);
              if (REGNO (x11) != 22)
                return -1;
              x5 = XVECEXP (x1, 0, 1);
              x12 = XEXP (x5, 1);
              x13 = XEXP (x12, 0);
              if (REGNO (x13) != 24)
                return -1;
              x14 = XEXP (x12, 1);
              if (REGNO (x14) != 22)
                return -1;
              x8 = XVECEXP (x1, 0, 4);
              x15 = XEXP (x8, 0);
              if (REGNO (x15) != 36
                  || GET_MODE (x15) != E_CCmode)
                return -1;
              switch (pattern377 (x1))
                {
                case 0:
                  if (!
#line 3940 "../../gcc/config/avr/avr.md"
(reload_completed))
                    return -1;
                  return 586; /* *divmodqi4_call */

                case 1:
                  if (!
#line 4028 "../../gcc/config/avr/avr.md"
(reload_completed))
                    return -1;
                  return 592; /* *divmodhi4_call */

                default:
                  return -1;
                }

            case 1:
              switch (pattern371 (x1))
                {
                case 0:
                  return 607; /* *divmodpsi4_call_split */

                case 1:
                  if (!
#line 4426 "../../gcc/config/avr/avr.md"
(reload_completed))
                    return -1;
                  return 614; /* *divmodsi4_call */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case UDIV:
          switch (pattern118 (x1, 
UMOD))
            {
            case 0:
              if (pattern365 (x1, 
E_HImode, 
22, 
24) != 0)
                return -1;
              x5 = XVECEXP (x1, 0, 1);
              x16 = XEXP (x5, 0);
              if (REGNO (x16) != 24
                  || GET_MODE (x16) != E_HImode)
                return -1;
              x6 = XVECEXP (x1, 0, 2);
              x17 = XEXP (x6, 0);
              if (REGNO (x17) != 26
                  || GET_MODE (x17) != E_HImode)
                return -1;
              x7 = XVECEXP (x1, 0, 3);
              x10 = XEXP (x7, 0);
              if (REGNO (x10) != 21
                  || GET_MODE (x10) != E_QImode)
                return -1;
              x8 = XVECEXP (x1, 0, 4);
              x15 = XEXP (x8, 0);
              if (REGNO (x15) != 36
                  || GET_MODE (x15) != E_CCmode
                  || GET_MODE (x3) != E_HImode)
                return -1;
              x12 = XEXP (x5, 1);
              if (GET_MODE (x12) != E_HImode
                  || !
#line 4075 "../../gcc/config/avr/avr.md"
(reload_completed))
                return -1;
              return 595; /* *udivmodhi4_call */

            case 1:
              switch (pattern371 (x1))
                {
                case 0:
                  return 610; /* *udivmodpsi4_call_split */

                case 1:
                  if (!
#line 4473 "../../gcc/config/avr/avr.md"
(reload_completed))
                    return -1;
                  return 617; /* *udivmodsi4_call */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case UNSPEC:
          if (pattern119 (x1) != 0
              || pattern177 (x1, 
CLOBBER) != 0)
            return -1;
          x7 = XVECEXP (x1, 0, 3);
          x10 = XEXP (x7, 0);
          if (x10 == const_int_rtx[MAX_SAVED_CONST_INT + 0])
            {
              x18 = XVECEXP (x3, 0, 0);
              operands[0] = x18;
              if (register_operand (operands[0], E_HImode))
                {
                  x5 = XVECEXP (x1, 0, 1);
                  x16 = XEXP (x5, 0);
                  x19 = XEXP (x16, 0);
                  operands[1] = x19;
                  x6 = XVECEXP (x1, 0, 2);
                  x17 = XEXP (x6, 0);
                  operands[2] = x17;
                  if (scratch_operand (operands[2], E_HImode)
                      && 
#line 7954 "../../gcc/config/avr/avr.md"
(!AVR_HAVE_EIJMP_EICALL && reload_completed))
                    return 975; /* *tablejump */
                }
            }
          x18 = XVECEXP (x3, 0, 0);
          if (GET_CODE (x18) != REG
              || pattern329 (x1) != 0
              || !
#line 7991 "../../gcc/config/avr/avr.md"
(AVR_HAVE_EIJMP_EICALL && reload_completed))
            return -1;
          return 977; /* *tablejump.3byte-pc */

        case SIGN_EXTEND:
        case ZERO_EXTEND:
          operands[10] = x3;
          if (!extend_operator (operands[10], E_SImode))
            return -1;
          x5 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x5) != PARALLEL
              || XVECLEN (x5, 0) != 2)
            return -1;
          x20 = XVECEXP (x5, 0, 0);
          if (GET_CODE (x20) != SET)
            return -1;
          x21 = XEXP (x20, 1);
          if (GET_CODE (x21) != PLUS
              || GET_MODE (x21) != E_SImode)
            return -1;
          x22 = XVECEXP (x5, 0, 1);
          if (GET_CODE (x22) != CLOBBER)
            return -1;
          x23 = XEXP (x22, 0);
          if (GET_CODE (x23) != SCRATCH
              || GET_MODE (x23) != E_QImode)
            return -1;
          x6 = XVECEXP (x1, 0, 2);
          if (GET_CODE (x6) != PARALLEL
              || XVECLEN (x6, 0) != 2)
            return -1;
          x24 = XVECEXP (x6, 0, 0);
          if (GET_CODE (x24) != SET)
            return -1;
          x25 = XEXP (x24, 1);
          if (GET_CODE (x25) != IF_THEN_ELSE)
            return -1;
          x26 = XEXP (x25, 0);
          if (GET_CODE (x26) != GTU)
            return -1;
          x27 = XEXP (x25, 1);
          if (GET_CODE (x27) != LABEL_REF)
            return -1;
          x28 = XEXP (x25, 2);
          if (GET_CODE (x28) != PC)
            return -1;
          x29 = XEXP (x24, 0);
          if (GET_CODE (x29) != PC)
            return -1;
          x30 = XVECEXP (x6, 0, 1);
          if (GET_CODE (x30) != CLOBBER)
            return -1;
          x31 = XEXP (x30, 0);
          if (GET_CODE (x31) != SCRATCH
              || GET_MODE (x31) != E_QImode)
            return -1;
          x7 = XVECEXP (x1, 0, 3);
          if (GET_CODE (x7) != SET)
            return -1;
          x8 = XVECEXP (x1, 0, 4);
          if (GET_CODE (x8) != PARALLEL
              || XVECLEN (x8, 0) != 4)
            return -1;
          x32 = XVECEXP (x8, 0, 0);
          if (GET_CODE (x32) != SET)
            return -1;
          x33 = XEXP (x32, 1);
          if (GET_CODE (x33) != UNSPEC
              || XVECLEN (x33, 0) != 1
              || XINT (x33, 1) != 2
              || GET_MODE (x33) != E_HImode)
            return -1;
          x34 = XEXP (x32, 0);
          if (GET_CODE (x34) != PC)
            return -1;
          x35 = XVECEXP (x8, 0, 1);
          if (GET_CODE (x35) != USE)
            return -1;
          x36 = XEXP (x35, 0);
          if (GET_CODE (x36) != LABEL_REF)
            return -1;
          x37 = XVECEXP (x8, 0, 2);
          if (GET_CODE (x37) != CLOBBER)
            return -1;
          x38 = XVECEXP (x8, 0, 3);
          if (GET_CODE (x38) != CLOBBER)
            return -1;
          x4 = XEXP (x2, 0);
          operands[0] = x4;
          if (!register_operand (operands[0], E_SImode))
            return -1;
          x9 = XEXP (x3, 0);
          operands[11] = x9;
          x39 = XEXP (x20, 0);
          operands[5] = x39;
          if (!register_operand (operands[5], E_SImode))
            return -1;
          x40 = XEXP (x21, 1);
          operands[1] = x40;
          if (!const_int_operand (operands[1], E_SImode))
            return -1;
          x41 = XEXP (x26, 1);
          operands[2] = x41;
          if (!const_int_operand (operands[2], E_SImode))
            return -1;
          x42 = XEXP (x27, 0);
          operands[4] = x42;
          x10 = XEXP (x7, 0);
          operands[7] = x10;
          if (!register_operand (operands[7], E_HImode))
            return -1;
          x43 = XEXP (x7, 1);
          operands[6] = x43;
          x44 = XEXP (x36, 0);
          operands[3] = x44;
          x45 = XEXP (x37, 0);
          operands[8] = x45;
          x46 = XEXP (x38, 0);
          operands[9] = x46;
          x47 = XEXP (x21, 0);
          if (!rtx_equal_p (x47, operands[0]))
            return -1;
          x48 = XEXP (x26, 0);
          if (!rtx_equal_p (x48, operands[5]))
            return -1;
          x49 = XVECEXP (x33, 0, 0);
          if (!rtx_equal_p (x49, operands[7]))
            return -1;
          switch (GET_MODE (operands[11]))
            {
            case E_QImode:
              if (!register_operand (operands[11], E_QImode)
                  || !
#line 8104 "../../gcc/config/avr/avr.md"
(optimize
   && avr_casei_sequence_check_operands (operands)))
                return -1;
              return 978; /* casesi_qi_sequence */

            case E_HImode:
              if (!register_operand (operands[11], E_HImode)
                  || !
#line 8104 "../../gcc/config/avr/avr.md"
(optimize
   && avr_casei_sequence_check_operands (operands)))
                return -1;
              return 979; /* casesi_hi_sequence */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case UNSPEC_VOLATILE:
      x5 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x5) != SET)
        return -1;
      x7 = XVECEXP (x1, 0, 3);
      if (GET_CODE (x7) != CLOBBER)
        return -1;
      x8 = XVECEXP (x1, 0, 4);
      if (GET_CODE (x8) != CLOBBER)
        return -1;
      switch (XVECLEN (x2, 0))
        {
        case 1:
          if (pattern175 (x1) != 0
              || pattern188 (x1, 
E_CCmode, 
36, 
30) != 0)
            return -1;
          x12 = XEXP (x5, 1);
          x14 = XEXP (x12, 1);
          operands[0] = x14;
          if (!immediate_operand (operands[0], E_HImode))
            return -1;
          x6 = XVECEXP (x1, 0, 2);
          x50 = XEXP (x6, 1);
          x51 = XEXP (x50, 1);
          if (!rtx_equal_p (x51, operands[0]))
            return -1;
          return 997; /* epilogue_restores */

        case 2:
          if (XINT (x2, 1) != 10)
            return -1;
          x52 = XVECEXP (x2, 0, 1);
          if (x52 != const_int_rtx[MAX_SAVED_CONST_INT + 3]
              || pattern251 (x1) != 0)
            return -1;
          return 1007; /* delay_cycles_3 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 rtx_insn *
split_8 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  switch (pattern23 (x1))
    {
    case 0:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(UQQmode != QQmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1411 (insn, operands);

    case 1:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(HQmode != QQmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1412 (insn, operands);

    case 2:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(UHQmode != QQmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1413 (insn, operands);

    case 3:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(HAmode != QQmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1414 (insn, operands);

    case 4:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(UHAmode != QQmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1415 (insn, operands);

    case 5:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(SQmode != QQmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1416 (insn, operands);

    case 6:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(USQmode != QQmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1417 (insn, operands);

    case 7:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(SAmode != QQmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1418 (insn, operands);

    case 8:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(USAmode != QQmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1419 (insn, operands);

    case 9:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(DQmode != QQmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1420 (insn, operands);

    case 10:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(UDQmode != QQmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1421 (insn, operands);

    case 11:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(DAmode != QQmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1422 (insn, operands);

    case 12:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(UDAmode != QQmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1423 (insn, operands);

    case 13:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(TAmode != QQmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1424 (insn, operands);

    case 14:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(UTAmode != QQmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1425 (insn, operands);

    case 15:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(QImode != QQmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1426 (insn, operands);

    case 16:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(HImode != QQmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1427 (insn, operands);

    case 17:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(SImode != QQmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1428 (insn, operands);

    case 18:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(DImode != QQmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1429 (insn, operands);

    case 19:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(QQmode != UQQmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1430 (insn, operands);

    case 20:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(HQmode != UQQmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1431 (insn, operands);

    case 21:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(UHQmode != UQQmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1432 (insn, operands);

    case 22:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(HAmode != UQQmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1433 (insn, operands);

    case 23:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(UHAmode != UQQmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1434 (insn, operands);

    case 24:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(SQmode != UQQmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1435 (insn, operands);

    case 25:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(USQmode != UQQmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1436 (insn, operands);

    case 26:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(SAmode != UQQmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1437 (insn, operands);

    case 27:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(USAmode != UQQmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1438 (insn, operands);

    case 28:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(DQmode != UQQmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1439 (insn, operands);

    case 29:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(UDQmode != UQQmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1440 (insn, operands);

    case 30:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(DAmode != UQQmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1441 (insn, operands);

    case 31:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(UDAmode != UQQmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1442 (insn, operands);

    case 32:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(TAmode != UQQmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1443 (insn, operands);

    case 33:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(UTAmode != UQQmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1444 (insn, operands);

    case 34:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(QImode != UQQmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1445 (insn, operands);

    case 35:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(HImode != UQQmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1446 (insn, operands);

    case 36:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(SImode != UQQmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1447 (insn, operands);

    case 37:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(DImode != UQQmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1448 (insn, operands);

    case 38:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(QQmode != HQmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1449 (insn, operands);

    case 39:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(UQQmode != HQmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1450 (insn, operands);

    case 40:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(UHQmode != HQmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1451 (insn, operands);

    case 41:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(HAmode != HQmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1452 (insn, operands);

    case 42:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(UHAmode != HQmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1453 (insn, operands);

    case 43:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(SQmode != HQmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1454 (insn, operands);

    case 44:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(USQmode != HQmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1455 (insn, operands);

    case 45:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(SAmode != HQmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1456 (insn, operands);

    case 46:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(USAmode != HQmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1457 (insn, operands);

    case 47:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(DQmode != HQmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1458 (insn, operands);

    case 48:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(UDQmode != HQmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1459 (insn, operands);

    case 49:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(DAmode != HQmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1460 (insn, operands);

    case 50:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(UDAmode != HQmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1461 (insn, operands);

    case 51:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(TAmode != HQmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1462 (insn, operands);

    case 52:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(UTAmode != HQmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1463 (insn, operands);

    case 53:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(QImode != HQmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1464 (insn, operands);

    case 54:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(HImode != HQmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1465 (insn, operands);

    case 55:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(SImode != HQmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1466 (insn, operands);

    case 56:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(DImode != HQmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1467 (insn, operands);

    case 57:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(QQmode != UHQmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1468 (insn, operands);

    case 58:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(UQQmode != UHQmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1469 (insn, operands);

    case 59:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(HQmode != UHQmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1470 (insn, operands);

    case 60:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(HAmode != UHQmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1471 (insn, operands);

    case 61:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(UHAmode != UHQmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1472 (insn, operands);

    case 62:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(SQmode != UHQmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1473 (insn, operands);

    case 63:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(USQmode != UHQmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1474 (insn, operands);

    case 64:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(SAmode != UHQmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1475 (insn, operands);

    case 65:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(USAmode != UHQmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1476 (insn, operands);

    case 66:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(DQmode != UHQmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1477 (insn, operands);

    case 67:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(UDQmode != UHQmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1478 (insn, operands);

    case 68:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(DAmode != UHQmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1479 (insn, operands);

    case 69:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(UDAmode != UHQmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1480 (insn, operands);

    case 70:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(TAmode != UHQmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1481 (insn, operands);

    case 71:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(UTAmode != UHQmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1482 (insn, operands);

    case 72:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(QImode != UHQmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1483 (insn, operands);

    case 73:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(HImode != UHQmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1484 (insn, operands);

    case 74:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(SImode != UHQmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1485 (insn, operands);

    case 75:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(DImode != UHQmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1486 (insn, operands);

    case 76:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(QQmode != HAmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1487 (insn, operands);

    case 77:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(UQQmode != HAmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1488 (insn, operands);

    case 78:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(HQmode != HAmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1489 (insn, operands);

    case 79:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(UHQmode != HAmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1490 (insn, operands);

    case 80:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(UHAmode != HAmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1491 (insn, operands);

    case 81:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(SQmode != HAmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1492 (insn, operands);

    case 82:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(USQmode != HAmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1493 (insn, operands);

    case 83:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(SAmode != HAmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1494 (insn, operands);

    case 84:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(USAmode != HAmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1495 (insn, operands);

    case 85:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(DQmode != HAmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1496 (insn, operands);

    case 86:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(UDQmode != HAmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1497 (insn, operands);

    case 87:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(DAmode != HAmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1498 (insn, operands);

    case 88:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(UDAmode != HAmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1499 (insn, operands);

    case 89:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(TAmode != HAmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1500 (insn, operands);

    case 90:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(UTAmode != HAmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1501 (insn, operands);

    case 91:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(QImode != HAmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1502 (insn, operands);

    case 92:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(HImode != HAmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1503 (insn, operands);

    case 93:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(SImode != HAmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1504 (insn, operands);

    case 94:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(DImode != HAmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1505 (insn, operands);

    case 95:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(QQmode != UHAmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1506 (insn, operands);

    case 96:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(UQQmode != UHAmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1507 (insn, operands);

    case 97:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(HQmode != UHAmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1508 (insn, operands);

    case 98:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(UHQmode != UHAmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1509 (insn, operands);

    case 99:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(HAmode != UHAmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1510 (insn, operands);

    case 100:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(SQmode != UHAmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1511 (insn, operands);

    case 101:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(USQmode != UHAmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1512 (insn, operands);

    case 102:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(SAmode != UHAmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1513 (insn, operands);

    case 103:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(USAmode != UHAmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1514 (insn, operands);

    case 104:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(DQmode != UHAmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1515 (insn, operands);

    case 105:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(UDQmode != UHAmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1516 (insn, operands);

    case 106:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(DAmode != UHAmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1517 (insn, operands);

    case 107:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(UDAmode != UHAmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1518 (insn, operands);

    case 108:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(TAmode != UHAmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1519 (insn, operands);

    case 109:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(UTAmode != UHAmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1520 (insn, operands);

    case 110:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(QImode != UHAmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1521 (insn, operands);

    case 111:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(HImode != UHAmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1522 (insn, operands);

    case 112:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(SImode != UHAmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1523 (insn, operands);

    case 113:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(DImode != UHAmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1524 (insn, operands);

    case 114:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(QQmode != SQmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1525 (insn, operands);

    case 115:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(UQQmode != SQmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1526 (insn, operands);

    case 116:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(HQmode != SQmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1527 (insn, operands);

    case 117:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(UHQmode != SQmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1528 (insn, operands);

    case 118:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(HAmode != SQmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1529 (insn, operands);

    case 119:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(UHAmode != SQmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1530 (insn, operands);

    case 120:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(USQmode != SQmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1531 (insn, operands);

    case 121:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(SAmode != SQmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1532 (insn, operands);

    case 122:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(USAmode != SQmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1533 (insn, operands);

    case 123:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(DQmode != SQmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1534 (insn, operands);

    case 124:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(UDQmode != SQmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1535 (insn, operands);

    case 125:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(DAmode != SQmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1536 (insn, operands);

    case 126:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(UDAmode != SQmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1537 (insn, operands);

    case 127:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(TAmode != SQmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1538 (insn, operands);

    case 128:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(UTAmode != SQmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1539 (insn, operands);

    case 129:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(QImode != SQmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1540 (insn, operands);

    case 130:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(HImode != SQmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1541 (insn, operands);

    case 131:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(SImode != SQmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1542 (insn, operands);

    case 132:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(DImode != SQmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1543 (insn, operands);

    case 133:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(QQmode != USQmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1544 (insn, operands);

    case 134:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(UQQmode != USQmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1545 (insn, operands);

    case 135:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(HQmode != USQmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1546 (insn, operands);

    case 136:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(UHQmode != USQmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1547 (insn, operands);

    case 137:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(HAmode != USQmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1548 (insn, operands);

    case 138:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(UHAmode != USQmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1549 (insn, operands);

    case 139:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(SQmode != USQmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1550 (insn, operands);

    case 140:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(SAmode != USQmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1551 (insn, operands);

    case 141:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(USAmode != USQmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1552 (insn, operands);

    case 142:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(DQmode != USQmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1553 (insn, operands);

    case 143:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(UDQmode != USQmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1554 (insn, operands);

    case 144:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(DAmode != USQmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1555 (insn, operands);

    case 145:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(UDAmode != USQmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1556 (insn, operands);

    case 146:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(TAmode != USQmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1557 (insn, operands);

    case 147:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(UTAmode != USQmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1558 (insn, operands);

    case 148:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(QImode != USQmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1559 (insn, operands);

    case 149:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(HImode != USQmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1560 (insn, operands);

    case 150:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(SImode != USQmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1561 (insn, operands);

    case 151:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(DImode != USQmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1562 (insn, operands);

    case 152:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(QQmode != SAmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1563 (insn, operands);

    case 153:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(UQQmode != SAmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1564 (insn, operands);

    case 154:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(HQmode != SAmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1565 (insn, operands);

    case 155:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(UHQmode != SAmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1566 (insn, operands);

    case 156:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(HAmode != SAmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1567 (insn, operands);

    case 157:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(UHAmode != SAmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1568 (insn, operands);

    case 158:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(SQmode != SAmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1569 (insn, operands);

    case 159:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(USQmode != SAmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1570 (insn, operands);

    case 160:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(USAmode != SAmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1571 (insn, operands);

    case 161:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(DQmode != SAmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1572 (insn, operands);

    case 162:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(UDQmode != SAmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1573 (insn, operands);

    case 163:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(DAmode != SAmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1574 (insn, operands);

    case 164:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(UDAmode != SAmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1575 (insn, operands);

    case 165:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(TAmode != SAmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1576 (insn, operands);

    case 166:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(UTAmode != SAmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1577 (insn, operands);

    case 167:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(QImode != SAmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1578 (insn, operands);

    case 168:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(HImode != SAmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1579 (insn, operands);

    case 169:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(SImode != SAmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1580 (insn, operands);

    case 170:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(DImode != SAmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1581 (insn, operands);

    case 171:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(QQmode != USAmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1582 (insn, operands);

    case 172:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(UQQmode != USAmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1583 (insn, operands);

    case 173:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(HQmode != USAmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1584 (insn, operands);

    case 174:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(UHQmode != USAmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1585 (insn, operands);

    case 175:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(HAmode != USAmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1586 (insn, operands);

    case 176:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(UHAmode != USAmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1587 (insn, operands);

    case 177:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(SQmode != USAmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1588 (insn, operands);

    case 178:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(USQmode != USAmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1589 (insn, operands);

    case 179:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(SAmode != USAmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1590 (insn, operands);

    case 180:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(DQmode != USAmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1591 (insn, operands);

    case 181:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(UDQmode != USAmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1592 (insn, operands);

    case 182:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(DAmode != USAmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1593 (insn, operands);

    case 183:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(UDAmode != USAmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1594 (insn, operands);

    case 184:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(TAmode != USAmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1595 (insn, operands);

    case 185:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(UTAmode != USAmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1596 (insn, operands);

    case 186:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(QImode != USAmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1597 (insn, operands);

    case 187:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(HImode != USAmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1598 (insn, operands);

    case 188:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(SImode != USAmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1599 (insn, operands);

    case 189:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(DImode != USAmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1600 (insn, operands);

    case 190:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(QQmode != DQmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1601 (insn, operands);

    case 191:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(UQQmode != DQmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1602 (insn, operands);

    case 192:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(HQmode != DQmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1603 (insn, operands);

    case 193:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(UHQmode != DQmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1604 (insn, operands);

    case 194:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(HAmode != DQmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1605 (insn, operands);

    case 195:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(UHAmode != DQmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1606 (insn, operands);

    case 196:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(SQmode != DQmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1607 (insn, operands);

    case 197:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(USQmode != DQmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1608 (insn, operands);

    case 198:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(SAmode != DQmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1609 (insn, operands);

    case 199:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(USAmode != DQmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1610 (insn, operands);

    case 200:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(UDQmode != DQmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1611 (insn, operands);

    case 201:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(DAmode != DQmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1612 (insn, operands);

    case 202:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(UDAmode != DQmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1613 (insn, operands);

    case 203:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(TAmode != DQmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1614 (insn, operands);

    case 204:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(UTAmode != DQmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1615 (insn, operands);

    case 205:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(QImode != DQmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1616 (insn, operands);

    case 206:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(HImode != DQmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1617 (insn, operands);

    case 207:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(SImode != DQmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1618 (insn, operands);

    case 208:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(DImode != DQmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1619 (insn, operands);

    case 209:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(QQmode != UDQmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1620 (insn, operands);

    case 210:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(UQQmode != UDQmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1621 (insn, operands);

    case 211:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(HQmode != UDQmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1622 (insn, operands);

    case 212:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(UHQmode != UDQmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1623 (insn, operands);

    case 213:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(HAmode != UDQmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1624 (insn, operands);

    case 214:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(UHAmode != UDQmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1625 (insn, operands);

    case 215:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(SQmode != UDQmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1626 (insn, operands);

    case 216:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(USQmode != UDQmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1627 (insn, operands);

    case 217:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(SAmode != UDQmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1628 (insn, operands);

    case 218:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(USAmode != UDQmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1629 (insn, operands);

    case 219:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(DQmode != UDQmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1630 (insn, operands);

    case 220:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(DAmode != UDQmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1631 (insn, operands);

    case 221:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(UDAmode != UDQmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1632 (insn, operands);

    case 222:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(TAmode != UDQmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1633 (insn, operands);

    case 223:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(UTAmode != UDQmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1634 (insn, operands);

    case 224:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(QImode != UDQmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1635 (insn, operands);

    case 225:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(HImode != UDQmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1636 (insn, operands);

    case 226:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(SImode != UDQmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1637 (insn, operands);

    case 227:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(DImode != UDQmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1638 (insn, operands);

    case 228:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(QQmode != DAmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1639 (insn, operands);

    case 229:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(UQQmode != DAmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1640 (insn, operands);

    case 230:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(HQmode != DAmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1641 (insn, operands);

    case 231:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(UHQmode != DAmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1642 (insn, operands);

    case 232:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(HAmode != DAmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1643 (insn, operands);

    case 233:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(UHAmode != DAmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1644 (insn, operands);

    case 234:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(SQmode != DAmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1645 (insn, operands);

    case 235:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(USQmode != DAmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1646 (insn, operands);

    case 236:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(SAmode != DAmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1647 (insn, operands);

    case 237:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(USAmode != DAmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1648 (insn, operands);

    case 238:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(DQmode != DAmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1649 (insn, operands);

    case 239:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(UDQmode != DAmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1650 (insn, operands);

    case 240:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(UDAmode != DAmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1651 (insn, operands);

    case 241:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(TAmode != DAmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1652 (insn, operands);

    case 242:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(UTAmode != DAmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1653 (insn, operands);

    case 243:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(QImode != DAmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1654 (insn, operands);

    case 244:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(HImode != DAmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1655 (insn, operands);

    case 245:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(SImode != DAmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1656 (insn, operands);

    case 246:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(DImode != DAmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1657 (insn, operands);

    case 247:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(QQmode != UDAmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1658 (insn, operands);

    case 248:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(UQQmode != UDAmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1659 (insn, operands);

    case 249:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(HQmode != UDAmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1660 (insn, operands);

    case 250:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(UHQmode != UDAmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1661 (insn, operands);

    case 251:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(HAmode != UDAmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1662 (insn, operands);

    case 252:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(UHAmode != UDAmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1663 (insn, operands);

    case 253:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(SQmode != UDAmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1664 (insn, operands);

    case 254:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(USQmode != UDAmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1665 (insn, operands);

    case 255:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(SAmode != UDAmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1666 (insn, operands);

    case 256:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(USAmode != UDAmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1667 (insn, operands);

    case 257:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(DQmode != UDAmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1668 (insn, operands);

    case 258:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(UDQmode != UDAmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1669 (insn, operands);

    case 259:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(DAmode != UDAmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1670 (insn, operands);

    case 260:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(TAmode != UDAmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1671 (insn, operands);

    case 261:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(UTAmode != UDAmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1672 (insn, operands);

    case 262:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(QImode != UDAmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1673 (insn, operands);

    case 263:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(HImode != UDAmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1674 (insn, operands);

    case 264:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(SImode != UDAmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1675 (insn, operands);

    case 265:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(DImode != UDAmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1676 (insn, operands);

    case 266:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(QQmode != TAmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1677 (insn, operands);

    case 267:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(UQQmode != TAmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1678 (insn, operands);

    case 268:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(HQmode != TAmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1679 (insn, operands);

    case 269:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(UHQmode != TAmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1680 (insn, operands);

    case 270:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(HAmode != TAmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1681 (insn, operands);

    case 271:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(UHAmode != TAmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1682 (insn, operands);

    case 272:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(SQmode != TAmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1683 (insn, operands);

    case 273:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(USQmode != TAmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1684 (insn, operands);

    case 274:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(SAmode != TAmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1685 (insn, operands);

    case 275:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(USAmode != TAmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1686 (insn, operands);

    case 276:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(DQmode != TAmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1687 (insn, operands);

    case 277:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(UDQmode != TAmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1688 (insn, operands);

    case 278:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(DAmode != TAmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1689 (insn, operands);

    case 279:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(UDAmode != TAmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1690 (insn, operands);

    case 280:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(UTAmode != TAmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1691 (insn, operands);

    case 281:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(QImode != TAmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1692 (insn, operands);

    case 282:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(HImode != TAmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1693 (insn, operands);

    case 283:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(SImode != TAmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1694 (insn, operands);

    case 284:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(DImode != TAmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1695 (insn, operands);

    case 285:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(QQmode != UTAmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1696 (insn, operands);

    case 286:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(UQQmode != UTAmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1697 (insn, operands);

    case 287:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(HQmode != UTAmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1698 (insn, operands);

    case 288:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(UHQmode != UTAmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1699 (insn, operands);

    case 289:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(HAmode != UTAmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1700 (insn, operands);

    case 290:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(UHAmode != UTAmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1701 (insn, operands);

    case 291:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(SQmode != UTAmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1702 (insn, operands);

    case 292:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(USQmode != UTAmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1703 (insn, operands);

    case 293:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(SAmode != UTAmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1704 (insn, operands);

    case 294:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(USAmode != UTAmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1705 (insn, operands);

    case 295:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(DQmode != UTAmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1706 (insn, operands);

    case 296:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(UDQmode != UTAmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1707 (insn, operands);

    case 297:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(DAmode != UTAmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1708 (insn, operands);

    case 298:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(UDAmode != UTAmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1709 (insn, operands);

    case 299:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(TAmode != UTAmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1710 (insn, operands);

    case 300:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(QImode != UTAmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1711 (insn, operands);

    case 301:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(HImode != UTAmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1712 (insn, operands);

    case 302:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(SImode != UTAmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1713 (insn, operands);

    case 303:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(DImode != UTAmode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1714 (insn, operands);

    case 304:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(QQmode != QImode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1715 (insn, operands);

    case 305:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(UQQmode != QImode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1716 (insn, operands);

    case 306:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(HQmode != QImode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1717 (insn, operands);

    case 307:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(UHQmode != QImode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1718 (insn, operands);

    case 308:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(HAmode != QImode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1719 (insn, operands);

    case 309:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(UHAmode != QImode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1720 (insn, operands);

    case 310:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(SQmode != QImode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1721 (insn, operands);

    case 311:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(USQmode != QImode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1722 (insn, operands);

    case 312:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(SAmode != QImode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1723 (insn, operands);

    case 313:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(USAmode != QImode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1724 (insn, operands);

    case 314:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(DQmode != QImode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1725 (insn, operands);

    case 315:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(UDQmode != QImode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1726 (insn, operands);

    case 316:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(DAmode != QImode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1727 (insn, operands);

    case 317:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(UDAmode != QImode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1728 (insn, operands);

    case 318:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(TAmode != QImode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1729 (insn, operands);

    case 319:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(UTAmode != QImode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1730 (insn, operands);

    case 320:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(HImode != QImode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1731 (insn, operands);

    case 321:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(SImode != QImode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1732 (insn, operands);

    case 322:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(DImode != QImode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1733 (insn, operands);

    case 323:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(QQmode != HImode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1734 (insn, operands);

    case 324:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(UQQmode != HImode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1735 (insn, operands);

    case 325:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(HQmode != HImode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1736 (insn, operands);

    case 326:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(UHQmode != HImode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1737 (insn, operands);

    case 327:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(HAmode != HImode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1738 (insn, operands);

    case 328:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(UHAmode != HImode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1739 (insn, operands);

    case 329:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(SQmode != HImode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1740 (insn, operands);

    case 330:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(USQmode != HImode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1741 (insn, operands);

    case 331:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(SAmode != HImode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1742 (insn, operands);

    case 332:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(USAmode != HImode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1743 (insn, operands);

    case 333:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(DQmode != HImode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1744 (insn, operands);

    case 334:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(UDQmode != HImode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1745 (insn, operands);

    case 335:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(DAmode != HImode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1746 (insn, operands);

    case 336:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(UDAmode != HImode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1747 (insn, operands);

    case 337:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(TAmode != HImode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1748 (insn, operands);

    case 338:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(UTAmode != HImode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1749 (insn, operands);

    case 339:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(QImode != HImode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1750 (insn, operands);

    case 340:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(SImode != HImode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1751 (insn, operands);

    case 341:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(DImode != HImode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1752 (insn, operands);

    case 342:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(QQmode != SImode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1753 (insn, operands);

    case 343:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(UQQmode != SImode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1754 (insn, operands);

    case 344:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(HQmode != SImode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1755 (insn, operands);

    case 345:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(UHQmode != SImode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1756 (insn, operands);

    case 346:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(HAmode != SImode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1757 (insn, operands);

    case 347:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(UHAmode != SImode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1758 (insn, operands);

    case 348:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(SQmode != SImode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1759 (insn, operands);

    case 349:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(USQmode != SImode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1760 (insn, operands);

    case 350:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(SAmode != SImode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1761 (insn, operands);

    case 351:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(USAmode != SImode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1762 (insn, operands);

    case 352:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(DQmode != SImode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1763 (insn, operands);

    case 353:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(UDQmode != SImode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1764 (insn, operands);

    case 354:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(DAmode != SImode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1765 (insn, operands);

    case 355:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(UDAmode != SImode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1766 (insn, operands);

    case 356:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(TAmode != SImode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1767 (insn, operands);

    case 357:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(UTAmode != SImode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1768 (insn, operands);

    case 358:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(QImode != SImode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1769 (insn, operands);

    case 359:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(HImode != SImode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1770 (insn, operands);

    case 360:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(DImode != SImode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1771 (insn, operands);

    case 361:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(QQmode != DImode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1772 (insn, operands);

    case 362:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(UQQmode != DImode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1773 (insn, operands);

    case 363:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(HQmode != DImode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1774 (insn, operands);

    case 364:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(UHQmode != DImode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1775 (insn, operands);

    case 365:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(HAmode != DImode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1776 (insn, operands);

    case 366:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(UHAmode != DImode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1777 (insn, operands);

    case 367:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(SQmode != DImode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1778 (insn, operands);

    case 368:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(USQmode != DImode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1779 (insn, operands);

    case 369:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(SAmode != DImode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1780 (insn, operands);

    case 370:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(USAmode != DImode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1781 (insn, operands);

    case 371:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(DQmode != DImode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1782 (insn, operands);

    case 372:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(UDQmode != DImode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1783 (insn, operands);

    case 373:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(DAmode != DImode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1784 (insn, operands);

    case 374:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(UDAmode != DImode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1785 (insn, operands);

    case 375:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(TAmode != DImode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1786 (insn, operands);

    case 376:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(UTAmode != DImode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1787 (insn, operands);

    case 377:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(QImode != DImode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1788 (insn, operands);

    case 378:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(HImode != DImode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1789 (insn, operands);

    case 379:
      if (!(
#line 86 "../../gcc/config/avr/avr-fixed.md"
(SImode != DImode) && 
#line 88 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1790 (insn, operands);

    default:
      return NULL;
    }
}
