/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern3 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  operands[2] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x1) != E_HImode)
        return -1;
      x3 = XEXP (x1, 0);
      if (GET_MODE (x3) != E_HImode
          || !register_operand (operands[1], E_QImode)
          || !register_operand (operands[2], E_HImode))
        return -1;
      return 0;

    case E_PSImode:
      if (!register_operand (operands[0], E_PSImode)
          || GET_MODE (x1) != E_PSImode)
        return -1;
      x3 = XEXP (x1, 0);
      if (GET_MODE (x3) != E_PSImode
          || !register_operand (operands[2], E_PSImode))
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 1;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 2;

        default:
          return -1;
        }

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode)
        return -1;
      x3 = XEXP (x1, 0);
      if (GET_MODE (x3) != E_SImode
          || !register_operand (operands[2], E_SImode))
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 3;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 4;

        case E_PSImode:
          if (!register_operand (operands[1], E_PSImode))
            return -1;
          return 5;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern25 (rtx x1, unsigned int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (REGNO (x2) != i1)
    return -1;
  switch (GET_MODE (x2))
    {
    case E_SAmode:
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_SAmode)
        return -1;
      x4 = XEXP (x3, 0);
      if (GET_MODE (x4) != E_SAmode)
        return -1;
      x5 = XEXP (x3, 1);
      if (GET_MODE (x5) != E_SAmode)
        return -1;
      return 0;

    case E_USAmode:
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_USAmode)
        return -1;
      x4 = XEXP (x3, 0);
      if (GET_MODE (x4) != E_USAmode)
        return -1;
      x5 = XEXP (x3, 1);
      if (GET_MODE (x5) != E_USAmode)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern30 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (x1))
    {
    case E_QImode:
      if (!register_operand (operands[1], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!register_operand (operands[1], E_HImode))
        return -1;
      return 1;

    case E_PSImode:
      if (!register_operand (operands[1], E_PSImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern34 (rtx x1, machine_mode i1, unsigned int i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != i2
      || GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  return 0;
}

int
pattern38 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x1, 1);
  operands[2] = x5;
  return pattern37 (x1); /* [-1, 5] */
}

int
pattern42 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_QImode)
    return -1;
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x5 = XEXP (x1, 0);
  operands[0] = x5;
  return pattern41 (x2); /* [-1, 1] */
}

int
pattern45 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern51 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_QImode)
    return -1;
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x5 = XEXP (x1, 0);
  operands[0] = x5;
  if (!register_operand (operands[0], E_HImode)
      || GET_MODE (x2) != E_HImode)
    return -1;
  x6 = XEXP (x3, 0);
  operands[1] = x6;
  x7 = XEXP (x3, 2);
  operands[2] = x7;
  switch (GET_MODE (operands[1]))
    {
    case E_QImode:
      if (!register_operand (operands[1], E_QImode)
          || !const_0_to_7_operand (operands[2], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!register_operand (operands[1], E_HImode)
          || !const_0_to_15_operand (operands[2], E_QImode))
        return -1;
      return 1;

    case E_PSImode:
      if (!register_operand (operands[1], E_PSImode)
          || !const_0_to_23_operand (operands[2], E_QImode))
        return -1;
      return 2;

    case E_SImode:
      if (!register_operand (operands[1], E_SImode)
          || !const_0_to_31_operand (operands[2], E_QImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern60 (rtx x1, unsigned int i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != i1
      || GET_MODE (x3) != i2)
    return -1;
  x4 = XEXP (x1, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != i1
      || GET_MODE (x4) != i2)
    return -1;
  return 0;
}

int
pattern66 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != REG)
    return -1;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (REGNO (x4))
    {
    case 24:
      if (REGNO (x2) != 24)
        return -1;
      switch (GET_MODE (x2))
        {
        case E_HQmode:
          if (GET_MODE (x3) != E_HQmode
              || GET_MODE (x4) != E_HQmode)
            return -1;
          return 0;

        case E_HAmode:
          if (GET_MODE (x3) != E_HAmode
              || GET_MODE (x4) != E_HAmode)
            return -1;
          return 1;

        default:
          return -1;
        }

    case 22:
      if (REGNO (x2) != 22)
        return -1;
      switch (GET_MODE (x2))
        {
        case E_SAmode:
          if (GET_MODE (x3) != E_SAmode
              || GET_MODE (x4) != E_SAmode)
            return -1;
          return 2;

        case E_SQmode:
          if (GET_MODE (x3) != E_SQmode
              || GET_MODE (x4) != E_SQmode)
            return -1;
          return 3;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern74 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != AND
      || GET_MODE (x3) != E_QImode)
    return -1;
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 7])
    return -1;
  x5 = XEXP (x1, 0);
  operands[0] = x5;
  if (!register_operand (operands[0], E_QImode)
      || GET_MODE (x2) != E_QImode)
    return -1;
  x6 = XEXP (x3, 0);
  operands[1] = x6;
  if (!register_operand (operands[1], E_QImode))
    return -1;
  return 0;
}

int
pattern77 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 1);
  operands[2] = x3;
  x4 = XEXP (x1, 1);
  operands[3] = x4;
  x5 = XEXP (x2, 0);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
      operands[1] = x5;
      switch (GET_CODE (operands[3]))
        {
        case CONST_INT:
          return pattern76 (x1); /* [-1, 3] */

        case REG:
        case SUBREG:
          if (!register_operand (operands[3], E_QImode)
              || !register_operand (operands[0], E_QImode)
              || GET_MODE (x1) != E_QImode
              || GET_MODE (x2) != E_QImode
              || !register_operand (operands[1], E_QImode)
              || !const_0_to_7_operand (operands[2], E_QImode))
            return -1;
          return 4;

        default:
          return -1;
        }

    case XOR:
      if (GET_MODE (x5) != E_QImode
          || !register_operand (operands[0], E_QImode)
          || GET_MODE (x1) != E_QImode
          || GET_MODE (x2) != E_QImode)
        return -1;
      x6 = XEXP (x5, 0);
      operands[1] = x6;
      if (!register_operand (operands[1], E_QImode))
        return -1;
      x7 = XEXP (x5, 1);
      operands[4] = x7;
      if (!const_int_operand (operands[4], E_QImode)
          || !const_0_to_7_operand (operands[2], E_QImode)
          || !register_operand (operands[3], E_QImode))
        return -1;
      return 5;

    default:
      return -1;
    }
}

int
pattern90 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != LABEL_REF)
    return -1;
  x4 = XEXP (x2, 2);
  if (GET_CODE (x4) != PC)
    return -1;
  x5 = XEXP (x1, 0);
  if (GET_CODE (x5) != PC)
    return -1;
  x6 = XEXP (x2, 0);
  x7 = XEXP (x6, 0);
  switch (GET_CODE (x7))
    {
    case REG:
    case SUBREG:
      return 0;

    case SIGN_EXTEND:
      return 1;

    case ZERO_EXTEND:
      return 2;

    default:
      return -1;
    }
}

int
pattern93 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_QImode
      || GET_MODE (x2) != E_QImode)
    return -1;
  x4 = XEXP (x2, 2);
  operands[3] = x4;
  if (!const_0_to_7_operand (operands[3], E_QImode))
    return -1;
  x5 = XEXP (x1, 0);
  switch (GET_CODE (x5))
    {
    case ZERO_EXTRACT:
      if (GET_MODE (x5) != E_QImode)
        return -1;
      x6 = XEXP (x5, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x7 = XEXP (x5, 0);
      operands[0] = x7;
      if (!register_operand (operands[0], E_QImode))
        return -1;
      x8 = XEXP (x5, 2);
      operands[1] = x8;
      if (!const_0_to_7_operand (operands[1], E_QImode))
        return -1;
      x9 = XEXP (x3, 0);
      operands[2] = x9;
      if (!register_operand (operands[2], E_QImode))
        return -1;
      x10 = XEXP (x3, 1);
      operands[4] = x10;
      if (!const_int_operand (operands[4], E_QImode))
        return -1;
      return 0;

    case REG:
    case SUBREG:
      operands[0] = x5;
      if (!register_operand (operands[0], E_QImode))
        return -1;
      x9 = XEXP (x3, 0);
      operands[1] = x9;
      if (!reg_or_low_io_operand (operands[1], E_QImode))
        return -1;
      x10 = XEXP (x3, 1);
      operands[2] = x10;
      if (!single_one_operand (operands[2], E_QImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern109 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!scratch_operand (operands[3], E_QImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      return pattern108 (x1, 
E_HImode); /* [-1, 0] */

    case E_PSImode:
      if (pattern108 (x1, 
E_PSImode) != 0)
        return -1;
      return 1;

    case E_SImode:
      if (pattern108 (x1, 
E_SImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern118 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != REG)
    return -1;
  x5 = XEXP (x3, 1);
  if (GET_CODE (x5) != REG)
    return -1;
  x6 = XEXP (x2, 0);
  if (GET_CODE (x6) != REG)
    return -1;
  x7 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x7) != SET)
    return -1;
  x8 = XEXP (x7, 1);
  if (GET_CODE (x8) != i1)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_CODE (x9) != REG)
    return -1;
  x10 = XEXP (x8, 1);
  if (GET_CODE (x10) != REG)
    return -1;
  x11 = XEXP (x7, 0);
  if (GET_CODE (x11) != REG)
    return -1;
  x12 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x12) != CLOBBER)
    return -1;
  x13 = XEXP (x12, 0);
  if (GET_CODE (x13) != REG)
    return -1;
  x14 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x14) != CLOBBER)
    return -1;
  x15 = XEXP (x14, 0);
  if (GET_CODE (x15) != REG)
    return -1;
  x16 = XVECEXP (x1, 0, 4);
  if (GET_CODE (x16) != CLOBBER)
    return -1;
  x17 = XEXP (x16, 0);
  if (GET_CODE (x17) != REG)
    return -1;
  switch (REGNO (x4))
    {
    case 24:
      return 0;

    case 22:
      return 1;

    default:
      return -1;
    }
}

int
pattern131 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 1);
  operands[3] = x4;
  x5 = XEXP (x3, 0);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_QImode:
          if (!register_operand (operands[0], E_QImode)
              || GET_MODE (x1) != E_QImode
              || !register_operand (operands[1], E_QImode)
              || GET_MODE (x3) != E_QImode
              || !register_operand (operands[2], E_QImode)
              || !const7_operand (operands[3], E_QImode))
            return -1;
          return 0;

        case E_HImode:
          if (!register_operand (operands[0], E_HImode)
              || GET_MODE (x1) != E_HImode
              || !register_operand (operands[1], E_HImode)
              || GET_MODE (x3) != E_HImode
              || !register_operand (operands[2], E_HImode)
              || !const15_operand (operands[3], E_QImode))
            return -1;
          return 1;

        case E_PSImode:
          if (!register_operand (operands[0], E_PSImode)
              || GET_MODE (x1) != E_PSImode
              || !register_operand (operands[1], E_PSImode)
              || GET_MODE (x3) != E_PSImode
              || !register_operand (operands[2], E_PSImode)
              || !const23_operand (operands[3], E_QImode))
            return -1;
          return 2;

        case E_SImode:
          if (!register_operand (operands[0], E_SImode)
              || GET_MODE (x1) != E_SImode
              || !register_operand (operands[1], E_SImode)
              || GET_MODE (x3) != E_SImode
              || !register_operand (operands[2], E_SImode)
              || !const31_operand (operands[3], E_QImode))
            return -1;
          return 3;

        default:
          return -1;
        }

    case SIGN_EXTEND:
      x6 = XEXP (x5, 0);
      operands[2] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_HImode:
          if (!register_operand (operands[0], E_HImode)
              || GET_MODE (x1) != E_HImode
              || !register_operand (operands[1], E_HImode)
              || GET_MODE (x3) != E_HImode
              || GET_MODE (x5) != E_HImode
              || !register_operand (operands[2], E_QImode)
              || !const15_operand (operands[3], E_QImode))
            return -1;
          return 4;

        case E_PSImode:
          if (!register_operand (operands[0], E_PSImode)
              || GET_MODE (x1) != E_PSImode
              || !register_operand (operands[1], E_PSImode)
              || GET_MODE (x3) != E_PSImode
              || GET_MODE (x5) != E_PSImode
              || !const23_operand (operands[3], E_QImode))
            return -1;
          switch (GET_MODE (operands[2]))
            {
            case E_QImode:
              if (!register_operand (operands[2], E_QImode))
                return -1;
              return 5;

            case E_HImode:
              if (!register_operand (operands[2], E_HImode))
                return -1;
              return 6;

            default:
              return -1;
            }

        case E_SImode:
          if (!register_operand (operands[0], E_SImode)
              || GET_MODE (x1) != E_SImode
              || !register_operand (operands[1], E_SImode)
              || GET_MODE (x3) != E_SImode
              || GET_MODE (x5) != E_SImode
              || !const31_operand (operands[3], E_QImode))
            return -1;
          switch (GET_MODE (operands[2]))
            {
            case E_QImode:
              if (!register_operand (operands[2], E_QImode))
                return -1;
              return 7;

            case E_HImode:
              if (!register_operand (operands[2], E_HImode))
                return -1;
              return 8;

            case E_PSImode:
              if (!register_operand (operands[2], E_PSImode))
                return -1;
              return 9;

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern164 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!const_0_to_7_operand (operands[2], E_QImode))
    return -1;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  if (!register_operand (operands[0], E_QImode))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != E_QImode
      || !register_operand (operands[1], E_QImode))
    return -1;
  return 0;
}

int
pattern169 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 36
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  if (!register_operand (operands[0], i1))
    return -1;
  x6 = XEXP (x4, 1);
  if (GET_MODE (x6) != i1)
    return -1;
  return 0;
}

int
pattern172 (rtx x1, unsigned int i1, unsigned int i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != i2)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  return pattern100 (x4, 
i1, 
i3); /* [-1, 0] */
}

int
pattern175 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (XINT (x2, 1) != 1
      || GET_MODE (x2) != E_QImode)
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != PLUS
      || GET_MODE (x5) != E_HImode)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 28
      || GET_MODE (x6) != E_HImode)
    return -1;
  x7 = XEXP (x4, 0);
  if (GET_CODE (x7) != REG
      || REGNO (x7) != 28
      || GET_MODE (x7) != E_HImode)
    return -1;
  x8 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x8) != SET)
    return -1;
  x9 = XEXP (x8, 1);
  if (GET_CODE (x9) != PLUS
      || GET_MODE (x9) != E_HImode)
    return -1;
  x10 = XEXP (x9, 0);
  if (GET_CODE (x10) != REG
      || REGNO (x10) != 28
      || GET_MODE (x10) != E_HImode)
    return -1;
  x11 = XEXP (x8, 0);
  if (GET_CODE (x11) != REG
      || REGNO (x11) != 32
      || GET_MODE (x11) != E_HImode)
    return -1;
  return 0;
}

int
pattern187 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XVECEXP (x1, 0, 2);
  x4 = XEXP (x3, 0);
  if (REGNO (x4) != 36
      || GET_MODE (x4) != E_CCmode)
    return -1;
  x5 = XVECEXP (x1, 0, 0);
  x6 = XEXP (x5, 0);
  operands[0] = x6;
  x7 = XEXP (x5, 1);
  x8 = XEXP (x7, 0);
  operands[1] = x8;
  x9 = XEXP (x7, 1);
  operands[2] = x9;
  if (!const_int_operand (operands[2], E_QImode))
    return -1;
  x10 = XEXP (x2, 0);
  operands[3] = x10;
  if (!scratch_or_dreg_operand (operands[3], E_QImode))
    return -1;
  return pattern186 (x7); /* [-1, 10] */
}

int
pattern194 (rtx x1, int *pnum_clobbers, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !pseudo_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !pseudo_register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern199 (rtx x1, machine_mode i1, unsigned int i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (REGNO (x2) != i2
      || GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  return 0;
}

int
pattern204 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x1, 1);
  operands[1] = x4;
  switch (GET_MODE (x2))
    {
    case E_HImode:
      if (!register_operand (operands[0], E_QImode)
          || !register_operand (operands[1], E_HImode))
        return -1;
      return 0;

    case E_PSImode:
      if (!register_operand (operands[1], E_PSImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_QImode:
          if (!register_operand (operands[0], E_QImode))
            return -1;
          return 1;

        case E_HImode:
          if (!register_operand (operands[0], E_HImode))
            return -1;
          return 2;

        default:
          return -1;
        }

    case E_SImode:
      if (!register_operand (operands[1], E_SImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_QImode:
          if (!register_operand (operands[0], E_QImode))
            return -1;
          return 3;

        case E_HImode:
          if (!register_operand (operands[0], E_HImode))
            return -1;
          return 4;

        case E_PSImode:
          if (!register_operand (operands[0], E_PSImode))
            return -1;
          return 5;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern218 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_QImode)
      || GET_MODE (x1) != E_QImode)
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case LSHIFTRT:
      return pattern217 (x3); /* [-1, 2] */

    case ASHIFTRT:
      res = pattern217 (x3);
      if (res >= 0)
        return res + 3; /* [3, 5] */
      return -1;

    default:
      return -1;
    }
}

int
pattern225 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  operands[2] = x4;
  if (!register_operand (operands[2], E_HImode))
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 36
      || GET_MODE (x6) != E_CCmode)
    return -1;
  return 0;
}

int
pattern229 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (REGNO (x1))
    {
    case 30:
      if (GET_MODE (x1) != E_HImode)
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_QImode:
          if (!register_operand (operands[0], E_QImode)
              || !memory_operand (operands[1], E_QImode))
            return -1;
          return 0;

        case E_QQmode:
          if (!register_operand (operands[0], E_QQmode)
              || !memory_operand (operands[1], E_QQmode))
            return -1;
          return 1;

        case E_UQQmode:
          if (!register_operand (operands[0], E_UQQmode)
              || !memory_operand (operands[1], E_UQQmode))
            return -1;
          return 2;

        case E_HImode:
          if (!register_operand (operands[0], E_HImode)
              || !memory_operand (operands[1], E_HImode))
            return -1;
          return 3;

        case E_HQmode:
          if (!register_operand (operands[0], E_HQmode)
              || !memory_operand (operands[1], E_HQmode))
            return -1;
          return 4;

        case E_UHQmode:
          if (!register_operand (operands[0], E_UHQmode)
              || !memory_operand (operands[1], E_UHQmode))
            return -1;
          return 5;

        case E_HAmode:
          if (!register_operand (operands[0], E_HAmode)
              || !memory_operand (operands[1], E_HAmode))
            return -1;
          return 6;

        case E_UHAmode:
          if (!register_operand (operands[0], E_UHAmode)
              || !memory_operand (operands[1], E_UHAmode))
            return -1;
          return 7;

        case E_SImode:
          if (!register_operand (operands[0], E_SImode)
              || !memory_operand (operands[1], E_SImode))
            return -1;
          return 8;

        case E_SQmode:
          if (!register_operand (operands[0], E_SQmode)
              || !memory_operand (operands[1], E_SQmode))
            return -1;
          return 9;

        case E_USQmode:
          if (!register_operand (operands[0], E_USQmode)
              || !memory_operand (operands[1], E_USQmode))
            return -1;
          return 10;

        case E_SAmode:
          if (!register_operand (operands[0], E_SAmode)
              || !memory_operand (operands[1], E_SAmode))
            return -1;
          return 11;

        case E_USAmode:
          if (!register_operand (operands[0], E_USAmode)
              || !memory_operand (operands[1], E_USAmode))
            return -1;
          return 12;

        case E_SFmode:
          if (!register_operand (operands[0], E_SFmode)
              || !memory_operand (operands[1], E_SFmode))
            return -1;
          return 13;

        case E_PSImode:
          if (!register_operand (operands[0], E_PSImode)
              || !memory_operand (operands[1], E_PSImode))
            return -1;
          return 14;

        default:
          return -1;
        }

    case 36:
      if (GET_MODE (x1) != E_CCmode)
        return -1;
      return 15;

    default:
      return -1;
    }
}

int
pattern248 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XVECEXP (x1, 0, 2);
  x5 = XEXP (x4, 0);
  operands[2] = x5;
  x6 = XEXP (x2, 1);
  x7 = XVECEXP (x6, 0, 0);
  if (!rtx_equal_p (x7, operands[1]))
    return -1;
  x8 = XVECEXP (x1, 0, 0);
  x9 = XVECEXP (x8, 0, 1);
  switch (XWINT (x9, 0))
    {
    case 1L:
      if (!const_int_operand (operands[0], E_QImode)
          || !scratch_operand (operands[2], E_QImode))
        return -1;
      return 0;

    case 2L:
      if (!const_int_operand (operands[0], E_HImode)
          || !scratch_operand (operands[2], E_HImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern255 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 36
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 1);
  return pattern186 (x5); /* [-1, 10] */
}

int
pattern260 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[3] = x3;
  x4 = XEXP (x1, 0);
  x5 = XEXP (x4, 1);
  switch (GET_CODE (x5))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      operands[2] = x5;
      return 0;

    case SIGN_EXTEND:
      res = pattern259 (x5);
      if (res >= 0)
        return res + 1; /* [1, 6] */
      return -1;

    case ZERO_EXTEND:
      res = pattern259 (x5);
      if (res >= 0)
        return res + 7; /* [7, 12] */
      return -1;

    default:
      return -1;
    }
}

int
pattern270 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != ZERO_EXTEND)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG)
    return -1;
  x6 = XEXP (x2, 0);
  if (GET_CODE (x6) != REG)
    return -1;
  return pattern269 (x1); /* [-1, 1] */
}

int
pattern274 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  if (REGNO (x3) != 26
      || GET_MODE (x3) != E_HImode)
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  x5 = XEXP (x4, 0);
  if (REGNO (x5) != 18
      || GET_MODE (x5) != E_DImode)
    return -1;
  x6 = XVECEXP (x1, 0, 0);
  x7 = XEXP (x6, 0);
  operands[0] = x7;
  if (!pseudo_register_operand (operands[0], E_SImode))
    return -1;
  x8 = XEXP (x6, 1);
  if (GET_MODE (x8) != E_SImode)
    return -1;
  x9 = XEXP (x8, 0);
  x10 = XEXP (x9, 0);
  operands[1] = x10;
  x11 = XEXP (x8, 1);
  switch (GET_CODE (x11))
    {
    case CONST_INT:
    case REG:
    case SUBREG:
      operands[2] = x11;
      return pattern271 (); /* [-1, 1] */

    case SIGN_EXTEND:
      if (GET_MODE (x11) != E_SImode)
        return -1;
      x12 = XEXP (x11, 0);
      res = pattern273 (x12);
      if (res >= 0)
        return res + 2; /* [2, 5] */
      return -1;

    case ZERO_EXTEND:
      if (GET_MODE (x11) != E_SImode)
        return -1;
      x12 = XEXP (x11, 0);
      res = pattern273 (x12);
      if (res >= 0)
        return res + 6; /* [6, 9] */
      return -1;

    default:
      return -1;
    }
}

int
pattern290 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != REG
      || REGNO (x7) != 18
      || GET_MODE (x7) != E_HImode)
    return -1;
  x8 = XEXP (x5, 1);
  if (GET_CODE (x8) != i1
      || GET_MODE (x8) != E_SImode)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_CODE (x9) != REG
      || REGNO (x9) != 26
      || GET_MODE (x9) != E_HImode)
    return -1;
  x10 = XEXP (x4, 1);
  if (XWINT (x10, 0) != 16L)
    return -1;
  x11 = XEXP (x2, 0);
  if (GET_CODE (x11) != REG
      || REGNO (x11) != 24
      || GET_MODE (x11) != E_HImode)
    return -1;
  x12 = XVECEXP (x1, 0, 1);
  x13 = XEXP (x12, 0);
  if (REGNO (x13) != 22
      || GET_MODE (x13) != E_HImode
      || GET_MODE (x3) != E_HImode
      || GET_MODE (x4) != E_SImode
      || GET_MODE (x5) != E_SImode)
    return -1;
  return 0;
}

int
pattern298 (rtx x1, machine_mode i1, unsigned int i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i3)
    return -1;
  x5 = XEXP (x1, 0);
  if (REGNO (x5) != i2
      || GET_MODE (x5) != i1
      || GET_MODE (x2) != i1)
    return -1;
  x6 = XEXP (x2, 0);
  if (GET_MODE (x6) != i1
      || GET_MODE (x3) != i1)
    return -1;
  return 0;
}

int
pattern304 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_HImode)
      || GET_MODE (x1) != E_HImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_HImode)
    return -1;
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  if (!register_operand (operands[1], E_QImode))
    return -1;
  return 0;
}

int
pattern309 (rtx x1, machine_mode i1, unsigned int i2, unsigned int i3, unsigned int i4)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (REGNO (x4) != i4)
    return -1;
  x5 = XEXP (x2, 0);
  if (REGNO (x5) != 24)
    return -1;
  return pattern280 (x1, 
i1, 
i2, 
i3); /* [-1, 3] */
}

int
pattern314 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != PLUS
      || GET_MODE (x3) != i1)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 36
      || GET_MODE (x5) != E_CCmode)
    return -1;
  x6 = XEXP (x2, 0);
  operands[2] = x6;
  if (!l_register_operand (operands[2], i1))
    return -1;
  x7 = XEXP (x3, 0);
  if (!rtx_equal_p (x7, operands[2]))
    return -1;
  x8 = XEXP (x3, 1);
  if (!rtx_equal_p (x8, operands[0]))
    return -1;
  return 0;
}

int
pattern325 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern329 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 0);
  if (REGNO (x4) != 30
      || GET_MODE (x4) != E_HImode)
    return -1;
  x5 = XVECEXP (x1, 0, 2);
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 30
      || GET_MODE (x6) != E_HImode)
    return -1;
  x7 = XVECEXP (x1, 0, 3);
  x8 = XEXP (x7, 0);
  if (GET_CODE (x8) != REG
      || REGNO (x8) != 24
      || GET_MODE (x8) != E_QImode)
    return -1;
  x9 = XVECEXP (x1, 0, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  operands[0] = x11;
  return 0;
}

int
pattern337 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_QImode:
      if (!register_operand (operands[1], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!register_operand (operands[1], E_HImode))
        return -1;
      return 1;

    case E_PSImode:
      if (!register_operand (operands[1], E_PSImode))
        return -1;
      return 2;

    case E_SImode:
      if (!register_operand (operands[1], E_SImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern341 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (GET_MODE (x4) != E_QQmode)
    return -1;
  x5 = XEXP (x2, 0);
  if (REGNO (x5) != 23
      || GET_MODE (x5) != E_QQmode)
    return -1;
  x6 = XVECEXP (x1, 0, 2);
  x7 = XEXP (x6, 0);
  if (REGNO (x7) != 24
      || GET_MODE (x7) != E_HImode
      || GET_MODE (x3) != E_QQmode)
    return -1;
  x8 = XEXP (x3, 0);
  if (GET_MODE (x8) != E_QQmode)
    return -1;
  x9 = XVECEXP (x1, 0, 1);
  x10 = XEXP (x9, 0);
  if (GET_MODE (x10) != E_QImode)
    return -1;
  return 0;
}

int
pattern346 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 0);
  operands[3] = x7;
  return pattern345 (x1); /* [-1, 2] */
}

int
pattern353 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (!ordered_comparison_operator (x2, E_VOIDmode))
    return -1;
  operands[0] = x2;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 36
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XEXP (x2, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x1, 1);
  x6 = XEXP (x5, 0);
  operands[4] = x6;
  return 0;
}

int
pattern359 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 2);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XEXP (x4, 1);
  if (GET_MODE (x6) != i1)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_MODE (x7) != i1)
    return -1;
  x8 = XEXP (x6, 1);
  if (GET_MODE (x8) != i1)
    return -1;
  x9 = XVECEXP (x1, 0, 1);
  x10 = XEXP (x9, 0);
  if (GET_MODE (x10) != i1)
    return -1;
  return 0;
}

int
pattern366 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  x5 = XEXP (x4, 1);
  if (GET_MODE (x5) != E_HImode)
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != REG
      || REGNO (x7) != 36
      || GET_MODE (x7) != E_CCmode)
    return -1;
  x8 = XEXP (x5, 0);
  operands[2] = x8;
  if (!register_operand (operands[2], E_QImode))
    return -1;
  return 0;
}

int
pattern373 (rtx x1, machine_mode i1, machine_mode i2, unsigned int i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 3);
  x3 = XEXP (x2, 0);
  if (REGNO (x3) != i3
      || GET_MODE (x3) != i2)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 1);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 1);
  if (GET_MODE (x7) != i1)
    return -1;
  return 0;
}

int
pattern378 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  switch (GET_MODE (x2))
    {
    case E_QImode:
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_QImode)
        return -1;
      return 0;

    case E_QQmode:
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_QQmode)
        return -1;
      return 1;

    case E_UQQmode:
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_UQQmode)
        return -1;
      return 2;

    case E_HImode:
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_HImode)
        return -1;
      return 3;

    case E_HQmode:
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_HQmode)
        return -1;
      return 4;

    case E_UHQmode:
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_UHQmode)
        return -1;
      return 5;

    case E_HAmode:
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_HAmode)
        return -1;
      return 6;

    case E_UHAmode:
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_UHAmode)
        return -1;
      return 7;

    case E_SImode:
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_SImode)
        return -1;
      return 8;

    case E_SQmode:
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_SQmode)
        return -1;
      return 9;

    case E_USQmode:
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_USQmode)
        return -1;
      return 10;

    case E_SAmode:
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_SAmode)
        return -1;
      return 11;

    case E_USAmode:
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_USAmode)
        return -1;
      return 12;

    case E_SFmode:
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_SFmode)
        return -1;
      return 13;

    case E_PSImode:
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_PSImode)
        return -1;
      return 14;

    default:
      return -1;
    }
}

 int
recog_2 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_QImode)
    return -1;
  x3 = XEXP (x2, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x4 = XEXP (x2, 2);
  operands[1] = x4;
  if (!const_0_to_7_operand (operands[1], E_QImode))
    return -1;
  x5 = XEXP (x1, 1);
  operands[2] = x5;
  if (!nonmemory_operand (operands[2], E_QImode))
    return -1;
  x6 = XEXP (x2, 0);
  switch (pattern230 (x6))
    {
    case 0:
      return 1076; /* *insv.io */

    case 1:
      return 1078; /* *insv.reg_split */

    default:
      return -1;
    }
}

 int
recog_8 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case SIGN_EXTEND:
      switch (pattern130 (x2))
        {
        case 0:
          return 246; /* *subhi3.sign_extend.qi_split */

        case 1:
          return 248; /* *subpsi3.sign_extend.qi_split */

        case 2:
          return 252; /* *subpsi3.sign_extend.hi_split */

        case 3:
          return 250; /* *subsi3.sign_extend.qi_split */

        case 4:
          return 254; /* *subsi3.sign_extend.hi_split */

        case 5:
          return 256; /* *subsi3.sign_extend.psi_split */

        default:
          return -1;
        }

    case ZERO_EXTEND:
      switch (pattern130 (x2))
        {
        case 0:
          return 247; /* *subhi3.zero_extend.qi_split */

        case 1:
          return 249; /* *subpsi3.zero_extend.qi_split */

        case 2:
          return 253; /* *subpsi3.zero_extend.hi_split */

        case 3:
          return 251; /* *subsi3.zero_extend.qi_split */

        case 4:
          return 255; /* *subsi3.zero_extend.hi_split */

        case 5:
          return 257; /* *subsi3.zero_extend.psi_split */

        default:
          return -1;
        }

    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      operands[2] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_PSImode:
          if (pattern193 (x2, 
E_PSImode) != 0)
            return -1;
          return 272; /* subpsi3 */

        case E_QImode:
          if (pattern215 (x2, 
E_QImode) != 0)
            return -1;
          return 274; /* subqi3 */

        case E_QQmode:
          if (pattern215 (x2, 
E_QQmode) != 0)
            return -1;
          return 275; /* subqq3 */

        case E_UQQmode:
          if (pattern215 (x2, 
E_UQQmode) != 0)
            return -1;
          return 276; /* subuqq3 */

        case E_HImode:
          if (pnum_clobbers == NULL
              || pattern215 (x2, 
E_HImode) != 0)
            return -1;
          *pnum_clobbers = 1;
          return 280; /* subhi3 */

        case E_HQmode:
          if (pnum_clobbers == NULL
              || pattern215 (x2, 
E_HQmode) != 0)
            return -1;
          *pnum_clobbers = 1;
          return 281; /* subhq3 */

        case E_UHQmode:
          if (pnum_clobbers == NULL
              || pattern215 (x2, 
E_UHQmode) != 0)
            return -1;
          *pnum_clobbers = 1;
          return 282; /* subuhq3 */

        case E_HAmode:
          if (pnum_clobbers == NULL
              || pattern215 (x2, 
E_HAmode) != 0)
            return -1;
          *pnum_clobbers = 1;
          return 283; /* subha3 */

        case E_UHAmode:
          if (pnum_clobbers == NULL
              || pattern215 (x2, 
E_UHAmode) != 0)
            return -1;
          *pnum_clobbers = 1;
          return 284; /* subuha3 */

        case E_SImode:
          if (pnum_clobbers == NULL
              || pattern215 (x2, 
E_SImode) != 0)
            return -1;
          *pnum_clobbers = 1;
          return 290; /* subsi3 */

        case E_SQmode:
          if (pnum_clobbers == NULL
              || pattern215 (x2, 
E_SQmode) != 0)
            return -1;
          *pnum_clobbers = 1;
          return 291; /* subsq3 */

        case E_USQmode:
          if (pnum_clobbers == NULL
              || pattern215 (x2, 
E_USQmode) != 0)
            return -1;
          *pnum_clobbers = 1;
          return 292; /* subusq3 */

        case E_SAmode:
          if (pnum_clobbers == NULL
              || pattern215 (x2, 
E_SAmode) != 0)
            return -1;
          *pnum_clobbers = 1;
          return 293; /* subsa3 */

        case E_USAmode:
          if (pnum_clobbers == NULL
              || pattern215 (x2, 
E_USAmode) != 0)
            return -1;
          *pnum_clobbers = 1;
          return 294; /* subusa3 */

        default:
          return -1;
        }

    case LSHIFTRT:
      switch (pattern131 (x2))
        {
        case 0:
          return 308; /* *subqi3.msbit_split */

        case 1:
          return 310; /* *subhi3.msbit_split */

        case 2:
          return 312; /* *subpsi3.msbit_split */

        case 3:
          return 314; /* *subsi3.msbit_split */

        case 4:
          return 336; /* *subhi3.sex.msbit_split */

        case 5:
          return 338; /* *subpsi3.sex.msbit_split */

        case 6:
          return 342; /* *subpsi3.sex.msbit_split */

        case 7:
          return 340; /* *subsi3.sex.msbit_split */

        case 8:
          return 344; /* *subsi3.sex.msbit_split */

        case 9:
          return 346; /* *subsi3.sex.msbit_split */

        default:
          return -1;
        }

    case ASHIFTRT:
      switch (pattern131 (x2))
        {
        case 0:
          return 309; /* *subqi3.msbit_split */

        case 1:
          return 311; /* *subhi3.msbit_split */

        case 2:
          return 313; /* *subpsi3.msbit_split */

        case 3:
          return 315; /* *subsi3.msbit_split */

        case 4:
          return 337; /* *subhi3.sex.msbit_split */

        case 5:
          return 339; /* *subpsi3.sex.msbit_split */

        case 6:
          return 343; /* *subpsi3.sex.msbit_split */

        case 7:
          return 341; /* *subsi3.sex.msbit_split */

        case 8:
          return 345; /* *subsi3.sex.msbit_split */

        case 9:
          return 347; /* *subsi3.sex.msbit_split */

        default:
          return -1;
        }

    case GE:
      switch (pattern133 (x2))
        {
        case 0:
          if (pnum_clobbers != NULL
              && 
#line 2374 "../../gcc/config/avr/avr.md"
(reload_completed))
            {
              *pnum_clobbers = 1;
              return 348; /* *subqi3.ge0 */
            }
          return 444; /* *subqi3.ge0_split */

        case 1:
          if (pnum_clobbers != NULL
              && 
#line 2374 "../../gcc/config/avr/avr.md"
(reload_completed))
            {
              *pnum_clobbers = 1;
              return 356; /* *subqi3.ge0 */
            }
          return 452; /* *subqi3.ge0_split */

        case 2:
          if (pnum_clobbers != NULL
              && 
#line 2374 "../../gcc/config/avr/avr.md"
(reload_completed))
            {
              *pnum_clobbers = 1;
              return 364; /* *subqi3.ge0 */
            }
          return 460; /* *subqi3.ge0_split */

        case 3:
          if (pnum_clobbers != NULL
              && 
#line 2374 "../../gcc/config/avr/avr.md"
(reload_completed))
            {
              *pnum_clobbers = 1;
              return 372; /* *subqi3.ge0 */
            }
          return 468; /* *subqi3.ge0_split */

        case 4:
          if (pnum_clobbers != NULL
              && 
#line 2374 "../../gcc/config/avr/avr.md"
(reload_completed))
            {
              *pnum_clobbers = 1;
              return 350; /* *subhi3.ge0 */
            }
          return 446; /* *subhi3.ge0_split */

        case 5:
          if (pnum_clobbers != NULL
              && 
#line 2374 "../../gcc/config/avr/avr.md"
(reload_completed))
            {
              *pnum_clobbers = 1;
              return 358; /* *subhi3.ge0 */
            }
          return 454; /* *subhi3.ge0_split */

        case 6:
          if (pnum_clobbers != NULL
              && 
#line 2374 "../../gcc/config/avr/avr.md"
(reload_completed))
            {
              *pnum_clobbers = 1;
              return 366; /* *subhi3.ge0 */
            }
          return 462; /* *subhi3.ge0_split */

        case 7:
          if (pnum_clobbers != NULL
              && 
#line 2374 "../../gcc/config/avr/avr.md"
(reload_completed))
            {
              *pnum_clobbers = 1;
              return 374; /* *subhi3.ge0 */
            }
          return 470; /* *subhi3.ge0_split */

        case 8:
          if (pnum_clobbers != NULL
              && 
#line 2374 "../../gcc/config/avr/avr.md"
(reload_completed))
            {
              *pnum_clobbers = 1;
              return 352; /* *subpsi3.ge0 */
            }
          return 448; /* *subpsi3.ge0_split */

        case 9:
          if (pnum_clobbers != NULL
              && 
#line 2374 "../../gcc/config/avr/avr.md"
(reload_completed))
            {
              *pnum_clobbers = 1;
              return 360; /* *subpsi3.ge0 */
            }
          return 456; /* *subpsi3.ge0_split */

        case 10:
          if (pnum_clobbers != NULL
              && 
#line 2374 "../../gcc/config/avr/avr.md"
(reload_completed))
            {
              *pnum_clobbers = 1;
              return 368; /* *subpsi3.ge0 */
            }
          return 464; /* *subpsi3.ge0_split */

        case 11:
          if (pnum_clobbers != NULL
              && 
#line 2374 "../../gcc/config/avr/avr.md"
(reload_completed))
            {
              *pnum_clobbers = 1;
              return 376; /* *subpsi3.ge0 */
            }
          return 472; /* *subpsi3.ge0_split */

        case 12:
          if (pnum_clobbers != NULL
              && 
#line 2374 "../../gcc/config/avr/avr.md"
(reload_completed))
            {
              *pnum_clobbers = 1;
              return 354; /* *subsi3.ge0 */
            }
          return 450; /* *subsi3.ge0_split */

        case 13:
          if (pnum_clobbers != NULL
              && 
#line 2374 "../../gcc/config/avr/avr.md"
(reload_completed))
            {
              *pnum_clobbers = 1;
              return 362; /* *subsi3.ge0 */
            }
          return 458; /* *subsi3.ge0_split */

        case 14:
          if (pnum_clobbers != NULL
              && 
#line 2374 "../../gcc/config/avr/avr.md"
(reload_completed))
            {
              *pnum_clobbers = 1;
              return 370; /* *subsi3.ge0 */
            }
          return 466; /* *subsi3.ge0_split */

        case 15:
          if (pnum_clobbers != NULL
              && 
#line 2374 "../../gcc/config/avr/avr.md"
(reload_completed))
            {
              *pnum_clobbers = 1;
              return 378; /* *subsi3.ge0 */
            }
          return 474; /* *subsi3.ge0_split */

        default:
          return -1;
        }

    case LT:
      switch (pattern133 (x2))
        {
        case 0:
          if (pnum_clobbers != NULL
              && 
#line 2374 "../../gcc/config/avr/avr.md"
(reload_completed))
            {
              *pnum_clobbers = 1;
              return 349; /* *subqi3.lt0 */
            }
          return 445; /* *subqi3.lt0_split */

        case 1:
          if (pnum_clobbers != NULL
              && 
#line 2374 "../../gcc/config/avr/avr.md"
(reload_completed))
            {
              *pnum_clobbers = 1;
              return 357; /* *subqi3.lt0 */
            }
          return 453; /* *subqi3.lt0_split */

        case 2:
          if (pnum_clobbers != NULL
              && 
#line 2374 "../../gcc/config/avr/avr.md"
(reload_completed))
            {
              *pnum_clobbers = 1;
              return 365; /* *subqi3.lt0 */
            }
          return 461; /* *subqi3.lt0_split */

        case 3:
          if (pnum_clobbers != NULL
              && 
#line 2374 "../../gcc/config/avr/avr.md"
(reload_completed))
            {
              *pnum_clobbers = 1;
              return 373; /* *subqi3.lt0 */
            }
          return 469; /* *subqi3.lt0_split */

        case 4:
          if (pnum_clobbers != NULL
              && 
#line 2374 "../../gcc/config/avr/avr.md"
(reload_completed))
            {
              *pnum_clobbers = 1;
              return 351; /* *subhi3.lt0 */
            }
          return 447; /* *subhi3.lt0_split */

        case 5:
          if (pnum_clobbers != NULL
              && 
#line 2374 "../../gcc/config/avr/avr.md"
(reload_completed))
            {
              *pnum_clobbers = 1;
              return 359; /* *subhi3.lt0 */
            }
          return 455; /* *subhi3.lt0_split */

        case 6:
          if (pnum_clobbers != NULL
              && 
#line 2374 "../../gcc/config/avr/avr.md"
(reload_completed))
            {
              *pnum_clobbers = 1;
              return 367; /* *subhi3.lt0 */
            }
          return 463; /* *subhi3.lt0_split */

        case 7:
          if (pnum_clobbers != NULL
              && 
#line 2374 "../../gcc/config/avr/avr.md"
(reload_completed))
            {
              *pnum_clobbers = 1;
              return 375; /* *subhi3.lt0 */
            }
          return 471; /* *subhi3.lt0_split */

        case 8:
          if (pnum_clobbers != NULL
              && 
#line 2374 "../../gcc/config/avr/avr.md"
(reload_completed))
            {
              *pnum_clobbers = 1;
              return 353; /* *subpsi3.lt0 */
            }
          return 449; /* *subpsi3.lt0_split */

        case 9:
          if (pnum_clobbers != NULL
              && 
#line 2374 "../../gcc/config/avr/avr.md"
(reload_completed))
            {
              *pnum_clobbers = 1;
              return 361; /* *subpsi3.lt0 */
            }
          return 457; /* *subpsi3.lt0_split */

        case 10:
          if (pnum_clobbers != NULL
              && 
#line 2374 "../../gcc/config/avr/avr.md"
(reload_completed))
            {
              *pnum_clobbers = 1;
              return 369; /* *subpsi3.lt0 */
            }
          return 465; /* *subpsi3.lt0_split */

        case 11:
          if (pnum_clobbers != NULL
              && 
#line 2374 "../../gcc/config/avr/avr.md"
(reload_completed))
            {
              *pnum_clobbers = 1;
              return 377; /* *subpsi3.lt0 */
            }
          return 473; /* *subpsi3.lt0_split */

        case 12:
          if (pnum_clobbers != NULL
              && 
#line 2374 "../../gcc/config/avr/avr.md"
(reload_completed))
            {
              *pnum_clobbers = 1;
              return 355; /* *subsi3.lt0 */
            }
          return 451; /* *subsi3.lt0_split */

        case 13:
          if (pnum_clobbers != NULL
              && 
#line 2374 "../../gcc/config/avr/avr.md"
(reload_completed))
            {
              *pnum_clobbers = 1;
              return 363; /* *subsi3.lt0 */
            }
          return 459; /* *subsi3.lt0_split */

        case 14:
          if (pnum_clobbers != NULL
              && 
#line 2374 "../../gcc/config/avr/avr.md"
(reload_completed))
            {
              *pnum_clobbers = 1;
              return 371; /* *subsi3.lt0 */
            }
          return 467; /* *subsi3.lt0_split */

        case 15:
          if (pnum_clobbers != NULL
              && 
#line 2374 "../../gcc/config/avr/avr.md"
(reload_completed))
            {
              *pnum_clobbers = 1;
              return 379; /* *subsi3.lt0 */
            }
          return 475; /* *subsi3.lt0_split */

        default:
          return -1;
        }

    case MULT:
      x4 = XEXP (x2, 0);
      operands[3] = x4;
      x5 = XEXP (x3, 0);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
          if (pattern191 (x2) != 0)
            return -1;
          switch (GET_CODE (operands[2]))
            {
            case REG:
            case SUBREG:
              if (!register_operand (operands[2], E_QImode))
                return -1;
              if (
#line 2622 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
                return 492; /* *msubqi4_split */
              if (pnum_clobbers == NULL
                  || !
#line 2637 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
                return -1;
              *pnum_clobbers = 1;
              return 493; /* *msubqi4 */

            case CONST_INT:
              if (pnum_clobbers == NULL
                  || !const_int_operand (operands[2], E_QImode)
                  || !
#line 2666 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
                return -1;
              *pnum_clobbers = 1;
              return 495; /* *msubqi4.const */

            default:
              return -1;
            }

        case SIGN_EXTEND:
          if (pattern192 (x2) != 0)
            return -1;
          x6 = XEXP (x3, 1);
          switch (GET_CODE (x6))
            {
            case SIGN_EXTEND:
              if (GET_MODE (x6) != E_HImode)
                return -1;
              x7 = XEXP (x6, 0);
              operands[2] = x7;
              if (!register_operand (operands[2], E_QImode))
                return -1;
              if (
#line 2734 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
                return 500; /* *msubqihi4_split */
              if (pnum_clobbers == NULL
                  || !
#line 2749 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
                return -1;
              *pnum_clobbers = 1;
              return 502; /* *msubqihi4 */

            case ZERO_EXTEND:
              if (GET_MODE (x6) != E_HImode)
                return -1;
              x7 = XEXP (x6, 0);
              operands[2] = x7;
              if (!register_operand (operands[2], E_QImode))
                return -1;
              if (
#line 2798 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL
   && reload_completed
   && SIGN_EXTEND != ZERO_EXTEND))
                return 509; /* *sumsubqihi4_split */
              if (pnum_clobbers == NULL
                  || !
#line 2815 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL
   && reload_completed
   && SIGN_EXTEND != ZERO_EXTEND))
                return -1;
              *pnum_clobbers = 1;
              return 511; /* *sumsubqihi4 */

            case CONST_INT:
              if (pnum_clobbers == NULL)
                return -1;
              operands[2] = x6;
              if (s8_operand (operands[2], E_HImode)
                  && 
#line 2881 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
                {
                  *pnum_clobbers = 1;
                  return 515; /* *msubqihi4.sconst */
                }
              if (!u8_operand (operands[2], E_HImode)
                  || !
#line 2972 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL
   && !s8_operand (operands[2], VOIDmode)))
                return -1;
              *pnum_clobbers = 1;
              return 520; /* *sumsubqihi4.uconst */

            default:
              return -1;
            }

        case ZERO_EXTEND:
          if (pattern192 (x2) != 0)
            return -1;
          x6 = XEXP (x3, 1);
          switch (GET_CODE (x6))
            {
            case ZERO_EXTEND:
              if (GET_MODE (x6) != E_HImode)
                return -1;
              x7 = XEXP (x6, 0);
              operands[2] = x7;
              if (!register_operand (operands[2], E_QImode))
                return -1;
              if (
#line 2734 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
                return 501; /* *umsubqihi4_split */
              if (pnum_clobbers == NULL
                  || !
#line 2749 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
                return -1;
              *pnum_clobbers = 1;
              return 503; /* *umsubqihi4 */

            case SIGN_EXTEND:
              if (GET_MODE (x6) != E_HImode)
                return -1;
              x7 = XEXP (x6, 0);
              operands[2] = x7;
              if (!register_operand (operands[2], E_QImode))
                return -1;
              if (
#line 2798 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL
   && reload_completed
   && ZERO_EXTEND != SIGN_EXTEND))
                return 508; /* *usmsubqihi4_split */
              if (pnum_clobbers == NULL
                  || !
#line 2815 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL
   && reload_completed
   && ZERO_EXTEND != SIGN_EXTEND))
                return -1;
              *pnum_clobbers = 1;
              return 510; /* *usmsubqihi4 */

            case CONST_INT:
              if (pnum_clobbers == NULL)
                return -1;
              operands[2] = x6;
              if (!u8_operand (operands[2], E_HImode)
                  || !
#line 2881 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
                return -1;
              *pnum_clobbers = 1;
              return 516; /* *umsubqihi4.uconst */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case ASHIFT:
      if (pnum_clobbers == NULL
          || GET_MODE (x3) != E_HImode
          || !register_operand (operands[0], E_HImode)
          || GET_MODE (x2) != E_HImode)
        return -1;
      x4 = XEXP (x2, 0);
      operands[3] = x4;
      if (!register_operand (operands[3], E_HImode))
        return -1;
      x5 = XEXP (x3, 0);
      if (GET_MODE (x5) != E_HImode)
        return -1;
      x6 = XEXP (x3, 1);
      operands[2] = x6;
      switch (GET_CODE (x5))
        {
        case ZERO_EXTEND:
          x8 = XEXP (x5, 0);
          operands[1] = x8;
          if (!register_operand (operands[1], E_QImode)
              || !const_2_to_7_operand (operands[2], E_HImode)
              || !
#line 2904 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
            return -1;
          *pnum_clobbers = 1;
          return 517; /* *umsubqihi4.uconst.ashift */

        case SIGN_EXTEND:
          x8 = XEXP (x5, 0);
          operands[1] = x8;
          if (!register_operand (operands[1], E_QImode)
              || !const_1_to_6_operand (operands[2], E_HImode)
              || !
#line 2928 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
            return -1;
          *pnum_clobbers = 1;
          return 518; /* *msubqihi4.sconst.ashift */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_29 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  switch (GET_CODE (x2))
    {
    case REG:
    case SUBREG:
      switch (pattern54 (x1, pnum_clobbers))
        {
        case 0:
          return 705; /* ashrqi3 */

        case 1:
          return 706; /* ashrqq3 */

        case 2:
          return 707; /* ashruqq3 */

        case 3:
          if (nop_general_operand (operands[2], E_QImode))
            return 711; /* ashrhi3 */
          if (pnum_clobbers != NULL
              && const_int_operand (operands[2], E_QImode)
              && 
#line 5896 "../../gcc/config/avr/avr.md"
(reload_completed))
            {
              *pnum_clobbers = 2;
              return 733; /* *ashrhi3_const */
            }
          break;

        case 4:
          if (nop_general_operand (operands[2], E_QImode))
            return 712; /* ashrhq3 */
          if (pnum_clobbers != NULL
              && const_int_operand (operands[2], E_QImode)
              && 
#line 5896 "../../gcc/config/avr/avr.md"
(reload_completed))
            {
              *pnum_clobbers = 2;
              return 734; /* *ashrhq3_const */
            }
          break;

        case 5:
          if (nop_general_operand (operands[2], E_QImode))
            return 713; /* ashruhq3 */
          if (pnum_clobbers != NULL
              && const_int_operand (operands[2], E_QImode)
              && 
#line 5896 "../../gcc/config/avr/avr.md"
(reload_completed))
            {
              *pnum_clobbers = 2;
              return 735; /* *ashruhq3_const */
            }
          break;

        case 6:
          if (nop_general_operand (operands[2], E_QImode))
            return 714; /* ashrha3 */
          if (pnum_clobbers != NULL
              && const_int_operand (operands[2], E_QImode)
              && 
#line 5896 "../../gcc/config/avr/avr.md"
(reload_completed))
            {
              *pnum_clobbers = 2;
              return 736; /* *ashrha3_const */
            }
          break;

        case 7:
          if (nop_general_operand (operands[2], E_QImode))
            return 715; /* ashruha3 */
          if (pnum_clobbers != NULL
              && const_int_operand (operands[2], E_QImode)
              && 
#line 5896 "../../gcc/config/avr/avr.md"
(reload_completed))
            {
              *pnum_clobbers = 2;
              return 737; /* *ashruha3_const */
            }
          break;

        case 8:
          *pnum_clobbers = 1;
          return 721; /* ashrpsi3 */

        case 9:
          return 723; /* ashrsi3 */

        case 10:
          return 724; /* ashrsq3 */

        case 11:
          return 725; /* ashrusq3 */

        case 12:
          return 726; /* ashrsa3 */

        case 13:
          return 727; /* ashrusa3 */

        default:
          break;
        }
      break;

    case ZERO_EXTRACT:
      if (pattern55 (x1) == 0)
        return 1083; /* *insv.shiftrt */
      break;

    default:
      break;
    }
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != REG)
    return -1;
  switch (pattern56 (x1))
    {
    case 0:
      if (
#line 629 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
        return 3305; /* ashrdi3_insn */
      if (pnum_clobbers == NULL
          || !
#line 642 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 3333; /* *ashrdi3_insn */

    case 1:
      if (
#line 629 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
        return 3309; /* ashrdq3_insn */
      if (pnum_clobbers == NULL
          || !
#line 642 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 3337; /* *ashrdq3_insn */

    case 2:
      if (
#line 629 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
        return 3313; /* ashrudq3_insn */
      if (pnum_clobbers == NULL
          || !
#line 642 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 3341; /* *ashrudq3_insn */

    case 3:
      if (
#line 629 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
        return 3317; /* ashrda3_insn */
      if (pnum_clobbers == NULL
          || !
#line 642 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 3345; /* *ashrda3_insn */

    case 4:
      if (
#line 629 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
        return 3321; /* ashruda3_insn */
      if (pnum_clobbers == NULL
          || !
#line 642 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 3349; /* *ashruda3_insn */

    case 5:
      if (
#line 629 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
        return 3325; /* ashrta3_insn */
      if (pnum_clobbers == NULL
          || !
#line 642 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 3353; /* *ashrta3_insn */

    case 6:
      if (
#line 629 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
        return 3329; /* ashruta3_insn */
      if (pnum_clobbers == NULL
          || !
#line 642 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 3357; /* *ashruta3_insn */

    default:
      return -1;
    }
}

 int
recog_33 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case REG:
    case SUBREG:
      operands[1] = x3;
      res = recog_18 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      if (GET_CODE (x3) != REG)
        return -1;
      switch (pattern56 (x1))
        {
        case 0:
          if (
#line 629 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
            return 3307; /* rotldi3_insn */
          if (pnum_clobbers == NULL
              || !
#line 642 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          *pnum_clobbers = 1;
          return 3335; /* *rotldi3_insn */

        case 1:
          if (
#line 629 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
            return 3311; /* rotldq3_insn */
          if (pnum_clobbers == NULL
              || !
#line 642 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          *pnum_clobbers = 1;
          return 3339; /* *rotldq3_insn */

        case 2:
          if (
#line 629 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
            return 3315; /* rotludq3_insn */
          if (pnum_clobbers == NULL
              || !
#line 642 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          *pnum_clobbers = 1;
          return 3343; /* *rotludq3_insn */

        case 3:
          if (
#line 629 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
            return 3319; /* rotlda3_insn */
          if (pnum_clobbers == NULL
              || !
#line 642 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          *pnum_clobbers = 1;
          return 3347; /* *rotlda3_insn */

        case 4:
          if (
#line 629 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
            return 3323; /* rotluda3_insn */
          if (pnum_clobbers == NULL
              || !
#line 642 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          *pnum_clobbers = 1;
          return 3351; /* *rotluda3_insn */

        case 5:
          if (
#line 629 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
            return 3327; /* rotlta3_insn */
          if (pnum_clobbers == NULL
              || !
#line 642 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          *pnum_clobbers = 1;
          return 3355; /* *rotlta3_insn */

        case 6:
          if (
#line 629 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
            return 3331; /* rotluta3_insn */
          if (pnum_clobbers == NULL
              || !
#line 642 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          *pnum_clobbers = 1;
          return 3359; /* *rotluta3_insn */

        default:
          return -1;
        }

    case CONST_INT:
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      if (!register_operand (operands[0], E_QImode)
          || GET_MODE (x2) != E_QImode)
        return -1;
      switch (XWINT (x3, 0))
        {
        case 1L:
          if (pnum_clobbers == NULL)
            return -1;
          x5 = XEXP (x2, 1);
          operands[1] = x5;
          if (!register_operand (operands[1], E_QImode)
              || !
#line 8980 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          *pnum_clobbers = 1;
          return 1014; /* *mask1_0x01 */

        case -2L:
          x5 = XEXP (x2, 1);
          switch (GET_CODE (x5))
            {
            case AND:
              if (GET_MODE (x5) != E_QImode)
                return -1;
              x6 = XEXP (x5, 1);
              if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 7])
                return -1;
              x7 = XEXP (x5, 0);
              operands[1] = x7;
              if (!register_operand (operands[1], E_QImode))
                return -1;
              return 1018; /* mask1_0xfe_split */

            case REG:
            case SUBREG:
              if (pnum_clobbers == NULL)
                return -1;
              operands[1] = x5;
              if (!register_operand (operands[1], E_QImode)
                  || !
#line 9056 "../../gcc/config/avr/avr.md"
(reload_completed))
                return -1;
              *pnum_clobbers = 1;
              return 1019; /* *mask1_0xfe */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_42 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  switch (GET_CODE (x4))
    {
    case SIGN_EXTEND:
      switch (pattern221 (x1))
        {
        case 0:
          if (!
#line 2038 "../../gcc/config/avr/avr.md"
(reload_completed
   && 2 > 1))
            return -1;
          return 258; /* *subhi3.sign_extend.qi */

        case 1:
          if (!
#line 2038 "../../gcc/config/avr/avr.md"
(reload_completed
   && 3 > 1))
            return -1;
          return 260; /* *subpsi3.sign_extend.qi */

        case 2:
          if (!
#line 2038 "../../gcc/config/avr/avr.md"
(reload_completed
   && 3 > 2))
            return -1;
          return 264; /* *subpsi3.sign_extend.hi */

        case 3:
          if (!
#line 2038 "../../gcc/config/avr/avr.md"
(reload_completed
   && 4 > 1))
            return -1;
          return 262; /* *subsi3.sign_extend.qi */

        case 4:
          if (!
#line 2038 "../../gcc/config/avr/avr.md"
(reload_completed
   && 4 > 2))
            return -1;
          return 266; /* *subsi3.sign_extend.hi */

        case 5:
          if (!
#line 2038 "../../gcc/config/avr/avr.md"
(reload_completed
   && 4 > 3))
            return -1;
          return 268; /* *subsi3.sign_extend.psi */

        default:
          return -1;
        }

    case ZERO_EXTEND:
      switch (pattern221 (x1))
        {
        case 0:
          if (!
#line 2038 "../../gcc/config/avr/avr.md"
(reload_completed
   && 2 > 1))
            return -1;
          return 259; /* *subhi3.zero_extend.qi */

        case 1:
          if (!
#line 2038 "../../gcc/config/avr/avr.md"
(reload_completed
   && 3 > 1))
            return -1;
          return 261; /* *subpsi3.zero_extend.qi */

        case 2:
          if (!
#line 2038 "../../gcc/config/avr/avr.md"
(reload_completed
   && 3 > 2))
            return -1;
          return 265; /* *subpsi3.zero_extend.hi */

        case 3:
          if (!
#line 2038 "../../gcc/config/avr/avr.md"
(reload_completed
   && 4 > 1))
            return -1;
          return 263; /* *subsi3.zero_extend.qi */

        case 4:
          if (!
#line 2038 "../../gcc/config/avr/avr.md"
(reload_completed
   && 4 > 2))
            return -1;
          return 267; /* *subsi3.zero_extend.hi */

        case 5:
          if (!
#line 2038 "../../gcc/config/avr/avr.md"
(reload_completed
   && 4 > 3))
            return -1;
          return 269; /* *subsi3.zero_extend.psi */

        default:
          return -1;
        }

    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      operands[2] = x4;
      x5 = XEXP (x3, 0);
      operands[1] = x5;
      x6 = XVECEXP (x1, 0, 1);
      x7 = XEXP (x6, 0);
      if (GET_CODE (x7) == REG
          && REGNO (x7) == 36
          && GET_MODE (x7) == E_CCmode)
        {
          switch (GET_MODE (operands[0]))
            {
            case E_PSImode:
              if (pattern325 (x3, 
E_PSImode) == 0
                  && 
#line 2092 "../../gcc/config/avr/avr.md"
(reload_completed))
                return 273; /* *subpsi3 */
              break;

            case E_QImode:
              if (pattern312 (x3, 
E_QImode) == 0
                  && 
#line 2119 "../../gcc/config/avr/avr.md"
(reload_completed))
                return 277; /* *subqi3 */
              break;

            case E_QQmode:
              if (pattern312 (x3, 
E_QQmode) == 0
                  && 
#line 2119 "../../gcc/config/avr/avr.md"
(reload_completed))
                return 278; /* *subqq3 */
              break;

            case E_UQQmode:
              if (pattern312 (x3, 
E_UQQmode) == 0
                  && 
#line 2119 "../../gcc/config/avr/avr.md"
(reload_completed))
                return 279; /* *subuqq3 */
              break;

            default:
              break;
            }
        }
      operands[3] = x7;
      if (!scratch_operand (operands[3], E_QImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_HImode:
          if (pattern312 (x3, 
E_HImode) != 0)
            return -1;
          return 280; /* subhi3 */

        case E_HQmode:
          if (pattern312 (x3, 
E_HQmode) != 0)
            return -1;
          return 281; /* subhq3 */

        case E_UHQmode:
          if (pattern312 (x3, 
E_UHQmode) != 0)
            return -1;
          return 282; /* subuhq3 */

        case E_HAmode:
          if (pattern312 (x3, 
E_HAmode) != 0)
            return -1;
          return 283; /* subha3 */

        case E_UHAmode:
          if (pattern312 (x3, 
E_UHAmode) != 0)
            return -1;
          return 284; /* subuha3 */

        case E_SImode:
          if (pattern312 (x3, 
E_SImode) != 0)
            return -1;
          return 290; /* subsi3 */

        case E_SQmode:
          if (pattern312 (x3, 
E_SQmode) != 0)
            return -1;
          return 291; /* subsq3 */

        case E_USQmode:
          if (pattern312 (x3, 
E_USQmode) != 0)
            return -1;
          return 292; /* subusq3 */

        case E_SAmode:
          if (pattern312 (x3, 
E_SAmode) != 0)
            return -1;
          return 293; /* subsa3 */

        case E_USAmode:
          if (pattern312 (x3, 
E_USAmode) != 0)
            return -1;
          return 294; /* subusa3 */

        default:
          return -1;
        }

    case GE:
      switch (pattern223 (x1))
        {
        case 0:
          if (!
#line 2374 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 348; /* *subqi3.ge0 */

        case 1:
          if (!
#line 2374 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 356; /* *subqi3.ge0 */

        case 2:
          if (!
#line 2374 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 364; /* *subqi3.ge0 */

        case 3:
          if (!
#line 2374 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 372; /* *subqi3.ge0 */

        case 4:
          if (!
#line 2374 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 350; /* *subhi3.ge0 */

        case 5:
          if (!
#line 2374 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 358; /* *subhi3.ge0 */

        case 6:
          if (!
#line 2374 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 366; /* *subhi3.ge0 */

        case 7:
          if (!
#line 2374 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 374; /* *subhi3.ge0 */

        case 8:
          if (!
#line 2374 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 352; /* *subpsi3.ge0 */

        case 9:
          if (!
#line 2374 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 360; /* *subpsi3.ge0 */

        case 10:
          if (!
#line 2374 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 368; /* *subpsi3.ge0 */

        case 11:
          if (!
#line 2374 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 376; /* *subpsi3.ge0 */

        case 12:
          if (!
#line 2374 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 354; /* *subsi3.ge0 */

        case 13:
          if (!
#line 2374 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 362; /* *subsi3.ge0 */

        case 14:
          if (!
#line 2374 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 370; /* *subsi3.ge0 */

        case 15:
          if (!
#line 2374 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 378; /* *subsi3.ge0 */

        default:
          return -1;
        }

    case LT:
      switch (pattern223 (x1))
        {
        case 0:
          if (!
#line 2374 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 349; /* *subqi3.lt0 */

        case 1:
          if (!
#line 2374 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 357; /* *subqi3.lt0 */

        case 2:
          if (!
#line 2374 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 365; /* *subqi3.lt0 */

        case 3:
          if (!
#line 2374 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 373; /* *subqi3.lt0 */

        case 4:
          if (!
#line 2374 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 351; /* *subhi3.lt0 */

        case 5:
          if (!
#line 2374 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 359; /* *subhi3.lt0 */

        case 6:
          if (!
#line 2374 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 367; /* *subhi3.lt0 */

        case 7:
          if (!
#line 2374 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 375; /* *subhi3.lt0 */

        case 8:
          if (!
#line 2374 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 353; /* *subpsi3.lt0 */

        case 9:
          if (!
#line 2374 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 361; /* *subpsi3.lt0 */

        case 10:
          if (!
#line 2374 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 369; /* *subpsi3.lt0 */

        case 11:
          if (!
#line 2374 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 377; /* *subpsi3.lt0 */

        case 12:
          if (!
#line 2374 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 355; /* *subsi3.lt0 */

        case 13:
          if (!
#line 2374 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 363; /* *subsi3.lt0 */

        case 14:
          if (!
#line 2374 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 371; /* *subsi3.lt0 */

        case 15:
          if (!
#line 2374 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 379; /* *subsi3.lt0 */

        default:
          return -1;
        }

    case MULT:
      x5 = XEXP (x3, 0);
      operands[3] = x5;
      switch (pattern237 (x3))
        {
        case 0:
          x8 = XEXP (x4, 1);
          operands[2] = x8;
          switch (GET_CODE (operands[2]))
            {
            case REG:
            case SUBREG:
              if (!register_operand (operands[2], E_QImode))
                return -1;
              x6 = XVECEXP (x1, 0, 1);
              x7 = XEXP (x6, 0);
              if (GET_CODE (x7) != REG
                  || REGNO (x7) != 36
                  || GET_MODE (x7) != E_CCmode
                  || !
#line 2637 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
                return -1;
              return 493; /* *msubqi4 */

            case CONST_INT:
              if (!const_int_operand (operands[2], E_QImode))
                return -1;
              x6 = XVECEXP (x1, 0, 1);
              x7 = XEXP (x6, 0);
              operands[4] = x7;
              if (!scratch_operand (operands[4], E_QImode)
                  || !
#line 2666 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
                return -1;
              return 495; /* *msubqi4.const */

            default:
              return -1;
            }

        case 1:
          x8 = XEXP (x4, 1);
          switch (GET_CODE (x8))
            {
            case SIGN_EXTEND:
              if (pattern366 (x1) != 0
                  || !
#line 2749 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
                return -1;
              return 502; /* *msubqihi4 */

            case ZERO_EXTEND:
              if (pattern366 (x1) != 0
                  || !
#line 2815 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL
   && reload_completed
   && SIGN_EXTEND != ZERO_EXTEND))
                return -1;
              return 511; /* *sumsubqihi4 */

            case CONST_INT:
              operands[2] = x8;
              x6 = XVECEXP (x1, 0, 1);
              x7 = XEXP (x6, 0);
              operands[4] = x7;
              if (!scratch_operand (operands[4], E_QImode))
                return -1;
              if (s8_operand (operands[2], E_HImode)
                  && 
#line 2881 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
                return 515; /* *msubqihi4.sconst */
              if (!u8_operand (operands[2], E_HImode)
                  || !
#line 2972 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL
   && !s8_operand (operands[2], VOIDmode)))
                return -1;
              return 520; /* *sumsubqihi4.uconst */

            default:
              return -1;
            }

        case 2:
          x8 = XEXP (x4, 1);
          switch (GET_CODE (x8))
            {
            case ZERO_EXTEND:
              if (pattern366 (x1) != 0
                  || !
#line 2749 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
                return -1;
              return 503; /* *umsubqihi4 */

            case SIGN_EXTEND:
              if (pattern366 (x1) != 0
                  || !
#line 2815 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL
   && reload_completed
   && ZERO_EXTEND != SIGN_EXTEND))
                return -1;
              return 510; /* *usmsubqihi4 */

            case CONST_INT:
              operands[2] = x8;
              if (!u8_operand (operands[2], E_HImode))
                return -1;
              x6 = XVECEXP (x1, 0, 1);
              x7 = XEXP (x6, 0);
              operands[4] = x7;
              if (!scratch_operand (operands[4], E_QImode)
                  || !
#line 2881 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
                return -1;
              return 516; /* *umsubqihi4.uconst */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case ASHIFT:
      if (pattern224 (x3) != 0)
        return -1;
      x8 = XEXP (x4, 1);
      operands[2] = x8;
      x6 = XVECEXP (x1, 0, 1);
      x7 = XEXP (x6, 0);
      operands[4] = x7;
      if (!scratch_operand (operands[4], E_QImode))
        return -1;
      x9 = XEXP (x4, 0);
      switch (pattern356 (x9))
        {
        case 0:
          if (!
#line 2904 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
            return -1;
          return 517; /* *umsubqihi4.uconst.ashift */

        case 1:
          if (!
#line 2928 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
            return -1;
          return 518; /* *msubqihi4.sconst.ashift */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_63 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XVECEXP (x1, 0, 0);
  x4 = XEXP (x3, 1);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case SIGN_EXTEND:
      if (GET_MODE (x5) != E_HImode)
        return -1;
      x6 = XEXP (x4, 1);
      if (GET_CODE (x6) != CONST_INT)
        return -1;
      x7 = XEXP (x3, 0);
      operands[0] = x7;
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x4) != E_HImode)
        return -1;
      x8 = XEXP (x5, 0);
      operands[1] = x8;
      if (!register_operand (operands[1], E_QImode))
        return -1;
      if (XWINT (x6, 0) == 1L)
        {
          x9 = XEXP (x2, 0);
          if (GET_CODE (x9) == REG
              && REGNO (x9) == 36
              && GET_MODE (x9) == E_CCmode
              && 
#line 3085 "../../gcc/config/avr/avr.md"
(reload_completed))
            return 527; /* *ashiftqihi2.signx.1 */
        }
      x9 = XEXP (x2, 0);
      if (!scratch_operand (x9, E_QImode))
        return -1;
      operands[3] = x9;
      operands[2] = x6;
      if (const_2_to_6_operand (operands[2], E_HImode)
          && 
#line 3096 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
        return 528; /* *ashifthi3.signx.const */
      operands[2] = x9;
      if (XWINT (x6, 0) != 7L
          || !
#line 3114 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
        return -1;
      return 529; /* *ashifthi3.signx.const7 */

    case ZERO_EXTEND:
      if (GET_MODE (x5) != E_HImode)
        return -1;
      x7 = XEXP (x3, 0);
      operands[0] = x7;
      if (pattern226 (x1) != 0
          || !
#line 3132 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
        return -1;
      return 530; /* *ashifthi3.zerox.const */

    case REG:
    case SUBREG:
      operands[1] = x5;
      res = recog_46 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      if (GET_CODE (x5) != REG)
        return -1;
      switch (pattern170 (x1))
        {
        case 0:
          if (!
#line 642 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          return 3332; /* *ashldi3_insn */

        case 1:
          if (!
#line 642 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          return 3336; /* *ashldq3_insn */

        case 2:
          if (!
#line 642 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          return 3340; /* *ashludq3_insn */

        case 3:
          if (!
#line 642 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          return 3344; /* *ashlda3_insn */

        case 4:
          if (!
#line 642 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          return 3348; /* *ashluda3_insn */

        case 5:
          if (!
#line 642 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          return 3352; /* *ashlta3_insn */

        case 6:
          if (!
#line 642 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          return 3356; /* *ashluta3_insn */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_69 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (pattern99 (x1) != 0)
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      if (!register_operand (operands[0], E_HImode))
        return -1;
      x2 = XVECEXP (x1, 0, 0);
      x3 = XEXP (x2, 1);
      if (GET_MODE (x3) != E_HImode
          || !combine_pseudo_register_operand (operands[1], E_QImode)
          || !
#line 6456 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 807; /* *extendqihi2 */

    case E_PSImode:
      if (!register_operand (operands[0], E_PSImode))
        return -1;
      x2 = XVECEXP (x1, 0, 0);
      x3 = XEXP (x2, 1);
      if (GET_MODE (x3) != E_PSImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QImode:
          if (!combine_pseudo_register_operand (operands[1], E_QImode)
              || !
#line 6477 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 809; /* *extendqipsi2 */

        case E_HImode:
          if (!combine_pseudo_register_operand (operands[1], E_HImode)
              || !
#line 6519 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 813; /* *extendhipsi2 */

        default:
          return -1;
        }

    case E_SImode:
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x2 = XVECEXP (x1, 0, 0);
      x3 = XEXP (x2, 1);
      if (GET_MODE (x3) != E_SImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QImode:
          if (!combine_pseudo_register_operand (operands[1], E_QImode)
              || !
#line 6498 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 811; /* *extendqisi2 */

        case E_HImode:
          if (!combine_pseudo_register_operand (operands[1], E_HImode)
              || !
#line 6540 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 815; /* *extendhisi2 */

        case E_PSImode:
          if (!combine_pseudo_register_operand (operands[1], E_PSImode)
              || !
#line 6561 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 817; /* *extendpsisi2 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_76 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[0] = x4;
  if (!register_operand (operands[0], E_HImode))
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  x6 = XEXP (x5, 0);
  x7 = XEXP (x6, 0);
  operands[1] = x7;
  x8 = XVECEXP (x1, 0, 2);
  x9 = XEXP (x8, 0);
  operands[2] = x9;
  if (!scratch_operand (operands[2], E_HImode))
    return -1;
  if (
#line 7933 "../../gcc/config/avr/avr.md"
(!AVR_HAVE_EIJMP_EICALL))
    return 974; /* *tablejump_split */
  if (pnum_clobbers == NULL
      || !
#line 7954 "../../gcc/config/avr/avr.md"
(!AVR_HAVE_EIJMP_EICALL && reload_completed))
    return -1;
  *pnum_clobbers = 1;
  return 975; /* *tablejump */
}

 int
recog_78 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x3) != CLOBBER)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 36
      || GET_MODE (x4) != E_CCmode)
    return -1;
  x5 = XVECEXP (x1, 0, 0);
  x6 = XEXP (x5, 0);
  operands[0] = x6;
  x7 = XEXP (x2, 0);
  operands[2] = x7;
  if (!register_operand (operands[2], E_QImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      if (!register_operand (operands[0], E_QImode)
          || !const_operand (operands[1], E_QImode)
          || !
#line 885 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 119; /* *reload_inqi */

    case E_QQmode:
      if (!register_operand (operands[0], E_QQmode)
          || !const_operand (operands[1], E_QQmode)
          || !
#line 885 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 120; /* *reload_inqq */

    case E_UQQmode:
      if (!register_operand (operands[0], E_UQQmode)
          || !const_operand (operands[1], E_UQQmode)
          || !
#line 885 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 121; /* *reload_inuqq */

    case E_HImode:
      if (!l_register_operand (operands[0], E_HImode)
          || !immediate_operand (operands[1], E_HImode)
          || !
#line 950 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 123; /* *reload_inhi */

    case E_HQmode:
      if (!l_register_operand (operands[0], E_HQmode)
          || !immediate_operand (operands[1], E_HQmode)
          || !
#line 950 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 124; /* *reload_inhq */

    case E_UHQmode:
      if (!l_register_operand (operands[0], E_UHQmode)
          || !immediate_operand (operands[1], E_UHQmode)
          || !
#line 950 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 125; /* *reload_inuhq */

    case E_HAmode:
      if (!l_register_operand (operands[0], E_HAmode)
          || !immediate_operand (operands[1], E_HAmode)
          || !
#line 950 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 126; /* *reload_inha */

    case E_UHAmode:
      if (!l_register_operand (operands[0], E_UHAmode)
          || !immediate_operand (operands[1], E_UHAmode)
          || !
#line 950 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 127; /* *reload_inuha */

    case E_PSImode:
      if (!register_operand (operands[0], E_PSImode)
          || !immediate_operand (operands[1], E_PSImode)
          || !
#line 1125 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 138; /* *reload_inpsi */

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || !immediate_operand (operands[1], E_SImode)
          || !
#line 1182 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 141; /* *reload_insi */

    case E_SQmode:
      if (!register_operand (operands[0], E_SQmode)
          || !immediate_operand (operands[1], E_SQmode)
          || !
#line 1182 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 142; /* *reload_insi */

    case E_USQmode:
      if (!register_operand (operands[0], E_USQmode)
          || !immediate_operand (operands[1], E_USQmode)
          || !
#line 1182 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 143; /* *reload_insi */

    case E_SAmode:
      if (!register_operand (operands[0], E_SAmode)
          || !immediate_operand (operands[1], E_SAmode)
          || !
#line 1182 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 144; /* *reload_insi */

    case E_USAmode:
      if (!register_operand (operands[0], E_USAmode)
          || !immediate_operand (operands[1], E_USAmode)
          || !
#line 1182 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 145; /* *reload_insi */

    case E_SFmode:
      if (!register_operand (operands[0], E_SFmode)
          || !const_double_operand (operands[1], E_SFmode)
          || !
#line 1283 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 159; /* *reload_insf */

    default:
      return -1;
    }
}

 int
recog_86 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != MEM
      || GET_MODE (x3) != E_BLKmode)
    return -1;
  x4 = XEXP (x3, 0);
  if (pattern104 (x4, 
23) != 0
      || pattern310 (x1) != 0)
    return -1;
  x5 = XVECEXP (x1, 0, 2);
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 24
      || pattern27 (x1) != 0)
    return -1;
  x7 = XVECEXP (x1, 0, 6);
  x8 = XEXP (x7, 0);
  if (GET_CODE (x8) != REG
      || REGNO (x8) != 24
      || GET_MODE (x8) != E_HImode)
    return -1;
  x9 = XVECEXP (x1, 0, 7);
  if (pattern390 (x9, 
E_QImode, 
23) != 0)
    return -1;
  x10 = XVECEXP (x1, 0, 8);
  if (GET_CODE (x10) != CLOBBER)
    return -1;
  x11 = XEXP (x10, 0);
  if (GET_CODE (x11) != MEM
      || GET_MODE (x11) != E_QImode)
    return -1;
  x12 = XVECEXP (x1, 0, 9);
  if (GET_CODE (x12) != CLOBBER)
    return -1;
  x13 = XEXP (x12, 0);
  if (GET_CODE (x13) != REG
      || REGNO (x13) != 36
      || GET_MODE (x13) != E_CCmode)
    return -1;
  x14 = XVECEXP (x1, 0, 1);
  x15 = XVECEXP (x14, 0, 0);
  operands[0] = x15;
  if (!const_int_operand (operands[0], E_QImode))
    return -1;
  x16 = XEXP (x11, 0);
  operands[1] = x16;
  if (!io_address_operand (operands[1], E_QImode))
    return -1;
  switch (GET_MODE (x6))
    {
    case E_QImode:
      if (!
#line 1416 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 166; /* *cpymemx_qi */

    case E_HImode:
      if (!
#line 1416 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 167; /* *cpymemx_hi */

    default:
      return -1;
    }
}

 int
recog (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  recog_data.insn = NULL;
  switch (GET_CODE (x1))
    {
    case SET:
      return recog_89 (x1, insn, pnum_clobbers);

    case PARALLEL:
      switch (XVECLEN (x1, 0))
        {
        case 2:
          res = recog_72 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case 4:
          res = recog_77 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case 3:
          res = recog_84 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case 7:
          res = recog_85 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case 8:
          if (pattern28 (x1) == 0)
            {
              x2 = XVECEXP (x1, 0, 7);
              if (pattern390 (x2, 
E_CCmode, 
36) == 0)
                {
                  switch (pattern389 (x1))
                    {
                    case 0:
                      if (
#line 1351 "../../gcc/config/avr/avr.md"
(reload_completed))
                        return 162; /* *cpymem_qi */
                      break;

                    case 1:
                      if (
#line 1351 "../../gcc/config/avr/avr.md"
(reload_completed))
                        return 163; /* *cpymem_hi */
                      break;

                    default:
                      break;
                    }
                }
            }
          break;

        case 9:
          switch (pattern29 (x1))
            {
            case 0:
              return 164; /* cpymemx_qi */

            case 1:
              return 165; /* cpymemx_hi */

            default:
              break;
            }
          break;

        case 10:
          res = recog_86 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case 5:
          res = recog_87 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case 6:
          res = recog_88 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        default:
          break;
        }
      if (XVECLEN (x1, 0) < 6)
        return -1;
      operands[0] = x1;
      if (!set_some_operation (operands[0], E_VOIDmode))
        return -1;
      x3 = XVECEXP (x1, 0, 0);
      if (GET_CODE (x3) != USE)
        return -1;
      x4 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x4) != USE
          || pattern177 (x1, 
USE) != 0)
        return -1;
      x5 = XVECEXP (x1, 0, 5);
      if (GET_CODE (x5) != SET)
        return -1;
      x6 = XEXP (x3, 0);
      operands[1] = x6;
      if (!dreg_or_0_operand (operands[1], E_QImode))
        return -1;
      x7 = XEXP (x4, 0);
      operands[2] = x7;
      if (!const_int_operand (operands[2], E_QImode))
        return -1;
      x8 = XVECEXP (x1, 0, 2);
      x9 = XEXP (x8, 0);
      operands[3] = x9;
      if (!const_int_operand (operands[3], E_QImode))
        return -1;
      x10 = XVECEXP (x1, 0, 3);
      x11 = XEXP (x10, 0);
      operands[4] = x11;
      if (!const_int_operand (operands[4], E_QImode))
        return -1;
      x12 = XEXP (x5, 0);
      operands[5] = x12;
      if (!register_operand (operands[5], E_QImode))
        return -1;
      x13 = XEXP (x5, 1);
      operands[6] = x13;
      if (!const_int_operand (operands[6], E_QImode)
          || !
#line 1229 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 156; /* set_some */

    case CONST_INT:
      if (XWINT (x1, 0) != 0L)
        return -1;
      return 972; /* nop */

    case RETURN:
      if (
#line 8685 "../../gcc/config/avr/avr.md"
(reload_completed && avr_simple_epilogue ()))
        return 999; /* return */
      if (
#line 8691 "../../gcc/config/avr/avr.md"
(reload_completed
   && cfun->machine
   && !(cfun->machine->is_interrupt || cfun->machine->is_signal)
   && !cfun->machine->is_naked))
        return 1000; /* return_from_epilogue */
      if (
#line 8700 "../../gcc/config/avr/avr.md"
(reload_completed
   && cfun->machine
   && (cfun->machine->is_interrupt || cfun->machine->is_signal)
   && !cfun->machine->is_naked))
        return 1001; /* return_from_interrupt_epilogue */
      if (!
#line 8709 "../../gcc/config/avr/avr.md"
(reload_completed
   && cfun->machine
   && cfun->machine->is_naked))
        return -1;
      return 1002; /* return_from_naked_epilogue */

    default:
      return -1;
    }
}

 rtx_insn *
split_3 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  if (!register_operand (operands[0], E_HImode))
    return NULL;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != E_HImode)
    return NULL;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != E_HImode)
    return NULL;
  x5 = XEXP (x3, 1);
  switch (pattern283 (x5))
    {
    case 0:
      if (!(
#line 2469 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 2471 "../../gcc/config/avr/avr.md"
( reload_completed)))
        return NULL;
      return gen_split_271 (insn, operands);

    case 1:
      if (!(
#line 2517 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 2519 "../../gcc/config/avr/avr.md"
( reload_completed)))
        return NULL;
      return gen_split_274 (insn, operands);

    case 2:
      if (!(
#line 3153 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 3155 "../../gcc/config/avr/avr.md"
( reload_completed)))
        return NULL;
      return gen_split_307 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_4 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case ZERO_EXTEND:
      switch (GET_MODE (operands[0]))
        {
        case E_HImode:
          if (pattern195 (x2) != 0
              || !(
#line 2469 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 2471 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_272 (insn, operands);

        case E_PSImode:
          switch (pattern196 (x2))
            {
            case 0:
              if (!(
#line 4112 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 4114 "../../gcc/config/avr/avr.md"
( reload_completed)))
                return NULL;
              return gen_split_353 (insn, operands);

            case 1:
              if (!(
#line 4139 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 4141 "../../gcc/config/avr/avr.md"
( reload_completed)))
                return NULL;
              return gen_split_354 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case SIGN_EXTEND:
      if (GET_MODE (x3) != E_HImode
          || !register_operand (operands[0], E_HImode)
          || GET_MODE (x2) != E_HImode)
        return NULL;
      x4 = XEXP (x2, 0);
      if (GET_MODE (x4) != E_HImode)
        return NULL;
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      if (!register_operand (operands[1], E_QImode))
        return NULL;
      x6 = XEXP (x3, 0);
      operands[2] = x6;
      if (!register_operand (operands[2], E_QImode)
          || !(
#line 2492 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 2494 "../../gcc/config/avr/avr.md"
( reload_completed)))
        return NULL;
      return gen_split_273 (insn, operands);

    case REG:
    case SUBREG:
      operands[2] = x3;
      if (!register_operand (operands[2], E_HImode)
          || !register_operand (operands[0], E_HImode)
          || GET_MODE (x2) != E_HImode)
        return NULL;
      x4 = XEXP (x2, 0);
      if (GET_MODE (x4) != E_HImode)
        return NULL;
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      if (!register_operand (operands[1], E_QImode)
          || !(
#line 3178 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 3180 "../../gcc/config/avr/avr.md"
( reload_completed)))
        return NULL;
      return gen_split_308 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_5 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  if (pattern126 (x3) != 0)
    return NULL;
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  x7 = XEXP (x6, 0);
  operands[1] = x7;
  if (!register_operand (operands[1], E_QImode))
    return NULL;
  x8 = XEXP (x3, 1);
  switch (pattern283 (x8))
    {
    case 0:
      if (!(
#line 2542 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 2544 "../../gcc/config/avr/avr.md"
( reload_completed)))
        return NULL;
      return gen_split_275 (insn, operands);

    case 1:
      if (!(
#line 2566 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 2568 "../../gcc/config/avr/avr.md"
( reload_completed)))
        return NULL;
      return gen_split_276 (insn, operands);

    case 2:
      if (!(
#line 3205 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 3207 "../../gcc/config/avr/avr.md"
( reload_completed)))
        return NULL;
      return gen_split_309 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_6 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != CONST_INT)
    return NULL;
  operands[2] = x3;
  if (pattern164 (x1) == 0
      && 
#line 5028 "../../gcc/config/avr/avr.md"
( reload_completed))
    return gen_split_396 (insn, operands);
  x4 = XEXP (x1, 0);
  operands[0] = x4;
  switch (XWINT (x3, 0))
    {
    case 1L:
      switch (pattern203 (x2))
        {
        case 0:
          if (!
#line 5101 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_397 (insn, operands);

        case 1:
          if (!
#line 5143 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_399 (insn, operands);

        case 2:
          if (!
#line 5185 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_401 (insn, operands);

        default:
          return NULL;
        }

    case 15L:
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x2) != E_HImode
          || !register_operand (operands[1], E_HImode)
          || !
#line 5122 "../../gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_398 (insn, operands);

    case 23L:
      if (!register_operand (operands[0], E_PSImode)
          || GET_MODE (x2) != E_PSImode
          || !register_operand (operands[1], E_PSImode)
          || !
#line 5164 "../../gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_400 (insn, operands);

    case 31L:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x2) != E_SImode
          || !register_operand (operands[1], E_SImode)
          || !
#line 5206 "../../gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_402 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_9 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  switch (pattern23 (x1))
    {
    case 0:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(UQQmode != QQmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1031 (insn, operands);

    case 1:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(HQmode != QQmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1032 (insn, operands);

    case 2:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(UHQmode != QQmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1033 (insn, operands);

    case 3:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(HAmode != QQmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1034 (insn, operands);

    case 4:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(UHAmode != QQmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1035 (insn, operands);

    case 5:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(SQmode != QQmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1036 (insn, operands);

    case 6:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(USQmode != QQmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1037 (insn, operands);

    case 7:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(SAmode != QQmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1038 (insn, operands);

    case 8:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(USAmode != QQmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1039 (insn, operands);

    case 9:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(DQmode != QQmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1040 (insn, operands);

    case 10:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(UDQmode != QQmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1041 (insn, operands);

    case 11:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(DAmode != QQmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1042 (insn, operands);

    case 12:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(UDAmode != QQmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1043 (insn, operands);

    case 13:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(TAmode != QQmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1044 (insn, operands);

    case 14:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(UTAmode != QQmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1045 (insn, operands);

    case 15:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(QImode != QQmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1046 (insn, operands);

    case 16:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(HImode != QQmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1047 (insn, operands);

    case 17:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(SImode != QQmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1048 (insn, operands);

    case 18:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(DImode != QQmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1049 (insn, operands);

    case 19:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(QQmode != UQQmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1050 (insn, operands);

    case 20:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(HQmode != UQQmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1051 (insn, operands);

    case 21:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(UHQmode != UQQmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1052 (insn, operands);

    case 22:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(HAmode != UQQmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1053 (insn, operands);

    case 23:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(UHAmode != UQQmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1054 (insn, operands);

    case 24:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(SQmode != UQQmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1055 (insn, operands);

    case 25:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(USQmode != UQQmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1056 (insn, operands);

    case 26:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(SAmode != UQQmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1057 (insn, operands);

    case 27:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(USAmode != UQQmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1058 (insn, operands);

    case 28:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(DQmode != UQQmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1059 (insn, operands);

    case 29:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(UDQmode != UQQmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1060 (insn, operands);

    case 30:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(DAmode != UQQmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1061 (insn, operands);

    case 31:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(UDAmode != UQQmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1062 (insn, operands);

    case 32:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(TAmode != UQQmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1063 (insn, operands);

    case 33:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(UTAmode != UQQmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1064 (insn, operands);

    case 34:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(QImode != UQQmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1065 (insn, operands);

    case 35:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(HImode != UQQmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1066 (insn, operands);

    case 36:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(SImode != UQQmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1067 (insn, operands);

    case 37:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(DImode != UQQmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1068 (insn, operands);

    case 38:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(QQmode != HQmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1069 (insn, operands);

    case 39:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(UQQmode != HQmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1070 (insn, operands);

    case 40:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(UHQmode != HQmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1071 (insn, operands);

    case 41:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(HAmode != HQmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1072 (insn, operands);

    case 42:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(UHAmode != HQmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1073 (insn, operands);

    case 43:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(SQmode != HQmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1074 (insn, operands);

    case 44:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(USQmode != HQmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1075 (insn, operands);

    case 45:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(SAmode != HQmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1076 (insn, operands);

    case 46:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(USAmode != HQmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1077 (insn, operands);

    case 47:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(DQmode != HQmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1078 (insn, operands);

    case 48:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(UDQmode != HQmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1079 (insn, operands);

    case 49:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(DAmode != HQmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1080 (insn, operands);

    case 50:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(UDAmode != HQmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1081 (insn, operands);

    case 51:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(TAmode != HQmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1082 (insn, operands);

    case 52:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(UTAmode != HQmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1083 (insn, operands);

    case 53:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(QImode != HQmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1084 (insn, operands);

    case 54:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(HImode != HQmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1085 (insn, operands);

    case 55:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(SImode != HQmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1086 (insn, operands);

    case 56:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(DImode != HQmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1087 (insn, operands);

    case 57:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(QQmode != UHQmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1088 (insn, operands);

    case 58:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(UQQmode != UHQmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1089 (insn, operands);

    case 59:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(HQmode != UHQmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1090 (insn, operands);

    case 60:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(HAmode != UHQmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1091 (insn, operands);

    case 61:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(UHAmode != UHQmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1092 (insn, operands);

    case 62:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(SQmode != UHQmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1093 (insn, operands);

    case 63:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(USQmode != UHQmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1094 (insn, operands);

    case 64:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(SAmode != UHQmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1095 (insn, operands);

    case 65:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(USAmode != UHQmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1096 (insn, operands);

    case 66:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(DQmode != UHQmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1097 (insn, operands);

    case 67:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(UDQmode != UHQmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1098 (insn, operands);

    case 68:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(DAmode != UHQmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1099 (insn, operands);

    case 69:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(UDAmode != UHQmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1100 (insn, operands);

    case 70:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(TAmode != UHQmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1101 (insn, operands);

    case 71:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(UTAmode != UHQmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1102 (insn, operands);

    case 72:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(QImode != UHQmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1103 (insn, operands);

    case 73:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(HImode != UHQmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1104 (insn, operands);

    case 74:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(SImode != UHQmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1105 (insn, operands);

    case 75:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(DImode != UHQmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1106 (insn, operands);

    case 76:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(QQmode != HAmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1107 (insn, operands);

    case 77:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(UQQmode != HAmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1108 (insn, operands);

    case 78:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(HQmode != HAmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1109 (insn, operands);

    case 79:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(UHQmode != HAmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1110 (insn, operands);

    case 80:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(UHAmode != HAmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1111 (insn, operands);

    case 81:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(SQmode != HAmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1112 (insn, operands);

    case 82:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(USQmode != HAmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1113 (insn, operands);

    case 83:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(SAmode != HAmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1114 (insn, operands);

    case 84:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(USAmode != HAmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1115 (insn, operands);

    case 85:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(DQmode != HAmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1116 (insn, operands);

    case 86:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(UDQmode != HAmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1117 (insn, operands);

    case 87:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(DAmode != HAmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1118 (insn, operands);

    case 88:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(UDAmode != HAmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1119 (insn, operands);

    case 89:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(TAmode != HAmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1120 (insn, operands);

    case 90:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(UTAmode != HAmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1121 (insn, operands);

    case 91:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(QImode != HAmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1122 (insn, operands);

    case 92:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(HImode != HAmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1123 (insn, operands);

    case 93:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(SImode != HAmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1124 (insn, operands);

    case 94:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(DImode != HAmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1125 (insn, operands);

    case 95:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(QQmode != UHAmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1126 (insn, operands);

    case 96:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(UQQmode != UHAmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1127 (insn, operands);

    case 97:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(HQmode != UHAmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1128 (insn, operands);

    case 98:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(UHQmode != UHAmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1129 (insn, operands);

    case 99:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(HAmode != UHAmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1130 (insn, operands);

    case 100:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(SQmode != UHAmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1131 (insn, operands);

    case 101:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(USQmode != UHAmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1132 (insn, operands);

    case 102:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(SAmode != UHAmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1133 (insn, operands);

    case 103:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(USAmode != UHAmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1134 (insn, operands);

    case 104:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(DQmode != UHAmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1135 (insn, operands);

    case 105:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(UDQmode != UHAmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1136 (insn, operands);

    case 106:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(DAmode != UHAmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1137 (insn, operands);

    case 107:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(UDAmode != UHAmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1138 (insn, operands);

    case 108:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(TAmode != UHAmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1139 (insn, operands);

    case 109:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(UTAmode != UHAmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1140 (insn, operands);

    case 110:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(QImode != UHAmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1141 (insn, operands);

    case 111:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(HImode != UHAmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1142 (insn, operands);

    case 112:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(SImode != UHAmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1143 (insn, operands);

    case 113:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(DImode != UHAmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1144 (insn, operands);

    case 114:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(QQmode != SQmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1145 (insn, operands);

    case 115:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(UQQmode != SQmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1146 (insn, operands);

    case 116:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(HQmode != SQmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1147 (insn, operands);

    case 117:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(UHQmode != SQmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1148 (insn, operands);

    case 118:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(HAmode != SQmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1149 (insn, operands);

    case 119:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(UHAmode != SQmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1150 (insn, operands);

    case 120:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(USQmode != SQmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1151 (insn, operands);

    case 121:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(SAmode != SQmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1152 (insn, operands);

    case 122:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(USAmode != SQmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1153 (insn, operands);

    case 123:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(DQmode != SQmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1154 (insn, operands);

    case 124:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(UDQmode != SQmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1155 (insn, operands);

    case 125:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(DAmode != SQmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1156 (insn, operands);

    case 126:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(UDAmode != SQmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1157 (insn, operands);

    case 127:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(TAmode != SQmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1158 (insn, operands);

    case 128:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(UTAmode != SQmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1159 (insn, operands);

    case 129:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(QImode != SQmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1160 (insn, operands);

    case 130:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(HImode != SQmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1161 (insn, operands);

    case 131:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(SImode != SQmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1162 (insn, operands);

    case 132:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(DImode != SQmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1163 (insn, operands);

    case 133:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(QQmode != USQmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1164 (insn, operands);

    case 134:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(UQQmode != USQmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1165 (insn, operands);

    case 135:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(HQmode != USQmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1166 (insn, operands);

    case 136:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(UHQmode != USQmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1167 (insn, operands);

    case 137:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(HAmode != USQmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1168 (insn, operands);

    case 138:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(UHAmode != USQmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1169 (insn, operands);

    case 139:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(SQmode != USQmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1170 (insn, operands);

    case 140:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(SAmode != USQmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1171 (insn, operands);

    case 141:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(USAmode != USQmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1172 (insn, operands);

    case 142:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(DQmode != USQmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1173 (insn, operands);

    case 143:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(UDQmode != USQmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1174 (insn, operands);

    case 144:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(DAmode != USQmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1175 (insn, operands);

    case 145:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(UDAmode != USQmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1176 (insn, operands);

    case 146:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(TAmode != USQmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1177 (insn, operands);

    case 147:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(UTAmode != USQmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1178 (insn, operands);

    case 148:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(QImode != USQmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1179 (insn, operands);

    case 149:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(HImode != USQmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1180 (insn, operands);

    case 150:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(SImode != USQmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1181 (insn, operands);

    case 151:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(DImode != USQmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1182 (insn, operands);

    case 152:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(QQmode != SAmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1183 (insn, operands);

    case 153:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(UQQmode != SAmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1184 (insn, operands);

    case 154:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(HQmode != SAmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1185 (insn, operands);

    case 155:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(UHQmode != SAmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1186 (insn, operands);

    case 156:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(HAmode != SAmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1187 (insn, operands);

    case 157:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(UHAmode != SAmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1188 (insn, operands);

    case 158:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(SQmode != SAmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1189 (insn, operands);

    case 159:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(USQmode != SAmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1190 (insn, operands);

    case 160:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(USAmode != SAmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1191 (insn, operands);

    case 161:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(DQmode != SAmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1192 (insn, operands);

    case 162:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(UDQmode != SAmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1193 (insn, operands);

    case 163:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(DAmode != SAmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1194 (insn, operands);

    case 164:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(UDAmode != SAmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1195 (insn, operands);

    case 165:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(TAmode != SAmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1196 (insn, operands);

    case 166:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(UTAmode != SAmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1197 (insn, operands);

    case 167:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(QImode != SAmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1198 (insn, operands);

    case 168:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(HImode != SAmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1199 (insn, operands);

    case 169:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(SImode != SAmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1200 (insn, operands);

    case 170:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(DImode != SAmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1201 (insn, operands);

    case 171:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(QQmode != USAmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1202 (insn, operands);

    case 172:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(UQQmode != USAmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1203 (insn, operands);

    case 173:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(HQmode != USAmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1204 (insn, operands);

    case 174:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(UHQmode != USAmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1205 (insn, operands);

    case 175:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(HAmode != USAmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1206 (insn, operands);

    case 176:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(UHAmode != USAmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1207 (insn, operands);

    case 177:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(SQmode != USAmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1208 (insn, operands);

    case 178:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(USQmode != USAmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1209 (insn, operands);

    case 179:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(SAmode != USAmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1210 (insn, operands);

    case 180:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(DQmode != USAmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1211 (insn, operands);

    case 181:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(UDQmode != USAmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1212 (insn, operands);

    case 182:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(DAmode != USAmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1213 (insn, operands);

    case 183:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(UDAmode != USAmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1214 (insn, operands);

    case 184:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(TAmode != USAmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1215 (insn, operands);

    case 185:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(UTAmode != USAmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1216 (insn, operands);

    case 186:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(QImode != USAmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1217 (insn, operands);

    case 187:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(HImode != USAmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1218 (insn, operands);

    case 188:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(SImode != USAmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1219 (insn, operands);

    case 189:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(DImode != USAmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1220 (insn, operands);

    case 190:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(QQmode != DQmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1221 (insn, operands);

    case 191:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(UQQmode != DQmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1222 (insn, operands);

    case 192:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(HQmode != DQmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1223 (insn, operands);

    case 193:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(UHQmode != DQmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1224 (insn, operands);

    case 194:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(HAmode != DQmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1225 (insn, operands);

    case 195:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(UHAmode != DQmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1226 (insn, operands);

    case 196:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(SQmode != DQmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1227 (insn, operands);

    case 197:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(USQmode != DQmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1228 (insn, operands);

    case 198:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(SAmode != DQmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1229 (insn, operands);

    case 199:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(USAmode != DQmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1230 (insn, operands);

    case 200:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(UDQmode != DQmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1231 (insn, operands);

    case 201:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(DAmode != DQmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1232 (insn, operands);

    case 202:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(UDAmode != DQmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1233 (insn, operands);

    case 203:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(TAmode != DQmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1234 (insn, operands);

    case 204:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(UTAmode != DQmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1235 (insn, operands);

    case 205:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(QImode != DQmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1236 (insn, operands);

    case 206:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(HImode != DQmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1237 (insn, operands);

    case 207:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(SImode != DQmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1238 (insn, operands);

    case 208:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(DImode != DQmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1239 (insn, operands);

    case 209:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(QQmode != UDQmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1240 (insn, operands);

    case 210:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(UQQmode != UDQmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1241 (insn, operands);

    case 211:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(HQmode != UDQmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1242 (insn, operands);

    case 212:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(UHQmode != UDQmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1243 (insn, operands);

    case 213:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(HAmode != UDQmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1244 (insn, operands);

    case 214:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(UHAmode != UDQmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1245 (insn, operands);

    case 215:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(SQmode != UDQmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1246 (insn, operands);

    case 216:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(USQmode != UDQmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1247 (insn, operands);

    case 217:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(SAmode != UDQmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1248 (insn, operands);

    case 218:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(USAmode != UDQmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1249 (insn, operands);

    case 219:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(DQmode != UDQmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1250 (insn, operands);

    case 220:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(DAmode != UDQmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1251 (insn, operands);

    case 221:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(UDAmode != UDQmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1252 (insn, operands);

    case 222:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(TAmode != UDQmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1253 (insn, operands);

    case 223:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(UTAmode != UDQmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1254 (insn, operands);

    case 224:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(QImode != UDQmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1255 (insn, operands);

    case 225:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(HImode != UDQmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1256 (insn, operands);

    case 226:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(SImode != UDQmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1257 (insn, operands);

    case 227:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(DImode != UDQmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1258 (insn, operands);

    case 228:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(QQmode != DAmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1259 (insn, operands);

    case 229:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(UQQmode != DAmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1260 (insn, operands);

    case 230:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(HQmode != DAmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1261 (insn, operands);

    case 231:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(UHQmode != DAmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1262 (insn, operands);

    case 232:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(HAmode != DAmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1263 (insn, operands);

    case 233:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(UHAmode != DAmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1264 (insn, operands);

    case 234:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(SQmode != DAmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1265 (insn, operands);

    case 235:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(USQmode != DAmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1266 (insn, operands);

    case 236:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(SAmode != DAmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1267 (insn, operands);

    case 237:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(USAmode != DAmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1268 (insn, operands);

    case 238:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(DQmode != DAmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1269 (insn, operands);

    case 239:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(UDQmode != DAmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1270 (insn, operands);

    case 240:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(UDAmode != DAmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1271 (insn, operands);

    case 241:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(TAmode != DAmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1272 (insn, operands);

    case 242:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(UTAmode != DAmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1273 (insn, operands);

    case 243:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(QImode != DAmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1274 (insn, operands);

    case 244:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(HImode != DAmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1275 (insn, operands);

    case 245:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(SImode != DAmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1276 (insn, operands);

    case 246:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(DImode != DAmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1277 (insn, operands);

    case 247:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(QQmode != UDAmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1278 (insn, operands);

    case 248:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(UQQmode != UDAmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1279 (insn, operands);

    case 249:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(HQmode != UDAmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1280 (insn, operands);

    case 250:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(UHQmode != UDAmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1281 (insn, operands);

    case 251:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(HAmode != UDAmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1282 (insn, operands);

    case 252:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(UHAmode != UDAmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1283 (insn, operands);

    case 253:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(SQmode != UDAmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1284 (insn, operands);

    case 254:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(USQmode != UDAmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1285 (insn, operands);

    case 255:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(SAmode != UDAmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1286 (insn, operands);

    case 256:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(USAmode != UDAmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1287 (insn, operands);

    case 257:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(DQmode != UDAmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1288 (insn, operands);

    case 258:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(UDQmode != UDAmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1289 (insn, operands);

    case 259:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(DAmode != UDAmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1290 (insn, operands);

    case 260:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(TAmode != UDAmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1291 (insn, operands);

    case 261:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(UTAmode != UDAmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1292 (insn, operands);

    case 262:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(QImode != UDAmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1293 (insn, operands);

    case 263:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(HImode != UDAmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1294 (insn, operands);

    case 264:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(SImode != UDAmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1295 (insn, operands);

    case 265:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(DImode != UDAmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1296 (insn, operands);

    case 266:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(QQmode != TAmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1297 (insn, operands);

    case 267:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(UQQmode != TAmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1298 (insn, operands);

    case 268:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(HQmode != TAmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1299 (insn, operands);

    case 269:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(UHQmode != TAmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1300 (insn, operands);

    case 270:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(HAmode != TAmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1301 (insn, operands);

    case 271:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(UHAmode != TAmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1302 (insn, operands);

    case 272:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(SQmode != TAmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1303 (insn, operands);

    case 273:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(USQmode != TAmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1304 (insn, operands);

    case 274:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(SAmode != TAmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1305 (insn, operands);

    case 275:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(USAmode != TAmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1306 (insn, operands);

    case 276:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(DQmode != TAmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1307 (insn, operands);

    case 277:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(UDQmode != TAmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1308 (insn, operands);

    case 278:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(DAmode != TAmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1309 (insn, operands);

    case 279:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(UDAmode != TAmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1310 (insn, operands);

    case 280:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(UTAmode != TAmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1311 (insn, operands);

    case 281:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(QImode != TAmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1312 (insn, operands);

    case 282:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(HImode != TAmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1313 (insn, operands);

    case 283:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(SImode != TAmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1314 (insn, operands);

    case 284:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(DImode != TAmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1315 (insn, operands);

    case 285:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(QQmode != UTAmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1316 (insn, operands);

    case 286:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(UQQmode != UTAmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1317 (insn, operands);

    case 287:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(HQmode != UTAmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1318 (insn, operands);

    case 288:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(UHQmode != UTAmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1319 (insn, operands);

    case 289:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(HAmode != UTAmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1320 (insn, operands);

    case 290:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(UHAmode != UTAmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1321 (insn, operands);

    case 291:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(SQmode != UTAmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1322 (insn, operands);

    case 292:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(USQmode != UTAmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1323 (insn, operands);

    case 293:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(SAmode != UTAmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1324 (insn, operands);

    case 294:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(USAmode != UTAmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1325 (insn, operands);

    case 295:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(DQmode != UTAmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1326 (insn, operands);

    case 296:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(UDQmode != UTAmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1327 (insn, operands);

    case 297:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(DAmode != UTAmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1328 (insn, operands);

    case 298:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(UDAmode != UTAmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1329 (insn, operands);

    case 299:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(TAmode != UTAmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1330 (insn, operands);

    case 300:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(QImode != UTAmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1331 (insn, operands);

    case 301:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(HImode != UTAmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1332 (insn, operands);

    case 302:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(SImode != UTAmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1333 (insn, operands);

    case 303:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(DImode != UTAmode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1334 (insn, operands);

    case 304:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(QQmode != QImode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1335 (insn, operands);

    case 305:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(UQQmode != QImode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1336 (insn, operands);

    case 306:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(HQmode != QImode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1337 (insn, operands);

    case 307:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(UHQmode != QImode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1338 (insn, operands);

    case 308:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(HAmode != QImode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1339 (insn, operands);

    case 309:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(UHAmode != QImode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1340 (insn, operands);

    case 310:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(SQmode != QImode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1341 (insn, operands);

    case 311:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(USQmode != QImode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1342 (insn, operands);

    case 312:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(SAmode != QImode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1343 (insn, operands);

    case 313:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(USAmode != QImode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1344 (insn, operands);

    case 314:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(DQmode != QImode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1345 (insn, operands);

    case 315:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(UDQmode != QImode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1346 (insn, operands);

    case 316:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(DAmode != QImode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1347 (insn, operands);

    case 317:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(UDAmode != QImode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1348 (insn, operands);

    case 318:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(TAmode != QImode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1349 (insn, operands);

    case 319:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(UTAmode != QImode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1350 (insn, operands);

    case 320:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(HImode != QImode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1351 (insn, operands);

    case 321:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(SImode != QImode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1352 (insn, operands);

    case 322:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(DImode != QImode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1353 (insn, operands);

    case 323:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(QQmode != HImode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1354 (insn, operands);

    case 324:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(UQQmode != HImode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1355 (insn, operands);

    case 325:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(HQmode != HImode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1356 (insn, operands);

    case 326:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(UHQmode != HImode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1357 (insn, operands);

    case 327:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(HAmode != HImode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1358 (insn, operands);

    case 328:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(UHAmode != HImode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1359 (insn, operands);

    case 329:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(SQmode != HImode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1360 (insn, operands);

    case 330:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(USQmode != HImode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1361 (insn, operands);

    case 331:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(SAmode != HImode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1362 (insn, operands);

    case 332:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(USAmode != HImode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1363 (insn, operands);

    case 333:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(DQmode != HImode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1364 (insn, operands);

    case 334:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(UDQmode != HImode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1365 (insn, operands);

    case 335:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(DAmode != HImode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1366 (insn, operands);

    case 336:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(UDAmode != HImode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1367 (insn, operands);

    case 337:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(TAmode != HImode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1368 (insn, operands);

    case 338:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(UTAmode != HImode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1369 (insn, operands);

    case 339:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(QImode != HImode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1370 (insn, operands);

    case 340:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(SImode != HImode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1371 (insn, operands);

    case 341:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(DImode != HImode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1372 (insn, operands);

    case 342:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(QQmode != SImode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1373 (insn, operands);

    case 343:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(UQQmode != SImode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1374 (insn, operands);

    case 344:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(HQmode != SImode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1375 (insn, operands);

    case 345:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(UHQmode != SImode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1376 (insn, operands);

    case 346:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(HAmode != SImode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1377 (insn, operands);

    case 347:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(UHAmode != SImode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1378 (insn, operands);

    case 348:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(SQmode != SImode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1379 (insn, operands);

    case 349:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(USQmode != SImode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1380 (insn, operands);

    case 350:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(SAmode != SImode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1381 (insn, operands);

    case 351:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(USAmode != SImode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1382 (insn, operands);

    case 352:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(DQmode != SImode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1383 (insn, operands);

    case 353:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(UDQmode != SImode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1384 (insn, operands);

    case 354:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(DAmode != SImode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1385 (insn, operands);

    case 355:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(UDAmode != SImode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1386 (insn, operands);

    case 356:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(TAmode != SImode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1387 (insn, operands);

    case 357:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(UTAmode != SImode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1388 (insn, operands);

    case 358:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(QImode != SImode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1389 (insn, operands);

    case 359:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(HImode != SImode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1390 (insn, operands);

    case 360:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(DImode != SImode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1391 (insn, operands);

    case 361:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(QQmode != DImode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1392 (insn, operands);

    case 362:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(UQQmode != DImode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1393 (insn, operands);

    case 363:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(HQmode != DImode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1394 (insn, operands);

    case 364:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(UHQmode != DImode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1395 (insn, operands);

    case 365:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(HAmode != DImode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1396 (insn, operands);

    case 366:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(UHAmode != DImode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1397 (insn, operands);

    case 367:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(SQmode != DImode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1398 (insn, operands);

    case 368:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(USQmode != DImode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1399 (insn, operands);

    case 369:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(SAmode != DImode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1400 (insn, operands);

    case 370:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(USAmode != DImode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1401 (insn, operands);

    case 371:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(DQmode != DImode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1402 (insn, operands);

    case 372:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(UDQmode != DImode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1403 (insn, operands);

    case 373:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(DAmode != DImode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1404 (insn, operands);

    case 374:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(UDAmode != DImode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1405 (insn, operands);

    case 375:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(TAmode != DImode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1406 (insn, operands);

    case 376:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(UTAmode != DImode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1407 (insn, operands);

    case 377:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(QImode != DImode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1408 (insn, operands);

    case 378:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(HImode != DImode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1409 (insn, operands);

    case 379:
      if (!(
#line 62 "../../gcc/config/avr/avr-fixed.md"
(SImode != DImode) && 
#line 64 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1410 (insn, operands);

    default:
      return NULL;
    }
}
