/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern4 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[1]))
    {
    case E_QImode:
      if (!register_operand (operands[1], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!register_operand (operands[1], E_HImode))
        return -1;
      return 1;

    case E_PSImode:
      if (!register_operand (operands[1], E_PSImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern12 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[4] = x5;
  x6 = XEXP (x2, 1);
  operands[2] = x6;
  x7 = XEXP (x1, 1);
  operands[3] = x7;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x1) != E_HImode
          || GET_MODE (x2) != E_HImode
          || GET_MODE (x3) != E_HImode
          || !register_operand (operands[1], E_HImode)
          || !const_0_to_15_operand (operands[4], E_QImode)
          || !single_one_operand (operands[2], E_HImode)
          || !register_operand (operands[3], E_HImode))
        return -1;
      return 0;

    case E_PSImode:
      if (!register_operand (operands[0], E_PSImode)
          || GET_MODE (x1) != E_PSImode
          || GET_MODE (x2) != E_PSImode
          || GET_MODE (x3) != E_PSImode
          || !register_operand (operands[1], E_PSImode)
          || !const_0_to_23_operand (operands[4], E_QImode)
          || !single_one_operand (operands[2], E_PSImode)
          || !register_operand (operands[3], E_PSImode))
        return -1;
      return 1;

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode
          || GET_MODE (x2) != E_SImode
          || GET_MODE (x3) != E_SImode
          || !register_operand (operands[1], E_SImode)
          || !const_0_to_31_operand (operands[4], E_QImode)
          || !single_one_operand (operands[2], E_SImode)
          || !register_operand (operands[3], E_SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern28 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != MEM
      || GET_MODE (x3) != E_BLKmode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 30
      || GET_MODE (x4) != E_HImode)
    return -1;
  x5 = XEXP (x2, 0);
  if (GET_CODE (x5) != MEM
      || GET_MODE (x5) != E_BLKmode)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 26
      || GET_MODE (x6) != E_HImode)
    return -1;
  x7 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x7) != UNSPEC
      || XVECLEN (x7, 0) != 1
      || XINT (x7, 1) != 1)
    return -1;
  x8 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x8) != USE
      || pattern27 (x1) != 0)
    return -1;
  return 0;
}

int
pattern33 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x5 = XEXP (x1, 0);
  operands[0] = x5;
  x6 = XEXP (x3, 0);
  operands[1] = x6;
  x7 = XEXP (x2, 1);
  operands[2] = x7;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      return pattern32 (x2, 
E_QImode); /* [-1, 3] */

    case E_HImode:
      res = pattern32 (x2, 
E_HImode);
      if (res >= 0)
        return res + 4; /* [4, 7] */
      return -1;

    case E_PSImode:
      res = pattern32 (x2, 
E_PSImode);
      if (res >= 0)
        return res + 8; /* [8, 11] */
      return -1;

    case E_SImode:
      res = pattern32 (x2, 
E_SImode);
      if (res >= 0)
        return res + 12; /* [12, 15] */
      return -1;

    default:
      return -1;
    }
}

int
pattern44 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_QImode)
    return -1;
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x1, 0);
  operands[0] = x5;
  return pattern43 (x2); /* [-1, 0] */
}

int
pattern49 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_HImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != ZERO_EXTEND
      || GET_MODE (x4) != E_HImode)
    return -1;
  x5 = XEXP (x3, 1);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x6 = XEXP (x1, 0);
  operands[0] = x6;
  if (!register_operand (operands[0], E_PSImode)
      || GET_MODE (x2) != E_PSImode)
    return -1;
  x7 = XEXP (x4, 0);
  operands[1] = x7;
  if (!register_operand (operands[1], E_QImode))
    return -1;
  return 0;
}

int
pattern55 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_QImode)
    return -1;
  x3 = XEXP (x2, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x4 = XEXP (x2, 0);
  operands[0] = x4;
  if (!register_operand (operands[0], E_QImode))
    return -1;
  x5 = XEXP (x2, 2);
  operands[1] = x5;
  if (!const_0_to_7_operand (operands[1], E_QImode))
    return -1;
  x6 = XEXP (x1, 1);
  if (GET_MODE (x6) != E_QImode)
    return -1;
  x7 = XEXP (x6, 0);
  operands[2] = x7;
  if (!register_operand (operands[2], E_QImode))
    return -1;
  x8 = XEXP (x6, 1);
  operands[3] = x8;
  if (!const_0_to_7_operand (operands[3], E_QImode))
    return -1;
  return 0;
}

int
pattern61 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !nonmemory_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern65 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (REGNO (x3) != 18)
    return -1;
  x4 = XEXP (x1, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 18)
    return -1;
  x5 = XEXP (x2, 1);
  switch (GET_CODE (x5))
    {
    case REG:
      if (REGNO (x5) != 10)
        return -1;
      switch (GET_MODE (x4))
        {
        case E_UDQmode:
          if (GET_MODE (x2) != E_UDQmode
              || GET_MODE (x3) != E_UDQmode
              || GET_MODE (x5) != E_UDQmode)
            return -1;
          return 0;

        case E_UDAmode:
          if (GET_MODE (x2) != E_UDAmode
              || GET_MODE (x3) != E_UDAmode
              || GET_MODE (x5) != E_UDAmode)
            return -1;
          return 1;

        case E_UTAmode:
          if (GET_MODE (x2) != E_UTAmode
              || GET_MODE (x3) != E_UTAmode
              || GET_MODE (x5) != E_UTAmode)
            return -1;
          return 2;

        default:
          return -1;
        }

    case CONST_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
      operands[0] = x5;
      switch (GET_MODE (x4))
        {
        case E_UDQmode:
          if (GET_MODE (x2) != E_UDQmode
              || GET_MODE (x3) != E_UDQmode
              || !const_operand (operands[0], E_UDQmode))
            return -1;
          return 3;

        case E_UDAmode:
          if (GET_MODE (x2) != E_UDAmode
              || GET_MODE (x3) != E_UDAmode
              || !const_operand (operands[0], E_UDAmode))
            return -1;
          return 4;

        case E_UTAmode:
          if (GET_MODE (x2) != E_UTAmode
              || GET_MODE (x3) != E_UTAmode
              || !const_operand (operands[0], E_UTAmode))
            return -1;
          return 5;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern78 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  x5 = XEXP (x1, 1);
  operands[3] = x5;
  return pattern76 (x1); /* [-1, 3] */
}

int
pattern81 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case REG:
    case SUBREG:
      operands[1] = x3;
      switch (GET_MODE (operands[0]))
        {
        case E_HImode:
          return pattern79 (x1, 
E_HImode); /* [-1, 0] */

        case E_PSImode:
          if (pattern79 (x1, 
E_PSImode) != 0)
            return -1;
          return 1;

        case E_SImode:
          if (pattern79 (x1, 
E_SImode) != 0)
            return -1;
          return 2;

        case E_QImode:
          if (pattern80 (x1) != 0)
            return -1;
          return 3;

        default:
          return -1;
        }

    case ZERO_EXTEND:
      res = pattern47 (x1);
      if (res >= 0)
        return res + 4; /* [4, 9] */
      return -1;

    case XOR:
      if (GET_MODE (x3) != E_QImode
          || !register_operand (operands[0], E_QImode)
          || GET_MODE (x1) != E_QImode
          || GET_MODE (x2) != E_QImode)
        return -1;
      x4 = XEXP (x3, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_QImode))
        return -1;
      x5 = XEXP (x3, 1);
      operands[4] = x5;
      if (!const_int_operand (operands[4], E_QImode))
        return -1;
      x6 = XEXP (x2, 1);
      operands[2] = x6;
      if (!const_0_to_7_operand (operands[2], E_QImode))
        return -1;
      x7 = XEXP (x1, 1);
      operands[3] = x7;
      if (!register_operand (operands[3], E_QImode))
        return -1;
      return 10;

    default:
      return -1;
    }
}

int
pattern92 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_QImode)
    return -1;
  x4 = XEXP (x1, 0);
  if (GET_CODE (x4) != ZERO_EXTRACT
      || GET_MODE (x4) != E_QImode)
    return -1;
  x5 = XEXP (x4, 1);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x6 = XEXP (x4, 0);
  operands[0] = x6;
  if (!register_operand (operands[0], E_QImode))
    return -1;
  x7 = XEXP (x4, 2);
  operands[1] = x7;
  if (!const_0_to_7_operand (operands[1], E_QImode)
      || GET_MODE (x2) != E_QImode)
    return -1;
  x8 = XEXP (x3, 0);
  operands[2] = x8;
  if (!register_operand (operands[2], E_QImode))
    return -1;
  x9 = XEXP (x3, 1);
  operands[4] = x9;
  if (!const_int_operand (operands[4], E_QImode))
    return -1;
  x10 = XEXP (x2, 2);
  operands[3] = x10;
  if (!const_0_to_7_operand (operands[3], E_QImode))
    return -1;
  return 0;
}

int
pattern102 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 36
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  x6 = XEXP (x4, 1);
  x7 = XEXP (x6, 0);
  operands[1] = x7;
  switch (GET_MODE (operands[0]))
    {
    case E_QQmode:
      if (!register_operand (operands[0], E_QQmode)
          || GET_MODE (x6) != E_QQmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_UQQmode:
          if (!register_operand (operands[1], E_UQQmode))
            return -1;
          return 0;

        case E_HQmode:
          if (!register_operand (operands[1], E_HQmode))
            return -1;
          return 1;

        case E_UHQmode:
          if (!register_operand (operands[1], E_UHQmode))
            return -1;
          return 2;

        case E_HAmode:
          if (!register_operand (operands[1], E_HAmode))
            return -1;
          return 3;

        case E_UHAmode:
          if (!register_operand (operands[1], E_UHAmode))
            return -1;
          return 4;

        case E_SQmode:
          if (!register_operand (operands[1], E_SQmode))
            return -1;
          return 5;

        case E_USQmode:
          if (!register_operand (operands[1], E_USQmode))
            return -1;
          return 6;

        case E_SAmode:
          if (!register_operand (operands[1], E_SAmode))
            return -1;
          return 7;

        case E_USAmode:
          if (!register_operand (operands[1], E_USAmode))
            return -1;
          return 8;

        case E_DQmode:
          if (!register_operand (operands[1], E_DQmode))
            return -1;
          return 9;

        case E_UDQmode:
          if (!register_operand (operands[1], E_UDQmode))
            return -1;
          return 10;

        case E_DAmode:
          if (!register_operand (operands[1], E_DAmode))
            return -1;
          return 11;

        case E_UDAmode:
          if (!register_operand (operands[1], E_UDAmode))
            return -1;
          return 12;

        case E_TAmode:
          if (!register_operand (operands[1], E_TAmode))
            return -1;
          return 13;

        case E_UTAmode:
          if (!register_operand (operands[1], E_UTAmode))
            return -1;
          return 14;

        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 15;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 16;

        case E_SImode:
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 17;

        case E_DImode:
          if (!register_operand (operands[1], E_DImode))
            return -1;
          return 18;

        default:
          return -1;
        }

    case E_UQQmode:
      if (!register_operand (operands[0], E_UQQmode)
          || GET_MODE (x6) != E_UQQmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QQmode:
          if (!register_operand (operands[1], E_QQmode))
            return -1;
          return 19;

        case E_HQmode:
          if (!register_operand (operands[1], E_HQmode))
            return -1;
          return 20;

        case E_UHQmode:
          if (!register_operand (operands[1], E_UHQmode))
            return -1;
          return 21;

        case E_HAmode:
          if (!register_operand (operands[1], E_HAmode))
            return -1;
          return 22;

        case E_UHAmode:
          if (!register_operand (operands[1], E_UHAmode))
            return -1;
          return 23;

        case E_SQmode:
          if (!register_operand (operands[1], E_SQmode))
            return -1;
          return 24;

        case E_USQmode:
          if (!register_operand (operands[1], E_USQmode))
            return -1;
          return 25;

        case E_SAmode:
          if (!register_operand (operands[1], E_SAmode))
            return -1;
          return 26;

        case E_USAmode:
          if (!register_operand (operands[1], E_USAmode))
            return -1;
          return 27;

        case E_DQmode:
          if (!register_operand (operands[1], E_DQmode))
            return -1;
          return 28;

        case E_UDQmode:
          if (!register_operand (operands[1], E_UDQmode))
            return -1;
          return 29;

        case E_DAmode:
          if (!register_operand (operands[1], E_DAmode))
            return -1;
          return 30;

        case E_UDAmode:
          if (!register_operand (operands[1], E_UDAmode))
            return -1;
          return 31;

        case E_TAmode:
          if (!register_operand (operands[1], E_TAmode))
            return -1;
          return 32;

        case E_UTAmode:
          if (!register_operand (operands[1], E_UTAmode))
            return -1;
          return 33;

        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 34;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 35;

        case E_SImode:
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 36;

        case E_DImode:
          if (!register_operand (operands[1], E_DImode))
            return -1;
          return 37;

        default:
          return -1;
        }

    case E_HQmode:
      if (!register_operand (operands[0], E_HQmode)
          || GET_MODE (x6) != E_HQmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QQmode:
          if (!register_operand (operands[1], E_QQmode))
            return -1;
          return 38;

        case E_UQQmode:
          if (!register_operand (operands[1], E_UQQmode))
            return -1;
          return 39;

        case E_UHQmode:
          if (!register_operand (operands[1], E_UHQmode))
            return -1;
          return 40;

        case E_HAmode:
          if (!register_operand (operands[1], E_HAmode))
            return -1;
          return 41;

        case E_UHAmode:
          if (!register_operand (operands[1], E_UHAmode))
            return -1;
          return 42;

        case E_SQmode:
          if (!register_operand (operands[1], E_SQmode))
            return -1;
          return 43;

        case E_USQmode:
          if (!register_operand (operands[1], E_USQmode))
            return -1;
          return 44;

        case E_SAmode:
          if (!register_operand (operands[1], E_SAmode))
            return -1;
          return 45;

        case E_USAmode:
          if (!register_operand (operands[1], E_USAmode))
            return -1;
          return 46;

        case E_DQmode:
          if (!register_operand (operands[1], E_DQmode))
            return -1;
          return 47;

        case E_UDQmode:
          if (!register_operand (operands[1], E_UDQmode))
            return -1;
          return 48;

        case E_DAmode:
          if (!register_operand (operands[1], E_DAmode))
            return -1;
          return 49;

        case E_UDAmode:
          if (!register_operand (operands[1], E_UDAmode))
            return -1;
          return 50;

        case E_TAmode:
          if (!register_operand (operands[1], E_TAmode))
            return -1;
          return 51;

        case E_UTAmode:
          if (!register_operand (operands[1], E_UTAmode))
            return -1;
          return 52;

        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 53;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 54;

        case E_SImode:
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 55;

        case E_DImode:
          if (!register_operand (operands[1], E_DImode))
            return -1;
          return 56;

        default:
          return -1;
        }

    case E_UHQmode:
      if (!register_operand (operands[0], E_UHQmode)
          || GET_MODE (x6) != E_UHQmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QQmode:
          if (!register_operand (operands[1], E_QQmode))
            return -1;
          return 57;

        case E_UQQmode:
          if (!register_operand (operands[1], E_UQQmode))
            return -1;
          return 58;

        case E_HQmode:
          if (!register_operand (operands[1], E_HQmode))
            return -1;
          return 59;

        case E_HAmode:
          if (!register_operand (operands[1], E_HAmode))
            return -1;
          return 60;

        case E_UHAmode:
          if (!register_operand (operands[1], E_UHAmode))
            return -1;
          return 61;

        case E_SQmode:
          if (!register_operand (operands[1], E_SQmode))
            return -1;
          return 62;

        case E_USQmode:
          if (!register_operand (operands[1], E_USQmode))
            return -1;
          return 63;

        case E_SAmode:
          if (!register_operand (operands[1], E_SAmode))
            return -1;
          return 64;

        case E_USAmode:
          if (!register_operand (operands[1], E_USAmode))
            return -1;
          return 65;

        case E_DQmode:
          if (!register_operand (operands[1], E_DQmode))
            return -1;
          return 66;

        case E_UDQmode:
          if (!register_operand (operands[1], E_UDQmode))
            return -1;
          return 67;

        case E_DAmode:
          if (!register_operand (operands[1], E_DAmode))
            return -1;
          return 68;

        case E_UDAmode:
          if (!register_operand (operands[1], E_UDAmode))
            return -1;
          return 69;

        case E_TAmode:
          if (!register_operand (operands[1], E_TAmode))
            return -1;
          return 70;

        case E_UTAmode:
          if (!register_operand (operands[1], E_UTAmode))
            return -1;
          return 71;

        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 72;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 73;

        case E_SImode:
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 74;

        case E_DImode:
          if (!register_operand (operands[1], E_DImode))
            return -1;
          return 75;

        default:
          return -1;
        }

    case E_HAmode:
      if (!register_operand (operands[0], E_HAmode)
          || GET_MODE (x6) != E_HAmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QQmode:
          if (!register_operand (operands[1], E_QQmode))
            return -1;
          return 76;

        case E_UQQmode:
          if (!register_operand (operands[1], E_UQQmode))
            return -1;
          return 77;

        case E_HQmode:
          if (!register_operand (operands[1], E_HQmode))
            return -1;
          return 78;

        case E_UHQmode:
          if (!register_operand (operands[1], E_UHQmode))
            return -1;
          return 79;

        case E_UHAmode:
          if (!register_operand (operands[1], E_UHAmode))
            return -1;
          return 80;

        case E_SQmode:
          if (!register_operand (operands[1], E_SQmode))
            return -1;
          return 81;

        case E_USQmode:
          if (!register_operand (operands[1], E_USQmode))
            return -1;
          return 82;

        case E_SAmode:
          if (!register_operand (operands[1], E_SAmode))
            return -1;
          return 83;

        case E_USAmode:
          if (!register_operand (operands[1], E_USAmode))
            return -1;
          return 84;

        case E_DQmode:
          if (!register_operand (operands[1], E_DQmode))
            return -1;
          return 85;

        case E_UDQmode:
          if (!register_operand (operands[1], E_UDQmode))
            return -1;
          return 86;

        case E_DAmode:
          if (!register_operand (operands[1], E_DAmode))
            return -1;
          return 87;

        case E_UDAmode:
          if (!register_operand (operands[1], E_UDAmode))
            return -1;
          return 88;

        case E_TAmode:
          if (!register_operand (operands[1], E_TAmode))
            return -1;
          return 89;

        case E_UTAmode:
          if (!register_operand (operands[1], E_UTAmode))
            return -1;
          return 90;

        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 91;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 92;

        case E_SImode:
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 93;

        case E_DImode:
          if (!register_operand (operands[1], E_DImode))
            return -1;
          return 94;

        default:
          return -1;
        }

    case E_UHAmode:
      if (!register_operand (operands[0], E_UHAmode)
          || GET_MODE (x6) != E_UHAmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QQmode:
          if (!register_operand (operands[1], E_QQmode))
            return -1;
          return 95;

        case E_UQQmode:
          if (!register_operand (operands[1], E_UQQmode))
            return -1;
          return 96;

        case E_HQmode:
          if (!register_operand (operands[1], E_HQmode))
            return -1;
          return 97;

        case E_UHQmode:
          if (!register_operand (operands[1], E_UHQmode))
            return -1;
          return 98;

        case E_HAmode:
          if (!register_operand (operands[1], E_HAmode))
            return -1;
          return 99;

        case E_SQmode:
          if (!register_operand (operands[1], E_SQmode))
            return -1;
          return 100;

        case E_USQmode:
          if (!register_operand (operands[1], E_USQmode))
            return -1;
          return 101;

        case E_SAmode:
          if (!register_operand (operands[1], E_SAmode))
            return -1;
          return 102;

        case E_USAmode:
          if (!register_operand (operands[1], E_USAmode))
            return -1;
          return 103;

        case E_DQmode:
          if (!register_operand (operands[1], E_DQmode))
            return -1;
          return 104;

        case E_UDQmode:
          if (!register_operand (operands[1], E_UDQmode))
            return -1;
          return 105;

        case E_DAmode:
          if (!register_operand (operands[1], E_DAmode))
            return -1;
          return 106;

        case E_UDAmode:
          if (!register_operand (operands[1], E_UDAmode))
            return -1;
          return 107;

        case E_TAmode:
          if (!register_operand (operands[1], E_TAmode))
            return -1;
          return 108;

        case E_UTAmode:
          if (!register_operand (operands[1], E_UTAmode))
            return -1;
          return 109;

        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 110;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 111;

        case E_SImode:
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 112;

        case E_DImode:
          if (!register_operand (operands[1], E_DImode))
            return -1;
          return 113;

        default:
          return -1;
        }

    case E_SQmode:
      if (!register_operand (operands[0], E_SQmode)
          || GET_MODE (x6) != E_SQmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QQmode:
          if (!register_operand (operands[1], E_QQmode))
            return -1;
          return 114;

        case E_UQQmode:
          if (!register_operand (operands[1], E_UQQmode))
            return -1;
          return 115;

        case E_HQmode:
          if (!register_operand (operands[1], E_HQmode))
            return -1;
          return 116;

        case E_UHQmode:
          if (!register_operand (operands[1], E_UHQmode))
            return -1;
          return 117;

        case E_HAmode:
          if (!register_operand (operands[1], E_HAmode))
            return -1;
          return 118;

        case E_UHAmode:
          if (!register_operand (operands[1], E_UHAmode))
            return -1;
          return 119;

        case E_USQmode:
          if (!register_operand (operands[1], E_USQmode))
            return -1;
          return 120;

        case E_SAmode:
          if (!register_operand (operands[1], E_SAmode))
            return -1;
          return 121;

        case E_USAmode:
          if (!register_operand (operands[1], E_USAmode))
            return -1;
          return 122;

        case E_DQmode:
          if (!register_operand (operands[1], E_DQmode))
            return -1;
          return 123;

        case E_UDQmode:
          if (!register_operand (operands[1], E_UDQmode))
            return -1;
          return 124;

        case E_DAmode:
          if (!register_operand (operands[1], E_DAmode))
            return -1;
          return 125;

        case E_UDAmode:
          if (!register_operand (operands[1], E_UDAmode))
            return -1;
          return 126;

        case E_TAmode:
          if (!register_operand (operands[1], E_TAmode))
            return -1;
          return 127;

        case E_UTAmode:
          if (!register_operand (operands[1], E_UTAmode))
            return -1;
          return 128;

        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 129;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 130;

        case E_SImode:
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 131;

        case E_DImode:
          if (!register_operand (operands[1], E_DImode))
            return -1;
          return 132;

        default:
          return -1;
        }

    case E_USQmode:
      if (!register_operand (operands[0], E_USQmode)
          || GET_MODE (x6) != E_USQmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QQmode:
          if (!register_operand (operands[1], E_QQmode))
            return -1;
          return 133;

        case E_UQQmode:
          if (!register_operand (operands[1], E_UQQmode))
            return -1;
          return 134;

        case E_HQmode:
          if (!register_operand (operands[1], E_HQmode))
            return -1;
          return 135;

        case E_UHQmode:
          if (!register_operand (operands[1], E_UHQmode))
            return -1;
          return 136;

        case E_HAmode:
          if (!register_operand (operands[1], E_HAmode))
            return -1;
          return 137;

        case E_UHAmode:
          if (!register_operand (operands[1], E_UHAmode))
            return -1;
          return 138;

        case E_SQmode:
          if (!register_operand (operands[1], E_SQmode))
            return -1;
          return 139;

        case E_SAmode:
          if (!register_operand (operands[1], E_SAmode))
            return -1;
          return 140;

        case E_USAmode:
          if (!register_operand (operands[1], E_USAmode))
            return -1;
          return 141;

        case E_DQmode:
          if (!register_operand (operands[1], E_DQmode))
            return -1;
          return 142;

        case E_UDQmode:
          if (!register_operand (operands[1], E_UDQmode))
            return -1;
          return 143;

        case E_DAmode:
          if (!register_operand (operands[1], E_DAmode))
            return -1;
          return 144;

        case E_UDAmode:
          if (!register_operand (operands[1], E_UDAmode))
            return -1;
          return 145;

        case E_TAmode:
          if (!register_operand (operands[1], E_TAmode))
            return -1;
          return 146;

        case E_UTAmode:
          if (!register_operand (operands[1], E_UTAmode))
            return -1;
          return 147;

        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 148;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 149;

        case E_SImode:
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 150;

        case E_DImode:
          if (!register_operand (operands[1], E_DImode))
            return -1;
          return 151;

        default:
          return -1;
        }

    case E_SAmode:
      if (!register_operand (operands[0], E_SAmode)
          || GET_MODE (x6) != E_SAmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QQmode:
          if (!register_operand (operands[1], E_QQmode))
            return -1;
          return 152;

        case E_UQQmode:
          if (!register_operand (operands[1], E_UQQmode))
            return -1;
          return 153;

        case E_HQmode:
          if (!register_operand (operands[1], E_HQmode))
            return -1;
          return 154;

        case E_UHQmode:
          if (!register_operand (operands[1], E_UHQmode))
            return -1;
          return 155;

        case E_HAmode:
          if (!register_operand (operands[1], E_HAmode))
            return -1;
          return 156;

        case E_UHAmode:
          if (!register_operand (operands[1], E_UHAmode))
            return -1;
          return 157;

        case E_SQmode:
          if (!register_operand (operands[1], E_SQmode))
            return -1;
          return 158;

        case E_USQmode:
          if (!register_operand (operands[1], E_USQmode))
            return -1;
          return 159;

        case E_USAmode:
          if (!register_operand (operands[1], E_USAmode))
            return -1;
          return 160;

        case E_DQmode:
          if (!register_operand (operands[1], E_DQmode))
            return -1;
          return 161;

        case E_UDQmode:
          if (!register_operand (operands[1], E_UDQmode))
            return -1;
          return 162;

        case E_DAmode:
          if (!register_operand (operands[1], E_DAmode))
            return -1;
          return 163;

        case E_UDAmode:
          if (!register_operand (operands[1], E_UDAmode))
            return -1;
          return 164;

        case E_TAmode:
          if (!register_operand (operands[1], E_TAmode))
            return -1;
          return 165;

        case E_UTAmode:
          if (!register_operand (operands[1], E_UTAmode))
            return -1;
          return 166;

        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 167;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 168;

        case E_SImode:
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 169;

        case E_DImode:
          if (!register_operand (operands[1], E_DImode))
            return -1;
          return 170;

        default:
          return -1;
        }

    case E_USAmode:
      if (!register_operand (operands[0], E_USAmode)
          || GET_MODE (x6) != E_USAmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QQmode:
          if (!register_operand (operands[1], E_QQmode))
            return -1;
          return 171;

        case E_UQQmode:
          if (!register_operand (operands[1], E_UQQmode))
            return -1;
          return 172;

        case E_HQmode:
          if (!register_operand (operands[1], E_HQmode))
            return -1;
          return 173;

        case E_UHQmode:
          if (!register_operand (operands[1], E_UHQmode))
            return -1;
          return 174;

        case E_HAmode:
          if (!register_operand (operands[1], E_HAmode))
            return -1;
          return 175;

        case E_UHAmode:
          if (!register_operand (operands[1], E_UHAmode))
            return -1;
          return 176;

        case E_SQmode:
          if (!register_operand (operands[1], E_SQmode))
            return -1;
          return 177;

        case E_USQmode:
          if (!register_operand (operands[1], E_USQmode))
            return -1;
          return 178;

        case E_SAmode:
          if (!register_operand (operands[1], E_SAmode))
            return -1;
          return 179;

        case E_DQmode:
          if (!register_operand (operands[1], E_DQmode))
            return -1;
          return 180;

        case E_UDQmode:
          if (!register_operand (operands[1], E_UDQmode))
            return -1;
          return 181;

        case E_DAmode:
          if (!register_operand (operands[1], E_DAmode))
            return -1;
          return 182;

        case E_UDAmode:
          if (!register_operand (operands[1], E_UDAmode))
            return -1;
          return 183;

        case E_TAmode:
          if (!register_operand (operands[1], E_TAmode))
            return -1;
          return 184;

        case E_UTAmode:
          if (!register_operand (operands[1], E_UTAmode))
            return -1;
          return 185;

        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 186;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 187;

        case E_SImode:
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 188;

        case E_DImode:
          if (!register_operand (operands[1], E_DImode))
            return -1;
          return 189;

        default:
          return -1;
        }

    case E_DQmode:
      if (!register_operand (operands[0], E_DQmode)
          || GET_MODE (x6) != E_DQmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QQmode:
          if (!register_operand (operands[1], E_QQmode))
            return -1;
          return 190;

        case E_UQQmode:
          if (!register_operand (operands[1], E_UQQmode))
            return -1;
          return 191;

        case E_HQmode:
          if (!register_operand (operands[1], E_HQmode))
            return -1;
          return 192;

        case E_UHQmode:
          if (!register_operand (operands[1], E_UHQmode))
            return -1;
          return 193;

        case E_HAmode:
          if (!register_operand (operands[1], E_HAmode))
            return -1;
          return 194;

        case E_UHAmode:
          if (!register_operand (operands[1], E_UHAmode))
            return -1;
          return 195;

        case E_SQmode:
          if (!register_operand (operands[1], E_SQmode))
            return -1;
          return 196;

        case E_USQmode:
          if (!register_operand (operands[1], E_USQmode))
            return -1;
          return 197;

        case E_SAmode:
          if (!register_operand (operands[1], E_SAmode))
            return -1;
          return 198;

        case E_USAmode:
          if (!register_operand (operands[1], E_USAmode))
            return -1;
          return 199;

        case E_UDQmode:
          if (!register_operand (operands[1], E_UDQmode))
            return -1;
          return 200;

        case E_DAmode:
          if (!register_operand (operands[1], E_DAmode))
            return -1;
          return 201;

        case E_UDAmode:
          if (!register_operand (operands[1], E_UDAmode))
            return -1;
          return 202;

        case E_TAmode:
          if (!register_operand (operands[1], E_TAmode))
            return -1;
          return 203;

        case E_UTAmode:
          if (!register_operand (operands[1], E_UTAmode))
            return -1;
          return 204;

        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 205;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 206;

        case E_SImode:
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 207;

        case E_DImode:
          if (!register_operand (operands[1], E_DImode))
            return -1;
          return 208;

        default:
          return -1;
        }

    case E_UDQmode:
      if (!register_operand (operands[0], E_UDQmode)
          || GET_MODE (x6) != E_UDQmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QQmode:
          if (!register_operand (operands[1], E_QQmode))
            return -1;
          return 209;

        case E_UQQmode:
          if (!register_operand (operands[1], E_UQQmode))
            return -1;
          return 210;

        case E_HQmode:
          if (!register_operand (operands[1], E_HQmode))
            return -1;
          return 211;

        case E_UHQmode:
          if (!register_operand (operands[1], E_UHQmode))
            return -1;
          return 212;

        case E_HAmode:
          if (!register_operand (operands[1], E_HAmode))
            return -1;
          return 213;

        case E_UHAmode:
          if (!register_operand (operands[1], E_UHAmode))
            return -1;
          return 214;

        case E_SQmode:
          if (!register_operand (operands[1], E_SQmode))
            return -1;
          return 215;

        case E_USQmode:
          if (!register_operand (operands[1], E_USQmode))
            return -1;
          return 216;

        case E_SAmode:
          if (!register_operand (operands[1], E_SAmode))
            return -1;
          return 217;

        case E_USAmode:
          if (!register_operand (operands[1], E_USAmode))
            return -1;
          return 218;

        case E_DQmode:
          if (!register_operand (operands[1], E_DQmode))
            return -1;
          return 219;

        case E_DAmode:
          if (!register_operand (operands[1], E_DAmode))
            return -1;
          return 220;

        case E_UDAmode:
          if (!register_operand (operands[1], E_UDAmode))
            return -1;
          return 221;

        case E_TAmode:
          if (!register_operand (operands[1], E_TAmode))
            return -1;
          return 222;

        case E_UTAmode:
          if (!register_operand (operands[1], E_UTAmode))
            return -1;
          return 223;

        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 224;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 225;

        case E_SImode:
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 226;

        case E_DImode:
          if (!register_operand (operands[1], E_DImode))
            return -1;
          return 227;

        default:
          return -1;
        }

    case E_DAmode:
      if (!register_operand (operands[0], E_DAmode)
          || GET_MODE (x6) != E_DAmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QQmode:
          if (!register_operand (operands[1], E_QQmode))
            return -1;
          return 228;

        case E_UQQmode:
          if (!register_operand (operands[1], E_UQQmode))
            return -1;
          return 229;

        case E_HQmode:
          if (!register_operand (operands[1], E_HQmode))
            return -1;
          return 230;

        case E_UHQmode:
          if (!register_operand (operands[1], E_UHQmode))
            return -1;
          return 231;

        case E_HAmode:
          if (!register_operand (operands[1], E_HAmode))
            return -1;
          return 232;

        case E_UHAmode:
          if (!register_operand (operands[1], E_UHAmode))
            return -1;
          return 233;

        case E_SQmode:
          if (!register_operand (operands[1], E_SQmode))
            return -1;
          return 234;

        case E_USQmode:
          if (!register_operand (operands[1], E_USQmode))
            return -1;
          return 235;

        case E_SAmode:
          if (!register_operand (operands[1], E_SAmode))
            return -1;
          return 236;

        case E_USAmode:
          if (!register_operand (operands[1], E_USAmode))
            return -1;
          return 237;

        case E_DQmode:
          if (!register_operand (operands[1], E_DQmode))
            return -1;
          return 238;

        case E_UDQmode:
          if (!register_operand (operands[1], E_UDQmode))
            return -1;
          return 239;

        case E_UDAmode:
          if (!register_operand (operands[1], E_UDAmode))
            return -1;
          return 240;

        case E_TAmode:
          if (!register_operand (operands[1], E_TAmode))
            return -1;
          return 241;

        case E_UTAmode:
          if (!register_operand (operands[1], E_UTAmode))
            return -1;
          return 242;

        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 243;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 244;

        case E_SImode:
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 245;

        case E_DImode:
          if (!register_operand (operands[1], E_DImode))
            return -1;
          return 246;

        default:
          return -1;
        }

    case E_UDAmode:
      if (!register_operand (operands[0], E_UDAmode)
          || GET_MODE (x6) != E_UDAmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QQmode:
          if (!register_operand (operands[1], E_QQmode))
            return -1;
          return 247;

        case E_UQQmode:
          if (!register_operand (operands[1], E_UQQmode))
            return -1;
          return 248;

        case E_HQmode:
          if (!register_operand (operands[1], E_HQmode))
            return -1;
          return 249;

        case E_UHQmode:
          if (!register_operand (operands[1], E_UHQmode))
            return -1;
          return 250;

        case E_HAmode:
          if (!register_operand (operands[1], E_HAmode))
            return -1;
          return 251;

        case E_UHAmode:
          if (!register_operand (operands[1], E_UHAmode))
            return -1;
          return 252;

        case E_SQmode:
          if (!register_operand (operands[1], E_SQmode))
            return -1;
          return 253;

        case E_USQmode:
          if (!register_operand (operands[1], E_USQmode))
            return -1;
          return 254;

        case E_SAmode:
          if (!register_operand (operands[1], E_SAmode))
            return -1;
          return 255;

        case E_USAmode:
          if (!register_operand (operands[1], E_USAmode))
            return -1;
          return 256;

        case E_DQmode:
          if (!register_operand (operands[1], E_DQmode))
            return -1;
          return 257;

        case E_UDQmode:
          if (!register_operand (operands[1], E_UDQmode))
            return -1;
          return 258;

        case E_DAmode:
          if (!register_operand (operands[1], E_DAmode))
            return -1;
          return 259;

        case E_TAmode:
          if (!register_operand (operands[1], E_TAmode))
            return -1;
          return 260;

        case E_UTAmode:
          if (!register_operand (operands[1], E_UTAmode))
            return -1;
          return 261;

        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 262;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 263;

        case E_SImode:
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 264;

        case E_DImode:
          if (!register_operand (operands[1], E_DImode))
            return -1;
          return 265;

        default:
          return -1;
        }

    case E_TAmode:
      if (!register_operand (operands[0], E_TAmode)
          || GET_MODE (x6) != E_TAmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QQmode:
          if (!register_operand (operands[1], E_QQmode))
            return -1;
          return 266;

        case E_UQQmode:
          if (!register_operand (operands[1], E_UQQmode))
            return -1;
          return 267;

        case E_HQmode:
          if (!register_operand (operands[1], E_HQmode))
            return -1;
          return 268;

        case E_UHQmode:
          if (!register_operand (operands[1], E_UHQmode))
            return -1;
          return 269;

        case E_HAmode:
          if (!register_operand (operands[1], E_HAmode))
            return -1;
          return 270;

        case E_UHAmode:
          if (!register_operand (operands[1], E_UHAmode))
            return -1;
          return 271;

        case E_SQmode:
          if (!register_operand (operands[1], E_SQmode))
            return -1;
          return 272;

        case E_USQmode:
          if (!register_operand (operands[1], E_USQmode))
            return -1;
          return 273;

        case E_SAmode:
          if (!register_operand (operands[1], E_SAmode))
            return -1;
          return 274;

        case E_USAmode:
          if (!register_operand (operands[1], E_USAmode))
            return -1;
          return 275;

        case E_DQmode:
          if (!register_operand (operands[1], E_DQmode))
            return -1;
          return 276;

        case E_UDQmode:
          if (!register_operand (operands[1], E_UDQmode))
            return -1;
          return 277;

        case E_DAmode:
          if (!register_operand (operands[1], E_DAmode))
            return -1;
          return 278;

        case E_UDAmode:
          if (!register_operand (operands[1], E_UDAmode))
            return -1;
          return 279;

        case E_UTAmode:
          if (!register_operand (operands[1], E_UTAmode))
            return -1;
          return 280;

        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 281;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 282;

        case E_SImode:
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 283;

        case E_DImode:
          if (!register_operand (operands[1], E_DImode))
            return -1;
          return 284;

        default:
          return -1;
        }

    case E_UTAmode:
      if (!register_operand (operands[0], E_UTAmode)
          || GET_MODE (x6) != E_UTAmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QQmode:
          if (!register_operand (operands[1], E_QQmode))
            return -1;
          return 285;

        case E_UQQmode:
          if (!register_operand (operands[1], E_UQQmode))
            return -1;
          return 286;

        case E_HQmode:
          if (!register_operand (operands[1], E_HQmode))
            return -1;
          return 287;

        case E_UHQmode:
          if (!register_operand (operands[1], E_UHQmode))
            return -1;
          return 288;

        case E_HAmode:
          if (!register_operand (operands[1], E_HAmode))
            return -1;
          return 289;

        case E_UHAmode:
          if (!register_operand (operands[1], E_UHAmode))
            return -1;
          return 290;

        case E_SQmode:
          if (!register_operand (operands[1], E_SQmode))
            return -1;
          return 291;

        case E_USQmode:
          if (!register_operand (operands[1], E_USQmode))
            return -1;
          return 292;

        case E_SAmode:
          if (!register_operand (operands[1], E_SAmode))
            return -1;
          return 293;

        case E_USAmode:
          if (!register_operand (operands[1], E_USAmode))
            return -1;
          return 294;

        case E_DQmode:
          if (!register_operand (operands[1], E_DQmode))
            return -1;
          return 295;

        case E_UDQmode:
          if (!register_operand (operands[1], E_UDQmode))
            return -1;
          return 296;

        case E_DAmode:
          if (!register_operand (operands[1], E_DAmode))
            return -1;
          return 297;

        case E_UDAmode:
          if (!register_operand (operands[1], E_UDAmode))
            return -1;
          return 298;

        case E_TAmode:
          if (!register_operand (operands[1], E_TAmode))
            return -1;
          return 299;

        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 300;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 301;

        case E_SImode:
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 302;

        case E_DImode:
          if (!register_operand (operands[1], E_DImode))
            return -1;
          return 303;

        default:
          return -1;
        }

    case E_QImode:
      if (!register_operand (operands[0], E_QImode)
          || GET_MODE (x6) != E_QImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QQmode:
          if (!register_operand (operands[1], E_QQmode))
            return -1;
          return 304;

        case E_UQQmode:
          if (!register_operand (operands[1], E_UQQmode))
            return -1;
          return 305;

        case E_HQmode:
          if (!register_operand (operands[1], E_HQmode))
            return -1;
          return 306;

        case E_UHQmode:
          if (!register_operand (operands[1], E_UHQmode))
            return -1;
          return 307;

        case E_HAmode:
          if (!register_operand (operands[1], E_HAmode))
            return -1;
          return 308;

        case E_UHAmode:
          if (!register_operand (operands[1], E_UHAmode))
            return -1;
          return 309;

        case E_SQmode:
          if (!register_operand (operands[1], E_SQmode))
            return -1;
          return 310;

        case E_USQmode:
          if (!register_operand (operands[1], E_USQmode))
            return -1;
          return 311;

        case E_SAmode:
          if (!register_operand (operands[1], E_SAmode))
            return -1;
          return 312;

        case E_USAmode:
          if (!register_operand (operands[1], E_USAmode))
            return -1;
          return 313;

        case E_DQmode:
          if (!register_operand (operands[1], E_DQmode))
            return -1;
          return 314;

        case E_UDQmode:
          if (!register_operand (operands[1], E_UDQmode))
            return -1;
          return 315;

        case E_DAmode:
          if (!register_operand (operands[1], E_DAmode))
            return -1;
          return 316;

        case E_UDAmode:
          if (!register_operand (operands[1], E_UDAmode))
            return -1;
          return 317;

        case E_TAmode:
          if (!register_operand (operands[1], E_TAmode))
            return -1;
          return 318;

        case E_UTAmode:
          if (!register_operand (operands[1], E_UTAmode))
            return -1;
          return 319;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 320;

        case E_SImode:
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 321;

        case E_DImode:
          if (!register_operand (operands[1], E_DImode))
            return -1;
          return 322;

        default:
          return -1;
        }

    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x6) != E_HImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QQmode:
          if (!register_operand (operands[1], E_QQmode))
            return -1;
          return 323;

        case E_UQQmode:
          if (!register_operand (operands[1], E_UQQmode))
            return -1;
          return 324;

        case E_HQmode:
          if (!register_operand (operands[1], E_HQmode))
            return -1;
          return 325;

        case E_UHQmode:
          if (!register_operand (operands[1], E_UHQmode))
            return -1;
          return 326;

        case E_HAmode:
          if (!register_operand (operands[1], E_HAmode))
            return -1;
          return 327;

        case E_UHAmode:
          if (!register_operand (operands[1], E_UHAmode))
            return -1;
          return 328;

        case E_SQmode:
          if (!register_operand (operands[1], E_SQmode))
            return -1;
          return 329;

        case E_USQmode:
          if (!register_operand (operands[1], E_USQmode))
            return -1;
          return 330;

        case E_SAmode:
          if (!register_operand (operands[1], E_SAmode))
            return -1;
          return 331;

        case E_USAmode:
          if (!register_operand (operands[1], E_USAmode))
            return -1;
          return 332;

        case E_DQmode:
          if (!register_operand (operands[1], E_DQmode))
            return -1;
          return 333;

        case E_UDQmode:
          if (!register_operand (operands[1], E_UDQmode))
            return -1;
          return 334;

        case E_DAmode:
          if (!register_operand (operands[1], E_DAmode))
            return -1;
          return 335;

        case E_UDAmode:
          if (!register_operand (operands[1], E_UDAmode))
            return -1;
          return 336;

        case E_TAmode:
          if (!register_operand (operands[1], E_TAmode))
            return -1;
          return 337;

        case E_UTAmode:
          if (!register_operand (operands[1], E_UTAmode))
            return -1;
          return 338;

        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 339;

        case E_SImode:
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 340;

        case E_DImode:
          if (!register_operand (operands[1], E_DImode))
            return -1;
          return 341;

        default:
          return -1;
        }

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x6) != E_SImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QQmode:
          if (!register_operand (operands[1], E_QQmode))
            return -1;
          return 342;

        case E_UQQmode:
          if (!register_operand (operands[1], E_UQQmode))
            return -1;
          return 343;

        case E_HQmode:
          if (!register_operand (operands[1], E_HQmode))
            return -1;
          return 344;

        case E_UHQmode:
          if (!register_operand (operands[1], E_UHQmode))
            return -1;
          return 345;

        case E_HAmode:
          if (!register_operand (operands[1], E_HAmode))
            return -1;
          return 346;

        case E_UHAmode:
          if (!register_operand (operands[1], E_UHAmode))
            return -1;
          return 347;

        case E_SQmode:
          if (!register_operand (operands[1], E_SQmode))
            return -1;
          return 348;

        case E_USQmode:
          if (!register_operand (operands[1], E_USQmode))
            return -1;
          return 349;

        case E_SAmode:
          if (!register_operand (operands[1], E_SAmode))
            return -1;
          return 350;

        case E_USAmode:
          if (!register_operand (operands[1], E_USAmode))
            return -1;
          return 351;

        case E_DQmode:
          if (!register_operand (operands[1], E_DQmode))
            return -1;
          return 352;

        case E_UDQmode:
          if (!register_operand (operands[1], E_UDQmode))
            return -1;
          return 353;

        case E_DAmode:
          if (!register_operand (operands[1], E_DAmode))
            return -1;
          return 354;

        case E_UDAmode:
          if (!register_operand (operands[1], E_UDAmode))
            return -1;
          return 355;

        case E_TAmode:
          if (!register_operand (operands[1], E_TAmode))
            return -1;
          return 356;

        case E_UTAmode:
          if (!register_operand (operands[1], E_UTAmode))
            return -1;
          return 357;

        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 358;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 359;

        case E_DImode:
          if (!register_operand (operands[1], E_DImode))
            return -1;
          return 360;

        default:
          return -1;
        }

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x6) != E_DImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QQmode:
          if (!register_operand (operands[1], E_QQmode))
            return -1;
          return 361;

        case E_UQQmode:
          if (!register_operand (operands[1], E_UQQmode))
            return -1;
          return 362;

        case E_HQmode:
          if (!register_operand (operands[1], E_HQmode))
            return -1;
          return 363;

        case E_UHQmode:
          if (!register_operand (operands[1], E_UHQmode))
            return -1;
          return 364;

        case E_HAmode:
          if (!register_operand (operands[1], E_HAmode))
            return -1;
          return 365;

        case E_UHAmode:
          if (!register_operand (operands[1], E_UHAmode))
            return -1;
          return 366;

        case E_SQmode:
          if (!register_operand (operands[1], E_SQmode))
            return -1;
          return 367;

        case E_USQmode:
          if (!register_operand (operands[1], E_USQmode))
            return -1;
          return 368;

        case E_SAmode:
          if (!register_operand (operands[1], E_SAmode))
            return -1;
          return 369;

        case E_USAmode:
          if (!register_operand (operands[1], E_USAmode))
            return -1;
          return 370;

        case E_DQmode:
          if (!register_operand (operands[1], E_DQmode))
            return -1;
          return 371;

        case E_UDQmode:
          if (!register_operand (operands[1], E_UDQmode))
            return -1;
          return 372;

        case E_DAmode:
          if (!register_operand (operands[1], E_DAmode))
            return -1;
          return 373;

        case E_UDAmode:
          if (!register_operand (operands[1], E_UDAmode))
            return -1;
          return 374;

        case E_TAmode:
          if (!register_operand (operands[1], E_TAmode))
            return -1;
          return 375;

        case E_UTAmode:
          if (!register_operand (operands[1], E_UTAmode))
            return -1;
          return 376;

        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 377;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 378;

        case E_SImode:
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 379;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_28 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  switch (GET_CODE (x2))
    {
    case REG:
    case SUBREG:
      switch (pattern54 (x1, pnum_clobbers))
        {
        case 0:
          return 743; /* *lshrqi3_split */

        case 1:
          return 744; /* *lshrqq3_split */

        case 2:
          return 745; /* *lshruqq3_split */

        case 3:
          if (nop_general_operand (operands[2], E_QImode))
            return 749; /* lshrhi3 */
          if (pnum_clobbers != NULL
              && const_int_operand (operands[2], E_QImode)
              && 
#line 6152 "../../gcc/config/avr/avr.md"
(reload_completed))
            {
              *pnum_clobbers = 2;
              return 771; /* *lshrhi3_const */
            }
          break;

        case 4:
          if (nop_general_operand (operands[2], E_QImode))
            return 750; /* lshrhq3 */
          if (pnum_clobbers != NULL
              && const_int_operand (operands[2], E_QImode)
              && 
#line 6152 "../../gcc/config/avr/avr.md"
(reload_completed))
            {
              *pnum_clobbers = 2;
              return 772; /* *lshrhq3_const */
            }
          break;

        case 5:
          if (nop_general_operand (operands[2], E_QImode))
            return 751; /* lshruhq3 */
          if (pnum_clobbers != NULL
              && const_int_operand (operands[2], E_QImode)
              && 
#line 6152 "../../gcc/config/avr/avr.md"
(reload_completed))
            {
              *pnum_clobbers = 2;
              return 773; /* *lshruhq3_const */
            }
          break;

        case 6:
          if (nop_general_operand (operands[2], E_QImode))
            return 752; /* lshrha3 */
          if (pnum_clobbers != NULL
              && const_int_operand (operands[2], E_QImode)
              && 
#line 6152 "../../gcc/config/avr/avr.md"
(reload_completed))
            {
              *pnum_clobbers = 2;
              return 774; /* *lshrha3_const */
            }
          break;

        case 7:
          if (nop_general_operand (operands[2], E_QImode))
            return 753; /* lshruha3 */
          if (pnum_clobbers != NULL
              && const_int_operand (operands[2], E_QImode)
              && 
#line 6152 "../../gcc/config/avr/avr.md"
(reload_completed))
            {
              *pnum_clobbers = 2;
              return 775; /* *lshruha3_const */
            }
          break;

        case 8:
          *pnum_clobbers = 1;
          return 759; /* lshrpsi3 */

        case 9:
          return 761; /* lshrsi3 */

        case 10:
          return 762; /* lshrsq3 */

        case 11:
          return 763; /* lshrusq3 */

        case 12:
          return 764; /* lshrsa3 */

        case 13:
          return 765; /* lshrusa3 */

        default:
          break;
        }
      break;

    case ZERO_EXTRACT:
      if (pattern55 (x1) == 0)
        return 1082; /* *insv.shiftrt */
      break;

    default:
      break;
    }
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) == E_QImode)
    {
      x4 = XEXP (x3, 1);
      if (x4 == const_int_rtx[MAX_SAVED_CONST_INT + 7])
        {
          operands[0] = x2;
          if (register_operand (operands[0], E_QImode))
            {
              x5 = XEXP (x3, 0);
              operands[1] = x5;
              if (reg_or_low_io_operand (operands[1], E_QImode)
                  && 
#line 10564 "../../gcc/config/avr/avr.md"
(! reload_completed))
                return 1181; /* *extzv.io.lsr7 */
            }
        }
    }
  x5 = XEXP (x3, 0);
  if (GET_CODE (x5) != REG)
    return -1;
  switch (pattern56 (x1))
    {
    case 0:
      if (
#line 629 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
        return 3306; /* lshrdi3_insn */
      if (pnum_clobbers == NULL
          || !
#line 642 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 3334; /* *lshrdi3_insn */

    case 1:
      if (
#line 629 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
        return 3310; /* lshrdq3_insn */
      if (pnum_clobbers == NULL
          || !
#line 642 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 3338; /* *lshrdq3_insn */

    case 2:
      if (
#line 629 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
        return 3314; /* lshrudq3_insn */
      if (pnum_clobbers == NULL
          || !
#line 642 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 3342; /* *lshrudq3_insn */

    case 3:
      if (
#line 629 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
        return 3318; /* lshrda3_insn */
      if (pnum_clobbers == NULL
          || !
#line 642 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 3346; /* *lshrda3_insn */

    case 4:
      if (
#line 629 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
        return 3322; /* lshruda3_insn */
      if (pnum_clobbers == NULL
          || !
#line 642 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 3350; /* *lshruda3_insn */

    case 5:
      if (
#line 629 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
        return 3326; /* lshrta3_insn */
      if (pnum_clobbers == NULL
          || !
#line 642 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 3354; /* *lshrta3_insn */

    case 6:
      if (
#line 629 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
        return 3330; /* lshruta3_insn */
      if (pnum_clobbers == NULL
          || !
#line 642 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 3358; /* *lshruta3_insn */

    default:
      return -1;
    }
}

 int
recog_35 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case LSHIFTRT:
      x4 = XEXP (x3, 0);
      if (GET_CODE (x4) != MULT)
        return -1;
      x5 = XEXP (x3, 1);
      if (GET_CODE (x5) != CONST_INT)
        return -1;
      x6 = XEXP (x4, 0);
      switch (GET_CODE (x6))
        {
        case SIGN_EXTEND:
          if (GET_MODE (x6) == E_HImode
              && pattern201 (x1, 
SIGN_EXTEND) == 0)
            {
              if (
#line 2269 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
                return 304; /* smulqi3_highpart */
              if (pnum_clobbers != NULL
                  && 
#line 2286 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
                {
                  *pnum_clobbers = 1;
                  return 306; /* *smulqi3_highpart */
                }
            }
          if (pnum_clobbers == NULL
              || pattern202 (x1, 
SIGN_EXTEND) != 0)
            return -1;
          if (
#line 3804 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
            {
              *pnum_clobbers = 1;
              return 572; /* *smulhi3_highpart_call_split */
            }
          if (!
#line 3821 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
            return -1;
          *pnum_clobbers = 2;
          return 574; /* *smulhi3_highpart_call */

        case ZERO_EXTEND:
          if (GET_MODE (x6) == E_HImode
              && pattern201 (x1, 
ZERO_EXTEND) == 0)
            {
              if (
#line 2269 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
                return 305; /* umulqi3_highpart */
              if (pnum_clobbers != NULL
                  && 
#line 2286 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
                {
                  *pnum_clobbers = 1;
                  return 307; /* *umulqi3_highpart */
                }
            }
          if (pnum_clobbers == NULL
              || pattern202 (x1, 
ZERO_EXTEND) != 0)
            return -1;
          if (
#line 3804 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
            {
              *pnum_clobbers = 1;
              return 573; /* *umulhi3_highpart_call_split */
            }
          if (!
#line 3821 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
            return -1;
          *pnum_clobbers = 2;
          return 575; /* *umulhi3_highpart_call */

        default:
          return -1;
        }

    case PARITY:
      if (GET_MODE (x3) != E_SImode
          || pattern35 (x1, 
E_SImode, 
22) != 0)
        return -1;
      return 1029; /* *paritysihi2.libgcc_split */

    case POPCOUNT:
      if (GET_MODE (x3) != E_SImode
          || pattern35 (x1, 
E_SImode, 
22) != 0)
        return -1;
      return 1034; /* *popcountsi2.libgcc_split */

    case CLZ:
      if (pattern36 (x1, pnum_clobbers) != 0)
        return -1;
      *pnum_clobbers = 1;
      return 1041; /* *clzsihi2.libgcc_split */

    case CTZ:
      if (pattern36 (x1, pnum_clobbers) != 0)
        return -1;
      *pnum_clobbers = 2;
      return 1045; /* *ctzsihi2.libgcc_split */

    case FFS:
      if (pattern36 (x1, pnum_clobbers) != 0)
        return -1;
      *pnum_clobbers = 2;
      return 1049; /* *ffssihi2.libgcc_split */

    default:
      return -1;
    }
}

 int
recog_37 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  switch (pattern64 (x3))
    {
    case 0:
      return 3037; /* ussubuqq3 */

    case 1:
      return 3039; /* ussubuhq3 */

    case 2:
      return 3041; /* ussubuha3 */

    case 3:
      return 3043; /* ussubusa3 */

    case 4:
      return 3045; /* ussubusq3 */

    default:
      break;
    }
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != REG)
    return -1;
  switch (pattern65 (x1))
    {
    case 0:
      if (
#line 361 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
        return 3249; /* ussubudq3_insn */
      if (pnum_clobbers == NULL
          || !
#line 374 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 3255; /* *ussubudq3_insn */

    case 1:
      if (
#line 361 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
        return 3251; /* ussubuda3_insn */
      if (pnum_clobbers == NULL
          || !
#line 374 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 3257; /* *ussubuda3_insn */

    case 2:
      if (
#line 361 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
        return 3253; /* ussubuta3_insn */
      if (pnum_clobbers == NULL
          || !
#line 374 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 3259; /* *ussubuta3_insn */

    case 3:
      if (
#line 382 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
        return 3261; /* ussubudq3_const_insn */
      if (pnum_clobbers == NULL
          || !
#line 395 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 3267; /* *ussubudq3_const_insn */

    case 4:
      if (
#line 382 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
        return 3263; /* ussubuda3_const_insn */
      if (pnum_clobbers == NULL
          || !
#line 395 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 3269; /* *ussubuda3_const_insn */

    case 5:
      if (
#line 382 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
        return 3265; /* ussubuta3_const_insn */
      if (pnum_clobbers == NULL
          || !
#line 395 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 3271; /* *ussubuta3_const_insn */

    default:
      return -1;
    }
}

 int
recog_45 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  if (pattern169 (x1, 
E_HImode) != 0)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != E_HImode)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != E_HImode)
    return -1;
  x6 = XEXP (x5, 0);
  x7 = XEXP (x6, 0);
  operands[1] = x7;
  if (!register_operand (operands[1], E_QImode))
    return -1;
  x8 = XEXP (x3, 1);
  switch (GET_CODE (x8))
    {
    case SIGN_EXTEND:
      if (GET_MODE (x8) != E_HImode)
        return -1;
      x9 = XEXP (x8, 0);
      operands[2] = x9;
      if (!register_operand (operands[2], E_QImode)
          || !
#line 2555 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
        return -1;
      return 487; /* *osmulqihi3 */

    case ZERO_EXTEND:
      if (GET_MODE (x8) != E_HImode)
        return -1;
      x9 = XEXP (x8, 0);
      operands[2] = x9;
      if (!register_operand (operands[2], E_QImode)
          || !
#line 2579 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
        return -1;
      return 489; /* *oumulqihi3 */

    case REG:
    case SUBREG:
      operands[2] = x8;
      if (!register_operand (operands[2], E_HImode)
          || !
#line 3218 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
        return -1;
      return 536; /* *muloqihi3 */

    default:
      return -1;
    }
}

 int
recog_48 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  if (nop_general_operand (operands[2], E_QImode))
    {
      switch (pattern238 (x1))
        {
        case 0:
          if (
#line 5786 "../../gcc/config/avr/avr.md"
(reload_completed))
            return 708; /* *ashrqi3 */
          break;

        case 1:
          if (
#line 5786 "../../gcc/config/avr/avr.md"
(reload_completed))
            return 709; /* *ashrqq3 */
          break;

        case 2:
          if (
#line 5786 "../../gcc/config/avr/avr.md"
(reload_completed))
            return 710; /* *ashruqq3 */
          break;

        case 3:
          if (
#line 5818 "../../gcc/config/avr/avr.md"
(reload_completed))
            return 716; /* *ashrhi3 */
          break;

        case 4:
          if (
#line 5818 "../../gcc/config/avr/avr.md"
(reload_completed))
            return 717; /* *ashrhq3 */
          break;

        case 5:
          if (
#line 5818 "../../gcc/config/avr/avr.md"
(reload_completed))
            return 718; /* *ashruhq3 */
          break;

        case 6:
          if (
#line 5818 "../../gcc/config/avr/avr.md"
(reload_completed))
            return 719; /* *ashrha3 */
          break;

        case 7:
          if (
#line 5818 "../../gcc/config/avr/avr.md"
(reload_completed))
            return 720; /* *ashruha3 */
          break;

        case 8:
          if (
#line 5878 "../../gcc/config/avr/avr.md"
(reload_completed))
            return 728; /* *ashrsi3 */
          break;

        case 9:
          if (
#line 5878 "../../gcc/config/avr/avr.md"
(reload_completed))
            return 729; /* *ashrsq3 */
          break;

        case 10:
          if (
#line 5878 "../../gcc/config/avr/avr.md"
(reload_completed))
            return 730; /* *ashrusq3 */
          break;

        case 11:
          if (
#line 5878 "../../gcc/config/avr/avr.md"
(reload_completed))
            return 731; /* *ashrsa3 */
          break;

        case 12:
          if (
#line 5878 "../../gcc/config/avr/avr.md"
(reload_completed))
            return 732; /* *ashrusa3 */
          break;

        default:
          break;
        }
    }
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 0);
  operands[3] = x7;
  switch (GET_MODE (operands[0]))
    {
    case E_PSImode:
      if (pattern112 (x3) != 0)
        return -1;
      return 721; /* ashrpsi3 */

    case E_SImode:
      if (pnum_clobbers == NULL
          || pattern114 (x3, 
E_SImode) != 0
          || !
#line 5914 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 738; /* *ashrsi3_const */

    case E_SQmode:
      if (pnum_clobbers == NULL
          || pattern114 (x3, 
E_SQmode) != 0
          || !
#line 5914 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 739; /* *ashrsq3_const */

    case E_USQmode:
      if (pnum_clobbers == NULL
          || pattern114 (x3, 
E_USQmode) != 0
          || !
#line 5914 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 740; /* *ashrusq3_const */

    case E_SAmode:
      if (pnum_clobbers == NULL
          || pattern114 (x3, 
E_SAmode) != 0
          || !
#line 5914 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 741; /* *ashrsa3_const */

    case E_USAmode:
      if (pnum_clobbers == NULL
          || pattern114 (x3, 
E_USAmode) != 0
          || !
#line 5914 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 742; /* *ashrusa3_const */

    default:
      return -1;
    }
}

 int
recog_57 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  switch (XVECLEN (x3, 0))
    {
    case 3:
      x4 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x4) != CLOBBER)
        return -1;
      x5 = XEXP (x4, 0);
      if (GET_CODE (x5) != REG
          || REGNO (x5) != 36
          || GET_MODE (x5) != E_CCmode)
        return -1;
      x6 = XEXP (x2, 0);
      operands[0] = x6;
      switch (XINT (x3, 1))
        {
        case 0:
          if (GET_MODE (x3) != E_HImode)
            return -1;
          x7 = XVECEXP (x3, 0, 0);
          if (GET_CODE (x7) != MEM
              || GET_MODE (x7) != E_BLKmode)
            return -1;
          x8 = XVECEXP (x3, 0, 1);
          if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
              || !register_operand (operands[0], E_HImode))
            return -1;
          x9 = XEXP (x7, 0);
          operands[1] = x9;
          if (!register_operand (operands[1], E_HImode))
            return -1;
          x10 = XVECEXP (x3, 0, 2);
          operands[2] = x10;
          if (!immediate_operand (operands[2], E_HImode)
              || !
#line 1568 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 173; /* *strlenhi */

        case 7:
          if (GET_MODE (x3) != E_QImode
              || !register_operand (operands[0], E_QImode))
            return -1;
          x7 = XVECEXP (x3, 0, 0);
          operands[1] = x7;
          if (!const_int_operand (operands[1], E_SImode))
            return -1;
          x8 = XVECEXP (x3, 0, 1);
          operands[2] = x8;
          if (!register_operand (operands[2], E_QImode))
            return -1;
          x10 = XVECEXP (x3, 0, 2);
          operands[3] = x10;
          if (!nonmemory_operand (operands[3], E_QImode)
              || !
#line 8924 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 1012; /* *insert_bits */

        case 8:
          x10 = XVECEXP (x3, 0, 2);
          if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x7 = XVECEXP (x3, 0, 0);
          operands[1] = x7;
          x8 = XVECEXP (x3, 0, 1);
          operands[2] = x8;
          if (!const_int_operand (operands[2], E_HImode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_QQmode:
              if (!register_operand (operands[0], E_QQmode)
                  || GET_MODE (x3) != E_QQmode
                  || !register_operand (operands[1], E_QQmode)
                  || !
#line 701 "../../gcc/config/avr/avr-fixed.md"
(reload_completed))
                return -1;
              return 3136; /* *roundqq3_const */

            case E_HQmode:
              if (!register_operand (operands[0], E_HQmode)
                  || GET_MODE (x3) != E_HQmode
                  || !register_operand (operands[1], E_HQmode)
                  || !
#line 701 "../../gcc/config/avr/avr-fixed.md"
(reload_completed))
                return -1;
              return 3137; /* *roundhq3_const */

            case E_HAmode:
              if (!register_operand (operands[0], E_HAmode)
                  || GET_MODE (x3) != E_HAmode
                  || !register_operand (operands[1], E_HAmode)
                  || !
#line 701 "../../gcc/config/avr/avr-fixed.md"
(reload_completed))
                return -1;
              return 3138; /* *roundha3_const */

            case E_SAmode:
              if (!register_operand (operands[0], E_SAmode)
                  || GET_MODE (x3) != E_SAmode
                  || !register_operand (operands[1], E_SAmode)
                  || !
#line 701 "../../gcc/config/avr/avr-fixed.md"
(reload_completed))
                return -1;
              return 3139; /* *roundsa3_const */

            case E_SQmode:
              if (!register_operand (operands[0], E_SQmode)
                  || GET_MODE (x3) != E_SQmode
                  || !register_operand (operands[1], E_SQmode)
                  || !
#line 701 "../../gcc/config/avr/avr-fixed.md"
(reload_completed))
                return -1;
              return 3140; /* *roundsq3_const */

            case E_UQQmode:
              if (!register_operand (operands[0], E_UQQmode)
                  || GET_MODE (x3) != E_UQQmode
                  || !register_operand (operands[1], E_UQQmode)
                  || !
#line 701 "../../gcc/config/avr/avr-fixed.md"
(reload_completed))
                return -1;
              return 3141; /* *rounduqq3_const */

            case E_UHQmode:
              if (!register_operand (operands[0], E_UHQmode)
                  || GET_MODE (x3) != E_UHQmode
                  || !register_operand (operands[1], E_UHQmode)
                  || !
#line 701 "../../gcc/config/avr/avr-fixed.md"
(reload_completed))
                return -1;
              return 3142; /* *rounduhq3_const */

            case E_UHAmode:
              if (!register_operand (operands[0], E_UHAmode)
                  || GET_MODE (x3) != E_UHAmode
                  || !register_operand (operands[1], E_UHAmode)
                  || !
#line 701 "../../gcc/config/avr/avr-fixed.md"
(reload_completed))
                return -1;
              return 3143; /* *rounduha3_const */

            case E_USAmode:
              if (!register_operand (operands[0], E_USAmode)
                  || GET_MODE (x3) != E_USAmode
                  || !register_operand (operands[1], E_USAmode)
                  || !
#line 701 "../../gcc/config/avr/avr-fixed.md"
(reload_completed))
                return -1;
              return 3144; /* *roundusa3_const */

            case E_USQmode:
              if (!register_operand (operands[0], E_USQmode)
                  || GET_MODE (x3) != E_USQmode
                  || !register_operand (operands[1], E_USQmode)
                  || !
#line 701 "../../gcc/config/avr/avr-fixed.md"
(reload_completed))
                return -1;
              return 3145; /* *roundusq3_const */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 1:
      switch (XINT (x3, 1))
        {
        case 2:
          if (pnum_clobbers == NULL
              || GET_MODE (x3) != E_HImode)
            return -1;
          x7 = XVECEXP (x3, 0, 0);
          if (GET_CODE (x7) != REG
              || REGNO (x7) != 30
              || GET_MODE (x7) != E_HImode)
            return -1;
          x6 = XEXP (x2, 0);
          if (GET_CODE (x6) != PC)
            return -1;
          x4 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x4) != USE)
            return -1;
          x5 = XEXP (x4, 0);
          if (GET_CODE (x5) != LABEL_REF)
            return -1;
          x11 = XEXP (x5, 0);
          operands[0] = x11;
          if (
#line 7969 "../../gcc/config/avr/avr.md"
(AVR_HAVE_EIJMP_EICALL))
            {
              *pnum_clobbers = 2;
              return 976; /* *tablejump.3byte-pc_split */
            }
          if (!
#line 7991 "../../gcc/config/avr/avr.md"
(AVR_HAVE_EIJMP_EICALL && reload_completed))
            return -1;
          *pnum_clobbers = 3;
          return 977; /* *tablejump.3byte-pc */

        case 3:
          if (GET_MODE (x3) != E_QImode)
            return -1;
          x7 = XVECEXP (x3, 0, 0);
          if (GET_CODE (x7) != IOR
              || GET_MODE (x7) != E_QImode)
            return -1;
          x9 = XEXP (x7, 0);
          if (GET_CODE (x9) != ASHIFT
              || GET_MODE (x9) != E_QImode)
            return -1;
          x4 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x4) != CLOBBER
              || pattern210 (x1, 
E_QImode) != 0)
            return -1;
          x12 = XEXP (x9, 0);
          operands[1] = x12;
          if (!register_operand (operands[1], E_QImode))
            return -1;
          x13 = XEXP (x9, 1);
          operands[2] = x13;
          if (!const_0_to_7_operand (operands[2], E_QImode))
            return -1;
          x14 = XEXP (x7, 1);
          operands[3] = x14;
          if (!register_operand (operands[3], E_QImode)
              || !
#line 11134 "../../gcc/config/avr/avr.md"
(optimize && avropt_use_nonzero_bits))
            return -1;
          return 1495; /* *nzb=1.ior.ashift */

        default:
          return -1;
        }

    case 2:
      x4 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x4) != CLOBBER)
        return -1;
      x5 = XEXP (x4, 0);
      if (GET_CODE (x5) != REG)
        return -1;
      switch (XINT (x3, 1))
        {
        case 4:
          if (GET_MODE (x3) != E_HImode)
            return -1;
          if (REGNO (x5) == 36
              && pattern261 (x1) == 0
              && 
#line 9722 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
            return 1058; /* *fmul_insn */
          x7 = XVECEXP (x3, 0, 0);
          if (GET_CODE (x7) != REG
              || pattern263 (x1) != 0
              || !
#line 9733 "../../gcc/config/avr/avr.md"
(!AVR_HAVE_MUL))
            return -1;
          return 1059; /* *fmul.call_split */

        case 5:
          if (GET_MODE (x3) != E_HImode)
            return -1;
          if (REGNO (x5) == 36
              && pattern261 (x1) == 0
              && 
#line 9794 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
            return 1062; /* *fmuls_insn */
          x7 = XVECEXP (x3, 0, 0);
          if (GET_CODE (x7) != REG
              || pattern263 (x1) != 0
              || !
#line 9805 "../../gcc/config/avr/avr.md"
(!AVR_HAVE_MUL))
            return -1;
          return 1063; /* *fmuls.call_split */

        case 6:
          if (GET_MODE (x3) != E_HImode)
            return -1;
          if (REGNO (x5) == 36
              && pattern261 (x1) == 0
              && 
#line 9866 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
            return 1066; /* *fmulsu_insn */
          x7 = XVECEXP (x3, 0, 0);
          if (GET_CODE (x7) != REG
              || pattern263 (x1) != 0
              || !
#line 9877 "../../gcc/config/avr/avr.md"
(!AVR_HAVE_MUL))
            return -1;
          return 1067; /* *fmulsu.call_split */

        case 8:
          x7 = XVECEXP (x3, 0, 0);
          if (GET_CODE (x7) != REG)
            return -1;
          x8 = XVECEXP (x3, 0, 1);
          if (GET_CODE (x8) != REG
              || REGNO (x8) != 24
              || GET_MODE (x8) != E_QImode)
            return -1;
          x6 = XEXP (x2, 0);
          if (GET_CODE (x6) != REG)
            return -1;
          switch (pattern295 (x1))
            {
            case 0:
              return 3146; /* *roundqq3.libgcc_split */

            case 1:
              return 3147; /* *rounduqq3.libgcc_split */

            case 2:
              return 3150; /* *roundhq3.libgcc_split */

            case 3:
              return 3151; /* *rounduhq3.libgcc_split */

            case 4:
              return 3152; /* *roundha3.libgcc_split */

            case 5:
              return 3153; /* *rounduha3.libgcc_split */

            case 6:
              return 3158; /* *roundsq3.libgcc_split */

            case 7:
              return 3159; /* *roundusq3.libgcc_split */

            case 8:
              return 3160; /* *roundsa3.libgcc_split */

            case 9:
              return 3161; /* *roundusa3.libgcc_split */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_68 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_QImode)
    return -1;
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x5) != CLOBBER
      || pattern210 (x1, 
E_QImode) != 0)
    return -1;
  x6 = XEXP (x3, 2);
  operands[2] = x6;
  x7 = XEXP (x3, 0);
  switch (GET_CODE (x7))
    {
    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x7;
      switch (GET_MODE (operands[1]))
        {
        case E_QImode:
          if (!reg_or_low_io_operand (operands[1], E_QImode)
              || !const_0_to_7_operand (operands[2], E_QImode)
              || !
#line 10412 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 1149; /* *extzvqi */

        case E_HImode:
          if (!reg_or_low_io_operand (operands[1], E_HImode)
              || !const_0_to_15_operand (operands[2], E_QImode)
              || !
#line 10412 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 1150; /* *extzvhi */

        case E_PSImode:
          if (!reg_or_low_io_operand (operands[1], E_PSImode)
              || !const_0_to_23_operand (operands[2], E_QImode)
              || !
#line 10412 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 1151; /* *extzvpsi */

        case E_SImode:
          if (!reg_or_low_io_operand (operands[1], E_SImode)
              || !const_0_to_31_operand (operands[2], E_QImode)
              || !
#line 10412 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 1152; /* *extzvsi */

        default:
          return -1;
        }

    case NOT:
      if (GET_MODE (x7) != E_QImode)
        return -1;
      x8 = XEXP (x7, 0);
      operands[1] = x8;
      if (!reg_or_low_io_operand (operands[1], E_QImode)
          || !const_0_to_7_operand (operands[2], E_QImode)
          || !
#line 10458 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 1156; /* *extzv.not */

    default:
      return -1;
    }
}

 int
recog_75 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  switch (pattern245 (x1, 
UMOD))
    {
    case 0:
      x2 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x2) != SET)
        return -1;
      x3 = XEXP (x2, 1);
      if (GET_CODE (x3) != UMOD)
        return -1;
      x4 = XEXP (x3, 0);
      if (GET_CODE (x4) != REG
          || REGNO (x4) != 24)
        return -1;
      x5 = XEXP (x3, 1);
      if (GET_CODE (x5) != REG
          || REGNO (x5) != 22)
        return -1;
      x6 = XEXP (x2, 0);
      if (GET_CODE (x6) != REG)
        return -1;
      x7 = XVECEXP (x1, 0, 0);
      x8 = XEXP (x7, 0);
      switch (REGNO (x8))
        {
        case 24:
          if (pattern383 (x1, 
E_QImode, 
E_CCmode, 
36, 
23, 
25) != 0
              || !
#line 3982 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 589; /* *udivmodqi4_call */

        case 22:
          if (pattern383 (x1, 
E_HImode, 
E_QImode, 
21, 
26, 
24) != 0)
            return -1;
          return 594; /* *udivmodhi4_call_split */

        default:
          return -1;
        }

    case 1:
      switch (pattern328 (x1))
        {
        case 0:
          if (!
#line 625 "../../gcc/config/avr/avr-fixed.md"
(reload_completed))
            return -1;
          return 3122; /* *udivsa3.call */

        case 1:
          if (!
#line 625 "../../gcc/config/avr/avr-fixed.md"
(reload_completed))
            return -1;
          return 3124; /* *udivusa3.call */

        default:
          return -1;
        }

    case 2:
      return 616; /* *udivmodsi4_call_split */

    case 3:
      if (!
#line 577 "../../gcc/config/avr/avr-fixed.md"
(reload_completed))
        return -1;
      return 3110; /* *udivhq3.call */

    case 4:
      if (!
#line 577 "../../gcc/config/avr/avr-fixed.md"
(reload_completed))
        return -1;
      return 3112; /* *udivuhq3.call */

    case 5:
      if (!
#line 577 "../../gcc/config/avr/avr-fixed.md"
(reload_completed))
        return -1;
      return 3114; /* *udivha3.call */

    case 6:
      if (!
#line 577 "../../gcc/config/avr/avr-fixed.md"
(reload_completed))
        return -1;
      return 3116; /* *udivuha3.call */

    default:
      return -1;
    }
}

 int
recog_81 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != PLUS)
    return -1;
  x5 = XEXP (x3, 1);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x6 = XEXP (x2, 0);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 36)
    return -1;
  x7 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x7) != SET)
    return -1;
  x8 = XEXP (x7, 1);
  if (GET_CODE (x8) != PLUS)
    return -1;
  x9 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x9) != CLOBBER)
    return -1;
  x10 = XEXP (x4, 0);
  operands[3] = x10;
  x11 = XEXP (x4, 1);
  operands[1] = x11;
  x12 = XEXP (x7, 0);
  operands[0] = x12;
  x13 = XEXP (x8, 0);
  operands[4] = x13;
  x14 = XEXP (x8, 1);
  operands[5] = x14;
  x15 = XEXP (x9, 0);
  operands[2] = x15;
  if (!scratch_operand (operands[2], E_QImode))
    return -1;
  switch (GET_MODE (x6))
    {
    case E_CCZNmode:
      if (GET_MODE (x3) != E_CCZNmode)
        return -1;
      switch (GET_MODE (x4))
        {
        case E_HImode:
          if (pattern384 (x8, 
E_HImode) != 0
              || !
#line 7338 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 916; /* *add.for.cczn.hi */

        case E_PSImode:
          if (pattern384 (x8, 
E_PSImode) != 0
              || !
#line 7338 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 917; /* *add.for.cczn.psi */

        case E_SImode:
          if (pattern384 (x8, 
E_SImode) != 0
              || !
#line 7338 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 918; /* *add.for.cczn.si */

        default:
          return -1;
        }

    case E_CCNmode:
      if (GET_MODE (x3) != E_CCNmode)
        return -1;
      switch (GET_MODE (x4))
        {
        case E_HImode:
          if (pattern367 (x8, 
E_HImode) != 0
              || !
#line 7357 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 919; /* *add.for.ccn.hi */

        case E_PSImode:
          if (pattern367 (x8, 
E_PSImode) != 0
              || !
#line 7357 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 920; /* *add.for.ccn.psi */

        case E_SImode:
          if (pattern367 (x8, 
E_SImode) != 0
              || !
#line 7357 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 921; /* *add.for.ccn.si */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_85 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XVECEXP (x1, 0, 4);
  if (GET_CODE (x3) != CLOBBER)
    return -1;
  x4 = XVECEXP (x1, 0, 5);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XVECEXP (x1, 0, 6);
  if (GET_CODE (x5) != CLOBBER)
    return -1;
  x6 = XVECEXP (x1, 0, 0);
  switch (GET_CODE (x6))
    {
    case SET:
      x7 = XEXP (x6, 1);
      if (GET_CODE (x7) != MEM
          || GET_MODE (x7) != E_BLKmode)
        return -1;
      x8 = XEXP (x7, 0);
      if (GET_CODE (x8) != REG
          || REGNO (x8) != 30
          || GET_MODE (x8) != E_HImode
          || pattern310 (x1) != 0
          || pattern372 (x1, 
E_QImode, 
0) != 0)
        return -1;
      switch (pattern389 (x1))
        {
        case 0:
          return 160; /* cpymem_qi */

        case 1:
          return 161; /* cpymem_hi */

        default:
          return -1;
        }

    case UNSPEC_VOLATILE:
      if (pattern158 (x1, 
4) != 0)
        return -1;
      x9 = XVECEXP (x1, 0, 1);
      x10 = XEXP (x9, 1);
      if (GET_CODE (x10) != UNSPEC_VOLATILE
          || XVECLEN (x10, 0) != 1
          || XINT (x10, 1) != 6
          || GET_MODE (x10) != E_BLKmode)
        return -1;
      x11 = XVECEXP (x1, 0, 2);
      if (GET_CODE (x11) != CLOBBER)
        return -1;
      x12 = XEXP (x5, 0);
      if (GET_CODE (x12) != REG
          || REGNO (x12) != 36
          || GET_MODE (x12) != E_CCmode
          || pattern349 (x1) != 0
          || !
#line 8886 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 1010; /* *delay_cycles_4 */

    default:
      return -1;
    }
}

 int
recog_89 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      return recog_34 (x1, insn, pnum_clobbers);

    case UNSPEC_VOLATILE:
      if (XVECLEN (x2, 0) != 2
          || XINT (x2, 1) != 2
          || GET_MODE (x2) != E_HImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!stack_register_operand (operands[0], E_HImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_HImode))
        return -1;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      if (!const_int_operand (operands[2], E_HImode))
        return -1;
      return 122; /* movhi_sp_r */

    case UNSPEC:
      return recog_26 (x1, insn, pnum_clobbers);

    case PLUS:
      return recog_21 (x1, insn, pnum_clobbers);

    case MINUS:
      return recog_30 (x1, insn, pnum_clobbers);

    case MULT:
      return recog_23 (x1, insn, pnum_clobbers);

    case TRUNCATE:
      return recog_35 (x1, insn, pnum_clobbers);

    case ASHIFT:
      return recog_27 (x1, insn, pnum_clobbers);

    case AND:
      return recog_31 (x1, insn, pnum_clobbers);

    case IOR:
      return recog_24 (x1, insn, pnum_clobbers);

    case XOR:
      return recog_25 (x1, insn, pnum_clobbers);

    case ROTATE:
      return recog_33 (x1, insn, pnum_clobbers);

    case ZERO_EXTEND:
      x6 = XEXP (x2, 0);
      switch (GET_CODE (x6))
        {
        case ASHIFT:
          if (pattern49 (x1) != 0)
            return -1;
          return 704; /* *ashlqi.1.zextpsi_split */

        case REG:
        case SUBREG:
          switch (pattern50 (x1))
            {
            case 0:
              return 818; /* zero_extendqihi2 */

            case 1:
              return 819; /* zero_extendqipsi2 */

            case 2:
              return 821; /* zero_extendhipsi2 */

            case 3:
              return 820; /* zero_extendqisi2 */

            case 4:
              return 823; /* zero_extendhisi2 */

            case 5:
              return 824; /* zero_extendpsisi2 */

            case 6:
              return 825; /* zero_extendqidi2 */

            case 7:
              return 826; /* zero_extendhidi2 */

            case 8:
              return 827; /* zero_extendsidi2 */

            default:
              return -1;
            }

        case PARITY:
          if (pnum_clobbers != NULL
              && pattern16 (x1, 
E_QImode) == 0
              && 
#line 9159 "../../gcc/config/avr/avr.md"
(!reload_completed))
            {
              *pnum_clobbers = 1;
              return 1023; /* *parityqihi2.1 */
            }
          if (GET_MODE (x6) != E_QImode
              || pattern35 (x1, 
E_QImode, 
24) != 0)
            return -1;
          return 1027; /* *parityqihi2.libgcc_split */

        case POPCOUNT:
          if (GET_MODE (x6) != E_QImode
              || pattern34 (x1, 
E_HImode, 
24) != 0)
            return -1;
          x7 = XEXP (x6, 0);
          operands[0] = x7;
          if (register_operand (operands[0], E_QImode)
              && 
#line 9281 "../../gcc/config/avr/avr.md"
(! reload_completed))
            return 1031; /* *popcounthi2.split8 */
          if (GET_CODE (x7) != REG
              || REGNO (x7) != 24
              || GET_MODE (x7) != E_QImode)
            return -1;
          return 1038; /* *popcountqihi2.libgcc */

        case ZERO_EXTRACT:
          switch (pattern51 (x1))
            {
            case 0:
              if (!
#line 10612 "../../gcc/config/avr/avr.md"
(! reload_completed))
                return -1;
              return 1206; /* *extzv.qihi2 */

            case 1:
              if (!
#line 10612 "../../gcc/config/avr/avr.md"
(! reload_completed))
                return -1;
              return 1207; /* *extzv.hihi2 */

            case 2:
              if (!
#line 10612 "../../gcc/config/avr/avr.md"
(! reload_completed))
                return -1;
              return 1208; /* *extzv.psihi2 */

            case 3:
              if (!
#line 10612 "../../gcc/config/avr/avr.md"
(! reload_completed))
                return -1;
              return 1209; /* *extzv.sihi2 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case ASHIFTRT:
      return recog_29 (x1, insn, pnum_clobbers);

    case LSHIFTRT:
      return recog_28 (x1, insn, pnum_clobbers);

    case ABS:
      switch (pattern15 (x1))
        {
        case 0:
          return 781; /* absqi2 */

        case 1:
          return 783; /* abssf2 */

        default:
          return -1;
        }

    case NEG:
      return recog_32 (x1, insn, pnum_clobbers);

    case NOT:
      x6 = XEXP (x2, 0);
      switch (GET_CODE (x6))
        {
        case REG:
        case SUBREG:
          switch (pattern57 (x1))
            {
            case 0:
              return 798; /* one_cmplqi2 */

            case 1:
              return 800; /* one_cmplhi2 */

            case 2:
              return 802; /* one_cmplpsi2 */

            case 3:
              return 804; /* one_cmplsi2 */

            case 4:
              x3 = XEXP (x1, 0);
              x8 = XEXP (x3, 2);
              operands[1] = x8;
              if (!const_0_to_7_operand (operands[1], E_QImode)
                  || GET_MODE (x2) != E_QImode)
                return -1;
              operands[2] = x6;
              if (!register_operand (operands[2], E_QImode))
                return -1;
              x9 = XEXP (x3, 0);
              switch (pattern230 (x9))
                {
                case 0:
                  return 1077; /* *insv.not.io */

                case 1:
                  return 1088; /* *insv.not-bit.0_split */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case ROTATE:
          if (pattern58 (x1) != 0)
            return -1;
          return 1017; /* *avr.md:9025 */

        case ZERO_EXTRACT:
          if (pnum_clobbers == NULL
              || GET_MODE (x6) != E_QImode)
            return -1;
          x10 = XEXP (x6, 1);
          if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
            return -1;
          x3 = XEXP (x1, 0);
          if (GET_CODE (x3) != ZERO_EXTRACT
              || GET_MODE (x3) != E_QImode)
            return -1;
          x11 = XEXP (x3, 1);
          if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
            return -1;
          x9 = XEXP (x3, 0);
          operands[0] = x9;
          if (!register_operand (operands[0], E_QImode))
            return -1;
          x8 = XEXP (x3, 2);
          operands[1] = x8;
          if (!const_0_to_7_operand (operands[1], E_QImode)
              || GET_MODE (x2) != E_QImode)
            return -1;
          x7 = XEXP (x6, 0);
          operands[2] = x7;
          if (!register_operand (operands[2], E_QImode))
            return -1;
          x12 = XEXP (x6, 2);
          operands[3] = x12;
          if (!const_0_to_7_operand (operands[3], E_QImode)
              || !
#line 10059 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          *pnum_clobbers = 1;
          return 1084; /* insv_notbit */

        case LSHIFTRT:
          if (pattern59 (x1) != 0)
            return -1;
          return 1085; /* *insv.not-shiftrt_split */

        case ASHIFTRT:
          if (pattern59 (x1) != 0)
            return -1;
          return 1086; /* *insv.not-shiftrt_split */

        default:
          return -1;
        }

    case SIGN_EXTEND:
      switch (pattern20 (x1))
        {
        case 0:
          return 806; /* extendqihi2 */

        case 1:
          return 808; /* extendqipsi2 */

        case 2:
          return 812; /* extendhipsi2 */

        case 3:
          return 810; /* extendqisi2 */

        case 4:
          return 814; /* extendhisi2 */

        case 5:
          return 816; /* extendpsisi2 */

        default:
          return -1;
        }

    case LO_SUM:
      if (pnum_clobbers == NULL
          || GET_MODE (x2) != E_PSImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_PSImode))
        return -1;
      x6 = XEXP (x2, 0);
      operands[1] = x6;
      if (!const_int_operand (operands[1], E_QImode))
        return -1;
      x13 = XEXP (x2, 1);
      operands[2] = x13;
      if (!register_operand (operands[2], E_HImode))
        return -1;
      *pnum_clobbers = 1;
      return 822; /* n_extendhipsi2 */

    case COMPARE:
      return recog_22 (x1, insn, pnum_clobbers);

    case IF_THEN_ELSE:
      x6 = XEXP (x2, 0);
      switch (GET_CODE (x6))
        {
        case NE:
        case EQ:
        case GE:
        case GT:
        case LE:
        case LT:
        case GEU:
        case GTU:
        case LEU:
        case LTU:
          if (ordered_comparison_operator (x6, E_VOIDmode))
            {
              res = recog_20 (x1, insn, pnum_clobbers);
              if (res >= 0)
                return res;
            }
          x10 = XEXP (x6, 1);
          if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          switch (pattern91 (x1))
            {
            case 0:
              return 948; /* sbrx_branchqi_split */

            case 1:
              return 949; /* sbrx_branchhi_split */

            case 2:
              return 950; /* sbrx_branchpsi_split */

            case 3:
              return 951; /* sbrx_branchsi_split */

            case 4:
              return 952; /* sbrx_branchdi_split */

            case 5:
              if (low_io_address_operand (operands[1], E_VOIDmode))
                return 982; /* *sbix_branch_split */
              if (!high_io_address_operand (operands[1], E_VOIDmode))
                return -1;
              return 988; /* *sbix_branch_tmp_split */

            case 6:
              if (low_io_address_operand (operands[1], E_VOIDmode))
                return 983; /* *sbix_branch_split */
              if (!high_io_address_operand (operands[1], E_VOIDmode))
                return -1;
              return 989; /* *sbix_branch_tmp_split */

            case 7:
              return 958; /* *sbrx_and_branchqi_split */

            case 8:
              return 959; /* *sbrx_and_branchhi_split */

            case 9:
              return 960; /* *sbrx_and_branchpsi_split */

            case 10:
              return 961; /* *sbrx_and_branchsi_split */

            case 11:
              operands[0] = x6;
              if (gelt_operator (operands[0], E_VOIDmode))
                {
                  x7 = XEXP (x6, 0);
                  if (GET_CODE (x7) == MEM
                      && GET_MODE (x7) == E_QImode)
                    {
                      x14 = XEXP (x7, 0);
                      operands[1] = x14;
                      x13 = XEXP (x2, 1);
                      x15 = XEXP (x13, 0);
                      operands[2] = x15;
                      if (low_io_address_operand (operands[1], E_VOIDmode))
                        return 986; /* *sbix_branch_bit7_split */
                      if (high_io_address_operand (operands[1], E_VOIDmode))
                        return 992; /* *sbix_branch_tmp_bit7_split */
                    }
                }
              if (GET_CODE (x6) != GE)
                return -1;
              x7 = XEXP (x6, 0);
              operands[0] = x7;
              if (!register_operand (operands[0], E_QImode))
                return -1;
              x13 = XEXP (x2, 1);
              x15 = XEXP (x13, 0);
              operands[1] = x15;
              return 1020; /* *flash_segment1 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case ROTATERT:
      if (pnum_clobbers == NULL
          || GET_MODE (x2) != E_QImode)
        return -1;
      x6 = XEXP (x2, 0);
      if (GET_CODE (x6) != CONST_INT
          || XWINT (x6, 0) != -128L)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_QImode))
        return -1;
      x13 = XEXP (x2, 1);
      operands[1] = x13;
      if (!register_operand (operands[1], E_QImode)
          || !
#line 9013 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 1016; /* *mask1_0x80 */

    case PARITY:
      if (pnum_clobbers != NULL
          && GET_MODE (x2) == E_HImode)
        {
          x3 = XEXP (x1, 0);
          operands[0] = x3;
          if (register_operand (operands[0], E_HImode))
            {
              x6 = XEXP (x2, 0);
              operands[1] = x6;
              switch (GET_MODE (operands[1]))
                {
                case E_HImode:
                  if (register_operand (operands[1], E_HImode)
                      && 
#line 9144 "../../gcc/config/avr/avr.md"
(!reload_completed))
                    {
                      *pnum_clobbers = 1;
                      return 1022; /* *parityhi2 */
                    }
                  break;

                case E_QImode:
                  if (register_operand (operands[1], E_QImode)
                      && 
#line 9173 "../../gcc/config/avr/avr.md"
(!reload_completed))
                    {
                      *pnum_clobbers = 1;
                      return 1024; /* *parityqihi2.2 */
                    }
                  break;

                default:
                  break;
                }
            }
        }
      if (GET_MODE (x2) != E_HImode
          || pattern60 (x1, 
24, 
E_HImode) != 0)
        return -1;
      return 1025; /* *parityhi2.libgcc_split */

    case POPCOUNT:
      switch (pattern22 (x1))
        {
        case 0:
          return 1032; /* *popcounthi2.libgcc_split */

        case 1:
          return 1036; /* *popcountqi2.libgcc_split */

        default:
          return -1;
        }

    case CLZ:
      if (pnum_clobbers == NULL
          || GET_MODE (x2) != E_HImode
          || pattern60 (x1, 
24, 
E_HImode) != 0)
        return -1;
      *pnum_clobbers = 1;
      return 1039; /* *clzhi2.libgcc_split */

    case CTZ:
      if (pnum_clobbers == NULL
          || GET_MODE (x2) != E_HImode
          || pattern60 (x1, 
24, 
E_HImode) != 0)
        return -1;
      *pnum_clobbers = 1;
      return 1043; /* *ctzhi2.libgcc_split */

    case FFS:
      if (pnum_clobbers == NULL
          || GET_MODE (x2) != E_HImode
          || pattern60 (x1, 
24, 
E_HImode) != 0)
        return -1;
      *pnum_clobbers = 1;
      return 1047; /* *ffshi2.libgcc_split */

    case COPYSIGN:
      if (GET_MODE (x2) != E_SFmode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_SFmode))
        return -1;
      x6 = XEXP (x2, 0);
      operands[1] = x6;
      if (!register_operand (operands[1], E_SFmode))
        return -1;
      x13 = XEXP (x2, 1);
      operands[2] = x13;
      if (!nonmemory_operand (operands[2], E_SFmode))
        return -1;
      return 1051; /* copysignsf3 */

    case BSWAP:
      if (GET_MODE (x2) != E_SImode
          || pattern60 (x1, 
22, 
E_SImode) != 0)
        return -1;
      return 1052; /* *bswapsi2.libgcc_split */

    case SIGN_EXTRACT:
      x13 = XEXP (x2, 1);
      if (x13 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x6 = XEXP (x2, 0);
      switch (GET_CODE (x6))
        {
        case REG:
        case SUBREG:
          x3 = XEXP (x1, 0);
          switch (GET_CODE (x3))
            {
            case ZERO_EXTRACT:
              if (pattern137 (x1) != 0)
                return -1;
              return 1080; /* *insv.extract */

            case REG:
            case SUBREG:
              operands[0] = x3;
              operands[1] = x6;
              switch (pattern180 (x2))
                {
                case 0:
                  return 1216; /* *sextr.qi.qi_split */

                case 1:
                  return 1220; /* *sextr.qi.hi_split */

                case 2:
                  return 1224; /* *sextr.qi.psi_split */

                case 3:
                  return 1228; /* *sextr.qi.si_split */

                case 4:
                  return 1217; /* *sextr.hi.qi_split */

                case 5:
                  return 1221; /* *sextr.hi.hi_split */

                case 6:
                  return 1225; /* *sextr.hi.psi_split */

                case 7:
                  return 1229; /* *sextr.hi.si_split */

                case 8:
                  return 1218; /* *sextr.psi.qi_split */

                case 9:
                  return 1222; /* *sextr.psi.hi_split */

                case 10:
                  return 1226; /* *sextr.psi.psi_split */

                case 11:
                  return 1230; /* *sextr.psi.si_split */

                case 12:
                  return 1219; /* *sextr.si.qi_split */

                case 13:
                  return 1223; /* *sextr.si.hi_split */

                case 14:
                  return 1227; /* *sextr.si.psi_split */

                case 15:
                  return 1231; /* *sextr.si.si_split */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case XOR:
          if (pattern92 (x1) != 0
              || !
#line 10137 "../../gcc/config/avr/avr.md"
(INTVAL (operands[4]) & (1 << INTVAL (operands[3]))))
            return -1;
          return 1090; /* *insv.xor-extract_split */

        default:
          return -1;
        }

    case ZERO_EXTRACT:
      return recog_36 (x1, insn, pnum_clobbers);

    case GE:
      if (GET_MODE (x2) != E_QImode)
        return -1;
      x13 = XEXP (x2, 1);
      if (x13 == const_int_rtx[MAX_SAVED_CONST_INT + 0]
          && pattern95 (x1) == 0)
        return 1089; /* *insv.not-bit.7_split */
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      switch (pattern96 (x2))
        {
        case 0:
          return 1173; /* *extzvqi.ge */

        case 1:
          return 1174; /* *extzvhi.ge */

        case 2:
          return 1175; /* *extzvpsi.ge */

        case 3:
          return 1176; /* *extzvsi.ge */

        default:
          return -1;
        }

    case FRACT_CONVERT:
      switch (pattern23 (x1))
        {
        case 0:
          return 1496; /* fractuqqqq2 */

        case 1:
          return 1497; /* fracthqqq2 */

        case 2:
          return 1498; /* fractuhqqq2 */

        case 3:
          return 1499; /* fracthaqq2 */

        case 4:
          return 1500; /* fractuhaqq2 */

        case 5:
          return 1501; /* fractsqqq2 */

        case 6:
          return 1502; /* fractusqqq2 */

        case 7:
          return 1503; /* fractsaqq2 */

        case 8:
          return 1504; /* fractusaqq2 */

        case 9:
          return 1505; /* fractdqqq2 */

        case 10:
          return 1506; /* fractudqqq2 */

        case 11:
          return 1507; /* fractdaqq2 */

        case 12:
          return 1508; /* fractudaqq2 */

        case 13:
          return 1509; /* fracttaqq2 */

        case 14:
          return 1510; /* fractutaqq2 */

        case 15:
          return 1511; /* fractqiqq2 */

        case 16:
          return 1512; /* fracthiqq2 */

        case 17:
          return 1513; /* fractsiqq2 */

        case 18:
          return 1514; /* fractdiqq2 */

        case 19:
          return 1515; /* fractqquqq2 */

        case 20:
          return 1516; /* fracthquqq2 */

        case 21:
          return 1517; /* fractuhquqq2 */

        case 22:
          return 1518; /* fracthauqq2 */

        case 23:
          return 1519; /* fractuhauqq2 */

        case 24:
          return 1520; /* fractsquqq2 */

        case 25:
          return 1521; /* fractusquqq2 */

        case 26:
          return 1522; /* fractsauqq2 */

        case 27:
          return 1523; /* fractusauqq2 */

        case 28:
          return 1524; /* fractdquqq2 */

        case 29:
          return 1525; /* fractudquqq2 */

        case 30:
          return 1526; /* fractdauqq2 */

        case 31:
          return 1527; /* fractudauqq2 */

        case 32:
          return 1528; /* fracttauqq2 */

        case 33:
          return 1529; /* fractutauqq2 */

        case 34:
          return 1530; /* fractqiuqq2 */

        case 35:
          return 1531; /* fracthiuqq2 */

        case 36:
          return 1532; /* fractsiuqq2 */

        case 37:
          return 1533; /* fractdiuqq2 */

        case 38:
          return 1534; /* fractqqhq2 */

        case 39:
          return 1535; /* fractuqqhq2 */

        case 40:
          return 1536; /* fractuhqhq2 */

        case 41:
          return 1537; /* fracthahq2 */

        case 42:
          return 1538; /* fractuhahq2 */

        case 43:
          return 1539; /* fractsqhq2 */

        case 44:
          return 1540; /* fractusqhq2 */

        case 45:
          return 1541; /* fractsahq2 */

        case 46:
          return 1542; /* fractusahq2 */

        case 47:
          return 1543; /* fractdqhq2 */

        case 48:
          return 1544; /* fractudqhq2 */

        case 49:
          return 1545; /* fractdahq2 */

        case 50:
          return 1546; /* fractudahq2 */

        case 51:
          return 1547; /* fracttahq2 */

        case 52:
          return 1548; /* fractutahq2 */

        case 53:
          return 1549; /* fractqihq2 */

        case 54:
          return 1550; /* fracthihq2 */

        case 55:
          return 1551; /* fractsihq2 */

        case 56:
          return 1552; /* fractdihq2 */

        case 57:
          return 1553; /* fractqquhq2 */

        case 58:
          return 1554; /* fractuqquhq2 */

        case 59:
          return 1555; /* fracthquhq2 */

        case 60:
          return 1556; /* fracthauhq2 */

        case 61:
          return 1557; /* fractuhauhq2 */

        case 62:
          return 1558; /* fractsquhq2 */

        case 63:
          return 1559; /* fractusquhq2 */

        case 64:
          return 1560; /* fractsauhq2 */

        case 65:
          return 1561; /* fractusauhq2 */

        case 66:
          return 1562; /* fractdquhq2 */

        case 67:
          return 1563; /* fractudquhq2 */

        case 68:
          return 1564; /* fractdauhq2 */

        case 69:
          return 1565; /* fractudauhq2 */

        case 70:
          return 1566; /* fracttauhq2 */

        case 71:
          return 1567; /* fractutauhq2 */

        case 72:
          return 1568; /* fractqiuhq2 */

        case 73:
          return 1569; /* fracthiuhq2 */

        case 74:
          return 1570; /* fractsiuhq2 */

        case 75:
          return 1571; /* fractdiuhq2 */

        case 76:
          return 1572; /* fractqqha2 */

        case 77:
          return 1573; /* fractuqqha2 */

        case 78:
          return 1574; /* fracthqha2 */

        case 79:
          return 1575; /* fractuhqha2 */

        case 80:
          return 1576; /* fractuhaha2 */

        case 81:
          return 1577; /* fractsqha2 */

        case 82:
          return 1578; /* fractusqha2 */

        case 83:
          return 1579; /* fractsaha2 */

        case 84:
          return 1580; /* fractusaha2 */

        case 85:
          return 1581; /* fractdqha2 */

        case 86:
          return 1582; /* fractudqha2 */

        case 87:
          return 1583; /* fractdaha2 */

        case 88:
          return 1584; /* fractudaha2 */

        case 89:
          return 1585; /* fracttaha2 */

        case 90:
          return 1586; /* fractutaha2 */

        case 91:
          return 1587; /* fractqiha2 */

        case 92:
          return 1588; /* fracthiha2 */

        case 93:
          return 1589; /* fractsiha2 */

        case 94:
          return 1590; /* fractdiha2 */

        case 95:
          return 1591; /* fractqquha2 */

        case 96:
          return 1592; /* fractuqquha2 */

        case 97:
          return 1593; /* fracthquha2 */

        case 98:
          return 1594; /* fractuhquha2 */

        case 99:
          return 1595; /* fracthauha2 */

        case 100:
          return 1596; /* fractsquha2 */

        case 101:
          return 1597; /* fractusquha2 */

        case 102:
          return 1598; /* fractsauha2 */

        case 103:
          return 1599; /* fractusauha2 */

        case 104:
          return 1600; /* fractdquha2 */

        case 105:
          return 1601; /* fractudquha2 */

        case 106:
          return 1602; /* fractdauha2 */

        case 107:
          return 1603; /* fractudauha2 */

        case 108:
          return 1604; /* fracttauha2 */

        case 109:
          return 1605; /* fractutauha2 */

        case 110:
          return 1606; /* fractqiuha2 */

        case 111:
          return 1607; /* fracthiuha2 */

        case 112:
          return 1608; /* fractsiuha2 */

        case 113:
          return 1609; /* fractdiuha2 */

        case 114:
          return 1610; /* fractqqsq2 */

        case 115:
          return 1611; /* fractuqqsq2 */

        case 116:
          return 1612; /* fracthqsq2 */

        case 117:
          return 1613; /* fractuhqsq2 */

        case 118:
          return 1614; /* fracthasq2 */

        case 119:
          return 1615; /* fractuhasq2 */

        case 120:
          return 1616; /* fractusqsq2 */

        case 121:
          return 1617; /* fractsasq2 */

        case 122:
          return 1618; /* fractusasq2 */

        case 123:
          return 1619; /* fractdqsq2 */

        case 124:
          return 1620; /* fractudqsq2 */

        case 125:
          return 1621; /* fractdasq2 */

        case 126:
          return 1622; /* fractudasq2 */

        case 127:
          return 1623; /* fracttasq2 */

        case 128:
          return 1624; /* fractutasq2 */

        case 129:
          return 1625; /* fractqisq2 */

        case 130:
          return 1626; /* fracthisq2 */

        case 131:
          return 1627; /* fractsisq2 */

        case 132:
          return 1628; /* fractdisq2 */

        case 133:
          return 1629; /* fractqqusq2 */

        case 134:
          return 1630; /* fractuqqusq2 */

        case 135:
          return 1631; /* fracthqusq2 */

        case 136:
          return 1632; /* fractuhqusq2 */

        case 137:
          return 1633; /* fracthausq2 */

        case 138:
          return 1634; /* fractuhausq2 */

        case 139:
          return 1635; /* fractsqusq2 */

        case 140:
          return 1636; /* fractsausq2 */

        case 141:
          return 1637; /* fractusausq2 */

        case 142:
          return 1638; /* fractdqusq2 */

        case 143:
          return 1639; /* fractudqusq2 */

        case 144:
          return 1640; /* fractdausq2 */

        case 145:
          return 1641; /* fractudausq2 */

        case 146:
          return 1642; /* fracttausq2 */

        case 147:
          return 1643; /* fractutausq2 */

        case 148:
          return 1644; /* fractqiusq2 */

        case 149:
          return 1645; /* fracthiusq2 */

        case 150:
          return 1646; /* fractsiusq2 */

        case 151:
          return 1647; /* fractdiusq2 */

        case 152:
          return 1648; /* fractqqsa2 */

        case 153:
          return 1649; /* fractuqqsa2 */

        case 154:
          return 1650; /* fracthqsa2 */

        case 155:
          return 1651; /* fractuhqsa2 */

        case 156:
          return 1652; /* fracthasa2 */

        case 157:
          return 1653; /* fractuhasa2 */

        case 158:
          return 1654; /* fractsqsa2 */

        case 159:
          return 1655; /* fractusqsa2 */

        case 160:
          return 1656; /* fractusasa2 */

        case 161:
          return 1657; /* fractdqsa2 */

        case 162:
          return 1658; /* fractudqsa2 */

        case 163:
          return 1659; /* fractdasa2 */

        case 164:
          return 1660; /* fractudasa2 */

        case 165:
          return 1661; /* fracttasa2 */

        case 166:
          return 1662; /* fractutasa2 */

        case 167:
          return 1663; /* fractqisa2 */

        case 168:
          return 1664; /* fracthisa2 */

        case 169:
          return 1665; /* fractsisa2 */

        case 170:
          return 1666; /* fractdisa2 */

        case 171:
          return 1667; /* fractqqusa2 */

        case 172:
          return 1668; /* fractuqqusa2 */

        case 173:
          return 1669; /* fracthqusa2 */

        case 174:
          return 1670; /* fractuhqusa2 */

        case 175:
          return 1671; /* fracthausa2 */

        case 176:
          return 1672; /* fractuhausa2 */

        case 177:
          return 1673; /* fractsqusa2 */

        case 178:
          return 1674; /* fractusqusa2 */

        case 179:
          return 1675; /* fractsausa2 */

        case 180:
          return 1676; /* fractdqusa2 */

        case 181:
          return 1677; /* fractudqusa2 */

        case 182:
          return 1678; /* fractdausa2 */

        case 183:
          return 1679; /* fractudausa2 */

        case 184:
          return 1680; /* fracttausa2 */

        case 185:
          return 1681; /* fractutausa2 */

        case 186:
          return 1682; /* fractqiusa2 */

        case 187:
          return 1683; /* fracthiusa2 */

        case 188:
          return 1684; /* fractsiusa2 */

        case 189:
          return 1685; /* fractdiusa2 */

        case 190:
          return 1686; /* fractqqdq2 */

        case 191:
          return 1687; /* fractuqqdq2 */

        case 192:
          return 1688; /* fracthqdq2 */

        case 193:
          return 1689; /* fractuhqdq2 */

        case 194:
          return 1690; /* fracthadq2 */

        case 195:
          return 1691; /* fractuhadq2 */

        case 196:
          return 1692; /* fractsqdq2 */

        case 197:
          return 1693; /* fractusqdq2 */

        case 198:
          return 1694; /* fractsadq2 */

        case 199:
          return 1695; /* fractusadq2 */

        case 200:
          return 1696; /* fractudqdq2 */

        case 201:
          return 1697; /* fractdadq2 */

        case 202:
          return 1698; /* fractudadq2 */

        case 203:
          return 1699; /* fracttadq2 */

        case 204:
          return 1700; /* fractutadq2 */

        case 205:
          return 1701; /* fractqidq2 */

        case 206:
          return 1702; /* fracthidq2 */

        case 207:
          return 1703; /* fractsidq2 */

        case 208:
          return 1704; /* fractdidq2 */

        case 209:
          return 1705; /* fractqqudq2 */

        case 210:
          return 1706; /* fractuqqudq2 */

        case 211:
          return 1707; /* fracthqudq2 */

        case 212:
          return 1708; /* fractuhqudq2 */

        case 213:
          return 1709; /* fracthaudq2 */

        case 214:
          return 1710; /* fractuhaudq2 */

        case 215:
          return 1711; /* fractsqudq2 */

        case 216:
          return 1712; /* fractusqudq2 */

        case 217:
          return 1713; /* fractsaudq2 */

        case 218:
          return 1714; /* fractusaudq2 */

        case 219:
          return 1715; /* fractdqudq2 */

        case 220:
          return 1716; /* fractdaudq2 */

        case 221:
          return 1717; /* fractudaudq2 */

        case 222:
          return 1718; /* fracttaudq2 */

        case 223:
          return 1719; /* fractutaudq2 */

        case 224:
          return 1720; /* fractqiudq2 */

        case 225:
          return 1721; /* fracthiudq2 */

        case 226:
          return 1722; /* fractsiudq2 */

        case 227:
          return 1723; /* fractdiudq2 */

        case 228:
          return 1724; /* fractqqda2 */

        case 229:
          return 1725; /* fractuqqda2 */

        case 230:
          return 1726; /* fracthqda2 */

        case 231:
          return 1727; /* fractuhqda2 */

        case 232:
          return 1728; /* fracthada2 */

        case 233:
          return 1729; /* fractuhada2 */

        case 234:
          return 1730; /* fractsqda2 */

        case 235:
          return 1731; /* fractusqda2 */

        case 236:
          return 1732; /* fractsada2 */

        case 237:
          return 1733; /* fractusada2 */

        case 238:
          return 1734; /* fractdqda2 */

        case 239:
          return 1735; /* fractudqda2 */

        case 240:
          return 1736; /* fractudada2 */

        case 241:
          return 1737; /* fracttada2 */

        case 242:
          return 1738; /* fractutada2 */

        case 243:
          return 1739; /* fractqida2 */

        case 244:
          return 1740; /* fracthida2 */

        case 245:
          return 1741; /* fractsida2 */

        case 246:
          return 1742; /* fractdida2 */

        case 247:
          return 1743; /* fractqquda2 */

        case 248:
          return 1744; /* fractuqquda2 */

        case 249:
          return 1745; /* fracthquda2 */

        case 250:
          return 1746; /* fractuhquda2 */

        case 251:
          return 1747; /* fracthauda2 */

        case 252:
          return 1748; /* fractuhauda2 */

        case 253:
          return 1749; /* fractsquda2 */

        case 254:
          return 1750; /* fractusquda2 */

        case 255:
          return 1751; /* fractsauda2 */

        case 256:
          return 1752; /* fractusauda2 */

        case 257:
          return 1753; /* fractdquda2 */

        case 258:
          return 1754; /* fractudquda2 */

        case 259:
          return 1755; /* fractdauda2 */

        case 260:
          return 1756; /* fracttauda2 */

        case 261:
          return 1757; /* fractutauda2 */

        case 262:
          return 1758; /* fractqiuda2 */

        case 263:
          return 1759; /* fracthiuda2 */

        case 264:
          return 1760; /* fractsiuda2 */

        case 265:
          return 1761; /* fractdiuda2 */

        case 266:
          return 1762; /* fractqqta2 */

        case 267:
          return 1763; /* fractuqqta2 */

        case 268:
          return 1764; /* fracthqta2 */

        case 269:
          return 1765; /* fractuhqta2 */

        case 270:
          return 1766; /* fracthata2 */

        case 271:
          return 1767; /* fractuhata2 */

        case 272:
          return 1768; /* fractsqta2 */

        case 273:
          return 1769; /* fractusqta2 */

        case 274:
          return 1770; /* fractsata2 */

        case 275:
          return 1771; /* fractusata2 */

        case 276:
          return 1772; /* fractdqta2 */

        case 277:
          return 1773; /* fractudqta2 */

        case 278:
          return 1774; /* fractdata2 */

        case 279:
          return 1775; /* fractudata2 */

        case 280:
          return 1776; /* fractutata2 */

        case 281:
          return 1777; /* fractqita2 */

        case 282:
          return 1778; /* fracthita2 */

        case 283:
          return 1779; /* fractsita2 */

        case 284:
          return 1780; /* fractdita2 */

        case 285:
          return 1781; /* fractqquta2 */

        case 286:
          return 1782; /* fractuqquta2 */

        case 287:
          return 1783; /* fracthquta2 */

        case 288:
          return 1784; /* fractuhquta2 */

        case 289:
          return 1785; /* fracthauta2 */

        case 290:
          return 1786; /* fractuhauta2 */

        case 291:
          return 1787; /* fractsquta2 */

        case 292:
          return 1788; /* fractusquta2 */

        case 293:
          return 1789; /* fractsauta2 */

        case 294:
          return 1790; /* fractusauta2 */

        case 295:
          return 1791; /* fractdquta2 */

        case 296:
          return 1792; /* fractudquta2 */

        case 297:
          return 1793; /* fractdauta2 */

        case 298:
          return 1794; /* fractudauta2 */

        case 299:
          return 1795; /* fracttauta2 */

        case 300:
          return 1796; /* fractqiuta2 */

        case 301:
          return 1797; /* fracthiuta2 */

        case 302:
          return 1798; /* fractsiuta2 */

        case 303:
          return 1799; /* fractdiuta2 */

        case 304:
          return 1800; /* fractqqqi2 */

        case 305:
          return 1801; /* fractuqqqi2 */

        case 306:
          return 1802; /* fracthqqi2 */

        case 307:
          return 1803; /* fractuhqqi2 */

        case 308:
          return 1804; /* fracthaqi2 */

        case 309:
          return 1805; /* fractuhaqi2 */

        case 310:
          return 1806; /* fractsqqi2 */

        case 311:
          return 1807; /* fractusqqi2 */

        case 312:
          return 1808; /* fractsaqi2 */

        case 313:
          return 1809; /* fractusaqi2 */

        case 314:
          return 1810; /* fractdqqi2 */

        case 315:
          return 1811; /* fractudqqi2 */

        case 316:
          return 1812; /* fractdaqi2 */

        case 317:
          return 1813; /* fractudaqi2 */

        case 318:
          return 1814; /* fracttaqi2 */

        case 319:
          return 1815; /* fractutaqi2 */

        case 320:
          return 1816; /* fracthiqi2 */

        case 321:
          return 1817; /* fractsiqi2 */

        case 322:
          return 1818; /* fractdiqi2 */

        case 323:
          return 1819; /* fractqqhi2 */

        case 324:
          return 1820; /* fractuqqhi2 */

        case 325:
          return 1821; /* fracthqhi2 */

        case 326:
          return 1822; /* fractuhqhi2 */

        case 327:
          return 1823; /* fracthahi2 */

        case 328:
          return 1824; /* fractuhahi2 */

        case 329:
          return 1825; /* fractsqhi2 */

        case 330:
          return 1826; /* fractusqhi2 */

        case 331:
          return 1827; /* fractsahi2 */

        case 332:
          return 1828; /* fractusahi2 */

        case 333:
          return 1829; /* fractdqhi2 */

        case 334:
          return 1830; /* fractudqhi2 */

        case 335:
          return 1831; /* fractdahi2 */

        case 336:
          return 1832; /* fractudahi2 */

        case 337:
          return 1833; /* fracttahi2 */

        case 338:
          return 1834; /* fractutahi2 */

        case 339:
          return 1835; /* fractqihi2 */

        case 340:
          return 1836; /* fractsihi2 */

        case 341:
          return 1837; /* fractdihi2 */

        case 342:
          return 1838; /* fractqqsi2 */

        case 343:
          return 1839; /* fractuqqsi2 */

        case 344:
          return 1840; /* fracthqsi2 */

        case 345:
          return 1841; /* fractuhqsi2 */

        case 346:
          return 1842; /* fracthasi2 */

        case 347:
          return 1843; /* fractuhasi2 */

        case 348:
          return 1844; /* fractsqsi2 */

        case 349:
          return 1845; /* fractusqsi2 */

        case 350:
          return 1846; /* fractsasi2 */

        case 351:
          return 1847; /* fractusasi2 */

        case 352:
          return 1848; /* fractdqsi2 */

        case 353:
          return 1849; /* fractudqsi2 */

        case 354:
          return 1850; /* fractdasi2 */

        case 355:
          return 1851; /* fractudasi2 */

        case 356:
          return 1852; /* fracttasi2 */

        case 357:
          return 1853; /* fractutasi2 */

        case 358:
          return 1854; /* fractqisi2 */

        case 359:
          return 1855; /* fracthisi2 */

        case 360:
          return 1856; /* fractdisi2 */

        case 361:
          return 1857; /* fractqqdi2 */

        case 362:
          return 1858; /* fractuqqdi2 */

        case 363:
          return 1859; /* fracthqdi2 */

        case 364:
          return 1860; /* fractuhqdi2 */

        case 365:
          return 1861; /* fracthadi2 */

        case 366:
          return 1862; /* fractuhadi2 */

        case 367:
          return 1863; /* fractsqdi2 */

        case 368:
          return 1864; /* fractusqdi2 */

        case 369:
          return 1865; /* fractsadi2 */

        case 370:
          return 1866; /* fractusadi2 */

        case 371:
          return 1867; /* fractdqdi2 */

        case 372:
          return 1868; /* fractudqdi2 */

        case 373:
          return 1869; /* fractdadi2 */

        case 374:
          return 1870; /* fractudadi2 */

        case 375:
          return 1871; /* fracttadi2 */

        case 376:
          return 1872; /* fractutadi2 */

        case 377:
          return 1873; /* fractqidi2 */

        case 378:
          return 1874; /* fracthidi2 */

        case 379:
          return 1875; /* fractsidi2 */

        default:
          return -1;
        }

    case UNSIGNED_FRACT_CONVERT:
      switch (pattern23 (x1))
        {
        case 0:
          return 2256; /* fractunsuqqqq2 */

        case 1:
          return 2257; /* fractunshqqq2 */

        case 2:
          return 2258; /* fractunsuhqqq2 */

        case 3:
          return 2259; /* fractunshaqq2 */

        case 4:
          return 2260; /* fractunsuhaqq2 */

        case 5:
          return 2261; /* fractunssqqq2 */

        case 6:
          return 2262; /* fractunsusqqq2 */

        case 7:
          return 2263; /* fractunssaqq2 */

        case 8:
          return 2264; /* fractunsusaqq2 */

        case 9:
          return 2265; /* fractunsdqqq2 */

        case 10:
          return 2266; /* fractunsudqqq2 */

        case 11:
          return 2267; /* fractunsdaqq2 */

        case 12:
          return 2268; /* fractunsudaqq2 */

        case 13:
          return 2269; /* fractunstaqq2 */

        case 14:
          return 2270; /* fractunsutaqq2 */

        case 15:
          return 2271; /* fractunsqiqq2 */

        case 16:
          return 2272; /* fractunshiqq2 */

        case 17:
          return 2273; /* fractunssiqq2 */

        case 18:
          return 2274; /* fractunsdiqq2 */

        case 19:
          return 2275; /* fractunsqquqq2 */

        case 20:
          return 2276; /* fractunshquqq2 */

        case 21:
          return 2277; /* fractunsuhquqq2 */

        case 22:
          return 2278; /* fractunshauqq2 */

        case 23:
          return 2279; /* fractunsuhauqq2 */

        case 24:
          return 2280; /* fractunssquqq2 */

        case 25:
          return 2281; /* fractunsusquqq2 */

        case 26:
          return 2282; /* fractunssauqq2 */

        case 27:
          return 2283; /* fractunsusauqq2 */

        case 28:
          return 2284; /* fractunsdquqq2 */

        case 29:
          return 2285; /* fractunsudquqq2 */

        case 30:
          return 2286; /* fractunsdauqq2 */

        case 31:
          return 2287; /* fractunsudauqq2 */

        case 32:
          return 2288; /* fractunstauqq2 */

        case 33:
          return 2289; /* fractunsutauqq2 */

        case 34:
          return 2290; /* fractunsqiuqq2 */

        case 35:
          return 2291; /* fractunshiuqq2 */

        case 36:
          return 2292; /* fractunssiuqq2 */

        case 37:
          return 2293; /* fractunsdiuqq2 */

        case 38:
          return 2294; /* fractunsqqhq2 */

        case 39:
          return 2295; /* fractunsuqqhq2 */

        case 40:
          return 2296; /* fractunsuhqhq2 */

        case 41:
          return 2297; /* fractunshahq2 */

        case 42:
          return 2298; /* fractunsuhahq2 */

        case 43:
          return 2299; /* fractunssqhq2 */

        case 44:
          return 2300; /* fractunsusqhq2 */

        case 45:
          return 2301; /* fractunssahq2 */

        case 46:
          return 2302; /* fractunsusahq2 */

        case 47:
          return 2303; /* fractunsdqhq2 */

        case 48:
          return 2304; /* fractunsudqhq2 */

        case 49:
          return 2305; /* fractunsdahq2 */

        case 50:
          return 2306; /* fractunsudahq2 */

        case 51:
          return 2307; /* fractunstahq2 */

        case 52:
          return 2308; /* fractunsutahq2 */

        case 53:
          return 2309; /* fractunsqihq2 */

        case 54:
          return 2310; /* fractunshihq2 */

        case 55:
          return 2311; /* fractunssihq2 */

        case 56:
          return 2312; /* fractunsdihq2 */

        case 57:
          return 2313; /* fractunsqquhq2 */

        case 58:
          return 2314; /* fractunsuqquhq2 */

        case 59:
          return 2315; /* fractunshquhq2 */

        case 60:
          return 2316; /* fractunshauhq2 */

        case 61:
          return 2317; /* fractunsuhauhq2 */

        case 62:
          return 2318; /* fractunssquhq2 */

        case 63:
          return 2319; /* fractunsusquhq2 */

        case 64:
          return 2320; /* fractunssauhq2 */

        case 65:
          return 2321; /* fractunsusauhq2 */

        case 66:
          return 2322; /* fractunsdquhq2 */

        case 67:
          return 2323; /* fractunsudquhq2 */

        case 68:
          return 2324; /* fractunsdauhq2 */

        case 69:
          return 2325; /* fractunsudauhq2 */

        case 70:
          return 2326; /* fractunstauhq2 */

        case 71:
          return 2327; /* fractunsutauhq2 */

        case 72:
          return 2328; /* fractunsqiuhq2 */

        case 73:
          return 2329; /* fractunshiuhq2 */

        case 74:
          return 2330; /* fractunssiuhq2 */

        case 75:
          return 2331; /* fractunsdiuhq2 */

        case 76:
          return 2332; /* fractunsqqha2 */

        case 77:
          return 2333; /* fractunsuqqha2 */

        case 78:
          return 2334; /* fractunshqha2 */

        case 79:
          return 2335; /* fractunsuhqha2 */

        case 80:
          return 2336; /* fractunsuhaha2 */

        case 81:
          return 2337; /* fractunssqha2 */

        case 82:
          return 2338; /* fractunsusqha2 */

        case 83:
          return 2339; /* fractunssaha2 */

        case 84:
          return 2340; /* fractunsusaha2 */

        case 85:
          return 2341; /* fractunsdqha2 */

        case 86:
          return 2342; /* fractunsudqha2 */

        case 87:
          return 2343; /* fractunsdaha2 */

        case 88:
          return 2344; /* fractunsudaha2 */

        case 89:
          return 2345; /* fractunstaha2 */

        case 90:
          return 2346; /* fractunsutaha2 */

        case 91:
          return 2347; /* fractunsqiha2 */

        case 92:
          return 2348; /* fractunshiha2 */

        case 93:
          return 2349; /* fractunssiha2 */

        case 94:
          return 2350; /* fractunsdiha2 */

        case 95:
          return 2351; /* fractunsqquha2 */

        case 96:
          return 2352; /* fractunsuqquha2 */

        case 97:
          return 2353; /* fractunshquha2 */

        case 98:
          return 2354; /* fractunsuhquha2 */

        case 99:
          return 2355; /* fractunshauha2 */

        case 100:
          return 2356; /* fractunssquha2 */

        case 101:
          return 2357; /* fractunsusquha2 */

        case 102:
          return 2358; /* fractunssauha2 */

        case 103:
          return 2359; /* fractunsusauha2 */

        case 104:
          return 2360; /* fractunsdquha2 */

        case 105:
          return 2361; /* fractunsudquha2 */

        case 106:
          return 2362; /* fractunsdauha2 */

        case 107:
          return 2363; /* fractunsudauha2 */

        case 108:
          return 2364; /* fractunstauha2 */

        case 109:
          return 2365; /* fractunsutauha2 */

        case 110:
          return 2366; /* fractunsqiuha2 */

        case 111:
          return 2367; /* fractunshiuha2 */

        case 112:
          return 2368; /* fractunssiuha2 */

        case 113:
          return 2369; /* fractunsdiuha2 */

        case 114:
          return 2370; /* fractunsqqsq2 */

        case 115:
          return 2371; /* fractunsuqqsq2 */

        case 116:
          return 2372; /* fractunshqsq2 */

        case 117:
          return 2373; /* fractunsuhqsq2 */

        case 118:
          return 2374; /* fractunshasq2 */

        case 119:
          return 2375; /* fractunsuhasq2 */

        case 120:
          return 2376; /* fractunsusqsq2 */

        case 121:
          return 2377; /* fractunssasq2 */

        case 122:
          return 2378; /* fractunsusasq2 */

        case 123:
          return 2379; /* fractunsdqsq2 */

        case 124:
          return 2380; /* fractunsudqsq2 */

        case 125:
          return 2381; /* fractunsdasq2 */

        case 126:
          return 2382; /* fractunsudasq2 */

        case 127:
          return 2383; /* fractunstasq2 */

        case 128:
          return 2384; /* fractunsutasq2 */

        case 129:
          return 2385; /* fractunsqisq2 */

        case 130:
          return 2386; /* fractunshisq2 */

        case 131:
          return 2387; /* fractunssisq2 */

        case 132:
          return 2388; /* fractunsdisq2 */

        case 133:
          return 2389; /* fractunsqqusq2 */

        case 134:
          return 2390; /* fractunsuqqusq2 */

        case 135:
          return 2391; /* fractunshqusq2 */

        case 136:
          return 2392; /* fractunsuhqusq2 */

        case 137:
          return 2393; /* fractunshausq2 */

        case 138:
          return 2394; /* fractunsuhausq2 */

        case 139:
          return 2395; /* fractunssqusq2 */

        case 140:
          return 2396; /* fractunssausq2 */

        case 141:
          return 2397; /* fractunsusausq2 */

        case 142:
          return 2398; /* fractunsdqusq2 */

        case 143:
          return 2399; /* fractunsudqusq2 */

        case 144:
          return 2400; /* fractunsdausq2 */

        case 145:
          return 2401; /* fractunsudausq2 */

        case 146:
          return 2402; /* fractunstausq2 */

        case 147:
          return 2403; /* fractunsutausq2 */

        case 148:
          return 2404; /* fractunsqiusq2 */

        case 149:
          return 2405; /* fractunshiusq2 */

        case 150:
          return 2406; /* fractunssiusq2 */

        case 151:
          return 2407; /* fractunsdiusq2 */

        case 152:
          return 2408; /* fractunsqqsa2 */

        case 153:
          return 2409; /* fractunsuqqsa2 */

        case 154:
          return 2410; /* fractunshqsa2 */

        case 155:
          return 2411; /* fractunsuhqsa2 */

        case 156:
          return 2412; /* fractunshasa2 */

        case 157:
          return 2413; /* fractunsuhasa2 */

        case 158:
          return 2414; /* fractunssqsa2 */

        case 159:
          return 2415; /* fractunsusqsa2 */

        case 160:
          return 2416; /* fractunsusasa2 */

        case 161:
          return 2417; /* fractunsdqsa2 */

        case 162:
          return 2418; /* fractunsudqsa2 */

        case 163:
          return 2419; /* fractunsdasa2 */

        case 164:
          return 2420; /* fractunsudasa2 */

        case 165:
          return 2421; /* fractunstasa2 */

        case 166:
          return 2422; /* fractunsutasa2 */

        case 167:
          return 2423; /* fractunsqisa2 */

        case 168:
          return 2424; /* fractunshisa2 */

        case 169:
          return 2425; /* fractunssisa2 */

        case 170:
          return 2426; /* fractunsdisa2 */

        case 171:
          return 2427; /* fractunsqqusa2 */

        case 172:
          return 2428; /* fractunsuqqusa2 */

        case 173:
          return 2429; /* fractunshqusa2 */

        case 174:
          return 2430; /* fractunsuhqusa2 */

        case 175:
          return 2431; /* fractunshausa2 */

        case 176:
          return 2432; /* fractunsuhausa2 */

        case 177:
          return 2433; /* fractunssqusa2 */

        case 178:
          return 2434; /* fractunsusqusa2 */

        case 179:
          return 2435; /* fractunssausa2 */

        case 180:
          return 2436; /* fractunsdqusa2 */

        case 181:
          return 2437; /* fractunsudqusa2 */

        case 182:
          return 2438; /* fractunsdausa2 */

        case 183:
          return 2439; /* fractunsudausa2 */

        case 184:
          return 2440; /* fractunstausa2 */

        case 185:
          return 2441; /* fractunsutausa2 */

        case 186:
          return 2442; /* fractunsqiusa2 */

        case 187:
          return 2443; /* fractunshiusa2 */

        case 188:
          return 2444; /* fractunssiusa2 */

        case 189:
          return 2445; /* fractunsdiusa2 */

        case 190:
          return 2446; /* fractunsqqdq2 */

        case 191:
          return 2447; /* fractunsuqqdq2 */

        case 192:
          return 2448; /* fractunshqdq2 */

        case 193:
          return 2449; /* fractunsuhqdq2 */

        case 194:
          return 2450; /* fractunshadq2 */

        case 195:
          return 2451; /* fractunsuhadq2 */

        case 196:
          return 2452; /* fractunssqdq2 */

        case 197:
          return 2453; /* fractunsusqdq2 */

        case 198:
          return 2454; /* fractunssadq2 */

        case 199:
          return 2455; /* fractunsusadq2 */

        case 200:
          return 2456; /* fractunsudqdq2 */

        case 201:
          return 2457; /* fractunsdadq2 */

        case 202:
          return 2458; /* fractunsudadq2 */

        case 203:
          return 2459; /* fractunstadq2 */

        case 204:
          return 2460; /* fractunsutadq2 */

        case 205:
          return 2461; /* fractunsqidq2 */

        case 206:
          return 2462; /* fractunshidq2 */

        case 207:
          return 2463; /* fractunssidq2 */

        case 208:
          return 2464; /* fractunsdidq2 */

        case 209:
          return 2465; /* fractunsqqudq2 */

        case 210:
          return 2466; /* fractunsuqqudq2 */

        case 211:
          return 2467; /* fractunshqudq2 */

        case 212:
          return 2468; /* fractunsuhqudq2 */

        case 213:
          return 2469; /* fractunshaudq2 */

        case 214:
          return 2470; /* fractunsuhaudq2 */

        case 215:
          return 2471; /* fractunssqudq2 */

        case 216:
          return 2472; /* fractunsusqudq2 */

        case 217:
          return 2473; /* fractunssaudq2 */

        case 218:
          return 2474; /* fractunsusaudq2 */

        case 219:
          return 2475; /* fractunsdqudq2 */

        case 220:
          return 2476; /* fractunsdaudq2 */

        case 221:
          return 2477; /* fractunsudaudq2 */

        case 222:
          return 2478; /* fractunstaudq2 */

        case 223:
          return 2479; /* fractunsutaudq2 */

        case 224:
          return 2480; /* fractunsqiudq2 */

        case 225:
          return 2481; /* fractunshiudq2 */

        case 226:
          return 2482; /* fractunssiudq2 */

        case 227:
          return 2483; /* fractunsdiudq2 */

        case 228:
          return 2484; /* fractunsqqda2 */

        case 229:
          return 2485; /* fractunsuqqda2 */

        case 230:
          return 2486; /* fractunshqda2 */

        case 231:
          return 2487; /* fractunsuhqda2 */

        case 232:
          return 2488; /* fractunshada2 */

        case 233:
          return 2489; /* fractunsuhada2 */

        case 234:
          return 2490; /* fractunssqda2 */

        case 235:
          return 2491; /* fractunsusqda2 */

        case 236:
          return 2492; /* fractunssada2 */

        case 237:
          return 2493; /* fractunsusada2 */

        case 238:
          return 2494; /* fractunsdqda2 */

        case 239:
          return 2495; /* fractunsudqda2 */

        case 240:
          return 2496; /* fractunsudada2 */

        case 241:
          return 2497; /* fractunstada2 */

        case 242:
          return 2498; /* fractunsutada2 */

        case 243:
          return 2499; /* fractunsqida2 */

        case 244:
          return 2500; /* fractunshida2 */

        case 245:
          return 2501; /* fractunssida2 */

        case 246:
          return 2502; /* fractunsdida2 */

        case 247:
          return 2503; /* fractunsqquda2 */

        case 248:
          return 2504; /* fractunsuqquda2 */

        case 249:
          return 2505; /* fractunshquda2 */

        case 250:
          return 2506; /* fractunsuhquda2 */

        case 251:
          return 2507; /* fractunshauda2 */

        case 252:
          return 2508; /* fractunsuhauda2 */

        case 253:
          return 2509; /* fractunssquda2 */

        case 254:
          return 2510; /* fractunsusquda2 */

        case 255:
          return 2511; /* fractunssauda2 */

        case 256:
          return 2512; /* fractunsusauda2 */

        case 257:
          return 2513; /* fractunsdquda2 */

        case 258:
          return 2514; /* fractunsudquda2 */

        case 259:
          return 2515; /* fractunsdauda2 */

        case 260:
          return 2516; /* fractunstauda2 */

        case 261:
          return 2517; /* fractunsutauda2 */

        case 262:
          return 2518; /* fractunsqiuda2 */

        case 263:
          return 2519; /* fractunshiuda2 */

        case 264:
          return 2520; /* fractunssiuda2 */

        case 265:
          return 2521; /* fractunsdiuda2 */

        case 266:
          return 2522; /* fractunsqqta2 */

        case 267:
          return 2523; /* fractunsuqqta2 */

        case 268:
          return 2524; /* fractunshqta2 */

        case 269:
          return 2525; /* fractunsuhqta2 */

        case 270:
          return 2526; /* fractunshata2 */

        case 271:
          return 2527; /* fractunsuhata2 */

        case 272:
          return 2528; /* fractunssqta2 */

        case 273:
          return 2529; /* fractunsusqta2 */

        case 274:
          return 2530; /* fractunssata2 */

        case 275:
          return 2531; /* fractunsusata2 */

        case 276:
          return 2532; /* fractunsdqta2 */

        case 277:
          return 2533; /* fractunsudqta2 */

        case 278:
          return 2534; /* fractunsdata2 */

        case 279:
          return 2535; /* fractunsudata2 */

        case 280:
          return 2536; /* fractunsutata2 */

        case 281:
          return 2537; /* fractunsqita2 */

        case 282:
          return 2538; /* fractunshita2 */

        case 283:
          return 2539; /* fractunssita2 */

        case 284:
          return 2540; /* fractunsdita2 */

        case 285:
          return 2541; /* fractunsqquta2 */

        case 286:
          return 2542; /* fractunsuqquta2 */

        case 287:
          return 2543; /* fractunshquta2 */

        case 288:
          return 2544; /* fractunsuhquta2 */

        case 289:
          return 2545; /* fractunshauta2 */

        case 290:
          return 2546; /* fractunsuhauta2 */

        case 291:
          return 2547; /* fractunssquta2 */

        case 292:
          return 2548; /* fractunsusquta2 */

        case 293:
          return 2549; /* fractunssauta2 */

        case 294:
          return 2550; /* fractunsusauta2 */

        case 295:
          return 2551; /* fractunsdquta2 */

        case 296:
          return 2552; /* fractunsudquta2 */

        case 297:
          return 2553; /* fractunsdauta2 */

        case 298:
          return 2554; /* fractunsudauta2 */

        case 299:
          return 2555; /* fractunstauta2 */

        case 300:
          return 2556; /* fractunsqiuta2 */

        case 301:
          return 2557; /* fractunshiuta2 */

        case 302:
          return 2558; /* fractunssiuta2 */

        case 303:
          return 2559; /* fractunsdiuta2 */

        case 304:
          return 2560; /* fractunsqqqi2 */

        case 305:
          return 2561; /* fractunsuqqqi2 */

        case 306:
          return 2562; /* fractunshqqi2 */

        case 307:
          return 2563; /* fractunsuhqqi2 */

        case 308:
          return 2564; /* fractunshaqi2 */

        case 309:
          return 2565; /* fractunsuhaqi2 */

        case 310:
          return 2566; /* fractunssqqi2 */

        case 311:
          return 2567; /* fractunsusqqi2 */

        case 312:
          return 2568; /* fractunssaqi2 */

        case 313:
          return 2569; /* fractunsusaqi2 */

        case 314:
          return 2570; /* fractunsdqqi2 */

        case 315:
          return 2571; /* fractunsudqqi2 */

        case 316:
          return 2572; /* fractunsdaqi2 */

        case 317:
          return 2573; /* fractunsudaqi2 */

        case 318:
          return 2574; /* fractunstaqi2 */

        case 319:
          return 2575; /* fractunsutaqi2 */

        case 320:
          return 2576; /* fractunshiqi2 */

        case 321:
          return 2577; /* fractunssiqi2 */

        case 322:
          return 2578; /* fractunsdiqi2 */

        case 323:
          return 2579; /* fractunsqqhi2 */

        case 324:
          return 2580; /* fractunsuqqhi2 */

        case 325:
          return 2581; /* fractunshqhi2 */

        case 326:
          return 2582; /* fractunsuhqhi2 */

        case 327:
          return 2583; /* fractunshahi2 */

        case 328:
          return 2584; /* fractunsuhahi2 */

        case 329:
          return 2585; /* fractunssqhi2 */

        case 330:
          return 2586; /* fractunsusqhi2 */

        case 331:
          return 2587; /* fractunssahi2 */

        case 332:
          return 2588; /* fractunsusahi2 */

        case 333:
          return 2589; /* fractunsdqhi2 */

        case 334:
          return 2590; /* fractunsudqhi2 */

        case 335:
          return 2591; /* fractunsdahi2 */

        case 336:
          return 2592; /* fractunsudahi2 */

        case 337:
          return 2593; /* fractunstahi2 */

        case 338:
          return 2594; /* fractunsutahi2 */

        case 339:
          return 2595; /* fractunsqihi2 */

        case 340:
          return 2596; /* fractunssihi2 */

        case 341:
          return 2597; /* fractunsdihi2 */

        case 342:
          return 2598; /* fractunsqqsi2 */

        case 343:
          return 2599; /* fractunsuqqsi2 */

        case 344:
          return 2600; /* fractunshqsi2 */

        case 345:
          return 2601; /* fractunsuhqsi2 */

        case 346:
          return 2602; /* fractunshasi2 */

        case 347:
          return 2603; /* fractunsuhasi2 */

        case 348:
          return 2604; /* fractunssqsi2 */

        case 349:
          return 2605; /* fractunsusqsi2 */

        case 350:
          return 2606; /* fractunssasi2 */

        case 351:
          return 2607; /* fractunsusasi2 */

        case 352:
          return 2608; /* fractunsdqsi2 */

        case 353:
          return 2609; /* fractunsudqsi2 */

        case 354:
          return 2610; /* fractunsdasi2 */

        case 355:
          return 2611; /* fractunsudasi2 */

        case 356:
          return 2612; /* fractunstasi2 */

        case 357:
          return 2613; /* fractunsutasi2 */

        case 358:
          return 2614; /* fractunsqisi2 */

        case 359:
          return 2615; /* fractunshisi2 */

        case 360:
          return 2616; /* fractunsdisi2 */

        case 361:
          return 2617; /* fractunsqqdi2 */

        case 362:
          return 2618; /* fractunsuqqdi2 */

        case 363:
          return 2619; /* fractunshqdi2 */

        case 364:
          return 2620; /* fractunsuhqdi2 */

        case 365:
          return 2621; /* fractunshadi2 */

        case 366:
          return 2622; /* fractunsuhadi2 */

        case 367:
          return 2623; /* fractunssqdi2 */

        case 368:
          return 2624; /* fractunsusqdi2 */

        case 369:
          return 2625; /* fractunssadi2 */

        case 370:
          return 2626; /* fractunsusadi2 */

        case 371:
          return 2627; /* fractunsdqdi2 */

        case 372:
          return 2628; /* fractunsudqdi2 */

        case 373:
          return 2629; /* fractunsdadi2 */

        case 374:
          return 2630; /* fractunsudadi2 */

        case 375:
          return 2631; /* fractunstadi2 */

        case 376:
          return 2632; /* fractunsutadi2 */

        case 377:
          return 2633; /* fractunsqidi2 */

        case 378:
          return 2634; /* fractunshidi2 */

        case 379:
          return 2635; /* fractunssidi2 */

        default:
          return -1;
        }

    case SS_PLUS:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      switch (pattern62 (x2))
        {
        case 0:
          return 3016; /* ssaddqq3 */

        case 1:
          return 3018; /* ssaddhq3 */

        case 2:
          return 3020; /* ssaddha3 */

        case 3:
          return 3022; /* ssaddsa3 */

        case 4:
          return 3024; /* ssaddsq3 */

        default:
          break;
        }
      x6 = XEXP (x2, 0);
      if (GET_CODE (x6) != REG)
        return -1;
      switch (pattern63 (x1))
        {
        case 0:
          if (
#line 288 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
            return 3224; /* ssadddq3_insn */
          if (pnum_clobbers == NULL
              || !
#line 301 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          *pnum_clobbers = 1;
          return 3230; /* *ssadddq3_insn */

        case 1:
          if (
#line 288 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
            return 3226; /* ssaddda3_insn */
          if (pnum_clobbers == NULL
              || !
#line 301 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          *pnum_clobbers = 1;
          return 3232; /* *ssaddda3_insn */

        case 2:
          if (
#line 288 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
            return 3228; /* ssaddta3_insn */
          if (pnum_clobbers == NULL
              || !
#line 301 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          *pnum_clobbers = 1;
          return 3234; /* *ssaddta3_insn */

        case 3:
          if (
#line 309 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
            return 3236; /* ssadddq3_const_insn */
          if (pnum_clobbers == NULL
              || !
#line 322 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          *pnum_clobbers = 1;
          return 3242; /* *ssadddq3_const_insn */

        case 4:
          if (
#line 309 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
            return 3238; /* ssaddda3_const_insn */
          if (pnum_clobbers == NULL
              || !
#line 322 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          *pnum_clobbers = 1;
          return 3244; /* *ssaddda3_const_insn */

        case 5:
          if (
#line 309 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
            return 3240; /* ssaddta3_const_insn */
          if (pnum_clobbers == NULL
              || !
#line 322 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          *pnum_clobbers = 1;
          return 3246; /* *ssaddta3_const_insn */

        default:
          return -1;
        }

    case SS_MINUS:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      switch (pattern62 (x2))
        {
        case 0:
          return 3017; /* sssubqq3 */

        case 1:
          return 3019; /* sssubhq3 */

        case 2:
          return 3021; /* sssubha3 */

        case 3:
          return 3023; /* sssubsa3 */

        case 4:
          return 3025; /* sssubsq3 */

        default:
          break;
        }
      x6 = XEXP (x2, 0);
      if (GET_CODE (x6) != REG)
        return -1;
      switch (pattern63 (x1))
        {
        case 0:
          if (
#line 288 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
            return 3225; /* sssubdq3_insn */
          if (pnum_clobbers == NULL
              || !
#line 301 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          *pnum_clobbers = 1;
          return 3231; /* *sssubdq3_insn */

        case 1:
          if (
#line 288 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
            return 3227; /* sssubda3_insn */
          if (pnum_clobbers == NULL
              || !
#line 301 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          *pnum_clobbers = 1;
          return 3233; /* *sssubda3_insn */

        case 2:
          if (
#line 288 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
            return 3229; /* sssubta3_insn */
          if (pnum_clobbers == NULL
              || !
#line 301 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          *pnum_clobbers = 1;
          return 3235; /* *sssubta3_insn */

        case 3:
          if (
#line 309 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
            return 3237; /* sssubdq3_const_insn */
          if (pnum_clobbers == NULL
              || !
#line 322 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          *pnum_clobbers = 1;
          return 3243; /* *sssubdq3_const_insn */

        case 4:
          if (
#line 309 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
            return 3239; /* sssubda3_const_insn */
          if (pnum_clobbers == NULL
              || !
#line 322 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          *pnum_clobbers = 1;
          return 3245; /* *sssubda3_const_insn */

        case 5:
          if (
#line 309 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
            return 3241; /* sssubta3_const_insn */
          if (pnum_clobbers == NULL
              || !
#line 322 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          *pnum_clobbers = 1;
          return 3247; /* *sssubta3_const_insn */

        default:
          return -1;
        }

    case US_PLUS:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      switch (pattern64 (x2))
        {
        case 0:
          return 3036; /* usadduqq3 */

        case 1:
          return 3038; /* usadduhq3 */

        case 2:
          return 3040; /* usadduha3 */

        case 3:
          return 3042; /* usaddusa3 */

        case 4:
          return 3044; /* usaddusq3 */

        default:
          break;
        }
      x6 = XEXP (x2, 0);
      if (GET_CODE (x6) != REG)
        return -1;
      switch (pattern65 (x1))
        {
        case 0:
          if (
#line 361 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
            return 3248; /* usaddudq3_insn */
          if (pnum_clobbers == NULL
              || !
#line 374 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          *pnum_clobbers = 1;
          return 3254; /* *usaddudq3_insn */

        case 1:
          if (
#line 361 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
            return 3250; /* usadduda3_insn */
          if (pnum_clobbers == NULL
              || !
#line 374 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          *pnum_clobbers = 1;
          return 3256; /* *usadduda3_insn */

        case 2:
          if (
#line 361 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
            return 3252; /* usadduta3_insn */
          if (pnum_clobbers == NULL
              || !
#line 374 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          *pnum_clobbers = 1;
          return 3258; /* *usadduta3_insn */

        case 3:
          if (
#line 382 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
            return 3260; /* usaddudq3_const_insn */
          if (pnum_clobbers == NULL
              || !
#line 395 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          *pnum_clobbers = 1;
          return 3266; /* *usaddudq3_const_insn */

        case 4:
          if (
#line 382 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
            return 3262; /* usadduda3_const_insn */
          if (pnum_clobbers == NULL
              || !
#line 395 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          *pnum_clobbers = 1;
          return 3268; /* *usadduda3_const_insn */

        case 5:
          if (
#line 382 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
            return 3264; /* usadduta3_const_insn */
          if (pnum_clobbers == NULL
              || !
#line 395 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          *pnum_clobbers = 1;
          return 3270; /* *usadduta3_const_insn */

        default:
          return -1;
        }

    case US_MINUS:
      return recog_37 (x1, insn, pnum_clobbers);

    case SS_NEG:
      if (GET_MODE (x2) == E_QQmode)
        {
          x3 = XEXP (x1, 0);
          operands[0] = x3;
          if (register_operand (operands[0], E_QQmode))
            {
              x6 = XEXP (x2, 0);
              operands[1] = x6;
              if (register_operand (operands[1], E_QQmode))
                return 3056; /* ssnegqq2 */
            }
        }
      x6 = XEXP (x2, 0);
      if (GET_CODE (x6) != REG)
        return -1;
      switch (pattern66 (x1))
        {
        case 0:
          return 3061; /* *ssneghq2_split */

        case 1:
          return 3063; /* *ssnegha2_split */

        case 2:
          return 3069; /* *ssnegsa2_split */

        case 3:
          return 3071; /* *ssnegsq2_split */

        default:
          return -1;
        }

    case SS_ABS:
      if (GET_MODE (x2) == E_QQmode)
        {
          x3 = XEXP (x1, 0);
          operands[0] = x3;
          if (register_operand (operands[0], E_QQmode))
            {
              x6 = XEXP (x2, 0);
              operands[1] = x6;
              if (register_operand (operands[1], E_QQmode))
                return 3058; /* ssabsqq2 */
            }
        }
      x6 = XEXP (x2, 0);
      if (GET_CODE (x6) != REG)
        return -1;
      switch (pattern66 (x1))
        {
        case 0:
          return 3060; /* *ssabshq2_split */

        case 1:
          return 3062; /* *ssabsha2_split */

        case 2:
          return 3068; /* *ssabssa2_split */

        case 3:
          return 3070; /* *ssabssq2_split */

        default:
          return -1;
        }

    case UDIV:
      switch (pattern26 (x1, pnum_clobbers))
        {
        case 0:
          *pnum_clobbers = 1;
          return 3094; /* *udivqq3.call_split */

        case 1:
          *pnum_clobbers = 1;
          return 3096; /* *udivuqq3.call_split */

        case 2:
          *pnum_clobbers = 2;
          return 3102; /* *udivhq3.call_split */

        case 3:
          *pnum_clobbers = 2;
          return 3104; /* *udivuhq3.call_split */

        case 4:
          *pnum_clobbers = 2;
          return 3106; /* *udivha3.call_split */

        case 5:
          *pnum_clobbers = 2;
          return 3108; /* *udivuha3.call_split */

        case 6:
          *pnum_clobbers = 2;
          return 3118; /* *udivsa3.call_split */

        case 7:
          *pnum_clobbers = 2;
          return 3120; /* *udivusa3.call_split */

        default:
          return -1;
        }

    case DIV:
      switch (pattern26 (x1, pnum_clobbers))
        {
        case 0:
          *pnum_clobbers = 1;
          return 3095; /* *divqq3.call_split */

        case 1:
          *pnum_clobbers = 1;
          return 3097; /* *divuqq3.call_split */

        case 2:
          *pnum_clobbers = 2;
          return 3103; /* *divhq3.call_split */

        case 3:
          *pnum_clobbers = 2;
          return 3105; /* *divuhq3.call_split */

        case 4:
          *pnum_clobbers = 2;
          return 3107; /* *divha3.call_split */

        case 5:
          *pnum_clobbers = 2;
          return 3109; /* *divuha3.call_split */

        case 6:
          *pnum_clobbers = 2;
          return 3119; /* *divsa3.call_split */

        case 7:
          *pnum_clobbers = 2;
          return 3121; /* *divusa3.call_split */

        default:
          return -1;
        }

    default:
      return -1;
    }
}
