/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern6 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[1]))
    {
    case E_QImode:
      if (!register_operand (operands[1], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!register_operand (operands[1], E_HImode))
        return -1;
      return 1;

    case E_PSImode:
      if (!register_operand (operands[1], E_PSImode))
        return -1;
      return 2;

    case E_SImode:
      if (!register_operand (operands[1], E_SImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern14 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case ZERO_EXTEND:
      if (GET_MODE (x3) != E_HImode)
        return -1;
      x4 = XEXP (x2, 1);
      if (GET_CODE (x4) != ZERO_EXTEND
          || GET_MODE (x4) != E_HImode)
        return -1;
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x2) != E_HImode)
        return -1;
      x6 = XEXP (x3, 0);
      operands[1] = x6;
      if (!register_operand (operands[1], E_QImode))
        return -1;
      x7 = XEXP (x4, 0);
      operands[2] = x7;
      if (!register_operand (operands[2], E_QImode))
        return -1;
      return 0;

    case REG:
    case SUBREG:
      return 1;

    default:
      return -1;
    }
}

int
pattern21 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_CCmode)
    return -1;
  x3 = XEXP (x1, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 36
      || GET_MODE (x3) != E_CCmode)
    return -1;
  return 0;
}

int
pattern24 (rtx x1, unsigned int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (REGNO (x3) != i1)
    return -1;
  x4 = XEXP (x1, 0);
  if (REGNO (x4) != 24)
    return -1;
  switch (GET_MODE (x4))
    {
    case E_HQmode:
      if (GET_MODE (x2) != E_HQmode)
        return -1;
      x5 = XEXP (x2, 0);
      if (GET_MODE (x5) != E_HQmode
          || GET_MODE (x3) != E_HQmode)
        return -1;
      return 0;

    case E_UHQmode:
      if (GET_MODE (x2) != E_UHQmode)
        return -1;
      x5 = XEXP (x2, 0);
      if (GET_MODE (x5) != E_UHQmode
          || GET_MODE (x3) != E_UHQmode)
        return -1;
      return 1;

    case E_HAmode:
      if (GET_MODE (x2) != E_HAmode)
        return -1;
      x5 = XEXP (x2, 0);
      if (GET_MODE (x5) != E_HAmode
          || GET_MODE (x3) != E_HAmode)
        return -1;
      return 2;

    case E_UHAmode:
      if (GET_MODE (x2) != E_UHAmode)
        return -1;
      x5 = XEXP (x2, 0);
      if (GET_MODE (x5) != E_UHAmode
          || GET_MODE (x3) != E_UHAmode)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern32 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !nonmemory_operand (operands[2], i1))
    return -1;
  return pattern6 (); /* [-1, 3] */
}

int
pattern36 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_SImode
      || pattern35 (x1, 
E_SImode, 
22) != 0)
    return -1;
  return 0;
}

int
pattern40 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_QImode)
    return -1;
  x4 = XEXP (x1, 0);
  if (GET_CODE (x4) != MEM
      || GET_MODE (x4) != E_QImode)
    return -1;
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  if (!low_io_address_operand (operands[0], E_VOIDmode)
      || GET_MODE (x2) != E_QImode)
    return -1;
  x6 = XEXP (x2, 1);
  operands[1] = x6;
  return 0;
}

int
pattern46 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!const_8_16_24_operand (operands[3], E_QImode))
    return -1;
  x2 = XEXP (x1, 1);
  operands[2] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x1) != E_HImode)
        return -1;
      x3 = XEXP (x1, 0);
      if (GET_MODE (x3) != E_HImode)
        return -1;
      x4 = XEXP (x3, 0);
      if (GET_MODE (x4) != E_HImode
          || !register_operand (operands[1], E_QImode)
          || !register_operand (operands[2], E_HImode))
        return -1;
      return 0;

    case E_PSImode:
      if (!register_operand (operands[0], E_PSImode)
          || GET_MODE (x1) != E_PSImode)
        return -1;
      x3 = XEXP (x1, 0);
      if (GET_MODE (x3) != E_PSImode)
        return -1;
      x4 = XEXP (x3, 0);
      if (GET_MODE (x4) != E_PSImode
          || !register_operand (operands[2], E_PSImode))
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 1;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 2;

        default:
          return -1;
        }

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode)
        return -1;
      x3 = XEXP (x1, 0);
      if (GET_MODE (x3) != E_SImode)
        return -1;
      x4 = XEXP (x3, 0);
      if (GET_MODE (x4) != E_SImode
          || !register_operand (operands[2], E_SImode))
        return -1;
      res = pattern4 ();
      if (res >= 0)
        return res + 3; /* [3, 5] */
      return -1;

    default:
      return -1;
    }
}

int
pattern63 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (REGNO (x3) != 18)
    return -1;
  x4 = XEXP (x1, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 18)
    return -1;
  x5 = XEXP (x2, 1);
  switch (GET_CODE (x5))
    {
    case REG:
      if (REGNO (x5) != 10)
        return -1;
      switch (GET_MODE (x4))
        {
        case E_DQmode:
          if (GET_MODE (x2) != E_DQmode
              || GET_MODE (x3) != E_DQmode
              || GET_MODE (x5) != E_DQmode)
            return -1;
          return 0;

        case E_DAmode:
          if (GET_MODE (x2) != E_DAmode
              || GET_MODE (x3) != E_DAmode
              || GET_MODE (x5) != E_DAmode)
            return -1;
          return 1;

        case E_TAmode:
          if (GET_MODE (x2) != E_TAmode
              || GET_MODE (x3) != E_TAmode
              || GET_MODE (x5) != E_TAmode)
            return -1;
          return 2;

        default:
          return -1;
        }

    case CONST_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
      operands[0] = x5;
      switch (GET_MODE (x4))
        {
        case E_DQmode:
          if (GET_MODE (x2) != E_DQmode
              || GET_MODE (x3) != E_DQmode
              || !const_operand (operands[0], E_DQmode))
            return -1;
          return 3;

        case E_DAmode:
          if (GET_MODE (x2) != E_DAmode
              || GET_MODE (x3) != E_DAmode
              || !const_operand (operands[0], E_DAmode))
            return -1;
          return 4;

        case E_TAmode:
          if (GET_MODE (x2) != E_TAmode
              || GET_MODE (x3) != E_TAmode
              || !const_operand (operands[0], E_TAmode))
            return -1;
          return 5;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern76 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      if (!register_operand (operands[0], E_QImode)
          || GET_MODE (x1) != E_QImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_QImode
          || !register_operand (operands[1], E_QImode)
          || !const_0_to_7_operand (operands[2], E_QImode)
          || !single_one_operand (operands[3], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x1) != E_HImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_HImode
          || !register_operand (operands[1], E_HImode)
          || !const_0_to_15_operand (operands[2], E_QImode)
          || !single_one_operand (operands[3], E_HImode))
        return -1;
      return 1;

    case E_PSImode:
      if (!register_operand (operands[0], E_PSImode)
          || GET_MODE (x1) != E_PSImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_PSImode
          || !register_operand (operands[1], E_PSImode)
          || !const_0_to_23_operand (operands[2], E_QImode)
          || !single_one_operand (operands[3], E_PSImode))
        return -1;
      return 2;

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_SImode
          || !register_operand (operands[1], E_SImode)
          || !const_0_to_31_operand (operands[2], E_QImode)
          || !single_one_operand (operands[3], E_SImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern91 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != LABEL_REF)
    return -1;
  x4 = XEXP (x2, 2);
  if (GET_CODE (x4) != PC)
    return -1;
  x5 = XEXP (x1, 0);
  if (GET_CODE (x5) != PC)
    return -1;
  x6 = XEXP (x2, 0);
  switch (GET_CODE (x6))
    {
    case NE:
    case EQ:
      operands[0] = x6;
      if (!eqne_operator (operands[0], E_VOIDmode))
        return -1;
      x7 = XEXP (x3, 0);
      operands[3] = x7;
      x8 = XEXP (x6, 0);
      switch (GET_CODE (x8))
        {
        case ZERO_EXTRACT:
          x9 = XEXP (x8, 1);
          if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
            return -1;
          x10 = XEXP (x8, 2);
          operands[2] = x10;
          if (!const_int_operand (operands[2], E_VOIDmode))
            return -1;
          x11 = XEXP (x8, 0);
          switch (GET_CODE (x11))
            {
            case REG:
            case SUBREG:
              operands[1] = x11;
              if (!register_operand (operands[1], E_VOIDmode))
                return -1;
              switch (GET_MODE (x8))
                {
                case E_QImode:
                  return 0;

                case E_HImode:
                  return 1;

                case E_PSImode:
                  return 2;

                case E_SImode:
                  return 3;

                case E_DImode:
                  return 4;

                default:
                  return -1;
                }

            case MEM:
              if (GET_MODE (x11) != E_QImode)
                return -1;
              x12 = XEXP (x11, 0);
              operands[1] = x12;
              switch (GET_MODE (x8))
                {
                case E_QImode:
                  return 5;

                case E_HImode:
                  return 6;

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case AND:
          x11 = XEXP (x8, 0);
          operands[1] = x11;
          x9 = XEXP (x8, 1);
          operands[2] = x9;
          switch (GET_MODE (x8))
            {
            case E_QImode:
              if (!register_operand (operands[1], E_QImode)
                  || !single_one_operand (operands[2], E_QImode))
                return -1;
              return 7;

            case E_HImode:
              if (!register_operand (operands[1], E_HImode)
                  || !single_one_operand (operands[2], E_HImode))
                return -1;
              return 8;

            case E_PSImode:
              if (!register_operand (operands[1], E_PSImode)
                  || !single_one_operand (operands[2], E_PSImode))
                return -1;
              return 9;

            case E_SImode:
              if (!register_operand (operands[1], E_SImode)
                  || !single_one_operand (operands[2], E_SImode))
                return -1;
              return 10;

            default:
              return -1;
            }

        default:
          return -1;
        }

    case GE:
    case LT:
      return 11;

    default:
      return -1;
    }
}

int
pattern127 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  operands[3] = x2;
  x3 = XEXP (x1, 0);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
      operands[1] = x5;
      if (!register_operand (operands[1], E_QImode)
          || pattern126 (x1) != 0)
        return -1;
      return 0;

    case AND:
      x6 = XEXP (x5, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x7 = XEXP (x5, 0);
      operands[1] = x7;
      x8 = XEXP (x3, 1);
      operands[2] = x8;
      res = pattern85 (x1);
      if (res >= 0)
        return res + 1; /* [1, 6] */
      return -1;

    default:
      return -1;
    }
}

int
pattern133 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x4 = XEXP (x1, 0);
  operands[1] = x4;
  x5 = XEXP (x2, 0);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      return pattern132 (x1, 
E_QImode); /* [-1, 3] */

    case E_HImode:
      res = pattern132 (x1, 
E_HImode);
      if (res >= 0)
        return res + 4; /* [4, 7] */
      return -1;

    case E_PSImode:
      res = pattern132 (x1, 
E_PSImode);
      if (res >= 0)
        return res + 8; /* [8, 11] */
      return -1;

    case E_SImode:
      res = pattern132 (x1, 
E_SImode);
      if (res >= 0)
        return res + 12; /* [12, 15] */
      return -1;

    default:
      return -1;
    }
}

int
pattern136 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x2, 2);
  operands[2] = x4;
  if (!const0_operand (operands[2], E_QImode))
    return -1;
  x5 = XEXP (x1, 1);
  operands[3] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      return pattern135 (x1, 
E_QImode); /* [-1, 3] */

    case E_HImode:
      res = pattern135 (x1, 
E_HImode);
      if (res >= 0)
        return res + 4; /* [4, 7] */
      return -1;

    case E_PSImode:
      res = pattern135 (x1, 
E_PSImode);
      if (res >= 0)
        return res + 8; /* [8, 11] */
      return -1;

    case E_SImode:
      res = pattern135 (x1, 
E_SImode);
      if (res >= 0)
        return res + 12; /* [12, 15] */
      return -1;

    default:
      return -1;
    }
}

int
pattern142 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x3, 1);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 1);
  if (GET_MODE (x7) != i1)
    return -1;
  x8 = XEXP (x7, 0);
  if (GET_MODE (x8) != i1)
    return -1;
  x9 = XEXP (x7, 1);
  if (GET_MODE (x9) != i1)
    return -1;
  return 0;
}

int
pattern147 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 36
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  if (!register_operand (operands[0], E_QQmode))
    return -1;
  x6 = XEXP (x4, 1);
  x7 = XEXP (x6, 0);
  operands[1] = x7;
  if (!register_operand (operands[1], E_QQmode))
    return -1;
  return 0;
}

int
pattern154 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 1);
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  return pattern110 (x1); /* [-1, 2] */
}

int
pattern158 (rtx x1, int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (XVECLEN (x2, 0) != 2
      || XINT (x2, 1) != 10)
    return -1;
  x3 = XVECEXP (x2, 0, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + i1])
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != SET)
    return -1;
  return 0;
}

int
pattern162 (rtx x1, machine_mode i1, unsigned int i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != i2
      || GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != E_SImode)
    return -1;
  return 0;
}

int
pattern166 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i1))
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_QImode:
      if (!register_operand (operands[1], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!register_operand (operands[1], E_HImode))
        return -1;
      return 1;

    case E_PSImode:
      if (!register_operand (operands[1], E_PSImode))
        return -1;
      return 2;

    case E_SImode:
      if (!register_operand (operands[1], E_SImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern173 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG)
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG)
    return -1;
  x6 = XVECEXP (x1, 0, 3);
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != REG)
    return -1;
  return 0;
}

int
pattern178 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      if (!d_register_operand (operands[0], E_QImode)
          || GET_MODE (x1) != E_QImode)
        return -1;
      return 0;

    case E_QQmode:
      if (!d_register_operand (operands[0], E_QQmode)
          || GET_MODE (x1) != E_QQmode)
        return -1;
      return 1;

    case E_UQQmode:
      if (!d_register_operand (operands[0], E_UQQmode)
          || GET_MODE (x1) != E_UQQmode)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern184 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != LO_SUM
      || GET_MODE (x3) != E_PSImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 21
      || GET_MODE (x4) != E_QImode)
    return -1;
  x5 = XEXP (x3, 1);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 30
      || GET_MODE (x5) != E_HImode)
    return -1;
  x6 = XEXP (x1, 0);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 22)
    return -1;
  return 0;
}

int
pattern191 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  if (!register_operand (operands[1], E_QImode)
      || !register_operand (operands[0], E_QImode)
      || GET_MODE (x1) != E_QImode
      || !register_operand (operands[3], E_QImode)
      || GET_MODE (x2) != E_QImode)
    return -1;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  return 0;
}

int
pattern195 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_HImode)
      || GET_MODE (x1) != E_HImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_HImode)
    return -1;
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  if (!register_operand (operands[1], E_QImode))
    return -1;
  x4 = XEXP (x1, 1);
  if (GET_MODE (x4) != E_HImode)
    return -1;
  x5 = XEXP (x4, 0);
  operands[2] = x5;
  if (!register_operand (operands[2], E_QImode))
    return -1;
  return 0;
}

int
pattern201 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != i1
      || GET_MODE (x5) != E_HImode)
    return -1;
  x6 = XEXP (x3, 1);
  if (XWINT (x6, 0) != 8L)
    return -1;
  x7 = XEXP (x1, 0);
  operands[0] = x7;
  if (!register_operand (operands[0], E_QImode)
      || GET_MODE (x2) != E_QImode
      || GET_MODE (x3) != E_HImode
      || GET_MODE (x4) != E_HImode)
    return -1;
  x8 = XEXP (x4, 0);
  x9 = XEXP (x8, 0);
  operands[1] = x9;
  if (!register_operand (operands[1], E_QImode))
    return -1;
  x10 = XEXP (x5, 0);
  operands[2] = x10;
  if (!register_operand (operands[2], E_QImode))
    return -1;
  return 0;
}

int
pattern209 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != E_QImode)
    return -1;
  x5 = XEXP (x3, 1);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x6) != SET)
    return -1;
  x7 = XEXP (x6, 1);
  if (GET_CODE (x7) != i1
      || GET_MODE (x7) != E_QImode)
    return -1;
  return 0;
}

int
pattern217 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  x3 = XEXP (x1, 1);
  operands[2] = x3;
  switch (GET_MODE (x1))
    {
    case E_HImode:
      if (!register_operand (operands[1], E_HImode)
          || !const_0_to_15_operand (operands[2], E_QImode))
        return -1;
      return 0;

    case E_PSImode:
      if (!register_operand (operands[1], E_PSImode)
          || !const_0_to_23_operand (operands[2], E_QImode))
        return -1;
      return 1;

    case E_SImode:
      if (!register_operand (operands[1], E_SImode)
          || !const_0_to_31_operand (operands[2], E_QImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern227 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_HImode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  if (!register_operand (operands[0], E_HImode))
    return -1;
  x6 = XEXP (x4, 1);
  x7 = XEXP (x6, 0);
  operands[1] = x7;
  switch (GET_MODE (operands[1]))
    {
    case E_HImode:
      if (!register_operand (operands[1], E_HImode))
        return -1;
      return 0;

    case E_QImode:
      if (!register_operand (operands[1], E_QImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern232 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x1) != E_HImode
          || !register_operand (operands[1], E_QImode))
        return -1;
      return 0;

    case E_PSImode:
      if (!register_operand (operands[0], E_PSImode)
          || GET_MODE (x1) != E_PSImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 1;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 2;

        default:
          return -1;
        }

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 3;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 4;

        case E_PSImode:
          if (!register_operand (operands[1], E_PSImode))
            return -1;
          return 5;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern243 (rtx x1, machine_mode i1, machine_mode i2, unsigned int i3, unsigned int i4)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 2);
  x3 = XEXP (x2, 0);
  if (REGNO (x3) != i4
      || GET_MODE (x3) != E_HImode)
    return -1;
  x4 = XVECEXP (x1, 0, 3);
  x5 = XEXP (x4, 0);
  if (REGNO (x5) != i3
      || GET_MODE (x5) != i2)
    return -1;
  x6 = XVECEXP (x1, 0, 0);
  x7 = XEXP (x6, 1);
  if (GET_MODE (x7) != i1)
    return -1;
  return 0;
}

int
pattern246 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 3);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_QImode)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != SET)
    return -1;
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != i1
      || GET_MODE (x5) != E_PSImode)
    return -1;
  x6 = XVECEXP (x1, 0, 2);
  x7 = XEXP (x6, 0);
  if (REGNO (x7) != 18
      || GET_MODE (x7) != E_DImode)
    return -1;
  x8 = XVECEXP (x1, 0, 0);
  x9 = XEXP (x8, 0);
  operands[0] = x9;
  if (!pseudo_register_operand (operands[0], E_PSImode))
    return -1;
  x10 = XEXP (x8, 1);
  if (GET_MODE (x10) != E_PSImode)
    return -1;
  x11 = XEXP (x10, 0);
  operands[1] = x11;
  if (!pseudo_register_operand (operands[1], E_PSImode))
    return -1;
  x12 = XEXP (x10, 1);
  operands[2] = x12;
  if (!pseudo_register_operand (operands[2], E_PSImode))
    return -1;
  x13 = XEXP (x4, 0);
  operands[3] = x13;
  if (!pseudo_register_operand (operands[3], E_PSImode))
    return -1;
  x14 = XEXP (x5, 0);
  if (!rtx_equal_p (x14, operands[1]))
    return -1;
  x15 = XEXP (x5, 1);
  if (!rtx_equal_p (x15, operands[2]))
    return -1;
  return 0;
}

int
pattern254 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  operands[3] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      return pattern253 (x5, 
E_HImode); /* [-1, 0] */

    case E_SImode:
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      if (GET_MODE (x5) != E_SImode
          || !register_operand (operands[1], E_SImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_HImode:
          if (!scratch_operand (operands[3], E_HImode))
            return -1;
          return 1;

        case E_QImode:
          if (!scratch_operand (operands[3], E_QImode))
            return -1;
          return 2;

        default:
          return -1;
        }

    case E_PSImode:
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      if (pattern253 (x5, 
E_PSImode) != 0)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern265 (rtx x1, machine_mode i1, unsigned int i2, unsigned int i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != i3
      || GET_MODE (x3) != E_QImode)
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != i2
      || GET_MODE (x5) != i1)
    return -1;
  x6 = XVECEXP (x1, 0, 3);
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != REG
      || REGNO (x7) != 36
      || GET_MODE (x7) != E_CCmode)
    return -1;
  return 0;
}

int
pattern273 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  operands[2] = x1;
  switch (GET_MODE (operands[1]))
    {
    case E_QImode:
      return pattern272 (
E_QImode); /* [-1, 1] */

    case E_HImode:
      res = pattern272 (
E_HImode);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    default:
      return -1;
    }
}

int
pattern280 (rtx x1, machine_mode i1, unsigned int i2, unsigned int i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  if (REGNO (x3) != i3
      || GET_MODE (x3) != E_HImode)
    return -1;
  return pattern279 (x1, 
i1, 
i2); /* [-1, 3] */
}

int
pattern285 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XEXP (x3, 1);
  if (REGNO (x5) != 18
      || GET_MODE (x5) != E_SImode
      || pattern206 (x1, 
E_SImode, 
E_HImode, 
22, 
26) != 0)
    return -1;
  return 0;
}

int
pattern288 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  operands[2] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x1) != E_HImode)
        return -1;
      x3 = XEXP (x1, 0);
      if (GET_MODE (x3) != E_HImode
          || !register_operand (operands[1], E_QImode)
          || !register_operand (operands[2], E_HImode))
        return -1;
      return 0;

    case E_PSImode:
      if (!register_operand (operands[0], E_PSImode)
          || GET_MODE (x1) != E_PSImode)
        return -1;
      x3 = XEXP (x1, 0);
      if (GET_MODE (x3) != E_PSImode
          || !register_operand (operands[2], E_PSImode))
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 1;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 2;

        default:
          return -1;
        }

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode)
        return -1;
      x3 = XEXP (x1, 0);
      if (GET_MODE (x3) != E_SImode
          || !register_operand (operands[2], E_SImode))
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 3;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 4;

        case E_PSImode:
          if (!register_operand (operands[1], E_PSImode))
            return -1;
          return 5;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern305 (rtx x1, machine_mode i1, unsigned int i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x1, 0);
  if (REGNO (x4) != i2
      || GET_MODE (x4) != i1
      || GET_MODE (x2) != i1)
    return -1;
  return 0;
}

int
pattern311 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !const_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern315 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!d_register_operand (operands[0], i1)
      || !const_operand (operands[1], i1)
      || GET_CODE (x1) != PARALLEL
      || XVECLEN (x1, 0) != 2
      || pattern314 (x1, 
i1) != 0)
    return -1;
  return 0;
}

int
pattern320 (rtx x1, machine_mode i1, rtx_code i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != PARALLEL
      || XVECLEN (x1, 0) != 2
      || pattern319 (x1, 
i1, 
i2) != 0)
    return -1;
  return 0;
}

int
pattern323 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!rtx_equal_p (x1, operands[0]))
    return -1;
  x2 = PATTERN (peep2_next_insn (1));
  if (GET_CODE (x2) != PARALLEL
      || XVECLEN (x2, 0) != 2)
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  if (GET_CODE (x3) != SET)
    return -1;
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != COMPARE
      || GET_MODE (x4) != E_CCmode)
    return -1;
  x5 = XEXP (x3, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 36
      || GET_MODE (x5) != E_CCmode)
    return -1;
  x6 = XVECEXP (x2, 0, 1);
  if (GET_CODE (x6) != CLOBBER)
    return -1;
  return 0;
}

int
pattern331 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || !d_register_operand (operands[1], i1)
      || XVECLEN (x1, 0) != 3)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x3) != CLOBBER)
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 36
      || GET_MODE (x5) != E_CCmode)
    return -1;
  x6 = XEXP (x2, 1);
  if (GET_MODE (x6) != i1)
    return -1;
  x7 = XEXP (x3, 0);
  operands[3] = x7;
  if (!d_register_operand (operands[3], E_QImode))
    return -1;
  x8 = XEXP (x2, 0);
  if (!rtx_equal_p (x8, operands[0]))
    return -1;
  switch (GET_CODE (x6))
    {
    case PLUS:
      x9 = XEXP (x6, 1);
      operands[2] = x9;
      if (!const_operand (operands[2], i1))
        return -1;
      x10 = XEXP (x6, 0);
      if (!rtx_equal_p (x10, operands[0]))
        return -1;
      return 0;

    case IOR:
      x9 = XEXP (x6, 1);
      operands[2] = x9;
      if (!const_operand (operands[2], i1))
        return -1;
      x10 = XEXP (x6, 0);
      if (!rtx_equal_p (x10, operands[0]))
        return -1;
      return 1;

    case AND:
      x9 = XEXP (x6, 1);
      operands[2] = x9;
      if (!const_operand (operands[2], i1))
        return -1;
      x10 = XEXP (x6, 0);
      if (!rtx_equal_p (x10, operands[0]))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern345 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (!rtx_equal_p (x4, operands[1]))
    return -1;
  x5 = XEXP (x3, 1);
  if (!rtx_equal_p (x5, operands[2]))
    return -1;
  x6 = XVECEXP (x1, 0, 2);
  x7 = XEXP (x6, 0);
  switch (REGNO (x7))
    {
    case 22:
      if (GET_MODE (x7) != E_QImode)
        return -1;
      x8 = XVECEXP (x1, 0, 3);
      x9 = XEXP (x8, 0);
      if (REGNO (x9) != 23
          || GET_MODE (x9) != E_QImode)
        return -1;
      x10 = XVECEXP (x1, 0, 4);
      x11 = XEXP (x10, 0);
      if (REGNO (x11) != 24
          || GET_MODE (x11) != E_QImode)
        return -1;
      x12 = XVECEXP (x1, 0, 5);
      x13 = XEXP (x12, 0);
      if (REGNO (x13) != 25
          || GET_MODE (x13) != E_QImode
          || pattern140 (x1, 
E_QImode) != 0)
        return -1;
      return 0;

    case 21:
      if (GET_MODE (x7) != E_QImode
          || pattern344 (x1, 
E_HImode, 
26, 
24) != 0)
        return -1;
      return 1;

    case 18:
      if (GET_MODE (x7) != E_SImode
          || pattern344 (x1, 
E_SImode, 
30, 
26) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern360 (rtx x1, machine_mode i1, unsigned int i2, machine_mode i3, unsigned int i4)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  if (REGNO (x3) != i4
      || GET_MODE (x3) != i3)
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  x5 = XEXP (x4, 0);
  if (REGNO (x5) != i2
      || GET_MODE (x5) != i1)
    return -1;
  return 0;
}

int
pattern365 (rtx x1, machine_mode i1, unsigned int i2, unsigned int i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x3, 1);
  if (REGNO (x5) != i2
      || GET_MODE (x5) != i1)
    return -1;
  x6 = XEXP (x2, 0);
  if (REGNO (x6) != i2
      || GET_MODE (x6) != i1)
    return -1;
  x7 = XVECEXP (x1, 0, 1);
  x8 = XEXP (x7, 1);
  x9 = XEXP (x8, 0);
  if (REGNO (x9) != i3
      || GET_MODE (x9) != i1)
    return -1;
  x10 = XEXP (x8, 1);
  if (REGNO (x10) != i2
      || GET_MODE (x10) != i1)
    return -1;
  return 0;
}

int
pattern376 (rtx x1, machine_mode i1, unsigned int i2, unsigned int i3, unsigned int i4)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 0);
  if (REGNO (x5) != i4
      || GET_MODE (x5) != i1)
    return -1;
  x6 = XVECEXP (x1, 0, 2);
  x7 = XEXP (x6, 0);
  if (REGNO (x7) != i3
      || GET_MODE (x7) != i1)
    return -1;
  x8 = XVECEXP (x1, 0, 3);
  x9 = XEXP (x8, 0);
  if (REGNO (x9) != i2
      || pattern142 (x1, 
i1) != 0)
    return -1;
  return 0;
}

int
pattern382 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  operands[2] = x1;
  if (!const_operand (operands[2], i1))
    return -1;
  x2 = PATTERN (peep2_next_insn (1));
  x3 = XEXP (x2, 1);
  return pattern353 (x3); /* [-1, 0] */
}

int
pattern386 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  if (!rtx_equal_p (x1, operands[0]))
    return -1;
  x2 = PATTERN (peep2_next_insn (2));
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != IF_THEN_ELSE)
    return -1;
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != LABEL_REF)
    return -1;
  x5 = XEXP (x3, 2);
  if (GET_CODE (x5) != PC)
    return -1;
  x6 = XEXP (x2, 0);
  if (GET_CODE (x6) != PC)
    return -1;
  x7 = XEXP (x4, 0);
  operands[2] = x7;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      return 0;

    case E_PSImode:
      return 1;

    case E_SImode:
      return 2;

    default:
      return -1;
    }
}

int
pattern393 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[1], i1))
    return -1;
  switch (GET_CODE (x1))
    {
    case EQ:
      return pattern391 (x1); /* [-1, 0] */

    case NE:
      if (pattern391 (x1) != 0)
        return -1;
      return 1;

    case GE:
      if (pattern391 (x1) != 0)
        return -1;
      return 2;

    case LT:
      if (pattern391 (x1) != 0)
        return -1;
      return 3;

    case GT:
      if (pattern391 (x1) != 0)
        return -1;
      return 4;

    case LE:
      if (pattern391 (x1) != 0)
        return -1;
      return 5;

    default:
      return -1;
    }
}

 int
recog_3 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != LO_SUM
      || GET_MODE (x3) != E_PSImode)
    return -1;
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 30
      || GET_MODE (x4) != E_HImode)
    return -1;
  x5 = XEXP (x3, 0);
  operands[1] = x5;
  if (!register_operand (operands[1], E_QImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      if (!register_operand (operands[0], E_QImode)
          || GET_MODE (x2) != E_QImode)
        return -1;
      if (
#line 640 "../../gcc/config/avr/avr.md"
(1 == 1
   && avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)))
        return 50; /* xmovqi_8 */
      if (pnum_clobbers == NULL
          || !
#line 655 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false)))
        return -1;
      *pnum_clobbers = 1;
      return 53; /* fmovqi */

    case E_QQmode:
      if (!register_operand (operands[0], E_QQmode)
          || GET_MODE (x2) != E_QQmode)
        return -1;
      if (
#line 640 "../../gcc/config/avr/avr.md"
(1 == 1
   && avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)))
        return 51; /* xmovqq_8 */
      if (pnum_clobbers == NULL
          || !
#line 655 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false)))
        return -1;
      *pnum_clobbers = 1;
      return 54; /* fmovqq */

    case E_UQQmode:
      if (!register_operand (operands[0], E_UQQmode)
          || GET_MODE (x2) != E_UQQmode)
        return -1;
      if (
#line 640 "../../gcc/config/avr/avr.md"
(1 == 1
   && avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)))
        return 52; /* xmovuqq_8 */
      if (pnum_clobbers == NULL
          || !
#line 655 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false)))
        return -1;
      *pnum_clobbers = 1;
      return 55; /* fmovuqq */

    case E_HImode:
      if (pnum_clobbers == NULL
          || !register_operand (operands[0], E_HImode)
          || GET_MODE (x2) != E_HImode
          || !
#line 655 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false)))
        return -1;
      *pnum_clobbers = 1;
      return 56; /* fmovhi */

    case E_HQmode:
      if (pnum_clobbers == NULL
          || !register_operand (operands[0], E_HQmode)
          || GET_MODE (x2) != E_HQmode
          || !
#line 655 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false)))
        return -1;
      *pnum_clobbers = 1;
      return 57; /* fmovhq */

    case E_UHQmode:
      if (pnum_clobbers == NULL
          || !register_operand (operands[0], E_UHQmode)
          || GET_MODE (x2) != E_UHQmode
          || !
#line 655 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false)))
        return -1;
      *pnum_clobbers = 1;
      return 58; /* fmovuhq */

    case E_HAmode:
      if (pnum_clobbers == NULL
          || !register_operand (operands[0], E_HAmode)
          || GET_MODE (x2) != E_HAmode
          || !
#line 655 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false)))
        return -1;
      *pnum_clobbers = 1;
      return 59; /* fmovha */

    case E_UHAmode:
      if (pnum_clobbers == NULL
          || !register_operand (operands[0], E_UHAmode)
          || GET_MODE (x2) != E_UHAmode
          || !
#line 655 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false)))
        return -1;
      *pnum_clobbers = 1;
      return 60; /* fmovuha */

    case E_SImode:
      if (pnum_clobbers == NULL
          || !register_operand (operands[0], E_SImode)
          || GET_MODE (x2) != E_SImode
          || !
#line 655 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false)))
        return -1;
      *pnum_clobbers = 1;
      return 61; /* fmovsi */

    case E_SQmode:
      if (pnum_clobbers == NULL
          || !register_operand (operands[0], E_SQmode)
          || GET_MODE (x2) != E_SQmode
          || !
#line 655 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false)))
        return -1;
      *pnum_clobbers = 1;
      return 62; /* fmovsq */

    case E_USQmode:
      if (pnum_clobbers == NULL
          || !register_operand (operands[0], E_USQmode)
          || GET_MODE (x2) != E_USQmode
          || !
#line 655 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false)))
        return -1;
      *pnum_clobbers = 1;
      return 63; /* fmovusq */

    case E_SAmode:
      if (pnum_clobbers == NULL
          || !register_operand (operands[0], E_SAmode)
          || GET_MODE (x2) != E_SAmode
          || !
#line 655 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false)))
        return -1;
      *pnum_clobbers = 1;
      return 64; /* fmovsa */

    case E_USAmode:
      if (pnum_clobbers == NULL
          || !register_operand (operands[0], E_USAmode)
          || GET_MODE (x2) != E_USAmode
          || !
#line 655 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false)))
        return -1;
      *pnum_clobbers = 1;
      return 65; /* fmovusa */

    case E_SFmode:
      if (pnum_clobbers == NULL
          || !register_operand (operands[0], E_SFmode)
          || GET_MODE (x2) != E_SFmode
          || !
#line 655 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false)))
        return -1;
      *pnum_clobbers = 1;
      return 66; /* fmovsf */

    case E_PSImode:
      if (pnum_clobbers == NULL
          || !register_operand (operands[0], E_PSImode)
          || GET_MODE (x2) != E_PSImode
          || !
#line 655 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false)))
        return -1;
      *pnum_clobbers = 1;
      return 67; /* fmovpsi */

    default:
      return -1;
    }
}

 int
recog_12 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case ZERO_EXTEND:
      switch (GET_MODE (operands[0]))
        {
        case E_HImode:
          if (pattern195 (x2) != 0)
            return -1;
          if (
#line 2469 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
            return 479; /* umulqihi3_split */
          if (pnum_clobbers == NULL
              || !
#line 2482 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
            return -1;
          *pnum_clobbers = 1;
          return 481; /* umulqihi3 */

        case E_SImode:
          if (pnum_clobbers == NULL
              || !pseudo_register_operand (operands[0], E_SImode)
              || GET_MODE (x2) != E_SImode)
            return -1;
          x4 = XEXP (x2, 0);
          if (GET_MODE (x4) != E_SImode)
            return -1;
          x5 = XEXP (x4, 0);
          operands[1] = x5;
          if (GET_MODE (x3) != E_SImode)
            return -1;
          x6 = XEXP (x3, 0);
          operands[2] = x6;
          switch (GET_MODE (operands[1]))
            {
            case E_QImode:
              switch (pattern197 (
E_QImode))
                {
                case 0:
                  if (!
#line 3650 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed))
                    return -1;
                  *pnum_clobbers = 2;
                  return 551; /* *uumulqiqisi3 */

                case 1:
                  if (!
#line 3650 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed))
                    return -1;
                  *pnum_clobbers = 2;
                  return 559; /* *uumulqihisi3 */

                default:
                  return -1;
                }

            case E_HImode:
              switch (pattern197 (
E_HImode))
                {
                case 0:
                  if (!
#line 3650 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed))
                    return -1;
                  *pnum_clobbers = 2;
                  return 555; /* *uumulhiqisi3 */

                case 1:
                  if (!
#line 3650 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed))
                    return -1;
                  *pnum_clobbers = 2;
                  return 563; /* *uumulhihisi3 */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case E_PSImode:
          switch (pattern196 (x2))
            {
            case 0:
              if (
#line 4112 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
                return 596; /* *umulqihipsi3_split */
              if (pnum_clobbers == NULL
                  || !
#line 4125 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
                return -1;
              *pnum_clobbers = 1;
              return 597; /* *umulqihipsi3 */

            case 1:
              if (
#line 4139 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
                return 598; /* *umulhiqipsi3_split */
              if (pnum_clobbers == NULL
                  || !
#line 4152 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
                return -1;
              *pnum_clobbers = 1;
              return 599; /* *umulhiqipsi3 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case SIGN_EXTEND:
      x4 = XEXP (x2, 0);
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      switch (pattern198 (x2, pnum_clobbers))
        {
        case 0:
          if (
#line 2492 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
            return 482; /* usmulqihi3 */
          if (pnum_clobbers == NULL
              || !
#line 2505 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
            return -1;
          *pnum_clobbers = 1;
          return 483; /* *usmulqihi3 */

        case 1:
          if (!
#line 3650 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed))
            return -1;
          *pnum_clobbers = 2;
          return 549; /* *usmulqiqisi3 */

        case 2:
          if (!
#line 3650 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed))
            return -1;
          *pnum_clobbers = 2;
          return 557; /* *usmulqihisi3 */

        case 3:
          if (!
#line 3650 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed))
            return -1;
          *pnum_clobbers = 2;
          return 553; /* *usmulhiqisi3 */

        case 4:
          if (!
#line 3650 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed))
            return -1;
          *pnum_clobbers = 2;
          return 561; /* *usmulhihisi3 */

        default:
          return -1;
        }

    case CONST_INT:
    case REG:
    case SUBREG:
      if (register_operand (operands[0], E_HImode))
        {
          res = recog_11 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      if (pnum_clobbers == NULL)
        return -1;
      operands[2] = x3;
      if (!pseudo_register_or_const_int_operand (operands[2], E_SImode)
          || !pseudo_register_operand (operands[0], E_SImode)
          || GET_MODE (x2) != E_SImode)
        return -1;
      x4 = XEXP (x2, 0);
      if (GET_MODE (x4) != E_SImode)
        return -1;
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      switch (GET_MODE (operands[1]))
        {
        case E_QImode:
          if (!pseudo_register_operand (operands[1], E_QImode)
              || !
#line 3487 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed))
            return -1;
          *pnum_clobbers = 2;
          return 543; /* *muluqisi3 */

        case E_HImode:
          if (!pseudo_register_operand (operands[1], E_HImode)
              || !
#line 3487 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed))
            return -1;
          *pnum_clobbers = 2;
          return 544; /* *muluhisi3 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_23 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case REG:
    case SUBREG:
      operands[1] = x3;
      res = recog_9 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      if (GET_CODE (x3) != REG)
        return -1;
      x4 = XEXP (x2, 1);
      if (GET_CODE (x4) != REG)
        return -1;
      x5 = XEXP (x1, 0);
      if (GET_CODE (x5) != REG)
        return -1;
      switch (REGNO (x3))
        {
        case 24:
          if (pnum_clobbers == NULL)
            return -1;
          switch (REGNO (x4))
            {
            case 22:
              if (REGNO (x5) != 24)
                return -1;
              switch (GET_MODE (x5))
                {
                case E_QImode:
                  if (GET_MODE (x2) != E_QImode
                      || GET_MODE (x3) != E_QImode
                      || GET_MODE (x4) != E_QImode)
                    return -1;
                  if (
#line 2243 "../../gcc/config/avr/avr.md"
(!AVR_HAVE_MUL))
                    {
                      *pnum_clobbers = 1;
                      return 302; /* *mulqi3_call_split */
                    }
                  if (!
#line 2256 "../../gcc/config/avr/avr.md"
(!AVR_HAVE_MUL && reload_completed))
                    return -1;
                  *pnum_clobbers = 2;
                  return 303; /* *mulqi3_call */

                case E_HImode:
                  if (GET_MODE (x2) != E_HImode
                      || GET_MODE (x3) != E_HImode
                      || GET_MODE (x4) != E_HImode)
                    return -1;
                  if (
#line 3319 "../../gcc/config/avr/avr.md"
(!AVR_HAVE_MUL))
                    {
                      *pnum_clobbers = 2;
                      return 539; /* *mulhi3_call_split */
                    }
                  if (!
#line 3334 "../../gcc/config/avr/avr.md"
(!AVR_HAVE_MUL && reload_completed))
                    return -1;
                  *pnum_clobbers = 3;
                  return 540; /* *mulhi3_call */

                default:
                  return -1;
                }

            case 25:
              if (GET_MODE (x4) != E_QQmode
                  || pattern199 (x1, 
E_QQmode, 
23) != 0)
                return -1;
              if (
#line 377 "../../gcc/config/avr/avr-fixed.md"
(!AVR_HAVE_MUL))
                {
                  *pnum_clobbers = 2;
                  return 3080; /* *mulqq3.call_split */
                }
              if (!
#line 394 "../../gcc/config/avr/avr-fixed.md"
(!AVR_HAVE_MUL && reload_completed))
                return -1;
              *pnum_clobbers = 3;
              return 3081; /* *mulqq3.call */

            default:
              return -1;
            }

        case 22:
          if (pnum_clobbers == NULL
              || REGNO (x4) != 18
              || REGNO (x5) != 22)
            return -1;
          switch (GET_MODE (x5))
            {
            case E_SImode:
              if (GET_MODE (x2) != E_SImode
                  || GET_MODE (x3) != E_SImode
                  || GET_MODE (x4) != E_SImode)
                return -1;
              if (
#line 3719 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
                {
                  *pnum_clobbers = 1;
                  return 564; /* *mulsi3_call_split */
                }
              if (
#line 3735 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! AVR_HAVE_MUL
   && ! AVR_TINY))
                {
                  *pnum_clobbers = 3;
                  return 565; /* *mulsi3_call_pr118012_split */
                }
              if (
#line 3754 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
                {
                  *pnum_clobbers = 2;
                  return 566; /* *mulsi3_call */
                }
              if (!
#line 3766 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! AVR_HAVE_MUL
   && ! AVR_TINY
   && reload_completed))
                return -1;
              *pnum_clobbers = 4;
              return 567; /* *mulsi3_call_pr118012 */

            case E_PSImode:
              if (GET_MODE (x2) != E_PSImode
                  || GET_MODE (x3) != E_PSImode
                  || GET_MODE (x4) != E_PSImode)
                return -1;
              if (
#line 4253 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
                {
                  *pnum_clobbers = 3;
                  return 604; /* *mulpsi3.libgcc_split */
                }
              if (!
#line 4272 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
                return -1;
              *pnum_clobbers = 4;
              return 605; /* *mulpsi3.libgcc */

            default:
              return -1;
            }

        case 18:
          if (pnum_clobbers == NULL)
            return -1;
          switch (pattern24 (x1, 
26))
            {
            case 0:
              if (
#line 425 "../../gcc/config/avr/avr-fixed.md"
(AVR_HAVE_MUL))
                {
                  *pnum_clobbers = 1;
                  return 3082; /* *mulhq3.call_split */
                }
              if (!
#line 440 "../../gcc/config/avr/avr-fixed.md"
(AVR_HAVE_MUL && reload_completed))
                return -1;
              *pnum_clobbers = 2;
              return 3086; /* *mulhq3.call */

            case 1:
              if (
#line 425 "../../gcc/config/avr/avr-fixed.md"
(AVR_HAVE_MUL))
                {
                  *pnum_clobbers = 1;
                  return 3083; /* *muluhq3.call_split */
                }
              if (!
#line 440 "../../gcc/config/avr/avr-fixed.md"
(AVR_HAVE_MUL && reload_completed))
                return -1;
              *pnum_clobbers = 2;
              return 3087; /* *muluhq3.call */

            case 2:
              if (
#line 425 "../../gcc/config/avr/avr-fixed.md"
(AVR_HAVE_MUL))
                {
                  *pnum_clobbers = 1;
                  return 3084; /* *mulha3.call_split */
                }
              if (!
#line 440 "../../gcc/config/avr/avr-fixed.md"
(AVR_HAVE_MUL && reload_completed))
                return -1;
              *pnum_clobbers = 2;
              return 3088; /* *mulha3.call */

            case 3:
              if (
#line 425 "../../gcc/config/avr/avr-fixed.md"
(AVR_HAVE_MUL))
                {
                  *pnum_clobbers = 1;
                  return 3085; /* *muluha3.call_split */
                }
              if (!
#line 440 "../../gcc/config/avr/avr-fixed.md"
(AVR_HAVE_MUL && reload_completed))
                return -1;
              *pnum_clobbers = 2;
              return 3089; /* *muluha3.call */

            default:
              return -1;
            }

        case 16:
          if (REGNO (x4) != 20)
            return -1;
          switch (pattern25 (x1, 
24))
            {
            case 0:
              if (
#line 468 "../../gcc/config/avr/avr-fixed.md"
(AVR_HAVE_MUL))
                return 3090; /* *mulsa3.call_split */
              if (pnum_clobbers == NULL
                  || !
#line 481 "../../gcc/config/avr/avr-fixed.md"
(AVR_HAVE_MUL && reload_completed))
                return -1;
              *pnum_clobbers = 1;
              return 3092; /* *mulsa3.call */

            case 1:
              if (
#line 468 "../../gcc/config/avr/avr-fixed.md"
(AVR_HAVE_MUL))
                return 3091; /* *mulusa3.call_split */
              if (pnum_clobbers == NULL
                  || !
#line 481 "../../gcc/config/avr/avr-fixed.md"
(AVR_HAVE_MUL && reload_completed))
                return -1;
              *pnum_clobbers = 1;
              return 3093; /* *mulusa3.call */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case ZERO_EXTEND:
      switch (pattern31 (x1))
        {
        case 0:
          if (pnum_clobbers != NULL)
            {
              res = recog_10 (x1, insn, pnum_clobbers);
              if (res >= 0)
                return res;
            }
          x5 = XEXP (x1, 0);
          operands[0] = x5;
          res = recog_12 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          x6 = XEXP (x3, 0);
          if (GET_CODE (x6) != REG)
            return -1;
          switch (pattern134 (x1))
            {
            case 0:
              if (
#line 3779 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
                return 569; /* *umulhisi3_call_split */
              if (pnum_clobbers == NULL
                  || !
#line 3792 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
                return -1;
              *pnum_clobbers = 1;
              return 571; /* *umulhisi3_call */

            case 1:
              if (
#line 3829 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
                return 576; /* *usmulhisi3_call_split */
              if (pnum_clobbers == NULL
                  || !
#line 3842 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
                return -1;
              *pnum_clobbers = 1;
              return 577; /* *usmulhisi3_call */

            case 2:
              if (
#line 3850 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
                return 579; /* *muluhisi3_call_split */
              if (pnum_clobbers == NULL
                  || !
#line 3863 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
                return -1;
              *pnum_clobbers = 1;
              return 581; /* *muluhisi3_call */

            default:
              return -1;
            }

        case 1:
          if (!
#line 10874 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 2 > 1
   && ! reload_completed))
            return -1;
          return 1434; /* *map.mul.ext.and1-to-skip.hi */

        case 2:
          if (!
#line 10874 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 1
   && ! reload_completed))
            return -1;
          return 1436; /* *map.mul.ext.and1-to-skip.psi */

        case 3:
          if (!
#line 10874 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 2
   && ! reload_completed))
            return -1;
          return 1440; /* *map.mul.ext.and1-to-skip.psi */

        case 4:
          if (!
#line 10874 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 1
   && ! reload_completed))
            return -1;
          return 1438; /* *map.mul.ext.and1-to-skip.si */

        case 5:
          if (!
#line 10874 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 2
   && ! reload_completed))
            return -1;
          return 1442; /* *map.mul.ext.and1-to-skip.si */

        case 6:
          if (!
#line 10874 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 3
   && ! reload_completed))
            return -1;
          return 1444; /* *map.mul.ext.and1-to-skip.si */

        default:
          return -1;
        }

    case SIGN_EXTEND:
      switch (pattern31 (x1))
        {
        case 0:
          x6 = XEXP (x3, 0);
          operands[1] = x6;
          res = recog_14 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          if (GET_CODE (x6) != REG)
            return -1;
          x5 = XEXP (x1, 0);
          if (GET_CODE (x5) != REG)
            return -1;
          switch (REGNO (x6))
            {
            case 18:
              x4 = XEXP (x2, 1);
              if (GET_CODE (x4) != SIGN_EXTEND)
                return -1;
              x7 = XEXP (x4, 0);
              if (GET_CODE (x7) != REG)
                return -1;
              switch (REGNO (x7))
                {
                case 26:
                  if (pattern258 (x1, 
E_SImode, 
E_HImode, 
22) != 0)
                    return -1;
                  if (
#line 3779 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
                    return 568; /* *mulhisi3_call_split */
                  if (pnum_clobbers == NULL
                      || !
#line 3792 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
                    return -1;
                  *pnum_clobbers = 1;
                  return 570; /* *mulhisi3_call */

                case 22:
                  if (pnum_clobbers == NULL
                      || pattern258 (x1, 
E_DImode, 
E_SImode, 
18) != 0)
                    return -1;
                  if (
#line 675 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && AVR_HAVE_MUL))
                    {
                      *pnum_clobbers = 2;
                      return 3360; /* mulsidi3_insn */
                    }
                  if (!
#line 693 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && AVR_HAVE_MUL
   && reload_completed))
                    return -1;
                  *pnum_clobbers = 3;
                  return 3362; /* *mulsidi3_insn */

                default:
                  return -1;
                }

            case 26:
              if (pattern200 (x1, 
E_SImode, 
22, 
18, 
E_HImode) != 0)
                return -1;
              if (
#line 3850 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
                return 578; /* *mulshisi3_call_split */
              if (pnum_clobbers == NULL
                  || !
#line 3863 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
                return -1;
              *pnum_clobbers = 1;
              return 580; /* *mulshisi3_call */

            case 25:
              if (pattern200 (x1, 
E_PSImode, 
18, 
22, 
E_QImode) != 0)
                return -1;
              if (
#line 4229 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
                return 602; /* *mulsqipsi3.libgcc_split */
              if (pnum_clobbers == NULL
                  || !
#line 4242 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
                return -1;
              *pnum_clobbers = 1;
              return 603; /* *mulsqipsi3.libgcc */

            default:
              return -1;
            }

        case 1:
          if (!
#line 10874 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 2 > 1
   && ! reload_completed))
            return -1;
          return 1433; /* *map.mul.ext.and1-to-skip.hi */

        case 2:
          if (!
#line 10874 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 1
   && ! reload_completed))
            return -1;
          return 1435; /* *map.mul.ext.and1-to-skip.psi */

        case 3:
          if (!
#line 10874 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 2
   && ! reload_completed))
            return -1;
          return 1439; /* *map.mul.ext.and1-to-skip.psi */

        case 4:
          if (!
#line 10874 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 1
   && ! reload_completed))
            return -1;
          return 1437; /* *map.mul.ext.and1-to-skip.si */

        case 5:
          if (!
#line 10874 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 2
   && ! reload_completed))
            return -1;
          return 1441; /* *map.mul.ext.and1-to-skip.si */

        case 6:
          if (!
#line 10874 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 3
   && ! reload_completed))
            return -1;
          return 1443; /* *map.mul.ext.and1-to-skip.si */

        default:
          return -1;
        }

    case NOT:
      x6 = XEXP (x3, 0);
      if (GET_CODE (x6) != ZERO_EXTEND)
        return -1;
      x8 = XEXP (x6, 0);
      if (GET_CODE (x8) != NOT)
        return -1;
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      res = recog_15 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      if (GET_MODE (x8) != E_HImode
          || pattern163 (x1) != 0)
        return -1;
      if (
#line 3871 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
        return 582; /* *mulohisi3_call_split */
      if (pnum_clobbers == NULL
          || !
#line 3884 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 583; /* *mulohisi3_call */

    case AND:
      switch (pattern33 (x1))
        {
        case 0:
          if (!
#line 10844 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
            return -1;
          return 1413; /* *map.mul.and1-to-skip.qi */

        case 1:
          if (!
#line 10844 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
            return -1;
          return 1417; /* *map.mul.and1-to-skip.qi */

        case 2:
          if (!
#line 10844 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
            return -1;
          return 1421; /* *map.mul.and1-to-skip.qi */

        case 3:
          if (!
#line 10844 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
            return -1;
          return 1425; /* *map.mul.and1-to-skip.qi */

        case 4:
          if (!
#line 10844 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
            return -1;
          return 1414; /* *map.mul.and1-to-skip.hi */

        case 5:
          if (!
#line 10844 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
            return -1;
          return 1418; /* *map.mul.and1-to-skip.hi */

        case 6:
          if (!
#line 10844 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
            return -1;
          return 1422; /* *map.mul.and1-to-skip.hi */

        case 7:
          if (!
#line 10844 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
            return -1;
          return 1426; /* *map.mul.and1-to-skip.hi */

        case 8:
          if (!
#line 10844 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
            return -1;
          return 1415; /* *map.mul.and1-to-skip.psi */

        case 9:
          if (!
#line 10844 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
            return -1;
          return 1419; /* *map.mul.and1-to-skip.psi */

        case 10:
          if (!
#line 10844 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
            return -1;
          return 1423; /* *map.mul.and1-to-skip.psi */

        case 11:
          if (!
#line 10844 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
            return -1;
          return 1427; /* *map.mul.and1-to-skip.psi */

        case 12:
          if (!
#line 10844 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
            return -1;
          return 1416; /* *map.mul.and1-to-skip.si */

        case 13:
          if (!
#line 10844 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
            return -1;
          return 1420; /* *map.mul.and1-to-skip.si */

        case 14:
          if (!
#line 10844 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
            return -1;
          return 1424; /* *map.mul.and1-to-skip.si */

        case 15:
          if (!
#line 10844 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
            return -1;
          return 1428; /* *map.mul.and1-to-skip.si */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_39 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) == REG)
    {
      res = recog_38 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
    }
  if (pnum_clobbers != NULL)
    {
      operands[0] = x3;
      x4 = XEXP (x2, 1);
      operands[1] = x4;
      x5 = XVECEXP (x1, 0, 1);
      x6 = XEXP (x5, 0);
      operands[2] = x6;
      if (register_operand (operands[2], E_QImode))
        {
          switch (GET_MODE (operands[0]))
            {
            case E_QImode:
              if (register_operand (operands[0], E_QImode)
                  && const_operand (operands[1], E_QImode)
                  && 
#line 885 "../../gcc/config/avr/avr.md"
(reload_completed))
                {
                  *pnum_clobbers = 1;
                  return 119; /* *reload_inqi */
                }
              break;

            case E_QQmode:
              if (register_operand (operands[0], E_QQmode)
                  && const_operand (operands[1], E_QQmode)
                  && 
#line 885 "../../gcc/config/avr/avr.md"
(reload_completed))
                {
                  *pnum_clobbers = 1;
                  return 120; /* *reload_inqq */
                }
              break;

            case E_UQQmode:
              if (register_operand (operands[0], E_UQQmode)
                  && const_operand (operands[1], E_UQQmode)
                  && 
#line 885 "../../gcc/config/avr/avr.md"
(reload_completed))
                {
                  *pnum_clobbers = 1;
                  return 121; /* *reload_inuqq */
                }
              break;

            case E_PSImode:
              if (register_operand (operands[0], E_PSImode)
                  && immediate_operand (operands[1], E_PSImode)
                  && 
#line 1125 "../../gcc/config/avr/avr.md"
(reload_completed))
                {
                  *pnum_clobbers = 1;
                  return 138; /* *reload_inpsi */
                }
              break;

            case E_SImode:
              if (register_operand (operands[0], E_SImode)
                  && immediate_operand (operands[1], E_SImode)
                  && 
#line 1182 "../../gcc/config/avr/avr.md"
(reload_completed))
                {
                  *pnum_clobbers = 1;
                  return 141; /* *reload_insi */
                }
              break;

            case E_SQmode:
              if (register_operand (operands[0], E_SQmode)
                  && immediate_operand (operands[1], E_SQmode)
                  && 
#line 1182 "../../gcc/config/avr/avr.md"
(reload_completed))
                {
                  *pnum_clobbers = 1;
                  return 142; /* *reload_insi */
                }
              break;

            case E_USQmode:
              if (register_operand (operands[0], E_USQmode)
                  && immediate_operand (operands[1], E_USQmode)
                  && 
#line 1182 "../../gcc/config/avr/avr.md"
(reload_completed))
                {
                  *pnum_clobbers = 1;
                  return 143; /* *reload_insi */
                }
              break;

            case E_SAmode:
              if (register_operand (operands[0], E_SAmode)
                  && immediate_operand (operands[1], E_SAmode)
                  && 
#line 1182 "../../gcc/config/avr/avr.md"
(reload_completed))
                {
                  *pnum_clobbers = 1;
                  return 144; /* *reload_insi */
                }
              break;

            case E_USAmode:
              if (register_operand (operands[0], E_USAmode)
                  && immediate_operand (operands[1], E_USAmode)
                  && 
#line 1182 "../../gcc/config/avr/avr.md"
(reload_completed))
                {
                  *pnum_clobbers = 1;
                  return 145; /* *reload_insi */
                }
              break;

            case E_SFmode:
              if (register_operand (operands[0], E_SFmode)
                  && const_double_operand (operands[1], E_SFmode)
                  && 
#line 1283 "../../gcc/config/avr/avr.md"
(reload_completed))
                {
                  *pnum_clobbers = 1;
                  return 159; /* *reload_insf */
                }
              break;

            default:
              break;
            }
        }
    }
  operands[0] = x3;
  x5 = XVECEXP (x1, 0, 1);
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != REG)
    return -1;
  x4 = XEXP (x2, 1);
  operands[1] = x4;
  switch (pattern229 (x6))
    {
    case 0:
      if (!
#line 599 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false))))
        return -1;
      return 35; /* fxmovqi_A */

    case 1:
      if (!
#line 599 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false))))
        return -1;
      return 36; /* fxmovqq_A */

    case 2:
      if (!
#line 599 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false))))
        return -1;
      return 37; /* fxmovuqq_A */

    case 3:
      if (!
#line 599 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false))))
        return -1;
      return 38; /* fxmovhi_A */

    case 4:
      if (!
#line 599 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false))))
        return -1;
      return 39; /* fxmovhq_A */

    case 5:
      if (!
#line 599 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false))))
        return -1;
      return 40; /* fxmovuhq_A */

    case 6:
      if (!
#line 599 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false))))
        return -1;
      return 41; /* fxmovha_A */

    case 7:
      if (!
#line 599 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false))))
        return -1;
      return 42; /* fxmovuha_A */

    case 8:
      if (!
#line 599 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false))))
        return -1;
      return 43; /* fxmovsi_A */

    case 9:
      if (!
#line 599 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false))))
        return -1;
      return 44; /* fxmovsq_A */

    case 10:
      if (!
#line 599 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false))))
        return -1;
      return 45; /* fxmovusq_A */

    case 11:
      if (!
#line 599 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false))))
        return -1;
      return 46; /* fxmovsa_A */

    case 12:
      if (!
#line 599 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false))))
        return -1;
      return 47; /* fxmovusa_A */

    case 13:
      if (!
#line 599 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false))))
        return -1;
      return 48; /* fxmovsf_A */

    case 14:
      if (!
#line 599 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false))))
        return -1;
      return 49; /* fxmovpsi_A */

    case 15:
      switch (GET_MODE (operands[0]))
        {
        case E_QImode:
          if (!nonimmediate_operand (operands[0], E_QImode)
              || !nox_general_operand (operands[1], E_QImode)
              || !
#line 866 "../../gcc/config/avr/avr.md"
((register_operand (operands[0], QImode)
    || reg_or_0_operand (operands[1], QImode))
   && reload_completed))
            return -1;
          return 116; /* movqi_insn */

        case E_QQmode:
          if (!nonimmediate_operand (operands[0], E_QQmode)
              || !nox_general_operand (operands[1], E_QQmode)
              || !
#line 866 "../../gcc/config/avr/avr.md"
((register_operand (operands[0], QQmode)
    || reg_or_0_operand (operands[1], QQmode))
   && reload_completed))
            return -1;
          return 117; /* movqq_insn */

        case E_UQQmode:
          if (!nonimmediate_operand (operands[0], E_UQQmode)
              || !nox_general_operand (operands[1], E_UQQmode)
              || !
#line 866 "../../gcc/config/avr/avr.md"
((register_operand (operands[0], UQQmode)
    || reg_or_0_operand (operands[1], UQQmode))
   && reload_completed))
            return -1;
          return 118; /* movuqq_insn */

        case E_HImode:
          if (!nonimmediate_operand (operands[0], E_HImode)
              || !nox_general_operand (operands[1], E_HImode)
              || !
#line 975 "../../gcc/config/avr/avr.md"
((register_operand (operands[0], HImode)
    || reg_or_0_operand (operands[1], HImode))
   && reload_completed))
            return -1;
          return 133; /* *movhi */

        case E_HQmode:
          if (!nonimmediate_operand (operands[0], E_HQmode)
              || !nox_general_operand (operands[1], E_HQmode)
              || !
#line 975 "../../gcc/config/avr/avr.md"
((register_operand (operands[0], HQmode)
    || reg_or_0_operand (operands[1], HQmode))
   && reload_completed))
            return -1;
          return 134; /* *movhq */

        case E_UHQmode:
          if (!nonimmediate_operand (operands[0], E_UHQmode)
              || !nox_general_operand (operands[1], E_UHQmode)
              || !
#line 975 "../../gcc/config/avr/avr.md"
((register_operand (operands[0], UHQmode)
    || reg_or_0_operand (operands[1], UHQmode))
   && reload_completed))
            return -1;
          return 135; /* *movuhq */

        case E_HAmode:
          if (!nonimmediate_operand (operands[0], E_HAmode)
              || !nox_general_operand (operands[1], E_HAmode)
              || !
#line 975 "../../gcc/config/avr/avr.md"
((register_operand (operands[0], HAmode)
    || reg_or_0_operand (operands[1], HAmode))
   && reload_completed))
            return -1;
          return 136; /* *movha */

        case E_UHAmode:
          if (!nonimmediate_operand (operands[0], E_UHAmode)
              || !nox_general_operand (operands[1], E_UHAmode)
              || !
#line 975 "../../gcc/config/avr/avr.md"
((register_operand (operands[0], UHAmode)
    || reg_or_0_operand (operands[1], UHAmode))
   && reload_completed))
            return -1;
          return 137; /* *movuha */

        case E_PSImode:
          if (!nonimmediate_operand (operands[0], E_PSImode)
              || !nox_general_operand (operands[1], E_PSImode)
              || !
#line 1148 "../../gcc/config/avr/avr.md"
((register_operand (operands[0], PSImode)
    || register_operand (operands[1], PSImode)
    || const0_rtx == operands[1])
   && reload_completed))
            return -1;
          return 140; /* *movpsi */

        case E_SImode:
          if (!nonimmediate_operand (operands[0], E_SImode)
              || !nox_general_operand (operands[1], E_SImode)
              || !
#line 1208 "../../gcc/config/avr/avr.md"
((register_operand (operands[0], SImode)
    || reg_or_0_operand (operands[1], SImode))
   && reload_completed))
            return -1;
          return 151; /* *movsi */

        case E_SQmode:
          if (!nonimmediate_operand (operands[0], E_SQmode)
              || !nox_general_operand (operands[1], E_SQmode)
              || !
#line 1208 "../../gcc/config/avr/avr.md"
((register_operand (operands[0], SQmode)
    || reg_or_0_operand (operands[1], SQmode))
   && reload_completed))
            return -1;
          return 152; /* *movsq */

        case E_USQmode:
          if (!nonimmediate_operand (operands[0], E_USQmode)
              || !nox_general_operand (operands[1], E_USQmode)
              || !
#line 1208 "../../gcc/config/avr/avr.md"
((register_operand (operands[0], USQmode)
    || reg_or_0_operand (operands[1], USQmode))
   && reload_completed))
            return -1;
          return 153; /* *movusq */

        case E_SAmode:
          if (!nonimmediate_operand (operands[0], E_SAmode)
              || !nox_general_operand (operands[1], E_SAmode)
              || !
#line 1208 "../../gcc/config/avr/avr.md"
((register_operand (operands[0], SAmode)
    || reg_or_0_operand (operands[1], SAmode))
   && reload_completed))
            return -1;
          return 154; /* *movsa */

        case E_USAmode:
          if (!nonimmediate_operand (operands[0], E_USAmode)
              || !nox_general_operand (operands[1], E_USAmode)
              || !
#line 1208 "../../gcc/config/avr/avr.md"
((register_operand (operands[0], USAmode)
    || reg_or_0_operand (operands[1], USAmode))
   && reload_completed))
            return -1;
          return 155; /* *movusa */

        case E_SFmode:
          if (!nonimmediate_operand (operands[0], E_SFmode)
              || !nox_general_operand (operands[1], E_SFmode)
              || !
#line 1256 "../../gcc/config/avr/avr.md"
((register_operand (operands[0], SFmode)
    || reg_or_0_operand (operands[1], SFmode))
   && reload_completed))
            return -1;
          return 158; /* *movsf */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_62 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (pattern100 (x2, 
36, 
E_CCmode) != 0)
    return -1;
  x3 = XVECEXP (x1, 0, 0);
  x4 = XEXP (x3, 1);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
      operands[1] = x5;
      x6 = XEXP (x3, 0);
      operands[0] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_QImode:
          if (!register_operand (operands[0], E_QImode)
              || GET_MODE (x4) != E_QImode
              || !register_operand (operands[1], E_QImode)
              || !
#line 6370 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 799; /* *one_cmplqi2 */

        case E_HImode:
          if (!register_operand (operands[0], E_HImode)
              || GET_MODE (x4) != E_HImode
              || !register_operand (operands[1], E_HImode)
              || !
#line 6388 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 801; /* *one_cmplhi2 */

        case E_PSImode:
          if (!register_operand (operands[0], E_PSImode)
              || GET_MODE (x4) != E_PSImode
              || !register_operand (operands[1], E_PSImode)
              || !
#line 6407 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 803; /* *one_cmplpsi2 */

        case E_SImode:
          if (!register_operand (operands[0], E_SImode)
              || GET_MODE (x4) != E_SImode
              || !register_operand (operands[1], E_SImode)
              || !
#line 6425 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 805; /* *one_cmplsi2 */

        default:
          return -1;
        }

    case ZERO_EXTRACT:
      if (GET_MODE (x5) != E_QImode)
        return -1;
      x7 = XEXP (x5, 1);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x6 = XEXP (x3, 0);
      if (GET_CODE (x6) != ZERO_EXTRACT
          || GET_MODE (x6) != E_QImode)
        return -1;
      x8 = XEXP (x6, 1);
      if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x9 = XEXP (x6, 0);
      operands[0] = x9;
      if (!register_operand (operands[0], E_QImode))
        return -1;
      x10 = XEXP (x6, 2);
      operands[1] = x10;
      if (!const_0_to_7_operand (operands[1], E_QImode)
          || GET_MODE (x4) != E_QImode)
        return -1;
      x11 = XEXP (x5, 0);
      operands[2] = x11;
      if (!register_operand (operands[2], E_QImode))
        return -1;
      x12 = XEXP (x5, 2);
      operands[3] = x12;
      if (!const_0_to_7_operand (operands[3], E_QImode)
          || !
#line 10059 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 1084; /* insv_notbit */

    default:
      return -1;
    }
}

 int
recog_67 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 1);
  x6 = XEXP (x5, 0);
  switch (GET_CODE (x6))
    {
    case LSHIFTRT:
      x7 = XEXP (x6, 0);
      if (GET_CODE (x7) != MULT)
        return -1;
      x8 = XEXP (x6, 1);
      if (GET_CODE (x8) != CONST_INT)
        return -1;
      x9 = XEXP (x7, 0);
      switch (GET_CODE (x9))
        {
        case SIGN_EXTEND:
          if (GET_MODE (x9) == E_HImode
              && pattern289 (x1, 
SIGN_EXTEND) == 0
              && 
#line 2286 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
            return 306; /* *smulqi3_highpart */
          if (GET_MODE (x9) != E_SImode
              || pattern290 (x1, 
SIGN_EXTEND) != 0
              || !
#line 3804 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
            return -1;
          return 572; /* *smulhi3_highpart_call_split */

        case ZERO_EXTEND:
          if (GET_MODE (x9) == E_HImode
              && pattern289 (x1, 
ZERO_EXTEND) == 0
              && 
#line 2286 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
            return 307; /* *umulqi3_highpart */
          if (GET_MODE (x9) != E_SImode
              || pattern290 (x1, 
ZERO_EXTEND) != 0
              || !
#line 3804 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
            return -1;
          return 573; /* *umulhi3_highpart_call_split */

        default:
          return -1;
        }

    case PARITY:
      if (pattern207 (x1, 
E_CCmode, 
36) != 0
          || !
#line 9247 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 1030; /* *paritysihi2.libgcc */

    case POPCOUNT:
      if (pattern207 (x1, 
E_CCmode, 
36) != 0
          || !
#line 9323 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 1035; /* *popcountsi2.libgcc */

    case CLZ:
      if (pattern207 (x1, 
E_QImode, 
26) != 0)
        return -1;
      return 1041; /* *clzsihi2.libgcc_split */

    default:
      return -1;
    }
}

 int
recog_70 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_HImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != PARITY
      || GET_MODE (x4) != E_QImode)
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x5) != CLOBBER)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != REG)
    return -1;
  if (REGNO (x6) == 24
      && GET_MODE (x6) == E_HImode)
    {
      x7 = XEXP (x2, 0);
      operands[0] = x7;
      if (register_operand (operands[0], E_HImode))
        {
          x8 = XEXP (x4, 0);
          operands[1] = x8;
          if (register_operand (operands[1], E_QImode)
              && 
#line 9159 "../../gcc/config/avr/avr.md"
(!reload_completed))
            return 1023; /* *parityqihi2.1 */
        }
    }
  if (REGNO (x6) != 36
      || GET_MODE (x6) != E_CCmode)
    return -1;
  x8 = XEXP (x4, 0);
  if (GET_CODE (x8) != REG
      || REGNO (x8) != 24
      || GET_MODE (x8) != E_QImode)
    return -1;
  x7 = XEXP (x2, 0);
  if (GET_CODE (x7) != REG
      || REGNO (x7) != 24
      || GET_MODE (x7) != E_HImode
      || !
#line 9229 "../../gcc/config/avr/avr.md"
(reload_completed))
    return -1;
  return 1028; /* *parityqihi2.libgcc */
}

 int
recog_74 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  switch (pattern245 (x1, 
MOD))
    {
    case 0:
      x2 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x2) != SET)
        return -1;
      x3 = XEXP (x2, 1);
      if (GET_CODE (x3) != MOD)
        return -1;
      x4 = XEXP (x3, 0);
      if (GET_CODE (x4) != REG
          || REGNO (x4) != 24)
        return -1;
      x5 = XEXP (x3, 1);
      if (GET_CODE (x5) != REG
          || REGNO (x5) != 22)
        return -1;
      x6 = XEXP (x2, 0);
      if (GET_CODE (x6) != REG)
        return -1;
      switch (pattern377 (x1))
        {
        case 0:
          return 585; /* *divmodqi4_call_split */

        case 1:
          return 591; /* *divmodhi4_call_split */

        default:
          return -1;
        }

    case 1:
      switch (pattern328 (x1))
        {
        case 0:
          if (!
#line 625 "../../gcc/config/avr/avr-fixed.md"
(reload_completed))
            return -1;
          return 3123; /* *divsa3.call */

        case 1:
          if (!
#line 625 "../../gcc/config/avr/avr-fixed.md"
(reload_completed))
            return -1;
          return 3125; /* *divusa3.call */

        default:
          return -1;
        }

    case 2:
      return 613; /* *divmodsi4_call_split */

    case 3:
      if (!
#line 577 "../../gcc/config/avr/avr-fixed.md"
(reload_completed))
        return -1;
      return 3111; /* *divhq3.call */

    case 4:
      if (!
#line 577 "../../gcc/config/avr/avr-fixed.md"
(reload_completed))
        return -1;
      return 3113; /* *divuhq3.call */

    case 5:
      if (!
#line 577 "../../gcc/config/avr/avr-fixed.md"
(reload_completed))
        return -1;
      return 3115; /* *divha3.call */

    case 6:
      if (!
#line 577 "../../gcc/config/avr/avr-fixed.md"
(reload_completed))
        return -1;
      return 3117; /* *divuha3.call */

    default:
      return -1;
    }
}

 int
recog_80 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  if (pattern106 (x1) != 0)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      if (GET_CODE (x4) == REG)
        {
          res = recog_79 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      operands[1] = x4;
      switch (pattern267 (x1))
        {
        case 0:
          if (!
#line 3407 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed))
            return -1;
          return 541; /* *mulsi3 */

        case 1:
          if (!
#line 4201 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed))
            return -1;
          return 601; /* *mulpsi3 */

        default:
          return -1;
        }

    case ZERO_EXTEND:
      x5 = XEXP (x4, 0);
      if (GET_CODE (x5) == REG)
        {
          switch (pattern270 (x1))
            {
            case 0:
              if (
#line 2441 "../../gcc/config/avr/avr.md"
(!AVR_HAVE_MUL))
                return 476; /* *umulqihi3.call_split */
              break;

            case 1:
              if (
#line 675 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && AVR_HAVE_MUL))
                return 3361; /* umulsidi3_insn */
              break;

            default:
              break;
            }
        }
      if (GET_MODE (x4) != E_SImode)
        return -1;
      switch (pattern274 (x1))
        {
        case 0:
          if (!
#line 3487 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed))
            return -1;
          return 543; /* *muluqisi3 */

        case 1:
          if (!
#line 3487 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed))
            return -1;
          return 544; /* *muluhisi3 */

        case 2:
          if (!
#line 3650 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed))
            return -1;
          return 549; /* *usmulqiqisi3 */

        case 3:
          if (!
#line 3650 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed))
            return -1;
          return 557; /* *usmulqihisi3 */

        case 4:
          if (!
#line 3650 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed))
            return -1;
          return 553; /* *usmulhiqisi3 */

        case 5:
          if (!
#line 3650 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed))
            return -1;
          return 561; /* *usmulhihisi3 */

        case 6:
          if (!
#line 3650 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed))
            return -1;
          return 551; /* *uumulqiqisi3 */

        case 7:
          if (!
#line 3650 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed))
            return -1;
          return 559; /* *uumulqihisi3 */

        case 8:
          if (!
#line 3650 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed))
            return -1;
          return 555; /* *uumulhiqisi3 */

        case 9:
          if (!
#line 3650 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed))
            return -1;
          return 563; /* *uumulhihisi3 */

        default:
          return -1;
        }

    case SIGN_EXTEND:
      x6 = XVECEXP (x1, 0, 1);
      x7 = XEXP (x6, 0);
      if (REGNO (x7) != 26
          || GET_MODE (x7) != E_HImode)
        return -1;
      x8 = XVECEXP (x1, 0, 2);
      x9 = XEXP (x8, 0);
      if (REGNO (x9) == 18)
        {
          switch (pattern307 (x1))
            {
            case 0:
              if (
#line 3539 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed))
                return 545; /* *mulsqisi3 */
              break;

            case 1:
              if (
#line 3539 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed))
                return 546; /* *mulshisi3 */
              break;

            case 2:
              if (
#line 4182 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed))
                return 600; /* *mulsqipsi3 */
              break;

            case 3:
              if (
#line 3650 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed))
                return 548; /* *ssmulqiqisi3 */
              break;

            case 4:
              if (
#line 3650 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed))
                return 556; /* *ssmulqihisi3 */
              break;

            case 5:
              if (
#line 3650 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed))
                return 552; /* *ssmulhiqisi3 */
              break;

            case 6:
              if (
#line 3650 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed))
                return 560; /* *ssmulhihisi3 */
              break;

            case 7:
              if (
#line 3650 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed))
                return 550; /* *sumulqiqisi3 */
              break;

            case 8:
              if (
#line 3650 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed))
                return 558; /* *sumulqihisi3 */
              break;

            case 9:
              if (
#line 3650 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed))
                return 554; /* *sumulhiqisi3 */
              break;

            case 10:
              if (
#line 3650 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed))
                return 562; /* *sumulhihisi3 */
              break;

            default:
              break;
            }
        }
      x5 = XEXP (x4, 0);
      if (GET_CODE (x5) != REG
          || pattern308 (x1) != 0
          || !
#line 675 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && AVR_HAVE_MUL))
        return -1;
      return 3360; /* mulsidi3_insn */

    case NOT:
      if (pattern247 (x1) != 0
          || !
#line 3598 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed))
        return -1;
      return 547; /* *mulohisi3 */

    default:
      return -1;
    }
}

 rtx_insn *
split_1 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) == REG)
    {
      x3 = XEXP (x1, 1);
      operands[0] = x3;
      switch (REGNO (x2))
        {
        case 32:
          if (GET_MODE (x2) == E_HImode
              && register_operand (operands[0], E_HImode)
              && 
#line 537 "../../gcc/config/avr/avr.md"
(reload_completed
   && frame_pointer_needed
   && !cfun->calls_alloca
   && find_reg_note (insn, REG_ARGS_SIZE, const0_rtx)
   && REGNO (operands[0]) != REG_Y))
            return gen_split_1 (insn, operands);
          break;

        case 22:
          switch (pattern159 (x2))
            {
            case 0:
              if ((
#line 572 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))) && 
#line 576 "../../gcc/config/avr/avr.md"
( reload_completed)))
                return gen_split_2 (insn, operands);
              break;

            case 1:
              if ((
#line 572 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))) && 
#line 576 "../../gcc/config/avr/avr.md"
( reload_completed)))
                return gen_split_3 (insn, operands);
              break;

            case 2:
              if ((
#line 572 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))) && 
#line 576 "../../gcc/config/avr/avr.md"
( reload_completed)))
                return gen_split_4 (insn, operands);
              break;

            case 3:
              if ((
#line 572 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))) && 
#line 576 "../../gcc/config/avr/avr.md"
( reload_completed)))
                return gen_split_5 (insn, operands);
              break;

            case 4:
              if ((
#line 572 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))) && 
#line 576 "../../gcc/config/avr/avr.md"
( reload_completed)))
                return gen_split_6 (insn, operands);
              break;

            case 5:
              if ((
#line 572 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))) && 
#line 576 "../../gcc/config/avr/avr.md"
( reload_completed)))
                return gen_split_7 (insn, operands);
              break;

            case 6:
              if ((
#line 572 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))) && 
#line 576 "../../gcc/config/avr/avr.md"
( reload_completed)))
                return gen_split_8 (insn, operands);
              break;

            case 7:
              if ((
#line 572 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))) && 
#line 576 "../../gcc/config/avr/avr.md"
( reload_completed)))
                return gen_split_9 (insn, operands);
              break;

            case 8:
              if ((
#line 572 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))) && 
#line 576 "../../gcc/config/avr/avr.md"
( reload_completed)))
                return gen_split_10 (insn, operands);
              break;

            case 9:
              if ((
#line 572 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))) && 
#line 576 "../../gcc/config/avr/avr.md"
( reload_completed)))
                return gen_split_11 (insn, operands);
              break;

            case 10:
              if ((
#line 572 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))) && 
#line 576 "../../gcc/config/avr/avr.md"
( reload_completed)))
                return gen_split_12 (insn, operands);
              break;

            case 11:
              if ((
#line 572 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))) && 
#line 576 "../../gcc/config/avr/avr.md"
( reload_completed)))
                return gen_split_13 (insn, operands);
              break;

            case 12:
              if ((
#line 572 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))) && 
#line 576 "../../gcc/config/avr/avr.md"
( reload_completed)))
                return gen_split_14 (insn, operands);
              break;

            case 13:
              if ((
#line 572 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))) && 
#line 576 "../../gcc/config/avr/avr.md"
( reload_completed)))
                return gen_split_15 (insn, operands);
              break;

            case 14:
              if ((
#line 572 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))) && 
#line 576 "../../gcc/config/avr/avr.md"
( reload_completed)))
                return gen_split_16 (insn, operands);
              break;

            default:
              break;
            }
          break;

        default:
          break;
        }
    }
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  switch (pattern67 (x3))
    {
    case 0:
      if (!(
#line 852 "../../gcc/config/avr/avr.md"
(register_operand (operands[0], QImode)
    || reg_or_0_operand (operands[1], QImode)) && 
#line 855 "../../gcc/config/avr/avr.md"
( reload_completed)))
        return NULL;
      return gen_split_62 (insn, operands);

    case 1:
      if (!(
#line 852 "../../gcc/config/avr/avr.md"
(register_operand (operands[0], QQmode)
    || reg_or_0_operand (operands[1], QQmode)) && 
#line 855 "../../gcc/config/avr/avr.md"
( reload_completed)))
        return NULL;
      return gen_split_63 (insn, operands);

    case 2:
      if (!(
#line 852 "../../gcc/config/avr/avr.md"
(register_operand (operands[0], UQQmode)
    || reg_or_0_operand (operands[1], UQQmode)) && 
#line 855 "../../gcc/config/avr/avr.md"
( reload_completed)))
        return NULL;
      return gen_split_64 (insn, operands);

    case 3:
      if (nonimmediate_operand (operands[0], E_HImode)
          && nox_general_operand (operands[1], E_HImode)
          && (
#line 963 "../../gcc/config/avr/avr.md"
(register_operand (operands[0], HImode)
   || reg_or_0_operand (operands[1], HImode)) && 
#line 966 "../../gcc/config/avr/avr.md"
( reload_completed)))
        return gen_split_65 (insn, operands);
      if (!register_operand (operands[0], E_HImode)
          || !reg_or_0_operand (operands[1], E_HImode)
          || !
#line 4895 "../../gcc/config/avr/avr.md"
(optimize
   && reload_completed
   && GENERAL_REG_P (operands[0])
   && (operands[1] == const0_rtx || GENERAL_REG_P (operands[1]))
   && (!AVR_HAVE_MOVW
       || const0_rtx == operands[1])))
        return NULL;
      return gen_split_386 (insn, operands);

    case 4:
      if (!(
#line 963 "../../gcc/config/avr/avr.md"
(register_operand (operands[0], HQmode)
   || reg_or_0_operand (operands[1], HQmode)) && 
#line 966 "../../gcc/config/avr/avr.md"
( reload_completed)))
        return NULL;
      return gen_split_66 (insn, operands);

    case 5:
      if (!(
#line 963 "../../gcc/config/avr/avr.md"
(register_operand (operands[0], UHQmode)
   || reg_or_0_operand (operands[1], UHQmode)) && 
#line 966 "../../gcc/config/avr/avr.md"
( reload_completed)))
        return NULL;
      return gen_split_67 (insn, operands);

    case 6:
      if (!(
#line 963 "../../gcc/config/avr/avr.md"
(register_operand (operands[0], HAmode)
   || reg_or_0_operand (operands[1], HAmode)) && 
#line 966 "../../gcc/config/avr/avr.md"
( reload_completed)))
        return NULL;
      return gen_split_68 (insn, operands);

    case 7:
      if (!(
#line 963 "../../gcc/config/avr/avr.md"
(register_operand (operands[0], UHAmode)
   || reg_or_0_operand (operands[1], UHAmode)) && 
#line 966 "../../gcc/config/avr/avr.md"
( reload_completed)))
        return NULL;
      return gen_split_69 (insn, operands);

    case 8:
      if (nonimmediate_operand (operands[0], E_PSImode)
          && nox_general_operand (operands[1], E_PSImode)
          && (
#line 1135 "../../gcc/config/avr/avr.md"
(register_operand (operands[0], PSImode)
   || register_operand (operands[1], PSImode)
   || const0_rtx == operands[1]) && 
#line 1139 "../../gcc/config/avr/avr.md"
( reload_completed)))
        return gen_split_85 (insn, operands);
      if (!register_operand (operands[0], E_PSImode)
          || !register_operand (operands[1], E_PSImode)
          || !
#line 4874 "../../gcc/config/avr/avr.md"
(optimize
   && reload_completed))
        return NULL;
      return gen_split_381 (insn, operands);

    case 9:
      if (nonimmediate_operand (operands[0], E_SImode)
          && nox_general_operand (operands[1], E_SImode)
          && (
#line 1196 "../../gcc/config/avr/avr.md"
(register_operand (operands[0], SImode)
   || reg_or_0_operand (operands[1], SImode)) && 
#line 1199 "../../gcc/config/avr/avr.md"
( reload_completed)))
        return gen_split_86 (insn, operands);
      if (!register_operand (operands[0], E_SImode)
          || !register_operand (operands[1], E_SImode)
          || !
#line 4874 "../../gcc/config/avr/avr.md"
(optimize
   && reload_completed))
        return NULL;
      return gen_split_379 (insn, operands);

    case 10:
      if (nonimmediate_operand (operands[0], E_SQmode)
          && nox_general_operand (operands[1], E_SQmode)
          && (
#line 1196 "../../gcc/config/avr/avr.md"
(register_operand (operands[0], SQmode)
   || reg_or_0_operand (operands[1], SQmode)) && 
#line 1199 "../../gcc/config/avr/avr.md"
( reload_completed)))
        return gen_split_87 (insn, operands);
      if (!register_operand (operands[0], E_SQmode)
          || !register_operand (operands[1], E_SQmode)
          || !
#line 4874 "../../gcc/config/avr/avr.md"
(optimize
   && reload_completed))
        return NULL;
      return gen_split_382 (insn, operands);

    case 11:
      if (nonimmediate_operand (operands[0], E_USQmode)
          && nox_general_operand (operands[1], E_USQmode)
          && (
#line 1196 "../../gcc/config/avr/avr.md"
(register_operand (operands[0], USQmode)
   || reg_or_0_operand (operands[1], USQmode)) && 
#line 1199 "../../gcc/config/avr/avr.md"
( reload_completed)))
        return gen_split_88 (insn, operands);
      if (!register_operand (operands[0], E_USQmode)
          || !register_operand (operands[1], E_USQmode)
          || !
#line 4874 "../../gcc/config/avr/avr.md"
(optimize
   && reload_completed))
        return NULL;
      return gen_split_383 (insn, operands);

    case 12:
      if (nonimmediate_operand (operands[0], E_SAmode)
          && nox_general_operand (operands[1], E_SAmode)
          && (
#line 1196 "../../gcc/config/avr/avr.md"
(register_operand (operands[0], SAmode)
   || reg_or_0_operand (operands[1], SAmode)) && 
#line 1199 "../../gcc/config/avr/avr.md"
( reload_completed)))
        return gen_split_89 (insn, operands);
      if (!register_operand (operands[0], E_SAmode)
          || !register_operand (operands[1], E_SAmode)
          || !
#line 4874 "../../gcc/config/avr/avr.md"
(optimize
   && reload_completed))
        return NULL;
      return gen_split_384 (insn, operands);

    case 13:
      if (nonimmediate_operand (operands[0], E_USAmode)
          && nox_general_operand (operands[1], E_USAmode)
          && (
#line 1196 "../../gcc/config/avr/avr.md"
(register_operand (operands[0], USAmode)
   || reg_or_0_operand (operands[1], USAmode)) && 
#line 1199 "../../gcc/config/avr/avr.md"
( reload_completed)))
        return gen_split_90 (insn, operands);
      if (!register_operand (operands[0], E_USAmode)
          || !register_operand (operands[1], E_USAmode)
          || !
#line 4874 "../../gcc/config/avr/avr.md"
(optimize
   && reload_completed))
        return NULL;
      return gen_split_385 (insn, operands);

    case 14:
      if (nonimmediate_operand (operands[0], E_SFmode)
          && nox_general_operand (operands[1], E_SFmode)
          && (
#line 1244 "../../gcc/config/avr/avr.md"
(register_operand (operands[0], SFmode)
   || reg_or_0_operand (operands[1], SFmode)) && 
#line 1247 "../../gcc/config/avr/avr.md"
( reload_completed)))
        return gen_split_91 (insn, operands);
      if (!register_operand (operands[0], E_SFmode)
          || !register_operand (operands[1], E_SFmode)
          || !
#line 4874 "../../gcc/config/avr/avr.md"
(optimize
   && reload_completed))
        return NULL;
      return gen_split_380 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_10 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  rtx_insn *res ATTRIBUTE_UNUSED;
  switch (pattern13 (x1))
    {
    case 0:
      x2 = XEXP (x1, 1);
      x3 = XEXP (x2, 1);
      switch (GET_CODE (x3))
        {
        case CONST_INT:
        case CONST_WIDE_INT:
        case CONST_POLY_INT:
        case CONST_FIXED:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case CONST:
        case REG:
        case SUBREG:
        case LABEL_REF:
        case SYMBOL_REF:
        case HIGH:
          x4 = XEXP (x1, 0);
          switch (GET_MODE (x4))
            {
            case E_QImode:
              if (pattern124 (x1, 
E_QImode) == 0
                  && 
#line 1583 "../../gcc/config/avr/avr.md"
( reload_completed))
                return gen_split_99 (insn, operands);
              break;

            case E_QQmode:
              if (pattern124 (x1, 
E_QQmode) == 0
                  && 
#line 1583 "../../gcc/config/avr/avr.md"
( reload_completed))
                return gen_split_100 (insn, operands);
              break;

            case E_UQQmode:
              if (pattern124 (x1, 
E_UQQmode) == 0
                  && 
#line 1583 "../../gcc/config/avr/avr.md"
( reload_completed))
                return gen_split_101 (insn, operands);
              break;

            case E_HImode:
              if (GET_MODE (x2) == E_HImode)
                {
                  operands[1] = x4;
                  if (stack_register_operand (operands[1], E_HImode))
                    {
                      x5 = XEXP (x2, 0);
                      operands[2] = x5;
                      if (stack_register_operand (operands[2], E_HImode))
                        {
                          operands[0] = x3;
                          if (avr_sp_immediate_operand (operands[0], E_HImode))
                            return gen_split_108 (insn, operands);
                        }
                    }
                  operands[0] = x4;
                  if (register_operand (operands[0], E_HImode))
                    {
                      x5 = XEXP (x2, 0);
                      operands[1] = x5;
                      if (register_operand (operands[1], E_HImode))
                        {
                          operands[2] = x3;
                          if (nonmemory_or_const_operand (operands[2], E_HImode))
                            return gen_split_109 (insn, operands);
                        }
                    }
                }
              break;

            case E_HQmode:
              if (pattern151 (x1, 
E_HQmode) == 0)
                return gen_split_110 (insn, operands);
              break;

            case E_UHQmode:
              if (pattern151 (x1, 
E_UHQmode) == 0)
                return gen_split_111 (insn, operands);
              break;

            case E_HAmode:
              if (pattern151 (x1, 
E_HAmode) == 0)
                return gen_split_112 (insn, operands);
              break;

            case E_UHAmode:
              if (pattern151 (x1, 
E_UHAmode) == 0)
                return gen_split_113 (insn, operands);
              break;

            default:
              break;
            }
          break;

        case ZERO_EXTEND:
          if (pattern69 (x1) == 0
              && 
#line 1665 "../../gcc/config/avr/avr.md"
( reload_completed))
            return gen_split_103 (insn, operands);
          break;

        default:
          break;
        }
      x5 = XEXP (x2, 0);
      if (GET_CODE (x5) != REG)
        return NULL;
      switch (pattern72 (x1))
        {
        case 0:
          if (!(
#line 101 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 103 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
            return NULL;
          return gen_split_1866 (insn, operands);

        case 1:
          if (!(
#line 101 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 103 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
            return NULL;
          return gen_split_1867 (insn, operands);

        case 2:
          if (!(
#line 101 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 103 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
            return NULL;
          return gen_split_1868 (insn, operands);

        case 3:
          if (!(
#line 101 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 103 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
            return NULL;
          return gen_split_1869 (insn, operands);

        case 4:
          if (!(
#line 101 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 103 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
            return NULL;
          return gen_split_1870 (insn, operands);

        case 5:
          if (!(
#line 101 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 103 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
            return NULL;
          return gen_split_1871 (insn, operands);

        case 6:
          if (!(
#line 101 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 103 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
            return NULL;
          return gen_split_1872 (insn, operands);

        case 7:
          if (!(
#line 122 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 124 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
            return NULL;
          return gen_split_1873 (insn, operands);

        case 8:
          if (!(
#line 147 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && !s8_operand (operands[0], VOIDmode)) && 
#line 150 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
            return NULL;
          return gen_split_1874 (insn, operands);

        case 9:
          if (!(
#line 147 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && !s8_operand (operands[0], VOIDmode)) && 
#line 150 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
            return NULL;
          return gen_split_1875 (insn, operands);

        case 10:
          if (!(
#line 147 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && !s8_operand (operands[0], VOIDmode)) && 
#line 150 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
            return NULL;
          return gen_split_1876 (insn, operands);

        case 11:
          if (!(
#line 147 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && !s8_operand (operands[0], VOIDmode)) && 
#line 150 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
            return NULL;
          return gen_split_1877 (insn, operands);

        case 12:
          if (!(
#line 147 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && !s8_operand (operands[0], VOIDmode)) && 
#line 150 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
            return NULL;
          return gen_split_1878 (insn, operands);

        case 13:
          if (!(
#line 147 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && !s8_operand (operands[0], VOIDmode)) && 
#line 150 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
            return NULL;
          return gen_split_1879 (insn, operands);

        case 14:
          if (!(
#line 147 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && !s8_operand (operands[0], VOIDmode)) && 
#line 150 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
            return NULL;
          return gen_split_1880 (insn, operands);

        default:
          return NULL;
        }

    case 1:
      x2 = XEXP (x1, 1);
      x3 = XEXP (x2, 1);
      switch (GET_CODE (x3))
        {
        case REG:
        case SUBREG:
          switch (pattern3 (x2))
            {
            case 0:
              if (!
#line 1642 "../../gcc/config/avr/avr.md"
( reload_completed))
                return NULL;
              return gen_split_102 (insn, operands);

            case 1:
              if (!(
#line 1978 "../../gcc/config/avr/avr.md"
(3 > 1
   && (3 > 2 || ZERO_EXTEND == SIGN_EXTEND)) && 
#line 1981 "../../gcc/config/avr/avr.md"
( reload_completed)))
                return NULL;
              return gen_split_126 (insn, operands);

            case 2:
              if (!(
#line 1978 "../../gcc/config/avr/avr.md"
(3 > 2
   && (3 > 2 || ZERO_EXTEND == SIGN_EXTEND)) && 
#line 1981 "../../gcc/config/avr/avr.md"
( reload_completed)))
                return NULL;
              return gen_split_130 (insn, operands);

            case 3:
              if (!(
#line 1978 "../../gcc/config/avr/avr.md"
(4 > 1
   && (4 > 2 || ZERO_EXTEND == SIGN_EXTEND)) && 
#line 1981 "../../gcc/config/avr/avr.md"
( reload_completed)))
                return NULL;
              return gen_split_128 (insn, operands);

            case 4:
              if (!(
#line 1978 "../../gcc/config/avr/avr.md"
(4 > 2
   && (4 > 2 || ZERO_EXTEND == SIGN_EXTEND)) && 
#line 1981 "../../gcc/config/avr/avr.md"
( reload_completed)))
                return NULL;
              return gen_split_132 (insn, operands);

            case 5:
              if (!(
#line 1978 "../../gcc/config/avr/avr.md"
(4 > 3
   && (4 > 2 || ZERO_EXTEND == SIGN_EXTEND)) && 
#line 1981 "../../gcc/config/avr/avr.md"
( reload_completed)))
                return NULL;
              return gen_split_134 (insn, operands);

            default:
              return NULL;
            }

        case CONST_INT:
          operands[2] = x3;
          if (!const_m255_to_m1_operand (operands[2], E_HImode)
              || pattern190 (x2) != 0
              || !
#line 1686 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_104 (insn, operands);

        case ZERO_EXTEND:
          if (pattern161 (x2) != 0
              || !
#line 1754 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_106 (insn, operands);

        default:
          return NULL;
        }

    case 2:
      if (!
#line 1725 "../../gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_105 (insn, operands);

    case 3:
      if (!(
#line 10798 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 2 > 1
   && ! reload_completed) && 
#line 10802 "../../gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_911 (insn, operands);

    case 4:
      if (!(
#line 10798 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 1
   && ! reload_completed) && 
#line 10802 "../../gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_917 (insn, operands);

    case 5:
      if (!(
#line 10798 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 2
   && ! reload_completed) && 
#line 10802 "../../gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_929 (insn, operands);

    case 6:
      if (!(
#line 10798 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 1
   && ! reload_completed) && 
#line 10802 "../../gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_923 (insn, operands);

    case 7:
      if (!(
#line 10798 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 2
   && ! reload_completed) && 
#line 10802 "../../gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_935 (insn, operands);

    case 8:
      if (!(
#line 10798 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 3
   && ! reload_completed) && 
#line 10802 "../../gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_941 (insn, operands);

    case 9:
      if (!(
#line 10798 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 2 > 1
   && ! reload_completed) && 
#line 10802 "../../gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_910 (insn, operands);

    case 10:
      if (!(
#line 10798 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 1
   && ! reload_completed) && 
#line 10802 "../../gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_916 (insn, operands);

    case 11:
      if (!(
#line 10798 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 2
   && ! reload_completed) && 
#line 10802 "../../gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_928 (insn, operands);

    case 12:
      if (!(
#line 10798 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 1
   && ! reload_completed) && 
#line 10802 "../../gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_922 (insn, operands);

    case 13:
      if (!(
#line 10798 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 2
   && ! reload_completed) && 
#line 10802 "../../gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_934 (insn, operands);

    case 14:
      if (!(
#line 10798 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 3
   && ! reload_completed) && 
#line 10802 "../../gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_940 (insn, operands);

    case 15:
      if (!(
#line 1978 "../../gcc/config/avr/avr.md"
(2 > 1
   && (2 > 2 || SIGN_EXTEND == SIGN_EXTEND)) && 
#line 1981 "../../gcc/config/avr/avr.md"
( reload_completed)))
        return NULL;
      return gen_split_124 (insn, operands);

    case 16:
      if (!(
#line 1978 "../../gcc/config/avr/avr.md"
(3 > 1
   && (3 > 2 || SIGN_EXTEND == SIGN_EXTEND)) && 
#line 1981 "../../gcc/config/avr/avr.md"
( reload_completed)))
        return NULL;
      return gen_split_125 (insn, operands);

    case 17:
      if (!(
#line 1978 "../../gcc/config/avr/avr.md"
(3 > 2
   && (3 > 2 || SIGN_EXTEND == SIGN_EXTEND)) && 
#line 1981 "../../gcc/config/avr/avr.md"
( reload_completed)))
        return NULL;
      return gen_split_129 (insn, operands);

    case 18:
      if (!(
#line 1978 "../../gcc/config/avr/avr.md"
(4 > 1
   && (4 > 2 || SIGN_EXTEND == SIGN_EXTEND)) && 
#line 1981 "../../gcc/config/avr/avr.md"
( reload_completed)))
        return NULL;
      return gen_split_127 (insn, operands);

    case 19:
      if (!(
#line 1978 "../../gcc/config/avr/avr.md"
(4 > 2
   && (4 > 2 || SIGN_EXTEND == SIGN_EXTEND)) && 
#line 1981 "../../gcc/config/avr/avr.md"
( reload_completed)))
        return NULL;
      return gen_split_131 (insn, operands);

    case 20:
      if (!(
#line 1978 "../../gcc/config/avr/avr.md"
(4 > 3
   && (4 > 2 || SIGN_EXTEND == SIGN_EXTEND)) && 
#line 1981 "../../gcc/config/avr/avr.md"
( reload_completed)))
        return NULL;
      return gen_split_133 (insn, operands);

    case 21:
      if (!
#line 2320 "../../gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_174 (insn, operands);

    case 22:
      if (!
#line 2320 "../../gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_176 (insn, operands);

    case 23:
      if (!
#line 2320 "../../gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_178 (insn, operands);

    case 24:
      if (!
#line 2320 "../../gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_180 (insn, operands);

    case 25:
      if (!(
#line 2336 "../../gcc/config/avr/avr.md"
(2 > 1) && 
#line 2338 "../../gcc/config/avr/avr.md"
( reload_completed)))
        return NULL;
      return gen_split_182 (insn, operands);

    case 26:
      if (!(
#line 2336 "../../gcc/config/avr/avr.md"
(3 > 1) && 
#line 2338 "../../gcc/config/avr/avr.md"
( reload_completed)))
        return NULL;
      return gen_split_184 (insn, operands);

    case 27:
      if (!(
#line 2336 "../../gcc/config/avr/avr.md"
(3 > 2) && 
#line 2338 "../../gcc/config/avr/avr.md"
( reload_completed)))
        return NULL;
      return gen_split_188 (insn, operands);

    case 28:
      if (!(
#line 2336 "../../gcc/config/avr/avr.md"
(4 > 1) && 
#line 2338 "../../gcc/config/avr/avr.md"
( reload_completed)))
        return NULL;
      return gen_split_186 (insn, operands);

    case 29:
      if (!(
#line 2336 "../../gcc/config/avr/avr.md"
(4 > 2) && 
#line 2338 "../../gcc/config/avr/avr.md"
( reload_completed)))
        return NULL;
      return gen_split_190 (insn, operands);

    case 30:
      if (!(
#line 2336 "../../gcc/config/avr/avr.md"
(4 > 3) && 
#line 2338 "../../gcc/config/avr/avr.md"
( reload_completed)))
        return NULL;
      return gen_split_192 (insn, operands);

    case 31:
      if (!
#line 2320 "../../gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_175 (insn, operands);

    case 32:
      if (!
#line 2320 "../../gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_177 (insn, operands);

    case 33:
      if (!
#line 2320 "../../gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_179 (insn, operands);

    case 34:
      if (!
#line 2320 "../../gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_181 (insn, operands);

    case 35:
      if (!(
#line 2336 "../../gcc/config/avr/avr.md"
(2 > 1) && 
#line 2338 "../../gcc/config/avr/avr.md"
( reload_completed)))
        return NULL;
      return gen_split_183 (insn, operands);

    case 36:
      if (!(
#line 2336 "../../gcc/config/avr/avr.md"
(3 > 1) && 
#line 2338 "../../gcc/config/avr/avr.md"
( reload_completed)))
        return NULL;
      return gen_split_185 (insn, operands);

    case 37:
      if (!(
#line 2336 "../../gcc/config/avr/avr.md"
(3 > 2) && 
#line 2338 "../../gcc/config/avr/avr.md"
( reload_completed)))
        return NULL;
      return gen_split_189 (insn, operands);

    case 38:
      if (!(
#line 2336 "../../gcc/config/avr/avr.md"
(4 > 1) && 
#line 2338 "../../gcc/config/avr/avr.md"
( reload_completed)))
        return NULL;
      return gen_split_187 (insn, operands);

    case 39:
      if (!(
#line 2336 "../../gcc/config/avr/avr.md"
(4 > 2) && 
#line 2338 "../../gcc/config/avr/avr.md"
( reload_completed)))
        return NULL;
      return gen_split_191 (insn, operands);

    case 40:
      if (!(
#line 2336 "../../gcc/config/avr/avr.md"
(4 > 3) && 
#line 2338 "../../gcc/config/avr/avr.md"
( reload_completed)))
        return NULL;
      return gen_split_193 (insn, operands);

    case 41:
      if (!
#line 2407 "../../gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_206 (insn, operands);

    case 42:
      if (!
#line 2407 "../../gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_214 (insn, operands);

    case 43:
      if (!
#line 2407 "../../gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_222 (insn, operands);

    case 44:
      if (!
#line 2407 "../../gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_230 (insn, operands);

    case 45:
      if (!
#line 2407 "../../gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_208 (insn, operands);

    case 46:
      if (!
#line 2407 "../../gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_216 (insn, operands);

    case 47:
      if (!
#line 2407 "../../gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_224 (insn, operands);

    case 48:
      if (!
#line 2407 "../../gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_232 (insn, operands);

    case 49:
      if (!
#line 2407 "../../gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_210 (insn, operands);

    case 50:
      if (!
#line 2407 "../../gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_218 (insn, operands);

    case 51:
      if (!
#line 2407 "../../gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_226 (insn, operands);

    case 52:
      if (!
#line 2407 "../../gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_234 (insn, operands);

    case 53:
      if (!
#line 2407 "../../gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_212 (insn, operands);

    case 54:
      if (!
#line 2407 "../../gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_220 (insn, operands);

    case 55:
      if (!
#line 2407 "../../gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_228 (insn, operands);

    case 56:
      if (!
#line 2407 "../../gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_236 (insn, operands);

    case 57:
      if (!
#line 2407 "../../gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_207 (insn, operands);

    case 58:
      if (!
#line 2407 "../../gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_215 (insn, operands);

    case 59:
      if (!
#line 2407 "../../gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_223 (insn, operands);

    case 60:
      if (!
#line 2407 "../../gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_231 (insn, operands);

    case 61:
      if (!
#line 2407 "../../gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_209 (insn, operands);

    case 62:
      if (!
#line 2407 "../../gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_217 (insn, operands);

    case 63:
      if (!
#line 2407 "../../gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_225 (insn, operands);

    case 64:
      if (!
#line 2407 "../../gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_233 (insn, operands);

    case 65:
      if (!
#line 2407 "../../gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_211 (insn, operands);

    case 66:
      if (!
#line 2407 "../../gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_219 (insn, operands);

    case 67:
      if (!
#line 2407 "../../gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_227 (insn, operands);

    case 68:
      if (!
#line 2407 "../../gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_235 (insn, operands);

    case 69:
      if (!
#line 2407 "../../gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_213 (insn, operands);

    case 70:
      if (!
#line 2407 "../../gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_221 (insn, operands);

    case 71:
      if (!
#line 2407 "../../gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_229 (insn, operands);

    case 72:
      if (!
#line 2407 "../../gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_237 (insn, operands);

    case 73:
      x2 = XEXP (x1, 1);
      x5 = XEXP (x2, 0);
      x6 = XEXP (x5, 0);
      operands[1] = x6;
      if (!register_operand (operands[1], E_QImode)
          || !register_operand (operands[0], E_QImode)
          || GET_MODE (x2) != E_QImode
          || GET_MODE (x5) != E_QImode)
        return NULL;
      x7 = XEXP (x5, 1);
      operands[2] = x7;
      if (!register_operand (operands[2], E_QImode))
        return NULL;
      x3 = XEXP (x2, 1);
      operands[3] = x3;
      if (!register_operand (operands[3], E_QImode)
          || !(
#line 2596 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 2598 "../../gcc/config/avr/avr.md"
( reload_completed)))
        return NULL;
      return gen_split_277 (insn, operands);

    case 74:
      x2 = XEXP (x1, 1);
      switch (pattern127 (x2))
        {
        case 0:
          x5 = XEXP (x2, 0);
          x7 = XEXP (x5, 1);
          if (GET_MODE (x7) != E_HImode
              || !register_operand (operands[3], E_HImode))
            return NULL;
          switch (GET_CODE (x7))
            {
            case SIGN_EXTEND:
              x8 = XEXP (x7, 0);
              operands[2] = x8;
              if (!register_operand (operands[2], E_QImode)
                  || !(
#line 2705 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 2707 "../../gcc/config/avr/avr.md"
( reload_completed)))
                return NULL;
              return gen_split_281 (insn, operands);

            case ZERO_EXTEND:
              x8 = XEXP (x7, 0);
              operands[2] = x8;
              if (!register_operand (operands[2], E_QImode)
                  || !(
#line 2763 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL
   && reload_completed
   && SIGN_EXTEND != ZERO_EXTEND) && 
#line 2767 "../../gcc/config/avr/avr.md"
( reload_completed)))
                return NULL;
              return gen_split_286 (insn, operands);

            default:
              return NULL;
            }

        case 1:
          if (!(
#line 10778 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 2 > 1
   && ! reload_completed) && 
#line 10782 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_874 (insn, operands);

        case 2:
          if (!(
#line 10778 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 1
   && ! reload_completed) && 
#line 10782 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_880 (insn, operands);

        case 3:
          if (!(
#line 10778 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 2
   && ! reload_completed) && 
#line 10782 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_892 (insn, operands);

        case 4:
          if (!(
#line 10778 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 1
   && ! reload_completed) && 
#line 10782 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_886 (insn, operands);

        case 5:
          if (!(
#line 10778 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 2
   && ! reload_completed) && 
#line 10782 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_898 (insn, operands);

        case 6:
          if (!(
#line 10778 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 3
   && ! reload_completed) && 
#line 10782 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_904 (insn, operands);

        default:
          return NULL;
        }

    case 75:
      x2 = XEXP (x1, 1);
      switch (pattern128 (x2))
        {
        case 0:
          if (!(
#line 2705 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 2707 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_282 (insn, operands);

        case 1:
          if (!(
#line 2763 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL
   && reload_completed
   && ZERO_EXTEND != SIGN_EXTEND) && 
#line 2767 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_285 (insn, operands);

        case 2:
          x5 = XEXP (x2, 0);
          x7 = XEXP (x5, 1);
          if (XWINT (x7, 0) != 2L)
            return NULL;
          x3 = XEXP (x2, 1);
          operands[2] = x3;
          if (!(
#line 2836 "../../gcc/config/avr/avr.md"
(!reload_completed
   && !reg_overlap_mentioned_p (operands[0], operands[1])) && 
#line 2839 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_289 (insn, operands);

        case 3:
          if (!(
#line 10778 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 2 > 1
   && ! reload_completed) && 
#line 10782 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_875 (insn, operands);

        case 4:
          if (!(
#line 10778 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 1
   && ! reload_completed) && 
#line 10782 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_881 (insn, operands);

        case 5:
          if (!(
#line 10778 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 2
   && ! reload_completed) && 
#line 10782 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_893 (insn, operands);

        case 6:
          if (!(
#line 10778 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 1
   && ! reload_completed) && 
#line 10782 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_887 (insn, operands);

        case 7:
          if (!(
#line 10778 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 2
   && ! reload_completed) && 
#line 10782 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_899 (insn, operands);

        case 8:
          if (!(
#line 10778 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 3
   && ! reload_completed) && 
#line 10782 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_905 (insn, operands);

        default:
          return NULL;
        }

    case 76:
      x2 = XEXP (x1, 1);
      switch (pattern129 (x2))
        {
        case 0:
          if (!(
#line 10761 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10764 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_862 (insn, operands);

        case 1:
          if (!(
#line 10761 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10764 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_865 (insn, operands);

        case 2:
          if (!(
#line 10761 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10764 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_868 (insn, operands);

        case 3:
          if (!(
#line 10761 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10764 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_871 (insn, operands);

        default:
          return NULL;
        }

    case 77:
      if (!(
#line 10736 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10739 "../../gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_814 (insn, operands);

    case 78:
      if (!(
#line 10736 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10739 "../../gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_826 (insn, operands);

    case 79:
      if (!(
#line 10736 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10739 "../../gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_838 (insn, operands);

    case 80:
      if (!(
#line 10736 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10739 "../../gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_850 (insn, operands);

    case 81:
      if (!(
#line 10736 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10739 "../../gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_817 (insn, operands);

    case 82:
      if (!(
#line 10736 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10739 "../../gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_829 (insn, operands);

    case 83:
      if (!(
#line 10736 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10739 "../../gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_841 (insn, operands);

    case 84:
      if (!(
#line 10736 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10739 "../../gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_853 (insn, operands);

    case 85:
      if (!(
#line 10736 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10739 "../../gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_820 (insn, operands);

    case 86:
      if (!(
#line 10736 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10739 "../../gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_832 (insn, operands);

    case 87:
      if (!(
#line 10736 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10739 "../../gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_844 (insn, operands);

    case 88:
      if (!(
#line 10736 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10739 "../../gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_856 (insn, operands);

    case 89:
      if (!(
#line 10736 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10739 "../../gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_823 (insn, operands);

    case 90:
      if (!(
#line 10736 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10739 "../../gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_835 (insn, operands);

    case 91:
      if (!(
#line 10736 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10739 "../../gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_847 (insn, operands);

    case 92:
      if (!(
#line 10736 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10739 "../../gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_859 (insn, operands);

    case 93:
      if (!(
#line 10817 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && exact_log2 (UINTVAL (operands[2]) & GET_MODE_MASK (HImode))
      == INTVAL (operands[4])
   && ! reload_completed) && 
#line 10822 "../../gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_946 (insn, operands);

    case 94:
      if (!(
#line 10817 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && exact_log2 (UINTVAL (operands[2]) & GET_MODE_MASK (PSImode))
      == INTVAL (operands[4])
   && ! reload_completed) && 
#line 10822 "../../gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_949 (insn, operands);

    case 95:
      if (!(
#line 10817 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && exact_log2 (UINTVAL (operands[2]) & GET_MODE_MASK (SImode))
      == INTVAL (operands[4])
   && ! reload_completed) && 
#line 10822 "../../gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_952 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_28 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (pattern100 (x2, 
26, 
E_HImode) != 0)
    return NULL;
  x3 = XVECEXP (x1, 0, 2);
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 30
      || GET_MODE (x4) != E_HImode)
    return NULL;
  x5 = XVECEXP (x1, 0, 3);
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 18
      || GET_MODE (x6) != E_DImode)
    return NULL;
  x7 = XVECEXP (x1, 0, 0);
  x8 = XEXP (x7, 0);
  operands[0] = x8;
  if (!pseudo_register_operand (operands[0], E_SImode))
    return NULL;
  x9 = XEXP (x7, 1);
  x10 = XEXP (x9, 0);
  operands[1] = x10;
  if (!pseudo_register_operand (operands[1], E_SImode))
    return NULL;
  x11 = XEXP (x9, 1);
  operands[2] = x11;
  if (!pseudo_register_operand (operands[2], E_SImode)
      || !(
#line 3443 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! AVR_HAVE_MUL
   && ! AVR_TINY
   && ! reload_completed) && 
#line 3448 "../../gcc/config/avr/avr.md"
( 1)))
    return NULL;
  return gen_split_313 (insn, operands);
}

 rtx_insn *
split_30 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != REG)
    return NULL;
  x5 = XEXP (x2, 0);
  if (GET_CODE (x5) != REG)
    return NULL;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 0);
  if (REGNO (x7) != 22)
    return NULL;
  switch (pattern342 (x1))
    {
    case 0:
      if (!(
#line 3319 "../../gcc/config/avr/avr.md"
(!AVR_HAVE_MUL) && 
#line 3321 "../../gcc/config/avr/avr.md"
( reload_completed)))
        return NULL;
      return gen_split_311 (insn, operands);

    case 1:
      if (!(
#line 377 "../../gcc/config/avr/avr-fixed.md"
(!AVR_HAVE_MUL) && 
#line 379 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1823 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_32 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x2) != CLOBBER)
    return NULL;
  x3 = XVECEXP (x1, 0, 0);
  switch (GET_CODE (x3))
    {
    case SET:
      x4 = XEXP (x2, 0);
      if (GET_CODE (x4) != REG)
        return NULL;
      x5 = XEXP (x3, 1);
      switch (GET_CODE (x5))
        {
        case MEM:
          if (pattern184 (x3) != 0)
            return NULL;
          x6 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x6) != CLOBBER)
            return NULL;
          x7 = XEXP (x6, 0);
          if (GET_CODE (x7) != REG
              || REGNO (x7) != 21
              || GET_MODE (x7) != E_QImode)
            return NULL;
          switch (pattern379 (x1))
            {
            case 0:
              if (!(
#line 715 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
    || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true)) && 
#line 718 "../../gcc/config/avr/avr.md"
( reload_completed)))
                return NULL;
              return gen_split_47 (insn, operands);

            case 1:
              if (!(
#line 715 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
    || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true)) && 
#line 718 "../../gcc/config/avr/avr.md"
( reload_completed)))
                return NULL;
              return gen_split_48 (insn, operands);

            case 2:
              if (!(
#line 715 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
    || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true)) && 
#line 718 "../../gcc/config/avr/avr.md"
( reload_completed)))
                return NULL;
              return gen_split_49 (insn, operands);

            case 3:
              if (!(
#line 715 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
    || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true)) && 
#line 718 "../../gcc/config/avr/avr.md"
( reload_completed)))
                return NULL;
              return gen_split_50 (insn, operands);

            case 4:
              if (!(
#line 715 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
    || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true)) && 
#line 718 "../../gcc/config/avr/avr.md"
( reload_completed)))
                return NULL;
              return gen_split_51 (insn, operands);

            case 5:
              if (!(
#line 715 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
    || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true)) && 
#line 718 "../../gcc/config/avr/avr.md"
( reload_completed)))
                return NULL;
              return gen_split_52 (insn, operands);

            case 6:
              if (!(
#line 715 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
    || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true)) && 
#line 718 "../../gcc/config/avr/avr.md"
( reload_completed)))
                return NULL;
              return gen_split_53 (insn, operands);

            case 7:
              if (!(
#line 715 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
    || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true)) && 
#line 718 "../../gcc/config/avr/avr.md"
( reload_completed)))
                return NULL;
              return gen_split_54 (insn, operands);

            case 8:
              if (!(
#line 715 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
    || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true)) && 
#line 718 "../../gcc/config/avr/avr.md"
( reload_completed)))
                return NULL;
              return gen_split_55 (insn, operands);

            case 9:
              if (!(
#line 715 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
    || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true)) && 
#line 718 "../../gcc/config/avr/avr.md"
( reload_completed)))
                return NULL;
              return gen_split_56 (insn, operands);

            case 10:
              if (!(
#line 715 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
    || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true)) && 
#line 718 "../../gcc/config/avr/avr.md"
( reload_completed)))
                return NULL;
              return gen_split_57 (insn, operands);

            case 11:
              if (!(
#line 715 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
    || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true)) && 
#line 718 "../../gcc/config/avr/avr.md"
( reload_completed)))
                return NULL;
              return gen_split_58 (insn, operands);

            case 12:
              if (!(
#line 715 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
    || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true)) && 
#line 718 "../../gcc/config/avr/avr.md"
( reload_completed)))
                return NULL;
              return gen_split_59 (insn, operands);

            case 13:
              if (!(
#line 715 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
    || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true)) && 
#line 718 "../../gcc/config/avr/avr.md"
( reload_completed)))
                return NULL;
              return gen_split_60 (insn, operands);

            case 14:
              if (!(
#line 715 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
    || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true)) && 
#line 718 "../../gcc/config/avr/avr.md"
( reload_completed)))
                return NULL;
              return gen_split_61 (insn, operands);

            default:
              return NULL;
            }

        case MULT:
          x6 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x6) != CLOBBER)
            return NULL;
          x7 = XEXP (x6, 0);
          if (GET_CODE (x7) != REG)
            return NULL;
          x8 = XEXP (x5, 0);
          switch (GET_CODE (x8))
            {
            case ZERO_EXTEND:
              x9 = XEXP (x8, 0);
              if (GET_CODE (x9) == REG)
                {
                  switch (pattern270 (x1))
                    {
                    case 0:
                      if ((
#line 2441 "../../gcc/config/avr/avr.md"
(!AVR_HAVE_MUL) && 
#line 2443 "../../gcc/config/avr/avr.md"
( reload_completed)))
                        return gen_split_270 (insn, operands);
                      break;

                    case 1:
                      if ((
#line 675 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && AVR_HAVE_MUL) && 
#line 678 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
                        return gen_split_1964 (insn, operands);
                      break;

                    default:
                      break;
                    }
                }
              if (GET_MODE (x8) != E_SImode)
                return NULL;
              switch (pattern274 (x1))
                {
                case 0:
                  if (!(
#line 3487 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed) && 
#line 3489 "../../gcc/config/avr/avr.md"
( 1)))
                    return NULL;
                  return gen_split_314 (insn, operands);

                case 1:
                  if (!(
#line 3487 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed) && 
#line 3489 "../../gcc/config/avr/avr.md"
( 1)))
                    return NULL;
                  return gen_split_315 (insn, operands);

                case 2:
                  if (!(
#line 3650 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed) && 
#line 3652 "../../gcc/config/avr/avr.md"
( 1)))
                    return NULL;
                  return gen_split_320 (insn, operands);

                case 3:
                  if (!(
#line 3650 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed) && 
#line 3652 "../../gcc/config/avr/avr.md"
( 1)))
                    return NULL;
                  return gen_split_328 (insn, operands);

                case 4:
                  if (!(
#line 3650 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed) && 
#line 3652 "../../gcc/config/avr/avr.md"
( 1)))
                    return NULL;
                  return gen_split_324 (insn, operands);

                case 5:
                  if (!(
#line 3650 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed) && 
#line 3652 "../../gcc/config/avr/avr.md"
( 1)))
                    return NULL;
                  return gen_split_332 (insn, operands);

                case 6:
                  if (!(
#line 3650 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed) && 
#line 3652 "../../gcc/config/avr/avr.md"
( 1)))
                    return NULL;
                  return gen_split_322 (insn, operands);

                case 7:
                  if (!(
#line 3650 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed) && 
#line 3652 "../../gcc/config/avr/avr.md"
( 1)))
                    return NULL;
                  return gen_split_330 (insn, operands);

                case 8:
                  if (!(
#line 3650 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed) && 
#line 3652 "../../gcc/config/avr/avr.md"
( 1)))
                    return NULL;
                  return gen_split_326 (insn, operands);

                case 9:
                  if (!(
#line 3650 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed) && 
#line 3652 "../../gcc/config/avr/avr.md"
( 1)))
                    return NULL;
                  return gen_split_334 (insn, operands);

                default:
                  return NULL;
                }

            case REG:
            case SUBREG:
              if (GET_CODE (x8) == REG
                  && REGNO (x8) == 24)
                {
                  res = split_30 (x1, insn);
                  if (res != NULL_RTX)
                    return res;
                }
              operands[1] = x8;
              switch (pattern267 (x1))
                {
                case 0:
                  if (!(
#line 3407 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed) && 
#line 3409 "../../gcc/config/avr/avr.md"
( 1)))
                    return NULL;
                  return gen_split_312 (insn, operands);

                case 1:
                  if (!(
#line 4201 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed) && 
#line 4203 "../../gcc/config/avr/avr.md"
( 1)))
                    return NULL;
                  return gen_split_356 (insn, operands);

                default:
                  return NULL;
                }

            case SIGN_EXTEND:
              if (REGNO (x7) != 26
                  || GET_MODE (x7) != E_HImode)
                return NULL;
              if (REGNO (x4) == 18)
                {
                  switch (pattern307 (x1))
                    {
                    case 0:
                      if ((
#line 3539 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed) && 
#line 3541 "../../gcc/config/avr/avr.md"
( 1)))
                        return gen_split_316 (insn, operands);
                      break;

                    case 1:
                      if ((
#line 3539 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed) && 
#line 3541 "../../gcc/config/avr/avr.md"
( 1)))
                        return gen_split_317 (insn, operands);
                      break;

                    case 2:
                      if ((
#line 4182 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed) && 
#line 4184 "../../gcc/config/avr/avr.md"
( 1)))
                        return gen_split_355 (insn, operands);
                      break;

                    case 3:
                      if ((
#line 3650 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed) && 
#line 3652 "../../gcc/config/avr/avr.md"
( 1)))
                        return gen_split_319 (insn, operands);
                      break;

                    case 4:
                      if ((
#line 3650 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed) && 
#line 3652 "../../gcc/config/avr/avr.md"
( 1)))
                        return gen_split_327 (insn, operands);
                      break;

                    case 5:
                      if ((
#line 3650 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed) && 
#line 3652 "../../gcc/config/avr/avr.md"
( 1)))
                        return gen_split_323 (insn, operands);
                      break;

                    case 6:
                      if ((
#line 3650 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed) && 
#line 3652 "../../gcc/config/avr/avr.md"
( 1)))
                        return gen_split_331 (insn, operands);
                      break;

                    case 7:
                      if ((
#line 3650 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed) && 
#line 3652 "../../gcc/config/avr/avr.md"
( 1)))
                        return gen_split_321 (insn, operands);
                      break;

                    case 8:
                      if ((
#line 3650 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed) && 
#line 3652 "../../gcc/config/avr/avr.md"
( 1)))
                        return gen_split_329 (insn, operands);
                      break;

                    case 9:
                      if ((
#line 3650 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed) && 
#line 3652 "../../gcc/config/avr/avr.md"
( 1)))
                        return gen_split_325 (insn, operands);
                      break;

                    case 10:
                      if ((
#line 3650 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed) && 
#line 3652 "../../gcc/config/avr/avr.md"
( 1)))
                        return gen_split_333 (insn, operands);
                      break;

                    default:
                      break;
                    }
                }
              x9 = XEXP (x8, 0);
              if (GET_CODE (x9) != REG
                  || pattern308 (x1) != 0
                  || !(
#line 675 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && AVR_HAVE_MUL) && 
#line 678 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
                return NULL;
              return gen_split_1963 (insn, operands);

            case NOT:
              if (pattern247 (x1) != 0
                  || !(
#line 3598 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed) && 
#line 3600 "../../gcc/config/avr/avr.md"
( 1)))
                return NULL;
              return gen_split_318 (insn, operands);

            default:
              return NULL;
            }

        case UDIV:
          x8 = XEXP (x5, 0);
          if (GET_CODE (x8) != REG)
            return NULL;
          x10 = XEXP (x5, 1);
          if (GET_CODE (x10) != REG)
            return NULL;
          x11 = XEXP (x3, 0);
          if (GET_CODE (x11) != REG)
            return NULL;
          switch (REGNO (x8))
            {
            case 24:
              switch (pattern278 (x1))
                {
                case 0:
                  if (!
#line 3971 "../../gcc/config/avr/avr.md"
( reload_completed))
                    return NULL;
                  return gen_split_348 (insn, operands);

                case 1:
                  if (!
#line 610 "../../gcc/config/avr/avr-fixed.md"
( reload_completed))
                    return NULL;
                  return gen_split_1842 (insn, operands);

                case 2:
                  if (!
#line 610 "../../gcc/config/avr/avr-fixed.md"
( reload_completed))
                    return NULL;
                  return gen_split_1844 (insn, operands);

                default:
                  return NULL;
                }

            case 26:
              switch (pattern281 (x1))
                {
                case 0:
                  if (!
#line 562 "../../gcc/config/avr/avr-fixed.md"
( reload_completed))
                    return NULL;
                  return gen_split_1834 (insn, operands);

                case 1:
                  if (!
#line 562 "../../gcc/config/avr/avr-fixed.md"
( reload_completed))
                    return NULL;
                  return gen_split_1836 (insn, operands);

                case 2:
                  if (!
#line 562 "../../gcc/config/avr/avr-fixed.md"
( reload_completed))
                    return NULL;
                  return gen_split_1838 (insn, operands);

                case 3:
                  if (!
#line 562 "../../gcc/config/avr/avr-fixed.md"
( reload_completed))
                    return NULL;
                  return gen_split_1840 (insn, operands);

                default:
                  return NULL;
                }

            default:
              return NULL;
            }

        case XOR:
          switch (pattern185 (x1))
            {
            case 0:
              if (!
#line 4919 "../../gcc/config/avr/avr.md"
(optimize
   && reload_completed))
                return NULL;
              return gen_split_387 (insn, operands);

            case 1:
              if (!
#line 4919 "../../gcc/config/avr/avr.md"
(optimize
   && reload_completed))
                return NULL;
              return gen_split_390 (insn, operands);

            case 2:
              if (!
#line 4919 "../../gcc/config/avr/avr.md"
(optimize
   && reload_completed))
                return NULL;
              return gen_split_393 (insn, operands);

            default:
              return NULL;
            }

        case IOR:
          switch (pattern185 (x1))
            {
            case 0:
              if (!
#line 4919 "../../gcc/config/avr/avr.md"
(optimize
   && reload_completed))
                return NULL;
              return gen_split_388 (insn, operands);

            case 1:
              if (!
#line 4919 "../../gcc/config/avr/avr.md"
(optimize
   && reload_completed))
                return NULL;
              return gen_split_391 (insn, operands);

            case 2:
              if (!
#line 4919 "../../gcc/config/avr/avr.md"
(optimize
   && reload_completed))
                return NULL;
              return gen_split_394 (insn, operands);

            default:
              return NULL;
            }

        case AND:
          switch (pattern185 (x1))
            {
            case 0:
              if (!
#line 4919 "../../gcc/config/avr/avr.md"
(optimize
   && reload_completed))
                return NULL;
              return gen_split_389 (insn, operands);

            case 1:
              if (!
#line 4919 "../../gcc/config/avr/avr.md"
(optimize
   && reload_completed))
                return NULL;
              return gen_split_392 (insn, operands);

            case 2:
              if (!
#line 4919 "../../gcc/config/avr/avr.md"
(optimize
   && reload_completed))
                return NULL;
              return gen_split_395 (insn, operands);

            default:
              return NULL;
            }

        case LSHIFTRT:
          switch (pattern187 (x1))
            {
            case 0:
              if (!
#line 5624 "../../gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C2r (operands[2])))
                return NULL;
              return gen_split_468 (insn, operands);

            case 1:
              if (!
#line 5624 "../../gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C4r (operands[2])))
                return NULL;
              return gen_split_471 (insn, operands);

            case 2:
              if (!
#line 5624 "../../gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C3r (operands[2])))
                return NULL;
              return gen_split_474 (insn, operands);

            case 3:
              if (!
#line 5624 "../../gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C2r (operands[2])))
                return NULL;
              return gen_split_477 (insn, operands);

            case 4:
              if (!
#line 5624 "../../gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C2r (operands[2])))
                return NULL;
              return gen_split_480 (insn, operands);

            case 5:
              if (!
#line 5624 "../../gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C2r (operands[2])))
                return NULL;
              return gen_split_483 (insn, operands);

            case 6:
              if (!
#line 5624 "../../gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C2r (operands[2])))
                return NULL;
              return gen_split_486 (insn, operands);

            case 7:
              if (!
#line 5624 "../../gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C4r (operands[2])))
                return NULL;
              return gen_split_489 (insn, operands);

            case 8:
              if (!
#line 5624 "../../gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C4r (operands[2])))
                return NULL;
              return gen_split_492 (insn, operands);

            case 9:
              if (!
#line 5624 "../../gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C4r (operands[2])))
                return NULL;
              return gen_split_495 (insn, operands);

            case 10:
              if (!
#line 5624 "../../gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C4r (operands[2])))
                return NULL;
              return gen_split_498 (insn, operands);

            default:
              return NULL;
            }

        case ASHIFTRT:
          switch (pattern187 (x1))
            {
            case 0:
              if (!
#line 5624 "../../gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C2a (operands[2])))
                return NULL;
              return gen_split_469 (insn, operands);

            case 1:
              if (!
#line 5624 "../../gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C4a (operands[2])))
                return NULL;
              return gen_split_472 (insn, operands);

            case 2:
              if (!
#line 5624 "../../gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C3a (operands[2])))
                return NULL;
              return gen_split_475 (insn, operands);

            case 3:
              if (!
#line 5624 "../../gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C2a (operands[2])))
                return NULL;
              return gen_split_478 (insn, operands);

            case 4:
              if (!
#line 5624 "../../gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C2a (operands[2])))
                return NULL;
              return gen_split_481 (insn, operands);

            case 5:
              if (!
#line 5624 "../../gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C2a (operands[2])))
                return NULL;
              return gen_split_484 (insn, operands);

            case 6:
              if (!
#line 5624 "../../gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C2a (operands[2])))
                return NULL;
              return gen_split_487 (insn, operands);

            case 7:
              if (!
#line 5624 "../../gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C4a (operands[2])))
                return NULL;
              return gen_split_490 (insn, operands);

            case 8:
              if (!
#line 5624 "../../gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C4a (operands[2])))
                return NULL;
              return gen_split_493 (insn, operands);

            case 9:
              if (!
#line 5624 "../../gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C4a (operands[2])))
                return NULL;
              return gen_split_496 (insn, operands);

            case 10:
              if (!
#line 5624 "../../gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C4a (operands[2])))
                return NULL;
              return gen_split_499 (insn, operands);

            default:
              return NULL;
            }

        case ASHIFT:
          switch (pattern187 (x1))
            {
            case 0:
              if (!
#line 5624 "../../gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C2l (operands[2])))
                return NULL;
              return gen_split_470 (insn, operands);

            case 1:
              if (!
#line 5624 "../../gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C4l (operands[2])))
                return NULL;
              return gen_split_473 (insn, operands);

            case 2:
              if (!
#line 5624 "../../gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C3l (operands[2])))
                return NULL;
              return gen_split_476 (insn, operands);

            case 3:
              if (!
#line 5624 "../../gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C2l (operands[2])))
                return NULL;
              return gen_split_479 (insn, operands);

            case 4:
              if (!
#line 5624 "../../gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C2l (operands[2])))
                return NULL;
              return gen_split_482 (insn, operands);

            case 5:
              if (!
#line 5624 "../../gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C2l (operands[2])))
                return NULL;
              return gen_split_485 (insn, operands);

            case 6:
              if (!
#line 5624 "../../gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C2l (operands[2])))
                return NULL;
              return gen_split_488 (insn, operands);

            case 7:
              if (!
#line 5624 "../../gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C4l (operands[2])))
                return NULL;
              return gen_split_491 (insn, operands);

            case 8:
              if (!
#line 5624 "../../gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C4l (operands[2])))
                return NULL;
              return gen_split_494 (insn, operands);

            case 9:
              if (!
#line 5624 "../../gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C4l (operands[2])))
                return NULL;
              return gen_split_497 (insn, operands);

            case 10:
              if (!
#line 5624 "../../gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C4l (operands[2])))
                return NULL;
              return gen_split_500 (insn, operands);

            default:
              return NULL;
            }

        case TRUNCATE:
          if (pattern107 (x3, 
24, 
E_HImode) != 0)
            return NULL;
          x6 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x6) != CLOBBER)
            return NULL;
          x7 = XEXP (x6, 0);
          if (GET_CODE (x7) != REG
              || pattern313 (x1, 
E_QImode, 
26, 
22) != 0)
            return NULL;
          x8 = XEXP (x5, 0);
          switch (pattern357 (x8))
            {
            case 0:
              if (!
#line 9479 "../../gcc/config/avr/avr.md"
( reload_completed))
                return NULL;
              return gen_split_649 (insn, operands);

            case 1:
              if (!
#line 9551 "../../gcc/config/avr/avr.md"
( reload_completed))
                return NULL;
              return gen_split_651 (insn, operands);

            default:
              return NULL;
            }

        case DIV:
          x8 = XEXP (x5, 0);
          if (GET_CODE (x8) != REG)
            return NULL;
          x10 = XEXP (x5, 1);
          if (GET_CODE (x10) != REG)
            return NULL;
          x11 = XEXP (x3, 0);
          if (GET_CODE (x11) != REG)
            return NULL;
          x6 = XVECEXP (x1, 0, 1);
          if (pattern100 (x6, 
26, 
E_HImode) != 0)
            return NULL;
          switch (REGNO (x8))
            {
            case 26:
              if (REGNO (x10) != 22
                  || REGNO (x11) != 24)
                return NULL;
              switch (pattern279 (x1, 
E_QImode, 
21))
                {
                case 0:
                  if (!
#line 562 "../../gcc/config/avr/avr-fixed.md"
( reload_completed))
                    return NULL;
                  return gen_split_1835 (insn, operands);

                case 1:
                  if (!
#line 562 "../../gcc/config/avr/avr-fixed.md"
( reload_completed))
                    return NULL;
                  return gen_split_1837 (insn, operands);

                case 2:
                  if (!
#line 562 "../../gcc/config/avr/avr-fixed.md"
( reload_completed))
                    return NULL;
                  return gen_split_1839 (insn, operands);

                case 3:
                  if (!
#line 562 "../../gcc/config/avr/avr-fixed.md"
( reload_completed))
                    return NULL;
                  return gen_split_1841 (insn, operands);

                default:
                  return NULL;
                }

            case 24:
              if (REGNO (x10) != 18
                  || REGNO (x11) != 22)
                return NULL;
              switch (pattern276 (x1))
                {
                case 0:
                  if (!
#line 610 "../../gcc/config/avr/avr-fixed.md"
( reload_completed))
                    return NULL;
                  return gen_split_1843 (insn, operands);

                case 1:
                  if (!
#line 610 "../../gcc/config/avr/avr-fixed.md"
( reload_completed))
                    return NULL;
                  return gen_split_1845 (insn, operands);

                default:
                  return NULL;
                }

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case UNSPEC_VOLATILE:
      if (XVECLEN (x3, 0) != 2
          || XINT (x3, 1) != 10)
        return NULL;
      x12 = XVECEXP (x3, 0, 1);
      if (GET_CODE (x12) != CONST_INT)
        return NULL;
      x6 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x6) != SET)
        return NULL;
      x13 = XEXP (x6, 1);
      if (pattern103 (x13) != 0)
        return NULL;
      x14 = XVECEXP (x3, 0, 0);
      operands[0] = x14;
      switch (pattern248 (x1))
        {
        case 0:
          if (!
#line 8751 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_624 (insn, operands);

        case 1:
          if (!
#line 8783 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_625 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}
