/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern7 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i1))
    return -1;
  return pattern6 (); /* [-1, 3] */
}

int
pattern10 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !nonmemory_operand (operands[3], i1)
      || !register_operand (operands[4], i1))
    return -1;
  return pattern9 (); /* [-1, 3] */
}

int
pattern16 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x1, 0);
  operands[0] = x4;
  if (!register_operand (operands[0], E_HImode)
      || GET_MODE (x2) != E_HImode)
    return -1;
  x5 = XEXP (x3, 0);
  operands[1] = x5;
  if (!register_operand (operands[1], E_QImode))
    return -1;
  return 0;
}

int
pattern19 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_SImode)
      || GET_MODE (x1) != E_SImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_QImode:
      if (!combine_pseudo_register_operand (operands[1], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!combine_pseudo_register_operand (operands[1], E_HImode))
        return -1;
      return 1;

    case E_PSImode:
      if (!combine_pseudo_register_operand (operands[1], E_PSImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern26 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG)
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_CODE (x4) != REG)
    return -1;
  x5 = XEXP (x1, 0);
  if (GET_CODE (x5) != REG)
    return -1;
  switch (REGNO (x3))
    {
    case 25:
      if (REGNO (x4) != 22
          || REGNO (x5) != 24)
        return -1;
      switch (GET_MODE (x5))
        {
        case E_QQmode:
          if (GET_MODE (x2) != E_QQmode
              || GET_MODE (x3) != E_QQmode
              || GET_MODE (x4) != E_QQmode)
            return -1;
          return 0;

        case E_UQQmode:
          if (GET_MODE (x2) != E_UQQmode
              || GET_MODE (x3) != E_UQQmode
              || GET_MODE (x4) != E_UQQmode)
            return -1;
          return 1;

        default:
          return -1;
        }

    case 26:
      res = pattern24 (x1, 
22);
      if (res >= 0)
        return res + 2; /* [2, 5] */
      return -1;

    case 24:
      if (REGNO (x4) != 18)
        return -1;
      res = pattern25 (x1, 
22);
      if (res >= 0)
        return res + 6; /* [6, 7] */
      return -1;

    default:
      return -1;
    }
}

int
pattern35 (rtx x1, machine_mode i1, unsigned int i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != i2
      || GET_MODE (x4) != i1
      || pattern34 (x1, 
E_HImode, 
24) != 0)
    return -1;
  return 0;
}

int
pattern39 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
      operands[1] = x5;
      if (!register_operand (operands[1], E_QImode))
        return -1;
      return 0;

    case AND:
      x6 = XEXP (x5, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      res = pattern38 (x3);
      if (res >= 0)
        return res + 1; /* [1, 6] */
      return -1;

    default:
      return -1;
    }
}

int
pattern47 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x2, 1);
  operands[3] = x5;
  return pattern46 (x1); /* [-1, 5] */
}

int
pattern50 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x1, 0);
  operands[0] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x2) != E_HImode
          || !combine_pseudo_register_operand (operands[1], E_QImode))
        return -1;
      return 0;

    case E_PSImode:
      res = pattern18 (x2);
      if (res >= 0)
        return res + 1; /* [1, 2] */
      return -1;

    case E_SImode:
      res = pattern19 (x2);
      if (res >= 0)
        return res + 3; /* [3, 5] */
      return -1;

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x2) != E_DImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 6;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 7;

        case E_SImode:
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 8;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern62 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  x3 = XEXP (x1, 1);
  operands[2] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_QQmode:
      return pattern61 (x1, 
E_QQmode); /* [-1, 0] */

    case E_HQmode:
      if (pattern61 (x1, 
E_HQmode) != 0)
        return -1;
      return 1;

    case E_HAmode:
      if (pattern61 (x1, 
E_HAmode) != 0)
        return -1;
      return 2;

    case E_SAmode:
      if (pattern61 (x1, 
E_SAmode) != 0)
        return -1;
      return 3;

    case E_SQmode:
      if (pattern61 (x1, 
E_SQmode) != 0)
        return -1;
      return 4;

    default:
      return -1;
    }
}

int
pattern69 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_HImode)
    return -1;
  x4 = XEXP (x1, 0);
  operands[0] = x4;
  if (!register_operand (operands[0], E_HImode)
      || GET_MODE (x2) != E_HImode)
    return -1;
  x5 = XEXP (x2, 0);
  operands[1] = x5;
  if (!register_operand (operands[1], E_HImode))
    return -1;
  x6 = XEXP (x3, 0);
  operands[2] = x6;
  if (!register_operand (operands[2], E_QImode))
    return -1;
  return 0;
}

int
pattern73 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (REGNO (x3) != 18)
    return -1;
  x4 = XEXP (x1, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 18)
    return -1;
  x5 = XEXP (x2, 1);
  switch (GET_CODE (x5))
    {
    case REG:
      return pattern70 (x1); /* [-1, 6] */

    case CONST_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
      res = pattern71 (x1);
      if (res >= 0)
        return res + 7; /* [7, 13] */
      return -1;

    default:
      return -1;
    }
}

int
pattern75 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 1);
  operands[2] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      return pattern61 (x3, 
E_QImode); /* [-1, 0] */

    case E_HImode:
      if (pnum_clobbers == NULL
          || pattern61 (x3, 
E_HImode) != 0)
        return -1;
      return 1;

    case E_PSImode:
      if (pattern53 (x3, pnum_clobbers, 
E_PSImode) != 0)
        return -1;
      return 2;

    case E_SImode:
      if (pnum_clobbers == NULL
          || pattern61 (x3, 
E_SImode) != 0)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern83 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case REG:
    case SUBREG:
      operands[1] = x3;
      x4 = XEXP (x2, 1);
      if (GET_CODE (x4) != CONST_INT)
        return -1;
      return 0;

    case ZERO_EXTEND:
      x5 = XEXP (x3, 0);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
          operands[1] = x5;
          x4 = XEXP (x2, 1);
          if (GET_CODE (x4) != CONST_INT)
            return -1;
          return 1;

        case AND:
          res = pattern2 (x1);
          if (res >= 0)
            return res + 2; /* [2, 7] */
          return -1;

        default:
          return -1;
        }

    case SIGN_EXTEND:
      x5 = XEXP (x3, 0);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
          operands[1] = x5;
          if (!register_operand (operands[1], E_QImode))
            return -1;
          x4 = XEXP (x2, 1);
          if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 8]
              || !register_operand (operands[0], E_HImode)
              || GET_MODE (x1) != E_HImode
              || GET_MODE (x2) != E_HImode
              || GET_MODE (x3) != E_HImode)
            return -1;
          x6 = XEXP (x1, 1);
          res = pattern82 (x6);
          if (res >= 0)
            return res + 8; /* [8, 9] */
          return -1;

        case AND:
          res = pattern2 (x1);
          if (res >= 0)
            return res + 10; /* [10, 15] */
          return -1;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern95 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != ZERO_EXTRACT
      || GET_MODE (x2) != E_QImode)
    return -1;
  x3 = XEXP (x2, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x4 = XEXP (x2, 0);
  operands[0] = x4;
  if (!register_operand (operands[0], E_QImode))
    return -1;
  x5 = XEXP (x2, 2);
  operands[1] = x5;
  if (!const_0_to_7_operand (operands[1], E_QImode))
    return -1;
  x6 = XEXP (x1, 1);
  x7 = XEXP (x6, 0);
  operands[2] = x7;
  if (!register_operand (operands[2], E_QImode))
    return -1;
  return 0;
}

int
pattern101 (rtx x1, unsigned int i1, machine_mode i2, machine_mode i3, unsigned int i4)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i3)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != i4
      || GET_MODE (x4) != i3)
    return -1;
  x5 = XEXP (x2, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != i4
      || GET_MODE (x5) != i3)
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  return pattern100 (x6, 
i1, 
i2); /* [-1, 0] */
}

int
pattern108 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !nonmemory_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern114 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !const_int_operand (operands[2], E_QImode)
      || !scratch_or_dreg_operand (operands[3], E_QImode))
    return -1;
  return 0;
}

int
pattern120 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_QImode)
    return -1;
  x3 = XEXP (x2, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  return pattern41 (x1); /* [-1, 1] */
}

int
pattern123 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  switch (SUBREG_BYTE (x1))
    {
    case 0:
      x2 = XEXP (x1, 0);
      switch (GET_CODE (x2))
        {
        case ASHIFT:
          if (GET_MODE (x2) != E_HImode)
            return -1;
          x3 = XEXP (x2, 1);
          operands[2] = x3;
          if (!register_operand (operands[2], E_QImode))
            return -1;
          x4 = XEXP (x2, 0);
          switch (GET_CODE (x4))
            {
            case SIGN_EXTEND:
              if (GET_MODE (x4) != E_HImode)
                return -1;
              x5 = XEXP (x4, 0);
              operands[1] = x5;
              if (!register_operand (operands[1], E_QImode))
                return -1;
              return 0;

            case ZERO_EXTEND:
              if (GET_MODE (x4) != E_HImode)
                return -1;
              x5 = XEXP (x4, 0);
              operands[1] = x5;
              if (!register_operand (operands[1], E_QImode))
                return -1;
              return 1;

            case REG:
            case SUBREG:
              operands[1] = x4;
              if (!register_operand (operands[1], E_HImode)
                  || !nonimmediate_operand (operands[0], E_QImode))
                return -1;
              return 2;

            default:
              return -1;
            }

        case ASHIFTRT:
          if (GET_MODE (x2) != E_HImode)
            return -1;
          x4 = XEXP (x2, 0);
          if (GET_CODE (x4) != CONST_INT
              || XWINT (x4, 0) != 128L)
            return -1;
          x3 = XEXP (x2, 1);
          if (GET_CODE (x3) != AND
              || GET_MODE (x3) != E_QImode)
            return -1;
          x6 = XEXP (x3, 1);
          if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 7]
              || !register_operand (operands[0], E_QImode))
            return -1;
          x7 = XEXP (x3, 0);
          operands[1] = x7;
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 3;

        case ZERO_EXTRACT:
          x3 = XEXP (x2, 1);
          if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 1]
              || !register_operand (operands[0], E_QImode))
            return -1;
          x4 = XEXP (x2, 0);
          operands[1] = x4;
          x8 = XEXP (x2, 2);
          operands[2] = x8;
          switch (GET_MODE (x2))
            {
            case E_HImode:
              if (!register_operand (operands[1], E_HImode)
                  || !const_0_to_15_operand (operands[2], E_QImode))
                return -1;
              return 4;

            case E_PSImode:
              if (!register_operand (operands[1], E_PSImode)
                  || !const_0_to_23_operand (operands[2], E_QImode))
                return -1;
              return 5;

            case E_SImode:
              if (!register_operand (operands[1], E_SImode)
                  || !const_0_to_31_operand (operands[2], E_QImode))
                return -1;
              return 6;

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 2:
      x2 = XEXP (x1, 0);
      if (GET_CODE (x2) != LO_SUM
          || GET_MODE (x2) != E_PSImode
          || !register_operand (operands[0], E_QImode))
        return -1;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      if (!nonmemory_operand (operands[1], E_QImode))
        return -1;
      x3 = XEXP (x2, 1);
      operands[2] = x3;
      if (!register_operand (operands[2], E_HImode))
        return -1;
      return 7;

    default:
      return -1;
    }
}

int
pattern150 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (REGNO (x3) != 22)
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 18)
    return -1;
  x5 = XEXP (x1, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 22)
    return -1;
  return 0;
}

int
pattern153 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nop_general_operand (operands[2], E_QImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      if (!register_operand (operands[0], E_QImode)
          || GET_MODE (x1) != E_QImode
          || !register_operand (operands[1], E_QImode))
        return -1;
      return 0;

    case E_QQmode:
      if (!register_operand (operands[0], E_QQmode)
          || GET_MODE (x1) != E_QQmode
          || !register_operand (operands[1], E_QQmode))
        return -1;
      return 1;

    case E_UQQmode:
      if (!register_operand (operands[0], E_UQQmode)
          || GET_MODE (x1) != E_UQQmode
          || !register_operand (operands[1], E_UQQmode))
        return -1;
      return 2;

    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x1) != E_HImode
          || !register_operand (operands[1], E_HImode))
        return -1;
      return 3;

    case E_HQmode:
      if (!register_operand (operands[0], E_HQmode)
          || GET_MODE (x1) != E_HQmode
          || !register_operand (operands[1], E_HQmode))
        return -1;
      return 4;

    case E_UHQmode:
      if (!register_operand (operands[0], E_UHQmode)
          || GET_MODE (x1) != E_UHQmode
          || !register_operand (operands[1], E_UHQmode))
        return -1;
      return 5;

    case E_HAmode:
      if (!register_operand (operands[0], E_HAmode)
          || GET_MODE (x1) != E_HAmode
          || !register_operand (operands[1], E_HAmode))
        return -1;
      return 6;

    case E_UHAmode:
      if (!register_operand (operands[0], E_UHAmode)
          || GET_MODE (x1) != E_UHAmode
          || !register_operand (operands[1], E_UHAmode))
        return -1;
      return 7;

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode
          || !register_operand (operands[1], E_SImode))
        return -1;
      return 8;

    case E_SQmode:
      if (!register_operand (operands[0], E_SQmode)
          || GET_MODE (x1) != E_SQmode
          || !register_operand (operands[1], E_SQmode))
        return -1;
      return 9;

    case E_USQmode:
      if (!register_operand (operands[0], E_USQmode)
          || GET_MODE (x1) != E_USQmode
          || !register_operand (operands[1], E_USQmode))
        return -1;
      return 10;

    case E_SAmode:
      if (!register_operand (operands[0], E_SAmode)
          || GET_MODE (x1) != E_SAmode
          || !register_operand (operands[1], E_SAmode))
        return -1;
      return 11;

    case E_USAmode:
      if (!register_operand (operands[0], E_USAmode)
          || GET_MODE (x1) != E_USAmode
          || !register_operand (operands[1], E_USAmode))
        return -1;
      return 12;

    default:
      return -1;
    }
}

int
pattern182 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != E_HImode)
    return -1;
  x5 = XEXP (x2, 0);
  operands[0] = x5;
  if (!register_operand (operands[0], E_HImode)
      || GET_MODE (x3) != E_HImode)
    return -1;
  x6 = XEXP (x4, 0);
  operands[1] = x6;
  if (!register_operand (operands[1], E_QImode))
    return -1;
  x7 = XEXP (x3, 1);
  operands[2] = x7;
  x8 = XVECEXP (x1, 0, 1);
  x9 = XEXP (x8, 0);
  operands[3] = x9;
  if (!scratch_operand (operands[3], E_QImode))
    return -1;
  return 0;
}

int
pattern189 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_PSImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 22
      || GET_MODE (x4) != E_PSImode)
    return -1;
  x5 = XEXP (x3, 1);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 18
      || GET_MODE (x5) != E_PSImode)
    return -1;
  x6 = XEXP (x2, 0);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 22
      || GET_MODE (x6) != E_PSImode)
    return -1;
  x7 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x7) != SET)
    return -1;
  x8 = XEXP (x7, 1);
  if (GET_CODE (x8) != i1
      || GET_MODE (x8) != E_PSImode)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_CODE (x9) != REG
      || REGNO (x9) != 22
      || GET_MODE (x9) != E_PSImode)
    return -1;
  x10 = XEXP (x8, 1);
  if (GET_CODE (x10) != REG
      || REGNO (x10) != 18
      || GET_MODE (x10) != E_PSImode)
    return -1;
  x11 = XEXP (x7, 0);
  if (GET_CODE (x11) != REG
      || REGNO (x11) != 18
      || GET_MODE (x11) != E_PSImode)
    return -1;
  x12 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x12) != CLOBBER)
    return -1;
  x13 = XEXP (x12, 0);
  if (GET_CODE (x13) != REG
      || REGNO (x13) != 21
      || GET_MODE (x13) != E_QImode
      || pattern188 (x1, 
E_QImode, 
26, 
25) != 0)
    return -1;
  return 0;
}

int
pattern203 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x1) != E_HImode
          || !register_operand (operands[1], E_HImode))
        return -1;
      return 0;

    case E_PSImode:
      if (!register_operand (operands[0], E_PSImode)
          || GET_MODE (x1) != E_PSImode
          || !register_operand (operands[1], E_PSImode))
        return -1;
      return 1;

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode
          || !register_operand (operands[1], E_SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern210 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 36
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  if (!register_operand (operands[0], i1))
    return -1;
  return 0;
}

int
pattern215 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !nonmemory_or_const_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern220 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != ZERO_EXTEND
      || GET_MODE (x2) != E_HImode
      || pattern219 (x1, 
E_HImode) != 0)
    return -1;
  return 0;
}

int
pattern222 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  switch (GET_MODE (operands[2]))
    {
    case E_QImode:
      if (!register_operand (operands[2], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!register_operand (operands[2], E_HImode))
        return -1;
      return 1;

    case E_PSImode:
      if (!register_operand (operands[2], E_PSImode))
        return -1;
      return 2;

    case E_SImode:
      if (!register_operand (operands[2], E_SImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern231 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_HImode)
      || GET_MODE (x1) != E_HImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_HImode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_HImode
      || !register_operand (operands[1], E_QImode))
    return -1;
  x4 = XEXP (x1, 1);
  return pattern82 (x4); /* [-1, 1] */
}

int
pattern235 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_HImode
      || !register_operand (operands[0], E_HImode)
      || GET_MODE (x1) != E_HImode
      || GET_MODE (x2) != E_HImode)
    return -1;
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], E_QImode)
      || !register_operand (operands[3], E_HImode))
    return -1;
  return 0;
}

int
pattern238 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 36
      || GET_MODE (x3) != E_CCmode)
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      if (!register_operand (operands[0], E_QImode))
        return -1;
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      if (GET_MODE (x5) != E_QImode
          || !register_operand (operands[1], E_QImode))
        return -1;
      return 0;

    case E_QQmode:
      if (!register_operand (operands[0], E_QQmode))
        return -1;
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      if (GET_MODE (x5) != E_QQmode
          || !register_operand (operands[1], E_QQmode))
        return -1;
      return 1;

    case E_UQQmode:
      if (!register_operand (operands[0], E_UQQmode))
        return -1;
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      if (GET_MODE (x5) != E_UQQmode
          || !register_operand (operands[1], E_UQQmode))
        return -1;
      return 2;

    case E_HImode:
      if (!register_operand (operands[0], E_HImode))
        return -1;
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      if (GET_MODE (x5) != E_HImode
          || !register_operand (operands[1], E_HImode))
        return -1;
      return 3;

    case E_HQmode:
      if (!register_operand (operands[0], E_HQmode))
        return -1;
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      if (GET_MODE (x5) != E_HQmode
          || !register_operand (operands[1], E_HQmode))
        return -1;
      return 4;

    case E_UHQmode:
      if (!register_operand (operands[0], E_UHQmode))
        return -1;
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      if (GET_MODE (x5) != E_UHQmode
          || !register_operand (operands[1], E_UHQmode))
        return -1;
      return 5;

    case E_HAmode:
      if (!register_operand (operands[0], E_HAmode))
        return -1;
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      if (GET_MODE (x5) != E_HAmode
          || !register_operand (operands[1], E_HAmode))
        return -1;
      return 6;

    case E_UHAmode:
      if (!register_operand (operands[0], E_UHAmode))
        return -1;
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      if (GET_MODE (x5) != E_UHAmode
          || !register_operand (operands[1], E_UHAmode))
        return -1;
      return 7;

    case E_SImode:
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      if (GET_MODE (x5) != E_SImode
          || !register_operand (operands[1], E_SImode))
        return -1;
      return 8;

    case E_SQmode:
      if (!register_operand (operands[0], E_SQmode))
        return -1;
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      if (GET_MODE (x5) != E_SQmode
          || !register_operand (operands[1], E_SQmode))
        return -1;
      return 9;

    case E_USQmode:
      if (!register_operand (operands[0], E_USQmode))
        return -1;
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      if (GET_MODE (x5) != E_USQmode
          || !register_operand (operands[1], E_USQmode))
        return -1;
      return 10;

    case E_SAmode:
      if (!register_operand (operands[0], E_SAmode))
        return -1;
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      if (GET_MODE (x5) != E_SAmode
          || !register_operand (operands[1], E_SAmode))
        return -1;
      return 11;

    case E_USAmode:
      if (!register_operand (operands[0], E_USAmode))
        return -1;
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      if (GET_MODE (x5) != E_USAmode
          || !register_operand (operands[1], E_USAmode))
        return -1;
      return 12;

    default:
      return -1;
    }
}

int
pattern271 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!pseudo_register_or_const_int_operand (operands[2], E_SImode))
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_QImode:
      if (!pseudo_register_operand (operands[1], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!pseudo_register_operand (operands[1], E_HImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern275 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  switch (GET_MODE (x2))
    {
    case E_SAmode:
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_SAmode)
        return -1;
      x4 = XEXP (x3, 0);
      if (GET_MODE (x4) != E_SAmode)
        return -1;
      x5 = XEXP (x3, 1);
      if (GET_MODE (x5) != E_SAmode)
        return -1;
      return 0;

    case E_USAmode:
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_USAmode)
        return -1;
      x4 = XEXP (x3, 0);
      if (GET_MODE (x4) != E_USAmode)
        return -1;
      x5 = XEXP (x3, 1);
      if (GET_MODE (x5) != E_USAmode)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern286 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (REGNO (x4) != 26)
    return -1;
  x5 = XEXP (x2, 0);
  if (REGNO (x5) != 24)
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 0);
  if (REGNO (x7) != 22
      || GET_MODE (x7) != E_HImode)
    return -1;
  return pattern244 (x2); /* [-1, 3] */
}

int
pattern292 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 1);
  operands[2] = x5;
  x6 = XEXP (x3, 1);
  x7 = XEXP (x6, 0);
  operands[3] = x7;
  x8 = XVECEXP (x1, 0, 1);
  x9 = XEXP (x8, 0);
  operands[4] = x9;
  if (!scratch_operand (operands[4], E_QImode))
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_SImode:
      if (!register_operand (operands[1], E_SImode)
          || !nonmemory_operand (operands[2], E_SImode))
        return -1;
      return 0;

    case E_SQmode:
      if (!register_operand (operands[1], E_SQmode)
          || !nonmemory_operand (operands[2], E_SQmode))
        return -1;
      return 1;

    case E_USQmode:
      if (!register_operand (operands[1], E_USQmode)
          || !nonmemory_operand (operands[2], E_USQmode))
        return -1;
      return 2;

    case E_SAmode:
      if (!register_operand (operands[1], E_SAmode)
          || !nonmemory_operand (operands[2], E_SAmode))
        return -1;
      return 3;

    case E_USAmode:
      if (!register_operand (operands[1], E_USAmode)
          || !nonmemory_operand (operands[2], E_USAmode))
        return -1;
      return 4;

    case E_PSImode:
      if (!register_operand (operands[1], E_PSImode)
          || !nonmemory_operand (operands[2], E_PSImode))
        return -1;
      return 5;

    case E_HImode:
      if (!register_operand (operands[1], E_HImode)
          || !nonmemory_operand (operands[2], E_HImode))
        return -1;
      return 6;

    case E_HQmode:
      if (!register_operand (operands[1], E_HQmode)
          || !nonmemory_operand (operands[2], E_HQmode))
        return -1;
      return 7;

    case E_UHQmode:
      if (!register_operand (operands[1], E_UHQmode)
          || !nonmemory_operand (operands[2], E_UHQmode))
        return -1;
      return 8;

    case E_HAmode:
      if (!register_operand (operands[1], E_HAmode)
          || !nonmemory_operand (operands[2], E_HAmode))
        return -1;
      return 9;

    case E_UHAmode:
      if (!register_operand (operands[1], E_UHAmode)
          || !nonmemory_operand (operands[2], E_UHAmode))
        return -1;
      return 10;

    default:
      return -1;
    }
}

int
pattern313 (rtx x1, machine_mode i1, unsigned int i2, unsigned int i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  if (REGNO (x3) != i3
      || GET_MODE (x3) != i1)
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  x5 = XEXP (x4, 0);
  if (REGNO (x5) != i2
      || GET_MODE (x5) != i1)
    return -1;
  return 0;
}

int
pattern318 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != CLOBBER)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != 36
      || GET_MODE (x2) != E_CCmode)
    return -1;
  return 0;
}

int
pattern322 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!const_int_operand (operands[2], E_QImode))
    return -1;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  return pattern321 (x1); /* [-1, 9] */
}

int
pattern327 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  operands[1] = x3;
  if (!const_8_16_24_operand (operands[1], E_QImode))
    return -1;
  switch (GET_MODE (x1))
    {
    case E_HImode:
      if (!register_operand (operands[0], E_HImode))
        return -1;
      return 0;

    case E_PSImode:
      if (!register_operand (operands[0], E_PSImode))
        return -1;
      return 1;

    case E_SImode:
      if (!register_operand (operands[0], E_SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern333 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  switch (GET_MODE (x2))
    {
    case E_DImode:
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_DImode)
        return -1;
      return 0;

    case E_DQmode:
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_DQmode)
        return -1;
      return 1;

    case E_UDQmode:
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_UDQmode)
        return -1;
      return 2;

    case E_DAmode:
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_DAmode)
        return -1;
      return 3;

    case E_UDAmode:
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_UDAmode)
        return -1;
      return 4;

    case E_TAmode:
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_TAmode)
        return -1;
      return 5;

    case E_UTAmode:
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_UTAmode)
        return -1;
      return 6;

    default:
      return -1;
    }
}

int
pattern342 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  switch (REGNO (x4))
    {
    case 22:
      if (GET_MODE (x4) != E_HImode)
        return -1;
      x5 = XEXP (x2, 0);
      if (REGNO (x5) != 24
          || GET_MODE (x5) != E_HImode)
        return -1;
      x6 = XVECEXP (x1, 0, 2);
      x7 = XEXP (x6, 0);
      if (REGNO (x7) != 21
          || GET_MODE (x7) != E_QImode
          || GET_MODE (x3) != E_HImode)
        return -1;
      x8 = XEXP (x3, 0);
      if (GET_MODE (x8) != E_HImode)
        return -1;
      x9 = XVECEXP (x1, 0, 1);
      x10 = XEXP (x9, 0);
      if (GET_MODE (x10) != E_HImode)
        return -1;
      return 0;

    case 25:
      if (pattern341 (x1) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern352 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  operands[1] = x1;
  if (!const0_operand (operands[1], i1))
    return -1;
  x2 = PATTERN (peep2_next_insn (1));
  x3 = XEXP (x2, 1);
  return pattern351 (x3); /* [-1, 1] */
}

int
pattern355 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != i1)
    return -1;
  x5 = XVECEXP (x1, 0, 0);
  x6 = XEXP (x5, 1);
  x7 = XEXP (x6, 0);
  x8 = XEXP (x7, 1);
  x9 = XEXP (x8, 0);
  operands[4] = x9;
  x10 = XEXP (x4, 0);
  operands[2] = x10;
  switch (GET_MODE (x7))
    {
    case E_HImode:
      if (!register_operand (operands[3], E_HImode)
          || GET_MODE (x8) != E_HImode
          || !register_operand (operands[4], E_QImode)
          || !register_operand (operands[0], E_HImode)
          || GET_MODE (x3) != E_HImode
          || !register_operand (operands[1], E_HImode)
          || GET_MODE (x4) != E_HImode
          || !register_operand (operands[2], E_QImode))
        return -1;
      return 0;

    case E_PSImode:
      if (!register_operand (operands[3], E_PSImode)
          || GET_MODE (x8) != E_PSImode
          || !register_operand (operands[0], E_PSImode)
          || GET_MODE (x3) != E_PSImode
          || !register_operand (operands[1], E_PSImode)
          || GET_MODE (x4) != E_PSImode)
        return -1;
      switch (GET_MODE (operands[4]))
        {
        case E_QImode:
          if (!register_operand (operands[4], E_QImode)
              || !register_operand (operands[2], E_QImode))
            return -1;
          return 1;

        case E_HImode:
          if (!register_operand (operands[4], E_HImode)
              || !register_operand (operands[2], E_HImode))
            return -1;
          return 2;

        default:
          return -1;
        }

    case E_SImode:
      if (!register_operand (operands[3], E_SImode)
          || GET_MODE (x8) != E_SImode
          || !register_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode
          || !register_operand (operands[1], E_SImode)
          || GET_MODE (x4) != E_SImode)
        return -1;
      switch (GET_MODE (operands[4]))
        {
        case E_QImode:
          if (!register_operand (operands[4], E_QImode)
              || !register_operand (operands[2], E_QImode))
            return -1;
          return 3;

        case E_HImode:
          if (!register_operand (operands[4], E_HImode)
              || !register_operand (operands[2], E_HImode))
            return -1;
          return 4;

        case E_PSImode:
          if (!register_operand (operands[4], E_PSImode)
              || !register_operand (operands[2], E_PSImode))
            return -1;
          return 5;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern387 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != SCRATCH
      || GET_MODE (x3) != E_QImode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 1);
  x6 = XEXP (x5, 0);
  return pattern386 (x6); /* [-1, 2] */
}

int
pattern390 (rtx x1, machine_mode i1, unsigned int i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != CLOBBER)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != i2
      || GET_MODE (x2) != i1)
    return -1;
  return 0;
}

int
pattern394 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x1) != E_HImode
          || GET_MODE (x2) != E_HImode
          || !register_operand (operands[1], E_QImode))
        return -1;
      x4 = PATTERN (peep2_next_insn (2));
      x5 = XEXP (x4, 1);
      x6 = XEXP (x5, 0);
      return pattern392 (x6, 
E_HImode); /* [-1, 5] */

    case E_PSImode:
      if (!register_operand (operands[0], E_PSImode)
          || GET_MODE (x1) != E_PSImode
          || GET_MODE (x2) != E_PSImode
          || !const0_operand (operands[3], E_PSImode))
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QImode:
          x4 = PATTERN (peep2_next_insn (2));
          x5 = XEXP (x4, 1);
          x6 = XEXP (x5, 0);
          res = pattern393 (x6, 
E_QImode);
          if (res >= 0)
            return res + 6; /* [6, 11] */
          return -1;

        case E_HImode:
          x4 = PATTERN (peep2_next_insn (2));
          x5 = XEXP (x4, 1);
          x6 = XEXP (x5, 0);
          res = pattern393 (x6, 
E_HImode);
          if (res >= 0)
            return res + 12; /* [12, 17] */
          return -1;

        default:
          return -1;
        }

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode
          || GET_MODE (x2) != E_SImode
          || !const0_operand (operands[3], E_SImode))
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QImode:
          x4 = PATTERN (peep2_next_insn (2));
          x5 = XEXP (x4, 1);
          x6 = XEXP (x5, 0);
          res = pattern393 (x6, 
E_QImode);
          if (res >= 0)
            return res + 18; /* [18, 23] */
          return -1;

        case E_HImode:
          x4 = PATTERN (peep2_next_insn (2));
          x5 = XEXP (x4, 1);
          x6 = XEXP (x5, 0);
          res = pattern393 (x6, 
E_HImode);
          if (res >= 0)
            return res + 24; /* [24, 29] */
          return -1;

        case E_PSImode:
          x4 = PATTERN (peep2_next_insn (2));
          x5 = XEXP (x4, 1);
          x6 = XEXP (x5, 0);
          res = pattern393 (x6, 
E_PSImode);
          if (res >= 0)
            return res + 30; /* [30, 35] */
          return -1;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_9 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 1);
  operands[2] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      if (pattern193 (x3, 
E_QImode) != 0)
        return -1;
      if (
#line 2209 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
        return 300; /* *mulqi3_enh_split */
      if (pnum_clobbers == NULL
          || !
#line 2222 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 301; /* *mulqi3_enh */

    case E_HImode:
      if (pattern193 (x3, 
E_HImode) != 0)
        return -1;
      if (
#line 3277 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
        return 537; /* *mulhi3_enh_split */
      if (pnum_clobbers == NULL
          || !
#line 3290 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 538; /* *mulhi3_enh */

    case E_SImode:
      if (pattern194 (x3, pnum_clobbers, 
E_SImode) != 0)
        return -1;
      if (pseudo_register_or_const_int_operand (operands[2], E_SImode)
          && 
#line 3407 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed))
        {
          *pnum_clobbers = 2;
          return 541; /* *mulsi3 */
        }
      if (!pseudo_register_operand (operands[2], E_SImode)
          || !
#line 3443 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! AVR_HAVE_MUL
   && ! AVR_TINY
   && ! reload_completed))
        return -1;
      *pnum_clobbers = 3;
      return 542; /* *mulsi3_pr118012 */

    case E_PSImode:
      if (pattern194 (x3, pnum_clobbers, 
E_PSImode) != 0
          || !pseudo_register_or_const_int_operand (operands[2], E_PSImode)
          || !
#line 4201 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed))
        return -1;
      *pnum_clobbers = 2;
      return 601; /* *mulpsi3 */

    case E_QQmode:
      if (pattern193 (x3, 
E_QQmode) != 0)
        return -1;
      if (
#line 296 "../../gcc/config/avr/avr-fixed.md"
(AVR_HAVE_MUL))
        return 3076; /* mulqq3_enh */
      if (pnum_clobbers == NULL
          || !
#line 309 "../../gcc/config/avr/avr-fixed.md"
(AVR_HAVE_MUL && reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 3077; /* *mulqq3_enh */

    case E_UQQmode:
      if (pattern193 (x3, 
E_UQQmode) != 0)
        return -1;
      if (
#line 317 "../../gcc/config/avr/avr-fixed.md"
(AVR_HAVE_MUL))
        return 3078; /* muluqq3_enh */
      if (pnum_clobbers == NULL
          || !
#line 330 "../../gcc/config/avr/avr-fixed.md"
(AVR_HAVE_MUL && reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 3079; /* *muluqq3_enh */

    default:
      return -1;
    }
}

 int
recog_10 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != REG)
    return -1;
  x5 = XEXP (x2, 1);
  if (GET_CODE (x5) != ZERO_EXTEND)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != REG)
    return -1;
  x7 = XEXP (x1, 0);
  if (GET_CODE (x7) != REG)
    return -1;
  switch (REGNO (x4))
    {
    case 22:
      if (GET_MODE (x4) != E_QImode
          || REGNO (x6) != 24
          || pattern298 (x1, 
E_HImode, 
24, 
E_QImode) != 0)
        return -1;
      if (
#line 2441 "../../gcc/config/avr/avr.md"
(!AVR_HAVE_MUL))
        {
          *pnum_clobbers = 2;
          return 476; /* *umulqihi3.call_split */
        }
      if (!
#line 2458 "../../gcc/config/avr/avr.md"
(!AVR_HAVE_MUL && reload_completed))
        return -1;
      *pnum_clobbers = 3;
      return 477; /* *umulqihi3.call */

    case 18:
      if (GET_MODE (x4) != E_SImode
          || REGNO (x6) != 22
          || pattern298 (x1, 
E_DImode, 
18, 
E_SImode) != 0)
        return -1;
      if (
#line 675 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && AVR_HAVE_MUL))
        {
          *pnum_clobbers = 2;
          return 3361; /* umulsidi3_insn */
        }
      if (!
#line 693 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && AVR_HAVE_MUL
   && reload_completed))
        return -1;
      *pnum_clobbers = 3;
      return 3363; /* *umulsidi3_insn */

    default:
      return -1;
    }
}

 int
recog_13 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_HImode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_HImode)
    return -1;
  x4 = XEXP (x2, 1);
  switch (pattern257 (x4, pnum_clobbers))
    {
    case 0:
      if (s8_operand (operands[2], E_HImode)
          && 
#line 2998 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
        {
          *pnum_clobbers = 1;
          return 521; /* *mulsqihi3.sconst */
        }
      if (u8_operand (operands[2], E_HImode)
          && 
#line 3034 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
        {
          *pnum_clobbers = 1;
          return 524; /* *mulsqihi3.uconst */
        }
      if (!o8_operand (operands[2], E_HImode)
          || !
#line 3052 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
        return -1;
      *pnum_clobbers = 1;
      return 525; /* *mulsqihi3.oconst */

    case 1:
      if (
#line 3153 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
        return 531; /* mulsqihi3 */
      if (pnum_clobbers == NULL
          || !
#line 3166 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 532; /* *mulsqihi3 */

    default:
      return -1;
    }
}

 int
recog_16 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 1);
  operands[2] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      if (pattern52 (x3, 
E_QImode) != 0)
        return -1;
      return 661; /* *ashlqi3_split */

    case E_QQmode:
      if (pattern52 (x3, 
E_QQmode) != 0)
        return -1;
      return 662; /* *ashlqq3_split */

    case E_UQQmode:
      if (pattern52 (x3, 
E_UQQmode) != 0)
        return -1;
      return 663; /* *ashluqq3_split */

    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x3) != E_HImode
          || !register_operand (operands[1], E_HImode))
        return -1;
      if (nop_general_operand (operands[2], E_QImode))
        return 667; /* ashlhi3 */
      if (pnum_clobbers == NULL
          || !const_int_operand (operands[2], E_QImode)
          || !
#line 5576 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      *pnum_clobbers = 2;
      return 692; /* *ashlhi3_const */

    case E_HQmode:
      if (!register_operand (operands[0], E_HQmode)
          || GET_MODE (x3) != E_HQmode
          || !register_operand (operands[1], E_HQmode))
        return -1;
      if (nop_general_operand (operands[2], E_QImode))
        return 668; /* ashlhq3 */
      if (pnum_clobbers == NULL
          || !const_int_operand (operands[2], E_QImode)
          || !
#line 5576 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      *pnum_clobbers = 2;
      return 693; /* *ashlhq3_const */

    case E_UHQmode:
      if (!register_operand (operands[0], E_UHQmode)
          || GET_MODE (x3) != E_UHQmode
          || !register_operand (operands[1], E_UHQmode))
        return -1;
      if (nop_general_operand (operands[2], E_QImode))
        return 669; /* ashluhq3 */
      if (pnum_clobbers == NULL
          || !const_int_operand (operands[2], E_QImode)
          || !
#line 5576 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      *pnum_clobbers = 2;
      return 694; /* *ashluhq3_const */

    case E_HAmode:
      if (!register_operand (operands[0], E_HAmode)
          || GET_MODE (x3) != E_HAmode
          || !register_operand (operands[1], E_HAmode))
        return -1;
      if (nop_general_operand (operands[2], E_QImode))
        return 670; /* ashlha3 */
      if (pnum_clobbers == NULL
          || !const_int_operand (operands[2], E_QImode)
          || !
#line 5576 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      *pnum_clobbers = 2;
      return 695; /* *ashlha3_const */

    case E_UHAmode:
      if (!register_operand (operands[0], E_UHAmode)
          || GET_MODE (x3) != E_UHAmode
          || !register_operand (operands[1], E_UHAmode))
        return -1;
      if (nop_general_operand (operands[2], E_QImode))
        return 671; /* ashluha3 */
      if (pnum_clobbers == NULL
          || !const_int_operand (operands[2], E_QImode)
          || !
#line 5576 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      *pnum_clobbers = 2;
      return 696; /* *ashluha3_const */

    case E_SImode:
      if (pattern52 (x3, 
E_SImode) != 0)
        return -1;
      return 682; /* ashlsi3 */

    case E_SQmode:
      if (pattern52 (x3, 
E_SQmode) != 0)
        return -1;
      return 683; /* ashlsq3 */

    case E_USQmode:
      if (pattern52 (x3, 
E_USQmode) != 0)
        return -1;
      return 684; /* ashlusq3 */

    case E_SAmode:
      if (pattern52 (x3, 
E_SAmode) != 0)
        return -1;
      return 685; /* ashlsa3 */

    case E_USAmode:
      if (pattern52 (x3, 
E_USAmode) != 0)
        return -1;
      return 686; /* ashlusa3 */

    case E_PSImode:
      if (pattern53 (x3, pnum_clobbers, 
E_QImode) != 0)
        return -1;
      *pnum_clobbers = 1;
      return 702; /* *ashlpsi3_split */

    default:
      return -1;
    }
}

 int
recog_20 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  switch (pattern90 (x1))
    {
    case 0:
      x2 = XEXP (x1, 1);
      x3 = XEXP (x2, 0);
      x4 = XEXP (x3, 0);
      operands[1] = x4;
      operands[0] = x3;
      switch (pattern260 (x2))
        {
        case 0:
          switch (GET_MODE (operands[1]))
            {
            case E_QImode:
              if (register_operand (operands[1], E_QImode)
                  && nonmemory_operand (operands[2], E_QImode))
                return 878; /* cbranchqi4_insn */
              break;

            case E_QQmode:
              if (register_operand (operands[1], E_QQmode)
                  && nonmemory_operand (operands[2], E_QQmode))
                return 879; /* cbranchqq4_insn */
              break;

            case E_UQQmode:
              if (register_operand (operands[1], E_UQQmode)
                  && nonmemory_operand (operands[2], E_UQQmode))
                return 880; /* cbranchuqq4_insn */
              break;

            case E_SImode:
              if (pnum_clobbers != NULL
                  && register_operand (operands[1], E_SImode)
                  && nonmemory_operand (operands[2], E_SImode))
                {
                  *pnum_clobbers = 1;
                  return 881; /* cbranchsi4_insn */
                }
              break;

            case E_SQmode:
              if (pnum_clobbers != NULL
                  && register_operand (operands[1], E_SQmode)
                  && nonmemory_operand (operands[2], E_SQmode))
                {
                  *pnum_clobbers = 1;
                  return 882; /* cbranchsq4_insn */
                }
              break;

            case E_USQmode:
              if (pnum_clobbers != NULL
                  && register_operand (operands[1], E_USQmode)
                  && nonmemory_operand (operands[2], E_USQmode))
                {
                  *pnum_clobbers = 1;
                  return 883; /* cbranchusq4_insn */
                }
              break;

            case E_SAmode:
              if (pnum_clobbers != NULL
                  && register_operand (operands[1], E_SAmode)
                  && nonmemory_operand (operands[2], E_SAmode))
                {
                  *pnum_clobbers = 1;
                  return 884; /* cbranchsa4_insn */
                }
              break;

            case E_USAmode:
              if (pnum_clobbers != NULL
                  && register_operand (operands[1], E_USAmode)
                  && nonmemory_operand (operands[2], E_USAmode))
                {
                  *pnum_clobbers = 1;
                  return 885; /* cbranchusa4_insn */
                }
              break;

            case E_PSImode:
              if (pnum_clobbers != NULL
                  && register_operand (operands[1], E_PSImode)
                  && nonmemory_operand (operands[2], E_PSImode))
                {
                  *pnum_clobbers = 1;
                  return 886; /* cbranchpsi4_insn */
                }
              break;

            case E_HImode:
              if (pnum_clobbers != NULL
                  && register_operand (operands[1], E_HImode)
                  && nonmemory_operand (operands[2], E_HImode))
                {
                  *pnum_clobbers = 1;
                  return 887; /* cbranchhi4_insn */
                }
              break;

            case E_HQmode:
              if (pnum_clobbers != NULL
                  && register_operand (operands[1], E_HQmode)
                  && nonmemory_operand (operands[2], E_HQmode))
                {
                  *pnum_clobbers = 1;
                  return 888; /* cbranchhq4_insn */
                }
              break;

            case E_UHQmode:
              if (pnum_clobbers != NULL
                  && register_operand (operands[1], E_UHQmode)
                  && nonmemory_operand (operands[2], E_UHQmode))
                {
                  *pnum_clobbers = 1;
                  return 889; /* cbranchuhq4_insn */
                }
              break;

            case E_HAmode:
              if (pnum_clobbers != NULL
                  && register_operand (operands[1], E_HAmode)
                  && nonmemory_operand (operands[2], E_HAmode))
                {
                  *pnum_clobbers = 1;
                  return 890; /* cbranchha4_insn */
                }
              break;

            case E_UHAmode:
              if (pnum_clobbers != NULL
                  && register_operand (operands[1], E_UHAmode)
                  && nonmemory_operand (operands[2], E_UHAmode))
                {
                  *pnum_clobbers = 1;
                  return 891; /* cbranchuha4_insn */
                }
              break;

            default:
              break;
            }
          break;

        case 1:
          if (
#line 7131 "../../gcc/config/avr/avr.md"
(optimize
   && 2 > 1))
            return 904; /* *cbranchhi.sign_extendqi.0 */
          break;

        case 2:
          if (
#line 7131 "../../gcc/config/avr/avr.md"
(optimize
   && 3 > 1))
            return 906; /* *cbranchpsi.sign_extendqi.0 */
          break;

        case 3:
          if (
#line 7131 "../../gcc/config/avr/avr.md"
(optimize
   && 3 > 2))
            return 910; /* *cbranchpsi.sign_extendhi.0 */
          break;

        case 4:
          if (
#line 7131 "../../gcc/config/avr/avr.md"
(optimize
   && 4 > 1))
            return 908; /* *cbranchsi.sign_extendqi.0 */
          break;

        case 5:
          if (
#line 7131 "../../gcc/config/avr/avr.md"
(optimize
   && 4 > 2))
            return 912; /* *cbranchsi.sign_extendhi.0 */
          break;

        case 6:
          if (
#line 7131 "../../gcc/config/avr/avr.md"
(optimize
   && 4 > 3))
            return 914; /* *cbranchsi.sign_extendpsi.0 */
          break;

        case 7:
          if (
#line 7131 "../../gcc/config/avr/avr.md"
(optimize
   && 2 > 1))
            return 905; /* *cbranchhi.zero_extendqi.0 */
          break;

        case 8:
          if (
#line 7131 "../../gcc/config/avr/avr.md"
(optimize
   && 3 > 1))
            return 907; /* *cbranchpsi.zero_extendqi.0 */
          break;

        case 9:
          if (
#line 7131 "../../gcc/config/avr/avr.md"
(optimize
   && 3 > 2))
            return 911; /* *cbranchpsi.zero_extendhi.0 */
          break;

        case 10:
          if (
#line 7131 "../../gcc/config/avr/avr.md"
(optimize
   && 4 > 1))
            return 909; /* *cbranchsi.zero_extendqi.0 */
          break;

        case 11:
          if (
#line 7131 "../../gcc/config/avr/avr.md"
(optimize
   && 4 > 2))
            return 913; /* *cbranchsi.zero_extendhi.0 */
          break;

        case 12:
          if (
#line 7131 "../../gcc/config/avr/avr.md"
(optimize
   && 4 > 3))
            return 915; /* *cbranchsi.zero_extendpsi.0 */
          break;

        default:
          break;
        }
      if (GET_CODE (x4) != REG)
        return -1;
      switch (REGNO (x4))
        {
        case 36:
          x5 = XEXP (x3, 1);
          if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          operands[1] = x3;
          x6 = XEXP (x2, 1);
          x7 = XEXP (x6, 0);
          operands[0] = x7;
          switch (GET_MODE (x4))
            {
            case E_CCmode:
              if (!
#line 7789 "../../gcc/config/avr/avr.md"
(reload_completed))
                return -1;
              return 966; /* branch */

            case E_CCNmode:
              if (!
#line 7789 "../../gcc/config/avr/avr.md"
(reload_completed))
                return -1;
              return 967; /* branch_N */

            case E_CCZNmode:
              if (!
#line 7789 "../../gcc/config/avr/avr.md"
(reload_completed))
                return -1;
              return 968; /* branch_ZN */

            default:
              return -1;
            }

        case 18:
          operands[0] = x3;
          x5 = XEXP (x3, 1);
          switch (GET_CODE (x5))
            {
            case REG:
              if (REGNO (x5) != 10)
                return -1;
              x6 = XEXP (x2, 1);
              x7 = XEXP (x6, 0);
              operands[1] = x7;
              switch (pattern333 (x3))
                {
                case 0:
                  if (!
#line 500 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
                    return -1;
                  return 3274; /* cbranch_di2_split */

                case 1:
                  if (!
#line 500 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
                    return -1;
                  return 3275; /* cbranch_dq2_split */

                case 2:
                  if (!
#line 500 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
                    return -1;
                  return 3276; /* cbranch_udq2_split */

                case 3:
                  if (!
#line 500 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
                    return -1;
                  return 3277; /* cbranch_da2_split */

                case 4:
                  if (!
#line 500 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
                    return -1;
                  return 3278; /* cbranch_uda2_split */

                case 5:
                  if (!
#line 500 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
                    return -1;
                  return 3279; /* cbranch_ta2_split */

                case 6:
                  if (!
#line 500 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
                    return -1;
                  return 3280; /* cbranch_uta2_split */

                default:
                  return -1;
                }

            case SIGN_EXTEND:
              if (pattern299 (x3) != 0)
                return -1;
              x6 = XEXP (x2, 1);
              x7 = XEXP (x6, 0);
              operands[1] = x7;
              if (!
#line 529 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
                return -1;
              return 3288; /* cbranch_const8_di2_split */

            case CONST_INT:
            case CONST_FIXED:
            case CONST_DOUBLE:
              if (pnum_clobbers == NULL)
                return -1;
              operands[1] = x5;
              x6 = XEXP (x2, 1);
              x7 = XEXP (x6, 0);
              operands[2] = x7;
              switch (GET_MODE (x4))
                {
                case E_DImode:
                  if (!const_operand (operands[1], E_DImode)
                      || !
#line 555 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && !s8_operand (operands[1], VOIDmode)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3290; /* cbranch_const_di2_split */

                case E_DQmode:
                  if (!const_operand (operands[1], E_DQmode)
                      || !
#line 555 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && !s8_operand (operands[1], VOIDmode)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3291; /* cbranch_const_dq2_split */

                case E_UDQmode:
                  if (!const_operand (operands[1], E_UDQmode)
                      || !
#line 555 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && !s8_operand (operands[1], VOIDmode)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3292; /* cbranch_const_udq2_split */

                case E_DAmode:
                  if (!const_operand (operands[1], E_DAmode)
                      || !
#line 555 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && !s8_operand (operands[1], VOIDmode)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3293; /* cbranch_const_da2_split */

                case E_UDAmode:
                  if (!const_operand (operands[1], E_UDAmode)
                      || !
#line 555 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && !s8_operand (operands[1], VOIDmode)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3294; /* cbranch_const_uda2_split */

                case E_TAmode:
                  if (!const_operand (operands[1], E_TAmode)
                      || !
#line 555 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && !s8_operand (operands[1], VOIDmode)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3295; /* cbranch_const_ta2_split */

                case E_UTAmode:
                  if (!const_operand (operands[1], E_UTAmode)
                      || !
#line 555 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && !s8_operand (operands[1], VOIDmode)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3296; /* cbranch_const_uta2_split */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 1:
      x2 = XEXP (x1, 1);
      x3 = XEXP (x2, 0);
      operands[0] = x3;
      switch (pattern233 (x2))
        {
        case 0:
          if (!
#line 7100 "../../gcc/config/avr/avr.md"
(optimize
   && 2 > 1))
            return -1;
          return 892; /* *cbranchhi.sign_extendqi.0 */

        case 1:
          if (!
#line 7100 "../../gcc/config/avr/avr.md"
(optimize
   && 3 > 1))
            return -1;
          return 894; /* *cbranchpsi.sign_extendqi.0 */

        case 2:
          if (!
#line 7100 "../../gcc/config/avr/avr.md"
(optimize
   && 3 > 2))
            return -1;
          return 898; /* *cbranchpsi.sign_extendhi.0 */

        case 3:
          if (!
#line 7100 "../../gcc/config/avr/avr.md"
(optimize
   && 4 > 1))
            return -1;
          return 896; /* *cbranchsi.sign_extendqi.0 */

        case 4:
          if (!
#line 7100 "../../gcc/config/avr/avr.md"
(optimize
   && 4 > 2))
            return -1;
          return 900; /* *cbranchsi.sign_extendhi.0 */

        case 5:
          if (!
#line 7100 "../../gcc/config/avr/avr.md"
(optimize
   && 4 > 3))
            return -1;
          return 902; /* *cbranchsi.sign_extendpsi.0 */

        default:
          return -1;
        }

    case 2:
      x2 = XEXP (x1, 1);
      x3 = XEXP (x2, 0);
      operands[0] = x3;
      switch (pattern233 (x2))
        {
        case 0:
          if (!
#line 7100 "../../gcc/config/avr/avr.md"
(optimize
   && 2 > 1))
            return -1;
          return 893; /* *cbranchhi.zero_extendqi.0 */

        case 1:
          if (!
#line 7100 "../../gcc/config/avr/avr.md"
(optimize
   && 3 > 1))
            return -1;
          return 895; /* *cbranchpsi.zero_extendqi.0 */

        case 2:
          if (!
#line 7100 "../../gcc/config/avr/avr.md"
(optimize
   && 3 > 2))
            return -1;
          return 899; /* *cbranchpsi.zero_extendhi.0 */

        case 3:
          if (!
#line 7100 "../../gcc/config/avr/avr.md"
(optimize
   && 4 > 1))
            return -1;
          return 897; /* *cbranchsi.zero_extendqi.0 */

        case 4:
          if (!
#line 7100 "../../gcc/config/avr/avr.md"
(optimize
   && 4 > 2))
            return -1;
          return 901; /* *cbranchsi.zero_extendhi.0 */

        case 5:
          if (!
#line 7100 "../../gcc/config/avr/avr.md"
(optimize
   && 4 > 3))
            return -1;
          return 903; /* *cbranchsi.zero_extendpsi.0 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_32 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  switch (pattern17 (x1))
    {
    case 0:
      x2 = XEXP (x1, 1);
      x3 = XEXP (x2, 0);
      operands[1] = x3;
      switch (pattern88 (x1))
        {
        case 0:
          return 785; /* negqi2 */

        case 1:
          return 789; /* neghi2 */

        case 2:
          return 791; /* negpsi2 */

        case 3:
          return 793; /* negsi2 */

        case 4:
          return 796; /* negsf2 */

        default:
          break;
        }
      switch (GET_CODE (x3))
        {
        case REG:
          res = recog_19 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case SUBREG:
          switch (pattern89 (x1))
            {
            case 0:
              if (
#line 10551 "../../gcc/config/avr/avr.md"
(! reload_completed))
                return 1177; /* *neg.ashiftrtqi.msb */
              break;

            case 1:
              if (
#line 10551 "../../gcc/config/avr/avr.md"
(! reload_completed))
                return 1178; /* *neg.ashiftrthi.msb */
              break;

            case 2:
              if (
#line 10551 "../../gcc/config/avr/avr.md"
(! reload_completed))
                return 1179; /* *neg.ashiftrtpsi.msb */
              break;

            case 3:
              if (
#line 10551 "../../gcc/config/avr/avr.md"
(! reload_completed))
                return 1180; /* *neg.ashiftrtsi.msb */
              break;

            default:
              break;
            }
          break;

        default:
          break;
        }
      if (pnum_clobbers == NULL)
        return -1;
      operands[1] = x3;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x2) != E_SImode
          || !
#line 6324 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 795; /* *negsi2 */

    case 1:
      return 787; /* *negqihi2_split */

    case 2:
      if (!
#line 10679 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 2 > 1
   && ! reload_completed))
        return -1;
      return 1248; /* *neg.zextr-to-sextr.hi.qi */

    case 3:
      if (!
#line 10679 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 2 > 1
   && ! reload_completed))
        return -1;
      return 1249; /* *neg.zextr-to-sextr.hi.hi */

    case 4:
      if (!
#line 10679 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 2 > 1
   && ! reload_completed))
        return -1;
      return 1250; /* *neg.zextr-to-sextr.hi.psi */

    case 5:
      if (!
#line 10679 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 2 > 1
   && ! reload_completed))
        return -1;
      return 1251; /* *neg.zextr-to-sextr.hi.si */

    case 6:
      if (!
#line 10679 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 1
   && ! reload_completed))
        return -1;
      return 1252; /* *neg.zextr-to-sextr.psi.qi */

    case 7:
      if (!
#line 10679 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 1
   && ! reload_completed))
        return -1;
      return 1253; /* *neg.zextr-to-sextr.psi.hi */

    case 8:
      if (!
#line 10679 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 1
   && ! reload_completed))
        return -1;
      return 1254; /* *neg.zextr-to-sextr.psi.psi */

    case 9:
      if (!
#line 10679 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 1
   && ! reload_completed))
        return -1;
      return 1255; /* *neg.zextr-to-sextr.psi.si */

    case 10:
      if (!
#line 10679 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 2
   && ! reload_completed))
        return -1;
      return 1260; /* *neg.zextr-to-sextr.psi.qi */

    case 11:
      if (!
#line 10679 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 2
   && ! reload_completed))
        return -1;
      return 1261; /* *neg.zextr-to-sextr.psi.hi */

    case 12:
      if (!
#line 10679 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 2
   && ! reload_completed))
        return -1;
      return 1262; /* *neg.zextr-to-sextr.psi.psi */

    case 13:
      if (!
#line 10679 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 2
   && ! reload_completed))
        return -1;
      return 1263; /* *neg.zextr-to-sextr.psi.si */

    case 14:
      if (!
#line 10679 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 1
   && ! reload_completed))
        return -1;
      return 1256; /* *neg.zextr-to-sextr.si.qi */

    case 15:
      if (!
#line 10679 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 1
   && ! reload_completed))
        return -1;
      return 1257; /* *neg.zextr-to-sextr.si.hi */

    case 16:
      if (!
#line 10679 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 1
   && ! reload_completed))
        return -1;
      return 1258; /* *neg.zextr-to-sextr.si.psi */

    case 17:
      if (!
#line 10679 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 1
   && ! reload_completed))
        return -1;
      return 1259; /* *neg.zextr-to-sextr.si.si */

    case 18:
      if (!
#line 10679 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 2
   && ! reload_completed))
        return -1;
      return 1264; /* *neg.zextr-to-sextr.si.qi */

    case 19:
      if (!
#line 10679 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 2
   && ! reload_completed))
        return -1;
      return 1265; /* *neg.zextr-to-sextr.si.hi */

    case 20:
      if (!
#line 10679 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 2
   && ! reload_completed))
        return -1;
      return 1266; /* *neg.zextr-to-sextr.si.psi */

    case 21:
      if (!
#line 10679 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 2
   && ! reload_completed))
        return -1;
      return 1267; /* *neg.zextr-to-sextr.si.si */

    case 22:
      if (!
#line 10679 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 3
   && ! reload_completed))
        return -1;
      return 1268; /* *neg.zextr-to-sextr.si.qi */

    case 23:
      if (!
#line 10679 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 3
   && ! reload_completed))
        return -1;
      return 1269; /* *neg.zextr-to-sextr.si.hi */

    case 24:
      if (!
#line 10679 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 3
   && ! reload_completed))
        return -1;
      return 1270; /* *neg.zextr-to-sextr.si.psi */

    case 25:
      if (!
#line 10679 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 3
   && ! reload_completed))
        return -1;
      return 1271; /* *neg.zextr-to-sextr.si.si */

    default:
      return -1;
    }
}

 int
recog_46 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 1);
  x5 = XEXP (x4, 1);
  operands[2] = x5;
  if (nop_general_operand (operands[2], E_QImode))
    {
      switch (pattern238 (x1))
        {
        case 0:
          if (
#line 5341 "../../gcc/config/avr/avr.md"
(reload_completed))
            return 664; /* *ashlqi3 */
          break;

        case 1:
          if (
#line 5341 "../../gcc/config/avr/avr.md"
(reload_completed))
            return 665; /* *ashlqq3 */
          break;

        case 2:
          if (
#line 5341 "../../gcc/config/avr/avr.md"
(reload_completed))
            return 666; /* *ashluqq3 */
          break;

        case 3:
          if (
#line 5373 "../../gcc/config/avr/avr.md"
(reload_completed))
            return 672; /* *ashlhi3 */
          break;

        case 4:
          if (
#line 5373 "../../gcc/config/avr/avr.md"
(reload_completed))
            return 673; /* *ashlhq3 */
          break;

        case 5:
          if (
#line 5373 "../../gcc/config/avr/avr.md"
(reload_completed))
            return 674; /* *ashluhq3 */
          break;

        case 6:
          if (
#line 5373 "../../gcc/config/avr/avr.md"
(reload_completed))
            return 675; /* *ashlha3 */
          break;

        case 7:
          if (
#line 5373 "../../gcc/config/avr/avr.md"
(reload_completed))
            return 676; /* *ashluha3 */
          break;

        case 8:
          if (
#line 5486 "../../gcc/config/avr/avr.md"
(reload_completed))
            return 687; /* *ashlsi3 */
          break;

        case 9:
          if (
#line 5486 "../../gcc/config/avr/avr.md"
(reload_completed))
            return 688; /* *ashlsq3 */
          break;

        case 10:
          if (
#line 5486 "../../gcc/config/avr/avr.md"
(reload_completed))
            return 689; /* *ashlusq3 */
          break;

        case 11:
          if (
#line 5486 "../../gcc/config/avr/avr.md"
(reload_completed))
            return 690; /* *ashlsa3 */
          break;

        case 12:
          if (
#line 5486 "../../gcc/config/avr/avr.md"
(reload_completed))
            return 691; /* *ashlusa3 */
          break;

        default:
          break;
        }
    }
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 0);
  operands[3] = x7;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (pnum_clobbers == NULL
          || pattern114 (x4, 
E_SImode) != 0
          || !
#line 5674 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 697; /* *ashlsi3_const */

    case E_SQmode:
      if (pnum_clobbers == NULL
          || pattern114 (x4, 
E_SQmode) != 0
          || !
#line 5674 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 698; /* *ashlsq3_const */

    case E_USQmode:
      if (pnum_clobbers == NULL
          || pattern114 (x4, 
E_USQmode) != 0
          || !
#line 5674 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 699; /* *ashlusq3_const */

    case E_SAmode:
      if (pnum_clobbers == NULL
          || pattern114 (x4, 
E_SAmode) != 0
          || !
#line 5674 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 700; /* *ashlsa3_const */

    case E_USAmode:
      if (pnum_clobbers == NULL
          || pattern114 (x4, 
E_USAmode) != 0
          || !
#line 5674 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 701; /* *ashlusa3_const */

    case E_PSImode:
      if (pattern112 (x4) != 0)
        return -1;
      return 702; /* *ashlpsi3_split */

    default:
      return -1;
    }
}

 int
recog_53 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern102 (x1))
    {
    case 0:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UQQmode != QQmode
   && reload_completed))
        return -1;
      return 2636; /* *fractunsuqqqq2 */

    case 1:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(HQmode != QQmode
   && reload_completed))
        return -1;
      return 2637; /* *fractunshqqq2 */

    case 2:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UHQmode != QQmode
   && reload_completed))
        return -1;
      return 2638; /* *fractunsuhqqq2 */

    case 3:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(HAmode != QQmode
   && reload_completed))
        return -1;
      return 2639; /* *fractunshaqq2 */

    case 4:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UHAmode != QQmode
   && reload_completed))
        return -1;
      return 2640; /* *fractunsuhaqq2 */

    case 5:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(SQmode != QQmode
   && reload_completed))
        return -1;
      return 2641; /* *fractunssqqq2 */

    case 6:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(USQmode != QQmode
   && reload_completed))
        return -1;
      return 2642; /* *fractunsusqqq2 */

    case 7:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(SAmode != QQmode
   && reload_completed))
        return -1;
      return 2643; /* *fractunssaqq2 */

    case 8:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(USAmode != QQmode
   && reload_completed))
        return -1;
      return 2644; /* *fractunsusaqq2 */

    case 9:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(DQmode != QQmode
   && reload_completed))
        return -1;
      return 2645; /* *fractunsdqqq2 */

    case 10:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UDQmode != QQmode
   && reload_completed))
        return -1;
      return 2646; /* *fractunsudqqq2 */

    case 11:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(DAmode != QQmode
   && reload_completed))
        return -1;
      return 2647; /* *fractunsdaqq2 */

    case 12:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UDAmode != QQmode
   && reload_completed))
        return -1;
      return 2648; /* *fractunsudaqq2 */

    case 13:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(TAmode != QQmode
   && reload_completed))
        return -1;
      return 2649; /* *fractunstaqq2 */

    case 14:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UTAmode != QQmode
   && reload_completed))
        return -1;
      return 2650; /* *fractunsutaqq2 */

    case 15:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(QImode != QQmode
   && reload_completed))
        return -1;
      return 2651; /* *fractunsqiqq2 */

    case 16:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(HImode != QQmode
   && reload_completed))
        return -1;
      return 2652; /* *fractunshiqq2 */

    case 17:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(SImode != QQmode
   && reload_completed))
        return -1;
      return 2653; /* *fractunssiqq2 */

    case 18:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(DImode != QQmode
   && reload_completed))
        return -1;
      return 2654; /* *fractunsdiqq2 */

    case 19:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(QQmode != UQQmode
   && reload_completed))
        return -1;
      return 2655; /* *fractunsqquqq2 */

    case 20:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(HQmode != UQQmode
   && reload_completed))
        return -1;
      return 2656; /* *fractunshquqq2 */

    case 21:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UHQmode != UQQmode
   && reload_completed))
        return -1;
      return 2657; /* *fractunsuhquqq2 */

    case 22:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(HAmode != UQQmode
   && reload_completed))
        return -1;
      return 2658; /* *fractunshauqq2 */

    case 23:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UHAmode != UQQmode
   && reload_completed))
        return -1;
      return 2659; /* *fractunsuhauqq2 */

    case 24:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(SQmode != UQQmode
   && reload_completed))
        return -1;
      return 2660; /* *fractunssquqq2 */

    case 25:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(USQmode != UQQmode
   && reload_completed))
        return -1;
      return 2661; /* *fractunsusquqq2 */

    case 26:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(SAmode != UQQmode
   && reload_completed))
        return -1;
      return 2662; /* *fractunssauqq2 */

    case 27:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(USAmode != UQQmode
   && reload_completed))
        return -1;
      return 2663; /* *fractunsusauqq2 */

    case 28:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(DQmode != UQQmode
   && reload_completed))
        return -1;
      return 2664; /* *fractunsdquqq2 */

    case 29:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UDQmode != UQQmode
   && reload_completed))
        return -1;
      return 2665; /* *fractunsudquqq2 */

    case 30:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(DAmode != UQQmode
   && reload_completed))
        return -1;
      return 2666; /* *fractunsdauqq2 */

    case 31:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UDAmode != UQQmode
   && reload_completed))
        return -1;
      return 2667; /* *fractunsudauqq2 */

    case 32:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(TAmode != UQQmode
   && reload_completed))
        return -1;
      return 2668; /* *fractunstauqq2 */

    case 33:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UTAmode != UQQmode
   && reload_completed))
        return -1;
      return 2669; /* *fractunsutauqq2 */

    case 34:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(QImode != UQQmode
   && reload_completed))
        return -1;
      return 2670; /* *fractunsqiuqq2 */

    case 35:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(HImode != UQQmode
   && reload_completed))
        return -1;
      return 2671; /* *fractunshiuqq2 */

    case 36:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(SImode != UQQmode
   && reload_completed))
        return -1;
      return 2672; /* *fractunssiuqq2 */

    case 37:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(DImode != UQQmode
   && reload_completed))
        return -1;
      return 2673; /* *fractunsdiuqq2 */

    case 38:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(QQmode != HQmode
   && reload_completed))
        return -1;
      return 2674; /* *fractunsqqhq2 */

    case 39:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UQQmode != HQmode
   && reload_completed))
        return -1;
      return 2675; /* *fractunsuqqhq2 */

    case 40:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UHQmode != HQmode
   && reload_completed))
        return -1;
      return 2676; /* *fractunsuhqhq2 */

    case 41:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(HAmode != HQmode
   && reload_completed))
        return -1;
      return 2677; /* *fractunshahq2 */

    case 42:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UHAmode != HQmode
   && reload_completed))
        return -1;
      return 2678; /* *fractunsuhahq2 */

    case 43:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(SQmode != HQmode
   && reload_completed))
        return -1;
      return 2679; /* *fractunssqhq2 */

    case 44:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(USQmode != HQmode
   && reload_completed))
        return -1;
      return 2680; /* *fractunsusqhq2 */

    case 45:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(SAmode != HQmode
   && reload_completed))
        return -1;
      return 2681; /* *fractunssahq2 */

    case 46:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(USAmode != HQmode
   && reload_completed))
        return -1;
      return 2682; /* *fractunsusahq2 */

    case 47:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(DQmode != HQmode
   && reload_completed))
        return -1;
      return 2683; /* *fractunsdqhq2 */

    case 48:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UDQmode != HQmode
   && reload_completed))
        return -1;
      return 2684; /* *fractunsudqhq2 */

    case 49:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(DAmode != HQmode
   && reload_completed))
        return -1;
      return 2685; /* *fractunsdahq2 */

    case 50:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UDAmode != HQmode
   && reload_completed))
        return -1;
      return 2686; /* *fractunsudahq2 */

    case 51:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(TAmode != HQmode
   && reload_completed))
        return -1;
      return 2687; /* *fractunstahq2 */

    case 52:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UTAmode != HQmode
   && reload_completed))
        return -1;
      return 2688; /* *fractunsutahq2 */

    case 53:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(QImode != HQmode
   && reload_completed))
        return -1;
      return 2689; /* *fractunsqihq2 */

    case 54:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(HImode != HQmode
   && reload_completed))
        return -1;
      return 2690; /* *fractunshihq2 */

    case 55:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(SImode != HQmode
   && reload_completed))
        return -1;
      return 2691; /* *fractunssihq2 */

    case 56:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(DImode != HQmode
   && reload_completed))
        return -1;
      return 2692; /* *fractunsdihq2 */

    case 57:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(QQmode != UHQmode
   && reload_completed))
        return -1;
      return 2693; /* *fractunsqquhq2 */

    case 58:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UQQmode != UHQmode
   && reload_completed))
        return -1;
      return 2694; /* *fractunsuqquhq2 */

    case 59:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(HQmode != UHQmode
   && reload_completed))
        return -1;
      return 2695; /* *fractunshquhq2 */

    case 60:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(HAmode != UHQmode
   && reload_completed))
        return -1;
      return 2696; /* *fractunshauhq2 */

    case 61:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UHAmode != UHQmode
   && reload_completed))
        return -1;
      return 2697; /* *fractunsuhauhq2 */

    case 62:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(SQmode != UHQmode
   && reload_completed))
        return -1;
      return 2698; /* *fractunssquhq2 */

    case 63:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(USQmode != UHQmode
   && reload_completed))
        return -1;
      return 2699; /* *fractunsusquhq2 */

    case 64:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(SAmode != UHQmode
   && reload_completed))
        return -1;
      return 2700; /* *fractunssauhq2 */

    case 65:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(USAmode != UHQmode
   && reload_completed))
        return -1;
      return 2701; /* *fractunsusauhq2 */

    case 66:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(DQmode != UHQmode
   && reload_completed))
        return -1;
      return 2702; /* *fractunsdquhq2 */

    case 67:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UDQmode != UHQmode
   && reload_completed))
        return -1;
      return 2703; /* *fractunsudquhq2 */

    case 68:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(DAmode != UHQmode
   && reload_completed))
        return -1;
      return 2704; /* *fractunsdauhq2 */

    case 69:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UDAmode != UHQmode
   && reload_completed))
        return -1;
      return 2705; /* *fractunsudauhq2 */

    case 70:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(TAmode != UHQmode
   && reload_completed))
        return -1;
      return 2706; /* *fractunstauhq2 */

    case 71:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UTAmode != UHQmode
   && reload_completed))
        return -1;
      return 2707; /* *fractunsutauhq2 */

    case 72:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(QImode != UHQmode
   && reload_completed))
        return -1;
      return 2708; /* *fractunsqiuhq2 */

    case 73:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(HImode != UHQmode
   && reload_completed))
        return -1;
      return 2709; /* *fractunshiuhq2 */

    case 74:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(SImode != UHQmode
   && reload_completed))
        return -1;
      return 2710; /* *fractunssiuhq2 */

    case 75:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(DImode != UHQmode
   && reload_completed))
        return -1;
      return 2711; /* *fractunsdiuhq2 */

    case 76:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(QQmode != HAmode
   && reload_completed))
        return -1;
      return 2712; /* *fractunsqqha2 */

    case 77:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UQQmode != HAmode
   && reload_completed))
        return -1;
      return 2713; /* *fractunsuqqha2 */

    case 78:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(HQmode != HAmode
   && reload_completed))
        return -1;
      return 2714; /* *fractunshqha2 */

    case 79:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UHQmode != HAmode
   && reload_completed))
        return -1;
      return 2715; /* *fractunsuhqha2 */

    case 80:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UHAmode != HAmode
   && reload_completed))
        return -1;
      return 2716; /* *fractunsuhaha2 */

    case 81:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(SQmode != HAmode
   && reload_completed))
        return -1;
      return 2717; /* *fractunssqha2 */

    case 82:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(USQmode != HAmode
   && reload_completed))
        return -1;
      return 2718; /* *fractunsusqha2 */

    case 83:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(SAmode != HAmode
   && reload_completed))
        return -1;
      return 2719; /* *fractunssaha2 */

    case 84:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(USAmode != HAmode
   && reload_completed))
        return -1;
      return 2720; /* *fractunsusaha2 */

    case 85:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(DQmode != HAmode
   && reload_completed))
        return -1;
      return 2721; /* *fractunsdqha2 */

    case 86:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UDQmode != HAmode
   && reload_completed))
        return -1;
      return 2722; /* *fractunsudqha2 */

    case 87:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(DAmode != HAmode
   && reload_completed))
        return -1;
      return 2723; /* *fractunsdaha2 */

    case 88:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UDAmode != HAmode
   && reload_completed))
        return -1;
      return 2724; /* *fractunsudaha2 */

    case 89:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(TAmode != HAmode
   && reload_completed))
        return -1;
      return 2725; /* *fractunstaha2 */

    case 90:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UTAmode != HAmode
   && reload_completed))
        return -1;
      return 2726; /* *fractunsutaha2 */

    case 91:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(QImode != HAmode
   && reload_completed))
        return -1;
      return 2727; /* *fractunsqiha2 */

    case 92:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(HImode != HAmode
   && reload_completed))
        return -1;
      return 2728; /* *fractunshiha2 */

    case 93:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(SImode != HAmode
   && reload_completed))
        return -1;
      return 2729; /* *fractunssiha2 */

    case 94:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(DImode != HAmode
   && reload_completed))
        return -1;
      return 2730; /* *fractunsdiha2 */

    case 95:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(QQmode != UHAmode
   && reload_completed))
        return -1;
      return 2731; /* *fractunsqquha2 */

    case 96:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UQQmode != UHAmode
   && reload_completed))
        return -1;
      return 2732; /* *fractunsuqquha2 */

    case 97:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(HQmode != UHAmode
   && reload_completed))
        return -1;
      return 2733; /* *fractunshquha2 */

    case 98:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UHQmode != UHAmode
   && reload_completed))
        return -1;
      return 2734; /* *fractunsuhquha2 */

    case 99:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(HAmode != UHAmode
   && reload_completed))
        return -1;
      return 2735; /* *fractunshauha2 */

    case 100:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(SQmode != UHAmode
   && reload_completed))
        return -1;
      return 2736; /* *fractunssquha2 */

    case 101:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(USQmode != UHAmode
   && reload_completed))
        return -1;
      return 2737; /* *fractunsusquha2 */

    case 102:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(SAmode != UHAmode
   && reload_completed))
        return -1;
      return 2738; /* *fractunssauha2 */

    case 103:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(USAmode != UHAmode
   && reload_completed))
        return -1;
      return 2739; /* *fractunsusauha2 */

    case 104:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(DQmode != UHAmode
   && reload_completed))
        return -1;
      return 2740; /* *fractunsdquha2 */

    case 105:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UDQmode != UHAmode
   && reload_completed))
        return -1;
      return 2741; /* *fractunsudquha2 */

    case 106:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(DAmode != UHAmode
   && reload_completed))
        return -1;
      return 2742; /* *fractunsdauha2 */

    case 107:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UDAmode != UHAmode
   && reload_completed))
        return -1;
      return 2743; /* *fractunsudauha2 */

    case 108:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(TAmode != UHAmode
   && reload_completed))
        return -1;
      return 2744; /* *fractunstauha2 */

    case 109:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UTAmode != UHAmode
   && reload_completed))
        return -1;
      return 2745; /* *fractunsutauha2 */

    case 110:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(QImode != UHAmode
   && reload_completed))
        return -1;
      return 2746; /* *fractunsqiuha2 */

    case 111:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(HImode != UHAmode
   && reload_completed))
        return -1;
      return 2747; /* *fractunshiuha2 */

    case 112:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(SImode != UHAmode
   && reload_completed))
        return -1;
      return 2748; /* *fractunssiuha2 */

    case 113:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(DImode != UHAmode
   && reload_completed))
        return -1;
      return 2749; /* *fractunsdiuha2 */

    case 114:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(QQmode != SQmode
   && reload_completed))
        return -1;
      return 2750; /* *fractunsqqsq2 */

    case 115:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UQQmode != SQmode
   && reload_completed))
        return -1;
      return 2751; /* *fractunsuqqsq2 */

    case 116:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(HQmode != SQmode
   && reload_completed))
        return -1;
      return 2752; /* *fractunshqsq2 */

    case 117:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UHQmode != SQmode
   && reload_completed))
        return -1;
      return 2753; /* *fractunsuhqsq2 */

    case 118:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(HAmode != SQmode
   && reload_completed))
        return -1;
      return 2754; /* *fractunshasq2 */

    case 119:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UHAmode != SQmode
   && reload_completed))
        return -1;
      return 2755; /* *fractunsuhasq2 */

    case 120:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(USQmode != SQmode
   && reload_completed))
        return -1;
      return 2756; /* *fractunsusqsq2 */

    case 121:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(SAmode != SQmode
   && reload_completed))
        return -1;
      return 2757; /* *fractunssasq2 */

    case 122:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(USAmode != SQmode
   && reload_completed))
        return -1;
      return 2758; /* *fractunsusasq2 */

    case 123:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(DQmode != SQmode
   && reload_completed))
        return -1;
      return 2759; /* *fractunsdqsq2 */

    case 124:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UDQmode != SQmode
   && reload_completed))
        return -1;
      return 2760; /* *fractunsudqsq2 */

    case 125:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(DAmode != SQmode
   && reload_completed))
        return -1;
      return 2761; /* *fractunsdasq2 */

    case 126:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UDAmode != SQmode
   && reload_completed))
        return -1;
      return 2762; /* *fractunsudasq2 */

    case 127:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(TAmode != SQmode
   && reload_completed))
        return -1;
      return 2763; /* *fractunstasq2 */

    case 128:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UTAmode != SQmode
   && reload_completed))
        return -1;
      return 2764; /* *fractunsutasq2 */

    case 129:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(QImode != SQmode
   && reload_completed))
        return -1;
      return 2765; /* *fractunsqisq2 */

    case 130:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(HImode != SQmode
   && reload_completed))
        return -1;
      return 2766; /* *fractunshisq2 */

    case 131:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(SImode != SQmode
   && reload_completed))
        return -1;
      return 2767; /* *fractunssisq2 */

    case 132:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(DImode != SQmode
   && reload_completed))
        return -1;
      return 2768; /* *fractunsdisq2 */

    case 133:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(QQmode != USQmode
   && reload_completed))
        return -1;
      return 2769; /* *fractunsqqusq2 */

    case 134:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UQQmode != USQmode
   && reload_completed))
        return -1;
      return 2770; /* *fractunsuqqusq2 */

    case 135:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(HQmode != USQmode
   && reload_completed))
        return -1;
      return 2771; /* *fractunshqusq2 */

    case 136:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UHQmode != USQmode
   && reload_completed))
        return -1;
      return 2772; /* *fractunsuhqusq2 */

    case 137:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(HAmode != USQmode
   && reload_completed))
        return -1;
      return 2773; /* *fractunshausq2 */

    case 138:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UHAmode != USQmode
   && reload_completed))
        return -1;
      return 2774; /* *fractunsuhausq2 */

    case 139:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(SQmode != USQmode
   && reload_completed))
        return -1;
      return 2775; /* *fractunssqusq2 */

    case 140:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(SAmode != USQmode
   && reload_completed))
        return -1;
      return 2776; /* *fractunssausq2 */

    case 141:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(USAmode != USQmode
   && reload_completed))
        return -1;
      return 2777; /* *fractunsusausq2 */

    case 142:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(DQmode != USQmode
   && reload_completed))
        return -1;
      return 2778; /* *fractunsdqusq2 */

    case 143:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UDQmode != USQmode
   && reload_completed))
        return -1;
      return 2779; /* *fractunsudqusq2 */

    case 144:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(DAmode != USQmode
   && reload_completed))
        return -1;
      return 2780; /* *fractunsdausq2 */

    case 145:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UDAmode != USQmode
   && reload_completed))
        return -1;
      return 2781; /* *fractunsudausq2 */

    case 146:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(TAmode != USQmode
   && reload_completed))
        return -1;
      return 2782; /* *fractunstausq2 */

    case 147:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UTAmode != USQmode
   && reload_completed))
        return -1;
      return 2783; /* *fractunsutausq2 */

    case 148:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(QImode != USQmode
   && reload_completed))
        return -1;
      return 2784; /* *fractunsqiusq2 */

    case 149:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(HImode != USQmode
   && reload_completed))
        return -1;
      return 2785; /* *fractunshiusq2 */

    case 150:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(SImode != USQmode
   && reload_completed))
        return -1;
      return 2786; /* *fractunssiusq2 */

    case 151:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(DImode != USQmode
   && reload_completed))
        return -1;
      return 2787; /* *fractunsdiusq2 */

    case 152:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(QQmode != SAmode
   && reload_completed))
        return -1;
      return 2788; /* *fractunsqqsa2 */

    case 153:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UQQmode != SAmode
   && reload_completed))
        return -1;
      return 2789; /* *fractunsuqqsa2 */

    case 154:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(HQmode != SAmode
   && reload_completed))
        return -1;
      return 2790; /* *fractunshqsa2 */

    case 155:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UHQmode != SAmode
   && reload_completed))
        return -1;
      return 2791; /* *fractunsuhqsa2 */

    case 156:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(HAmode != SAmode
   && reload_completed))
        return -1;
      return 2792; /* *fractunshasa2 */

    case 157:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UHAmode != SAmode
   && reload_completed))
        return -1;
      return 2793; /* *fractunsuhasa2 */

    case 158:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(SQmode != SAmode
   && reload_completed))
        return -1;
      return 2794; /* *fractunssqsa2 */

    case 159:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(USQmode != SAmode
   && reload_completed))
        return -1;
      return 2795; /* *fractunsusqsa2 */

    case 160:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(USAmode != SAmode
   && reload_completed))
        return -1;
      return 2796; /* *fractunsusasa2 */

    case 161:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(DQmode != SAmode
   && reload_completed))
        return -1;
      return 2797; /* *fractunsdqsa2 */

    case 162:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UDQmode != SAmode
   && reload_completed))
        return -1;
      return 2798; /* *fractunsudqsa2 */

    case 163:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(DAmode != SAmode
   && reload_completed))
        return -1;
      return 2799; /* *fractunsdasa2 */

    case 164:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UDAmode != SAmode
   && reload_completed))
        return -1;
      return 2800; /* *fractunsudasa2 */

    case 165:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(TAmode != SAmode
   && reload_completed))
        return -1;
      return 2801; /* *fractunstasa2 */

    case 166:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UTAmode != SAmode
   && reload_completed))
        return -1;
      return 2802; /* *fractunsutasa2 */

    case 167:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(QImode != SAmode
   && reload_completed))
        return -1;
      return 2803; /* *fractunsqisa2 */

    case 168:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(HImode != SAmode
   && reload_completed))
        return -1;
      return 2804; /* *fractunshisa2 */

    case 169:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(SImode != SAmode
   && reload_completed))
        return -1;
      return 2805; /* *fractunssisa2 */

    case 170:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(DImode != SAmode
   && reload_completed))
        return -1;
      return 2806; /* *fractunsdisa2 */

    case 171:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(QQmode != USAmode
   && reload_completed))
        return -1;
      return 2807; /* *fractunsqqusa2 */

    case 172:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UQQmode != USAmode
   && reload_completed))
        return -1;
      return 2808; /* *fractunsuqqusa2 */

    case 173:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(HQmode != USAmode
   && reload_completed))
        return -1;
      return 2809; /* *fractunshqusa2 */

    case 174:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UHQmode != USAmode
   && reload_completed))
        return -1;
      return 2810; /* *fractunsuhqusa2 */

    case 175:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(HAmode != USAmode
   && reload_completed))
        return -1;
      return 2811; /* *fractunshausa2 */

    case 176:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UHAmode != USAmode
   && reload_completed))
        return -1;
      return 2812; /* *fractunsuhausa2 */

    case 177:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(SQmode != USAmode
   && reload_completed))
        return -1;
      return 2813; /* *fractunssqusa2 */

    case 178:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(USQmode != USAmode
   && reload_completed))
        return -1;
      return 2814; /* *fractunsusqusa2 */

    case 179:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(SAmode != USAmode
   && reload_completed))
        return -1;
      return 2815; /* *fractunssausa2 */

    case 180:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(DQmode != USAmode
   && reload_completed))
        return -1;
      return 2816; /* *fractunsdqusa2 */

    case 181:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UDQmode != USAmode
   && reload_completed))
        return -1;
      return 2817; /* *fractunsudqusa2 */

    case 182:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(DAmode != USAmode
   && reload_completed))
        return -1;
      return 2818; /* *fractunsdausa2 */

    case 183:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UDAmode != USAmode
   && reload_completed))
        return -1;
      return 2819; /* *fractunsudausa2 */

    case 184:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(TAmode != USAmode
   && reload_completed))
        return -1;
      return 2820; /* *fractunstausa2 */

    case 185:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UTAmode != USAmode
   && reload_completed))
        return -1;
      return 2821; /* *fractunsutausa2 */

    case 186:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(QImode != USAmode
   && reload_completed))
        return -1;
      return 2822; /* *fractunsqiusa2 */

    case 187:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(HImode != USAmode
   && reload_completed))
        return -1;
      return 2823; /* *fractunshiusa2 */

    case 188:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(SImode != USAmode
   && reload_completed))
        return -1;
      return 2824; /* *fractunssiusa2 */

    case 189:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(DImode != USAmode
   && reload_completed))
        return -1;
      return 2825; /* *fractunsdiusa2 */

    case 190:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(QQmode != DQmode
   && reload_completed))
        return -1;
      return 2826; /* *fractunsqqdq2 */

    case 191:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UQQmode != DQmode
   && reload_completed))
        return -1;
      return 2827; /* *fractunsuqqdq2 */

    case 192:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(HQmode != DQmode
   && reload_completed))
        return -1;
      return 2828; /* *fractunshqdq2 */

    case 193:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UHQmode != DQmode
   && reload_completed))
        return -1;
      return 2829; /* *fractunsuhqdq2 */

    case 194:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(HAmode != DQmode
   && reload_completed))
        return -1;
      return 2830; /* *fractunshadq2 */

    case 195:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UHAmode != DQmode
   && reload_completed))
        return -1;
      return 2831; /* *fractunsuhadq2 */

    case 196:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(SQmode != DQmode
   && reload_completed))
        return -1;
      return 2832; /* *fractunssqdq2 */

    case 197:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(USQmode != DQmode
   && reload_completed))
        return -1;
      return 2833; /* *fractunsusqdq2 */

    case 198:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(SAmode != DQmode
   && reload_completed))
        return -1;
      return 2834; /* *fractunssadq2 */

    case 199:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(USAmode != DQmode
   && reload_completed))
        return -1;
      return 2835; /* *fractunsusadq2 */

    case 200:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UDQmode != DQmode
   && reload_completed))
        return -1;
      return 2836; /* *fractunsudqdq2 */

    case 201:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(DAmode != DQmode
   && reload_completed))
        return -1;
      return 2837; /* *fractunsdadq2 */

    case 202:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UDAmode != DQmode
   && reload_completed))
        return -1;
      return 2838; /* *fractunsudadq2 */

    case 203:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(TAmode != DQmode
   && reload_completed))
        return -1;
      return 2839; /* *fractunstadq2 */

    case 204:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UTAmode != DQmode
   && reload_completed))
        return -1;
      return 2840; /* *fractunsutadq2 */

    case 205:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(QImode != DQmode
   && reload_completed))
        return -1;
      return 2841; /* *fractunsqidq2 */

    case 206:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(HImode != DQmode
   && reload_completed))
        return -1;
      return 2842; /* *fractunshidq2 */

    case 207:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(SImode != DQmode
   && reload_completed))
        return -1;
      return 2843; /* *fractunssidq2 */

    case 208:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(DImode != DQmode
   && reload_completed))
        return -1;
      return 2844; /* *fractunsdidq2 */

    case 209:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(QQmode != UDQmode
   && reload_completed))
        return -1;
      return 2845; /* *fractunsqqudq2 */

    case 210:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UQQmode != UDQmode
   && reload_completed))
        return -1;
      return 2846; /* *fractunsuqqudq2 */

    case 211:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(HQmode != UDQmode
   && reload_completed))
        return -1;
      return 2847; /* *fractunshqudq2 */

    case 212:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UHQmode != UDQmode
   && reload_completed))
        return -1;
      return 2848; /* *fractunsuhqudq2 */

    case 213:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(HAmode != UDQmode
   && reload_completed))
        return -1;
      return 2849; /* *fractunshaudq2 */

    case 214:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UHAmode != UDQmode
   && reload_completed))
        return -1;
      return 2850; /* *fractunsuhaudq2 */

    case 215:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(SQmode != UDQmode
   && reload_completed))
        return -1;
      return 2851; /* *fractunssqudq2 */

    case 216:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(USQmode != UDQmode
   && reload_completed))
        return -1;
      return 2852; /* *fractunsusqudq2 */

    case 217:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(SAmode != UDQmode
   && reload_completed))
        return -1;
      return 2853; /* *fractunssaudq2 */

    case 218:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(USAmode != UDQmode
   && reload_completed))
        return -1;
      return 2854; /* *fractunsusaudq2 */

    case 219:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(DQmode != UDQmode
   && reload_completed))
        return -1;
      return 2855; /* *fractunsdqudq2 */

    case 220:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(DAmode != UDQmode
   && reload_completed))
        return -1;
      return 2856; /* *fractunsdaudq2 */

    case 221:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UDAmode != UDQmode
   && reload_completed))
        return -1;
      return 2857; /* *fractunsudaudq2 */

    case 222:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(TAmode != UDQmode
   && reload_completed))
        return -1;
      return 2858; /* *fractunstaudq2 */

    case 223:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UTAmode != UDQmode
   && reload_completed))
        return -1;
      return 2859; /* *fractunsutaudq2 */

    case 224:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(QImode != UDQmode
   && reload_completed))
        return -1;
      return 2860; /* *fractunsqiudq2 */

    case 225:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(HImode != UDQmode
   && reload_completed))
        return -1;
      return 2861; /* *fractunshiudq2 */

    case 226:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(SImode != UDQmode
   && reload_completed))
        return -1;
      return 2862; /* *fractunssiudq2 */

    case 227:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(DImode != UDQmode
   && reload_completed))
        return -1;
      return 2863; /* *fractunsdiudq2 */

    case 228:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(QQmode != DAmode
   && reload_completed))
        return -1;
      return 2864; /* *fractunsqqda2 */

    case 229:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UQQmode != DAmode
   && reload_completed))
        return -1;
      return 2865; /* *fractunsuqqda2 */

    case 230:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(HQmode != DAmode
   && reload_completed))
        return -1;
      return 2866; /* *fractunshqda2 */

    case 231:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UHQmode != DAmode
   && reload_completed))
        return -1;
      return 2867; /* *fractunsuhqda2 */

    case 232:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(HAmode != DAmode
   && reload_completed))
        return -1;
      return 2868; /* *fractunshada2 */

    case 233:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UHAmode != DAmode
   && reload_completed))
        return -1;
      return 2869; /* *fractunsuhada2 */

    case 234:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(SQmode != DAmode
   && reload_completed))
        return -1;
      return 2870; /* *fractunssqda2 */

    case 235:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(USQmode != DAmode
   && reload_completed))
        return -1;
      return 2871; /* *fractunsusqda2 */

    case 236:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(SAmode != DAmode
   && reload_completed))
        return -1;
      return 2872; /* *fractunssada2 */

    case 237:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(USAmode != DAmode
   && reload_completed))
        return -1;
      return 2873; /* *fractunsusada2 */

    case 238:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(DQmode != DAmode
   && reload_completed))
        return -1;
      return 2874; /* *fractunsdqda2 */

    case 239:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UDQmode != DAmode
   && reload_completed))
        return -1;
      return 2875; /* *fractunsudqda2 */

    case 240:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UDAmode != DAmode
   && reload_completed))
        return -1;
      return 2876; /* *fractunsudada2 */

    case 241:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(TAmode != DAmode
   && reload_completed))
        return -1;
      return 2877; /* *fractunstada2 */

    case 242:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UTAmode != DAmode
   && reload_completed))
        return -1;
      return 2878; /* *fractunsutada2 */

    case 243:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(QImode != DAmode
   && reload_completed))
        return -1;
      return 2879; /* *fractunsqida2 */

    case 244:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(HImode != DAmode
   && reload_completed))
        return -1;
      return 2880; /* *fractunshida2 */

    case 245:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(SImode != DAmode
   && reload_completed))
        return -1;
      return 2881; /* *fractunssida2 */

    case 246:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(DImode != DAmode
   && reload_completed))
        return -1;
      return 2882; /* *fractunsdida2 */

    case 247:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(QQmode != UDAmode
   && reload_completed))
        return -1;
      return 2883; /* *fractunsqquda2 */

    case 248:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UQQmode != UDAmode
   && reload_completed))
        return -1;
      return 2884; /* *fractunsuqquda2 */

    case 249:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(HQmode != UDAmode
   && reload_completed))
        return -1;
      return 2885; /* *fractunshquda2 */

    case 250:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UHQmode != UDAmode
   && reload_completed))
        return -1;
      return 2886; /* *fractunsuhquda2 */

    case 251:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(HAmode != UDAmode
   && reload_completed))
        return -1;
      return 2887; /* *fractunshauda2 */

    case 252:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UHAmode != UDAmode
   && reload_completed))
        return -1;
      return 2888; /* *fractunsuhauda2 */

    case 253:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(SQmode != UDAmode
   && reload_completed))
        return -1;
      return 2889; /* *fractunssquda2 */

    case 254:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(USQmode != UDAmode
   && reload_completed))
        return -1;
      return 2890; /* *fractunsusquda2 */

    case 255:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(SAmode != UDAmode
   && reload_completed))
        return -1;
      return 2891; /* *fractunssauda2 */

    case 256:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(USAmode != UDAmode
   && reload_completed))
        return -1;
      return 2892; /* *fractunsusauda2 */

    case 257:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(DQmode != UDAmode
   && reload_completed))
        return -1;
      return 2893; /* *fractunsdquda2 */

    case 258:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UDQmode != UDAmode
   && reload_completed))
        return -1;
      return 2894; /* *fractunsudquda2 */

    case 259:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(DAmode != UDAmode
   && reload_completed))
        return -1;
      return 2895; /* *fractunsdauda2 */

    case 260:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(TAmode != UDAmode
   && reload_completed))
        return -1;
      return 2896; /* *fractunstauda2 */

    case 261:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UTAmode != UDAmode
   && reload_completed))
        return -1;
      return 2897; /* *fractunsutauda2 */

    case 262:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(QImode != UDAmode
   && reload_completed))
        return -1;
      return 2898; /* *fractunsqiuda2 */

    case 263:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(HImode != UDAmode
   && reload_completed))
        return -1;
      return 2899; /* *fractunshiuda2 */

    case 264:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(SImode != UDAmode
   && reload_completed))
        return -1;
      return 2900; /* *fractunssiuda2 */

    case 265:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(DImode != UDAmode
   && reload_completed))
        return -1;
      return 2901; /* *fractunsdiuda2 */

    case 266:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(QQmode != TAmode
   && reload_completed))
        return -1;
      return 2902; /* *fractunsqqta2 */

    case 267:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UQQmode != TAmode
   && reload_completed))
        return -1;
      return 2903; /* *fractunsuqqta2 */

    case 268:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(HQmode != TAmode
   && reload_completed))
        return -1;
      return 2904; /* *fractunshqta2 */

    case 269:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UHQmode != TAmode
   && reload_completed))
        return -1;
      return 2905; /* *fractunsuhqta2 */

    case 270:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(HAmode != TAmode
   && reload_completed))
        return -1;
      return 2906; /* *fractunshata2 */

    case 271:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UHAmode != TAmode
   && reload_completed))
        return -1;
      return 2907; /* *fractunsuhata2 */

    case 272:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(SQmode != TAmode
   && reload_completed))
        return -1;
      return 2908; /* *fractunssqta2 */

    case 273:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(USQmode != TAmode
   && reload_completed))
        return -1;
      return 2909; /* *fractunsusqta2 */

    case 274:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(SAmode != TAmode
   && reload_completed))
        return -1;
      return 2910; /* *fractunssata2 */

    case 275:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(USAmode != TAmode
   && reload_completed))
        return -1;
      return 2911; /* *fractunsusata2 */

    case 276:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(DQmode != TAmode
   && reload_completed))
        return -1;
      return 2912; /* *fractunsdqta2 */

    case 277:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UDQmode != TAmode
   && reload_completed))
        return -1;
      return 2913; /* *fractunsudqta2 */

    case 278:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(DAmode != TAmode
   && reload_completed))
        return -1;
      return 2914; /* *fractunsdata2 */

    case 279:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UDAmode != TAmode
   && reload_completed))
        return -1;
      return 2915; /* *fractunsudata2 */

    case 280:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UTAmode != TAmode
   && reload_completed))
        return -1;
      return 2916; /* *fractunsutata2 */

    case 281:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(QImode != TAmode
   && reload_completed))
        return -1;
      return 2917; /* *fractunsqita2 */

    case 282:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(HImode != TAmode
   && reload_completed))
        return -1;
      return 2918; /* *fractunshita2 */

    case 283:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(SImode != TAmode
   && reload_completed))
        return -1;
      return 2919; /* *fractunssita2 */

    case 284:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(DImode != TAmode
   && reload_completed))
        return -1;
      return 2920; /* *fractunsdita2 */

    case 285:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(QQmode != UTAmode
   && reload_completed))
        return -1;
      return 2921; /* *fractunsqquta2 */

    case 286:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UQQmode != UTAmode
   && reload_completed))
        return -1;
      return 2922; /* *fractunsuqquta2 */

    case 287:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(HQmode != UTAmode
   && reload_completed))
        return -1;
      return 2923; /* *fractunshquta2 */

    case 288:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UHQmode != UTAmode
   && reload_completed))
        return -1;
      return 2924; /* *fractunsuhquta2 */

    case 289:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(HAmode != UTAmode
   && reload_completed))
        return -1;
      return 2925; /* *fractunshauta2 */

    case 290:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UHAmode != UTAmode
   && reload_completed))
        return -1;
      return 2926; /* *fractunsuhauta2 */

    case 291:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(SQmode != UTAmode
   && reload_completed))
        return -1;
      return 2927; /* *fractunssquta2 */

    case 292:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(USQmode != UTAmode
   && reload_completed))
        return -1;
      return 2928; /* *fractunsusquta2 */

    case 293:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(SAmode != UTAmode
   && reload_completed))
        return -1;
      return 2929; /* *fractunssauta2 */

    case 294:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(USAmode != UTAmode
   && reload_completed))
        return -1;
      return 2930; /* *fractunsusauta2 */

    case 295:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(DQmode != UTAmode
   && reload_completed))
        return -1;
      return 2931; /* *fractunsdquta2 */

    case 296:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UDQmode != UTAmode
   && reload_completed))
        return -1;
      return 2932; /* *fractunsudquta2 */

    case 297:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(DAmode != UTAmode
   && reload_completed))
        return -1;
      return 2933; /* *fractunsdauta2 */

    case 298:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UDAmode != UTAmode
   && reload_completed))
        return -1;
      return 2934; /* *fractunsudauta2 */

    case 299:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(TAmode != UTAmode
   && reload_completed))
        return -1;
      return 2935; /* *fractunstauta2 */

    case 300:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(QImode != UTAmode
   && reload_completed))
        return -1;
      return 2936; /* *fractunsqiuta2 */

    case 301:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(HImode != UTAmode
   && reload_completed))
        return -1;
      return 2937; /* *fractunshiuta2 */

    case 302:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(SImode != UTAmode
   && reload_completed))
        return -1;
      return 2938; /* *fractunssiuta2 */

    case 303:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(DImode != UTAmode
   && reload_completed))
        return -1;
      return 2939; /* *fractunsdiuta2 */

    case 304:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(QQmode != QImode
   && reload_completed))
        return -1;
      return 2940; /* *fractunsqqqi2 */

    case 305:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UQQmode != QImode
   && reload_completed))
        return -1;
      return 2941; /* *fractunsuqqqi2 */

    case 306:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(HQmode != QImode
   && reload_completed))
        return -1;
      return 2942; /* *fractunshqqi2 */

    case 307:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UHQmode != QImode
   && reload_completed))
        return -1;
      return 2943; /* *fractunsuhqqi2 */

    case 308:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(HAmode != QImode
   && reload_completed))
        return -1;
      return 2944; /* *fractunshaqi2 */

    case 309:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UHAmode != QImode
   && reload_completed))
        return -1;
      return 2945; /* *fractunsuhaqi2 */

    case 310:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(SQmode != QImode
   && reload_completed))
        return -1;
      return 2946; /* *fractunssqqi2 */

    case 311:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(USQmode != QImode
   && reload_completed))
        return -1;
      return 2947; /* *fractunsusqqi2 */

    case 312:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(SAmode != QImode
   && reload_completed))
        return -1;
      return 2948; /* *fractunssaqi2 */

    case 313:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(USAmode != QImode
   && reload_completed))
        return -1;
      return 2949; /* *fractunsusaqi2 */

    case 314:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(DQmode != QImode
   && reload_completed))
        return -1;
      return 2950; /* *fractunsdqqi2 */

    case 315:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UDQmode != QImode
   && reload_completed))
        return -1;
      return 2951; /* *fractunsudqqi2 */

    case 316:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(DAmode != QImode
   && reload_completed))
        return -1;
      return 2952; /* *fractunsdaqi2 */

    case 317:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UDAmode != QImode
   && reload_completed))
        return -1;
      return 2953; /* *fractunsudaqi2 */

    case 318:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(TAmode != QImode
   && reload_completed))
        return -1;
      return 2954; /* *fractunstaqi2 */

    case 319:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UTAmode != QImode
   && reload_completed))
        return -1;
      return 2955; /* *fractunsutaqi2 */

    case 320:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(HImode != QImode
   && reload_completed))
        return -1;
      return 2956; /* *fractunshiqi2 */

    case 321:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(SImode != QImode
   && reload_completed))
        return -1;
      return 2957; /* *fractunssiqi2 */

    case 322:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(DImode != QImode
   && reload_completed))
        return -1;
      return 2958; /* *fractunsdiqi2 */

    case 323:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(QQmode != HImode
   && reload_completed))
        return -1;
      return 2959; /* *fractunsqqhi2 */

    case 324:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UQQmode != HImode
   && reload_completed))
        return -1;
      return 2960; /* *fractunsuqqhi2 */

    case 325:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(HQmode != HImode
   && reload_completed))
        return -1;
      return 2961; /* *fractunshqhi2 */

    case 326:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UHQmode != HImode
   && reload_completed))
        return -1;
      return 2962; /* *fractunsuhqhi2 */

    case 327:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(HAmode != HImode
   && reload_completed))
        return -1;
      return 2963; /* *fractunshahi2 */

    case 328:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UHAmode != HImode
   && reload_completed))
        return -1;
      return 2964; /* *fractunsuhahi2 */

    case 329:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(SQmode != HImode
   && reload_completed))
        return -1;
      return 2965; /* *fractunssqhi2 */

    case 330:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(USQmode != HImode
   && reload_completed))
        return -1;
      return 2966; /* *fractunsusqhi2 */

    case 331:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(SAmode != HImode
   && reload_completed))
        return -1;
      return 2967; /* *fractunssahi2 */

    case 332:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(USAmode != HImode
   && reload_completed))
        return -1;
      return 2968; /* *fractunsusahi2 */

    case 333:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(DQmode != HImode
   && reload_completed))
        return -1;
      return 2969; /* *fractunsdqhi2 */

    case 334:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UDQmode != HImode
   && reload_completed))
        return -1;
      return 2970; /* *fractunsudqhi2 */

    case 335:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(DAmode != HImode
   && reload_completed))
        return -1;
      return 2971; /* *fractunsdahi2 */

    case 336:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UDAmode != HImode
   && reload_completed))
        return -1;
      return 2972; /* *fractunsudahi2 */

    case 337:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(TAmode != HImode
   && reload_completed))
        return -1;
      return 2973; /* *fractunstahi2 */

    case 338:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UTAmode != HImode
   && reload_completed))
        return -1;
      return 2974; /* *fractunsutahi2 */

    case 339:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(QImode != HImode
   && reload_completed))
        return -1;
      return 2975; /* *fractunsqihi2 */

    case 340:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(SImode != HImode
   && reload_completed))
        return -1;
      return 2976; /* *fractunssihi2 */

    case 341:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(DImode != HImode
   && reload_completed))
        return -1;
      return 2977; /* *fractunsdihi2 */

    case 342:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(QQmode != SImode
   && reload_completed))
        return -1;
      return 2978; /* *fractunsqqsi2 */

    case 343:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UQQmode != SImode
   && reload_completed))
        return -1;
      return 2979; /* *fractunsuqqsi2 */

    case 344:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(HQmode != SImode
   && reload_completed))
        return -1;
      return 2980; /* *fractunshqsi2 */

    case 345:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UHQmode != SImode
   && reload_completed))
        return -1;
      return 2981; /* *fractunsuhqsi2 */

    case 346:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(HAmode != SImode
   && reload_completed))
        return -1;
      return 2982; /* *fractunshasi2 */

    case 347:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UHAmode != SImode
   && reload_completed))
        return -1;
      return 2983; /* *fractunsuhasi2 */

    case 348:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(SQmode != SImode
   && reload_completed))
        return -1;
      return 2984; /* *fractunssqsi2 */

    case 349:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(USQmode != SImode
   && reload_completed))
        return -1;
      return 2985; /* *fractunsusqsi2 */

    case 350:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(SAmode != SImode
   && reload_completed))
        return -1;
      return 2986; /* *fractunssasi2 */

    case 351:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(USAmode != SImode
   && reload_completed))
        return -1;
      return 2987; /* *fractunsusasi2 */

    case 352:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(DQmode != SImode
   && reload_completed))
        return -1;
      return 2988; /* *fractunsdqsi2 */

    case 353:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UDQmode != SImode
   && reload_completed))
        return -1;
      return 2989; /* *fractunsudqsi2 */

    case 354:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(DAmode != SImode
   && reload_completed))
        return -1;
      return 2990; /* *fractunsdasi2 */

    case 355:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UDAmode != SImode
   && reload_completed))
        return -1;
      return 2991; /* *fractunsudasi2 */

    case 356:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(TAmode != SImode
   && reload_completed))
        return -1;
      return 2992; /* *fractunstasi2 */

    case 357:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UTAmode != SImode
   && reload_completed))
        return -1;
      return 2993; /* *fractunsutasi2 */

    case 358:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(QImode != SImode
   && reload_completed))
        return -1;
      return 2994; /* *fractunsqisi2 */

    case 359:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(HImode != SImode
   && reload_completed))
        return -1;
      return 2995; /* *fractunshisi2 */

    case 360:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(DImode != SImode
   && reload_completed))
        return -1;
      return 2996; /* *fractunsdisi2 */

    case 361:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(QQmode != DImode
   && reload_completed))
        return -1;
      return 2997; /* *fractunsqqdi2 */

    case 362:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UQQmode != DImode
   && reload_completed))
        return -1;
      return 2998; /* *fractunsuqqdi2 */

    case 363:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(HQmode != DImode
   && reload_completed))
        return -1;
      return 2999; /* *fractunshqdi2 */

    case 364:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UHQmode != DImode
   && reload_completed))
        return -1;
      return 3000; /* *fractunsuhqdi2 */

    case 365:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(HAmode != DImode
   && reload_completed))
        return -1;
      return 3001; /* *fractunshadi2 */

    case 366:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UHAmode != DImode
   && reload_completed))
        return -1;
      return 3002; /* *fractunsuhadi2 */

    case 367:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(SQmode != DImode
   && reload_completed))
        return -1;
      return 3003; /* *fractunssqdi2 */

    case 368:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(USQmode != DImode
   && reload_completed))
        return -1;
      return 3004; /* *fractunsusqdi2 */

    case 369:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(SAmode != DImode
   && reload_completed))
        return -1;
      return 3005; /* *fractunssadi2 */

    case 370:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(USAmode != DImode
   && reload_completed))
        return -1;
      return 3006; /* *fractunsusadi2 */

    case 371:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(DQmode != DImode
   && reload_completed))
        return -1;
      return 3007; /* *fractunsdqdi2 */

    case 372:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UDQmode != DImode
   && reload_completed))
        return -1;
      return 3008; /* *fractunsudqdi2 */

    case 373:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(DAmode != DImode
   && reload_completed))
        return -1;
      return 3009; /* *fractunsdadi2 */

    case 374:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UDAmode != DImode
   && reload_completed))
        return -1;
      return 3010; /* *fractunsudadi2 */

    case 375:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(TAmode != DImode
   && reload_completed))
        return -1;
      return 3011; /* *fractunstadi2 */

    case 376:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UTAmode != DImode
   && reload_completed))
        return -1;
      return 3012; /* *fractunsutadi2 */

    case 377:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(QImode != DImode
   && reload_completed))
        return -1;
      return 3013; /* *fractunsqidi2 */

    case 378:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(HImode != DImode
   && reload_completed))
        return -1;
      return 3014; /* *fractunshidi2 */

    case 379:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(SImode != DImode
   && reload_completed))
        return -1;
      return 3015; /* *fractunssidi2 */

    default:
      return -1;
    }
}

 rtx_insn *
split_19 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case ASHIFT:
      if (pattern49 (x1) != 0
          || !
#line 5747 "../../gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_502 (insn, operands);

    case REG:
    case SUBREG:
      switch (pattern50 (x1))
        {
        case 0:
          if (!
#line 6576 "../../gcc/config/avr/avr.md"
(reload_completed))
            return NULL;
          return gen_split_556 (insn, operands);

        case 1:
          if (!
#line 6592 "../../gcc/config/avr/avr.md"
(reload_completed))
            return NULL;
          return gen_split_557 (insn, operands);

        case 2:
          if (!
#line 6623 "../../gcc/config/avr/avr.md"
(reload_completed))
            return NULL;
          return gen_split_559 (insn, operands);

        case 3:
          if (!
#line 6607 "../../gcc/config/avr/avr.md"
(reload_completed))
            return NULL;
          return gen_split_558 (insn, operands);

        case 4:
          if (!
#line 6657 "../../gcc/config/avr/avr.md"
(reload_completed))
            return NULL;
          return gen_split_561 (insn, operands);

        case 5:
          if (!
#line 6673 "../../gcc/config/avr/avr.md"
(reload_completed))
            return NULL;
          return gen_split_562 (insn, operands);

        case 6:
          if (!
#line 6686 "../../gcc/config/avr/avr.md"
(reload_completed))
            return NULL;
          return gen_split_563 (insn, operands);

        case 7:
          if (!
#line 6702 "../../gcc/config/avr/avr.md"
(reload_completed))
            return NULL;
          return gen_split_564 (insn, operands);

        case 8:
          if (!
#line 6718 "../../gcc/config/avr/avr.md"
(reload_completed))
            return NULL;
          return gen_split_565 (insn, operands);

        default:
          return NULL;
        }

    case PARITY:
      if (GET_MODE (x3) != E_QImode
          || pattern35 (x1, 
E_QImode, 
24) != 0
          || !
#line 9220 "../../gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_639 (insn, operands);

    case POPCOUNT:
      if (GET_MODE (x3) != E_QImode
          || pattern34 (x1, 
E_HImode, 
24) != 0)
        return NULL;
      x4 = XEXP (x3, 0);
      operands[0] = x4;
      if (register_operand (operands[0], E_QImode)
          && (
#line 9281 "../../gcc/config/avr/avr.md"
(! reload_completed) && 
#line 9283 "../../gcc/config/avr/avr.md"
( 1)))
        return gen_split_641 (insn, operands);
      if (GET_CODE (x4) != REG
          || REGNO (x4) != 24
          || GET_MODE (x4) != E_QImode)
        return NULL;
      return gen_split_645 (insn, operands);

    case ZERO_EXTRACT:
      switch (pattern51 (x1))
        {
        case 0:
          if (!(
#line 10612 "../../gcc/config/avr/avr.md"
(! reload_completed) && 
#line 10614 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_764 (insn, operands);

        case 1:
          if (!(
#line 10612 "../../gcc/config/avr/avr.md"
(! reload_completed) && 
#line 10614 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_765 (insn, operands);

        case 2:
          if (!(
#line 10612 "../../gcc/config/avr/avr.md"
(! reload_completed) && 
#line 10614 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_766 (insn, operands);

        case 3:
          if (!(
#line 10612 "../../gcc/config/avr/avr.md"
(! reload_completed) && 
#line 10614 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_767 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_24 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  operands[1] = x3;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG)
    return NULL;
  x6 = XEXP (x2, 0);
  operands[0] = x6;
  switch (pattern229 (x5))
    {
    case 0:
      if (!(
#line 599 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false))) && 
#line 604 "../../gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_17 (insn, operands);

    case 1:
      if (!(
#line 599 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false))) && 
#line 604 "../../gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_18 (insn, operands);

    case 2:
      if (!(
#line 599 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false))) && 
#line 604 "../../gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_19 (insn, operands);

    case 3:
      if (!(
#line 599 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false))) && 
#line 604 "../../gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_20 (insn, operands);

    case 4:
      if (!(
#line 599 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false))) && 
#line 604 "../../gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_21 (insn, operands);

    case 5:
      if (!(
#line 599 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false))) && 
#line 604 "../../gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_22 (insn, operands);

    case 6:
      if (!(
#line 599 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false))) && 
#line 604 "../../gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_23 (insn, operands);

    case 7:
      if (!(
#line 599 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false))) && 
#line 604 "../../gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_24 (insn, operands);

    case 8:
      if (!(
#line 599 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false))) && 
#line 604 "../../gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_25 (insn, operands);

    case 9:
      if (!(
#line 599 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false))) && 
#line 604 "../../gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_26 (insn, operands);

    case 10:
      if (!(
#line 599 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false))) && 
#line 604 "../../gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_27 (insn, operands);

    case 11:
      if (!(
#line 599 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false))) && 
#line 604 "../../gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_28 (insn, operands);

    case 12:
      if (!(
#line 599 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false))) && 
#line 604 "../../gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_29 (insn, operands);

    case 13:
      if (!(
#line 599 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false))) && 
#line 604 "../../gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_30 (insn, operands);

    case 14:
      if (!(
#line 599 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false))) && 
#line 604 "../../gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_31 (insn, operands);

    case 15:
      switch (GET_MODE (operands[0]))
        {
        case E_QImode:
          if (!nonimmediate_operand (operands[0], E_QImode)
              || !general_operand (operands[1], E_QImode)
              || !
#line 1077 "../../gcc/config/avr/avr.md"
(reload_completed
   && (MEM_P (operands[0]) || MEM_P (operands[1]))))
            return NULL;
          return gen_split_70 (insn, operands);

        case E_QQmode:
          if (!nonimmediate_operand (operands[0], E_QQmode)
              || !general_operand (operands[1], E_QQmode)
              || !
#line 1077 "../../gcc/config/avr/avr.md"
(reload_completed
   && (MEM_P (operands[0]) || MEM_P (operands[1]))))
            return NULL;
          return gen_split_71 (insn, operands);

        case E_UQQmode:
          if (!nonimmediate_operand (operands[0], E_UQQmode)
              || !general_operand (operands[1], E_UQQmode)
              || !
#line 1077 "../../gcc/config/avr/avr.md"
(reload_completed
   && (MEM_P (operands[0]) || MEM_P (operands[1]))))
            return NULL;
          return gen_split_72 (insn, operands);

        case E_HImode:
          if (!nonimmediate_operand (operands[0], E_HImode)
              || !general_operand (operands[1], E_HImode)
              || !
#line 1077 "../../gcc/config/avr/avr.md"
(reload_completed
   && (MEM_P (operands[0]) || MEM_P (operands[1]))))
            return NULL;
          return gen_split_73 (insn, operands);

        case E_HQmode:
          if (!nonimmediate_operand (operands[0], E_HQmode)
              || !general_operand (operands[1], E_HQmode)
              || !
#line 1077 "../../gcc/config/avr/avr.md"
(reload_completed
   && (MEM_P (operands[0]) || MEM_P (operands[1]))))
            return NULL;
          return gen_split_74 (insn, operands);

        case E_UHQmode:
          if (!nonimmediate_operand (operands[0], E_UHQmode)
              || !general_operand (operands[1], E_UHQmode)
              || !
#line 1077 "../../gcc/config/avr/avr.md"
(reload_completed
   && (MEM_P (operands[0]) || MEM_P (operands[1]))))
            return NULL;
          return gen_split_75 (insn, operands);

        case E_HAmode:
          if (!nonimmediate_operand (operands[0], E_HAmode)
              || !general_operand (operands[1], E_HAmode)
              || !
#line 1077 "../../gcc/config/avr/avr.md"
(reload_completed
   && (MEM_P (operands[0]) || MEM_P (operands[1]))))
            return NULL;
          return gen_split_76 (insn, operands);

        case E_UHAmode:
          if (!nonimmediate_operand (operands[0], E_UHAmode)
              || !general_operand (operands[1], E_UHAmode)
              || !
#line 1077 "../../gcc/config/avr/avr.md"
(reload_completed
   && (MEM_P (operands[0]) || MEM_P (operands[1]))))
            return NULL;
          return gen_split_77 (insn, operands);

        case E_SImode:
          if (!nonimmediate_operand (operands[0], E_SImode)
              || !general_operand (operands[1], E_SImode)
              || !
#line 1077 "../../gcc/config/avr/avr.md"
(reload_completed
   && (MEM_P (operands[0]) || MEM_P (operands[1]))))
            return NULL;
          return gen_split_78 (insn, operands);

        case E_SQmode:
          if (!nonimmediate_operand (operands[0], E_SQmode)
              || !general_operand (operands[1], E_SQmode)
              || !
#line 1077 "../../gcc/config/avr/avr.md"
(reload_completed
   && (MEM_P (operands[0]) || MEM_P (operands[1]))))
            return NULL;
          return gen_split_79 (insn, operands);

        case E_USQmode:
          if (!nonimmediate_operand (operands[0], E_USQmode)
              || !general_operand (operands[1], E_USQmode)
              || !
#line 1077 "../../gcc/config/avr/avr.md"
(reload_completed
   && (MEM_P (operands[0]) || MEM_P (operands[1]))))
            return NULL;
          return gen_split_80 (insn, operands);

        case E_SAmode:
          if (!nonimmediate_operand (operands[0], E_SAmode)
              || !general_operand (operands[1], E_SAmode)
              || !
#line 1077 "../../gcc/config/avr/avr.md"
(reload_completed
   && (MEM_P (operands[0]) || MEM_P (operands[1]))))
            return NULL;
          return gen_split_81 (insn, operands);

        case E_USAmode:
          if (!nonimmediate_operand (operands[0], E_USAmode)
              || !general_operand (operands[1], E_USAmode)
              || !
#line 1077 "../../gcc/config/avr/avr.md"
(reload_completed
   && (MEM_P (operands[0]) || MEM_P (operands[1]))))
            return NULL;
          return gen_split_82 (insn, operands);

        case E_SFmode:
          if (!nonimmediate_operand (operands[0], E_SFmode)
              || !general_operand (operands[1], E_SFmode)
              || !
#line 1077 "../../gcc/config/avr/avr.md"
(reload_completed
   && (MEM_P (operands[0]) || MEM_P (operands[1]))))
            return NULL;
          return gen_split_83 (insn, operands);

        case E_PSImode:
          if (!nonimmediate_operand (operands[0], E_PSImode)
              || !general_operand (operands[1], E_PSImode)
              || !
#line 1077 "../../gcc/config/avr/avr.md"
(reload_completed
   && (MEM_P (operands[0]) || MEM_P (operands[1]))))
            return NULL;
          return gen_split_84 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
peephole2_4 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (peep2_current_count < 2
      || peep2_current_count < 3)
    return NULL;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (pattern323 (x4) != 0)
    return NULL;
  x5 = PATTERN (peep2_next_insn (1));
  if (pattern385 (x5) != 0)
    return NULL;
  x6 = XEXP (x3, 1);
  switch (GET_CODE (x6))
    {
    case REG:
    case SUBREG:
      operands[1] = x6;
      if (!register_operand (operands[1], E_PSImode)
          || !register_operand (operands[0], E_PSImode)
          || GET_MODE (x3) != E_PSImode)
        return NULL;
      x7 = PATTERN (peep2_next_insn (2));
      x8 = XEXP (x7, 1);
      x9 = XEXP (x8, 0);
      switch (pattern392 (x9, 
E_PSImode))
        {
        case 0:
          if (!
#line 7414 "../../gcc/config/avr/avr.md"
(peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_200 (insn, operands);

        case 1:
          if (!
#line 7414 "../../gcc/config/avr/avr.md"
(peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_201 (insn, operands);

        case 2:
          if (!
#line 7414 "../../gcc/config/avr/avr.md"
(peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_202 (insn, operands);

        case 3:
          if (!
#line 7414 "../../gcc/config/avr/avr.md"
(peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_203 (insn, operands);

        case 4:
          if (!
#line 7414 "../../gcc/config/avr/avr.md"
(peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_204 (insn, operands);

        case 5:
          if (!
#line 7414 "../../gcc/config/avr/avr.md"
(peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_205 (insn, operands);

        default:
          return NULL;
        }

    case SIGN_EXTEND:
      switch (pattern394 (x3))
        {
        case 0:
          if (!
#line 7445 "../../gcc/config/avr/avr.md"
(2 > 1
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_206 (insn, operands);

        case 1:
          if (!
#line 7445 "../../gcc/config/avr/avr.md"
(2 > 1
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_207 (insn, operands);

        case 2:
          if (!
#line 7445 "../../gcc/config/avr/avr.md"
(2 > 1
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_208 (insn, operands);

        case 3:
          if (!
#line 7445 "../../gcc/config/avr/avr.md"
(2 > 1
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_209 (insn, operands);

        case 4:
          if (!
#line 7445 "../../gcc/config/avr/avr.md"
(2 > 1
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_210 (insn, operands);

        case 5:
          if (!
#line 7445 "../../gcc/config/avr/avr.md"
(2 > 1
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_211 (insn, operands);

        case 6:
          if (!
#line 7445 "../../gcc/config/avr/avr.md"
(3 > 1
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_218 (insn, operands);

        case 7:
          if (!
#line 7445 "../../gcc/config/avr/avr.md"
(3 > 1
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_219 (insn, operands);

        case 8:
          if (!
#line 7445 "../../gcc/config/avr/avr.md"
(3 > 1
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_220 (insn, operands);

        case 9:
          if (!
#line 7445 "../../gcc/config/avr/avr.md"
(3 > 1
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_221 (insn, operands);

        case 10:
          if (!
#line 7445 "../../gcc/config/avr/avr.md"
(3 > 1
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_222 (insn, operands);

        case 11:
          if (!
#line 7445 "../../gcc/config/avr/avr.md"
(3 > 1
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_223 (insn, operands);

        case 12:
          if (!
#line 7445 "../../gcc/config/avr/avr.md"
(3 > 2
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_242 (insn, operands);

        case 13:
          if (!
#line 7445 "../../gcc/config/avr/avr.md"
(3 > 2
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_243 (insn, operands);

        case 14:
          if (!
#line 7445 "../../gcc/config/avr/avr.md"
(3 > 2
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_244 (insn, operands);

        case 15:
          if (!
#line 7445 "../../gcc/config/avr/avr.md"
(3 > 2
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_245 (insn, operands);

        case 16:
          if (!
#line 7445 "../../gcc/config/avr/avr.md"
(3 > 2
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_246 (insn, operands);

        case 17:
          if (!
#line 7445 "../../gcc/config/avr/avr.md"
(3 > 2
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_247 (insn, operands);

        case 18:
          if (!
#line 7445 "../../gcc/config/avr/avr.md"
(4 > 1
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_230 (insn, operands);

        case 19:
          if (!
#line 7445 "../../gcc/config/avr/avr.md"
(4 > 1
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_231 (insn, operands);

        case 20:
          if (!
#line 7445 "../../gcc/config/avr/avr.md"
(4 > 1
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_232 (insn, operands);

        case 21:
          if (!
#line 7445 "../../gcc/config/avr/avr.md"
(4 > 1
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_233 (insn, operands);

        case 22:
          if (!
#line 7445 "../../gcc/config/avr/avr.md"
(4 > 1
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_234 (insn, operands);

        case 23:
          if (!
#line 7445 "../../gcc/config/avr/avr.md"
(4 > 1
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_235 (insn, operands);

        case 24:
          if (!
#line 7445 "../../gcc/config/avr/avr.md"
(4 > 2
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_254 (insn, operands);

        case 25:
          if (!
#line 7445 "../../gcc/config/avr/avr.md"
(4 > 2
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_255 (insn, operands);

        case 26:
          if (!
#line 7445 "../../gcc/config/avr/avr.md"
(4 > 2
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_256 (insn, operands);

        case 27:
          if (!
#line 7445 "../../gcc/config/avr/avr.md"
(4 > 2
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_257 (insn, operands);

        case 28:
          if (!
#line 7445 "../../gcc/config/avr/avr.md"
(4 > 2
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_258 (insn, operands);

        case 29:
          if (!
#line 7445 "../../gcc/config/avr/avr.md"
(4 > 2
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_259 (insn, operands);

        case 30:
          if (!
#line 7445 "../../gcc/config/avr/avr.md"
(4 > 3
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_266 (insn, operands);

        case 31:
          if (!
#line 7445 "../../gcc/config/avr/avr.md"
(4 > 3
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_267 (insn, operands);

        case 32:
          if (!
#line 7445 "../../gcc/config/avr/avr.md"
(4 > 3
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_268 (insn, operands);

        case 33:
          if (!
#line 7445 "../../gcc/config/avr/avr.md"
(4 > 3
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_269 (insn, operands);

        case 34:
          if (!
#line 7445 "../../gcc/config/avr/avr.md"
(4 > 3
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_270 (insn, operands);

        case 35:
          if (!
#line 7445 "../../gcc/config/avr/avr.md"
(4 > 3
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_271 (insn, operands);

        default:
          return NULL;
        }

    case ZERO_EXTEND:
      switch (pattern394 (x3))
        {
        case 0:
          if (!
#line 7445 "../../gcc/config/avr/avr.md"
(2 > 1
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_212 (insn, operands);

        case 1:
          if (!
#line 7445 "../../gcc/config/avr/avr.md"
(2 > 1
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_213 (insn, operands);

        case 2:
          if (!
#line 7445 "../../gcc/config/avr/avr.md"
(2 > 1
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_214 (insn, operands);

        case 3:
          if (!
#line 7445 "../../gcc/config/avr/avr.md"
(2 > 1
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_215 (insn, operands);

        case 4:
          if (!
#line 7445 "../../gcc/config/avr/avr.md"
(2 > 1
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_216 (insn, operands);

        case 5:
          if (!
#line 7445 "../../gcc/config/avr/avr.md"
(2 > 1
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_217 (insn, operands);

        case 6:
          if (!
#line 7445 "../../gcc/config/avr/avr.md"
(3 > 1
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_224 (insn, operands);

        case 7:
          if (!
#line 7445 "../../gcc/config/avr/avr.md"
(3 > 1
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_225 (insn, operands);

        case 8:
          if (!
#line 7445 "../../gcc/config/avr/avr.md"
(3 > 1
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_226 (insn, operands);

        case 9:
          if (!
#line 7445 "../../gcc/config/avr/avr.md"
(3 > 1
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_227 (insn, operands);

        case 10:
          if (!
#line 7445 "../../gcc/config/avr/avr.md"
(3 > 1
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_228 (insn, operands);

        case 11:
          if (!
#line 7445 "../../gcc/config/avr/avr.md"
(3 > 1
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_229 (insn, operands);

        case 12:
          if (!
#line 7445 "../../gcc/config/avr/avr.md"
(3 > 2
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_248 (insn, operands);

        case 13:
          if (!
#line 7445 "../../gcc/config/avr/avr.md"
(3 > 2
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_249 (insn, operands);

        case 14:
          if (!
#line 7445 "../../gcc/config/avr/avr.md"
(3 > 2
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_250 (insn, operands);

        case 15:
          if (!
#line 7445 "../../gcc/config/avr/avr.md"
(3 > 2
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_251 (insn, operands);

        case 16:
          if (!
#line 7445 "../../gcc/config/avr/avr.md"
(3 > 2
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_252 (insn, operands);

        case 17:
          if (!
#line 7445 "../../gcc/config/avr/avr.md"
(3 > 2
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_253 (insn, operands);

        case 18:
          if (!
#line 7445 "../../gcc/config/avr/avr.md"
(4 > 1
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_236 (insn, operands);

        case 19:
          if (!
#line 7445 "../../gcc/config/avr/avr.md"
(4 > 1
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_237 (insn, operands);

        case 20:
          if (!
#line 7445 "../../gcc/config/avr/avr.md"
(4 > 1
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_238 (insn, operands);

        case 21:
          if (!
#line 7445 "../../gcc/config/avr/avr.md"
(4 > 1
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_239 (insn, operands);

        case 22:
          if (!
#line 7445 "../../gcc/config/avr/avr.md"
(4 > 1
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_240 (insn, operands);

        case 23:
          if (!
#line 7445 "../../gcc/config/avr/avr.md"
(4 > 1
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_241 (insn, operands);

        case 24:
          if (!
#line 7445 "../../gcc/config/avr/avr.md"
(4 > 2
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_260 (insn, operands);

        case 25:
          if (!
#line 7445 "../../gcc/config/avr/avr.md"
(4 > 2
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_261 (insn, operands);

        case 26:
          if (!
#line 7445 "../../gcc/config/avr/avr.md"
(4 > 2
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_262 (insn, operands);

        case 27:
          if (!
#line 7445 "../../gcc/config/avr/avr.md"
(4 > 2
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_263 (insn, operands);

        case 28:
          if (!
#line 7445 "../../gcc/config/avr/avr.md"
(4 > 2
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_264 (insn, operands);

        case 29:
          if (!
#line 7445 "../../gcc/config/avr/avr.md"
(4 > 2
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_265 (insn, operands);

        case 30:
          if (!
#line 7445 "../../gcc/config/avr/avr.md"
(4 > 3
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_272 (insn, operands);

        case 31:
          if (!
#line 7445 "../../gcc/config/avr/avr.md"
(4 > 3
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_273 (insn, operands);

        case 32:
          if (!
#line 7445 "../../gcc/config/avr/avr.md"
(4 > 3
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_274 (insn, operands);

        case 33:
          if (!
#line 7445 "../../gcc/config/avr/avr.md"
(4 > 3
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_275 (insn, operands);

        case 34:
          if (!
#line 7445 "../../gcc/config/avr/avr.md"
(4 > 3
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_276 (insn, operands);

        case 35:
          if (!
#line 7445 "../../gcc/config/avr/avr.md"
(4 > 3
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_277 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}
