/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern8 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x1, 0);
  operands[0] = x5;
  x6 = XEXP (x3, 0);
  operands[1] = x6;
  x7 = XEXP (x2, 1);
  operands[2] = x7;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      return pattern7 (x2, 
E_QImode); /* [-1, 3] */

    case E_HImode:
      res = pattern7 (x2, 
E_HImode);
      if (res >= 0)
        return res + 4; /* [4, 7] */
      return -1;

    case E_PSImode:
      res = pattern7 (x2, 
E_PSImode);
      if (res >= 0)
        return res + 8; /* [8, 11] */
      return -1;

    case E_SImode:
      res = pattern7 (x2, 
E_SImode);
      if (res >= 0)
        return res + 12; /* [12, 15] */
      return -1;

    default:
      return -1;
    }
}

int
pattern17 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case REG:
    case SUBREG:
      return 0;

    case SIGN_EXTEND:
      if (pattern16 (x1, 
E_HImode) != 0)
        return -1;
      return 1;

    case ZERO_EXTEND:
      x4 = XEXP (x3, 0);
      if (GET_CODE (x4) != ZERO_EXTRACT)
        return -1;
      x5 = XEXP (x4, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x6 = XEXP (x1, 0);
      operands[0] = x6;
      x7 = XEXP (x4, 0);
      operands[1] = x7;
      x8 = XEXP (x4, 2);
      operands[2] = x8;
      if (!const0_operand (operands[2], E_QImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_HImode:
          if (!register_operand (operands[0], E_HImode)
              || GET_MODE (x2) != E_HImode
              || GET_MODE (x3) != E_HImode
              || GET_MODE (x4) != E_QImode)
            return -1;
          res = pattern9 ();
          if (res >= 0)
            return res + 2; /* [2, 5] */
          return -1;

        case E_PSImode:
          if (!register_operand (operands[0], E_PSImode)
              || GET_MODE (x2) != E_PSImode
              || GET_MODE (x3) != E_PSImode)
            return -1;
          switch (GET_MODE (x4))
            {
            case E_QImode:
              res = pattern9 ();
              if (res >= 0)
                return res + 6; /* [6, 9] */
              return -1;

            case E_HImode:
              res = pattern9 ();
              if (res >= 0)
                return res + 10; /* [10, 13] */
              return -1;

            default:
              return -1;
            }

        case E_SImode:
          if (!register_operand (operands[0], E_SImode)
              || GET_MODE (x2) != E_SImode
              || GET_MODE (x3) != E_SImode)
            return -1;
          switch (GET_MODE (x4))
            {
            case E_QImode:
              res = pattern9 ();
              if (res >= 0)
                return res + 14; /* [14, 17] */
              return -1;

            case E_HImode:
              res = pattern9 ();
              if (res >= 0)
                return res + 18; /* [18, 21] */
              return -1;

            case E_PSImode:
              res = pattern9 ();
              if (res >= 0)
                return res + 22; /* [22, 25] */
              return -1;

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern37 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x1) != E_HImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_HImode)
        return -1;
      x3 = XEXP (x2, 0);
      if (GET_MODE (x3) != E_QImode
          || !register_operand (operands[1], E_QImode)
          || !const_0_to_15_operand (operands[2], E_QImode))
        return -1;
      return 0;

    case E_PSImode:
      if (!register_operand (operands[0], E_PSImode)
          || GET_MODE (x1) != E_PSImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_PSImode
          || !const_0_to_23_operand (operands[2], E_QImode))
        return -1;
      x3 = XEXP (x2, 0);
      switch (GET_MODE (x3))
        {
        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 1;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 2;

        default:
          return -1;
        }

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_SImode
          || !const_0_to_31_operand (operands[2], E_QImode))
        return -1;
      x3 = XEXP (x2, 0);
      res = pattern30 (x3);
      if (res >= 0)
        return res + 3; /* [3, 5] */
      return -1;

    default:
      return -1;
    }
}

int
pattern57 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  switch (GET_CODE (x2))
    {
    case REG:
    case SUBREG:
      operands[0] = x2;
      x3 = XEXP (x1, 1);
      x4 = XEXP (x3, 0);
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_QImode:
          if (!register_operand (operands[0], E_QImode)
              || GET_MODE (x3) != E_QImode
              || !register_operand (operands[1], E_QImode))
            return -1;
          return 0;

        case E_HImode:
          if (!register_operand (operands[0], E_HImode)
              || GET_MODE (x3) != E_HImode
              || !register_operand (operands[1], E_HImode))
            return -1;
          return 1;

        case E_PSImode:
          if (!register_operand (operands[0], E_PSImode)
              || GET_MODE (x3) != E_PSImode
              || !register_operand (operands[1], E_PSImode))
            return -1;
          return 2;

        case E_SImode:
          if (!register_operand (operands[0], E_SImode)
              || GET_MODE (x3) != E_SImode
              || !register_operand (operands[1], E_SImode))
            return -1;
          return 3;

        default:
          return -1;
        }

    case ZERO_EXTRACT:
      if (GET_MODE (x2) != E_QImode)
        return -1;
      x5 = XEXP (x2, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      return 4;

    default:
      return -1;
    }
}

int
pattern68 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  switch (XINT (x1, 1))
    {
    case 0:
      if (GET_MODE (x1) != E_HImode)
        return -1;
      x2 = XVECEXP (x1, 0, 0);
      if (GET_CODE (x2) != MEM
          || GET_MODE (x2) != E_BLKmode)
        return -1;
      x3 = XVECEXP (x1, 0, 1);
      if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
          || !register_operand (operands[0], E_HImode))
        return -1;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_HImode))
        return -1;
      x5 = XVECEXP (x1, 0, 2);
      operands[2] = x5;
      if (!immediate_operand (operands[2], E_HImode))
        return -1;
      return 0;

    case 7:
      if (GET_MODE (x1) != E_QImode
          || !register_operand (operands[0], E_QImode))
        return -1;
      x2 = XVECEXP (x1, 0, 0);
      operands[1] = x2;
      if (!const_int_operand (operands[1], E_SImode))
        return -1;
      x3 = XVECEXP (x1, 0, 1);
      operands[2] = x3;
      if (!register_operand (operands[2], E_QImode))
        return -1;
      x5 = XVECEXP (x1, 0, 2);
      operands[3] = x5;
      if (!nonmemory_operand (operands[3], E_QImode))
        return -1;
      return 1;

    case 8:
      x5 = XVECEXP (x1, 0, 2);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x2 = XVECEXP (x1, 0, 0);
      operands[1] = x2;
      x3 = XVECEXP (x1, 0, 1);
      operands[2] = x3;
      if (!const_int_operand (operands[2], E_HImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_QQmode:
          if (!register_operand (operands[0], E_QQmode)
              || GET_MODE (x1) != E_QQmode
              || !register_operand (operands[1], E_QQmode))
            return -1;
          return 2;

        case E_HQmode:
          if (!register_operand (operands[0], E_HQmode)
              || GET_MODE (x1) != E_HQmode
              || !register_operand (operands[1], E_HQmode))
            return -1;
          return 3;

        case E_HAmode:
          if (!register_operand (operands[0], E_HAmode)
              || GET_MODE (x1) != E_HAmode
              || !register_operand (operands[1], E_HAmode))
            return -1;
          return 4;

        case E_SAmode:
          if (!register_operand (operands[0], E_SAmode)
              || GET_MODE (x1) != E_SAmode
              || !register_operand (operands[1], E_SAmode))
            return -1;
          return 5;

        case E_SQmode:
          if (!register_operand (operands[0], E_SQmode)
              || GET_MODE (x1) != E_SQmode
              || !register_operand (operands[1], E_SQmode))
            return -1;
          return 6;

        case E_UQQmode:
          if (!register_operand (operands[0], E_UQQmode)
              || GET_MODE (x1) != E_UQQmode
              || !register_operand (operands[1], E_UQQmode))
            return -1;
          return 7;

        case E_UHQmode:
          if (!register_operand (operands[0], E_UHQmode)
              || GET_MODE (x1) != E_UHQmode
              || !register_operand (operands[1], E_UHQmode))
            return -1;
          return 8;

        case E_UHAmode:
          if (!register_operand (operands[0], E_UHAmode)
              || GET_MODE (x1) != E_UHAmode
              || !register_operand (operands[1], E_UHAmode))
            return -1;
          return 9;

        case E_USAmode:
          if (!register_operand (operands[0], E_USAmode)
              || GET_MODE (x1) != E_USAmode
              || !register_operand (operands[1], E_USAmode))
            return -1;
          return 10;

        case E_USQmode:
          if (!register_operand (operands[0], E_USQmode)
              || GET_MODE (x1) != E_USQmode
              || !register_operand (operands[1], E_USQmode))
            return -1;
          return 11;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern98 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 1);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
      operands[1] = x5;
      x6 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x6) != CLOBBER)
        return -1;
      x7 = XEXP (x4, 1);
      operands[2] = x7;
      return 0;

    case ZERO_EXTRACT:
      if (pnum_clobbers == NULL)
        return -1;
      res = pattern97 (x1);
      if (res >= 0)
        return res + 1; /* [1, 2] */
      return -1;

    default:
      return -1;
    }
}

int
pattern105 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x3) != CLOBBER)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 36
      || GET_MODE (x4) != E_CCmode)
    return -1;
  x5 = XVECEXP (x1, 0, 0);
  x6 = XEXP (x5, 0);
  operands[0] = x6;
  x7 = XEXP (x5, 1);
  x8 = XEXP (x7, 0);
  operands[1] = x8;
  x9 = XEXP (x7, 1);
  operands[2] = x9;
  x10 = XEXP (x2, 0);
  operands[3] = x10;
  return 0;
}

int
pattern115 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x3) != CLOBBER)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 36
      || GET_MODE (x4) != E_CCmode)
    return -1;
  x5 = XVECEXP (x1, 0, 0);
  x6 = XEXP (x5, 0);
  operands[0] = x6;
  x7 = XEXP (x5, 1);
  x8 = XEXP (x7, 0);
  operands[1] = x8;
  x9 = XEXP (x7, 1);
  operands[2] = x9;
  x10 = XEXP (x2, 0);
  operands[3] = x10;
  switch (GET_MODE (operands[0]))
    {
    case E_PSImode:
      return pattern112 (x7); /* [-1, 0] */

    case E_HImode:
      if (pattern113 (x7, 
E_HImode) != 0)
        return -1;
      return 1;

    case E_HQmode:
      if (pattern113 (x7, 
E_HQmode) != 0)
        return -1;
      return 2;

    case E_UHQmode:
      if (pattern113 (x7, 
E_UHQmode) != 0)
        return -1;
      return 3;

    case E_HAmode:
      if (pattern113 (x7, 
E_HAmode) != 0)
        return -1;
      return 4;

    case E_UHAmode:
      if (pattern113 (x7, 
E_UHAmode) != 0)
        return -1;
      return 5;

    case E_SImode:
      if (pattern114 (x7, 
E_SImode) != 0)
        return -1;
      return 6;

    case E_SQmode:
      if (pattern114 (x7, 
E_SQmode) != 0)
        return -1;
      return 7;

    case E_USQmode:
      if (pattern114 (x7, 
E_USQmode) != 0)
        return -1;
      return 8;

    case E_SAmode:
      if (pattern114 (x7, 
E_SAmode) != 0)
        return -1;
      return 9;

    case E_USAmode:
      if (pattern114 (x7, 
E_USAmode) != 0)
        return -1;
      return 10;

    default:
      return -1;
    }
}

int
pattern132 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  switch (GET_MODE (operands[2]))
    {
    case E_QImode:
      if (!register_operand (operands[2], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!register_operand (operands[2], E_HImode))
        return -1;
      return 1;

    case E_PSImode:
      if (!register_operand (operands[2], E_PSImode))
        return -1;
      return 2;

    case E_SImode:
      if (!register_operand (operands[2], E_SImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern135 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !nonmemory_operand (operands[3], i1))
    return -1;
  return pattern6 (); /* [-1, 3] */
}

int
pattern138 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (x1))
    {
    case E_HImode:
      if (!register_operand (operands[1], E_HImode)
          || !single_one_operand (operands[2], E_HImode))
        return -1;
      return 0;

    case E_PSImode:
      if (!register_operand (operands[1], E_PSImode)
          || !single_one_operand (operands[2], E_PSImode))
        return -1;
      return 1;

    case E_SImode:
      if (!register_operand (operands[1], E_SImode)
          || !single_one_operand (operands[2], E_SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern143 (rtx x1, machine_mode i1, unsigned int i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 0);
  if (REGNO (x5) != i2
      || GET_MODE (x5) != i1
      || pattern142 (x1, 
i1) != 0)
    return -1;
  return 0;
}

int
pattern146 (rtx x1, int *pnum_clobbers, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != REG)
    return -1;
  x5 = XEXP (x2, 0);
  if (GET_CODE (x5) != REG)
    return -1;
  x6 = XEXP (x3, 0);
  switch (REGNO (x6))
    {
    case 24:
      if (pnum_clobbers == NULL
          || REGNO (x4) != 22)
        return -1;
      x7 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x7) != SET)
        return -1;
      x8 = XEXP (x7, 1);
      if (GET_CODE (x8) != i1)
        return -1;
      x9 = XEXP (x8, 0);
      if (GET_CODE (x9) != REG
          || REGNO (x9) != 24)
        return -1;
      x10 = XEXP (x8, 1);
      if (GET_CODE (x10) != REG
          || REGNO (x10) != 22)
        return -1;
      x11 = XEXP (x7, 0);
      if (GET_CODE (x11) != REG)
        return -1;
      switch (REGNO (x5))
        {
        case 24:
          return pattern143 (x1, 
E_QImode, 
25); /* [-1, 0] */

        case 22:
          if (pattern143 (x1, 
E_HImode, 
24) != 0)
            return -1;
          return 1;

        default:
          return -1;
        }

    case 22:
      if (pnum_clobbers == NULL
          || REGNO (x4) != 18)
        return -1;
      x7 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x7) != SET)
        return -1;
      x8 = XEXP (x7, 1);
      if (GET_CODE (x8) != i1)
        return -1;
      x9 = XEXP (x8, 0);
      if (GET_CODE (x9) != REG
          || REGNO (x9) != 22)
        return -1;
      x10 = XEXP (x8, 1);
      if (GET_CODE (x10) != REG
          || REGNO (x10) != 18)
        return -1;
      x11 = XEXP (x7, 0);
      if (GET_CODE (x11) != REG)
        return -1;
      switch (REGNO (x5))
        {
        case 22:
          if (pattern143 (x1, 
E_PSImode, 
18) != 0)
            return -1;
          return 2;

        case 18:
          if (pattern143 (x1, 
E_SImode, 
22) != 0)
            return -1;
          return 3;

        default:
          return -1;
        }

    case 25:
      if (REGNO (x4) != 22
          || REGNO (x5) != 24)
        return -1;
      x7 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x7) != CLOBBER)
        return -1;
      res = pattern145 (x1);
      if (res >= 0)
        return res + 4; /* [4, 5] */
      return -1;

    default:
      return -1;
    }
}

int
pattern171 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], E_PSImode))
    return -1;
  x4 = XEXP (x2, 1);
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  if (!const_int_operand (operands[1], E_QImode))
    return -1;
  x6 = XEXP (x4, 1);
  operands[2] = x6;
  if (!register_operand (operands[2], E_HImode))
    return -1;
  x7 = XVECEXP (x1, 0, 1);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  if (!scratch_operand (operands[3], E_QImode))
    return -1;
  return 0;
}

int
pattern174 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != MEM
      || GET_MODE (x3) != E_BLKmode)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != USE)
    return -1;
  x5 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x5) != USE)
    return -1;
  return 0;
}

int
pattern180 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 2);
  operands[2] = x2;
  if (!const0_operand (operands[2], E_QImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      return pattern179 (x1, 
E_QImode); /* [-1, 3] */

    case E_HImode:
      res = pattern179 (x1, 
E_HImode);
      if (res >= 0)
        return res + 4; /* [4, 7] */
      return -1;

    case E_PSImode:
      res = pattern179 (x1, 
E_PSImode);
      if (res >= 0)
        return res + 8; /* [8, 11] */
      return -1;

    case E_SImode:
      res = pattern179 (x1, 
E_SImode);
      if (res >= 0)
        return res + 12; /* [12, 15] */
      return -1;

    default:
      return -1;
    }
}

int
pattern188 (rtx x1, machine_mode i1, unsigned int i2, unsigned int i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 3);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != i3
      || GET_MODE (x3) != E_QImode)
    return -1;
  x4 = XVECEXP (x1, 0, 4);
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != i2
      || GET_MODE (x5) != i1)
    return -1;
  return 0;
}

int
pattern193 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern196 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_PSImode)
      || GET_MODE (x1) != E_PSImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_PSImode)
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != E_PSImode)
    return -1;
  x4 = XEXP (x2, 0);
  switch (GET_MODE (x4))
    {
    case E_QImode:
      operands[1] = x4;
      if (!register_operand (operands[1], E_QImode))
        return -1;
      x5 = XEXP (x3, 0);
      operands[2] = x5;
      if (!register_operand (operands[2], E_HImode))
        return -1;
      return 0;

    case E_HImode:
      operands[2] = x4;
      if (!register_operand (operands[2], E_HImode))
        return -1;
      x5 = XEXP (x3, 0);
      operands[1] = x5;
      if (!register_operand (operands[1], E_QImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern206 (rtx x1, machine_mode i1, machine_mode i2, unsigned int i3, unsigned int i4)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (REGNO (x3) != i3
      || GET_MODE (x3) != i1)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 0);
  if (REGNO (x5) != i4
      || GET_MODE (x5) != i2)
    return -1;
  x6 = XEXP (x2, 1);
  if (GET_MODE (x6) != i1)
    return -1;
  return 0;
}

int
pattern211 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 22)
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 21
      || GET_MODE (x5) != E_QImode)
    return -1;
  x6 = XVECEXP (x1, 0, 3);
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != REG
      || REGNO (x7) != 30
      || GET_MODE (x7) != E_HImode)
    return -1;
  x8 = XVECEXP (x1, 0, 0);
  x9 = XEXP (x8, 0);
  operands[0] = x9;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      if (!register_operand (operands[0], E_QImode)
          || !memory_operand (operands[1], E_QImode)
          || GET_MODE (x3) != E_QImode)
        return -1;
      return 0;

    case E_QQmode:
      if (!register_operand (operands[0], E_QQmode)
          || !memory_operand (operands[1], E_QQmode)
          || GET_MODE (x3) != E_QQmode)
        return -1;
      return 1;

    case E_UQQmode:
      if (!register_operand (operands[0], E_UQQmode)
          || !memory_operand (operands[1], E_UQQmode)
          || GET_MODE (x3) != E_UQQmode)
        return -1;
      return 2;

    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || !memory_operand (operands[1], E_HImode)
          || GET_MODE (x3) != E_HImode)
        return -1;
      return 3;

    case E_HQmode:
      if (!register_operand (operands[0], E_HQmode)
          || !memory_operand (operands[1], E_HQmode)
          || GET_MODE (x3) != E_HQmode)
        return -1;
      return 4;

    case E_UHQmode:
      if (!register_operand (operands[0], E_UHQmode)
          || !memory_operand (operands[1], E_UHQmode)
          || GET_MODE (x3) != E_UHQmode)
        return -1;
      return 5;

    case E_HAmode:
      if (!register_operand (operands[0], E_HAmode)
          || !memory_operand (operands[1], E_HAmode)
          || GET_MODE (x3) != E_HAmode)
        return -1;
      return 6;

    case E_UHAmode:
      if (!register_operand (operands[0], E_UHAmode)
          || !memory_operand (operands[1], E_UHAmode)
          || GET_MODE (x3) != E_UHAmode)
        return -1;
      return 7;

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || !memory_operand (operands[1], E_SImode)
          || GET_MODE (x3) != E_SImode)
        return -1;
      return 8;

    case E_SQmode:
      if (!register_operand (operands[0], E_SQmode)
          || !memory_operand (operands[1], E_SQmode)
          || GET_MODE (x3) != E_SQmode)
        return -1;
      return 9;

    case E_USQmode:
      if (!register_operand (operands[0], E_USQmode)
          || !memory_operand (operands[1], E_USQmode)
          || GET_MODE (x3) != E_USQmode)
        return -1;
      return 10;

    case E_SAmode:
      if (!register_operand (operands[0], E_SAmode)
          || !memory_operand (operands[1], E_SAmode)
          || GET_MODE (x3) != E_SAmode)
        return -1;
      return 11;

    case E_USAmode:
      if (!register_operand (operands[0], E_USAmode)
          || !memory_operand (operands[1], E_USAmode)
          || GET_MODE (x3) != E_USAmode)
        return -1;
      return 12;

    case E_SFmode:
      if (!register_operand (operands[0], E_SFmode)
          || !memory_operand (operands[1], E_SFmode)
          || GET_MODE (x3) != E_SFmode)
        return -1;
      return 13;

    case E_PSImode:
      if (!register_operand (operands[0], E_PSImode)
          || !memory_operand (operands[1], E_PSImode)
          || GET_MODE (x3) != E_PSImode)
        return -1;
      return 14;

    default:
      return -1;
    }
}

int
pattern245 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != REG)
    return -1;
  x5 = XEXP (x2, 0);
  if (GET_CODE (x5) != REG)
    return -1;
  x6 = XEXP (x3, 0);
  switch (REGNO (x6))
    {
    case 24:
      switch (REGNO (x4))
        {
        case 22:
          return 0;

        case 18:
          return 1;

        default:
          return -1;
        }

    case 22:
      if (GET_MODE (x6) != E_SImode
          || REGNO (x4) != 18
          || GET_MODE (x4) != E_SImode
          || REGNO (x5) != 18
          || GET_MODE (x5) != E_SImode)
        return -1;
      x7 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x7) != SET)
        return -1;
      x8 = XEXP (x7, 1);
      if (GET_CODE (x8) != i1
          || GET_MODE (x8) != E_SImode)
        return -1;
      x9 = XEXP (x8, 0);
      if (GET_CODE (x9) != REG
          || REGNO (x9) != 22
          || GET_MODE (x9) != E_SImode)
        return -1;
      x10 = XEXP (x8, 1);
      if (GET_CODE (x10) != REG
          || REGNO (x10) != 18
          || GET_MODE (x10) != E_SImode)
        return -1;
      x11 = XEXP (x7, 0);
      if (GET_CODE (x11) != REG
          || REGNO (x11) != 22
          || GET_MODE (x11) != E_SImode
          || pattern243 (x1, 
E_SImode, 
E_HImode, 
30, 
26) != 0)
        return -1;
      return 2;

    case 26:
      if (REGNO (x4) != 22
          || REGNO (x5) != 24)
        return -1;
      x7 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x7) != CLOBBER)
        return -1;
      x11 = XEXP (x7, 0);
      if (GET_CODE (x11) != REG
          || REGNO (x11) != 26
          || GET_MODE (x11) != E_HImode)
        return -1;
      x12 = XVECEXP (x1, 0, 2);
      x13 = XEXP (x12, 0);
      if (REGNO (x13) != 21
          || GET_MODE (x13) != E_QImode)
        return -1;
      x14 = XVECEXP (x1, 0, 3);
      x15 = XEXP (x14, 0);
      if (REGNO (x15) != 36
          || GET_MODE (x15) != E_CCmode)
        return -1;
      res = pattern244 (x2);
      if (res >= 0)
        return res + 3; /* [3, 6] */
      return -1;

    default:
      return -1;
    }
}

int
pattern261 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  if (!register_operand (operands[0], E_HImode))
    return -1;
  x6 = XEXP (x4, 1);
  x7 = XVECEXP (x6, 0, 0);
  operands[1] = x7;
  if (!register_operand (operands[1], E_QImode))
    return -1;
  x8 = XVECEXP (x6, 0, 1);
  operands[2] = x8;
  if (!register_operand (operands[2], E_QImode))
    return -1;
  return 0;
}

int
pattern267 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  if (REGNO (x3) != 26
      || GET_MODE (x3) != E_HImode)
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  x5 = XEXP (x4, 0);
  if (REGNO (x5) != 18
      || GET_MODE (x5) != E_DImode)
    return -1;
  x6 = XVECEXP (x1, 0, 0);
  x7 = XEXP (x6, 0);
  operands[0] = x7;
  x8 = XEXP (x6, 1);
  x9 = XEXP (x8, 1);
  operands[2] = x9;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern266 (x8, 
E_SImode); /* [-1, 0] */

    case E_PSImode:
      if (pattern266 (x8, 
E_PSImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern277 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  if (REGNO (x3) != 26
      || GET_MODE (x3) != E_HImode)
    return -1;
  return pattern276 (x1); /* [-1, 1] */
}

int
pattern282 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  if (XINT (x3, 1) != 3
      || GET_MODE (x3) != E_HImode)
    return -1;
  x4 = XVECEXP (x3, 0, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 32
      || GET_MODE (x4) != E_HImode)
    return -1;
  x5 = XEXP (x2, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 32
      || GET_MODE (x5) != E_HImode)
    return -1;
  x6 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x6) != SET)
    return -1;
  x7 = XEXP (x6, 1);
  if (GET_CODE (x7) != UNSPEC_VOLATILE
      || XVECLEN (x7, 0) != 1
      || XINT (x7, 1) != 6
      || GET_MODE (x7) != E_BLKmode
      || !const_int_operand (operands[0], E_QImode))
    return -1;
  x8 = XVECEXP (x1, 0, 0);
  x9 = XVECEXP (x8, 0, 1);
  operands[1] = x9;
  if (!const_int_operand (operands[1], E_QImode))
    return -1;
  x10 = XEXP (x6, 0);
  operands[2] = x10;
  x11 = XVECEXP (x7, 0, 0);
  if (!rtx_equal_p (x11, operands[2]))
    return -1;
  return 0;
}

int
pattern294 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_HImode)
    return -1;
  x4 = XVECEXP (x3, 0, 0);
  if (REGNO (x4) != 24
      || GET_MODE (x4) != E_QImode)
    return -1;
  x5 = XVECEXP (x3, 0, 1);
  if (REGNO (x5) != 25
      || pattern262 (x1, 
24, 
E_HImode, 
22, 
E_HImode) != 0)
    return -1;
  return 0;
}

int
pattern296 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  switch (XINT (x3, 1))
    {
    case 4:
      return pattern294 (x1); /* [-1, 0] */

    case 5:
      if (pattern294 (x1) != 0)
        return -1;
      return 1;

    case 6:
      if (pattern294 (x1) != 0)
        return -1;
      return 2;

    case 8:
      x4 = XVECEXP (x3, 0, 1);
      if (REGNO (x4) != 24)
        return -1;
      res = pattern295 (x1);
      if (res >= 0)
        return res + 3; /* [3, 12] */
      return -1;

    default:
      return -1;
    }
}

int
pattern300 (rtx x1, machine_mode i1, unsigned int i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i3)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != i2
      || GET_MODE (x2) != i1)
    return -1;
  return 0;
}

int
pattern306 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_SImode
      || !pseudo_register_operand (operands[0], E_SImode)
      || GET_MODE (x1) != E_SImode)
    return -1;
  x3 = XEXP (x1, 0);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x2, 0);
  return pattern273 (x4); /* [-1, 3] */
}

int
pattern312 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !nonmemory_or_const_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern316 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x3) != CLOBBER)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != SCRATCH
      || GET_MODE (x4) != E_QImode)
    return -1;
  x5 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x5) != CLOBBER)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 36
      || GET_MODE (x6) != E_CCmode)
    return -1;
  x7 = XEXP (x2, 1);
  if (GET_MODE (x7) != i1)
    return -1;
  x8 = XEXP (x2, 0);
  if (!rtx_equal_p (x8, operands[0]))
    return -1;
  switch (GET_CODE (x7))
    {
    case PLUS:
      x9 = XEXP (x7, 1);
      operands[2] = x9;
      if (!register_operand (operands[2], i1))
        return -1;
      x10 = XEXP (x7, 0);
      if (!rtx_equal_p (x10, operands[0]))
        return -1;
      return 0;

    case IOR:
      x9 = XEXP (x7, 1);
      operands[2] = x9;
      if (!register_operand (operands[2], i1))
        return -1;
      x10 = XEXP (x7, 0);
      if (!rtx_equal_p (x10, operands[0]))
        return -1;
      return 1;

    case AND:
      x9 = XEXP (x7, 1);
      operands[2] = x9;
      if (!register_operand (operands[2], i1))
        return -1;
      x10 = XEXP (x7, 0);
      if (!rtx_equal_p (x10, operands[0]))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern334 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (REGNO (x3) != 10)
    return -1;
  x4 = XEXP (x1, 0);
  switch (GET_MODE (x4))
    {
    case E_DImode:
      if (GET_MODE (x2) != E_DImode)
        return -1;
      x5 = XEXP (x2, 0);
      if (GET_MODE (x5) != E_DImode
          || GET_MODE (x3) != E_DImode)
        return -1;
      return 0;

    case E_DQmode:
      if (GET_MODE (x2) != E_DQmode)
        return -1;
      x5 = XEXP (x2, 0);
      if (GET_MODE (x5) != E_DQmode
          || GET_MODE (x3) != E_DQmode)
        return -1;
      return 1;

    case E_UDQmode:
      if (GET_MODE (x2) != E_UDQmode)
        return -1;
      x5 = XEXP (x2, 0);
      if (GET_MODE (x5) != E_UDQmode
          || GET_MODE (x3) != E_UDQmode)
        return -1;
      return 2;

    case E_DAmode:
      if (GET_MODE (x2) != E_DAmode)
        return -1;
      x5 = XEXP (x2, 0);
      if (GET_MODE (x5) != E_DAmode
          || GET_MODE (x3) != E_DAmode)
        return -1;
      return 3;

    case E_UDAmode:
      if (GET_MODE (x2) != E_UDAmode)
        return -1;
      x5 = XEXP (x2, 0);
      if (GET_MODE (x5) != E_UDAmode
          || GET_MODE (x3) != E_UDAmode)
        return -1;
      return 4;

    case E_TAmode:
      if (GET_MODE (x2) != E_TAmode)
        return -1;
      x5 = XEXP (x2, 0);
      if (GET_MODE (x5) != E_TAmode
          || GET_MODE (x3) != E_TAmode)
        return -1;
      return 5;

    case E_UTAmode:
      if (GET_MODE (x2) != E_UTAmode)
        return -1;
      x5 = XEXP (x2, 0);
      if (GET_MODE (x5) != E_UTAmode
          || GET_MODE (x3) != E_UTAmode)
        return -1;
      return 6;

    default:
      return -1;
    }
}

int
pattern347 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 4);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_QImode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 1);
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 22
      || GET_MODE (x6) != E_PSImode)
    return -1;
  x7 = XEXP (x5, 1);
  if (GET_CODE (x7) != REG
      || REGNO (x7) != 18
      || GET_MODE (x7) != E_PSImode)
    return -1;
  x8 = XEXP (x4, 0);
  if (GET_CODE (x8) != REG
      || REGNO (x8) != 22
      || GET_MODE (x8) != E_PSImode)
    return -1;
  x9 = XVECEXP (x1, 0, 1);
  x10 = XEXP (x9, 1);
  x11 = XEXP (x10, 0);
  if (GET_CODE (x11) != REG
      || REGNO (x11) != 22
      || GET_MODE (x11) != E_PSImode)
    return -1;
  x12 = XEXP (x10, 1);
  if (GET_CODE (x12) != REG
      || REGNO (x12) != 18
      || GET_MODE (x12) != E_PSImode)
    return -1;
  x13 = XEXP (x9, 0);
  if (GET_CODE (x13) != REG
      || REGNO (x13) != 18
      || GET_MODE (x13) != E_PSImode)
    return -1;
  x14 = XVECEXP (x1, 0, 2);
  x15 = XEXP (x14, 0);
  if (REGNO (x15) != 21
      || GET_MODE (x15) != E_QImode)
    return -1;
  x16 = XVECEXP (x1, 0, 3);
  x17 = XEXP (x16, 0);
  if (REGNO (x17) != 25
      || GET_MODE (x17) != E_QImode)
    return -1;
  x18 = XVECEXP (x1, 0, 5);
  x19 = XEXP (x18, 0);
  if (REGNO (x19) != 36
      || GET_MODE (x19) != E_CCmode
      || GET_MODE (x5) != E_PSImode
      || GET_MODE (x10) != E_PSImode)
    return -1;
  return 0;
}

int
pattern367 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[3], i1)
      || !nonmemory_operand (operands[1], i1)
      || !register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[4], i1)
      || !nonmemory_operand (operands[5], i1))
    return -1;
  return 0;
}

int
pattern374 (rtx x1, machine_mode i1, machine_mode i2, unsigned int i3, unsigned int i4, unsigned int i5)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x3, 1);
  if (REGNO (x5) != i5
      || GET_MODE (x5) != i1)
    return -1;
  x6 = XEXP (x2, 0);
  if (REGNO (x6) != i5
      || GET_MODE (x6) != i1)
    return -1;
  x7 = XVECEXP (x1, 0, 1);
  x8 = XEXP (x7, 1);
  x9 = XEXP (x8, 0);
  if (REGNO (x9) != i4
      || GET_MODE (x9) != i1)
    return -1;
  x10 = XEXP (x8, 1);
  if (REGNO (x10) != i5
      || GET_MODE (x10) != i1)
    return -1;
  x11 = XEXP (x7, 0);
  if (REGNO (x11) != i4
      || GET_MODE (x11) != i1
      || pattern373 (x1, 
i1, 
i2, 
i3) != 0)
    return -1;
  return 0;
}

int
pattern384 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[3], i1)
      || !const_int_operand (operands[1], i1)
      || !register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[4], i1)
      || !const_int_operand (operands[5], i1))
    return -1;
  return 0;
}

int
pattern388 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!l_register_operand (operands[0], i1)
      || !const_operand (operands[1], i1)
      || !l_register_operand (operands[3], i1)
      || GET_MODE (x1) != i1)
    return -1;
  return 0;
}

int
pattern392 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!const0_operand (operands[3], i1))
    return -1;
  switch (GET_CODE (x1))
    {
    case EQ:
      return pattern391 (x1); /* [-1, 0] */

    case NE:
      if (pattern391 (x1) != 0)
        return -1;
      return 1;

    case GE:
      if (pattern391 (x1) != 0)
        return -1;
      return 2;

    case LT:
      if (pattern391 (x1) != 0)
        return -1;
      return 3;

    case GT:
      if (pattern391 (x1) != 0)
        return -1;
      return 4;

    case LE:
      if (pattern391 (x1) != 0)
        return -1;
      return 5;

    default:
      return -1;
    }
}

 int
recog_1 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) == REG
      && REGNO (x2) == 22)
    {
      x3 = XEXP (x1, 1);
      operands[0] = x3;
      switch (pattern159 (x2))
        {
        case 0:
          if (
#line 572 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))))
            return 5; /* load_qi_libgcc */
          if (pnum_clobbers != NULL
              && 
#line 585 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))
   && reload_completed))
            {
              *pnum_clobbers = 1;
              return 20; /* *load_qi_libgcc */
            }
          break;

        case 1:
          if (
#line 572 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))))
            return 6; /* load_qq_libgcc */
          if (pnum_clobbers != NULL
              && 
#line 585 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))
   && reload_completed))
            {
              *pnum_clobbers = 1;
              return 21; /* *load_qq_libgcc */
            }
          break;

        case 2:
          if (
#line 572 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))))
            return 7; /* load_uqq_libgcc */
          if (pnum_clobbers != NULL
              && 
#line 585 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))
   && reload_completed))
            {
              *pnum_clobbers = 1;
              return 22; /* *load_uqq_libgcc */
            }
          break;

        case 3:
          if (
#line 572 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))))
            return 8; /* load_hi_libgcc */
          if (pnum_clobbers != NULL
              && 
#line 585 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))
   && reload_completed))
            {
              *pnum_clobbers = 1;
              return 23; /* *load_hi_libgcc */
            }
          break;

        case 4:
          if (
#line 572 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))))
            return 9; /* load_hq_libgcc */
          if (pnum_clobbers != NULL
              && 
#line 585 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))
   && reload_completed))
            {
              *pnum_clobbers = 1;
              return 24; /* *load_hq_libgcc */
            }
          break;

        case 5:
          if (
#line 572 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))))
            return 10; /* load_uhq_libgcc */
          if (pnum_clobbers != NULL
              && 
#line 585 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))
   && reload_completed))
            {
              *pnum_clobbers = 1;
              return 25; /* *load_uhq_libgcc */
            }
          break;

        case 6:
          if (
#line 572 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))))
            return 11; /* load_ha_libgcc */
          if (pnum_clobbers != NULL
              && 
#line 585 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))
   && reload_completed))
            {
              *pnum_clobbers = 1;
              return 26; /* *load_ha_libgcc */
            }
          break;

        case 7:
          if (
#line 572 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))))
            return 12; /* load_uha_libgcc */
          if (pnum_clobbers != NULL
              && 
#line 585 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))
   && reload_completed))
            {
              *pnum_clobbers = 1;
              return 27; /* *load_uha_libgcc */
            }
          break;

        case 8:
          if (
#line 572 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))))
            return 13; /* load_si_libgcc */
          if (pnum_clobbers != NULL
              && 
#line 585 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))
   && reload_completed))
            {
              *pnum_clobbers = 1;
              return 28; /* *load_si_libgcc */
            }
          break;

        case 9:
          if (
#line 572 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))))
            return 14; /* load_sq_libgcc */
          if (pnum_clobbers != NULL
              && 
#line 585 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))
   && reload_completed))
            {
              *pnum_clobbers = 1;
              return 29; /* *load_sq_libgcc */
            }
          break;

        case 10:
          if (
#line 572 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))))
            return 15; /* load_usq_libgcc */
          if (pnum_clobbers != NULL
              && 
#line 585 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))
   && reload_completed))
            {
              *pnum_clobbers = 1;
              return 30; /* *load_usq_libgcc */
            }
          break;

        case 11:
          if (
#line 572 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))))
            return 16; /* load_sa_libgcc */
          if (pnum_clobbers != NULL
              && 
#line 585 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))
   && reload_completed))
            {
              *pnum_clobbers = 1;
              return 31; /* *load_sa_libgcc */
            }
          break;

        case 12:
          if (
#line 572 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))))
            return 17; /* load_usa_libgcc */
          if (pnum_clobbers != NULL
              && 
#line 585 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))
   && reload_completed))
            {
              *pnum_clobbers = 1;
              return 32; /* *load_usa_libgcc */
            }
          break;

        case 13:
          if (
#line 572 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))))
            return 18; /* load_sf_libgcc */
          if (pnum_clobbers != NULL
              && 
#line 585 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))
   && reload_completed))
            {
              *pnum_clobbers = 1;
              return 33; /* *load_sf_libgcc */
            }
          break;

        case 14:
          if (
#line 572 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))))
            return 19; /* load_psi_libgcc */
          if (pnum_clobbers != NULL
              && 
#line 585 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))
   && reload_completed))
            {
              *pnum_clobbers = 1;
              return 34; /* *load_psi_libgcc */
            }
          break;

        default:
          break;
        }
    }
  if (pnum_clobbers == NULL)
    return -1;
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  switch (pattern122 (x3))
    {
    case 0:
      if (!
#line 599 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false))))
        return -1;
      *pnum_clobbers = 1;
      return 35; /* fxmovqi_A */

    case 1:
      if (!
#line 599 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false))))
        return -1;
      *pnum_clobbers = 1;
      return 36; /* fxmovqq_A */

    case 2:
      if (!
#line 599 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false))))
        return -1;
      *pnum_clobbers = 1;
      return 37; /* fxmovuqq_A */

    case 3:
      if (!
#line 599 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false))))
        return -1;
      *pnum_clobbers = 1;
      return 38; /* fxmovhi_A */

    case 4:
      if (!
#line 599 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false))))
        return -1;
      *pnum_clobbers = 1;
      return 39; /* fxmovhq_A */

    case 5:
      if (!
#line 599 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false))))
        return -1;
      *pnum_clobbers = 1;
      return 40; /* fxmovuhq_A */

    case 6:
      if (!
#line 599 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false))))
        return -1;
      *pnum_clobbers = 1;
      return 41; /* fxmovha_A */

    case 7:
      if (!
#line 599 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false))))
        return -1;
      *pnum_clobbers = 1;
      return 42; /* fxmovuha_A */

    case 8:
      if (!
#line 599 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false))))
        return -1;
      *pnum_clobbers = 1;
      return 43; /* fxmovsi_A */

    case 9:
      if (!
#line 599 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false))))
        return -1;
      *pnum_clobbers = 1;
      return 44; /* fxmovsq_A */

    case 10:
      if (!
#line 599 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false))))
        return -1;
      *pnum_clobbers = 1;
      return 45; /* fxmovusq_A */

    case 11:
      if (!
#line 599 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false))))
        return -1;
      *pnum_clobbers = 1;
      return 46; /* fxmovsa_A */

    case 12:
      if (!
#line 599 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false))))
        return -1;
      *pnum_clobbers = 1;
      return 47; /* fxmovusa_A */

    case 13:
      if (!
#line 599 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false))))
        return -1;
      *pnum_clobbers = 1;
      return 48; /* fxmovsf_A */

    case 14:
      if (!
#line 599 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false))))
        return -1;
      *pnum_clobbers = 1;
      return 49; /* fxmovpsi_A */

    default:
      return -1;
    }
}

 int
recog_26 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (XVECLEN (x2, 0))
    {
    case 3:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      switch (pattern68 (x2))
        {
        case 0:
          return 172; /* *strlenhi_split */

        case 1:
          return 1011; /* insert_bits */

        case 2:
          return 3126; /* roundqq3_const */

        case 3:
          return 3127; /* roundhq3_const */

        case 4:
          return 3128; /* roundha3_const */

        case 5:
          return 3129; /* roundsa3_const */

        case 6:
          return 3130; /* roundsq3_const */

        case 7:
          return 3131; /* rounduqq3_const */

        case 8:
          return 3132; /* rounduhq3_const */

        case 9:
          return 3133; /* rounduha3_const */

        case 10:
          return 3134; /* roundusa3_const */

        case 11:
          return 3135; /* roundusq3_const */

        default:
          return -1;
        }

    case 2:
      switch (XINT (x2, 1))
        {
        case 4:
          if (GET_MODE (x2) != E_HImode)
            return -1;
          x3 = XEXP (x1, 0);
          operands[0] = x3;
          if (register_operand (operands[0], E_HImode))
            {
              x4 = XVECEXP (x2, 0, 0);
              operands[1] = x4;
              if (register_operand (operands[1], E_QImode))
                {
                  x5 = XVECEXP (x2, 0, 1);
                  operands[2] = x5;
                  if (register_operand (operands[2], E_QImode))
                    {
                      if (
#line 9707 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
                        return 1057; /* fmul_insn */
                      if (pnum_clobbers != NULL
                          && 
#line 9722 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
                        {
                          *pnum_clobbers = 1;
                          return 1058; /* *fmul_insn */
                        }
                    }
                }
            }
          if (pnum_clobbers == NULL
              || pattern160 (x1) != 0)
            return -1;
          if (
#line 9733 "../../gcc/config/avr/avr.md"
(!AVR_HAVE_MUL))
            {
              *pnum_clobbers = 1;
              return 1059; /* *fmul.call_split */
            }
          if (!
#line 9748 "../../gcc/config/avr/avr.md"
(!AVR_HAVE_MUL && reload_completed))
            return -1;
          *pnum_clobbers = 2;
          return 1060; /* *fmul.call */

        case 5:
          if (GET_MODE (x2) != E_HImode)
            return -1;
          x3 = XEXP (x1, 0);
          operands[0] = x3;
          if (register_operand (operands[0], E_HImode))
            {
              x4 = XVECEXP (x2, 0, 0);
              operands[1] = x4;
              if (register_operand (operands[1], E_QImode))
                {
                  x5 = XVECEXP (x2, 0, 1);
                  operands[2] = x5;
                  if (register_operand (operands[2], E_QImode))
                    {
                      if (
#line 9779 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
                        return 1061; /* fmuls_insn */
                      if (pnum_clobbers != NULL
                          && 
#line 9794 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
                        {
                          *pnum_clobbers = 1;
                          return 1062; /* *fmuls_insn */
                        }
                    }
                }
            }
          if (pnum_clobbers == NULL
              || pattern160 (x1) != 0)
            return -1;
          if (
#line 9805 "../../gcc/config/avr/avr.md"
(!AVR_HAVE_MUL))
            {
              *pnum_clobbers = 1;
              return 1063; /* *fmuls.call_split */
            }
          if (!
#line 9820 "../../gcc/config/avr/avr.md"
(!AVR_HAVE_MUL && reload_completed))
            return -1;
          *pnum_clobbers = 2;
          return 1064; /* *fmuls.call */

        case 6:
          if (GET_MODE (x2) != E_HImode)
            return -1;
          x3 = XEXP (x1, 0);
          operands[0] = x3;
          if (register_operand (operands[0], E_HImode))
            {
              x4 = XVECEXP (x2, 0, 0);
              operands[1] = x4;
              if (register_operand (operands[1], E_QImode))
                {
                  x5 = XVECEXP (x2, 0, 1);
                  operands[2] = x5;
                  if (register_operand (operands[2], E_QImode))
                    {
                      if (
#line 9851 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
                        return 1065; /* fmulsu_insn */
                      if (pnum_clobbers != NULL
                          && 
#line 9866 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
                        {
                          *pnum_clobbers = 1;
                          return 1066; /* *fmulsu_insn */
                        }
                    }
                }
            }
          if (pnum_clobbers == NULL
              || pattern160 (x1) != 0)
            return -1;
          if (
#line 9877 "../../gcc/config/avr/avr.md"
(!AVR_HAVE_MUL))
            {
              *pnum_clobbers = 1;
              return 1067; /* *fmulsu.call_split */
            }
          if (!
#line 9892 "../../gcc/config/avr/avr.md"
(!AVR_HAVE_MUL && reload_completed))
            return -1;
          *pnum_clobbers = 2;
          return 1068; /* *fmulsu.call */

        case 8:
          if (pnum_clobbers == NULL)
            return -1;
          x4 = XVECEXP (x2, 0, 0);
          if (GET_CODE (x4) != REG)
            return -1;
          x5 = XVECEXP (x2, 0, 1);
          if (GET_CODE (x5) != REG
              || REGNO (x5) != 24
              || GET_MODE (x5) != E_QImode)
            return -1;
          x3 = XEXP (x1, 0);
          if (GET_CODE (x3) != REG)
            return -1;
          switch (REGNO (x4))
            {
            case 22:
              if (REGNO (x3) != 24)
                return -1;
              switch (GET_MODE (x3))
                {
                case E_QQmode:
                  if (GET_MODE (x2) != E_QQmode
                      || GET_MODE (x4) != E_QQmode)
                    return -1;
                  *pnum_clobbers = 1;
                  return 3146; /* *roundqq3.libgcc_split */

                case E_UQQmode:
                  if (GET_MODE (x2) != E_UQQmode
                      || GET_MODE (x4) != E_UQQmode)
                    return -1;
                  *pnum_clobbers = 1;
                  return 3147; /* *rounduqq3.libgcc_split */

                case E_HQmode:
                  if (GET_MODE (x2) != E_HQmode
                      || GET_MODE (x4) != E_HQmode)
                    return -1;
                  *pnum_clobbers = 1;
                  return 3150; /* *roundhq3.libgcc_split */

                case E_UHQmode:
                  if (GET_MODE (x2) != E_UHQmode
                      || GET_MODE (x4) != E_UHQmode)
                    return -1;
                  *pnum_clobbers = 1;
                  return 3151; /* *rounduhq3.libgcc_split */

                case E_HAmode:
                  if (GET_MODE (x2) != E_HAmode
                      || GET_MODE (x4) != E_HAmode)
                    return -1;
                  *pnum_clobbers = 1;
                  return 3152; /* *roundha3.libgcc_split */

                case E_UHAmode:
                  if (GET_MODE (x2) != E_UHAmode
                      || GET_MODE (x4) != E_UHAmode)
                    return -1;
                  *pnum_clobbers = 1;
                  return 3153; /* *rounduha3.libgcc_split */

                default:
                  return -1;
                }

            case 18:
              if (REGNO (x3) != 22)
                return -1;
              switch (GET_MODE (x3))
                {
                case E_SQmode:
                  if (GET_MODE (x2) != E_SQmode
                      || GET_MODE (x4) != E_SQmode)
                    return -1;
                  *pnum_clobbers = 1;
                  return 3158; /* *roundsq3.libgcc_split */

                case E_USQmode:
                  if (GET_MODE (x2) != E_USQmode
                      || GET_MODE (x4) != E_USQmode)
                    return -1;
                  *pnum_clobbers = 1;
                  return 3159; /* *roundusq3.libgcc_split */

                case E_SAmode:
                  if (GET_MODE (x2) != E_SAmode
                      || GET_MODE (x4) != E_SAmode)
                    return -1;
                  *pnum_clobbers = 1;
                  return 3160; /* *roundsa3.libgcc_split */

                case E_USAmode:
                  if (GET_MODE (x2) != E_USAmode
                      || GET_MODE (x4) != E_USAmode)
                    return -1;
                  *pnum_clobbers = 1;
                  return 3161; /* *roundusa3.libgcc_split */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 1:
      if (pnum_clobbers == NULL
          || XINT (x2, 1) != 3
          || GET_MODE (x2) != E_QImode)
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      if (GET_CODE (x4) != IOR
          || GET_MODE (x4) != E_QImode)
        return -1;
      x6 = XEXP (x4, 0);
      if (GET_CODE (x6) != ASHIFT
          || GET_MODE (x6) != E_QImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_QImode))
        return -1;
      x7 = XEXP (x6, 0);
      operands[1] = x7;
      if (!register_operand (operands[1], E_QImode))
        return -1;
      x8 = XEXP (x6, 1);
      operands[2] = x8;
      if (!const_0_to_7_operand (operands[2], E_QImode))
        return -1;
      x9 = XEXP (x4, 1);
      operands[3] = x9;
      if (!register_operand (operands[3], E_QImode)
          || !
#line 11134 "../../gcc/config/avr/avr.md"
(optimize && avropt_use_nonzero_bits))
        return -1;
      *pnum_clobbers = 1;
      return 1495; /* *nzb=1.ior.ashift */

    default:
      return -1;
    }
}

 int
recog_31 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case REG:
    case SUBREG:
      operands[1] = x3;
      switch (pattern75 (x1, pnum_clobbers))
        {
        case 0:
          return 618; /* andqi3 */

        case 1:
          *pnum_clobbers = 1;
          return 620; /* andhi3 */

        case 2:
          *pnum_clobbers = 1;
          return 622; /* andpsi3 */

        case 3:
          *pnum_clobbers = 1;
          return 624; /* andsi3 */

        default:
          break;
        }
      if (GET_CODE (x3) != SUBREG
          || maybe_ne (SUBREG_BYTE (x3), 0)
          || GET_MODE (x3) != E_QImode)
        return -1;
      x4 = XEXP (x2, 1);
      if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      switch (pattern218 (x2))
        {
        case 0:
          if (!
#line 10636 "../../gcc/config/avr/avr.md"
(! reload_completed))
            return -1;
          return 1210; /* *extract.subreg.bit */

        case 1:
          if (!
#line 10636 "../../gcc/config/avr/avr.md"
(! reload_completed))
            return -1;
          return 1212; /* *extract.subreg.bit */

        case 2:
          if (!
#line 10636 "../../gcc/config/avr/avr.md"
(! reload_completed))
            return -1;
          return 1214; /* *extract.subreg.bit */

        case 3:
          if (!
#line 10636 "../../gcc/config/avr/avr.md"
(! reload_completed))
            return -1;
          return 1211; /* *extract.subreg.bit */

        case 4:
          if (!
#line 10636 "../../gcc/config/avr/avr.md"
(! reload_completed))
            return -1;
          return 1213; /* *extract.subreg.bit */

        case 5:
          if (!
#line 10636 "../../gcc/config/avr/avr.md"
(! reload_completed))
            return -1;
          return 1215; /* *extract.subreg.bit */

        default:
          return -1;
        }

    case MEM:
      if (pattern40 (x1) != 0
          || !single_zero_operand (operands[1], E_QImode))
        return -1;
      x6 = XEXP (x3, 0);
      if (!rtx_equal_p (x6, operands[0]))
        return -1;
      return 980; /* *cbi */

    case LSHIFTRT:
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      switch (pattern77 (x2))
        {
        case 0:
          return 1182; /* *insv.any_shift.qi_split */

        case 1:
          return 1185; /* *insv.any_shift.hi_split */

        case 2:
          return 1188; /* *insv.any_shift.psi_split */

        case 3:
          return 1191; /* *insv.any_shift.si_split */

        case 4:
          if (!
#line 10992 "../../gcc/config/avr/avr.md"
(optimize && avropt_use_nonzero_bits
   && !reload_completed
   && avr_nonzero_bits_lsr_operands_p (AND, operands)))
            return -1;
          return 1481; /* *nzb=1.and.lsr_split */

        case 5:
          if (!
#line 11042 "../../gcc/config/avr/avr.md"
(optimize && avropt_use_nonzero_bits
   && !reload_completed
   && INTVAL (operands[2]) == exact_log2 (0xff & INTVAL (operands[4]))
   && avr_nonzero_bits_lsr_operands_p (AND, operands)))
            return -1;
          return 1487; /* *nzb=1.and.lsr.not_split */

        default:
          return -1;
        }

    case ASHIFTRT:
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      switch (pattern78 (x2))
        {
        case 0:
          return 1183; /* *insv.any_shift.qi_split */

        case 1:
          return 1186; /* *insv.any_shift.hi_split */

        case 2:
          return 1189; /* *insv.any_shift.psi_split */

        case 3:
          return 1192; /* *insv.any_shift.si_split */

        default:
          return -1;
        }

    case ASHIFT:
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      switch (pattern78 (x2))
        {
        case 0:
          return 1184; /* *insv.any_shift.qi_split */

        case 1:
          return 1187; /* *insv.any_shift.hi_split */

        case 2:
          return 1190; /* *insv.any_shift.psi_split */

        case 3:
          return 1193; /* *insv.any_shift.si_split */

        default:
          return -1;
        }

    case SIGN_EXTRACT:
      x7 = XEXP (x3, 1);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      switch (pattern136 (x2))
        {
        case 0:
          if (!
#line 10918 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
            return -1;
          return 1457; /* *map.and1-to-skip.qi */

        case 1:
          if (!
#line 10918 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
            return -1;
          return 1461; /* *map.and1-to-skip.qi */

        case 2:
          if (!
#line 10918 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
            return -1;
          return 1465; /* *map.and1-to-skip.qi */

        case 3:
          if (!
#line 10918 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
            return -1;
          return 1469; /* *map.and1-to-skip.qi */

        case 4:
          if (!
#line 10918 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
            return -1;
          return 1458; /* *map.and1-to-skip.hi */

        case 5:
          if (!
#line 10918 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
            return -1;
          return 1462; /* *map.and1-to-skip.hi */

        case 6:
          if (!
#line 10918 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
            return -1;
          return 1466; /* *map.and1-to-skip.hi */

        case 7:
          if (!
#line 10918 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
            return -1;
          return 1470; /* *map.and1-to-skip.hi */

        case 8:
          if (!
#line 10918 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
            return -1;
          return 1459; /* *map.and1-to-skip.psi */

        case 9:
          if (!
#line 10918 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
            return -1;
          return 1463; /* *map.and1-to-skip.psi */

        case 10:
          if (!
#line 10918 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
            return -1;
          return 1467; /* *map.and1-to-skip.psi */

        case 11:
          if (!
#line 10918 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
            return -1;
          return 1471; /* *map.and1-to-skip.psi */

        case 12:
          if (!
#line 10918 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
            return -1;
          return 1460; /* *map.and1-to-skip.si */

        case 13:
          if (!
#line 10918 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
            return -1;
          return 1464; /* *map.and1-to-skip.si */

        case 14:
          if (!
#line 10918 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
            return -1;
          return 1468; /* *map.and1-to-skip.si */

        case 15:
          if (!
#line 10918 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
            return -1;
          return 1472; /* *map.and1-to-skip.si */

        default:
          return -1;
        }

    case ZERO_EXTRACT:
      switch (pattern42 (x1))
        {
        case 0:
          if (!
#line 10947 "../../gcc/config/avr/avr.md"
(optimize && avropt_use_nonzero_bits
   && !reload_completed
   && (AND == IOR || AND == XOR
       || nonzero_bits (operands[3], QImode) == 1)))
            return -1;
          return 1475; /* *nzb=1.and.zerox_split */

        case 1:
          if (!
#line 11016 "../../gcc/config/avr/avr.md"
(optimize && avropt_use_nonzero_bits
   && !reload_completed
   && INTVAL (operands[2]) == exact_log2 (0xff & INTVAL (operands[4]))
   && (AND == IOR
       || nonzero_bits (operands[3], QImode) == 1)))
            return -1;
          return 1484; /* *nzb=1.and.zerox.not_split */

        default:
          return -1;
        }

    case GE:
      if (pattern44 (x1) != 0
          || !
#line 11066 "../../gcc/config/avr/avr.md"
(optimize && avropt_use_nonzero_bits
   && !reload_completed
   && (AND == IOR || AND == XOR
       || nonzero_bits (operands[2], QImode) == 1)))
        return -1;
      return 1490; /* *nzb=1.and.ge0_split */

    default:
      return -1;
    }
}

 int
recog_43 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], E_HImode))
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_MODE (x4) != E_HImode)
    return -1;
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[1] = x6;
  if (!register_operand (operands[1], E_QImode))
    return -1;
  x7 = XEXP (x4, 1);
  switch (GET_CODE (x7))
    {
    case SIGN_EXTEND:
      if (pattern326 (x1) != 0
          || !
#line 2482 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
        return -1;
      return 480; /* mulqihi3 */

    case ZERO_EXTEND:
      if (pattern326 (x1) != 0
          || !
#line 2530 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
        return -1;
      return 485; /* *sumulqihi3 */

    case CONST_INT:
      operands[2] = x7;
      x8 = XVECEXP (x1, 0, 1);
      x9 = XEXP (x8, 0);
      operands[3] = x9;
      if (!scratch_operand (operands[3], E_QImode))
        return -1;
      if (s8_operand (operands[2], E_HImode)
          && 
#line 2998 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
        return 521; /* *mulsqihi3.sconst */
      if (u8_operand (operands[2], E_HImode)
          && 
#line 3034 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
        return 524; /* *mulsqihi3.uconst */
      if (!o8_operand (operands[2], E_HImode)
          || !
#line 3052 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
        return -1;
      return 525; /* *mulsqihi3.oconst */

    case REG:
    case SUBREG:
      if (pattern225 (x1) != 0
          || !
#line 3166 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
        return -1;
      return 532; /* *mulsqihi3 */

    default:
      return -1;
    }
}

 int
recog_47 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != CONST_INT)
    return -1;
  operands[2] = x4;
  if (const_0_to_7_operand (operands[2], E_QImode))
    {
      x5 = XVECEXP (x1, 0, 1);
      x6 = XEXP (x5, 0);
      if (GET_CODE (x6) == REG
          && REGNO (x6) == 36
          && GET_MODE (x6) == E_CCmode)
        {
          x7 = XEXP (x2, 0);
          operands[0] = x7;
          if (register_operand (operands[0], E_QImode)
              && GET_MODE (x3) == E_QImode
              && register_operand (operands[1], E_QImode)
              && 
#line 5039 "../../gcc/config/avr/avr.md"
(reload_completed))
            return 643; /* *rotlqi3 */
        }
    }
  if (const_int_operand (operands[2], E_VOIDmode))
    {
      x7 = XEXP (x2, 0);
      operands[0] = x7;
      switch (pattern254 (x1))
        {
        case 0:
          if (
#line 5236 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MOVW
   && CONST_INT_P (operands[2])
   && 2 % 2 == 0
   && 0 == INTVAL (operands[2]) % 16))
            return 656; /* *rotwhi */
          if (
#line 5259 "../../gcc/config/avr/avr.md"
(CONST_INT_P (operands[2])
   && (8 == INTVAL (operands[2]) % 16
       || ((!AVR_HAVE_MOVW
            || 2 % 2 != 0)
           && 0 == INTVAL (operands[2]) % 16))))
            return 658; /* *rotbhi */
          break;

        case 1:
          if (
#line 5236 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MOVW
   && CONST_INT_P (operands[2])
   && 4 % 2 == 0
   && 0 == INTVAL (operands[2]) % 16))
            return 657; /* *rotwsi */
          break;

        case 2:
          if (
#line 5259 "../../gcc/config/avr/avr.md"
(CONST_INT_P (operands[2])
   && (8 == INTVAL (operands[2]) % 16
       || ((!AVR_HAVE_MOVW
            || 4 % 2 != 0)
           && 0 == INTVAL (operands[2]) % 16))))
            return 660; /* *rotbsi */
          break;

        case 3:
          if (
#line 5259 "../../gcc/config/avr/avr.md"
(CONST_INT_P (operands[2])
   && (8 == INTVAL (operands[2]) % 16
       || ((!AVR_HAVE_MOVW
            || 3 % 2 != 0)
           && 0 == INTVAL (operands[2]) % 16))))
            return 659; /* *rotbpsi */
          break;

        default:
          break;
        }
    }
  x5 = XVECEXP (x1, 0, 1);
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 36
      || GET_MODE (x6) != E_CCmode)
    return -1;
  x7 = XEXP (x2, 0);
  operands[0] = x7;
  switch (XWINT (x4, 0))
    {
    case 1L:
      switch (GET_MODE (operands[0]))
        {
        case E_HImode:
          if (!register_operand (operands[0], E_HImode)
              || GET_MODE (x3) != E_HImode
              || !register_operand (operands[1], E_HImode)
              || !
#line 5112 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 645; /* *rotlhi2.1 */

        case E_PSImode:
          if (!register_operand (operands[0], E_PSImode)
              || GET_MODE (x3) != E_PSImode
              || !register_operand (operands[1], E_PSImode)
              || !
#line 5154 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 649; /* *rotlpsi2.1 */

        case E_SImode:
          if (!register_operand (operands[0], E_SImode)
              || GET_MODE (x3) != E_SImode
              || !register_operand (operands[1], E_SImode)
              || !
#line 5196 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 653; /* *rotlsi2.1 */

        default:
          return -1;
        }

    case 15L:
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x3) != E_HImode
          || !register_operand (operands[1], E_HImode)
          || !
#line 5133 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 647; /* *rotlhi2.15 */

    case 23L:
      if (!register_operand (operands[0], E_PSImode)
          || GET_MODE (x3) != E_PSImode
          || !register_operand (operands[1], E_PSImode)
          || !
#line 5175 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 651; /* *rotlpsi2.23 */

    case 31L:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode
          || !register_operand (operands[1], E_SImode)
          || !
#line 5217 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 655; /* *rotlsi2.31 */

    default:
      return -1;
    }
}

 int
recog_56 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 36)
    return -1;
  x4 = XEXP (x2, 1);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
      operands[0] = x5;
      res = recog_50 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      if (GET_CODE (x5) != REG
          || REGNO (x5) != 18)
        return -1;
      x6 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x6) != CLOBBER
          || GET_MODE (x3) != E_CCmode
          || GET_MODE (x4) != E_CCmode)
        return -1;
      x7 = XEXP (x4, 1);
      operands[0] = x7;
      x8 = XEXP (x6, 0);
      operands[1] = x8;
      if (!register_operand (operands[1], E_QImode))
        return -1;
      switch (GET_MODE (x5))
        {
        case E_DImode:
          if (!const_operand (operands[0], E_DImode)
              || !
#line 576 "../../gcc/config/avr/avr-dimode.md"
(reload_completed
   && avr_have_dimode
   && !s8_operand (operands[0], VOIDmode)))
            return -1;
          return 3297; /* compare_const_di2 */

        case E_DQmode:
          if (!const_operand (operands[0], E_DQmode)
              || !
#line 576 "../../gcc/config/avr/avr-dimode.md"
(reload_completed
   && avr_have_dimode
   && !s8_operand (operands[0], VOIDmode)))
            return -1;
          return 3298; /* compare_const_dq2 */

        case E_UDQmode:
          if (!const_operand (operands[0], E_UDQmode)
              || !
#line 576 "../../gcc/config/avr/avr-dimode.md"
(reload_completed
   && avr_have_dimode
   && !s8_operand (operands[0], VOIDmode)))
            return -1;
          return 3299; /* compare_const_udq2 */

        case E_DAmode:
          if (!const_operand (operands[0], E_DAmode)
              || !
#line 576 "../../gcc/config/avr/avr-dimode.md"
(reload_completed
   && avr_have_dimode
   && !s8_operand (operands[0], VOIDmode)))
            return -1;
          return 3300; /* compare_const_da2 */

        case E_UDAmode:
          if (!const_operand (operands[0], E_UDAmode)
              || !
#line 576 "../../gcc/config/avr/avr-dimode.md"
(reload_completed
   && avr_have_dimode
   && !s8_operand (operands[0], VOIDmode)))
            return -1;
          return 3301; /* compare_const_uda2 */

        case E_TAmode:
          if (!const_operand (operands[0], E_TAmode)
              || !
#line 576 "../../gcc/config/avr/avr-dimode.md"
(reload_completed
   && avr_have_dimode
   && !s8_operand (operands[0], VOIDmode)))
            return -1;
          return 3302; /* compare_const_ta2 */

        case E_UTAmode:
          if (!const_operand (operands[0], E_UTAmode)
              || !
#line 576 "../../gcc/config/avr/avr-dimode.md"
(reload_completed
   && avr_have_dimode
   && !s8_operand (operands[0], VOIDmode)))
            return -1;
          return 3303; /* compare_const_uta2 */

        default:
          return -1;
        }

    case LSHIFTRT:
      x7 = XEXP (x4, 1);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x6 = XVECEXP (x1, 0, 1);
      switch (GET_CODE (x6))
        {
        case CLOBBER:
          x8 = XEXP (x6, 0);
          if (GET_CODE (x8) != SCRATCH
              || GET_MODE (x8) != E_QImode
              || GET_MODE (x3) != E_CCmode
              || GET_MODE (x4) != E_CCmode)
            return -1;
          switch (pattern327 (x5))
            {
            case 0:
              if (!
#line 6912 "../../gcc/config/avr/avr.md"
(reload_completed))
                return -1;
              return 875; /* *cmphi_lsr */

            case 1:
              if (!
#line 6912 "../../gcc/config/avr/avr.md"
(reload_completed))
                return -1;
              return 876; /* *cmppsi_lsr */

            case 2:
              if (!
#line 6912 "../../gcc/config/avr/avr.md"
(reload_completed))
                return -1;
              return 877; /* *cmpsi_lsr */

            default:
              return -1;
            }

        case SET:
          x9 = XEXP (x6, 1);
          if (GET_CODE (x9) != LSHIFTRT
              || GET_MODE (x9) != E_QImode
              || GET_MODE (x3) != E_CCZNmode
              || GET_MODE (x4) != E_CCZNmode
              || GET_MODE (x5) != E_QImode
              || pattern336 (x1) != 0
              || !
#line 7610 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 947; /* *op8.for.cczn.lshiftrt */

        default:
          return -1;
        }

    case PLUS:
      x7 = XEXP (x4, 1);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x6 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x6) != SET)
        return -1;
      x9 = XEXP (x6, 1);
      if (GET_CODE (x9) != PLUS)
        return -1;
      x10 = XEXP (x5, 0);
      operands[3] = x10;
      x8 = XEXP (x6, 0);
      operands[0] = x8;
      switch (GET_MODE (x3))
        {
        case E_CCZNmode:
          if (GET_MODE (x4) != E_CCZNmode)
            return -1;
          switch (GET_MODE (x5))
            {
            case E_HImode:
              if (pattern343 (x1, pnum_clobbers, 
E_HImode) != 0
                  || !
#line 7338 "../../gcc/config/avr/avr.md"
(reload_completed))
                return -1;
              *pnum_clobbers = 1;
              return 916; /* *add.for.cczn.hi */

            case E_PSImode:
              if (pattern343 (x1, pnum_clobbers, 
E_PSImode) != 0
                  || !
#line 7338 "../../gcc/config/avr/avr.md"
(reload_completed))
                return -1;
              *pnum_clobbers = 1;
              return 917; /* *add.for.cczn.psi */

            case E_SImode:
              if (pattern343 (x1, pnum_clobbers, 
E_SImode) != 0
                  || !
#line 7338 "../../gcc/config/avr/avr.md"
(reload_completed))
                return -1;
              *pnum_clobbers = 1;
              return 918; /* *add.for.cczn.si */

            case E_QImode:
              if (!register_operand (operands[3], E_QImode))
                return -1;
              x11 = XEXP (x5, 1);
              operands[4] = x11;
              if (!nonmemory_operand (operands[4], E_QImode)
                  || !register_operand (operands[0], E_QImode)
                  || GET_MODE (x9) != E_QImode)
                return -1;
              x12 = XEXP (x9, 0);
              operands[1] = x12;
              if (!register_operand (operands[1], E_QImode))
                return -1;
              x13 = XEXP (x9, 1);
              operands[2] = x13;
              if (!nonmemory_operand (operands[2], E_QImode)
                  || !
#line 7610 "../../gcc/config/avr/avr.md"
(reload_completed))
                return -1;
              return 940; /* *op8.for.cczn.plus */

            default:
              return -1;
            }

        case E_CCNmode:
          if (pnum_clobbers == NULL
              || GET_MODE (x4) != E_CCNmode)
            return -1;
          x11 = XEXP (x5, 1);
          operands[1] = x11;
          x12 = XEXP (x9, 0);
          operands[4] = x12;
          x13 = XEXP (x9, 1);
          operands[5] = x13;
          switch (GET_MODE (x5))
            {
            case E_HImode:
              if (pattern367 (x9, 
E_HImode) != 0
                  || !
#line 7357 "../../gcc/config/avr/avr.md"
(reload_completed))
                return -1;
              *pnum_clobbers = 1;
              return 919; /* *add.for.ccn.hi */

            case E_PSImode:
              if (pattern367 (x9, 
E_PSImode) != 0
                  || !
#line 7357 "../../gcc/config/avr/avr.md"
(reload_completed))
                return -1;
              *pnum_clobbers = 1;
              return 920; /* *add.for.ccn.psi */

            case E_SImode:
              if (pattern367 (x9, 
E_SImode) != 0
                  || !
#line 7357 "../../gcc/config/avr/avr.md"
(reload_completed))
                return -1;
              *pnum_clobbers = 1;
              return 921; /* *add.for.ccn.si */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case MINUS:
      x7 = XEXP (x4, 1);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x6 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x6) != SET)
        return -1;
      x9 = XEXP (x6, 1);
      if (GET_CODE (x9) != MINUS
          || GET_MODE (x3) != E_CCZNmode
          || GET_MODE (x4) != E_CCZNmode)
        return -1;
      x10 = XEXP (x5, 0);
      operands[3] = x10;
      x8 = XEXP (x6, 0);
      operands[0] = x8;
      x12 = XEXP (x9, 0);
      operands[1] = x12;
      x11 = XEXP (x5, 1);
      switch (GET_CODE (x11))
        {
        case REG:
        case SUBREG:
          operands[4] = x11;
          x13 = XEXP (x9, 1);
          operands[2] = x13;
          switch (GET_MODE (x5))
            {
            case E_HImode:
              if (pattern368 (x9, 
E_HImode) != 0
                  || !
#line 7473 "../../gcc/config/avr/avr.md"
(reload_completed))
                return -1;
              return 922; /* *sub.for.cczn.hi */

            case E_PSImode:
              if (pattern368 (x9, 
E_PSImode) != 0
                  || !
#line 7473 "../../gcc/config/avr/avr.md"
(reload_completed))
                return -1;
              return 923; /* *sub.for.cczn.psi */

            case E_SImode:
              if (pattern368 (x9, 
E_SImode) != 0
                  || !
#line 7473 "../../gcc/config/avr/avr.md"
(reload_completed))
                return -1;
              return 924; /* *sub.for.cczn.si */

            case E_QImode:
              if (pattern368 (x9, 
E_QImode) != 0
                  || !
#line 7610 "../../gcc/config/avr/avr.md"
(reload_completed))
                return -1;
              return 941; /* *op8.for.cczn.minus */

            default:
              return -1;
            }

        case SIGN_EXTEND:
          switch (pattern355 (x1, 
SIGN_EXTEND))
            {
            case 0:
              if (!
#line 7489 "../../gcc/config/avr/avr.md"
(reload_completed
   && 2 > 1))
                return -1;
              return 925; /* *sub-extendqi.for.cczn.hi */

            case 1:
              if (!
#line 7489 "../../gcc/config/avr/avr.md"
(reload_completed
   && 3 > 1))
                return -1;
              return 927; /* *sub-extendqi.for.cczn.psi */

            case 2:
              if (!
#line 7489 "../../gcc/config/avr/avr.md"
(reload_completed
   && 3 > 2))
                return -1;
              return 931; /* *sub-extendhi.for.cczn.psi */

            case 3:
              if (!
#line 7489 "../../gcc/config/avr/avr.md"
(reload_completed
   && 4 > 1))
                return -1;
              return 929; /* *sub-extendqi.for.cczn.si */

            case 4:
              if (!
#line 7489 "../../gcc/config/avr/avr.md"
(reload_completed
   && 4 > 2))
                return -1;
              return 933; /* *sub-extendhi.for.cczn.si */

            case 5:
              if (!
#line 7489 "../../gcc/config/avr/avr.md"
(reload_completed
   && 4 > 3))
                return -1;
              return 935; /* *sub-extendpsi.for.cczn.si */

            default:
              return -1;
            }

        case ZERO_EXTEND:
          switch (pattern355 (x1, 
ZERO_EXTEND))
            {
            case 0:
              if (!
#line 7489 "../../gcc/config/avr/avr.md"
(reload_completed
   && 2 > 1))
                return -1;
              return 926; /* *sub-extendqi.for.cczn.hi */

            case 1:
              if (!
#line 7489 "../../gcc/config/avr/avr.md"
(reload_completed
   && 3 > 1))
                return -1;
              return 928; /* *sub-extendqi.for.cczn.psi */

            case 2:
              if (!
#line 7489 "../../gcc/config/avr/avr.md"
(reload_completed
   && 3 > 2))
                return -1;
              return 932; /* *sub-extendhi.for.cczn.psi */

            case 3:
              if (!
#line 7489 "../../gcc/config/avr/avr.md"
(reload_completed
   && 4 > 1))
                return -1;
              return 930; /* *sub-extendqi.for.cczn.si */

            case 4:
              if (!
#line 7489 "../../gcc/config/avr/avr.md"
(reload_completed
   && 4 > 2))
                return -1;
              return 934; /* *sub-extendhi.for.cczn.si */

            case 5:
              if (!
#line 7489 "../../gcc/config/avr/avr.md"
(reload_completed
   && 4 > 3))
                return -1;
              return 936; /* *sub-extendpsi.for.cczn.si */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case ASHIFT:
      x11 = XEXP (x5, 1);
      if (GET_CODE (x11) != CONST_INT)
        return -1;
      x7 = XEXP (x4, 1);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x6 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x6) != SET)
        return -1;
      x9 = XEXP (x6, 1);
      if (GET_CODE (x9) != ASHIFT)
        return -1;
      x8 = XEXP (x6, 0);
      operands[0] = x8;
      x12 = XEXP (x9, 0);
      operands[1] = x12;
      if (XWINT (x11, 0) == 1L)
        {
          res = recog_51 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      if (!register_operand (operands[1], E_QImode)
          || GET_MODE (x3) != E_CCZNmode
          || GET_MODE (x4) != E_CCZNmode
          || GET_MODE (x5) != E_QImode)
        return -1;
      x10 = XEXP (x5, 0);
      operands[3] = x10;
      if (!register_operand (operands[3], E_QImode))
        return -1;
      operands[4] = x11;
      if (!const_1_to_3_operand (operands[4], E_QImode)
          || !register_operand (operands[0], E_QImode)
          || GET_MODE (x9) != E_QImode)
        return -1;
      x13 = XEXP (x9, 1);
      operands[2] = x13;
      if (!const_1_to_3_operand (operands[2], E_QImode)
          || !
#line 7610 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 945; /* *op8.for.cczn.ashift */

    case AND:
      if (pattern208 (x1, 
AND) != 0
          || !
#line 7610 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 942; /* *op8.for.cczn.and */

    case IOR:
      if (pattern208 (x1, 
IOR) != 0
          || !
#line 7610 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 943; /* *op8.for.cczn.ior */

    case XOR:
      if (pattern209 (x1, 
XOR) != 0
          || GET_MODE (x3) != E_CCZNmode
          || GET_MODE (x4) != E_CCZNmode)
        return -1;
      x10 = XEXP (x5, 0);
      operands[3] = x10;
      if (!register_operand (operands[3], E_QImode))
        return -1;
      x11 = XEXP (x5, 1);
      operands[4] = x11;
      if (!register_operand (operands[4], E_QImode))
        return -1;
      x6 = XVECEXP (x1, 0, 1);
      x8 = XEXP (x6, 0);
      operands[0] = x8;
      if (!register_operand (operands[0], E_QImode))
        return -1;
      x9 = XEXP (x6, 1);
      x12 = XEXP (x9, 0);
      operands[1] = x12;
      if (!register_operand (operands[1], E_QImode))
        return -1;
      x13 = XEXP (x9, 1);
      operands[2] = x13;
      if (!register_operand (operands[2], E_QImode)
          || !
#line 7610 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 944; /* *op8.for.cczn.xor */

    case ASHIFTRT:
      if (pattern209 (x1, 
ASHIFTRT) != 0
          || GET_MODE (x3) != E_CCZNmode
          || GET_MODE (x4) != E_CCZNmode
          || pattern336 (x1) != 0
          || !
#line 7610 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 946; /* *op8.for.cczn.ashiftrt */

    default:
      return -1;
    }
}

 int
recog_79 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != REG)
    return -1;
  x5 = XEXP (x2, 0);
  if (GET_CODE (x5) != REG)
    return -1;
  x6 = XEXP (x3, 0);
  switch (REGNO (x6))
    {
    case 24:
      x7 = XVECEXP (x1, 0, 1);
      x8 = XEXP (x7, 0);
      if (REGNO (x8) != 22)
        return -1;
      switch (REGNO (x4))
        {
        case 22:
          if (REGNO (x5) != 24)
            return -1;
          x9 = XVECEXP (x1, 0, 2);
          x10 = XEXP (x9, 0);
          switch (REGNO (x10))
            {
            case 36:
              if (pattern359 (x1, 
E_QImode, 
E_CCmode) != 0
                  || !
#line 2256 "../../gcc/config/avr/avr.md"
(!AVR_HAVE_MUL && reload_completed))
                return -1;
              return 303; /* *mulqi3_call */

            case 21:
              if (pattern359 (x1, 
E_HImode, 
E_QImode) != 0
                  || !
#line 3319 "../../gcc/config/avr/avr.md"
(!AVR_HAVE_MUL))
                return -1;
              return 539; /* *mulhi3_call_split */

            default:
              return -1;
            }

        case 25:
          if (pattern341 (x1) != 0
              || !
#line 377 "../../gcc/config/avr/avr-fixed.md"
(!AVR_HAVE_MUL))
            return -1;
          return 3080; /* *mulqq3.call_split */

        default:
          return -1;
        }

    case 22:
      if (GET_MODE (x6) != E_SImode
          || REGNO (x4) != 18
          || GET_MODE (x4) != E_SImode
          || REGNO (x5) != 22
          || GET_MODE (x5) != E_SImode
          || pattern360 (x1, 
E_CCmode, 
36, 
E_HImode, 
26) != 0
          || GET_MODE (x3) != E_SImode
          || !
#line 3754 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
        return -1;
      return 566; /* *mulsi3_call */

    case 18:
      switch (pattern309 (x1, 
E_CCmode, 
36, 
22, 
26))
        {
        case 0:
          if (!
#line 440 "../../gcc/config/avr/avr-fixed.md"
(AVR_HAVE_MUL && reload_completed))
            return -1;
          return 3086; /* *mulhq3.call */

        case 1:
          if (!
#line 440 "../../gcc/config/avr/avr-fixed.md"
(AVR_HAVE_MUL && reload_completed))
            return -1;
          return 3087; /* *muluhq3.call */

        case 2:
          if (!
#line 440 "../../gcc/config/avr/avr-fixed.md"
(AVR_HAVE_MUL && reload_completed))
            return -1;
          return 3088; /* *mulha3.call */

        case 3:
          if (!
#line 440 "../../gcc/config/avr/avr-fixed.md"
(AVR_HAVE_MUL && reload_completed))
            return -1;
          return 3089; /* *muluha3.call */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_83 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case MEM:
      x4 = XEXP (x3, 0);
      if (pattern104 (x4, 
21) != 0
          || pattern172 (x1, 
21, 
22, 
E_QImode) != 0)
        return -1;
      x5 = XVECEXP (x1, 0, 2);
      if (GET_CODE (x5) != CLOBBER)
        return -1;
      x6 = XEXP (x5, 0);
      if (GET_CODE (x6) != REG)
        return -1;
      switch (pattern379 (x1))
        {
        case 0:
          if (!
#line 715 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
    || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true)))
            return -1;
          return 83; /* fxload_qi_libgcc */

        case 1:
          if (!
#line 715 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
    || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true)))
            return -1;
          return 84; /* fxload_qq_libgcc */

        case 2:
          if (!
#line 715 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
    || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true)))
            return -1;
          return 85; /* fxload_uqq_libgcc */

        case 3:
          if (!
#line 715 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
    || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true)))
            return -1;
          return 86; /* fxload_hi_libgcc */

        case 4:
          if (!
#line 715 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
    || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true)))
            return -1;
          return 87; /* fxload_hq_libgcc */

        case 5:
          if (!
#line 715 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
    || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true)))
            return -1;
          return 88; /* fxload_uhq_libgcc */

        case 6:
          if (!
#line 715 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
    || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true)))
            return -1;
          return 89; /* fxload_ha_libgcc */

        case 7:
          if (!
#line 715 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
    || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true)))
            return -1;
          return 90; /* fxload_uha_libgcc */

        case 8:
          if (!
#line 715 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
    || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true)))
            return -1;
          return 91; /* fxload_si_libgcc */

        case 9:
          if (!
#line 715 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
    || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true)))
            return -1;
          return 92; /* fxload_sq_libgcc */

        case 10:
          if (!
#line 715 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
    || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true)))
            return -1;
          return 93; /* fxload_usq_libgcc */

        case 11:
          if (!
#line 715 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
    || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true)))
            return -1;
          return 94; /* fxload_sa_libgcc */

        case 12:
          if (!
#line 715 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
    || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true)))
            return -1;
          return 95; /* fxload_usa_libgcc */

        case 13:
          if (!
#line 715 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
    || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true)))
            return -1;
          return 96; /* fxload_sf_libgcc */

        case 14:
          if (!
#line 715 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
    || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true)))
            return -1;
          return 97; /* fxload_psi_libgcc */

        default:
          return -1;
        }

    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      operands[1] = x3;
      res = recog_78 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      if (pnum_clobbers == NULL
          || x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
          || pattern174 (x1) != 0)
        return -1;
      x7 = XEXP (x2, 0);
      x8 = XEXP (x7, 0);
      operands[0] = x8;
      if (!register_operand (operands[0], E_HImode))
        return -1;
      x9 = XVECEXP (x1, 0, 1);
      x10 = XEXP (x9, 0);
      operands[1] = x10;
      x5 = XVECEXP (x1, 0, 2);
      x6 = XEXP (x5, 0);
      operands[2] = x6;
      if (!const_int_operand (operands[2], E_HImode))
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          *pnum_clobbers = 2;
          return 168; /* *clrmemqi_split */

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          *pnum_clobbers = 2;
          return 170; /* *clrmemhi_split */

        default:
          return -1;
        }

    case PLUS:
      return recog_82 (x1, insn, pnum_clobbers);

    case MINUS:
      if (pattern105 (x1) != 0
          || !scratch_operand (operands[3], E_QImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_HImode:
          if (pattern312 (x3, 
E_HImode) != 0
              || !
#line 2152 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 285; /* *subhi3 */

        case E_HQmode:
          if (pattern312 (x3, 
E_HQmode) != 0
              || !
#line 2152 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 286; /* *subhq3 */

        case E_UHQmode:
          if (pattern312 (x3, 
E_UHQmode) != 0
              || !
#line 2152 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 287; /* *subuhq3 */

        case E_HAmode:
          if (pattern312 (x3, 
E_HAmode) != 0
              || !
#line 2152 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 288; /* *subha3 */

        case E_UHAmode:
          if (pattern312 (x3, 
E_UHAmode) != 0
              || !
#line 2152 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 289; /* *subuha3 */

        case E_SImode:
          if (pattern312 (x3, 
E_SImode) != 0
              || !
#line 2182 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 295; /* *subsi3 */

        case E_SQmode:
          if (pattern312 (x3, 
E_SQmode) != 0
              || !
#line 2182 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 296; /* *subsq3 */

        case E_USQmode:
          if (pattern312 (x3, 
E_USQmode) != 0
              || !
#line 2182 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 297; /* *subusq3 */

        case E_SAmode:
          if (pattern312 (x3, 
E_SAmode) != 0
              || !
#line 2182 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 298; /* *subsa3 */

        case E_USAmode:
          if (pattern312 (x3, 
E_USAmode) != 0
              || !
#line 2182 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 299; /* *subusa3 */

        default:
          return -1;
        }

    case MULT:
      return recog_80 (x1, insn, pnum_clobbers);

    case TRUNCATE:
      if (pattern107 (x2, 
24, 
E_HImode) != 0
          || pattern106 (x1) != 0)
        return -1;
      x4 = XEXP (x3, 0);
      if (GET_MODE (x4) != E_SImode)
        return -1;
      switch (GET_CODE (x4))
        {
        case LSHIFTRT:
          x11 = XEXP (x4, 0);
          if (GET_CODE (x11) != MULT
              || GET_MODE (x11) != E_SImode)
            return -1;
          x12 = XEXP (x4, 1);
          if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + 16]
              || pattern360 (x1, 
E_CCmode, 
36, 
E_HImode, 
22) != 0)
            return -1;
          switch (pattern362 (x11))
            {
            case 0:
              if (!
#line 3821 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
                return -1;
              return 574; /* *smulhi3_highpart_call */

            case 1:
              if (!
#line 3821 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
                return -1;
              return 575; /* *umulhi3_highpart_call */

            default:
              return -1;
            }

        case CLZ:
          x11 = XEXP (x4, 0);
          if (GET_CODE (x11) != REG
              || REGNO (x11) != 22
              || GET_MODE (x11) != E_SImode
              || pattern360 (x1, 
E_CCmode, 
36, 
E_QImode, 
26) != 0
              || !
#line 9420 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 1042; /* *clzsihi2.libgcc */

        case CTZ:
          if (pattern338 (x1) != 0)
            return -1;
          return 1045; /* *ctzsihi2.libgcc_split */

        case FFS:
          if (pattern338 (x1) != 0)
            return -1;
          return 1049; /* *ffssihi2.libgcc_split */

        default:
          return -1;
        }

    case UDIV:
      x4 = XEXP (x3, 0);
      if (GET_CODE (x4) != REG)
        return -1;
      x13 = XEXP (x3, 1);
      if (GET_CODE (x13) != REG)
        return -1;
      x7 = XEXP (x2, 0);
      if (GET_CODE (x7) != REG)
        return -1;
      x5 = XVECEXP (x1, 0, 2);
      if (GET_CODE (x5) != CLOBBER)
        return -1;
      x6 = XEXP (x5, 0);
      if (GET_CODE (x6) != REG)
        return -1;
      switch (REGNO (x4))
        {
        case 24:
          switch (pattern278 (x1))
            {
            case 0:
              return 588; /* *udivmodqi4_call_split */

            case 1:
              return 3118; /* *udivsa3.call_split */

            case 2:
              return 3120; /* *udivusa3.call_split */

            default:
              return -1;
            }

        case 25:
          if (REGNO (x13) != 22
              || REGNO (x7) != 24)
            return -1;
          x9 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x9) != CLOBBER)
            return -1;
          x10 = XEXP (x9, 0);
          if (GET_CODE (x10) != REG)
            return -1;
          switch (pattern339 (x1))
            {
            case 0:
              if (!
#line 529 "../../gcc/config/avr/avr-fixed.md"
(reload_completed))
                return -1;
              return 3098; /* *udivqq3.call */

            case 1:
              if (!
#line 529 "../../gcc/config/avr/avr-fixed.md"
(reload_completed))
                return -1;
              return 3100; /* *udivuqq3.call */

            default:
              return -1;
            }

        case 26:
          switch (pattern281 (x1))
            {
            case 0:
              return 3102; /* *udivhq3.call_split */

            case 1:
              return 3104; /* *udivuhq3.call_split */

            case 2:
              return 3106; /* *udivha3.call_split */

            case 3:
              return 3108; /* *udivuha3.call_split */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case AND:
      switch (pattern111 (x1))
        {
        case 0:
          if (!
#line 4526 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 621; /* *andhi3 */

        case 1:
          if (!
#line 4560 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 623; /* *andpsi3 */

        case 2:
          if (!
#line 4595 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 625; /* *andsi3 */

        case 3:
          if (!
#line 10974 "../../gcc/config/avr/avr.md"
(optimize && avropt_use_nonzero_bits))
            return -1;
          return 1478; /* *nzb=1.and.zerox */

        case 4:
          if (!
#line 11094 "../../gcc/config/avr/avr.md"
(optimize && avropt_use_nonzero_bits))
            return -1;
          return 1493; /* *nzb=1.and.zerox.not */

        default:
          return -1;
        }

    case IOR:
      switch (pattern111 (x1))
        {
        case 0:
          if (!
#line 4674 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 629; /* *iorhi3 */

        case 1:
          if (!
#line 4706 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 631; /* *iorpsi3 */

        case 2:
          if (!
#line 4738 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 633; /* *iorsi3 */

        case 3:
          if (!
#line 10974 "../../gcc/config/avr/avr.md"
(optimize && avropt_use_nonzero_bits))
            return -1;
          return 1477; /* *nzb=1.ior.zerox */

        case 4:
          if (!
#line 11094 "../../gcc/config/avr/avr.md"
(optimize && avropt_use_nonzero_bits))
            return -1;
          return 1492; /* *nzb=1.ior.zerox.not */

        default:
          return -1;
        }

    case XOR:
      switch (pattern111 (x1))
        {
        case 0:
          if (!
#line 4795 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 637; /* *xorhi3 */

        case 1:
          if (!
#line 4825 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 639; /* *xorpsi3 */

        case 2:
          if (!
#line 4857 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 641; /* *xorsi3 */

        case 3:
          if (!
#line 10974 "../../gcc/config/avr/avr.md"
(optimize && avropt_use_nonzero_bits))
            return -1;
          return 1476; /* *nzb=1.xor.zerox */

        case 4:
          if (!
#line 11094 "../../gcc/config/avr/avr.md"
(optimize && avropt_use_nonzero_bits))
            return -1;
          return 1491; /* *nzb=1.xor.zerox.not */

        default:
          return -1;
        }

    case ASHIFT:
      if (pattern105 (x1) != 0)
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_HImode:
          if (pattern113 (x3, 
E_HImode) != 0
              || !
#line 5576 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 692; /* *ashlhi3_const */

        case E_HQmode:
          if (pattern113 (x3, 
E_HQmode) != 0
              || !
#line 5576 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 693; /* *ashlhq3_const */

        case E_UHQmode:
          if (pattern113 (x3, 
E_UHQmode) != 0
              || !
#line 5576 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 694; /* *ashluhq3_const */

        case E_HAmode:
          if (pattern113 (x3, 
E_HAmode) != 0
              || !
#line 5576 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 695; /* *ashlha3_const */

        case E_UHAmode:
          if (pattern113 (x3, 
E_UHAmode) != 0
              || !
#line 5576 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 696; /* *ashluha3_const */

        case E_SImode:
          if (pattern114 (x3, 
E_SImode) != 0
              || !
#line 5674 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 697; /* *ashlsi3_const */

        case E_SQmode:
          if (pattern114 (x3, 
E_SQmode) != 0
              || !
#line 5674 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 698; /* *ashlsq3_const */

        case E_USQmode:
          if (pattern114 (x3, 
E_USQmode) != 0
              || !
#line 5674 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 699; /* *ashlusq3_const */

        case E_SAmode:
          if (pattern114 (x3, 
E_SAmode) != 0
              || !
#line 5674 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 700; /* *ashlsa3_const */

        case E_USAmode:
          if (pattern114 (x3, 
E_USAmode) != 0
              || !
#line 5674 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 701; /* *ashlusa3_const */

        case E_PSImode:
          if (pattern112 (x3) != 0
              || !
#line 5732 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 703; /* *ashlpsi3 */

        default:
          return -1;
        }

    case ASHIFTRT:
      switch (pattern115 (x1))
        {
        case 0:
          if (!
#line 5849 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 722; /* *ashrpsi3 */

        case 1:
          if (!
#line 5896 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 733; /* *ashrhi3_const */

        case 2:
          if (!
#line 5896 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 734; /* *ashrhq3_const */

        case 3:
          if (!
#line 5896 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 735; /* *ashruhq3_const */

        case 4:
          if (!
#line 5896 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 736; /* *ashrha3_const */

        case 5:
          if (!
#line 5896 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 737; /* *ashruha3_const */

        case 6:
          if (!
#line 5914 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 738; /* *ashrsi3_const */

        case 7:
          if (!
#line 5914 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 739; /* *ashrsq3_const */

        case 8:
          if (!
#line 5914 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 740; /* *ashrusq3_const */

        case 9:
          if (!
#line 5914 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 741; /* *ashrsa3_const */

        case 10:
          if (!
#line 5914 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 742; /* *ashrusa3_const */

        default:
          return -1;
        }

    case LSHIFTRT:
      switch (pattern115 (x1))
        {
        case 0:
          if (!
#line 6049 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 760; /* *lshrpsi3 */

        case 1:
          if (!
#line 6152 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 771; /* *lshrhi3_const */

        case 2:
          if (!
#line 6152 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 772; /* *lshrhq3_const */

        case 3:
          if (!
#line 6152 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 773; /* *lshruhq3_const */

        case 4:
          if (!
#line 6152 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 774; /* *lshrha3_const */

        case 5:
          if (!
#line 6152 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 775; /* *lshruha3_const */

        case 6:
          if (!
#line 6169 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 776; /* *lshrsi3_const */

        case 7:
          if (!
#line 6169 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 777; /* *lshrsq3_const */

        case 8:
          if (!
#line 6169 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 778; /* *lshrusq3_const */

        case 9:
          if (!
#line 6169 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 779; /* *lshrsa3_const */

        case 10:
          if (!
#line 6169 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 780; /* *lshrusa3_const */

        default:
          return -1;
        }

    case COMPARE:
      return recog_81 (x1, insn, pnum_clobbers);

    case CLZ:
      if (pattern117 (x1) != 0
          || !
#line 9399 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 1040; /* *clzhi2.libgcc */

    case CTZ:
      if (pattern117 (x1) != 0
          || !
#line 9468 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 1044; /* *ctzhi2.libgcc */

    case FFS:
      if (pattern117 (x1) != 0
          || !
#line 9540 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 1048; /* *ffshi2.libgcc */

    case UNSPEC:
      if (XVECLEN (x3, 0) != 2)
        return -1;
      x14 = XVECEXP (x3, 0, 0);
      if (GET_CODE (x14) != REG)
        return -1;
      x15 = XVECEXP (x3, 0, 1);
      if (GET_CODE (x15) != REG
          || GET_MODE (x15) != E_QImode)
        return -1;
      x7 = XEXP (x2, 0);
      if (GET_CODE (x7) != REG)
        return -1;
      x9 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x9) != CLOBBER)
        return -1;
      x10 = XEXP (x9, 0);
      if (GET_CODE (x10) != REG)
        return -1;
      x5 = XVECEXP (x1, 0, 2);
      if (pattern116 (x5) != 0)
        return -1;
      switch (pattern296 (x1))
        {
        case 0:
          if (!
#line 9748 "../../gcc/config/avr/avr.md"
(!AVR_HAVE_MUL && reload_completed))
            return -1;
          return 1060; /* *fmul.call */

        case 1:
          if (!
#line 9820 "../../gcc/config/avr/avr.md"
(!AVR_HAVE_MUL && reload_completed))
            return -1;
          return 1064; /* *fmuls.call */

        case 2:
          if (!
#line 9892 "../../gcc/config/avr/avr.md"
(!AVR_HAVE_MUL && reload_completed))
            return -1;
          return 1068; /* *fmulsu.call */

        case 3:
          if (!
#line 729 "../../gcc/config/avr/avr-fixed.md"
(reload_completed))
            return -1;
          return 3148; /* *roundqq3.libgcc */

        case 4:
          if (!
#line 729 "../../gcc/config/avr/avr-fixed.md"
(reload_completed))
            return -1;
          return 3149; /* *rounduqq3.libgcc */

        case 5:
          if (!
#line 755 "../../gcc/config/avr/avr-fixed.md"
(reload_completed))
            return -1;
          return 3154; /* *roundhq3.libgcc */

        case 6:
          if (!
#line 755 "../../gcc/config/avr/avr-fixed.md"
(reload_completed))
            return -1;
          return 3155; /* *rounduhq3.libgcc */

        case 7:
          if (!
#line 755 "../../gcc/config/avr/avr-fixed.md"
(reload_completed))
            return -1;
          return 3156; /* *roundha3.libgcc */

        case 8:
          if (!
#line 755 "../../gcc/config/avr/avr-fixed.md"
(reload_completed))
            return -1;
          return 3157; /* *rounduha3.libgcc */

        case 9:
          if (!
#line 781 "../../gcc/config/avr/avr-fixed.md"
(reload_completed))
            return -1;
          return 3162; /* *roundsq3.libgcc */

        case 10:
          if (!
#line 781 "../../gcc/config/avr/avr-fixed.md"
(reload_completed))
            return -1;
          return 3163; /* *roundusq3.libgcc */

        case 11:
          if (!
#line 781 "../../gcc/config/avr/avr-fixed.md"
(reload_completed))
            return -1;
          return 3164; /* *roundsa3.libgcc */

        case 12:
          if (!
#line 781 "../../gcc/config/avr/avr-fixed.md"
(reload_completed))
            return -1;
          return 3165; /* *roundusa3.libgcc */

        default:
          return -1;
        }

    case DIV:
      x4 = XEXP (x3, 0);
      if (GET_CODE (x4) != REG)
        return -1;
      x13 = XEXP (x3, 1);
      if (GET_CODE (x13) != REG)
        return -1;
      x7 = XEXP (x2, 0);
      if (GET_CODE (x7) != REG
          || pattern106 (x1) != 0)
        return -1;
      switch (REGNO (x4))
        {
        case 25:
          if (REGNO (x13) != 22
              || REGNO (x7) != 24)
            return -1;
          switch (pattern339 (x1))
            {
            case 0:
              if (!
#line 529 "../../gcc/config/avr/avr-fixed.md"
(reload_completed))
                return -1;
              return 3099; /* *divqq3.call */

            case 1:
              if (!
#line 529 "../../gcc/config/avr/avr-fixed.md"
(reload_completed))
                return -1;
              return 3101; /* *divuqq3.call */

            default:
              return -1;
            }

        case 26:
          switch (pattern309 (x1, 
E_QImode, 
21, 
26, 
22))
            {
            case 0:
              return 3103; /* *divhq3.call_split */

            case 1:
              return 3105; /* *divuhq3.call_split */

            case 2:
              return 3107; /* *divha3.call_split */

            case 3:
              return 3109; /* *divuha3.call_split */

            default:
              return -1;
            }

        case 24:
          if (REGNO (x13) != 18
              || REGNO (x7) != 22)
            return -1;
          switch (pattern277 (x1))
            {
            case 0:
              return 3119; /* *divsa3.call_split */

            case 1:
              return 3121; /* *divusa3.call_split */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 rtx_insn *
split_14 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[1] = x4;
      if (pattern152 (x3) == 0
          && 
#line 4486 "../../gcc/config/avr/avr.md"
( reload_completed))
        return gen_split_367 (insn, operands);
      if (GET_CODE (x4) != SUBREG
          || maybe_ne (SUBREG_BYTE (x4), 0)
          || GET_MODE (x4) != E_QImode)
        return NULL;
      x5 = XEXP (x3, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return NULL;
      switch (pattern218 (x3))
        {
        case 0:
          if (!(
#line 10636 "../../gcc/config/avr/avr.md"
(! reload_completed) && 
#line 10638 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_768 (insn, operands);

        case 1:
          if (!(
#line 10636 "../../gcc/config/avr/avr.md"
(! reload_completed) && 
#line 10638 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_770 (insn, operands);

        case 2:
          if (!(
#line 10636 "../../gcc/config/avr/avr.md"
(! reload_completed) && 
#line 10638 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_772 (insn, operands);

        case 3:
          if (!(
#line 10636 "../../gcc/config/avr/avr.md"
(! reload_completed) && 
#line 10638 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_769 (insn, operands);

        case 4:
          if (!(
#line 10636 "../../gcc/config/avr/avr.md"
(! reload_completed) && 
#line 10638 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_771 (insn, operands);

        case 5:
          if (!(
#line 10636 "../../gcc/config/avr/avr.md"
(! reload_completed) && 
#line 10638 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_773 (insn, operands);

        default:
          return NULL;
        }

    case LSHIFTRT:
      switch (pattern77 (x3))
        {
        case 0:
          if (!
#line 10586 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_752 (insn, operands);

        case 1:
          if (!
#line 10586 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_755 (insn, operands);

        case 2:
          if (!
#line 10586 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_758 (insn, operands);

        case 3:
          if (!
#line 10586 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_761 (insn, operands);

        case 4:
          if (!
#line 10996 "../../gcc/config/avr/avr.md"
(optimize && avropt_use_nonzero_bits
   && !reload_completed))
            return NULL;
          return gen_split_1020 (insn, operands);

        case 5:
          if (!
#line 11047 "../../gcc/config/avr/avr.md"
(optimize && avropt_use_nonzero_bits
   && !reload_completed))
            return NULL;
          return gen_split_1026 (insn, operands);

        default:
          return NULL;
        }

    case ASHIFTRT:
      switch (pattern78 (x3))
        {
        case 0:
          if (!
#line 10586 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_753 (insn, operands);

        case 1:
          if (!
#line 10586 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_756 (insn, operands);

        case 2:
          if (!
#line 10586 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_759 (insn, operands);

        case 3:
          if (!
#line 10586 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_762 (insn, operands);

        default:
          return NULL;
        }

    case ASHIFT:
      switch (pattern78 (x3))
        {
        case 0:
          if (!
#line 10586 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_754 (insn, operands);

        case 1:
          if (!
#line 10586 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_757 (insn, operands);

        case 2:
          if (!
#line 10586 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_760 (insn, operands);

        case 3:
          if (!
#line 10586 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_763 (insn, operands);

        default:
          return NULL;
        }

    case SIGN_EXTRACT:
      x6 = XEXP (x4, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return NULL;
      switch (pattern136 (x3))
        {
        case 0:
          if (!(
#line 10918 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10921 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_999 (insn, operands);

        case 1:
          if (!(
#line 10918 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10921 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_1003 (insn, operands);

        case 2:
          if (!(
#line 10918 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10921 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_1007 (insn, operands);

        case 3:
          if (!(
#line 10918 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10921 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_1011 (insn, operands);

        case 4:
          if (!(
#line 10918 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10921 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_1000 (insn, operands);

        case 5:
          if (!(
#line 10918 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10921 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_1004 (insn, operands);

        case 6:
          if (!(
#line 10918 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10921 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_1008 (insn, operands);

        case 7:
          if (!(
#line 10918 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10921 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_1012 (insn, operands);

        case 8:
          if (!(
#line 10918 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10921 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_1001 (insn, operands);

        case 9:
          if (!(
#line 10918 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10921 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_1005 (insn, operands);

        case 10:
          if (!(
#line 10918 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10921 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_1009 (insn, operands);

        case 11:
          if (!(
#line 10918 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10921 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_1013 (insn, operands);

        case 12:
          if (!(
#line 10918 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10921 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_1002 (insn, operands);

        case 13:
          if (!(
#line 10918 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10921 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_1006 (insn, operands);

        case 14:
          if (!(
#line 10918 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10921 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_1010 (insn, operands);

        case 15:
          if (!(
#line 10918 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10921 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_1014 (insn, operands);

        default:
          return NULL;
        }

    case ZERO_EXTRACT:
      switch (pattern120 (x3))
        {
        case 0:
          if (!
#line 10952 "../../gcc/config/avr/avr.md"
(optimize && avropt_use_nonzero_bits
   && !reload_completed))
            return NULL;
          return gen_split_1017 (insn, operands);

        case 1:
          if (!
#line 11022 "../../gcc/config/avr/avr.md"
(optimize && avropt_use_nonzero_bits
   && !reload_completed))
            return NULL;
          return gen_split_1023 (insn, operands);

        default:
          return NULL;
        }

    case GE:
      if (pattern121 (x3) != 0
          || !
#line 11071 "../../gcc/config/avr/avr.md"
(optimize && avropt_use_nonzero_bits
   && !reload_completed))
        return NULL;
      return gen_split_1029 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_15 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case SIGN_EXTEND:
      switch (pattern39 (x1))
        {
        case 0:
          x4 = XEXP (x2, 1);
          if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 1]
              || !register_operand (operands[0], E_HImode)
              || GET_MODE (x2) != E_HImode
              || GET_MODE (x3) != E_HImode
              || !
#line 3074 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_303 (insn, operands);

        case 1:
          if (!(
#line 10891 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 2 > 1
   && ! reload_completed) && 
#line 10895 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_987 (insn, operands);

        case 2:
          if (!(
#line 10891 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 1
   && ! reload_completed) && 
#line 10895 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_989 (insn, operands);

        case 3:
          if (!(
#line 10891 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 2
   && ! reload_completed) && 
#line 10895 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_993 (insn, operands);

        case 4:
          if (!(
#line 10891 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 1
   && ! reload_completed) && 
#line 10895 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_991 (insn, operands);

        case 5:
          if (!(
#line 10891 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 2
   && ! reload_completed) && 
#line 10895 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_995 (insn, operands);

        case 6:
          if (!(
#line 10891 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 3
   && ! reload_completed) && 
#line 10895 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_997 (insn, operands);

        default:
          return NULL;
        }

    case REG:
    case SUBREG:
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      x4 = XEXP (x2, 1);
      if (GET_CODE (x4) == CONST_INT
          && rtx_equal_p (x3, operands[0]))
        {
          switch (XWINT (x4, 0))
            {
            case 4L:
              switch (pattern178 (x2))
                {
                case 0:
                  return gen_split_408 (insn, operands);

                case 1:
                  return gen_split_409 (insn, operands);

                case 2:
                  return gen_split_410 (insn, operands);

                default:
                  break;
                }
              break;

            case 5L:
              switch (pattern178 (x2))
                {
                case 0:
                  return gen_split_411 (insn, operands);

                case 1:
                  return gen_split_412 (insn, operands);

                case 2:
                  return gen_split_413 (insn, operands);

                default:
                  break;
                }
              break;

            case 6L:
              switch (pattern178 (x2))
                {
                case 0:
                  return gen_split_414 (insn, operands);

                case 1:
                  return gen_split_415 (insn, operands);

                case 2:
                  return gen_split_416 (insn, operands);

                default:
                  break;
                }
              break;

            default:
              break;
            }
        }
      operands[1] = x3;
      operands[2] = x4;
      switch (pattern153 (x2))
        {
        case 0:
          if (
#line 5330 "../../gcc/config/avr/avr.md"
( reload_completed))
            return gen_split_417 (insn, operands);
          break;

        case 1:
          if (
#line 5330 "../../gcc/config/avr/avr.md"
( reload_completed))
            return gen_split_418 (insn, operands);
          break;

        case 2:
          if (
#line 5330 "../../gcc/config/avr/avr.md"
( reload_completed))
            return gen_split_419 (insn, operands);
          break;

        case 3:
          if (
#line 5357 "../../gcc/config/avr/avr.md"
( reload_completed))
            return gen_split_420 (insn, operands);
          break;

        case 4:
          if (
#line 5357 "../../gcc/config/avr/avr.md"
( reload_completed))
            return gen_split_421 (insn, operands);
          break;

        case 5:
          if (
#line 5357 "../../gcc/config/avr/avr.md"
( reload_completed))
            return gen_split_422 (insn, operands);
          break;

        case 6:
          if (
#line 5357 "../../gcc/config/avr/avr.md"
( reload_completed))
            return gen_split_423 (insn, operands);
          break;

        case 7:
          if (
#line 5357 "../../gcc/config/avr/avr.md"
( reload_completed))
            return gen_split_424 (insn, operands);
          break;

        case 8:
          if (
#line 5473 "../../gcc/config/avr/avr.md"
( reload_completed))
            return gen_split_430 (insn, operands);
          break;

        case 9:
          if (
#line 5473 "../../gcc/config/avr/avr.md"
( reload_completed))
            return gen_split_431 (insn, operands);
          break;

        case 10:
          if (
#line 5473 "../../gcc/config/avr/avr.md"
( reload_completed))
            return gen_split_432 (insn, operands);
          break;

        case 11:
          if (
#line 5473 "../../gcc/config/avr/avr.md"
( reload_completed))
            return gen_split_433 (insn, operands);
          break;

        case 12:
          if (
#line 5473 "../../gcc/config/avr/avr.md"
( reload_completed))
            return gen_split_434 (insn, operands);
          break;

        default:
          break;
        }
      if (GET_CODE (x3) != REG)
        return NULL;
      switch (pattern56 (x1))
        {
        case 0:
          if (!(
#line 629 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 631 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
            return NULL;
          return gen_split_1935 (insn, operands);

        case 1:
          if (!(
#line 629 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 631 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
            return NULL;
          return gen_split_1939 (insn, operands);

        case 2:
          if (!(
#line 629 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 631 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
            return NULL;
          return gen_split_1943 (insn, operands);

        case 3:
          if (!(
#line 629 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 631 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
            return NULL;
          return gen_split_1947 (insn, operands);

        case 4:
          if (!(
#line 629 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 631 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
            return NULL;
          return gen_split_1951 (insn, operands);

        case 5:
          if (!(
#line 629 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 631 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
            return NULL;
          return gen_split_1955 (insn, operands);

        case 6:
          if (!(
#line 629 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 631 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
            return NULL;
          return gen_split_1959 (insn, operands);

        default:
          return NULL;
        }

    case CONST_INT:
      if (XWINT (x3, 0) != 1L
          || pattern74 (x1) != 0
          || !
#line 8969 "../../gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_629 (insn, operands);

    case ZERO_EXTEND:
      x6 = XEXP (x3, 0);
      if (GET_CODE (x6) != AND)
        return NULL;
      x7 = XEXP (x6, 1);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return NULL;
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      switch (pattern38 (x2))
        {
        case 0:
          if (!(
#line 10891 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 2 > 1
   && ! reload_completed) && 
#line 10895 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_988 (insn, operands);

        case 1:
          if (!(
#line 10891 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 1
   && ! reload_completed) && 
#line 10895 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_990 (insn, operands);

        case 2:
          if (!(
#line 10891 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 2
   && ! reload_completed) && 
#line 10895 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_994 (insn, operands);

        case 3:
          if (!(
#line 10891 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 1
   && ! reload_completed) && 
#line 10895 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_992 (insn, operands);

        case 4:
          if (!(
#line 10891 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 2
   && ! reload_completed) && 
#line 10895 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_996 (insn, operands);

        case 5:
          if (!(
#line 10891 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 3
   && ! reload_completed) && 
#line 10895 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_998 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_18 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case NE:
    case EQ:
    case GE:
    case GT:
    case LE:
    case LT:
    case GEU:
    case GTU:
    case LEU:
    case LTU:
      operands[0] = x3;
      if (ordered_comparison_operator (operands[0], E_VOIDmode))
        {
          res = split_7 (x1, insn);
          if (res != NULL_RTX)
            return res;
        }
      x4 = XEXP (x3, 1);
      if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return NULL;
      switch (pattern91 (x1))
        {
        case 0:
          if (!
#line 7635 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_607 (insn, operands);

        case 1:
          if (!
#line 7635 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_608 (insn, operands);

        case 2:
          if (!
#line 7635 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_609 (insn, operands);

        case 3:
          if (!
#line 7635 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_610 (insn, operands);

        case 4:
          if (!
#line 7635 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_611 (insn, operands);

        case 5:
          if (low_io_address_operand (operands[1], E_VOIDmode)
              && 
#line 8149 "../../gcc/config/avr/avr.md"
( reload_completed))
            return gen_split_618 (insn, operands);
          if (!high_io_address_operand (operands[1], E_VOIDmode)
              || !
#line 8244 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_621 (insn, operands);

        case 6:
          if (low_io_address_operand (operands[1], E_VOIDmode)
              && 
#line 8149 "../../gcc/config/avr/avr.md"
( reload_completed))
            return gen_split_619 (insn, operands);
          if (!high_io_address_operand (operands[1], E_VOIDmode)
              || !
#line 8244 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_622 (insn, operands);

        case 7:
          if (!
#line 7688 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_612 (insn, operands);

        case 8:
          if (!
#line 7688 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_613 (insn, operands);

        case 9:
          if (!
#line 7688 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_614 (insn, operands);

        case 10:
          if (!
#line 7688 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_615 (insn, operands);

        case 11:
          operands[0] = x3;
          if (gelt_operator (operands[0], E_VOIDmode))
            {
              x5 = XEXP (x3, 0);
              if (GET_CODE (x5) == MEM
                  && GET_MODE (x5) == E_QImode)
                {
                  x6 = XEXP (x5, 0);
                  operands[1] = x6;
                  x7 = XEXP (x2, 1);
                  x8 = XEXP (x7, 0);
                  operands[2] = x8;
                  if (low_io_address_operand (operands[1], E_VOIDmode)
                      && 
#line 8197 "../../gcc/config/avr/avr.md"
( reload_completed))
                    return gen_split_620 (insn, operands);
                  if (high_io_address_operand (operands[1], E_VOIDmode)
                      && 
#line 8291 "../../gcc/config/avr/avr.md"
( reload_completed))
                    return gen_split_623 (insn, operands);
                }
            }
          if (GET_CODE (x3) != GE)
            return NULL;
          x5 = XEXP (x3, 0);
          operands[0] = x5;
          if (!register_operand (operands[0], E_QImode))
            return NULL;
          x7 = XEXP (x2, 1);
          x8 = XEXP (x7, 0);
          operands[1] = x8;
          if (!
#line 9093 "../../gcc/config/avr/avr.md"
(reload_completed))
            return NULL;
          return gen_split_633 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_26 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 0);
  if (!scratch_operand (x5, E_QImode))
    return NULL;
  x6 = XEXP (x2, 1);
  x7 = XEXP (x6, 1);
  switch (GET_CODE (x7))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      operands[2] = x7;
      x8 = XEXP (x6, 0);
      operands[1] = x8;
      operands[3] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_HImode:
          if (pattern312 (x6, 
E_HImode) != 0
              || !
#line 2139 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_152 (insn, operands);

        case E_HQmode:
          if (pattern312 (x6, 
E_HQmode) != 0
              || !
#line 2139 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_153 (insn, operands);

        case E_UHQmode:
          if (pattern312 (x6, 
E_UHQmode) != 0
              || !
#line 2139 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_154 (insn, operands);

        case E_HAmode:
          if (pattern312 (x6, 
E_HAmode) != 0
              || !
#line 2139 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_155 (insn, operands);

        case E_UHAmode:
          if (pattern312 (x6, 
E_UHAmode) != 0
              || !
#line 2139 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_156 (insn, operands);

        case E_SImode:
          if (pattern312 (x6, 
E_SImode) != 0
              || !
#line 2169 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_157 (insn, operands);

        case E_SQmode:
          if (pattern312 (x6, 
E_SQmode) != 0
              || !
#line 2169 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_158 (insn, operands);

        case E_USQmode:
          if (pattern312 (x6, 
E_USQmode) != 0
              || !
#line 2169 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_159 (insn, operands);

        case E_SAmode:
          if (pattern312 (x6, 
E_SAmode) != 0
              || !
#line 2169 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_160 (insn, operands);

        case E_USAmode:
          if (pattern312 (x6, 
E_USAmode) != 0
              || !
#line 2169 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_161 (insn, operands);

        default:
          return NULL;
        }

    case MULT:
      x8 = XEXP (x6, 0);
      operands[3] = x8;
      x9 = XEXP (x7, 1);
      operands[2] = x9;
      operands[4] = x5;
      switch (pattern237 (x6))
        {
        case 0:
          if (!const_int_operand (operands[2], E_QImode)
              || !(
#line 2666 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 2668 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_280 (insn, operands);

        case 1:
          if (s8_operand (operands[2], E_HImode)
              && (
#line 2881 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 2883 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return gen_split_292 (insn, operands);
          if (!u8_operand (operands[2], E_HImode)
              || !(
#line 2972 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL
   && !s8_operand (operands[2], VOIDmode)) && 
#line 2975 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_297 (insn, operands);

        case 2:
          if (!u8_operand (operands[2], E_HImode)
              || !(
#line 2881 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 2883 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_293 (insn, operands);

        default:
          return NULL;
        }

    case ASHIFT:
      if (pattern224 (x6) != 0)
        return NULL;
      x9 = XEXP (x7, 1);
      operands[2] = x9;
      operands[4] = x5;
      x10 = XEXP (x7, 0);
      switch (pattern356 (x10))
        {
        case 0:
          if (!(
#line 2904 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 2906 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_294 (insn, operands);

        case 1:
          if (!(
#line 2928 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 2930 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_295 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
peephole2_1 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 36
      || GET_MODE (x3) != E_CCmode)
    return NULL;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      if (!l_register_operand (operands[0], E_QImode)
          || !const_operand (operands[1], E_QImode)
          || !
#line 896 "../../gcc/config/avr/avr.md"
(!satisfies_constraint_Y00 (operands[1])
   && !satisfies_constraint_Y01 (operands[1])
   && !satisfies_constraint_Ym1 (operands[1])))
        return NULL;
      *pmatch_len_ = 0;
      return gen_peephole2_1 (insn, operands);

    case E_QQmode:
      if (!l_register_operand (operands[0], E_QQmode)
          || !const_operand (operands[1], E_QQmode)
          || !
#line 896 "../../gcc/config/avr/avr.md"
(!satisfies_constraint_Y00 (operands[1])
   && !satisfies_constraint_Y01 (operands[1])
   && !satisfies_constraint_Ym1 (operands[1])))
        return NULL;
      *pmatch_len_ = 0;
      return gen_peephole2_2 (insn, operands);

    case E_UQQmode:
      if (!l_register_operand (operands[0], E_UQQmode)
          || !const_operand (operands[1], E_UQQmode)
          || !
#line 896 "../../gcc/config/avr/avr.md"
(!satisfies_constraint_Y00 (operands[1])
   && !satisfies_constraint_Y01 (operands[1])
   && !satisfies_constraint_Ym1 (operands[1])))
        return NULL;
      *pmatch_len_ = 0;
      return gen_peephole2_3 (insn, operands);

    case E_HImode:
      if (l_register_operand (operands[0], E_HImode)
          && const_or_immediate_operand (operands[1], E_HImode)
          && 
#line 935 "../../gcc/config/avr/avr.md"
(operands[1] != CONST0_RTX (HImode)))
        {
          *pmatch_len_ = 0;
          res = gen_peephole2_4 (insn, operands);
          if (res != NULL_RTX)
            return res;
        }
      if (peep2_current_count < 2
          || !d_register_operand (operands[0], E_HImode))
        return NULL;
      x6 = PATTERN (peep2_next_insn (1));
      if (GET_CODE (x6) != PARALLEL)
        return NULL;
      if (const_int_operand (operands[1], E_HImode))
        {
          switch (XVECLEN (x6, 0))
            {
            case 3:
              switch (pattern316 (x6, 
E_HImode))
                {
                case 0:
                  if (
#line 1040 "../../gcc/config/avr/avr.md"
(! reg_overlap_mentioned_p (operands[0], operands[2])))
                    {
                      *pmatch_len_ = 1;
                      res = gen_peephole2_15 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                  break;

                case 1:
                  if (
#line 1040 "../../gcc/config/avr/avr.md"
(! reg_overlap_mentioned_p (operands[0], operands[2])))
                    {
                      *pmatch_len_ = 1;
                      res = gen_peephole2_16 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                  break;

                case 2:
                  if (
#line 1040 "../../gcc/config/avr/avr.md"
(! reg_overlap_mentioned_p (operands[0], operands[2])))
                    {
                      *pmatch_len_ = 1;
                      res = gen_peephole2_17 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                  break;

                default:
                  break;
                }
              break;

            case 2:
              if (pattern319 (x6, 
E_HImode, 
PLUS) == 0)
                {
                  x7 = XVECEXP (x6, 0, 0);
                  x8 = XEXP (x7, 1);
                  x9 = XEXP (x8, 1);
                  operands[2] = x9;
                  if (register_operand (operands[2], E_HImode))
                    {
                      x10 = XEXP (x8, 0);
                      if (rtx_equal_p (x10, operands[0]))
                        {
                          x11 = XEXP (x7, 0);
                          if (rtx_equal_p (x11, operands[0])
                              && 
#line 1059 "../../gcc/config/avr/avr.md"
(! reg_overlap_mentioned_p (operands[0], operands[2])))
                            {
                              *pmatch_len_ = 1;
                              res = gen_peephole2_24 (insn, operands);
                              if (res != NULL_RTX)
                                return res;
                            }
                        }
                    }
                }
              break;

            default:
              break;
            }
        }
      if (XVECLEN (x6, 0) != 2
          || !const_operand (operands[1], E_HImode)
          || pattern314 (x6, 
E_HImode) != 0
          || !
#line 1872 "../../gcc/config/avr/avr.md"
(peep2_reg_dead_p (2, operands[0])))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_32 (insn, operands);

    case E_HQmode:
      if (l_register_operand (operands[0], E_HQmode)
          && const_or_immediate_operand (operands[1], E_HQmode)
          && 
#line 935 "../../gcc/config/avr/avr.md"
(operands[1] != CONST0_RTX (HQmode)))
        {
          *pmatch_len_ = 0;
          res = gen_peephole2_5 (insn, operands);
          if (res != NULL_RTX)
            return res;
        }
      if (peep2_current_count < 2)
        return NULL;
      x6 = PATTERN (peep2_next_insn (1));
      if (pattern315 (x6, 
E_HQmode) != 0
          || !
#line 1872 "../../gcc/config/avr/avr.md"
(peep2_reg_dead_p (2, operands[0])))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_33 (insn, operands);

    case E_UHQmode:
      if (l_register_operand (operands[0], E_UHQmode)
          && const_or_immediate_operand (operands[1], E_UHQmode)
          && 
#line 935 "../../gcc/config/avr/avr.md"
(operands[1] != CONST0_RTX (UHQmode)))
        {
          *pmatch_len_ = 0;
          res = gen_peephole2_6 (insn, operands);
          if (res != NULL_RTX)
            return res;
        }
      if (peep2_current_count < 2)
        return NULL;
      x6 = PATTERN (peep2_next_insn (1));
      if (pattern315 (x6, 
E_UHQmode) != 0
          || !
#line 1872 "../../gcc/config/avr/avr.md"
(peep2_reg_dead_p (2, operands[0])))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_34 (insn, operands);

    case E_HAmode:
      if (l_register_operand (operands[0], E_HAmode)
          && const_or_immediate_operand (operands[1], E_HAmode)
          && 
#line 935 "../../gcc/config/avr/avr.md"
(operands[1] != CONST0_RTX (HAmode)))
        {
          *pmatch_len_ = 0;
          res = gen_peephole2_7 (insn, operands);
          if (res != NULL_RTX)
            return res;
        }
      if (peep2_current_count < 2)
        return NULL;
      x6 = PATTERN (peep2_next_insn (1));
      if (pattern315 (x6, 
E_HAmode) != 0
          || !
#line 1872 "../../gcc/config/avr/avr.md"
(peep2_reg_dead_p (2, operands[0])))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_35 (insn, operands);

    case E_UHAmode:
      if (l_register_operand (operands[0], E_UHAmode)
          && const_or_immediate_operand (operands[1], E_UHAmode)
          && 
#line 935 "../../gcc/config/avr/avr.md"
(operands[1] != CONST0_RTX (UHAmode)))
        {
          *pmatch_len_ = 0;
          res = gen_peephole2_8 (insn, operands);
          if (res != NULL_RTX)
            return res;
        }
      if (peep2_current_count < 2)
        return NULL;
      x6 = PATTERN (peep2_next_insn (1));
      if (pattern315 (x6, 
E_UHAmode) != 0
          || !
#line 1872 "../../gcc/config/avr/avr.md"
(peep2_reg_dead_p (2, operands[0])))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_36 (insn, operands);

    case E_PSImode:
      if (peep2_current_count >= 2)
        {
          x6 = PATTERN (peep2_next_insn (1));
          switch (pattern317 (x6, 
E_PSImode))
            {
            case 0:
              if (
#line 1040 "../../gcc/config/avr/avr.md"
(! reg_overlap_mentioned_p (operands[0], operands[2])))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_18 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            case 1:
              if (
#line 1040 "../../gcc/config/avr/avr.md"
(! reg_overlap_mentioned_p (operands[0], operands[2])))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_19 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            case 2:
              if (
#line 1040 "../../gcc/config/avr/avr.md"
(! reg_overlap_mentioned_p (operands[0], operands[2])))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_20 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            default:
              break;
            }
        }
      if (!l_register_operand (operands[0], E_PSImode)
          || !immediate_operand (operands[1], E_PSImode)
          || !
#line 1112 "../../gcc/config/avr/avr.md"
(operands[1] != const0_rtx
   && operands[1] != constm1_rtx))
        return NULL;
      *pmatch_len_ = 0;
      return gen_peephole2_25 (insn, operands);

    case E_SImode:
      if (peep2_current_count >= 2)
        {
          x6 = PATTERN (peep2_next_insn (1));
          switch (pattern317 (x6, 
E_SImode))
            {
            case 0:
              if (
#line 1040 "../../gcc/config/avr/avr.md"
(! reg_overlap_mentioned_p (operands[0], operands[2])))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_21 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            case 1:
              if (
#line 1040 "../../gcc/config/avr/avr.md"
(! reg_overlap_mentioned_p (operands[0], operands[2])))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_22 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            case 2:
              if (
#line 1040 "../../gcc/config/avr/avr.md"
(! reg_overlap_mentioned_p (operands[0], operands[2])))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_23 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            default:
              break;
            }
        }
      if (!l_register_operand (operands[0], E_SImode)
          || !immediate_operand (operands[1], E_SImode)
          || !
#line 1167 "../../gcc/config/avr/avr.md"
(operands[1] != CONST0_RTX (SImode)))
        return NULL;
      *pmatch_len_ = 0;
      return gen_peephole2_26 (insn, operands);

    case E_SQmode:
      if (!l_register_operand (operands[0], E_SQmode)
          || !immediate_operand (operands[1], E_SQmode)
          || !
#line 1167 "../../gcc/config/avr/avr.md"
(operands[1] != CONST0_RTX (SQmode)))
        return NULL;
      *pmatch_len_ = 0;
      return gen_peephole2_27 (insn, operands);

    case E_USQmode:
      if (!l_register_operand (operands[0], E_USQmode)
          || !immediate_operand (operands[1], E_USQmode)
          || !
#line 1167 "../../gcc/config/avr/avr.md"
(operands[1] != CONST0_RTX (USQmode)))
        return NULL;
      *pmatch_len_ = 0;
      return gen_peephole2_28 (insn, operands);

    case E_SAmode:
      if (!l_register_operand (operands[0], E_SAmode)
          || !immediate_operand (operands[1], E_SAmode)
          || !
#line 1167 "../../gcc/config/avr/avr.md"
(operands[1] != CONST0_RTX (SAmode)))
        return NULL;
      *pmatch_len_ = 0;
      return gen_peephole2_29 (insn, operands);

    case E_USAmode:
      if (!l_register_operand (operands[0], E_USAmode)
          || !immediate_operand (operands[1], E_USAmode)
          || !
#line 1167 "../../gcc/config/avr/avr.md"
(operands[1] != CONST0_RTX (USAmode)))
        return NULL;
      *pmatch_len_ = 0;
      return gen_peephole2_30 (insn, operands);

    case E_SFmode:
      if (!l_register_operand (operands[0], E_SFmode)
          || !const_double_operand (operands[1], E_SFmode)
          || !
#line 1271 "../../gcc/config/avr/avr.md"
(operands[1] != CONST0_RTX (SFmode)))
        return NULL;
      *pmatch_len_ = 0;
      return gen_peephole2_31 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
peephole2_5 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (peep2_current_count < 2)
    return NULL;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  operands[1] = x3;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 36
      || GET_MODE (x5) != E_CCmode)
    return NULL;
  x6 = XEXP (x2, 0);
  operands[0] = x6;
  x7 = PATTERN (peep2_next_insn (1));
  if (GET_CODE (x7) != PARALLEL)
    return NULL;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      if (pattern330 (x7) != 0)
        return NULL;
      x8 = XVECEXP (x7, 0, 0);
      x9 = XEXP (x8, 0);
      operands[2] = x9;
      if (odd_register_operand (operands[2], E_QImode)
          && even_register_operand (operands[0], E_QImode)
          && even_register_operand (operands[1], E_QImode))
        {
          x10 = XEXP (x8, 1);
          operands[3] = x10;
          if (odd_register_operand (operands[3], E_QImode)
              && 
#line 991 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MOVW
   && REGNO (operands[0]) == REGNO (operands[2]) - 1
   && REGNO (operands[1]) == REGNO (operands[3]) - 1))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_9 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
        }
      if (even_register_operand (operands[2], E_QImode)
          && odd_register_operand (operands[0], E_QImode)
          && odd_register_operand (operands[1], E_QImode))
        {
          x10 = XEXP (x8, 1);
          operands[3] = x10;
          if (even_register_operand (operands[3], E_QImode)
              && 
#line 1009 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MOVW
   && REGNO (operands[2]) == REGNO (operands[0]) - 1
   && REGNO (operands[3]) == REGNO (operands[1]) - 1))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_12 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
        }
      if (peep2_current_count < 3)
        return NULL;
      switch (pattern380 (x8, 
E_QImode))
        {
        case 0:
          if (!
#line 4990 "../../gcc/config/avr/avr.md"
(peep2_reg_dead_p (3, operands[0])))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_76 (insn, operands);

        case 1:
          if (!
#line 4990 "../../gcc/config/avr/avr.md"
(peep2_reg_dead_p (3, operands[0])))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_77 (insn, operands);

        case 2:
          if (!
#line 4990 "../../gcc/config/avr/avr.md"
(peep2_reg_dead_p (3, operands[0])))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_78 (insn, operands);

        default:
          return NULL;
        }

    case E_QQmode:
      if (pattern330 (x7) != 0)
        return NULL;
      x8 = XVECEXP (x7, 0, 0);
      x9 = XEXP (x8, 0);
      operands[2] = x9;
      if (odd_register_operand (operands[2], E_QQmode)
          && even_register_operand (operands[0], E_QQmode)
          && even_register_operand (operands[1], E_QQmode))
        {
          x10 = XEXP (x8, 1);
          operands[3] = x10;
          if (odd_register_operand (operands[3], E_QQmode)
              && 
#line 991 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MOVW
   && REGNO (operands[0]) == REGNO (operands[2]) - 1
   && REGNO (operands[1]) == REGNO (operands[3]) - 1))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_10 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
        }
      if (even_register_operand (operands[2], E_QQmode)
          && odd_register_operand (operands[0], E_QQmode)
          && odd_register_operand (operands[1], E_QQmode))
        {
          x10 = XEXP (x8, 1);
          operands[3] = x10;
          if (even_register_operand (operands[3], E_QQmode)
              && 
#line 1009 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MOVW
   && REGNO (operands[2]) == REGNO (operands[0]) - 1
   && REGNO (operands[3]) == REGNO (operands[1]) - 1))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_13 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
        }
      if (peep2_current_count < 3)
        return NULL;
      switch (pattern380 (x8, 
E_QQmode))
        {
        case 0:
          if (!
#line 4990 "../../gcc/config/avr/avr.md"
(peep2_reg_dead_p (3, operands[0])))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_79 (insn, operands);

        case 1:
          if (!
#line 4990 "../../gcc/config/avr/avr.md"
(peep2_reg_dead_p (3, operands[0])))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_80 (insn, operands);

        case 2:
          if (!
#line 4990 "../../gcc/config/avr/avr.md"
(peep2_reg_dead_p (3, operands[0])))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_81 (insn, operands);

        default:
          return NULL;
        }

    case E_UQQmode:
      if (pattern330 (x7) != 0)
        return NULL;
      x8 = XVECEXP (x7, 0, 0);
      x9 = XEXP (x8, 0);
      operands[2] = x9;
      if (odd_register_operand (operands[2], E_UQQmode)
          && even_register_operand (operands[0], E_UQQmode)
          && even_register_operand (operands[1], E_UQQmode))
        {
          x10 = XEXP (x8, 1);
          operands[3] = x10;
          if (odd_register_operand (operands[3], E_UQQmode)
              && 
#line 991 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MOVW
   && REGNO (operands[0]) == REGNO (operands[2]) - 1
   && REGNO (operands[1]) == REGNO (operands[3]) - 1))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_11 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
        }
      if (even_register_operand (operands[2], E_UQQmode)
          && odd_register_operand (operands[0], E_UQQmode)
          && odd_register_operand (operands[1], E_UQQmode))
        {
          x10 = XEXP (x8, 1);
          operands[3] = x10;
          if (even_register_operand (operands[3], E_UQQmode)
              && 
#line 1009 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MOVW
   && REGNO (operands[2]) == REGNO (operands[0]) - 1
   && REGNO (operands[3]) == REGNO (operands[1]) - 1))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_14 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
        }
      if (peep2_current_count < 3)
        return NULL;
      switch (pattern380 (x8, 
E_UQQmode))
        {
        case 0:
          if (!
#line 4990 "../../gcc/config/avr/avr.md"
(peep2_reg_dead_p (3, operands[0])))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_82 (insn, operands);

        case 1:
          if (!
#line 4990 "../../gcc/config/avr/avr.md"
(peep2_reg_dead_p (3, operands[0])))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_83 (insn, operands);

        case 2:
          if (!
#line 4990 "../../gcc/config/avr/avr.md"
(peep2_reg_dead_p (3, operands[0])))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_84 (insn, operands);

        default:
          return NULL;
        }

    case E_HImode:
      switch (pattern331 (x7, 
E_HImode))
        {
        case 0:
          if (!
#line 4957 "../../gcc/config/avr/avr.md"
(peep2_reg_dead_p (1, operands[1])))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_43 (insn, operands);

        case 1:
          if (!
#line 4957 "../../gcc/config/avr/avr.md"
(peep2_reg_dead_p (1, operands[1])))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_44 (insn, operands);

        case 2:
          if (!
#line 4957 "../../gcc/config/avr/avr.md"
(peep2_reg_dead_p (1, operands[1])))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_45 (insn, operands);

        default:
          return NULL;
        }

    case E_SImode:
      switch (pattern331 (x7, 
E_SImode))
        {
        case 0:
          if (!
#line 4957 "../../gcc/config/avr/avr.md"
(peep2_reg_dead_p (1, operands[1])))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_46 (insn, operands);

        case 1:
          if (!
#line 4957 "../../gcc/config/avr/avr.md"
(peep2_reg_dead_p (1, operands[1])))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_47 (insn, operands);

        case 2:
          if (!
#line 4957 "../../gcc/config/avr/avr.md"
(peep2_reg_dead_p (1, operands[1])))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_48 (insn, operands);

        default:
          return NULL;
        }

    case E_PSImode:
      switch (pattern331 (x7, 
E_PSImode))
        {
        case 0:
          if (!
#line 4957 "../../gcc/config/avr/avr.md"
(peep2_reg_dead_p (1, operands[1])))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_49 (insn, operands);

        case 1:
          if (!
#line 4957 "../../gcc/config/avr/avr.md"
(peep2_reg_dead_p (1, operands[1])))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_50 (insn, operands);

        case 2:
          if (!
#line 4957 "../../gcc/config/avr/avr.md"
(peep2_reg_dead_p (1, operands[1])))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_51 (insn, operands);

        default:
          return NULL;
        }

    case E_HQmode:
      switch (pattern331 (x7, 
E_HQmode))
        {
        case 0:
          if (!
#line 4957 "../../gcc/config/avr/avr.md"
(peep2_reg_dead_p (1, operands[1])))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_52 (insn, operands);

        case 1:
          if (!
#line 4957 "../../gcc/config/avr/avr.md"
(peep2_reg_dead_p (1, operands[1])))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_53 (insn, operands);

        case 2:
          if (!
#line 4957 "../../gcc/config/avr/avr.md"
(peep2_reg_dead_p (1, operands[1])))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_54 (insn, operands);

        default:
          return NULL;
        }

    case E_UHQmode:
      switch (pattern331 (x7, 
E_UHQmode))
        {
        case 0:
          if (!
#line 4957 "../../gcc/config/avr/avr.md"
(peep2_reg_dead_p (1, operands[1])))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_55 (insn, operands);

        case 1:
          if (!
#line 4957 "../../gcc/config/avr/avr.md"
(peep2_reg_dead_p (1, operands[1])))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_56 (insn, operands);

        case 2:
          if (!
#line 4957 "../../gcc/config/avr/avr.md"
(peep2_reg_dead_p (1, operands[1])))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_57 (insn, operands);

        default:
          return NULL;
        }

    case E_HAmode:
      switch (pattern331 (x7, 
E_HAmode))
        {
        case 0:
          if (!
#line 4957 "../../gcc/config/avr/avr.md"
(peep2_reg_dead_p (1, operands[1])))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_58 (insn, operands);

        case 1:
          if (!
#line 4957 "../../gcc/config/avr/avr.md"
(peep2_reg_dead_p (1, operands[1])))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_59 (insn, operands);

        case 2:
          if (!
#line 4957 "../../gcc/config/avr/avr.md"
(peep2_reg_dead_p (1, operands[1])))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_60 (insn, operands);

        default:
          return NULL;
        }

    case E_UHAmode:
      switch (pattern331 (x7, 
E_UHAmode))
        {
        case 0:
          if (!
#line 4957 "../../gcc/config/avr/avr.md"
(peep2_reg_dead_p (1, operands[1])))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_61 (insn, operands);

        case 1:
          if (!
#line 4957 "../../gcc/config/avr/avr.md"
(peep2_reg_dead_p (1, operands[1])))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_62 (insn, operands);

        case 2:
          if (!
#line 4957 "../../gcc/config/avr/avr.md"
(peep2_reg_dead_p (1, operands[1])))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_63 (insn, operands);

        default:
          return NULL;
        }

    case E_SQmode:
      switch (pattern331 (x7, 
E_SQmode))
        {
        case 0:
          if (!
#line 4957 "../../gcc/config/avr/avr.md"
(peep2_reg_dead_p (1, operands[1])))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_64 (insn, operands);

        case 1:
          if (!
#line 4957 "../../gcc/config/avr/avr.md"
(peep2_reg_dead_p (1, operands[1])))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_65 (insn, operands);

        case 2:
          if (!
#line 4957 "../../gcc/config/avr/avr.md"
(peep2_reg_dead_p (1, operands[1])))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_66 (insn, operands);

        default:
          return NULL;
        }

    case E_USQmode:
      switch (pattern331 (x7, 
E_USQmode))
        {
        case 0:
          if (!
#line 4957 "../../gcc/config/avr/avr.md"
(peep2_reg_dead_p (1, operands[1])))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_67 (insn, operands);

        case 1:
          if (!
#line 4957 "../../gcc/config/avr/avr.md"
(peep2_reg_dead_p (1, operands[1])))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_68 (insn, operands);

        case 2:
          if (!
#line 4957 "../../gcc/config/avr/avr.md"
(peep2_reg_dead_p (1, operands[1])))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_69 (insn, operands);

        default:
          return NULL;
        }

    case E_SAmode:
      switch (pattern331 (x7, 
E_SAmode))
        {
        case 0:
          if (!
#line 4957 "../../gcc/config/avr/avr.md"
(peep2_reg_dead_p (1, operands[1])))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_70 (insn, operands);

        case 1:
          if (!
#line 4957 "../../gcc/config/avr/avr.md"
(peep2_reg_dead_p (1, operands[1])))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_71 (insn, operands);

        case 2:
          if (!
#line 4957 "../../gcc/config/avr/avr.md"
(peep2_reg_dead_p (1, operands[1])))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_72 (insn, operands);

        default:
          return NULL;
        }

    case E_USAmode:
      switch (pattern331 (x7, 
E_USAmode))
        {
        case 0:
          if (!
#line 4957 "../../gcc/config/avr/avr.md"
(peep2_reg_dead_p (1, operands[1])))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_73 (insn, operands);

        case 1:
          if (!
#line 4957 "../../gcc/config/avr/avr.md"
(peep2_reg_dead_p (1, operands[1])))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_74 (insn, operands);

        case 2:
          if (!
#line 4957 "../../gcc/config/avr/avr.md"
(peep2_reg_dead_p (1, operands[1])))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_75 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}
